c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
c       Main Commmon block for SESAME
c       Wolfgang Werner, June 6 1994
c       Christian Schiebl, June 16 1994
c       Horst Wagner, June 17 1994

c       last modification: CS, 05-OCT-94, 14:03

!       !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!       !      UNITS: eV, Angstroem , s      !
!       ! UNLESS EXPLICITLY STATED OTHERWISE !
!       !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

c     nquads        number of quad-trees
c     nreg          number of regions
c     nener         number of energy intervals
c     nshell        number of shells taken into account for specified model
c     nele()        number of elements in region ireg
c     nelem         total number of elements in simulation
c     elem()        element index for element iele in ireg
c     shell()       number of shells taken into account
c     xcharline()   number of characteristic x-ray line taken into account
c     nshel()       number of shells considered in region ireg
c     shellele()    element of considered shell in ireg
c     shellshell()  shell (K,L,...) of considered shell in ireg
c     nshellofreg   Number of simulated shells in ireg
c     shellofreg    List of shells# in ireg
c     elemofshell   Element of shell#
c     shellofshell  Shell of shell#
c     enerofshell   Energy of shell#
c     ionintofshell ionization intensity of shell#
c     iscrofshell   first actual index according to LSCRN
c     nscrofshell   number of entries in scrofshell
c     scrofshell    Screen number of shell#
c     histofion     ionization histogram number
c     nscrofion     number of entries in scrofion
c     scrofion      screen# of location dependent ionization distribution
c     mxionscr      highest screen# for an IOD output to screen
c     niontoscr     number of entries in iontoscr
c     iontoscr      entry# in xchar table in dependence of screen# for IOD
c     nscrofxcg     number of entries in scrofxcg
c     scrofxcg      screen# of location dependent generated char. x-rays
c     mxxcgscr      highest screen# for an XGD output to screen
c     nxcgtoscr     number of entries in xcgtoscr
c     xcgtoscr      entry# in xchar table in dependence of screen# for XGD
c     nscrofxcd     number of entries in scrofxcd
c     scrofxcd      screen# of location dependent detected char. x-rays
c     xdetscrofxcd  detector# for scrofxcd
c     mxxcdscr      highest screen# for an XDD output to screen
c     nxcdtoscr     number of entries in xcdtoscr
c     xcdtoscr      entry# in xchar table in dependence of screen# for XDD
c     xdetscr       x-ray detector# in dependence of screen#
c     npsminofion   number of entries in psminofion
c     psminofion    save file# of location dependent ionization distribution
c     mxionpm       highest postmini file# for an IOD output
c     niontopm      number of entries in iontopm
c     iontopm       entry# in xchar table in dependence of pm file# for IOD
c     npsminofxcg   number of entries in psminofxcg
c     psminofxcg    save file# of location dependent generated char. x-rays
c     mxxcgpm       highest postmini file# for an XGD output
c     nxcgtopm      number of entries in xcgtopm
c     xcgtopm       entry# in xchar table in dependence of pm file# for XGD
c     npsminofxcd   number of entries in psminofxcd
c     psminofxcd    save file# of location dependent detected char. x-rays
c     xdetpsminofxcd detector# for psminofxcd
c     mxxcdpm       highest postmini file# for an XDD output
c     nxcdtopm      number of entries in xcdtopm
c     xcdtopm       entry# in xchar table in dependence of pm file# for XDD
c     xdetpm        x-ray detector# in dependence of pm file#
c     nionhist      number of entries in ionhist
c     ionhist       ionization distribution histogram indizes
c     nxcharofshell number of entries in xcharofshell
c     xcharofshell  index in XCHAR table
c     xchis         histogram# of char. x-rays
c     nxchis        number of histograms for specific line (ixchar)
c     xdetxchis     detector# for xchis
c     xchiswinfrac  fraction determined by the size of the detector energy 
c                   window
c     xkhis         histogram# of continuous. x-rays
c     nxkhis        number of histograms for specific line (ixcont)
c     xdetxkhis     detector# for xkhis
c     xchtabindx()  index in xchar table in dependence of element and shell
c     nxchtabindx() number of entries in xchtabindx()
c     augerpeak()   Auger peak (KLL=1,LMM=2,MNN=3); 1st: running, 2nd: element
c     augpkener()   Auger peak energy: 1st: peak, 2nd: element
c     augershell()  index in Auger table; 1st index: element, 2nd: shell
c     nauger	    Number of simulated Augerlines
c     elemofauger() Element of Augerline
c     lineofauger() Line    "     " (1=KLL,2=LMM,3=MNN)
c     enerofauger() Energy  "     "
c     addhis()      Hist# of Auger detection distribution
c     agdhis()      Hist#  "   "   generation distribution
c     idethis       Hist# of temporary Auger detection distribution
c     e_shell()     number of electrons in shell ishell
c     nelesource    Electron source(1=BEAM,2=PHI(Z),3=TABULATED)
c     density()     density of ireg in g/ų
c     atnum()       atomic number of iele
c     atmass()      atomic mass of iele
c     atdens()      atomic density of iele in ireg in At/ų
c     tot_atdens()  total atomic density in ireg in At/ų
c     atfrac()      atomic fraction of iele in ireg
c     weightfrac()  weight fraction of iele in ireg
c     zquer()       mean atomic number in ireg
c     Emin          lower boundary of energy range for lamdas and sigmas
c     Emax          upper boundary of energy range for lamdas and sigmas
c     umin          lower boundary of overvoltage
c     umax          upper boundary of overvoltage
C     ustep         interval width of overvoltage
c     Efermi()      Fermi energy of ireg
c     Eedge()       edge dnergy of shell ishell of iele
c     Nvalence()    number of valence electrons if iele in ireg
c
c     x_min,x_max,z_min,z_max Dimension of simulation area
c
c     costheta()    cosine of polar deflection angle in dependence of
c                   region, energy and random number
c     costhintv()   Energy intervals of tabulation of costheta in ireg
c     ncosthintv()  Number of energy intervals of costhint/costheta 
c                   in region ireg
c     elasttrans()  transformation matrix for probability density function
c     enerloss()    energy loss in dependence of region, energy and random
c                   number
c     stopping()    stopping power in ireg for iener
c     lambda_i()    inelastic mean free path in ireg for iele and iener
c     lambda_io()   mean free path for inner shell ionization  
c     lambda_e()    elastic mean free path in ireg for iener
c     lambda_t()    total mean free path (1/lambda_e+1/lambda_i) in ireg for
c                   iener
c     lambda_tr()   transport mean free path in ireg for iener
c     sigma_i_tot() total inelastic cross section in ireg for iener
c     sigma_e_tot() total elastic cross section in ireg for iener
c     sigma_tot()   total (elastic and inelastic) cross section in ireg for
c                   iener
c     sigma_io_ni() ionization cross section for iele, iener and ishell
c     sigma_io_cw() ionization cross section for ireg,iele and iener
c     sigma_io()    ionization cross section for ireg and iener         
c     sigma_ion()   ionization cross section for ireg,ishell,iener
c     sigma_i()     inelastic cross section for iele and iener
c     sigma_e()     elastic cross section for iele and iener
c     sigma_aug()   cross section for Auger line 
c
c     sec_x,y,z()   list of starting points of secondaries
c     sec_dirx,diry,dirz() list of directions "    "
c     sec_e()       list of energies of secondaries
c     sec_frac()    list of fraction values of secondaries 
c     sec_etyp()    electron type(1..PE,4..SE,5..AE,6..XE)
c     sec_esubtyp() subtype (for AE/XE : Auger/XPS line)
c     nsec          number of secondaries in list
c     xcchar()      char. x-rays taken into account
c     nxchar        number of charac. x-rays considered in region ireg
c     xcele()       element of considered charac. x-rays in ireg  
c     xcshell()     x-rays line (KA1,LA1,...) of considered x-ray in ireg
c     nxcharofreg   Number of simulated  charac. x-rays in ireg
c     xcharofreg    List of charac. x-rays# in ireg
c     elemofxchar   Element of charac. x-rays#
c     xcharofxchar  charac. x-ray of charac. x-rays#
c     shellofxchar  index of according ionization in shell table
c     enerofxchar   Energy of charac. x-rays#
c     xgenofxchar   generated x-ray intensity of charac. x-rays#
c     xdetofxchar   detected x-ray intensity of charac. x-rays#
c     xpeaktoback   peak-to-background ratio
c     xfiorifact    Fiori factor (peak/10 eV wide backgound at peak position)
c     fyieldofxchar fluorescence yield of char. x-ray line
c     frelintofxchar relative intensity of char. x-ray line
c     ffudgeofxchar fudge factor for the char. x-ray line
c     xdeteffofxchar x-ray detector efficiency
c     xdefftype     x-ray detector efficiency type (0:ideal,1:file,2:calculated)
c     fwhmofxchar   FWHM for char. x-ray line in XCHAR table
c     ixcharofxcont corresponding entry in XCONT tables
c     nxcont        number of discrete Bremsstrahlung energies
c     nxcorig       nxcont as specified in input deck
c     nxptob        number of Bremsstrahlung enrgies corresponding to
c                   characteristic x-ray energies in XCHAR tables
c     ixcontofxchar corresponding entry in XCHAR tables
c     enerofxcont   Energy of Bremsstrahlung
c     xdetofxcont   detected continuum x-ray intensity
c     dirxdet()     vector in direction to the x-ray detectors
c     Exchar()      energie of charac. x-ray (old data structure)
c     propion       sum of ionization probability for hybrid model
c     xcabs()       array of absorption factors for characteristic x-rays
c
c     statpol,statener()histogram of electron distribution for angle and energy
c
c     lplas()       Direct simulation in ireg?
c     lcsad()       Single scattering model in (ireg)
c
c     fmat()        Names of Plasmon datafiles for each region     
c     outfile       Name of Outputfile
c     infile        Name of Inputfile
c     augerfile     Name of File listing Augersites
c     laugfile      Create Augerfile?
c
c     nscatter()    number of scattering events
c                   (total,elastic,ionization,plasmon)
c     trlen()       total trajectory length of all electrons in sample 
c     trlenp()      total trajectory length of electrons stopped in sample
c     trlenb()      total trajectory length of backscattered electrons in sample
c     trlent()      total trajectory length of transmitted electrons in sample
c     trlens()      total trajectory length of electrons which left sample at
c                   one side (left of right)
c     
C     LPRIM         if .true. current electron is a primary electron
C     LBACK         if .true. current electron is backscattered
C     LTRAN         if .true. current electron is transmitted
C     LSECON        if .true. current electron is a secondary electron
C     LAUGER        if .true. current electron is an Auger electron


      
C    DOUBLE PRECISION COMMON BLOCK      

      double precision  bremsfudge
      double precision  bckcoeff
      double precision  trncoeff

** shell tabulation
      double precision  propion
cs      double precision  enerofshell(maxshells)
      double precision  enerofshell(1)
      pointer (p2enerofshell,enerofshell)
cs      double precision  ionintofshell(maxshells)
      double precision  ionintofshell(1)
      pointer (p2ionintofshell,ionintofshell)

** auger tabulation
      double precision	enerofauger(maxauger)

      double precision  density(maxreg)
      double precision  atmass(maxele)
      double precision  atdens(maxreg,maxele)
      double precision  tot_atdens(maxreg)
      double precision  atfrac(maxreg,maxele)
      double precision  weightfrac(maxreg,maxele)
      double precision  zquer(maxreg)
      double precision  Emin,Emax
      double precision  EStdd,EPrim
      double precision  Efermi(maxreg)
      double precision  Eedge(maxele,maxshell)

      double precision  x_min,x_max,z_min,z_max

      double precision  cosine(0:360),sine(0:360)

**  elastic scattering
      double precision  costheta(maxreg,maxener_e,0:90)
      double precision  costhintv(maxreg,maxener_e)
      double precision  elasttrans(0:ntrans,2)
      double precision  lambda_e(maxener_e,maxreg)                
      double precision  lambda_tr(maxener_e,maxreg)
      double precision  sigma_e(maxener_e,maxreg)

**  plasmon loss
      double precision  plasmon_tab(maxreg,maxener_i,0:maxran_i)
      double precision  plasmon_int(maxreg,maxener_i)

**  electron stopping
      double precision  enerloss(maxreg,maxener,maxran)
      double precision  stopping(maxener,maxreg)

**  energy loss after ionisation
      double precision ener_delta(maxw,maxu)    
      double precision umin,umax,ustep       

      double precision  lambda_i(maxreg,maxener)
      double precision  lambda_io(maxreg,maxener)               
chw      double precision       lambda_t(maxreg,maxener)                
chw      double precision  sigma_i_tot(maxreg,maxener)
chw      double precision  sigma_tot(maxreg,maxener)
cap      double precision   sigma_io(maxele,maxener,maxshell)
      double precision  sigma_io_ni(maxele,maxshell,maxener)
      double precision  sigma_io_cw(maxreg,maxele,maxener)
      double precision  sigma_io(maxreg,maxener)                
      double precision  sigma_ion(maxener,maxreg,maxshell)
      double precision  sigma_aug(maxener,maxreg,maxauger)
      double precision  sigma_i(maxele,maxener)

**  secondary electrons
      double precision  sec_x(maxsec)
      double precision  sec_y(maxsec)
      double precision  sec_z(maxsec)
      double precision  sec_dirx(maxsec)
      double precision  sec_diry(maxsec)
      double precision  sec_dirz(maxsec)
      double precision  sec_e(maxsec)
      double precision  sec_frac(maxsec)

** charcteristic x-rays
*  data structure analogous to ion
cs      double precision  enerofxchar(maxxchars)
      double precision  enerofxchar(1)
      pointer (p2enerofxchar,enerofxchar)
cs      double precision  xgenofxchar(maxxchars)
      double precision  xgenofxchar(1)
      pointer (p2xgenofxchar,xgenofxchar)
cs      double precision  xdetofxchar(0:maxxdet,maxxchars)
      double precision  xdetofxchar(1)
      pointer (p2xdetofxchar,xdetofxchar)
cs      double precision  xpeaktoback(0:maxxdet,maxxchars)
      double precision  xpeaktoback(1)
      pointer (p2xpeaktoback,xpeaktoback)
cs      double precision  xfiorifact(0:maxxdet,maxxchars)
      double precision  xfiorifact(1)
      pointer (p2xfiorifact,xfiorifact)
cs      double precision  fyieldofxchar(maxxchars)
      double precision  fyieldofxchar(1)
      pointer (p2fyieldofxchar,fyieldofxchar)
cs      double precision  frelintofxchar(maxxchars)
      double precision  frelintofxchar(1)
      pointer (p2frelintofxchar,frelintofxchar)
      double precision  ffudgeofxchar(1)
      pointer (p2ffudgeofxchar,ffudgeofxchar)
cs      double precision  xdeteffofxchar(0:maxxdet,
cs     &                                 max(maxxchars,maxxcont))
      double precision xdeteffofxchar(1)
      pointer (p2xdeteffofxchar,xdeteffofxchar)
cs      double precision  fwhmofxchar(0:maxxdet,
cs     &                              max(maxxchars,maxxcont))
      double precision fwhmofxchar(1)
      pointer (p2fwhmofxchar,fwhmofxchar)
      double precision  Exchar (maxele,maxxchar)
cs      double precision  xcabs(0:maxxdet,max(maxxchars,maxxcont),nxm,nzm)

** Bremsstrahlung
cs      double precision enerofxcont(maxxcont)
      double precision enerofxcont(1)
      pointer (p2enerofxcont,enerofxcont)
cs      double precision xdetofxcont(0:maxxdet,maxxcont)
      double precision xdetofxcont(1)
      pointer (p2xdetofxcont,xdetofxcont)
      double precision dirxdet(0:maxxdet,3)
**
      double precision state(0:maxstate)
      double precision statpol(0:179)

** trajectory information
      double precision trlen(6),trlenp(6),trlenb(6)
      double precision trlent(6),trlens(6)

      double precision xchiswinfrac(1)
      pointer          (p2xchiswinfrac,xchiswinfrac)

      common /SESAMD/
     2               density,atmass,atdens,tot_atdens,atfrac,zquer,
     3               weightfrac,Emin,Emax,EPrim,EStdd,Efermi,Eedge,
     4               costheta,costhintv,plasmon_tab,plasmon_int,
     5               elasttrans,enerloss,stopping,
     6               ener_delta,umin,umax,ustep,
     7               lambda_io,lambda_e,lambda_i,lambda_tr,
     8               sigma_io_cw,sigma_io_ni,
     9               sigma_ion,sigma_i,sigma_e,sec_x,sec_y,sec_z,
     .               sec_dirx,sec_diry,sec_dirz,sec_e,sec_frac,
     .               state,statpol,sine,cosine,x_min,x_max,
cs     .               z_min,z_max, enerofshell,ionintofshell, 
     .               z_min,z_max, 
cs     .               propion,Exchar,enerofxchar,enerofxcont,
     .               propion,Exchar,
cs     .               xgenofxchar,xdetofxchar,xdetofxcont,dirxdet,
     .               dirxdet,
cs     .               fyieldofxchar,frelintofxchar,xdeteffofxchar,
cs     .               fwhmofxchar,xpeaktoback,xfiorifact,
cs     .               xcabs,enerofauger,sigma_aug,
     .               enerofauger,sigma_aug,
     .               bckcoeff,trncoeff,
     .               trlen,trlenp,trlenb,trlent,trlens,bremsfudge

C    INTEGER COMMON BLOCK

      integer           nin
      integer           nback
      integer           ntran
      integer           nouts
      integer           noutr
      integer           noutl
      integer           noutlr

      integer           nquads

      integer           nreg
      integer           nener
      integer           nele(maxreg)
      integer           nelem
      integer           elem(maxreg,maxele)

** shell tabulation
      integer           shell(maxshell,maxele)
      integer           xcharline(maxxchar,maxele)
      integer           nshell
      integer		nshellofreg(maxreg)
cs      integer		  shellofreg(maxreg,maxshells)
      integer		shellofreg(1)
      pointer           (p2shellofreg,shellofreg)
cs      integer           elemofshell(maxshells)
      integer           elemofshell(1)
      pointer           (p2elemofshell,elemofshell)
cs      integer           shellofshell(maxshells)
      integer           shellofshell(1)
      pointer           (p2shellofshell,shellofshell)
      integer           iscrofshell
cs      integer           nscrofshell(maxshells)
      integer           nscrofshell(1)
      pointer           (p2nscrofshell,nscrofshell)
cs      integer           scrofshell(maxshells,maxscr+maxpst)
      integer           scrofshell(1)
      pointer           (p2scrofshell,scrofshell)
cs      integer           histofion(maxshells)
      integer           histofion(1)
      pointer           (p2histofion,histofion)
cs      integer           nscrofion(maxshells)
      integer           nscrofion(1)
      pointer           (p2nscrofion,nscrofion)
cs      integer           scrofion(maxshells,maxscr+maxpst)
      integer           scrofion(1)
      pointer           (p2scrofion,scrofion)
      integer           mxionscr
      integer           niontoscr(maxscr+maxpst)
cs      integer           iontoscr(maxscr+maxpst,maxshells)
      integer           iontoscr(1)
      pointer           (p2iontoscr,iontoscr)
cs      integer           nscrofxcg(maxxchars)
      integer           nscrofxcg(1)
      pointer           (p2nscrofxcg,nscrofxcg)
cs      integer           scrofxcg(maxxchars,maxscr+maxpst)
      integer           scrofxcg(1)
      pointer           (p2scrofxcg,scrofxcg)
      integer           mxxcgscr
      integer           nxcgtoscr(maxscr+maxpst)
cs      integer           xcgtoscr(maxscr+maxpst,maxxchars)
      integer           xcgtoscr(1)
      pointer           (p2xcgtoscr,xcgtoscr)
cs      integer           nscrofxcd(maxxchars)
      integer           nscrofxcd(1)
      pointer           (p2nscrofxcd,nscrofxcd)
cs      integer           scrofxcd(maxxchars,maxscr+maxpst)
      integer           scrofxcd(1)
      pointer           (p2scrofxcd,scrofxcd)
cs      integer           xdetscrofxcd(maxxchars,maxscr+maxpst)
      integer           xdetscrofxcd(1)
      pointer           (p2xdetscrofxcd,xdetscrofxcd)
      integer           mxxcdscr
      integer           nxcdtoscr(maxscr+maxpst)
cs      integer           xcdtoscr(maxscr+maxpst,maxxchars)
      integer           xcdtoscr(1)
      pointer           (p2xcdtoscr,xcdtoscr)
cs      integer           xdetscr(maxscr+maxpst,maxxchars)
      integer           xdetscr(1)
      pointer           (p2xdetscr,xdetscr)
cs      integer           npsminofion(maxshells)
      integer           npsminofion(1)
      pointer           (p2npsminofion,npsminofion)
cs      integer           psminofion(maxshells,maxsav)
      integer           psminofion(1)
      pointer           (p2psminofion,psminofion)
      integer           mxionpm
      integer           niontopm(maxsav)
cs      integer           iontopm(maxsav,maxshells)
      integer           iontopm(1)
      pointer           (p2iontopm,iontopm)
cs      integer           npsminofxcg(maxxchars)
      integer           npsminofxcg(1)
      pointer           (p2npsminofxcg,npsminofxcg)
cs      integer           psminofxcg(maxxchars,maxsav)
      integer           psminofxcg(1)
      pointer           (p2psminofxcg,psminofxcg)
      integer           mxxcgpm
      integer           nxcgtopm(maxsav)
cs      integer           xcgtopm(maxsav,maxxchars)
      integer           xcgtopm(1)
      pointer           (p2xcgtopm,xcgtopm)
cs      integer           npsminofxcd(maxxchars)
      integer           npsminofxcd(1)
      pointer           (p2npsminofxcd,npsminofxcd)
cs      integer           psminofxcd(maxxchars,maxsav)
      integer           psminofxcd(1)
      pointer           (p2psminofxcd,psminofxcd)
cs      integer           xdetpsminofxcd(maxxchars,maxsav)
      integer           xdetpsminofxcd(1)
      pointer           (p2xdetpsminofxcd,xdetpsminofxcd)
      integer           mxxcdpm
      integer           nxcdtopm(maxsav)
cs      integer           xcdtopm(maxsav,maxxchars)
      integer           xcdtopm(1)
      pointer           (p2xcdtopm,xcdtopm)
cs      integer           xdetpm(maxsav,maxxchars)
      integer           xdetpm(1)
      pointer           (p2xdetpm,xdetpm)
cs      integer           nionhist(maxshells)
      integer           nionhist(1)
      pointer           (p2nionhist,nionhist)
cs      integer           ionhist(maxshells,maxhis)
      integer           ionhist(1)
      pointer           (p2ionhist,ionhist)
cs      integer           nxcharofshell(maxshells)
      integer           nxcharofshell(1)
      pointer           (p2nxcharofshell,nxcharofshell)
cs      integer           xcharofshell(maxshells,maxxchars)
      integer           xcharofshell(1)
      pointer           (p2xcharofshell,xcharofshell)
cs      integer           xdetxchis(maxxchars,maxhis)
      integer           xdetxchis(1)
      pointer           (p2xdetxchis,xdetxchis)
cs      integer           xchis(maxxchars,maxhis)
      integer           xchis(1)
      pointer           (p2xchis,xchis)
cs      integer           nxchis(maxxchars)
      integer           nxchis(1)
      pointer           (p2nxchis,nxchis)
      integer           xdetxkhis(1)
      pointer           (p2xdetxkhis,xdetxkhis)
      integer           xkhis(1)
      pointer           (p2xkhis,xkhis)
      integer           nxkhis(1)
      pointer           (p2nxkhis,nxkhis)
cs      integer           xchtabindx(maxele,maxshell,maxxchars)
      integer           xchtabindx(1)
      pointer           (p2xchtabindx,xchtabindx)
      integer           nxchtabindx(maxele,maxshell)
cs      integer           ixcharofxcont(maxxchars)
      integer           ixcharofxcont(1)
      pointer           (p2ixcharofxcont,ixcharofxcont)

** auger tabulation
      integer		nauger
      integer           augerpeak(mxaugp,maxele)
      integer           augpkener(mxaugp,maxele)
      integer           augershell(maxele,maxshell)
      integer		elemofauger(maxauger)
      integer 		lineofauger(maxauger)
      integer		addhis(maxauger)
      integer		agdhis(maxauger)
      integer 		idethis
      
      integer           e_shell(maxshell)

      integer           nelesource

      integer           atnum(maxele)

      integer           Nvalence(maxreg,maxele)

**  elastic scattering
      integer           ncosthintv(maxreg)

**  plasmon loss
      integer           n_plasmon_int(maxreg)

**  secondary electrons
      integer	 	sec_etyp(maxsec)
      integer		sec_esubtyp(maxsec)
      integer           nsec      

** charcteristic x-rays
*  data structure analogous to ion
      integer           xcchar (maxxchar,maxele) 
      integer           nxchar
      integer           xcele(maxreg,maxxchar)
      integer           xcshell(maxreg,maxxchar) 
      integer		nxcharofreg(maxreg)
cs      integer	          xcharofreg(maxreg,maxxchars)
      integer		xcharofreg(1)
      pointer           (p2xcharofreg,xcharofreg)
cs      integer           elemofxchar(maxxchars)
      integer           elemofxchar(1)
      pointer           (p2elemofxchar,elemofxchar)
cs      integer           xcharofxchar(maxxchars)
      integer           xcharofxchar(1)
      pointer           (p2xcharofxchar,xcharofxchar)
cs      integer           shellofxchar(maxxchars)
      integer           shellofxchar(1)
      pointer           (p2shellofxchar,shellofxchar)

** Bremsstrahlung
      integer           nxcont
      integer           nxcorig
      integer           nxptob
cs      integer           ixcontofxchar(maxxcont)
      integer           ixcontofxchar(1)
      pointer           (p2ixcontofxchar,ixcontofxchar)

** scattering information
      integer           nscatter(4)

** x-ray detector information
      integer           xdefftype(0:maxxdet)

      common /SESAMI/
     1               nquads,nreg,nele,nelem,nener,nshell,elem,
     2               atnum,shell,Nvalence,e_shell,
     3               ncosthintv,n_plasmon_int,nsec,nelesource,
cs     4               nshellofreg,shellofreg,elemofshell,
     4               nshellofreg,
cs     5               shellofshell,iscrofshell,nscrofshell,scrofshell,
     5               iscrofshell,
cs     6               histofion,nscrofion,nscrofxcg,nscrofxcd,
cs     7               scrofion,scrofxcg,scrofxcd,xdetscrofxcd,
cs     8               mxionscr,niontoscr,iontoscr,
     8               mxionscr,niontoscr,
cs     9               mxxcgscr,nxcgtoscr,xcgtoscr,
     9               mxxcgscr,nxcgtoscr,
cs     .               mxxcdscr,nxcdtoscr,xcdtoscr,xdetscr,
     .               mxxcdscr,nxcdtoscr,
cs     .               npsminofion,npsminofxcg,npsminofxcd,
cs     .               psminofion,psminofxcg,psminofxcd,xdetpsminofxcd,
cs     .               mxionpm,niontopm,iontopm,
     .               mxionpm,niontopm,
cs     .               mxxcgpm,nxcgtopm,xcgtopm,
     .               mxxcgpm,nxcgtopm,
cs     .               mxxcdpm,nxcdtopm,xcdtopm,xdetpm,
     .               mxxcdpm,nxcdtopm,
cs     .               nionhist,ionhist,
cs     .               nxcharofshell,xcharofshell,
cs     .               nxchtabindx,xchtabindx,xdetxchis,
     .               nxchtabindx,
cs     .               xchis,nxchis,xcchar,nxchar,xcharline,xcele,
     .               xcchar,nxchar,xcharline,xcele,
cs     .               xcshell,nxcharofreg,xcharofreg,
     .               xcshell,nxcharofreg,
cs     .               nxcont,nxptob,ixcharofxcont,ixcontofxchar,
     .               nxcont,nxcorig,nxptob,
cs     .               elemofxchar,xcharofxchar,shellofxchar,
     .               nin,nback,ntran,nouts,noutr,noutl,noutlr,
     .		     nauger,elemofauger,lineofauger,
     .		     agdhis,addhis,
     .               augerpeak,augpkener,
     .               augershell,idethis,sec_etyp,sec_esubtyp,
     .               nscatter,xdefftype

C    LOGICAL COMMON BLOCK      

      logical lsing(maxreg)
      logical lplas(maxreg)
      logical laugfile
      LOGICAL LPRIM,LBACK,LTRAN,LSECON,LAUGER

      common /SESAML/
     2              lsing,lplas,laugfile,
     3              LPRIM,LBACK,LTRAN,LSECON,LAUGER

C    CHARACTER COMMON BLOCK  

      character*70  fmat(maxreg)
      character*104 infile
      character*64  outfile
      character*64  augerfile

      common /SESAMC/
     2               fmat,infile,outfile,augerfile

C    POINTER COMMON BLOCK
      common /SESAP1/
     2               p2ixcontofxchar,p2xdeteffofxchar,p2fwhmofxchar,
     3               p2enerofxcont,p2xdetofxcont,p2enerofshell,
     4               p2ionintofshell,p2shellofreg,p2elemofshell,
     5               p2shellofshell,p2nscrofshell,p2scrofshell,
     6               p2histofion,p2nscrofion,p2scrofion,p2iontoscr,
     7               p2npsminofion,p2psminofion,p2iontopm,
     8               p2nionhist,p2ionhist,p2nxcharofshell,
     9               p2xcharofshell

      common /SESAP2/
     2               p2enerofxchar,p2xgenofxchar,p2xdetofxchar,
     3               p2xpeaktoback,p2xfiorifact,p2fyieldofxchar,
     4               p2frelintofxchar,p2ffudgeofxchar,
     5               p2nscrofxcg,p2scrofxcg,p2xcgtoscr,
     6               p2nscrofxcd,p2scrofxcd,p2xdetscrofxcd,
     7               p2xcdtoscr,p2xdetscr,p2npsminofxcg,
     8               p2psminofxcg,p2xcgtopm,p2npsminofxcd,
     9               p2psminofxcd,p2xdetpsminofxcd,p2xcdtopm,
     1               p2xdetpm,p2xdetxchis,p2xchis,
     2               p2nxchis,p2xchtabindx,p2ixcharofxcont,
     3               p2xcharofreg,p2elemofxchar,p2xcharofxchar,
     4               p2shellofxchar,p2xkhis,p2nxkhis,p2xdetxkhis,
     5               p2xchiswinfrac

