c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
      double precision EPSMA,SMALL,VBNDLO,VBNDUP
      PARAMETER (EPSMA=1E-14,SMALL=1E-20)
      PARAMETER (VBNDLO=1E-30,VBNDUP=1E30)

      double precision PI,ZERO,ONE,TWO,THREE,FOUR,FIVE,SIX,TEN
      PARAMETER (PI=0.31415926535897931160D+01)
CS M  PARAMETER (PI=3.141592654)
      PARAMETER (ZERO=0,ONE=1,TWO=2,THREE=3,FOUR=4,FIVE=5,SIX=6,TEN=10)

      double precision HALF,THIRD,QUART
      PARAMETER (HALF=ONE/TWO,THIRD=ONE/THREE,QUART=ONE/FOUR)

      double precision 	a0,e2,rf,echarge,h_,me,n_avo,dtr,h2d2m
      parameter (   a0=       0.529177e0    )	!Bohr radius in Angstr
      parameter (   echarge=  1.6e-19       )	!elem charge
      parameter (   e2=       14.4e0        )	!e^2 in eV-Angstr.
      parameter (   rf=       0.885e0       )	!Fermi scr. radius const
      parameter (   h_=       6.582e-16     )	!Planck const in eV-s
      parameter (   me=       0.511e6       )	!electr.  mass in  eV
      parameter (   N_Avo=    6.02217e23    )	!Avogadros Number
      parameter (   dtr=      0.017453293   )	!converts degrees to rad
      parameter (   h2d2m=    3.807	    )   !h_^2/2m in eV-Ang^2

      INTEGER           MAX
      integer		maxele,maxreg,maxener,maxshell,maxran,maxran_e
      integer	        maxener_e,maxener_i,maxran_i,maxstate,maxsec
cs      integer           maxu,maxw,ntrans,maxshells,maxxchar,maxxchars
      integer           maxu,maxw,ntrans,maxxchar,maxxchars
      integer           maxauger,mxaugp,maxedtrn,maxedet,maxxdet
      integer           mdefxcont,maxxcont,nbcksz
	
      parameter 	(maxran=1000)
      parameter		(maxran_e=90)
      parameter		(maxran_i=2000)
      parameter 	(maxele=20)
      parameter 	(maxreg=40)
      parameter 	(maxener=100)
      parameter 	(maxener_e=60)
      parameter 	(maxener_i=20)
      parameter	 	(maxstate =2000)
      parameter 	(maxshell=16)
cs      parameter         (maxshells=30)
      parameter 	(maxxchar=10)
      parameter 	(maxxchars=50)
      parameter         (mdefxcont=32)
      parameter         (maxxcont=256)
      parameter	   	(maxsec=10000)
      parameter	   	(maxu=50)
      parameter	   	(maxw=100)
      parameter		(maxauger=30)
      parameter         (mxaugp=3)
      parameter  	(maxedtrn=50)
      parameter		(ntrans=20000)
      parameter         (maxedet=5)
      parameter         (maxxdet=5)
      parameter         (nbcksz=50)

c     maxele	    maximum number of elements
c     maxreg	    maximum number of regions
c     maxener	    maximum number of energy intervals
c     maxener_e	    maximum number of energy intervals for elastic scattering
c     maxener_i	    maximum number of energy intervals for inelastic scattering
c     maxshell	    maximum number of shells per atom (K to N7)
c     maxshells     maximum number of total shells in simulation
c     maxxchar	    maximum number of characteristic x-rays per atom
c     maxxchars     maximum number of total char. x-rays in simulation
c     mdefxcont     default value for nxcont for histograms
c     maxxcont      default number of descrete Bremsstrahlung energies
c                   should not be smaller than maxxchars
c     maxu          maximum number of overvoltage ratios for delta E
c     maxw          maximum number of enegy loss ratios for delta 
c     maxran	    maximum number of random number intervals
c     maxran_e      (max.) number of random numbers for elastic scattering
c     maxran_i      (max.) number of random numbers for inelastic scattering
c     maxstate      size of histogram array for energy distribution
c     maxauger      maximum number of simulated Auger lines
c     mxaugp        maximum number of different Auger peaks (KLL, LMM, MNN)
c     maxedtrn      maximum size of electron detector transmission arraye
c     ntrans        size of transformation matrix elasttrans()
c     maxseg        maximum number of ????
c     maxxdet       maximum number of x-ray detectors
c     maxedet       maximum number of electron detectors
c     nbcksz        size of histogram for spectrum background

**    /INIT/
      integer NSIG
      PARAMETER (NSIG=5)
**    /TARGET/
      integer N1M,N2M,NRM,NPTM
      PARAMETER (N1M=0,N2M=20)
CS    N2M MUST BE SET EQUAL TO MAXELE
      PARAMETER (NRM=40,NPTM=1000)
CS    NRM MUST BE SET EQUAL TO MAXREG
**    /DETECTOR/
      integer MXDLAY
      PARAMETER (MXDLAY=10)
**    /GRID/
      integer NXM,NZM,NYM
      PARAMETER (NXM=50,NZM=50,NYM=50)
**    /OUTPUT/
      integer MAXSCR,MAXPST,MAXSAV,MAXHIS
      PARAMETER (MAXSCR=20,MAXPST=6,MAXSAV=10,MAXHIS=40)
CS    MAXHIS MUST BE EQUAL TO MXHIST IN HIST.INC
*     MAXIMUM PIXEL NUMBER IN X AND Y DIRECTION
      INTEGER MXXPIX,MXYPIX
      PARAMETER (MXXPIX=1200,MXYPIX=1000)
**    /SCAN/
*     MAXIMUM NUMBER OF SCAN POSITIONS
      INTEGER MAXSCAN
      PARAMETER (MAXSCAN=1000)
**    /DEFAULT VALUES/
*     POLAR ANGLE (0 - 180 DEG)
      double precision DEFPOL,DEFAZI
      PARAMETER (DEFPOL=180)
*     AZIMUTHAL ANGLE (0 - 360 DEG)    
      PARAMETER (DEFAZI=360)
      INTEGER NSCXOF,NSCYOF,NSCSIX,NSCSIY,NPSSIX,NPSSIY
*     DEFAULT SCREEN OFFSET IN X-DIRECTION
      PARAMETER (NSCXOF=40)
*     DEFAULT SCREEN OFFSET IN Y-DIRECTION
      PARAMETER (NSCYOF=30)
*     DEFAULT SCREEN SIZE IN X-DIRECTION
      PARAMETER (NSCSIX=740)
*     DEFAULT SCREEN SIZE IN Y-DIRECTION
      PARAMETER (NSCSIY=520)
      INTEGER NPSXSI,NPSYSI
*     DEFAULT POSTSCRIPT OUTPUT SIZE IN WIDTH-DIRECTION
      PARAMETER (NPSSIX=500)
*     DEFAULT POSTSCRIPT OUTPUT SIZE IN HEIGHT-DIRECTION
      PARAMETER (NPSSIY=500)
*     DEFAULT OUTPUT ON SCREEN: [SC=SCAN MODE, NSC=NOT SCAN MODE]
      CHARACTER*70 CXCSC,CXCNSC,CXKSC,CXKNSC,CXRSC,CXRNSC
      CHARACTER*70 CBESC,CBENSC,CSESC,CSENSC,CTESC,CTENSC
      CHARACTER*70 CAESC,CAENSC,CIOSC,CIONSC
*     FOR SIGNAL=XC
      PARAMETER (CXCSC='XCS')
      PARAMETER (CXCNSC='XCS')
*     FOR SIGNAL=XK
      PARAMETER (CXKSC='XKS')
      PARAMETER (CXKNSC='XKS')
*     FOR SIGNAL=XR
      PARAMETER (CXRSC='XRS')
      PARAMETER (CXRNSC='XRS')
*     FOR SIGNAL=BE
      PARAMETER (CBESC='BEY')
      PARAMETER (CBENSC='BEE')
*     FOR SIGNAL=SE
      PARAMETER (CSESC='SEY')
      PARAMETER (CSENSC='SEE')
*     FOR SIGNAL=TE
      PARAMETER (CTESC='TEY')
      PARAMETER (CTENSC='TEE')
*     FOR SIGNAL=AE
      PARAMETER (CAESC='AEY')
      PARAMETER (CAENSC='AES')
*     FOR SIGNAL=IO
      PARAMETER (CIOSC='ION')
      PARAMETER (CIONSC='ION')
*     DEFAULT FRACTION OF MARGIN ON SCREEN FOR LOCATION DEPENDENT OUTPUT
*     DEFAULT VALUE IS 15%
      DOUBLE PRECISION SCMARG
      PARAMETER (SCMARG=0.15)
