c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
* last modification: CS 06-Dec-1994

*     MAXDIM: MAXIMUM DIMENSION OF HISTOGRAMS
*     MXHIST: MAXIMUM NUMBER OF HISTOGRAMS
*             (MUST BE EQUAL TO MAXHIS IN PARAM.INC)
*     MAXVAL: MAXIMUM NUMBER OF HISTOGRAM VALUES
*     NHINT:  DEFAULT VALUE FOR NUMBER OF INTERVALS (eigntlich Stuetzstellen)
*     VALHIS(): HISTOGRAM VALUES
*     IVBEG(J): FIRST ENTRY IN VALHIS() OF HISTOGRAM J
*     VALMIN(J,K): MINIMUM VALUE OF AXIS K OF HISTOGRAM J
*     VALMAX(J,K): MAXIMUM VALUE OF AXIS K OF HISTOGRAM J
*     VDELT(J,K): INTERVAL WIDTH OF AXIS K OF HISTOGRAM J
*     NVAL(J,K): NUMBER OF INTERVALS OF AXIS K OF HISTOGRAM J
*     NVDIM(J): DIMENSION OF HISTOGRAM J
*     NVTOT: TOTAL NUMBER OF OCCUPIED ENTRIES IN VALHIS()
*     NHIST: TOTAL NUMBER OF HISTOGRAMS
*     CVALUE(J): DEFINES THE STORED INFORMATION (SEE,BEA,...)
*     CHISTITLE(J): CONTAINS ADDITIONAL HISTOGRAM SCREEN TITLES
*     CHFILE(J): FILENAME FOR HISTOGRAM
*     COUT(J): SPECIFIES THE OUTPUT FILE (H1D,H2D,H3D,SAV,H2S,..)
*     HISSCR(J): OUTPUT OF HISTOGRAM J TO SCREEN# HISSCR(J)
*     HISEDT(J): DETECTOR NUMBER
*     HISUNT(J,I): UNIT FOR I-TH AXIS FOR HISTOGRAM J
*     HISENWIN(J,2): ENERGY WINDOW (EV) FOR X-RAY SCANS
*                    1: LEFT BOUNDARY
*                    2: RIGHT BOUNDARY
*     LOUTTO(J,I): OUTPUT OF HISTOGRAM J TO:
*                  I=0: NO OUTPUT AT ALL
*                  I=1: WINDOW ON SCREEN
*                  I=2: HISTOGRAM ASCII FILE
*                  I=3: PROMIS SAVE FILE
*     LENGY(J,I):  I-TH AXIS OF HISTOGRAM J IS AN ENERGY AXIS
*     LAZIMU(J,I): I-TH AXIS OF HISTOGRAM J IS AN AZIMUTHAL ANGLE AXIS
*     LPOLAR(J,I): I-TH AXIS OF HISTOGRAM J IS A POLAR ANGLE AXIS
*     LYIELD(J,I): I-TH AXIS OF HISTOGRAM J IS A YIELD AXIS

*     LHIS:   AT LEAST ONE HISTOGRAM IS TO BE WRITTEN
*     LBE:    AT LEAST ONE BE HISTOGRAM IS TO BE WRITTEN
*     LTE:    AT LEAST ONE TE HISTOGRAM IS TO BE WRITTEN
*     LSE:    AT LEAST ONE SE HISTOGRAM IS TO BE WRITTEN
*     LAE:    AT LEAST ONE AE HISTOGRAM IS TO BE WRITTEN
*     LIO:    AT LEAST ONE ION HISTOGRAM IS TO BE WRITTEN
*     LXR:    AT LEAST ONE XR HISTOGRAM IS TO BE WRITTEN
*     LXC:    AT LEAST ONE XC HISTOGRAM IS TO BE WRITTEN
*     LXK:    AT LEAST ONE XK HISTOGRAM IS TO BE WRITTEN
*     LANG:   AT LEAST ONE ANGLE DISTRIBUTION (AZIMUTHAL OR POLAR) IS TO BE
*             UPDATED
*     LAANG:  AT LEAST ONE AZIMUTHAL ANGLE DISTRIBUTION IS TO BE UPDATED
*     LPANG:  AT LEAST ONE POLAR ANGLE DISTRIBUTION IS TO BE UPDATED
*     LENERG: AT LEAST ONE ENERGY DISTRIBUTION IS TO BE UPDATED
*     VALION: HISTOGRAM FOR IONISATIONS
*     VALBREMS: HISTOGRAM FOR CONTINUUM X-RAYS
*
*     HBND:   IS ONE-EPSMA; NEEDED IN HISTOG FOR CORRECT ASSIGNMENT OF
*             VALUES TO HISTOGRAM ENTRIES

      PARAMETER (MAXDIM=3,MXHIST=40,MAXVAL=50000)
      PARAMETER (NHINT=30)
      PARAMETER (MAXXCSHIS=12)
      PARAMETER (MAXXKSHIS=12)

**********************************************************************

      INTEGER HISSCR(MXHIST),HISEDT(MXHIST)
      INTEGER IVBEG(MXHIST),NVAL(MXHIST,MAXDIM),NVDIM(MXHIST)
      INTEGER XCSHIS(MAXXCSHIS),XCSDET(MAXXCSHIS)
      INTEGER XKSHIS(MAXXKSHIS),XKSDET(MAXXKSHIS)

      COMMON / HISTI / NVTOT,NHIST,NVAL,NVDIM,IVBEG,HISSCR,HISEDT,
     &                 NXCSHIS,XCSHIS,XCSDET,NXKSHIS,XKSHIS,XKSDET

**********************************************************************

CS      DOUBLE PRECISION VALHIS(MAXVAL)
      DOUBLE PRECISION VALHIS(1)
      POINTER (P2VALHIS,VALHIS)
      DOUBLE PRECISION VALMIN(MXHIST,MAXDIM),VALMAX(MXHIST,MAXDIM)
      DOUBLE PRECISION VDELT(MXHIST,MAXDIM)
      DOUBLE PRECISION HISENWIN(MXHIST,2)

CS      COMMON / HISTR / VALHIS,VALMIN,VALMAX,VDELT,HBND
      COMMON / HISTR / VALMIN,VALMAX,VDELT,HBND,HISENWIN
      COMMON / HISTP / P2VALHIS

**********************************************************************

      LOGICAL LBE,LSE,LTE,LAE,LIO,LXR,LXC,LXK
      LOGICAL LANG,LAANG,LPANG,LENERG
      LOGICAL LENGY(MXHIST,MAXDIM),LYIELD(MXHIST,MAXDIM)
      LOGICAL LAZIMU(MXHIST,MAXDIM),LPOLAR(MXHIST,MAXDIM)
      LOGICAL LOUTTO(MXHIST,0:3)

      COMMON / HISTL / LHIS,LBE,LTE,LSE,LAE,LIO,LXR,LXC,LXK,
     1                 LANG,LAANG,LPANG,LENERG,LENGY,
     2                 LAZIMU,LPOLAR,LOUTTO

**********************************************************************

      CHARACTER*70 CHFILE(MXHIST)
      CHARACTER*40 CHISTITLE(MXHIST)
      CHARACTER*5  HISUNT(MXHIST,MAXDIM)
      CHARACTER*3  CVALUE(MXHIST),COUT(MXHIST)

      COMMON / HISTC / CHFILE,CHISTITLE,CVALUE,COUT,HISUNT

**********************************************************************

      INTEGER NOUTGR,NOUTAR,NBREMSOUTGR,NBREMSOUTAR

      COMMON / HISIIO / NOUTGR,NOUTAR,NBREMSOUTGR,NBREMSOUTAR

CS      DOUBLE PRECISION VALION(MAXSHELLS,NXM,NZM)
CS      DOUBLE PRECISION VALBREMS(MAXXCONT,NXM,NZM,0:MAXXDET)

CS      COMMON / HISDIO / VALION,VALBREMS
