c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
* last modification: CS 13-Feb-1997
*
*     
*     LOCOUT(I,M): ACTUAL SCREEN AND POSTSCRIPT FILE NUMBERS;
*                  CONSECUTIVE INDEX; I=1: PET; I=2: BET;
*                  I=3: TET; I=4: SET; I=5: AET; I=6: ION; I=7: PEB
*     SHELLSCR(MAXSHELL,MAXELE,IRUN): SCREEN NUMBER FOR SHELL AND ELEMENT
*     LLOC:        AT LEAST ONE LOCATION DEPENDENT OUTPUT
*     NLOCOUT(I):  SUM OF NLOCSC(I) AND NLOCPS(I)
*     ILOCST(I):   ACTUAL STARTING ENTRY OF OUTPUT (SCR AND PS OR ONLY PS)
*     NXLOC(I):    XPGP - DEVICE NUMBER OF LOCATION DEPENDENT OUTPUT I
*     NXSTAT  :    XPGP - DEVICE NUMBER OF STATUS WINDOW
*     NXCSTAT :    XPGP - DEVICE NUMBER OF XCHAR TABLE WINDOW
*     NXKSTAT :    XPGP - DEVICE NUMBER OF P/B TABLE WINDOW
*     NXDSTAT :    XPGP - DEVICE NUMBER OF X-RAY DETECTOR TABLE WINDOW
*     NLOC    :    NUMBER OF LOCATION DEPENDENT OUTPUTS (NSCL+NPS)
*     TRNMAT(I,J): TRANSFORMATION MATRIX FOR LOC OUTPUT J, I see TRNXYZ
*     LSCRN: AT LEAST ONE SCREEN() OUTPUT SPECIFIED AND OUTPUT SHOULD
*            BE ACTUALLY DIRECTED TO SCREEN (in COMMON.INC declared)
*     LSCRN1: SCREEN() OUTPUT MUST BE CALCULATED INDEPENDENT OF LSCRN
*       LSCLOC: AT LEAST ONE LOCATION DEPENDENT OUTPUT (TRAJECTORIES,
*               LOCATION OF IONIZATIONS) ON SCREEN
*	  NLOCSC(I): NUMBER OF OUTPUTS OF "SIGNAL" I TO SCREENS
*	  SCMIMA(J,I): MINIMUM (J=1,3,5) AND MAXIMUM VALUE (J=2,4,6)
*		       OF OUTPUT I
*	  SCMNMX(J,K): MINIMUM (J=1,3,5) AND MAXIMUM VALUE (J=2,4,6)
*		       OF SCREEN NUMBER K
*	  NSCL: NUMBER OF OPEN LOCATION DEPENDENT WINDOWS ON SCREEN
*         LSCSHL(I,J,K): IF TRUE OUTPUT OF IONIZATION OF ELEMENT I AND
*                        SHELL J ON SCREEN K (K=1,L1=2,L2=3,L3=4,M1=5,M2=6,
*                        M3=7,M4=8,M5=9)
*	  AGDLOC(I):  OUTPUT NUMBER OF SURFACE-IONIZATION FOR AUGLINE I
*         ADDLOC(I):  OUTPUT NUMBER OF DETECT DIST. OF AUGERLINE I
*         ADDLCED(I): DETECTOR NUMBER OF DETECT DIST. OF AUGERLINE I
*         NAE_HIS(I): NUMBER OF ENTRIES IN AE_HIS(I,*)
*         AE_HIS(I,J): AE HISTOGRAM NUMBERS
*         LSCS(I,J): SORT OF HELP ARRAY
*       LSCHIS: AT LEAST ON HISTOGRAM OUTPUT ON SCREEN
*         NSCH: NUMBER OF OPEN HISTOGRAM WINDOWS ON SCREEN
*       LQUAD:  OUTPUT OF QUADTREE ON SCREEN
*       LGRID:  OUTPUT OF GRID ON SCREEN
*	NSCRN:	TOTAL NUMBER OF OPEN WINDOWS ON SCREEN
*       IONCOL(I) : COLORTABLE FOR IONIZATION
*       NPALET    : SIZE OF COLOR PALETTE
*       NCOLOR(I) : COLOR PALETTE
*       NGRAY(I) : GRAY PALETTE
*	SCXSIZ(I): PIXELS OF SCREEN I IN X-DIRECTION
*	SCYSIZ(I): PIXELS OF SCREEN I IN Y-DIRECTION
*	SCXOFF(I): PIXELS OFFSET OF SCREEN I IN X-DIRECTION
*	SCYOFF(I): PIXELS OFFSET OF SCREEN I IN X-DIRECTION
*	NSCINP(M): INDEX (=DEFAULT SCREEN NUMBER) OF SCREEN() ARRAY
*                  INPUT DECK [M=CONSECUTIVE INDEX]
*	NSCOUT(M): SCREEN NUMBER SPECIFIED IN THE SCREEN() ARRAY
*                  [M=CONSECUTIVE INDEX]
*       SCRTITLE(I): TITLE OF LOCATION DEPENDENT SCREENS
*       ZMXSCD: MAXIMUM Z VALUE TO WHICH TO DRAW
*       ZMNSCD: MINIMUM Z VALUE TO WHICH TO DRAW
*
*     LPOST: AT LEAST ONE OUTPUT TO POSTSCRIPT FILE
*	NLOCPS(I): NUMBER OF OUTPUTS OF "SIGNAL" I TO PS FILES
*		   MEANING OF INDEX I SEE LOCOUT()
*	FILEPS(I): FILE NAME OF POSTSCRIPT FILE I
*	NPS: NUMBER OF OPEN POSTSCRIPT FILES
*	PSXSIZ(I): WIDTH OF PS FILE I IN POINTS (1/72 INCH)
*	PSYSIZ(I): HEIGHT OF PS FILE I IN POINTS (1/72 INCH)
*
*     LPMSAV: OUTPUT TO POSTMINI SAVE FILE
*	NPM: TOTAL NUMBER OF POSTMINI SAVE FILES
*       LPMION: IONIZATION DISTRIBUTION TO POSTMINI SAVE FILE (SORTIN,WRSAVE)
*	LPMHIS: AT LEAST ONE HISTOGRAM TO POSTMINI SAVE FILE
*	  NPMH: NUMBER OF HISTOGRAMS TO BE WRITTEN TO PM SAVE FILE
*	  NPMHIS(): INDEX OF HISTOGRAM IN THE HISTOGRAM ARRAY
*
*	FILEPM(): FILE NAME OF POSTMINI SAVE FILE
*
*     LHIS: AT LEAST ONE HISTOGRAM TO BE WRITTEN (SEE: HIST.INC)
*       BEHIS(): HISTOGRAM NUMBERS FOR BE HISTOGRAMS
*       NBEHIS:  NUMBER OF BE HISTOGRAMS
*       TEHIS(): HISTOGRAM NUMBERS FOR TE HISTOGRAMS
*       NTEHIS:  NUMBER OF TE HISTOGRAMS
*       SEHIS(): HISTOGRAM NUMBERS FOR SE HISTOGRAMS
*       NSEHIS:  NUMBER OF SE HISTOGRAMS
*       AEHIS(): HISTOGRAM NUMBERS FOR AE HISTOGRAMS
*       NAEHIS:  NUMBER OF AE HISTOGRAMS
*       LDELE(IETYP): AT LEAST ONE HISTOGRAM NEEDS DETECTED FRACTION OF
*                     ELECTRON OF TYPE IETYP.SEE ONETRJ FOR DESCRIPTION.
*
*     BCKHIS(): BACKGROUND HISTOGRAM NUMBER FOR AES
*
*
*     LOCATION DEPENDING HISTOGRAM HELP ARRAYS:
*        XCIODIS1(): IONIZATION HISTOGRAM NUMBER FOR LOCATION DEPENDENT
*                    HISTOGRAMS
*        XCIODIS2(): SCREENNUMBER OF IONIZATIONS, GENERATED AND DETECTED
*                    CHAR. X-RAYS
*        XCIODIS21():NUMBER OF ENTRIES IN XCIODIS2()
*        XCIODIS3(): SAVE FILE NUMBER FOR IONIZATIONS, GENERATED AND
*                    DETECTED CHAR. X-RAYS
*        XCIODIS31():NUMBER OF ENTRIES IN XCIODIS3()
*        XCIODIS4(): HISTOGRAM NUMBERS FOR IONIZATIONS
*        XCIODIS41():NUMBER OF ENTRIES IN XCIODIS4()
*        XCIODIS5(): AUGER LOC INFORMATION (1:ADGLOC,2:ADDLOC,3:AETLOC,4:ADDLCED)
*        XCIODIS6(): NUMBER OF ENTRIES IN XCIODIS5()
*        XCIODIS7(): AUGER HIS INFORMATION
*        XCIODIS8(): NUMBER OF ENTRIES IN XCIODIS7()
*        XCIODIS9(): HISTOGRAM NUMBERS FOR IONIZATION DISTRIBUTIONS
*        XCIODIS91():NUMBER OF ENTRIES IN XCIODIS9()
*
*     NTOSCR: NUMBER OF POSSIBLE SCREEN OUTPUT
*     NTOSCL: NUMBER OF POSSIBLE LOCATION DEPENDENT SCREEN OUTPUT
*     CTOSCR: 3 CHARACTER ABBREVIATION OF POSSIBLE SCREEN OUTPUT
*     CTOPST: 3 CHARACTER ABBREVIATION OF POSSIBLE POSTSCRIPT OUTPUT
*     NBUT:   NUMBER OF BUTTONS
*     BUTX1,BUTX2,BUTY1,BUTY2: POSITION AND SIZ OF BUTTONS
***********************************************************************

      PARAMETER (NTOSCR=40,NTOSCL=12,NTOPST=12)
      PARAMETER (NPALET=32)
      PARAMETER (NBUT=1)
***********************************************************************

      DIMENSION NSCINP(2*MAXSCR+3*MAXPST)
      DIMENSION NSCOUT(2*MAXSCR+3*MAXPST)
      DIMENSION NLOCSC(NTOSCL),NLOCPS(NTOSCL)
      DIMENSION NPMHIS(MAXSAV)
      DIMENSION NXLOC(MAXSCR+MAXPST),NXHIS(MAXSCR)
      DIMENSION NLOCOUT(NTOSCL)
      DIMENSION ILOCST(NTOSCL)
      DIMENSION NCOLOR(NPALET),NGRAY(NPALET),IACTICOL(0:NPALET)
      DIMENSION IONCOL(MAXELE)
      INTEGER ILOGIONTOSCR(MAXSCR+MAXPST)
      INTEGER ILOGXCGTOSCR(MAXSCR+MAXPST)
      INTEGER ILOGXCDTOSCR(MAXSCR+MAXPST)
      INTEGER NSHELLSCR(MAXELE,MAXSHELL)
      INTEGER SHELLSCR(MAXSHELL,MAXELE,MAXSCR+MAXPST)
      INTEGER NAGDLOC(MAXAUGER),AGDLOC(MAXAUGER,MAXSCR+MAXPST)
      INTEGER NADDLOC(MAXAUGER),ADDLOC(MAXAUGER,MAXSCR+MAXPST)
      INTEGER ADDLCED(MAXAUGER,MAXSCR+MAXPST)
      INTEGER NAETLOC(MAXAUGER),AETLOC(MAXAUGER,MAXSCR+MAXPST)
      INTEGER NAE_HIS(MAXAUGER)
      INTEGER AE_HIS(MAXAUGER,MAXHIS)
      INTEGER BEHIS(MXHIST),TEHIS(MXHIST)
      INTEGER SEHIS(MXHIST),AEHIS(MXHIST)
      INTEGER BCKHIS(0:MAXEDET)
      INTEGER LOCOUT(NTOSCL,MAXSCR+MAXPST)
      INTEGER SCXSIZ(MAXSCR),SCYSIZ(MAXSCR)
      INTEGER SCXOFF(MAXSCR),SCYOFF(MAXSCR)
      INTEGER PSXSIZ(MAXPST),PSYSIZ(MAXPST)
      INTEGER NXSTAT,NXCSTAT,NXKSTAT,NXDSTAT
      INTEGER NLOC,NBEHIS,NTEHIS,NSEHIS,NAEHIS
      INTEGER XCIODIS1(MAXELE,MAXSHELL)
      INTEGER XCIODIS2(MAXELE,MAX(MAXSHELL,MAXXCHAR),8,MAXSCR+MAXPST)
      INTEGER XCIODIS21(MAXELE,MAX(MAXSHELL,MAXXCHAR),8)
      INTEGER XCIODIS3(MAXELE,MAX(MAXSHELL,MAXXCHAR),5,MAXSAV)
      INTEGER XCIODIS31(MAXELE,MAX(MAXSHELL,MAXXCHAR),5)
      INTEGER XCIODIS4(MAXELE,MAXXCHAR,MAXHIS,2)
      INTEGER XCIODIS41(MAXELE,MAXXCHAR)
      INTEGER XCIODIS5(MAXELE,MXAUGP,MAXSCR+MAXPST,4)
      INTEGER XCIODIS6(MAXELE,MXAUGP,4)
      INTEGER XCIODIS7(MAXELE,MXAUGP,MAXHIS)
      INTEGER XCIODIS8(MAXELE,MXAUGP)
      INTEGER XCIODIS9(MAXELE,MAXSHELL,MAXHIS)
      INTEGER XCIODIS91(MAXELE,MAXSHELL)
      INTEGER BUTX1(NBUT)
      INTEGER BUTX2(NBUT)
      INTEGER BUTY1(NBUT)
      INTEGER BUTY2(NBUT)

      COMMON /OUTPTI/ NSCL,NSCH,NSCRN,NPS,NXSTAT,NXCSTAT,NXKSTAT,
     &                NXDSTAT,NLOC,LOCOUT,NSCINP,
     &		      NSCOUT,NLOCOUT,ILOCST,NLOCSC,NLOCPS,NPM,NPMH,
     &		      NPMHIS,NXHIS,NXLOC,SCXSIZ,SCYSIZ,SCXOFF,SCYOFF,
     &                NBEHIS,NTEHIS,NSEHIS,NAEHIS,BEHIS,TEHIS,
     &                SEHIS,AEHIS,BCKHIS,NADDLOC,ADDLOC,ADDLCED,NAGDLOC,
     &                AGDLOC,NAETLOC,AETLOC,NAE_HIS,AE_HIS,
     &                NCOLOR,NGRAY,IACTICOL,NSHELLSCR,SHELLSCR,IONCOL,
     &                ILOGIONTOSCR,ILOGXCGTOSCR,ILOGXCDTOSCR,
     &                PSXSIZ,PSYSIZ,XCIODIS1,
     &                XCIODIS2,XCIODIS21,XCIODIS3,XCIODIS31,
     &                XCIODIS4,XCIODIS41,XCIODIS5,XCIODIS6,
     &                XCIODIS7,XCIODIS8,XCIODIS9,XCIODIS91,
     &		      BUTX1,BUTX2,BUTY1,BUTY2

***********************************************************************

      CHARACTER*70 FILEPS(NTOSCL),FILEPM(MAXSAV)
      CHARACTER*3  CTOSCR(NTOSCR),CTOPST(NTOPST)
      CHARACTER*60 SCRTITLE(MAXSCR)

      COMMON /OUTPTC/ CTOSCR,CTOPST,FILEPS,FILEPM,SCRTITLE

***********************************************************************

      LOGICAL LDELE(6)
      LOGICAL LSCSHL(MAXELE,MAXSHELL,MAXSCR),LSCS(MAXELE,MAXSHELL)
      LOGICAL LPOST,LPMSAV,LLOC
      LOGICAL LSCLOC,LSCHIS,LPMION,LPMHIS

      COMMON /OUTPTL/ LPOST,LLOC,LPMSAV,LSCLOC,LSCHIS,LPMION,
     &                LPMHIS,LSCSHL,LSCS,LDELE


***********************************************************************

      DIMENSION SCMNMX(6,MAXSCR+MAXPST)
      DIMENSION SCMIMA(6,0:2*MAXSCR+3*MAXPST)
      DIMENSION TRNMAT(9,MAXSCR+MAXPST)

      COMMON /OUTPTR/ SCMNMX,SCMIMA,ZMNSCD,ZMXSCD,TRNMAT

***********************************************************************
c     LOWER AND UPPER LIMITS FOR FUNDAMENTAL PARAMETERS IN .DAT FILES
c     FOR CRITICAL AND CHRACTERISTIC ENERGIES

      INTEGER EDLIM(MAXSHELL,2),ECLIM(MAXXCHAR,2)
      COMMON /GETLIM/ EDLIM,ECLIM
