c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
      DOUBLE PRECISION FUNCTION  ANGLE (DX,DY)

***   ANGLE - CALCULATES ANGLE BETWEEN VECTOR (DX,DY) AND X-AXIS
*
**    ARGUMENTS
*
*     DX  - X-COORDINATE OF VECTOR
*     DY  - Y-COORDINATE OF VECTOR
*
**    AUTHOR:  C. Schiebl  19-DEC-1994
*
      INCLUDE 'TYPE.INC'

      PARAMETER (PI=3.141592654)

**    START OF EXECUTABLE CODE
*     ************************

      IF (DX.EQ.0) THEN
         IF (DY.GT.0) THEN
            ANG=90
         ELSE
            ANG=270
         ENDIF
         ANGLE=ANG
         RETURN
      ENDIF

      ANGLE=DATAN2(DY,DX)*180/PI
      IF (ANGLE.LT.0) ANGLE=360+ANGLE

      RETURN
      END
