c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
*last modification: 20-Feb-1997

      SUBROUTINE BACKUP(
     I                  IELTR,
     I                  VALION,VALBREMS,XCABS)

***   BACKUP - WRITES THE BACKUP FILE "BCK"
*
**    ARGUMENTS
*
*     IELTR  - INDEX OF THE LAST SIMULATED ELECTRON
*
**    AUTHOR:  CHRISTIAN SCHIEBL  OCT. 1995
*
      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'GLOBAL.INC'
      INCLUDE 'HIST.INC'
      INCLUDE 'OUTPUT.INC'
      INCLUDE 'FILE.INC'
      INCLUDE 'DMA.INC'

*     HISTOGRAM FOR IONISATIONS
      DOUBLE PRECISION VALION(NDMASHELL,NDMAXGRID,NDMAZGRID,NDMAYGRID)
*     BREMSSTRAHLUNG (CONTINUUM X-RAY) ARRAY
      DOUBLE PRECISION VALBREMS(NDMAXCONT,NDMAXGRID,NDMAZGRID,
     &                          NDMAYGRID,0:NDMAXDET-1)
*     ABSORPTION FACTORS (FOR CHARACTERISTIC AND BACKGROUND RADIATION)
      DOUBLE PRECISION XCABS(0:NDMAXDET-1,NDMAXCONT+NDMAXCHAR-NDMAPTOB,
     &                       NDMAXGRID,NDMAZGRID,NDMAYGRID)

      CHARACTER*80 BUFFER
      CHARACTER*20 CBL
      CHARACTER*1  CLOG

**    START OF EXECUTABLE CODE
*     ************************

      CBL='                     '

*     ---OPEN BACKUP FILE
      OPEN (NBCKUP,FILE=FETRBK(1:IEND(FETRBK)),FORM='UNFORMATTED',
     &      STATUS='UNKNOWN',IOSTAT=IOS)
CS-TEST
CS      OPEN (NBCKUP,FILE=FETRBK(1:IEND(FETRBK)),FORM='FORMATTED',
CS     &      STATUS='NEW',IOSTAT=IOS)
      IF (IOS.NE.0) THEN
         WRITE(6,'(A)')'      '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(A)')' COULD NOT OPEN BACKUP FILE'
         WRITE(6,'(A)')' NO BACKUP FILE WRITTEN'
         WRITE(6,'(A)')' SESAME - protests are useless ;-)'
         RETURN
      ENDIF

*     ---WRITE INDEX OF LAST SIMULATED ELECTRON
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,'(I12)') IELTR
      WRITE (NBCKUP)BUFFER

*     ---WRITE SEED OF RANDOM NUMBER GENERATOR
      CALL RANGET(M,IA,IB,IRAND)
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,'(4I15)') M,IA,IB,IRAND
      WRITE (NBCKUP)BUFFER

*     ---WRITE CONTENTS OF THE INPUT DECK TO BACKUP FILE
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'#START_INP_FILE'
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'&INIT    CUSTXT=''',CUSTXT(1:IEND(CUSTXT)),''''
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         JOB=''',JOB(1:IEND(JOB)),''''
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         UNITS=''',UNITS(1:IEND(UNITS)),''''
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         SIGNAL=''',
     &                          SIGNAL(1)(1:IEND(SIGNAL)),''''
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         TECHQU=''',TECHQU(1:IEND(TECHQU)),''''
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         &END'
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'&ETRNS   E0=',E0/1000
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         EF=',EF
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         NETRN=',NETRN
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         &END'
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'&EBEAM   DIVERG=',DIVERG
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         ESTD=',ESTD
      WRITE (NBCKUP)BUFFER
      CLOG='F'
      IF (SCAN) CLOG='T'
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         SCAN=',CLOG
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         SPSIZE=',SPSIZE
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         ZFOCUS=',ZFOCUS/DUNITS
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         &END'
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'&TARGET  ATMAT(1)=''',
     &                  ATMAT(1)(1:IEND(ATMAT(1))),''''
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'          DENS(1)=',DENS(1)
      WRITE (NBCKUP)BUFFER
      DO 10 I=2,MIN(NREG,9)
         BUFFER=CBL//CBL//CBL//CBL
         WRITE (BUFFER,'(A,I1,3A)')'          ATMAT(',I,')=''',
     &                  ATMAT(I)(1:IEND(ATMAT(I))),''''
         WRITE (NBCKUP)BUFFER
         BUFFER=CBL//CBL//CBL//CBL
         WRITE (BUFFER,'(A,I1,A,D18.12)')'          DENS(',I,')=',
     &                  DENS(I)
         WRITE (NBCKUP)BUFFER
 10   CONTINUE
      DO 12 I=10,NREG
         BUFFER=CBL//CBL//CBL//CBL
         WRITE (BUFFER,'(A,I2,3A)')'         ATMAT(',I,')=''',
     &                  ATMAT(I)(1:IEND(ATMAT(I))),''''
         WRITE (NBCKUP)BUFFER
         BUFFER=CBL//CBL//CBL//CBL
         WRITE (BUFFER,'(A,I2,A,D18.12)')'         DENS(',I,')=',
     &                  DENS(I)
         WRITE (NBCKUP)BUFFER
 12   CONTINUE
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         CGFILE=''',CGFILE(1:IEND(CGFILE)),''''
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         NREG=',NREG
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         &END'
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'&MODEL   AHISV=',AHISV
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         AUGMUL=',AUGMUL
      WRITE (NBCKUP)BUFFER
      DO 14 I=1,MIN(NREG,9)
         IF (FMAT(I)(1:3).NE.'   ') THEN
            IE=IEND(FMAT(I))
            BUFFER=CBL//CBL//CBL//CBL
            WRITE (BUFFER,'(A,I1,3A)')'          FMAT(',I,')=''',
     &                     FMAT(I)(1:IE),''''
            WRITE (NBCKUP)BUFFER
         ENDIF
 14   CONTINUE
      DO 16 I=10,NREG
         IF (FMAT(I)(1:3).NE.'   ') THEN
            IE=IEND(FMAT(I))
            BUFFER=CBL//CBL//CBL//CBL
            WRITE (BUFFER,'(A,I2,3A)')'          FMAT(',I,')=''',
     &                     FMAT(I)(1:IE),''''
            WRITE (NBCKUP)BUFFER
         ENDIF
 16   CONTINUE
      DO 18 I=1,MIN(MAXELE,9)
         IF (ION(I)(1:3).NE.'   ') THEN
            IE=IEND(ION(I))
            BUFFER=CBL//CBL//CBL//CBL
            WRITE (BUFFER,'(A,I1,3A)')'          ION(',I,')=''',
     &                  ION(I)(1:IE),''''
            WRITE (NBCKUP)BUFFER
         ENDIF
         IF (XCHAR(I)(1:3).NE.'   ') THEN
            IE=IEND(XCHAR(I))
            BUFFER=CBL//CBL//CBL//CBL
            WRITE (BUFFER,'(A,I1,3A)')'          XCHAR(',I,')=''',
     &                  XCHAR(I)(1:IE),''''
            WRITE (NBCKUP)BUFFER
         ENDIF
 18   CONTINUE
      DO 20 I=10,MAXELE
         IF (ION(I)(1:3).NE.'   ') THEN
            IE=IEND(ION(I))
            BUFFER=CBL//CBL//CBL//CBL
            WRITE (BUFFER,'(A,I2,3A)')'          ION(',I,')=''',
     &                  ION(I)(1:IE),''''
            WRITE (NBCKUP)BUFFER
         ENDIF
         IF (XCHAR(I)(1:3).NE.'   ') THEN
            IE=IEND(XCHAR(I))
            BUFFER=CBL//CBL//CBL//CBL
            WRITE (BUFFER,'(A,I2,3A)')'          XCHAR(',I,')=''',
     &                  XCHAR(I)(1:IE),''''
            WRITE (NBCKUP)BUFFER
         ENDIF
 20   CONTINUE
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         IONCRS=''',IONCRS(1:IEND(IONCRS)),''''
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         BREMSCRS=''',
     &                          BREMSCRS(1:IEND(BREMSCRS)),''''
      WRITE (NBCKUP)BUFFER
      CLOG='F'
      IF (LSECON) CLOG='T'
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         LSECON=',CLOG
      WRITE (NBCKUP)BUFFER
      DO 22 I=1,MIN(NREG,9)
         IE=IEND(MODR(I))
         IF (IE.GT.0) THEN
            BUFFER=CBL//CBL//CBL//CBL
            WRITE (BUFFER,'(A,I1,3A)')'          MODR(',I,')=''',
     &                  MODR(I)(1:IE),''''
            WRITE (NBCKUP)BUFFER
         ENDIF
 22   CONTINUE
      DO 24 I=10,NREG
         IE=IEND(MODR(I))
         IF (IE.GT.0) THEN
            BUFFER=CBL//CBL//CBL//CBL
            WRITE (BUFFER,'(A,I2,3A)')'          MODR(',I,')=''',
     &                  MODR(I)(1:IE),''''
            WRITE (NBCKUP)BUFFER
         ENDIF
 24   CONTINUE
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         &END'
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'&MSETUP  EBROT=',EBROT
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         EBTILT=',EBTILT
      WRITE (NBCKUP)BUFFER
      DO 26 I=0,NEDET
         BUFFER=CBL//CBL//CBL//CBL
         WRITE (BUFFER,'(A,I1,A,D18.12)')'          EDPHI(',I,')=',
     &                  EDPHI(I)
         WRITE (NBCKUP)BUFFER
         BUFFER=CBL//CBL//CBL//CBL
         WRITE (BUFFER,'(A,I1,A,D18.12)')'          EDTHET(',I,')=',
     &                  EDTHET(I)
         WRITE (NBCKUP)BUFFER
 26   CONTINUE
      DO 28 I=0,NXDET
         BUFFER=CBL//CBL//CBL//CBL
         WRITE (BUFFER,'(A,I1,A,D18.12)')'          TAKOFF(',I,')=',
     &                  TAKOFF(I)
         WRITE (NBCKUP)BUFFER
         BUFFER=CBL//CBL//CBL//CBL
         WRITE (BUFFER,'(A,I1,A,D18.12)')'          XDEROT(',I,')=',
     &                  XDEROT(I)
         WRITE (NBCKUP)BUFFER
 28   CONTINUE
      IF (NLSCP.LT.1) THEN
         BUFFER=CBL//CBL//CBL//CBL
         WRITE (BUFFER,*)'         MAGNI=',MAGNI
         WRITE (NBCKUP)BUFFER
      ENDIF
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         SCANANG=',SCANANG
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         XESPOT=',XESPOT/DUNITS
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         XRANGE=',XRANGE/DUNITS
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         &END'
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'&INSTR   XPCRT=',XPCRT/1E7
      WRITE (NBCKUP)BUFFER
      IF (NLSCP.GE.1) THEN
         BUFFER=CBL//CBL//CBL//CBL
         WRITE (BUFFER,*)'         NLSCP=',NLSCP
         WRITE (NBCKUP)BUFFER
      ENDIF
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         &END'
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'&DETECT'
      WRITE (NBCKUP)BUFFER
      DO 30 I=0,NEDET
         IE=IEND(FEDTRN(I))
         IF (IE.GT.0) THEN
            BUFFER=CBL//CBL//CBL//CBL
            WRITE (BUFFER,'(A,I1,3A)')'          FEDTRN(',I,')=''',
     &                  FEDTRN(I)(1:IE),''''
            WRITE (NBCKUP)BUFFER
         ENDIF
         BUFFER=CBL//CBL//CBL//CBL
         WRITE (BUFFER,'(A,I1,A,D18.12)')'          EDTHMN(',I,')=',
     &                  EDTHMN(I)
         WRITE (NBCKUP)BUFFER
         BUFFER=CBL//CBL//CBL//CBL
         WRITE (BUFFER,'(A,I1,A,D18.12)')'          EDTHMX(',I,')=',
     &                  EDTHMX(I)
         WRITE (NBCKUP)BUFFER
 30   CONTINUE
      DO 32 I=0,NXDET
         IF (XFDEFF(I)(1:3).NE.'   ') THEN
            IE=IEND(XFDEFF(I))
            BUFFER=CBL//CBL//CBL//CBL
            WRITE (BUFFER,'(A,I1,3A)')'          XFDEFF(',I,')=''',
     &                  XFDEFF(I)(1:IE),''''
            WRITE (NBCKUP)BUFFER
         ENDIF
 32   CONTINUE
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         &END'
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'&OUTPUT  NSCRUP=',NSCRUP
      WRITE (NBCKUP)BUFFER
      IF (CGRDFL(1:3).NE.'   ') THEN
         BUFFER=CBL//CBL//CBL//CBL
         WRITE (BUFFER,*)'         CGRDFL=''',
     &                    CGRDFL(1:IEND(CGRDFL)),''''
         WRITE (NBCKUP)BUFFER
      ENDIF
      IF (FETAB(1:3).NE.'   ') THEN
         BUFFER=CBL//CBL//CBL//CBL
         WRITE (BUFFER,*)'         FETAB=''',
     &                    FETAB(1:IEND(FETAB)),''''
         WRITE (NBCKUP)BUFFER
      ENDIF
      IF (FETRBK(1:3).NE.'   ') THEN
         BUFFER=CBL//CBL//CBL//CBL
         WRITE (BUFFER,*)'         FETRBK=''',
     &                    FETRBK(1:IEND(FETRBK)),''''
         WRITE (NBCKUP)BUFFER
      ENDIF
      CLOG='F'
      IF (LQUAD) CLOG='T'
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         LQUAD=',CLOG
      WRITE (NBCKUP)BUFFER
      CLOG='F'
      IF (LSCDEF) CLOG='T'
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         LSCDEF=',CLOG
      WRITE (NBCKUP)BUFFER
      CLOG='F'
      IF (LSCRN) CLOG='T'
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         LSCRN=',CLOG
      WRITE (NBCKUP)BUFFER
      CLOG='F'
      IF (LSTATW) CLOG='T'
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         LSTATW=',CLOG
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         NETRBK=',NETRBK
      WRITE (NBCKUP)BUFFER
      DO 34 I=1,MIN(MAXSCR,9)
         IF (SCREEN(I)(1:3).NE.'   ') THEN
            IE=IEND(SCREEN(I))
            BUFFER=CBL//CBL//CBL//CBL
            WRITE (BUFFER,'(A,I1,3A)')'          SCREEN(',I,')=''',
     &                  SCREEN(I)(1:IE),''''
            WRITE (NBCKUP)BUFFER
         ENDIF
 34   CONTINUE
      DO 36 I=10,MAXSCR
         IF (SCREEN(I)(1:3).NE.'   ') THEN
            IE=IEND(SCREEN(I))
            BUFFER=CBL//CBL//CBL//CBL
            WRITE (BUFFER,'(A,I2,3A)')'          SCREEN(',I,')=''',
     &                  SCREEN(I)(1:IE),''''
            WRITE (NBCKUP)BUFFER
         ENDIF
 36   CONTINUE
      DO 38 I=1,MIN(MAXPST,9)
         IF (POST(I)(1:3).NE.'   ') THEN
            IE=IEND(POST(I))
            BUFFER=CBL//CBL//CBL//CBL
            WRITE (BUFFER,'(A,I1,3A)')'          POST(',I,')=''',
     &                  POST(I)(1:IE),''''
            WRITE (NBCKUP)BUFFER
         ENDIF
 38   CONTINUE
      DO 40 I=10,MAXPST
         IF (POST(I)(1:3).NE.'   ') THEN
            IE=IEND(POST(I))
            BUFFER=CBL//CBL//CBL//CBL
            WRITE (BUFFER,'(A,I2,3A)')'          POST(',I,')=''',
     &                  POST(I)(1:IE),''''
            WRITE (NBCKUP)BUFFER
         ENDIF
 40   CONTINUE
      DO 42 I=1,MIN(MAXSAV,9)
         IF (PMSAV(I)(1:3).NE.'   ') THEN
            IE=IEND(PMSAV(I))
            BUFFER=CBL//CBL//CBL//CBL
            WRITE (BUFFER,'(A,I1,3A)')'          PMSAV(',I,')=''',
     &                  PMSAV(I)(1:IE),''''
            WRITE (NBCKUP)BUFFER
         ENDIF
 42   CONTINUE
      DO 44 I=10,MAXSAV
         IF (PMSAV(I)(1:3).NE.'   ') THEN
            IE=IEND(PMSAV(I))
            BUFFER=CBL//CBL//CBL//CBL
            WRITE (BUFFER,'(A,I2,3A)')'          PMSAV(',I,')=''',
     &                  PMSAV(I)(1:IE),''''
            WRITE (NBCKUP)BUFFER
         ENDIF
 44   CONTINUE
      DO 46 I=1,MIN(MAXHIS,9)
         IF (HIST(I)(1:3).NE.'   ') THEN
            IE=IEND(HIST(I))
            BUFFER=CBL//CBL//CBL//CBL
            WRITE (BUFFER,'(A,I1,3A)')'          HIST(',I,')=''',
     &                  HIST(I)(1:IE),''''
            WRITE (NBCKUP)BUFFER
         ENDIF
 46   CONTINUE
      DO 48 I=10,MAXHIS
         IF (HIST(I)(1:3).NE.'   ') THEN
            IE=IEND(HIST(I))
            BUFFER=CBL//CBL//CBL//CBL
            WRITE (BUFFER,'(A,I2,3A)')'          HIST(',I,')=''',
     &                  HIST(I)(1:IE),''''
            WRITE (NBCKUP)BUFFER
         ENDIF
 48   CONTINUE
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'         &END'
      WRITE (NBCKUP)BUFFER
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'#END_INP_FILE'
      WRITE (NBCKUP)BUFFER

*     ---WRITE LOCATION DEPENDENT HISTOGRAM INFORMATION (LDH)
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'#START_LDH_INFO'
      WRITE (NBCKUP)BUFFER
      WRITE (NBCKUP)NGRIDX,NGRIDZ,NGRIDY
      WRITE (NBCKUP)NSHELL,NXCHAR,NXCONT,NXPTOB
      CALL CHKBND(2,NGRIDX,'BACKUP','XGRIDL')
      CALL CHKBND(3,NGRIDZ,'BACKUP','ZGRIDL')
      CALL CHKBND(4,NGRIDY,'BACKUP','YGRIDL')
      DO 110 I=1,NGRIDX
         WRITE (NBCKUP)XGRIDL(I)
 110  CONTINUE
      DO 113 I=1,NGRIDZ
         WRITE (NBCKUP)ZGRIDL(I)
 113  CONTINUE
      DO 115 I=1,NGRIDY
         WRITE (NBCKUP)YGRIDL(I)
 115  CONTINUE
      MXINDX=NDMAXGRID*NDMAZGRID*(NGRIDY-1)+
     &       NDMAXGRID*(NGRIDZ-1)+NGRIDX
      CALL CHKBND(10,MXINDX,'BACKUP','WGTGRD')
      DO 125 I=1,NGRIDX
         DO 120 J=1,NGRIDZ
            DO 117 K=1,NGRIDY
               INDX=NDMAXGRID*NDMAZGRID*(K-1)+NDMAXGRID*(J-1)+I
               WRITE (NBCKUP)WGTGRD(INDX)
 117        CONTINUE
 120     CONTINUE
 125  CONTINUE
      DO 140 IS=1,NSHELL
         DO 135 I=1,NGRIDX
            DO 133 J=1,NGRIDZ
               DO 130 K=1,NGRIDY
                  WRITE (NBCKUP)VALION(IS,I,J,K)
 130           CONTINUE
 133        CONTINUE
 135     CONTINUE
 140  CONTINUE
      NIND=NXCHAR+NXCONT-NXPTOB
      WRITE (NBCKUP)NIND
      DO 160 IJ=0,NXDET
         DO 155 K=1,NIND
            DO 150 I=1,NGRIDX
               DO 148 J=1,NGRIDZ
                  DO 145 L=1,NGRIDY
                     WRITE (NBCKUP)XCABS(IJ,K,I,J,L)
 145              CONTINUE
 148           CONTINUE
 150        CONTINUE
 155     CONTINUE
 160  CONTINUE
      MXINDX=NXCONT*(NXDET+1)
      IF (MXINDX.GT.0) CALL CHKBND (15,MXINDX,'BACKUP','XDETOFXCONT')
      DO 180 IX=1,NXCONT
         DO 175 IJ=0,NXDET
            INDX=NDMAXDET*(IX-1)+(IJ+1)
CS            WRITE (NBCKUP)XDETOFXCONT(IJ,K)
            WRITE (NBCKUP)XDETOFXCONT(INDX)
            DO 170 I=1,NGRIDX
               DO 168 J=1,NGRIDZ
                  DO 165 K=1,NGRIDY
                     WRITE (NBCKUP)VALBREMS(IX,I,J,K,IJ)
 165              CONTINUE
 168           CONTINUE
 170        CONTINUE
 175     CONTINUE
 180  CONTINUE
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'#END_LDH_INFO'
      WRITE (NBCKUP)BUFFER

*     ---WRITE HISTOGRAM INFORMATION TO BACKUP FILE
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'#START_HIS_INFO'
      WRITE (NBCKUP)BUFFER
      WRITE (NBCKUP)NHIST,NVTOT
      CALL CHKBND(8,NVTOT,'BACKUP','VALHIS')
      DO 220 I=1,NVTOT
         WRITE (NBCKUP)VALHIS(I)
 220  CONTINUE
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'#END_HIS_INFO'
      WRITE (NBCKUP)BUFFER

*     ---WRITE MISCELLANEOUS INFORMATION TO BACKUP FILE
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'#START_MISC_INFO'
      WRITE (NBCKUP)BUFFER
      WRITE (NBCKUP)NIN,NBACK,NTRAN
      WRITE (NBCKUP)NOUTS,NOUTR,NOUTL,NOUTLR
      WRITE (NBCKUP)DENSUM,DEESUM
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'#END_MISC_INFO'
      WRITE (NBCKUP)BUFFER

*     ---WRITE GENERATED AND DETECTED X-RAY INTENSITIES TO BACKUP FILE
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'#START_XRAY_INFO'
      WRITE (NBCKUP)BUFFER
      WRITE (NBCKUP)NXCHAR,NXDET
      DO 250 I=1,NXCHAR
         WRITE (NBCKUP)XGENOFXCHAR(I)
         DO 245 J=0,NXDET
            IXINDX=(I-1)*NDMAXDET+J+1
            CALL CHKBND (20,IXINDX,'BACKUP    ','XDETOFXCHAR')          
CS            WRITE (NBCKUP)XDETOFXCHAR(J,I)
            WRITE (NBCKUP)XDETOFXCHAR(IXINDX)
 245     CONTINUE
 250  CONTINUE
      BUFFER=CBL//CBL//CBL//CBL
      WRITE (BUFFER,*)'#END_XRAY_INFO'
      WRITE (NBCKUP)BUFFER

*     ---WRITE EXECUTION TIME TO BACKUP FILE


*     ---REPORT WRITING OF THE BACKUP FILE TO THE OUTPUT FILE
      CALL WROUT (4,IELTR)

*     ---CLOSE BACKUP FILE
      CLOSE (NBCKUP)

      RETURN
      END
