c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
*last modification: 04-Feb-1997

      SUBROUTINE BSFINIT (IR,Z,BREMSSPEC,BREMSANGLE,IERR)

*     BSFINIT - A MODIFIED VERSION OF THE BSF PROGRAM FROM KISSEL ET AL.
*               FOR THE CALCULATION OF THE BREMSSTRAHLUNG SHAPE FUNCTIONS
*               NEEDED FOR THE CALCULATION OF THE BREMSSTRAHLUNG CROSS
*               SECTIONS
*
*     CHRISTIAN SCHIEBL
*     CONSULTANT (FORMER CEC-VIENNA)
*     KREMS/HUDSON, FEBRUARY 1997

      INCLUDE 'TYPE.INC'
      INCLUDE 'DMA.INC'
      INCLUDE 'BREMS.INC'

      INTEGER IR,Z,IERR
      DOUBLE PRECISION BREMSSPEC(NDMAREG,NDMAEENER,MAXPHENER)
      DOUBLE PRECISION BREMSANGLE(NDMAREG,NDMAEENER,MAXPHENER,
     &                            MAXANGLES)

C  BSF.FOR, VERSION JAN 29, 1986 (DATE ALSO IN FORMAT 1).
C
C  BREMSSTRAHLUNG SHAPE FUNCTIONS.
C
C  MODIFICATION LOG:
C    JAN 29, 1986 - (L. KISSEL, SNL) MODIFY CODE FOR STANDARD ANSI
C  FORTRAN 77.  REMOVE HOLLERITH STATEMENTS AND REPLACE WITH
C  CHARACTER STRINGS.  USE EXPLICIT STATEMENT TO OPEN
C  INPUT FILES AND CREATE OUTPUT FILE.  SPLIT BENCHMARK DATA FROM
C  ENERGY-SPECTRUM DATA; PUT IN SEPARATE FILES.  PROTECT AGAINST USER
C  VALUES OF T1 AND Z OUTSIDE RANGE OF CODE.  CORRECT T1=1 BUG IN
C  LOOP 81.  ADD HEADER RECORDS TO FILES CONTAINING BENCHMARK DATA
C  AND ENERGY-SPECTRUM DATA.
C    FEB 22, 1984 - (C.A.QUARLES, TCU) ORIGINAL VERSION.
C
C    PROGRAM TO COMPUTE SHAPE FUNCTIONS AND PRINT OUT IN PUBLICATION
C  FORM.  BENCHMARK DATA AND PHOTON ENERGY SPECTRA ARE READ
C  FROM DISK FILES ON UNIT #10.  A LINEAR INTERPOLATION IS DONE TO OBTAIN
C  PHOTON ENERGY SPECTRA FOR ENERGY EN.  B VALUES ARE COMPUTED FOR EN
C  AND ATOMIC #Z IN A CUBIC SPLINE INTERPOLATION OVER THE BENCHMARK DATA
C  OUTPUT IS IN THE FORM OF AT.&NUCL. DATA TABLES, ON FILE BSF.OUT
C  ON UNIT #11.
C
C  SOME DEFINITIONS:
C     BD(ENERGY,B-VALUE,Z,K/T) IS THE ARRAY OF BENCHMARK DATA FOR 6
C             ENERGIES, 5 B-VALUES, 6 Z'S, AND 4 K/T'S
C     KAR IS THE ARRAY OF 4 VALUES OF K/T BENCHMARK VALUES
C     XKAR IS THE ARRAY OF 12 VALUES OF K/T EVALUATED
C     JAR IS THE ARRAY OF 6 BENCHMARK VALUES OF Z
C     B1(B-VALUE,Z,K/T) IS THE ARRAY OF B-VALUES RESULTING FROM THE
C             CUBIC SPLINE INTERPOLATION
C     SARK(K/T,ANGLE) IS THE ARRAY OF SHAPE FUNCTIONS
C     SIG IS THE ARRAY OF PHOTON ENERGY SPECTRA
C     ENTEST IS THE ARRAY OF 12 ENERGY VALUES OF PHOTON ENERGY SPECTRA
C     COST AND SINT ARE ARRAYS OF SINES AND COSINES USED
C     B, SAR, IANG ARE FOR TEMPORARY USE
C
C     SUBROUTINE SPRATT COMPUTES THE SHAPE FUNCTIONS
C     SUBROUTINE SPCOFF AND FUNCTION SPLINE ARE USED TO DO THE
C             CUBIC SPLINE INTERPOLATIONS
C     XN, FN, S, INDEX ARE USED IN SPCOFF AND SPLINE
C
CS      PROGRAM BSF
C.....
C
C  DECLARATIONS.
C
      CHARACTER HEADER*1,FILENA*80,CBL*10
      DIMENSION B1(5,91,11),FN(6),XN(6),S(6),INDEX(6),AA(11)
      DIMENSION KAR(4),JAR(6),XKAR(12)
      DIMENSION SAR(37), SIG(2,12),ENTEST(12),SARK(12,37),IANG(37)
      DIMENSION B(6),BD(6,5,6,4),BETA(6)
      DIMENSION COST(1800),SINT(1800)
      DATA KAR/1,7,9,11/,JAR/1,7,12,46,78,91/,NKAR/4/,NJAR/6/
      DATA XKAR/0.,.1,.2,.3,.4,.5,.6,.7,.8,.9,.95,1.0/
C    DATA FOR 1 KEV
      DATA BETA(1)/0.06246/
C   DATA FOR 5 KEV
      DATA BETA(2)/.13887/
C  DATA FOR 10 KEV
      DATA BETA(3)/0.19498/
C  DATA FOR 50 KEV
      DATA BETA(4)/.41268/
C   DATA FOR 100 KEV
      DATA BETA(5)/.54822/
C   DATA FOR 500 KEV
      DATA BETA(6)/.86286/
C   ENERGY GRID OF ENERGY-SPECTRUM DATA
      DATA ENTEST/1.0,2.5,5.,10.,25.,50.,75.,100.,200.,300.,400.,500./

      INCLUDE 'PATH.INC'

C
C  TELL THE USER WHO WE ARE.
C
CS      PRINT 1
CS    1 FORMAT
CS     *  (  ' BSF: BREMSSTRAHLUNG SHAPE FUNCTIONS.'
CS     *  ,/,' BSF: VERSION JAN 29, 1986.'
CS     *  ,/,' BSF: THIS PROGRAM COMPUTES TABULATIONS AS PUBLISHED IN:'
CS     *  ,/,'   "SHAPE FUNCTIONS FOR ATOMIC-FIELD BREMSSTRAHLUNG FROM'
CS     *  ,/,'    ELECTRONS OF KINETIC ENERGY 1-500 keV ON SELECTED'
CS     *  ,/,'    NEUTRAL ATOMS 1<=Z<=92", Lynn Kissel, C. A. Quarles,'
CS     *  ,/,'    R. H. Pratt, Atomic Data and Nuclear Data Tables, 28,'
CS     *  ,/,'    381-460 (1983).'
CS     *  )
C.....
C
C  INITIALIZATIONS.
C
      IERR = 0
      CBL = '          '

C  OPEN AND READ FILE CONTAINING BENCHMARK DATA.
C
      FILENA=CBL//CBL//CBL//CBL//CBL//CBL//CBL//CBL
      FILENA=CFUND(1:IEND(CFUND))//'BMDATA.DAT'
      OPEN(UNIT=10,FILE=FILENA(1:IEND(FILENA)),STATUS='OLD')
      READ(10,'(A)') HEADER
      DO 10 I=1,6
        DO 10 K=1,6
          DO 10 L=1,4
            READ(10,*)(BD(I,J,K,L),J=1,5)
   10 CONTINUE
      CLOSE(UNIT=10)
C
C  OPEN FILE CONTAINING ENERGY SPECTRUM DATA.
C
      FILENA=CBL//CBL//CBL//CBL//CBL//CBL//CBL//CBL
      FILENA=CFUND(1:IEND(CFUND))//'ESPEC.DAT'
      OPEN(UNIT=10,FILE=FILENA(1:IEND(FILENA)),STATUS='OLD')
C
C  CREATE FILE TO RECEIVE OUTPUT TABLES.
C
CS      OPEN(UNIT=11,FILE='BSF.OUT',STATUS='NEW')
C
C COMPUTE SINES AND COSINES NEEDED
C
      DO 450 I=1,1800
        TH=FLOAT(I)*.0017453293
        COST(I)=COS(TH)
  450   SINT(I)=SIN(TH)
C.....
C
C LOOP OVER USER VALUES OF Z, T1.
C
CS 1000 CONTINUE
CS      PRINT '(A)',' BSF: ##################'
CS 1010 PRINT '(A)',' BSF: ENTER Z (0=>STOP)?'
CS      READ *,Z
      IF (Z.EQ.0) THEN
        IERR = 1
        GOTO 999
      ELSEIF ((Z.LT.2).OR.(92.LT.Z)) THEN
        WRITE(6,'(A)')'           '
        WRITE(6,'(A)')' *** BSFINIT: VALUE OF Z OUTSIDE RANGE 2-92.'
        IERR = 2
        GOTO 999
      ENDIF
CS 1020 PRINT '(A)',' BSF: ENTER T1 (IN KEV)?'
CS      READ *, EN
CS      IF ((EN.LT.1.).OR.(500.LT.EN)) THEN
CS        PRINT '(A)',' *** BSF: VALUE OF T1 OUTSIDE RANGE 1-500 KEV.'
CS        GOTO 1020
CS      ENDIF

*     LOOP OVER ALL ELECTRON ENERGY VALUES:
      DO 990 IEEN=1,NDMAEENER
        EN = VELENER(IEEN)

C DO ENERGY INTERPOLATION
C
        N=6
C
        BETIN=SQRT((EN+511.)**2-511.**2)/(EN+511.)
        DO 11 I=1,5
          DO 11 J=1,NJAR
          JJ=JAR(J)
            DO 11 K=1,NKAR
              KK=KAR(K)
              DO 12 L=1,6
                XN(L)=BETA(L)
   12           FN(L)=BD(L,I,J,K)
              CALL SPCOFF(N,XN,FN,S,INDEX)
   11         B1(I,JJ,KK)=SPLINE(N,XN,FN,S,INDEX,BETIN)
C
C  COMPUTE NEAREST-NEIGHBOR ENTIES IN ENERGY SPECTRUM TABLE.
C
      DO 81 I=2,12
        LASTI=I
        IF(EN .LE. ENTEST(I)) GO TO 83
   81 CONTINUE
   83 ENH=ENTEST(LASTI)
      ENL=ENTEST(LASTI-1)
C
C  READ NEAREST-NEIGHBOR PHOTON ENERGY SPECTRA
C
      READ(10,'(A)') HEADER
      DO 86 K=1,1104
 2070 READ(10,* ,END=2080)IZ,EG,(SIG(1,J),J=1,12)
      GOTO 2090
 2080 CONTINUE
CS        PRINT '(A)',' BSF: REWINDING ENERGY SPECTRA DATA.'
        REWIND(UNIT=10)
        READ(10,'(A)') HEADER
        GOTO 2070
 2090 CONTINUE
      IF(IZ .NE. Z) GO TO 86
      IF(EG .EQ. ENL) GO TO 87
   86 CONTINUE
   87 READ(10, * )IZ,EG,(SIG(2,J),J=1,12)
C
C  INTERPOLATE ON PHOTON ENERGY SPECTRA
C
      DO 88 I=1,12
   88 SIG(1,I)=SIG(1,I)+(SIG(2,I)-SIG(1,I))*(EN-ENL)/(ENH-ENL)
C  SIG(1,I) NOW HAS THE INTERPOLATED VALUES OF ENERGY SPECTRA
C
C
C  BEGIN TO COMPUTE B VALUE INTERPOLATION IN Z AND K/T
C
      DO 30 I=1,5
      N=NKAR
      DO 40    L=1,NJAR
   35 J=JAR(L)
      DO 42 M=1,N
      K=KAR(M)
      FN(M)=B1(I,J,K)
   42 XN(M)=XKAR(K)
      CALL SPCOFF(N,XN,FN,S,INDEX)
      DO 50 M=1,11
      XI=XKAR(M)
   50 B1(I,J,M)=SPLINE(N,XN,FN,S,INDEX,XI)
   40 CONTINUE
      N=NJAR
      DO 60 K=1,11
      DO 62 M=1,N
      J=JAR(M)
      FN(M)=B1(I,J,K)
   62 XN(M)=J+1
      CALL SPCOFF(N,XN,FN,S,INDEX)
      DO 70 J=1,91
      XI=J+1
   70 B1(I,J,K)=SPLINE(N,XN,FN,S,INDEX,XI)
   60 CONTINUE
   30 CONTINUE
C   ALL B VALUE ARRAYS COMPLETE
C
C
C  BEGIN CALCULATION OF S FUNCTIONS
C
      J=Z-1
      DO 520 K=1,11
      B(1)=1.
      B(2)=B1(1,J,K)
      B(3)=B1(2,J,K)
      B(4)=B1(3,J,K)
      B(5)=B1(4,J,K)
      B(6)=B1(5,J,K)
      CALL SPRATT(BETIN,B,SAR,COST,SINT,A)
      AA(K)=A
      DO 522 L=1,37
  522 SARK(K,L)=SAR(L)
  520 CONTINUE
C  LINEAR INTERPOLATION FOR K/T=1
      DO 530 L=1,37
  530 SARK(12,L)=2.*SARK(11,L)-SARK(10,L)
C
      DO 540 I=1,37
  540 IANG(I)=(I-1)*5
C
C  BEGIN OUTPUT IN PUBLICATION FORMAT
C
CS      WRITE(11,102)Z,EN
CS  102 FORMAT('1',//,18X,'BREMSSTRAHLUNG ENERGY SPECTRUM AND'
CS     *,' SHAPE FUNCTIONS FOR Z=',I3,', T1=',F6.1,' KEV'
CS     *,/,1X,120('-')
CS     *,/,6X,'K/T1=',4X,'0.0',6X,'0.1',6X,'0.2',6X,'0.3',6X,'0.4'
CS     *,6X,'0.5',6X,'0.6',6X,'0.7',6X,'0.8',6X,'0.9',6X,'0.95',5X,'1.0'
CS     *,/,1X,120('-'))
CS  103 FORMAT(2X,'SPECTRUM=',F8.3,11F9.3)
CS      WRITE(11,103)(SIG(1,I),I=1,12)
CS      WRITE(11,104)
CS  104 FORMAT(5X,'ANGLE')
CS      DO 105 I=1,37
CS      IF(I .EQ. 7) GOTO 109
CS      IF(I .EQ. 13) GO TO 109
CS      IF(I .EQ. 19) GO TO 109
CS      IF(I .EQ. 25) GO TO 109
CS      IF(I .EQ. 31) GO TO 109
CS      GO TO 105
CS  109 WRITE(11,108)
CS  108 FORMAT(' ')
CS  105 WRITE(11,106)IANG(I),(SARK(J,I),J=1,12)
CS  106 FORMAT(5X,I3,2X,12F9.4)

        DO 900 IEP=1,MAXPHENER
          BREMSSPEC(IR,IEEN,IEP)=SIG(1,IEP)
          DO 890 IAN=1,MAXANGLES
            BREMSANGLE(IR,IEEN,IEP,IAN)=SARK(IEP,IAN)
 890      CONTINUE
 900    CONTINUE

 990  CONTINUE

cs      write(6,'(a)')'    '
cs      write(6,'(12f6.3)')(bremsspec(1,18,i),i=1,12)
cs      write(6,'(12f6.3)')(bremsangle(1,18,i,13),i=1,12)
cs      read(*,*)

 999  RETURN
      END

*****************************************************************************

      SUBROUTINE SPCOFF(N,XN,FN,S,INDEX)
C
C  THE SUBROUTINE SPCOFF AND THE FUNCTION SPLINE CALCULATE THE
C  NATURAL CUBIC INTERPOLATORY SPLINE FIT TO THE DATA SPECIFIED
C  BY THE ARRAY OF N NODES XN, WITH CORRESPONDING FUNCTION
C  VALUES IN THE ARRAY FN. THE NODES XN MUST BE DISTINCT. THE
C  SPLINE IS DETERMINED IN SPCOFF AND EVALUATED IN SPLINE. SPCOFF
C  ARRANGES THE NODES IN INCREASING ORDER AND STORES THIS ORDER IN
C  THE ARRAY INDEX. THE ARRAY XN ITSELF IS NOT ALERTED. SPCOFF
C  THEN CALCULATES THE ARRAY S OF SECOND DERIVATIVES NEEDED TO
C  DEFINE THE SPLINE. THE ARRAY@S XN,FN,S,AND INDEX MUST BE
C  DIMENSIONED IN THE CALLING PROGRAM.
C
      INCLUDE 'TYPE.INC'

      DIMENSION XN(N),FN(N),S(N),INDEX(N)
C
C  SPCOFF IS WRITTEN TO HANDLE PROBLEMS WITH UP TO TWENTY FIVE
C  NODES. IF MORE NODES ARE USED, ONLY THE NEXT STATMENT
C  NEED BE CHANGED. THE DIMENSION OF THE ARRAYS RHO AND TAU
C  MUST BE AT LEAST N.
C
      DIMENSION RHO(25),TAU(25)
      NM1=N-1
C
C  ARRANGE THE NODES XN IN INCREASING ORDER. STOP THE
C  ORDER IN THE ARRAY INDEX.
      DO 1 I=1,N
  1   INDEX(I)=I
      DO 3 I=1,NM1
      IP1=I+1
      DO2 J=IP1,N
      II=INDEX(I)
      IJ=INDEX(J)
      IF(XN(II).LE.XN(IJ))GOTO 2
      ITEMP=INDEX(I)
      INDEX(I)=INDEX(J)
      INDEX(J)=ITEMP
  2   CONTINUE
  3   CONTINUE
      NM2=N-2
C
C  CALCULATE THE ELEMENTS OF THE ARRAYS RHO AND TAU
C
      RHO(2)=0.0
      TAU(2)=0.0
      DO 4 I=2,NM1
      IIM1=INDEX(I-1)
      II=INDEX(I)
      IIP1=INDEX(I+1)
      HIM1=XN(II)-XN(IIM1)
      HI=XN(IIP1)-XN(II)
      TEMP=(HIM1/HI)*(RHO(I)+2.0)+2.0
      RHO(I+1)=-1.0/TEMP
      D=6.0*((FN(IIP1)-FN(II))/HI-(FN(II)-FN(IIM1))/HIM1)/HI
    4 TAU(I+1)=(D-HIM1*TAU(I)/HI)/TEMP
C
C  COMPUTE ARRAY OF SECOND DERIVATIVES S FOR THE NATURAL SPLINE
C
      S(1)=0.0
      S(N)=0.0
      DO 5 I=1,NM2
      IB=N-I
  5   S(IB)=RHO(IB+1)*S(IB+1)+TAU(IB+1)
      RETURN
      END


      DOUBLE PRECISION FUNCTION SPLINE(N,XN,FN,S,INDEX,X)
C
C  THE FUNCTION SPLINE ACCEPTS AS INPUT THE QUANTITIES N, XN, FN,
C  S, AND INDEX AS DEFINED IN THE SUBROUTINE SPCOFF AND A NUMBER
C  X AT WHICH THE SPLINE IS TO BE EVALUATED. SPCOFF IS CALLED
C  ONCE EACH FIT. BUT SPLINE IS CALLED ONCE FOR EACH ARGUMENT
C  AT WHICH WE REQUIRE THE VALUE OF THE FIT.
C
      INCLUDE 'TYPE.INC'

      DIMENSION XN(N), FN(N),S(N),INDEX(N)
C
C  IF X.LT. XN(INDEX(1)), APPROXIMATE FUNCTION BY THE STRAIGHT
C  LINE WHICH PASSES THROUGH THE POINT (XN(INDEX(1)),FN(INDEX(1))
C  AND WHOSE SLOPE AGREES WITH THE SLOPE OF THE SPLINE AT THAT POINT.
C
      I1=INDEX(1)
      IF(X.GE.XN(I1))GO TO 1
      I2=INDEX(2)
      H1=XN(I2)-XN(I1)
      SPLINE =FN(I1)+(X-XN(I1))*((FN(I2)-FN(I1))/H1-H1*S(2)/6.0)
      RETURN
C
C  IF X.GE. XN(INDEX(N)). APPROXIMATE FUNCTIUON BY THE SRAIGHT LINE
C  WHICH PASSES THROUGH THE POINT (XN(INDEX(N)).FN(INDEX(N)) AND
C  WHOSE SLOPE AGREES WITH THE SLOPE OF THE SPLINE AT THAT POINT.
C
  1   IN=INDEX(N)
      IF(X.LE.XN(IN))GO TO 2
      INM1=INDEX(N-1)
      HNM1=XN(IN)-XN(INM1)
      SPLINE=FN(IN)+(X-XN(IN))*((FN(IN)-FN(INM1))/HNM1+HNM1*S(N-1)/6.0)
      RETURN
C
C  FOR XN(INDEX(1)).LE.X.LE.XN(INDEX(N)) CALCULATE SPLINE
C
  2   DO 3 I=2,N
      II=INDEX(I)
      IF(X.LE.XN(II))GO TO 4
  3   CONTINUE
  4   L=I-1
      IL=INDEX(L)
      ILP1=INDEX(L+1)
      A=XN(ILP1)-X
      B=X-XN(IL)
      HL=XN(ILP1)-XN(IL)
      SPLINE=A*S(L)*(A**2/HL-HL)/6.0+B*S(L+1)*(B**2/HL-HL)/6.0
     1 +(A*FN(IL)+B*FN(ILP1))/HL
      RETURN
      END
C
      SUBROUTINE SPRATT(BETA,B,S,COST,SINT,A)
      INCLUDE 'TYPE.INC'
      DIMENSION P(6),B(6), COST(1800),SINT(1800),S(37)
      P(1)=1.
      SS=0.
      PI=3.141592654
      DTH=0.1*PI/180.
      DO30 I=1,1800
      X=COST(I)
      Y=SINT(I)
      P(2)=X
      P(3)=1.5*X*X-.5
      P(4)=2.5*X**3-1.5*X
      P(5)=4.375*X**4-3.75*X*X+.375
      P(6)=7.85*X**5-8.75*X**3+1.875*X
      SUM=0.
      DO 40 K=1,6
      SUM=SUM +(B(K)*P(K))/(1.-BETA*X)**4.5
  40  CONTINUE
      SS=SS+SUM*Y/4./PI
  30  CONTINUE
      A=1./SS/2./PI/DTH
C
      DO 10 J=1,37
      I=(J-1)*5
      THETA=FLOAT(I)
      X=COS(THETA*PI/180.)
      P(2)=X
      P(3)=0.5*(3.*X*X-1.)
      P(4)=0.5*X*(5.*X*X -3.)
      P(5)=.125*((35.*X*X-30.)*X*X+3.)
      P(6)=.125*X*((63.*X*X-70.)*X*X+15.)
      SUM=0.
      DO 20 K=1,6
      SUM=SUM+(B(K)*P(K))/(1.-BETA*X)**4.5
  20  CONTINUE
      S(J) =(1./(4.*PI))*SUM*A
   10 CONTINUE
      RETURN
      END

*****************************************************************************
*last modification: 06-Feb-1997

      DOUBLE PRECISION FUNCTION GETQBRS (IR,ZQUER,EEN,PEN,
     &                                   COSPHI,BETA,
     &                                   BREMSSPEC,BREMSANGLE)

***   GETQBRS - DELIVERS BREMSSTRAHLUNG CROSS SECTION (KISSEL ET AL.)
*               IN ANGSTROM**2 PER eV PHOTON ENERGY
*
*     INPUT:
*             IR         - REGION NUMBER
*             ZQUER      - MEAN ATOMIC NUMBER IN REGION IR
*             EEN        - ELECTRON ENERGY [EV]
*             PEN        - PHOTON ENERGY [EV]
*             COSPHI     - COSINE OF ANGLE BETWEEN ELECTRON AND DETECTOR
*             BETA       - BETA (ELECTRON VELOCITY DEVIDED BY LIGHT VELOCITY
*             BREMSSPEC  - SPECTRUM TABLE
*             BREMSANGLE - ANGLE TABLE
*
**    AUTHOR: CHRISTIAN SCHIEBL
*             CONSULTANT (FORMER: CEC-VIENNA)
*             KREMS/HUDSON, FEBRUARY 1997

      INCLUDE 'TYPE.INC'
      INCLUDE 'DMA.INC'
      INCLUDE 'BREMS.INC'

      DOUBLE PRECISION BREMSSPEC(NDMAREG,NDMAEENER,MAXPHENER)
      DOUBLE PRECISION BREMSANGLE(NDMAREG,NDMAEENER,MAXPHENER,
     &                            MAXANGLES)

      INTEGER EEINDX(50)

      DATA EEINDX / 19,49,49,49,59,59,69,69,69,73,73,74,75,76,77,
     &              78,79,80,81,82,83,83,84,84,85,85,86,86,87,87,
     &              88,88,89,89,90,90,91,91,92,92,93,93,94,94,95,
     &              95,96,96,97,97 /
     &              

      DOUBLE PRECISION PI
      PARAMETER (PI=3.141592654)

*     ---TRANSFORM INTO KEV
      EE = EEN/1000
      EP = PEN/1000

*     ---DETERMINE EE INTERVALL (INDIXES I AND J)
      J = INT(EE/10+1)
      J=EEINDX(J)
      IF (J.LE.19) THEN
         J=19-INT((VELENER(J)-EE)/0.5)
         IF (J.EQ.1) J=2
      ELSE IF (J.LE.49) THEN
         J=49-INT(VELENER(J)-EE)
      ELSE IF (J.LE.59) THEN
         J=59-INT((VELENER(J)-EE)/2)
      ELSE IF (J.LE.69) THEN
         J=69-INT((VELENER(J)-EE)/3)
      ELSE IF (J.LE.73) THEN
         J=73-INT((VELENER(J)-EE)/5)
      ENDIF
      I=J-1
CS-TEST
CS      IF ((EE.LT.VELENER(I)).OR.(EE.GT.VELENER(J))) THEN
CS         WRITE(6,'(3F12.4)')VELENER(I),EE,VELENER(J)
CS      ENDIF

      IF ((J.LT.1).OR.(J.GT.NDMAEENER)) THEN

         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' GETQBRS: warning!'
         WRITE(6,'(A)')' Predetermined index is wrong!'
         WRITE(6,'(A)')' Will start with first index [2]!'
         J=2

 10      IF ((VELENER(J).LE.EE).AND.(J.LT.(NDMAEENER-1))) THEN
            J=J+1
            GOTO 10
         ENDIF
 15      IF ((VELENER(J).GT.EE).AND.(J.GT.1)) THEN
            J=J-1
            GOTO 15
         ENDIF
         J=J+1

         I=J
         IF (VELENER(I).GE.EE) THEN
            I=I-1
 20         IF ((VELENER(I).GT.EE).AND.(I.GT.1)) THEN
               I=I-1
               GOTO 20
            ENDIF
         ELSE
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' GETQBRS: severe error!'
            WRITE(6,'(A)')' Program never should enter this branch!'
            STOP
         ENDIF

         IF ((J-I).NE.1) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' GETQBRS: severe error!'
            WRITE(6,'(A)')' Difference in indices I and J > 1 !'
            WRITE(6,'(A,F8.3,A)')' ELECTRON ENERGY: ',EE,' keV'
            WRITE(6,'(A,F8.3,A)')' PHOTON ENERGY:   ',EP,' keV'
            WRITE(6,'(A,F8.3)')' E(P)/E(E):       ',EP/EE
            WRITE(6,'(A,I2,A,F8.3,A)')' E(',I,'): ',VELENER(I),' keV'
            WRITE(6,'(A,I2,A,F8.3,A)')' E(',J,'): ',VELENER(J),' keV'
            IF (J.GT.1) THEN
               I=J-1
            ELSE
               J=2
               I=1
            ENDIF
 25         IF ((EE.GE.VELENER(I)).AND.(EE.LE.VELENER(J))) THEN
*              EVERYTHING IS FINE
            ELSE
               IF (EE.LT.VELENER(I)) THEN
                 IF (I.GT.1) THEN
                   I=I-1
                   J=J-1
                 ELSE
                   STOP
                 ENDIF
               ELSE
                 IF (J.LT.NDMAEENER) THEN
                   J=J+1
                   I=I+1
                 ELSE
                   STOP
                 ENDIF
                 GOTO 25
               ENDIF
            ENDIF
         ENDIF
      ENDIF

*     ---DETERMINE ANGLE BETWEEN ELECTRON DIRECTION AND DETECTOR
      ANGLE=DACOS(COSPHI)
      IF (ANGLE.GT.PI) ANGLE = 2*PI-ANGLE
      IANG=INT(DACOS(COSPHI)*36/PI+0.5)+1

      EEI=VELENER(I)
      EEJ=VELENER(J)
      DELTEE=EEJ-EEI

*     ---DETERMINE FOR SMALLER EE (=I) THE EP INTERVALL (K,L)
      EPEE=EP/EE

      K=INT(EPEE*10)+1
      IF (K.EQ.10) THEN
         IF (EPEE.GT.0.95) K=11
      ENDIF
      L=K+1

      EPK=VEPHEEL(K)*VELENER(I)
      EPL=VEPHEEL(L)*VELENER(I)
      DELTEP=EPL-EPK

*     ---DETERMINE SPECTRUM AND ANGLE FOR HIGHER EE (J) AND EPK AND EPL
      T1=EPK/VELENER(J)
      T2=EPL/VELENER(J)

      I1=INT(T1*10)+1
      IF (I1.EQ.10) THEN
         IF (T1.GT.0.95) I1=11
      ENDIF
      J1=I1+1

      VALKJ=BREMSSPEC(IR,J,I1)+(BREMSSPEC(IR,J,I1)-BREMSSPEC(IR,J,J1))
     &      *(T1-VEPHEEL(I1))/(VEPHEEL(I1)-VEPHEEL(J1))
      VANGKJ=BREMSANGLE(IR,J,I1,IANG)+
     &       (BREMSANGLE(IR,J,I1,IANG)-BREMSANGLE(IR,J,J1,IANG))
     &       *(T1-VEPHEEL(I1))/(VEPHEEL(I1)-VEPHEEL(J1))

      I2=INT(T2*10)+1
      IF (I2.EQ.10) THEN
         IF (T2.GT.0.95) I2=11
      ENDIF
      J2=I2+1

      VALLJ=BREMSSPEC(IR,J,I2)+(BREMSSPEC(IR,J,I2)-BREMSSPEC(IR,J,J2))
     &      *(T2-VEPHEEL(I2))/(VEPHEEL(I2)-VEPHEEL(J2))
      VANGLJ=BREMSANGLE(IR,J,I2,IANG)+
     &       (BREMSANGLE(IR,J,I2,IANG)-BREMSANGLE(IR,J,J2,IANG))
     &       *(T2-VEPHEEL(I2))/(VEPHEEL(I2)-VEPHEEL(J2))

      VALKI=BREMSSPEC(IR,I,K)
      VALLI=BREMSSPEC(IR,I,L)
      VANGKI=BREMSANGLE(IR,I,K,IANG)
      VANGLI=BREMSANGLE(IR,I,L,IANG)

      DEEJ=EEJ-EE
      DEEI=EE-EEI
      DEPL=EPL-EP
      DEPK=EP-EPK
      VALSPEC=VALKI*DEEJ*DEPL+
     &        VALLI*DEEJ*DEPK+
     &        VALKJ*DEEI*DEPL+
     &        VALLJ*DEEI*DEPK
      VALSPEC=VALSPEC/DELTEE/DELTEP
      VALANGLE=VANGKI*DEEJ*DEPL+
     &         VANGLI*DEEJ*DEPK+
     &         VANGKJ*DEEI*DEPL+
     &         VANGLJ*DEEI*DEPK
      VALANGLE=VALANGLE/DELTEE/DELTEP

      GETQBRS=1.0D-14*ZQUER*ZQUER*VALSPEC*VALANGLE/EP/BETA/BETA

cs-TEST
cs      write(6,'(a)')'      '
cs      write(6,'(a,F8.3,A)')' EE = ',EE,' KEV'
cs      write(6,'(a,F8.3,A)')' EEI = ',EEI,' KEV'
cs      write(6,'(a,F8.3,A)')' EEJ = ',EEJ,' KEV'
cs      write(6,'(a,F8.3,A)')' EP = ',EP,' KEV'
cs      write(6,'(a,F8.5)')' EP/EE = ',EP/EE
cs      write(6,'(4F12.3)')VEPHEEL(I2),VEPHEEL(J2),T1,T2
cs      write(6,'(4F12.3)')BREMSSPEC(IR,J,I2),BREMSSPEC(IR,J,J2),
cs     &                   VALKJ,VALLJ
cs      write(6,'(A,2F12.3)')'                        ',
cs     &                      BREMSSPEC(IR,I,K),BREMSSPEC(IR,I,L)
cs      write(6,'(A,F12.3)')'                                    ',
cs     &                      VALSPEC
cs      write(6,'(a,f8.3,a,F9.4)')' Angle = ',angle*180/pi,
cs     &                          '   ANGLE = ',VALANGLE


      RETURN
      END

******************************************************************************



