c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
* last modification: CS  29-APR-1997

      SUBROUTINE CHKINI (XMIN,XMAX,ZMIN,ZMAX)

*     CHKINI - CHECK ALL INPUT PARAMETERS FOR CONSISTENCY
*
*     REMARKS
*
*     1) NO REMARKS PRESENTLY
*
*     AUTHOR:  C.SCHIEBL   NOVEMBER 1994

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'GLOBAL.INC'
      INCLUDE 'HIST.INC'
      INCLUDE 'OUTPUT.INC'
      INCLUDE 'DMA.INC'

      CHARACTER*1 CYN
      CHARACTER*10  CBL

      INCLUDE 'PATH.INC'

**    START OF EXECUTABLE CODE
*     ************************

      CBL='          '
      NWARN=0

*     ---CHECK ALL &INIT PARAMETERS
      IWARN=0
      WRITE(6,'(A)')'     '
      WRITE(6,'(A)')' CURRENTLY CHECKING ALL &INIT PARAMETERS !'
 10   CONTINUE
      CALL CCAP(UNITS,IEND(UNITS))
      IF (UNITS(1:2).EQ.'MI') THEN
         CUNITS='microns   '
         DUNITS=10000
      ELSE IF (UNITS(1:2).EQ.'AN') THEN
         CUNITS='Angstrom  '
         DUNITS=1
      ELSE IF (UNITS(1:2).EQ.'NM') THEN
         CUNITS='nm        '
         DUNITS=10
      ELSE IF (UNITS(1:2).EQ.'MM') THEN
         CUNITS='mm        '
         DUNITS=1E7
      ELSE IF (UNITS(1:2).EQ.'CM') THEN
         CUNITS='cm        '
         DUNITS=1E8
      ELSE
         WRITE(6,'(A)')'       '
         WRITE(6,'(A)')' %%% WARNING %%% '
         WRITE(6,'(2A)')' Invalid Specification of UNITS in the',
     &                  ' &INIT namelist !'
         WRITE(6,'(A)')' Default value is SEM microns !'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IWARN=IWARN+1
      ENDIF
      IF ((TECHQU.EQ.'???').AND.(SIGNAL(1).EQ.'??')) THEN
*        TECHQU AND SIGNAL NOT SPECIFIED IN INPUT DECK
         TECHQU='SEM'
         SIGNAL(1)='BE'
      ELSE IF ((TECHQU.NE.'???').AND.(SIGNAL(1).NE.'??')) THEN
*        BOTH, TECHQU AND SIGNAL, ARE SPECIFIED
*        ---CHECK TECHQU AND SIGNAL FOR VALID VALUES
         CALL CCAP(TECHQU,IEND(TECHQU))
         CALL CCAP(SIGNAL(1),IEND(SIGNAL(1)))
         IF ((TECHQU.NE.'EMP').AND.(TECHQU.NE.'SEM').AND.
     &       (TECHQU.NE.'TEM').AND.(TECHQU.NE.'AES')) THEN
            WRITE(6,'(A)')'       '
            WRITE(6,'(A)')' %%% WARNING %%% '
            WRITE(6,'(2A)')' Invalid Specification of TECHQU in the',
     &                     ' &INIT namelist !'
            WRITE(6,'(2A)')' Default value is SEM (Scanning Electron',
     &                     ' Microscopy) - take default value? (Y/N)'
            IWARN=IWARN+1
            READ(*,'(A)')CYN
            CALL CCAP(CYN,1)
            IF (CYN.EQ.'Y') THEN
               TECHQU='SEM'
            ELSE
               WRITE(6,'(A)')' Input TECHQU (SEM, EMP, TEM, or AES)'
               READ(*,'(A)')TECHQU
               CALL CCAP(TECHQU,IEND(TECHQU))
               GOTO 10
            ENDIF
         ENDIF
         IF ((SIGNAL(1).NE.'XC').AND.(SIGNAL(1).NE.'SE').AND.
CS           XR AND XK NOT IMPLEMENTED IN VERSION 1.0
CS   0       (SIGNAL(1).NE.'XR').AND.(SIGNAL(1).NE.'XK').AND.
     1       (SIGNAL(1).NE.'BE').AND.(SIGNAL(1).NE.'TE').AND.
     2       (SIGNAL(1).NE.'AE').AND.(SIGNAL(1).NE.'IO')) THEN
            WRITE(6,'(A)')'       '
            WRITE(6,'(A)')' %%% WARNING %%% '
            WRITE(6,'(2A)')' Invalid Specification of SIGNAL in the',
     &                     ' &INIT namelist !'
            WRITE(6,'(2A)')' Default value is BE for SEM, XC for EMP,',
     1                     ' TE for TEM, and AE for AES',
     2                     ' - take default value? (Y/N)'
            IWARN=IWARN+1
            READ(*,'(A)')CYN
            CALL CCAP(CYN,1)
            IF (CYN.EQ.'Y') THEN
               IF (TECHQU.EQ.'SEM') SIGNAL(1)='BE'
               IF (TECHQU.EQ.'EMP') SIGNAL(1)='XC'
               IF (TECHQU.EQ.'TEM') SIGNAL(1)='TE'
               IF (TECHQU.EQ.'AES') SIGNAL(1)='AE'
            ELSE
               WRITE(6,'(A)')' Input SIGNAL (XC, SE, BE, TE or AE)'
               READ(*,'(A)')SIGNAL(1)
               CALL CCAP(SIGNAL(1),IEND(SIGNAL(1)))
               GOTO 10
            ENDIF
         ENDIF
	 IF (SIGNAL(1).EQ.'XC') THEN
	    IF (TECHQU.EQ.'AES') THEN
               WRITE(6,'(A)')'      '
               WRITE(6,'(A)')' %%% WARNING %%%'
               WRITE(6,'(A)')' AES is not a valid TECHQU for SIGNAL=XC'
               WRITE(6,'(A)')' TECHQU is automatically set to SEM'
               WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
               TECHQU='SEM'
               IWARN=IWARN+1
            ENDIF
CS	 ELSE IF (SIGNAL(1).EQ.'XR') THEN
CS	    IF (TECHQU.EQ.'AES') THEN
CS             WRITE(6,'(A)')'     '
CS             WRITE(6,'(A)')' %%% WARNING %%%'
CS             WRITE(6,'(A)')' AES is not a valid TECHQU for SIGNAL=XR'
CS             WRITE(6,'(A)')' TECHQU is automatically set to SEM'
CS             WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
CS             TECHQU='SEM'
CS             IWARN=IWARN+1
CS          ENDIF
CS	 ELSE IF (SIGNAL(1).EQ.'XK') THEN
CS	    IF (TECHQU.EQ.'AES') THEN
CS             WRITE(6,'(A)')'      '
CS             WRITE(6,'(A)')' %%% WARNING %%%'
CS             WRITE(6,'(A)')' AES is not a valid TECHQU for SIGNAL=XK'
CS             WRITE(6,'(A)')' TECHQU is automatically set to SEM'
CS             WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
CS             TECHQU='SEM'
CS             IWARN=IWARN+1
CS          ENDIF
	 ELSE IF (SIGNAL(1).EQ.'BE') THEN
	    IF (TECHQU.EQ.'AES') THEN
               WRITE(6,'(A)')'      '
               WRITE(6,'(A)')' %%% WARNING %%%'
               WRITE(6,'(A)')' AES is not a valid TECHQU for SIGNAL=BE'
               WRITE(6,'(A)')' TECHQU is automatically set to SEM'
               WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
               TECHQU='SEM'
               IWARN=IWARN+1
            ENDIF
	 ELSE IF (SIGNAL(1).EQ.'SE') THEN
	    IF (TECHQU.EQ.'TEM') THEN
               WRITE(6,'(A)')'      '
               WRITE(6,'(A)')' %%% WARNING %%%'
               WRITE(6,'(A)')' TEM is not a valid TECHQU for SIGNAL=SE'
               WRITE(6,'(A)')' TECHQU is automatically set to SEM'
               WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
               TECHQU='SEM'
               IWARN=IWARN+1
            ENDIF
	 ELSE IF (SIGNAL(1).EQ.'TE') THEN
	    IF ((TECHQU.EQ.'AES').OR.(TECHQU.EQ.'SEM')) THEN
               WRITE(6,'(A)')'      '
               WRITE(6,'(A)')' %%% WARNING %%%'
               WRITE(6,'(3A)')TECHQU,' is not a valid TECHQU',
     &                        ' for SIGNAL=TE'
               WRITE(6,'(A)')' TECHQU is automatically set to TEM'
               WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
               TECHQU='TEM'
               IWARN=IWARN+1
            ENDIF
	 ELSE IF (SIGNAL(1).EQ.'AE') THEN
	    IF (TECHQU.NE.'AES') THEN
               WRITE(6,'(A)')'      '
               WRITE(6,'(A)')' %%% WARNING %%%'
               WRITE(6,'(3A)')TECHQU,' is not a valid TECHQU',
     &                        ' for SIGNAL=AE'
               WRITE(6,'(A)')' TECHQU is automatically set to AES'
               WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
               TECHQU='AES'
               IWARN=IWARN+1
            ENDIF
	 ELSE IF (SIGNAL(1).EQ.'IO') THEN
	    IF ((TECHQU.EQ.'AES').OR.(TECHQU.EQ.'TEM')) THEN
               WRITE(6,'(A)')'      '
               WRITE(6,'(A)')' %%% WARNING %%%'
               WRITE(6,'(3A)')TECHQU,' is not a valid TECHQU',
     &                        ' for SIGNAL=IO'
               WRITE(6,'(A)')' TECHQU is automatically set to TEM'
               WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
               TECHQU='EMP'
               IWARN=IWARN+1
            ENDIF
         ENDIF
      ELSE IF ((TECHQU.NE.'???').AND.(SIGNAL(1).EQ.'??')) THEN
*        ONLY TECHQU IS SPECIFIED
*        ---CHECK TECHQU FOR VALID VALUES
         CALL CCAP(TECHQU,IEND(TECHQU))
         IF ((TECHQU.NE.'EMP').AND.(TECHQU.NE.'SEM').AND.
     &       (TECHQU.NE.'TEM').AND.(TECHQU.NE.'AES')) THEN
            WRITE(6,'(A)')'       '
            WRITE(6,'(A)')' %%% WARNING %%% '
            WRITE(6,'(2A)')' Invalid Specification of TECHQU in the',
     &                     ' &INIT namelist !'
            WRITE(6,'(2A)')' Default value is SEM (Scanning Electron',
     &                     ' Microscopy) - take default value? (Y/N)'
            IWARN=IWARN+1
            READ(*,'(A)')CYN
            CALL CCAP(CYN,1)
            IF (CYN.EQ.'Y') THEN
               TECHQU='SEM'
            ELSE
               WRITE(6,'(A)')' Input TECHQU (SEM, EMP, TEM, or AES)'
               READ(*,'(A)')TECHQU
               CALL CCAP(TECHQU,IEND(TECHQU))
               GOTO 10
            ENDIF
         ENDIF
	 IF (TECHQU.EQ.'SEM') SIGNAL(1)='BE'
	 IF (TECHQU.EQ.'EMP') SIGNAL(1)='XC'
	 IF (TECHQU.EQ.'TEM') SIGNAL(1)='TE'
	 IF (TECHQU.EQ.'AES') SIGNAL(1)='AE'
      ELSE IF ((TECHQU.EQ.'???').AND.(SIGNAL(1).NE.'??')) THEN
*        ONLY SIGNAL IS SPECIFIED
*        ---CHECK SIGNAL FOR VALID VALUES
         CALL CCAP(TECHQU,IEND(TECHQU))
         CALL CCAP(SIGNAL(1),IEND(SIGNAL(1)))
         IF ((SIGNAL(1).NE.'XC').AND.(SIGNAL(1).NE.'SE').AND.
CS   0       (SIGNAL(1).NE.'XR').AND.(SIGNAL(1).NE.'XK').AND.
     1       (SIGNAL(1).NE.'BE').AND.(SIGNAL(1).NE.'TE').AND.
     2       (SIGNAL(1).NE.'AE').AND.(SIGNAL(1).NE.'IO')) THEN
            WRITE(6,'(A)')'       '
            WRITE(6,'(A)')' %%% WARNING %%% '
            WRITE(6,'(2A)')' Invalid Specification of SIGNAL in the',
     &                     ' &INIT namelist !'
            WRITE(6,'(2A)')' Default value is BE for SEM, XC for',
     &                     ' EMP, TE for TEM, and AE for AES'
            WRITE(6,'(A)')' Default TECHQU is SEM - take default',
     &                    ' value (=BE)? (Y/N)'
            IWARN=IWARN+1
            READ(*,'(A)')CYN
            CALL CCAP(CYN,1)
            IF (CYN.EQ.'Y') THEN
	       SIGNAL(1)='BE'
	    ELSE
               WRITE(6,'(A)')' Input SIGNAL (XR, SE, BE, TE or AE)'
               READ(*,'(A)')SIGNAL(1)
               CALL CCAP(SIGNAL(1),IEND(SIGNAL(1)))
               GOTO 10
            ENDIF
         ENDIF
         IF (SIGNAL(1).EQ.'BE') THEN
            TECHQU='SEM'
         ELSE IF (SIGNAL(1).EQ.'XC') THEN
            TECHQU='SEM'
CS       ELSE IF (SIGNAL(1).EQ.'XR') THEN
CS          TECHQU='SEM'
CS       ELSE IF (SIGNAL(1).EQ.'XK') THEN
CS          TECHQU='SEM'
         ELSE IF (SIGNAL(1).EQ.'SE') THEN
            TECHQU='SEM'
         ELSE IF(SIGNAL(1).EQ.'TE') THEN
            TECHQU='TEM'
         ELSE IF (SIGNAL(1).EQ.'AE') THEN
            TECHQU='AES'
         ENDIF
      ENDIF
      IF (SIGNAL(1).EQ.'XR') THEN
         LXRAY=.TRUE.
      ELSE IF (SIGNAL(1).EQ.'XC') THEN
         LXCHAR=.TRUE.
      ELSE IF (SIGNAL(1).EQ.'XK') THEN
         LXCONT=.TRUE.
      ELSE IF (SIGNAL(1).EQ.'BE') THEN
         LEBACK=.TRUE.
      ELSE IF (SIGNAL(1).EQ.'SE') THEN
         LESEC=.TRUE.
      ELSE IF (SIGNAL(1).EQ.'TE') THEN
         LETRAN=.TRUE.
      ELSE IF (SIGNAL(1).EQ.'AE') THEN
         LEAUG=.TRUE.
      ELSE IF (SIGNAL(1).EQ.'IO') THEN
         LIODIS=.TRUE.
      ENDIF
      IF (JOB(1:3).EQ.'   ') THEN
         JOB=INFILE(1:IEND(INFILE)-4)
      ENDIF
      IF (NDMAXCONT.GT.0) LXCONT=.TRUE.
      IF (NXCONT.GT.0) LXCONT=.TRUE.
      IF (LXCONT) LPTOB=.TRUE.
      LBREMS=LXCONT.OR.LPTOB
      NWARN=NWARN+IWARN
      IF (IWARN.NE.0) WRITE(6,'(A)')'     '
      WRITE(6,'(A,I3,2A)')' ',IWARN,' WARNING(S) GENERATED DURING',
     1                    ' CHECKING THE &INPUT PARAMETERS'


*     ---CHECK ALL &ETRNS PARAMETERS
      IWARN=0
      WRITE(6,'(A)')'     '
      WRITE(6,'(A)')' CURRENTLY CHECKING ALL &ETRNS PARAMETERS !'
      IF (NETRN.LE.0) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% ERROR %%%'
         WRITE(6,'(2A)')' Total number of electrons (NETRN) must be',
     &                  ' greater than 0 !'
         WRITE(6,'(A)')' SESAME is terminateing - correct input deck!'
         STOP
      ENDIF
      IF (EF.LT.0) THEN EF=100
      IF (EF.LT.10) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(2A)')' Final electron energy (EF) must'
     &                 ,' be greater or equal 10 eV !'
         WRITE(6,'(A)')' Default value EF=100 is taken'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IWARN=IWARN+1
         EF=100
      ENDIF
      EMIN=EF
      IF (E0.LE.10) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% ERROR %%%'
         WRITE(6,'(2A)')' Initial Energy of electrons (E0) must be',
     &                  ' greater than 10 eV !'
         WRITE(6,'(A)')' SESAME is terminating - correct input deck!'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         STOP
      ENDIF
      IF (E0.GT.300000) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% ERROR %%%'
         WRITE(6,'(2A)')' Initial Energy of electrons (E0) must be',
     &                  ' smaller or equal 500 keV !'
         WRITE(6,'(A)')' SESAME is terminating - correct input deck!'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         STOP
      ENDIF
      IF (E0.GE.300000) E0=299999
      EPRIM=E0
      IF (EF.GT.E0) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(2A)')' Final electron energy (EF) must'
     &                 ,' be smaller or equal E0 !'
         WRITE(6,'(A)')' Default value EF=100 is taken'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IWARN=IWARN+1
         EF=100
      ENDIF
      NWARN=NWARN+IWARN
      IF (IWARN.NE.0) WRITE(6,'(A)')'     '
      WRITE(6,'(A,I3,2A)')' ',IWARN,' WARNING(S) GENERATED DURING',
     1                    ' CHECKING THE &ETRNS PARAMETERS'


*     ---CHECK ALL &EBEAM PARAMETERS
      IWARN=0
*     Do NOT ACCOUNT FOR DIFFERENT UNITS SPSIZE ALWAYS IN ANGSTROM
      WRITE(6,'(A)')'     '
      WRITE(6,'(A)')' CURRENTLY CHECKING ALL &EBEAM PARAMETERS !'
      IF (ESTD.LT.0) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(2A)')' Standard deviation of electron energy (ESTD)'
     &                 ,' must be greater or equal 0 !'
         WRITE(6,'(A)')' Default value ESTD=0 is taken'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IWARN=IWARN+1
         ESTD=0
      ENDIF
      IF (DIVERG.LT.0) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(2A)')' Beam divergence (DIVERG)'
     &                 ,' must be greater or equal 0 !'
         WRITE(6,'(A)')' Default value DIVERG=0 is taken'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IWARN=IWARN+1
         DIVERG=0
      ENDIF
      IF (SPSIZE.LT.0) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(2A)')' Spot size of electron beam (SPSIZE)'
     &                 ,' must be greater or equal 0 !'
         WRITE(6,'(A)')' Default value SPSIZE=0 is taken'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IWARN=IWARN+1
         SPSIZE=0
      ENDIF
      IF (SPSIZE.EQ.0) SPSIZE=0.01
      ESTDD=ESTD
      IF ((TECHQU.EQ.'EMP').AND.(SCAN)) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(A)')' SCAN=T is not valid if TECHQU=EMP'
         WRITE(6,'(A)')' SCAN is set to F for this simulation'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IWARN=IWARN+1
         SCAN=.FALSE.
      ENDIF
      NWARN=NWARN+IWARN
      IF (IWARN.NE.0) WRITE(6,'(A)')'     '
      WRITE(6,'(A,I3,2A)')' ',IWARN,' WARNING(S) GENERATED DURING',
     1                    ' CHECKING THE &EBEAM PARAMETERS'


*     ---CHECK ALL &TARGET PARAMETERS
      IWARN=0
      WRITE(6,'(A)')'     '
      WRITE(6,'(A)')' CURRENTLY CHECKING ALL &TARGET PARAMETERS !'
      DO 420 I=1,NREG
         IF (DENS(I).LE.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% ERROR %%%'
            WRITE(6,'(A,I2,A)')' Density for region',I,
     &                         ' is out of range'
            WRITE(6,'(2A)')' SESAME is terminating -',
     &                     ' correct input deck!'
            STOP
         ENDIF
         DO 410 J=1,NELE(I)
            IF ((ATFRAC(I,J).LT.0).OR.(ATFRAC(I,J).GT.1)) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' %%% ERROR %%%'
               WRITE(6,'(A,I2,A,I2,A)')' Atomic fraction for element',
     &               J,' in region',I,' is out of range'
               WRITE(6,'(2A)')' SESAME is terminating -',
     &                        ' correct input deck!'
               STOP
            ENDIF
            IF ((WEIGHTFRAC(I,J).LT.0).OR.(WEIGHTFRAC(I,J).GT.1)) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' %%% ERROR %%%'
               WRITE(6,'(A,I2,A,I2,A)')' Weight fraction for element',
     &               J,' in region',I,' is out of range'
               WRITE(6,'(2A)')' SESAME is terminating -',
     &                        ' correct input deck!'
               STOP
            ENDIF
            IF (ATDENS(I,J).LE.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' %%% ERROR %%%'
               WRITE(6,'(A,I2,A,I2,A)')' Atomic density for element',
     &               J,' in region',I,' is out of range'
               WRITE(6,'(2A)')' SESAME is terminating -',
     &                        ' correct input deck!'
               STOP
            ENDIF
 410     CONTINUE
 420  CONTINUE
      DO 430 I=1,NELEM
         IF ((ATNUM(I).LT.1).OR.(ATNUM(I).GT.92)) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% ERROR %%%'
            WRITE(6,'(A,I2,A,I10)')' Atomic number for element ',I,
     &               ' is out of range: ',ATNUM(I)
            WRITE(6,'(2A)')' SESAME is terminating -',
     &                     ' correct input deck!'
            STOP
         ENDIF
         IF (ATMASS(I).LE.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% ERROR %%%'
            WRITE(6,'(A,I2,A,I10)')' Atomic mass for element ',I,
     &              ' and atomic number ',ATNUM(I),' is out of range'
            WRITE(6,'(2A)')' SESAME is terminating -',
     &                     ' correct input deck!'
            STOP
         ENDIF
 430  CONTINUE
      NWARN=NWARN+IWARN
      IF (IWARN.NE.0) WRITE(6,'(A)')'     '
      WRITE(6,'(A,I3,2A)')' ',IWARN,' WARNING(S) GENERATED DURING',
     1                    ' CHECKING THE &TARGET PARAMETERS'


*     ---CHECK ALL &MODEL PARAMETERS
      IWARN=0
      IMESS=0
      WRITE(6,'(A)')'     '
      WRITE(6,'(A)')' CURRENTLY CHECKING ALL &MODEL PARAMETERS !'
      IF (MODR(1).EQ.'???') THEN
         IF (SIGNAL(1).EQ.'XC') THEN
            MODR(1)='SIN'
CS       ELSE IF (SIGNAL(1).EQ.'XR') THEN
CS          MODR(1)='SIN'
CS       ELSE IF (SIGNAL(1).EQ.'XK') THEN
CS          MODR(1)='SIN'
         ELSE IF (SIGNAL(1).EQ.'BE') THEN
           MODR(1)='SIN'
         ELSE IF (SIGNAL(1).EQ.'SE') THEN
            MODR(1)='HYB'
         ELSE IF (SIGNAL(1).EQ.'TE') THEN
            MODR(1)='SIN'
         ELSE IF (SIGNAL(1).EQ.'AE') THEN
            MODR(1)='HYB'
         ELSE IF (SIGNAL(1).EQ.'IO') THEN
            MODR(1)='SIN'
         ENDIF
      ENDIF
      DO 530 I=2,NREG
         IF (MODR(I).EQ.'???') MODR(I)=MODR(1)
 530  CONTINUE
      CALL CCAP(MODR(1),IEND(MODR(1)))
      IF ((MODR(1).NE.'SIN').AND.(MODR(1).NE.'HYB').AND.
     1    (MODR(1).NE.'DIR')) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(3A)')' ',MODR(1),' is not a valid model (MODR)'
         WRITE(6,'(2A)')' Model is set to SIN (single scattering model'
     1                 ,') for region 1'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IWARN=IWARN+1
         MODR(1)='SIN'
      ENDIF
      DO 540 I=2,NREG
         CALL CCAP(MODR(I),IEND(MODR(I)))
         IF ((MODR(I).NE.'SIN').AND.(MODR(I).NE.'HYB').AND.
     1       (MODR(I).NE.'DIR')) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% WARNING %%%'
            WRITE(6,'(3A)')' ',MODR(I),' is not a valid model (MODR)'
            WRITE(6,'(2A,I3)')' Model is set to SIN (single',
     1                        ' scattering model) for region',I
            WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
            IWARN=IWARN+1
            MODR(I)=MODR(1)
         ENDIF
 540  CONTINUE
      DO 550 I=1,NREG
         IF (MODR(I).EQ.'SIN') LSING(I)=.TRUE.
 550  CONTINUE
      DO 580 I=1,MAXELE
         DO 570 J=1,MAXSHELL
            IF ((SHELL(J,I).LT.0).OR.(SHELL(J,I).GT.9)) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' %%% WARNING %%%'
               WRITE(6,'(A,I2,2A,F3.0)')' ',SHELL(J,I),' is not a',
     1                    ' valid shell for element with Z=',Z2(I)
               WRITE(6,'(2A)')' This shell will not be taken into',
     1                    ' account !'
               WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
               SHELL(J,I)=0
CS               IWARN=IWARN+1
               IMESS=IMESS+1
            ELSE IF ((SHELL(J,I).GT.0).AND.(SHELL(J,I).LT.10)) THEN
               IF ((ATNUM(I).GT.0).AND.(ATNUM(I).LT.93)) THEN
                  IZ=ATNUM(I)
                  IF ((IZ.LT.EDLIM(SHELL(J,I),1)).OR.
     1                (IZ.GT.EDLIM(SHELL(J,I),2))) THEN
                     WRITE(6,'(A)')'     '
                     WRITE(6,'(A)')' %%% WARNING %%%'
                     WRITE(6,'(A,I2,2A,F3.0)')' ',SHELL(J,I),' is',
     1               ' not a valid shell for element with Z=',Z2(I)
                     WRITE(6,'(2A)')' There is no edge energy avail',
     1                         'able for this element and shell !'
                     WRITE(6,'(2A)')' This shell will not be taken',
     1                         ' into account !'
                     WRITE(6,'(2A)')' Protests are useless -',
     1                              ' ;-) SESAME'
                     SHELL(J,I)=0
CS                     IWARN=IWARN+1
                     IMESS=IMESS+1
                  ENDIF
               ENDIF
            ENDIF
 570     CONTINUE
 580  CONTINUE
      CALL CCAP(STOPP,3)
      IF ((STOPP.NE.'LUO').AND.(STOPP.NE.'BET')) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(4A)')' ',STOPP,' is not a valid stopping ',
     1                  'power (STOPP)'
         WRITE(6,'(A)')' STOPP is set to LUO (Luo & Joy)'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IWARN=IWARN+1
         STOPP='LUO'
      ENDIF
      IF (STOPP.EQ.'LUO') THEN
         LBETHE=.FALSE.
      ELSE IF (STOPP.EQ.'BET') THEN
         LBETHE=.TRUE.
      ELSE
         LBETHE=.FALSE.
      ENDIF
      CALL CCAP(IONCRS,3)
      IF ((IONCRS.NE.'POU').AND.(IONCRS.NE.'GRY').AND.
     &    (IONCRS.NE.'CAS')) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(4A)')' ',IONCRS,' is not a valid ionization ',
     1                  'cross section (IONCRS)'
         WRITE(6,'(A)')' IONCRS is set to POU (Pouchou)'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IWARN=IWARN+1
         IONCRS='POU'
      ENDIF
      CALL CCAP(BREMSCRS,3)
      IF ((BREMSCRS.NE.'ANA').AND.(BREMSCRS.NE.'TAB')) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(4A)')' ',BREMSCRS,' is not a valid Bremsstrahlung ',
     1                  'cross section (BREMSCRS)'
         WRITE(6,'(2A)')' BREMSCRS is set to ANA',
     1                  ' (analytical [Wiedmann])'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IWARN=IWARN+1
         BREMSCRS='ANA'
      ENDIF
      NNSI=0
      DO 583 I=1,NREG
         IF (MODR(I).EQ.'SIN') NNSI=1
 583  CONTINUE
      DO 585 I=1,NREG
         IF ((MODR(I).EQ.'HYB').AND.(IONCRS.EQ.'POU').AND.
     1       (NNSI.EQ.1)) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% MESSAGE %%%'
            WRITE(6,'(2A)')' Since the hybrid model (HYB) is applied',
     1                     ' to at least one region, the Gryzinski'
            WRITE(6,'(2A)')' ionization cross section will be taken',
     1                     ' for the single scattering model (SIN)'
            WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
            IONCRS='GRY'
         ENDIF
 585  CONTINUE
      IF (IONCRS.EQ.'POU') THEN
         LPOUCH=.TRUE.
         LGRYZ=.FALSE.
         LCASNATI=.FALSE.
      ELSE IF (IONCRS.EQ.'GRY') THEN
         LPOUCH=.FALSE.
         LGRYZ=.TRUE.
         LCASNATI=.FALSE.
      ELSE IF (IONCRS.EQ.'CAS') THEN
         LPOUCH=.FALSE.
         LGRYZ=.FALSE.
         LCASNATI=.TRUE.
      ELSE
         LPOUCH=.TRUE.
         LGRYZ=.FALSE.
         LCASNATI=.FALSE.
      ENDIF
      IF (BREMSCRS.EQ.'ANA') THEN
         LWIEDKIRK=.TRUE.
         LKQP=.FALSE.
      ELSE IF (BREMSCRS.EQ.'TAB') THEN
         LWIEDKIRK=.FALSE.
         LKQP=.TRUE.
      ELSE
         LWIEDKIRK=.TRUE.
         LKQP=.FALSE.
      ENDIF
      NWARN=NWARN+IWARN
      IF ((IWARN.NE.0).OR.(IMESS.NE.0)) WRITE(6,'(A)')'     '
      WRITE(6,'(A,I3,2A)')' ',MAX(IWARN,IMESS),
     1                    ' WARNING(S) GENERATED DURING',
     2                    ' CHECKING THE &MODEL PARAMETERS'


*     ---CHECK ALL &MSETUP PARAMETERS
      IWARN=0
      WRITE(6,'(A)')'     '
      WRITE(6,'(A)')' CURRENTLY CHECKING ALL &MSETUP PARAMETERS !'
      IF ((SCANANG.NE.-999999).AND.(.NOT.SCAN)) THEN
	    WRITE(6,'(A)')'     '
	    WRITE(6,'(A)')' %%% WARNING %%%'
	    WRITE(6,'(2A)')' It does not make sense to explicitely ',
     1			   'specify SCANANG if SCAN is set to F !'
	    WRITE(6,'(A)')' SCANANG will be ignored !'
	    WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
	    IWARN=IWARN+1
            SCANANG=0
      ENDIF
      IF (SCANANG.EQ.-999999) SCANANG=0
      IF ((SCANANG.LE.-90).OR.(SCANANG.GE.90)) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(2A)')' The scanning angle (SCANANG) is',
     1                  ' out of range !'
         WRITE(6,'(A)')' SCANANG is set to the default value (0) !'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         SCANANG=0
         IWARN=IWARN+1
      ENDIF
      SCANANG=SCANANG*PI/180
      IF (XESPOT.EQ.999999) THEN
         XESPOT=(XMAX+XMIN)/2
      ELSE
*        ACCOUNT FOR DIFFERENT UNITS
         XESPOT=XESPOT*DUNITS
*        XESPOT NOW IN ANGSTROM
      ENDIF
      IF ((XESPOT.LE.XMIN).OR.(XESPOT.GE.XMAX)) THEN
         XESPOT=(XMAX+XMIN)/2
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(2A)')' The lateral electron impact postion ',
     1         '(XESPOT) lies outside the specified geometry! '
         WRITE(6,'(2A)')' XESPOT is set to the lateral center',
     1                  ' of the specified geometry !'
         WRITE(6,'(2A,F12.5)')' The new lateral impact position is: ',
     1                          XESPOT
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IWARN=IWARN+1
      ENDIF
      IF (SCAN) THEN
	 XM=MIN(XESPOT-XMIN,XMAX-XESPOT)
	 XDLT=(XMAX-XMIN)*0.02
	 IF (XDLT.GE.XM) THEN
	    SCAN=.FALSE.
	    XRANGE=999999
	    WRITE(6,'(A)')'     '
	    WRITE(6,'(A)')' %%% WARNING %%%'
	    WRITE(6,'(2A)')' XESPOT, the lateral electron impact ',
     1			   'position,'
	    WRITE(6,'(2A)')' lies too close to the left/right ',
     1			   'geometry boundary !'
	    WRITE(6,'(A)')' SCAN is therefore set to FALSE !'
	    WRITE(6,'(A,F12.5)')' The lateral impact position is: ',
     1				   XESPOT
	    WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
	    IWARN=IWARN+1
	    GOTO 620
	 ENDIF
	 IF (XRANGE.NE.999999) THEN
*	    XRANGE HAS BEEN EXPLICITELY SPECIFIED
*           TRANSFORM TO ANGSTROM
            XRANGE=XRANGE*DUNITS
	    IF (XRANGE.GT.(2*(XM-XDLT))) THEN
*	       XRANGE IS SPECIFIED TO WIDE
	       XRSPEC=XRANGE
	       XRANGE=2*(XM-XDLT)
	       WRITE(6,'(A)')'     '
	       WRITE(6,'(A)')' %%% WARNING %%%'
	       WRITE(6,'(2A)')' XRANGE, the lateral scanning range, ',
     1			   'crosses the lateral geometry boundaries !'
	       WRITE(6,'(2A,F12.5,A,F12.5)')' XRANGE is therefore ',
     1			'set from: ',XRSPEC,' to: ',XRANGE
	       WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
	       IWARN=IWARN+1
	    ENDIF
	 ELSE
	    XRANGE=2*(XM-XDLT)
	 ENDIF
      ELSE
	 IF (XRANGE.NE.999999) THEN
	    WRITE(6,'(A)')'     '
	    WRITE(6,'(A)')' %%% WARNING %%%'
	    WRITE(6,'(2A)')' It does not make sense to explicitely ',
     1			   'specify XRANGE if SCAN is set to F !'
	    WRITE(6,'(A)')' XRANGE will be ignored !'
	    WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
	    IWARN=IWARN+1
	    XRANGE=999999
	 ENDIF
      ENDIF
      XRANGEFF=XRANGE/COS(SCANANG)
 620  CONTINUE
      DO 621 I=0,NXDET
        IF ((DTAKOFF(I).LT.-90).OR.(DTAKOFF(I).GT.90)) THEN
          WRITE(6,'(A)')'     '
          WRITE(6,'(A)')' %%% WARNING %%%'
          WRITE(6,'(A,I2,A)')' Detector ',I,' :'
          WRITE(6,'(2A)')' The detector take-off angle (TAKOFF) is',
     1                   ' out of range !'
          WRITE(6,'(A)')' TAKOFF is set to the default value (30) !'
          WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
          DTAKOFF(I)=30
          IWARN=IWARN+1
        ENDIF
        IF (DTAKOFF(I).EQ.0) THEN
          WRITE(6,'(A)')'     '
          WRITE(6,'(A)')' %%% WARNING %%%'
          WRITE(6,'(A,I2,A)')' Detector ',I,' :'
          WRITE(6,'(2A)')' The detector take-off angle (TAKOFF) is',
     1                   ' zero - this is not supported !'
          WRITE(6,'(A)')' TAKOFF is set to the default value (30) !'
          WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
          DTAKOFF(I)=30
          IWARN=IWARN+1
        ENDIF
        IF ((DXDEROT(I).LT.0).OR.(DXDEROT(I).GT.360)) THEN
          WRITE(6,'(A)')'       '
          WRITE(6,'(A)')' %%% WARNING %%%'
          WRITE(6,'(A,I2,A)')' Detector ',I,' :'
          WRITE(6,'(2A)')' The detector rotation angle (XDEROT) is',
     1                   ' out of range !'
          WRITE(6,'(A)')' XDEROT is set to the default value (0) !'
          WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
          DXDEROT(I)=0
          IWARN=IWARN+1
        ENDIF
 621  CONTINUE
      DO 622 I=0,NEDET
         IF ((DEDTHET(I).LT.0).OR.(DEDTHET(I).GT.180)) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% WARNING %%%'
            WRITE(6,'(A,I3)')' ELECTRON DETECTOR NUMBER: ',I 
            WRITE(6,'(2A)')' The electron detector polar angle ',
     1                  '(EDTHET) is out of range !'
            WRITE(6,'(A)')' EDTHET is set to the default value (0) !'
            WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
            DEDTHET(I)=0
            IWARN=IWARN+1
         ENDIF
         IF ((DEDPHI(I).LT.0).OR.(DEDPHI(I).GT.360)) THEN
            WRITE(6,'(A)')'       '
            WRITE(6,'(A)')' %%% WARNING %%%'
            WRITE(6,'(A,I3)')' ELECTRON DETECTOR NUMBER: ',I
            WRITE(6,'(2A)')' The electron detector azim. angle ',
     1                  '(EDPHI) is out of range !'
            WRITE(6,'(A)')' EDPHI is set to the default value (0) !'
            WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
            DEDPHI(I)=0
            IWARN=IWARN+1
         ENDIF
 622  CONTINUE
      IF ((EBROT.LT.0).OR.(EBROT.GT.360)) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(2A)')' The electron beam rotation angle (EBROT) is',
     1                  ' out of range !'
         WRITE(6,'(A)')' EBROT is set to the default value (0) !'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         EBROT=0
         IWARN=IWARN+1
      ENDIF
      IF ((EBTILT.LT.0).OR.(EBTILT.GE.90)) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(2A)')' The electron beam tilt angle (EBTILT) is',
     1                  ' out of range !'
         WRITE(6,'(A)')' EBTILT is set to the default value (0) !'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         EBTILT=0
         IWARN=IWARN+1
      ENDIF
      IF (MTIME.LE.0) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(2A)')' The measurement (counting) time (MTIME) is',
     1                  ' out of range !'
         WRITE(6,'(A)')' MTIME is set to the default value (100) !'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         MTIME=100
         IWARN=IWARN+1
      ENDIF
      IF (CURRENT.LE.0) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(2A)')' The beam current (CURRENT) is',
     1                  ' out of range !'
         WRITE(6,'(A)')' CURRENT is set to the default value (1 nA) !'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         CURRENT=1
         IWARN=IWARN+1
      ENDIF
*     TRANSFORM TO RADIANS
      DO 623 I=0,NXDET
         TAKOFR(I)=DTAKOFF(I)*PI/180.
         COSTAK(I)=DCOS(TAKOFR(I))
         SINTAK(I)=DSIN(TAKOFR(I))
         DEROTR(I)=DXDEROT(I)*PI/180.
         COSXDER(I)=DCOS(DEROTR(I))
         SINXDER(I)=DSIN(DEROTR(I))
 623  CONTINUE
      DO 6231 I=0,NEDET
         DEDTHET(I)=DEDTHET(I)*PI/180.
         DEDPHI(I) =DEDPHI(I)*PI/180.
 6231 CONTINUE
      EBTLTR=EBTILT*PI/180.
      EBROTR=EBROT*PI/180.
      NWARN=NWARN+IWARN
      IF (IWARN.NE.0) WRITE(6,'(A)')'     '
      WRITE(6,'(A,I3,2A)')' ',IWARN,' WARNING(S) GENERATED DURING',
     1                    ' CHECKING THE &MSETUP VARIABLES'

*     ---CHECK ALL &INSTR PARAMETERS
      IWARN=0
*     TRANSFORM XPCRT TO ANGSTROM (FROM MM)
      XPCRT=XPCRT*1E7
      WRITE(6,'(A)')'     '
      WRITE(6,'(A)')' CURRENTLY CHECKING ALL &INSTR PARAMETERS !'
      IF (.NOT.SCAN) THEN
         IF (NLSCP.GT.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% WARNING %%%'
            WRITE(6,'(2A)')' Since SCAN=F the specification of NLSCP',
     1                     ' does not make sense !'
            WRITE(6,'(A)')' NLSCP is set to 1 !'
            WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
            WRITE(6,'(A)')' This has no effect on the simulation !'
            NLSCP=1
            IWARN=IWARN+1
         ENDIF
         IF (MAGNI.GT.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% WARNING %%%'
            WRITE(6,'(2A)')' Since SCAN=F the specification of MAGNI',
     1                     ' does not make sense !'
            WRITE(6,'(A)')' MAGNI will be ignored !'
            WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
            WRITE(6,'(A)')' This has no effect on the simulation !'
            IWARN=IWARN+1
         ENDIF
         IF (XPCRT.GT.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% WARNING %%%'
            WRITE(6,'(2A)')' Since SCAN=F the specification of XPCRT',
     1                     ' does not make sense !'
            WRITE(6,'(A)')' XPCRT will be ignored !'
            WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
            WRITE(6,'(A)')' This has no effect on the simulation !'
            IWARN=IWARN+1
         ENDIF
         NLSCP=1
         XPCRT=-XPCRT
         MAGNI=-MAGNI
      ELSE
         IF (XPCRT.EQ.-2500000) THEN
            XPCRT=-XPCRT
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% MESSAGE %%%'
            WRITE(6,'(2A)')' The pixel distance on used CRT (XPCRT) is',
     1                     ' not specified in the input deck !'
            WRITE(6,'(A)')' The default value (0.25) will be taken !'
            WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         ENDIF
         IF (XPCRT.LE.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% WARNING %%%'
            WRITE(6,'(2A)')' The pixel distance on used CRT (XPCRT) is',
     1                     ' out of range !'
            WRITE(6,'(A)')' XPCRT is set to the default value (0.25) !'
            WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
            XPCRT=0.25*1E7
            IWARN=IWARN+1
         ENDIF
         IF ((MAGNI.LE.0).AND.(NLSCP.LE.0)) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% WARNING %%%'
            WRITE(6,'(2A)')' Since SCAN=T MAGNI or NLSCP must ',
     1                     ' be specified !'
            WRITE(6,'(A)')' MAGNI will be set to the default value !'
            WRITE(6,'(A,I12)')' MAGNI is: ',INT(-MAGNI)
            WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
            MAGNI=-MAGNI
            NLSCP=INT(XRANGEFF*MAGNI/XPCRT+0.99999)
            IWARN=IWARN+1
         ELSE IF ((MAGNI.GT.0).AND.(NLSCP.GT.0)) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% WARNING %%%'
            WRITE(6,'(2A)')' Simultaneous specification of NLSCP and',
     1                     ' MAGNI does not make sense !'
            WRITE(6,'(A)')' The value of NLSCP will be ignored !'
            WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
            NLSCP=INT(XRANGEFF*MAGNI/XPCRT+0.99999)
 624        IF (NLSCP.GT.MAXSCAN) THEN
               NLSCP=NLSCP/2
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' %%% WARNING %%%'
               WRITE(6,'(2A)')' The number of scan positions (NLSCP)',
     1                        ' is too large !'
               WRITE(6,'(A)')' NLSCP is halved !'
               WRITE(6,'(A,I6)')' New value of NLSCP is: ',NLSCP
               WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
               IWARN=IWARN+1
               GOTO 624
            ENDIF
            IWARN=IWARN+1
         ELSE IF (MAGNI.GT.0) THEN
            NLSCP=INT(XRANGEFF*MAGNI/XPCRT+0.99999)
 625        IF (NLSCP.GT.MAXSCAN) THEN
               MAGNI=MAGNI/2
               NLSCP=INT(XRANGEFF*MAGNI/XPCRT+0.99999)
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' %%% WARNING %%%'
               WRITE(6,'(2A)')' The specified magnification (MAGNI)',
     1                        ' is too high !'
               WRITE(6,'(A)')' MAGNI is halved !'
               WRITE(6,'(A,F12.2)')' New value of MAGNI is: ',MAGNI
               WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
               IWARN=IWARN+1
               GOTO 625
            ENDIF
         ELSE IF (NLSCP.GT.0) THEN
 627        IF (NLSCP.GT.MAXSCAN) THEN
               NLSCP=NLSCP/2
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' %%% WARNING %%%'
               WRITE(6,'(2A)')' The number of scan positions (NLSCP)',
     1                        ' is too large !'
               WRITE(6,'(A)')' NLSCP is halved !'
               WRITE(6,'(A,I6)')' New value of NLSCP is: ',NLSCP
               WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
               GOTO 627
            ENDIF
            XRANGEFF=XRANGE
            MAGNI=(NLSCP-1)*XPCRT/XRANGEFF
         ELSE
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% WARNING %%%'
            WRITE(6,'(2A)')' Something went totally wrong in the',
     1                     ' specification of MAGNI, NLSCP, XPCRT !'
            WRITE(6,'(A)')' Default values will be taken !'
            WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
            MAGNI=10000
            XPCRT=0.25*1E7
            NLSCP=INT(XRANGEFF*MAGNI/XPCRT+0.99999)
            IWARN=IWARN+1
 629        IF (NLSCP.GT.MAXSCAN) THEN
               MAGNI=MAGNI/2
               NLSCP=INT(XRANGEFF*MAGNI/XPCRT+0.99999)
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' %%% WARNING %%%'
               WRITE(6,'(2A)')' The number of scan positions (NLSCP)',
     1                        ' is too large !'
               WRITE(6,'(A)')' NLSCP is halved !'
               WRITE(6,'(A,I6)')' New value of NLSCP is: ',NLSCP
               WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
               IWARN=IWARN+1
               GOTO 629
            ENDIF
         ENDIF
      ENDIF
*     CALCULATE FIRST AND LAST SCANNING POSITION AND DISTANCE
*     BETWEEN TWO ADJACENT SCANNING POSITIONS
      IF (SCAN) THEN
         XLSCP=XPCRT/MAGNI
         XLSCP=XLSCP*XRANGE/XRANGEFF
         XEFRST=XESPOT-XLSCP*DBLE((NLSCP-1))/2.
         XELAST=XESPOT+XLSCP*DBLE((NLSCP-1))/2.
      ELSE
         XLSCP=0
         XEFRST=XESPOT
         XELAST=XESPOT
      ENDIF
      NWARN=NWARN+IWARN
      IF (IWARN.NE.0) WRITE(6,'(A)')'     '
      WRITE(6,'(A,I3,2A)')' ',IWARN,' WARNING(S) GENERATED DURING',
     1                    ' CHECKING THE &INSTR PARAMETERS'


*     ---CHECK ALL &DETECT PARAMETERS
      IWARN=0
CS      XDEFFTYPE(0)=0
CS      DXDTYPE(0)='ED'
      WRITE(6,'(A)')'     '
      WRITE(6,'(A)')' CURRENTLY CHECKING ALL &DETECT PARAMETERS !'
      DO 850 J=0,NXDET
      XDEFFTYPE(J)=0
      IF (DXFDEFF(J)(1:10).NE.CBL) THEN
         OPEN (43,FILE=CFUND(1:IEND(CFUND))//
     +         DXFDEFF(J)(1:IEND(DXFDEFF(J))),
     +         STATUS='OLD',FORM='FORMATTED',IOSTAT=IOS)
         IF (IOS.NE.0) THEN
            OPEN (43,FILE=DXFDEFF(J)(1:IEND(DXFDEFF(J))),
     +            STATUS='OLD',FORM='FORMATTED',IOSTAT=IOS)
         ENDIF
         IF (IOS.NE.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% WARNING %%%'
            WRITE(6,'(2A)')' Cannot open detector efficiency file',
     1                     ' (XFDEFF) !'
            WRITE(6,'(2A)')' Specified file name is: ',
     1                       DXFDEFF(J)(1:IEND(DXFDEFF(J)))
            WRITE(6,'(2A)')' Detector efficiency is calculated if XLAY',
     1                     'MAT is specified for this detector number !'
            WRITE(6,'(2A)')' Detector efficiency is set to unity',
     1                     ' for the whole energy range otherwise !'
            WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
            DXFDEFF(J)=CBL//CBL//CBL//CBL//CBL//CBL//CBL
            IWARN=IWARN+1
         ELSE
            XDEFFTYPE(J)=10
            CLOSE (43)
*           CHECK DETECTOR TYPE, FWHM, ETC.
CS            GOTO 812
         ENDIF
      ENDIF
      IF (XLAYMAT(J,1)(1:10).EQ.CBL) GOTO 812
      XDEFFTYPE(J)=XDEFFTYPE(J)+2
CS    CHECK THE XLAYMAT STRING ARRAY
CS    AND INITIALIZE THE NXLAYEL AND LAYXEL ARRAYS
      CALL CHKXDET (J,IERROR)
      IF (IERROR.NE.0) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(A,I3)')' Detector number: ',J
         WRITE(6,'(A)')' Specification of detector efficiency wrong !'
         WRITE(6,'(A)')' X-ray detector efficiency is set to one !'
         XDEFFTYPE(J)=XDEFFTYPE(J)-2
         IF (XDEFFTYPE(J).LT.0) XDEFFTYPE(J)=0
         IWARN=IWARN+1
         GOTO 812
      ENDIF
      DO 810 I=1,NDLAY(J)
         IF (XLAYDN(J,I).LT.0) THEN
CS         IF (XLAYDN(J,I).LE.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% WARNING %%%'
            WRITE(6,'(A,I3)')' Detector number: ',J
            WRITE(6,'(A,I2,A)')' Density of detector layer ',I,
     1                         ' (XLAYDN) is out of range !'
            WRITE(6,'(2A)')' This layer will have absolutely no',
     1                     ' influence on the detected intensities !'
            WRITE(6,'(A)')' Density is set to zero !'
            WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
            XLAYDN(J,I)=0
            IWARN=IWARN+1
         ENDIF
         IF (XLAYTH(J,I).LT.0) THEN
CS         IF (XLAYTH(J,I).LE.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% WARNING %%%'
            WRITE(6,'(A,I3)')' Detector number: ',J
            WRITE(6,'(A,I2,A)')' Thickness of detector layer ',I,
     1                         ' (XLAYTH) is out of range !'
            WRITE(6,'(2A)')' This layer will have absolutely no',
     1                     ' influence on the detected intensities !'
            WRITE(6,'(A)')' Thickness is set to zero !'
            WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
            XLAYTH(J,I)=0
            IWARN=IWARN+1
         ENDIF
 810  CONTINUE
 812  CALL CCAP(DXDTYPE(J),2)
      IF ((DXDTYPE(J).NE.'ED').AND.(DXDTYPE(J).NE.'WD')) THEN
         IF (DXDTYPE(J).EQ.'  ') GOTO 815
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(A,I2)')' X-RAY DETECTOR NUMBER: ',J
         WRITE(6,'(2A)')' Invalid specification of the x-ray detecto',
     1                  'r type (XDTYPE) !'
         WRITE(6,'(A)')' XDTYPE is set to the default value (ED) !'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IWARN=IWARN+1
 815     DXDTYPE(J)='ED'
      ENDIF
      IF ((DSOLIDA(J).LE.0).OR.(DSOLIDA(J).GT.12.56637061)) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(A,I2)')' X-RAY DETECTOR NUMBER: ',J
         WRITE(6,'(2A)')' The solid angle of detection (SOLIDA) is',
     1                  ' out of range !'
         WRITE(6,'(2A)')' SOLIDA is set to the default value',
     1                  ' (0.00314 sr) !'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         DSOLIDA(J)=0.00314
         IWARN=IWARN+1
      ENDIF
      IF (DFWHM(J).LE.0) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(A,I2)')' X-RAY DETECTOR NUMBER: ',J
         WRITE(6,'(2A)')' The full width at half maximum (FWHM) is',
     1                  ' out of range !'
         WRITE(6,'(A)')' FWHM is set to the default value (150 eV) !'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         DFWHM(J)=150
         IWARN=IWARN+1
      ENDIF
      IF (DENFWHM(J).LT.1000) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(A,I2)')' X-RAY DETECTOR NUMBER: ',J
         WRITE(6,'(2A)')' The reference energy for the FWHM value ',
     1                  '(ENFWHM) should be larger than 1000 eV !'
         WRITE(6,'(A)')' ENFWHM is set to the default value (5899 eV) !'
         WRITE(6,'(A)')' This is the K-alpha line of Mn !'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         DENFWHM(J)=5899
         IWARN=IWARN+1
      ENDIF
 850  CONTINUE
CS      DEDTHMN(0)=DEDTHMN(0)*PI/180.
CS      DEDTHMX(0)=DEDTHMX(0)*PI/180.
      DO 860 I=0,NEDET
         IF (DEDTHMN(I).GE.DEDTHMX(I)) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% WARNING %%%'
            WRITE(6,'(A,I3)')' Electron Detector Number: ',I
            WRITE(6,'(2A)')' Sizing of electron detector ',
     1                     ' (EDTHMN,EDTHMX) invalid !'
            WRITE(6,'(A)')' Size is set to 0-90 deg !'
            WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
            DEDTHMN(I)=0.
            DEDTHMX(I)=90.
            IWARN=IWARN+1
         ENDIF
         DEDTHMN(I)=DEDTHMN(I)*PI/180.
         DEDTHMX(I)=DEDTHMX(I)*PI/180.
 860  CONTINUE
      NWARN=NWARN+IWARN
      IF (IWARN.NE.0) WRITE(6,'(A)')'     '
      WRITE(6,'(A,I3,2A)')' ',IWARN,' WARNING(S) GENERATED DURING',
     1                    ' CHECKING THE &DETECT PARAMETERS'


*     ---CHECK ALL &OUTPUT PARAMETERS
      IWARN=0
      IMESS=0
      WRITE(6,'(A)')'     '
      WRITE(6,'(A)')' CURRENTLY CHECKING ALL &OUTPUT PARAMETERS !'
      IF (NETRBK.LT.0) THEN
	 WRITE(6,'(A)')'     '
	 WRITE(6,'(A)')' %%% WARNING %%%'
	 WRITE(6,'(2A)')' Negative number of electrons for backup',
     1			' (NETRBK) does not make sense !'
	 WRITE(6,'(2A)')' NETRBK will be ignored and no backup file',
     1			' will be written !'
	 WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
	 NETRBK=0
         LETRBK=.FALSE.
	 IWARN=IWARN+1
      ENDIF
CS - PROBABLY ONLY FOR THE TIME BEING:
      NXGRID=NDMAXGRID
      NYGRID=NDMAYGRID
      NZGRID=NDMAZGRID
CS      IF (NXGRID.LT.1) NXGRID=NXM
CS      IF (NYGRID.LT.1) NYGRID=NQUADS
CS      IF (NZGRID.LT.1) NZGRID=NZM
      IF (NXGRID.GT.NXM) THEN
         NXGRID=NXM
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% MESSAGE %%%'
         WRITE(6,'(2A)')' The specified number of grid lines',
     1                  ' in x-direction is out of range !'
         WRITE(6,'(A)')' The default value (NXM) will be taken !'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IMESS=IMESS+1
      ENDIF
      IF (NYGRID.GT.NYM) THEN
         NYGRID=NYM
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% MESSAGE %%%'
         WRITE(6,'(2A)')' The specified number of grid lines',
     1                  ' in y-direction is out of range !'
         WRITE(6,'(A)')' The default value (NYM) will be taken !'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IMESS=IMESS+1
      ENDIF
      IF (NZGRID.GT.NZM) THEN
         NZGRID=NZM
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% MESSAGE %%%'
         WRITE(6,'(2A)')' The specified number of grid lines',
     1                  ' in z-direction is out of range !'
         WRITE(6,'(A)')' The default value (NZM) will be taken !'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IMESS=IMESS+1
      ENDIF
      IF (MNCOLPAL.EQ.NPALET) MNCOLPAL=NPALET-1
      IF ((MNCOLPAL.LT.1).OR.(MNCOLPAL.GT.NPALET)) THEN
         MNCOLPAL=1
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% MESSAGE %%%'
         WRITE(6,'(2A)')' The starting value in color palette',
     1                  ' (MNCOLPAL) to use for visualizing'
         WRITE(6,'(A)')' distributions (e.g.XDD) is out of range !'
         WRITE(6,'(A)')' The default value (1) will be taken !'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IMESS=IMESS+1
      ENDIF
      IF (MINICOL.GT.MAXICOL)THEN
         MH=MAXICOL
         MAXICOL=MINICOL
         MINICOL=MH
      ENDIF
      IF (MINICOL.EQ.MAXICOL) THEN
         IF (MINICOL.GT.1) MINICOL=MINICOL-1
         IF (MAXICOL.LT.NPALET) MAXICOL=MAXICOL+1
      ENDIF
      IF (MINICOL.EQ.NPALET) MINICOL=NPALET-1
      IF ((MINICOL.LT.1).OR.(MINICOL.GE.NPALET)) THEN
         MINICOL=1
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% MESSAGE %%%'
         WRITE(6,'(2A)')' The lower limit in color palette (MINICOL)',
     1                  ' for visualizing distributions'
         WRITE(6,'(A)')' (e.g.XDD) is out of range !'
         WRITE(6,'(A)')' The default value (1) will be taken !'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IMESS=IMESS+1
      ENDIF
      IF ((MAXICOL.LT.1).OR.(MAXICOL.GT.NPALET)) THEN
         MAXICOL=NPALET
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% MESSAGE %%%'
         WRITE(6,'(2A)')' The upper limit in color palette (MAXICOL)',
     1                  ' for visualizing distributions'
         WRITE(6,'(A)')' (e.g.XDD) is out of range !'
         WRITE(6,'(A)')' The default value (1) will be taken !'
         WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
         IMESS=IMESS+1
      ENDIF
      IACTICOL(0)=1
      DO 870 ICOL=1,NPALET
         IF (ICOL.LT.MINICOL) THEN
            IACTICOL(ICOL)=1
         ELSE IF (ICOL.GT.MAXICOL) THEN
            IACTICOL(ICOL)=NPALET
         ELSE
            IACTICOL(ICOL)=
     &            INT(DBLE(NPALET-MNCOLPAL)*(DBLE(ICOL-MINICOL)/
     &            DBLE(MAXICOL-MINICOL)+DBLE(MNCOLPAL)/
     &            DBLE(NPALET-MNCOLPAL))+0.5)
         ENDIF
c-test
cs         write(6,*)icol,iacticol(icol)
 870  CONTINUE
cs-test
cs      write(6,*)minicol,maxicol,mncolpal
cs      stop
CS      IF (LETRBK.AND.(NETRBK.GT.0)) THEN
CS	 WRITE(6,'(A)')'     '
CS	 WRITE(6,'(A)')' %%% WARNING %%%'
CS	 WRITE(6,'(2A)')' Backup files can only be read or written',
CS     1			' at the same time !'
CS	 WRITE(6,'(A)')' A backup file will be written !'
CS	 WRITE(6,'(A)')' No backup file will be read !'
CS	 WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
CS	 LETRBK=.FALSE.
CS	 IWARN=IWARN+1
CS      ENDIF
      IF (LETRBK.AND.(FETRBK(1:10).EQ.CBL)) THEN
	 IE=IEND(JOB)
	 FETRBK(1:IE)=JOB(1:IE)
	 FETRBK(IE+1:IE+4)='.BCK'
      ENDIF
      IF (LETRBK.AND.(FETRBK(1:10).EQ.CBL)) THEN
	 WRITE(6,'(A)')'     '
	 WRITE(6,'(A)')' %%% WARNING %%%'
	 WRITE(6,'(2A)')' If a backup file should be read then a',
     1			' file name (FETRBK) must be specified !'
	 WRITE(6,'(A)')' No backup file will be read !'
	 WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
	 LETRBK=.FALSE.
	 IWARN=IWARN+1
      ENDIF
      IF (NETRBK.GT.NETRN) THEN
	 WRITE(6,'(A)')'     '
	 WRITE(6,'(A)')' %%% MESSAGE %%%'
	 WRITE(6,'(2A)')' Number of electrons for backup (NETRBK) is',
     1		    ' greater than total number of electrons (NETRN)'
         WRITE(6,'(A,I10)')' NETRBK = ',NETRBK
	 WRITE(6,'(2A)')' Backup file will be written at end of',
     1                  ' simulation!'
	 WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
	 NETRBK=NETRN
         IMESS=IMESS+1
      ENDIF
      IF (LSCDEF) THEN
	 IF (SCAN) THEN
	    IF (SIGNAL(1).EQ.'XC') THEN
	       SCREEN(0)(1:IEND(CXCSC))=CXCSC
	    ELSE IF (SIGNAL(1).EQ.'XK') THEN
	       SCREEN(0)(1:IEND(CXKSC))=CXKSC
	    ELSE IF (SIGNAL(1).EQ.'XR') THEN
	       SCREEN(0)(1:IEND(CXRSC))=CXRSC
	    ELSE IF (SIGNAL(1).EQ.'BE') THEN
	       SCREEN(0)(1:IEND(CBESC))=CBESC
	    ELSE IF (SIGNAL(1).EQ.'SE') THEN
	       SCREEN(0)(1:IEND(CSESC))=CSESC
	    ELSE IF (SIGNAL(1).EQ.'TE') THEN
	       SCREEN(0)(1:IEND(CTESC))=CTESC
	    ELSE IF (SIGNAL(1).EQ.'AE') THEN
	       SCREEN(0)(1:IEND(CAESC))=CAESC
	    ELSE IF (SIGNAL(1).EQ.'IO') THEN
	       SCREEN(0)(1:IEND(CIOSC))=CIOSC
	    ENDIF
	 ELSE
	    IF (SIGNAL(1).EQ.'XC') THEN
	       SCREEN(0)(1:IEND(CXCNSC))=CXCNSC
	    ELSE IF (SIGNAL(1).EQ.'XK') THEN
	       SCREEN(0)(1:IEND(CXKNSC))=CXKNSC
	    ELSE IF (SIGNAL(1).EQ.'XR') THEN
	       SCREEN(0)(1:IEND(CXRNSC))=CXRNSC
	    ELSE IF (SIGNAL(1).EQ.'BE') THEN
	       SCREEN(0)(1:IEND(CBENSC))=CBENSC
	    ELSE IF (SIGNAL(1).EQ.'SE') THEN
	       SCREEN(0)(1:IEND(CSENSC))=CSENSC
	    ELSE IF (SIGNAL(1).EQ.'TE') THEN
	       SCREEN(0)(1:IEND(CTENSC))=CTENSC
	    ELSE IF (SIGNAL(1).EQ.'AE') THEN
	       SCREEN(0)(1:IEND(CAENSC))=CAENSC
	    ELSE IF (SIGNAL(1).EQ.'IO') THEN
	       SCREEN(0)(1:IEND(CIONSC))=CIONSC
	    ENDIF
	 ENDIF
      ENDIF
      IF (CGRDFL(1:10).NE.CBL) THEN
         LAUTOG=.FALSE.
         OPEN (43,FILE=CGRDFL(1:IEND(CGRDFL)),
     +         STATUS='OLD',FORM='FORMATTED',IOSTAT=IOS)
         IF (IOS.NE.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% WARNING %%%'
            WRITE(6,'(2A)')' Cannot open grid file',
     1                     ' (CGRDFL) !'
            WRITE(6,'(2A)')' Specified file name is: ',
     1                       CGRDFL(1:IEND(CGRDFL))
            WRITE(6,'(A)')' An automatic grid will be generated !'
            WRITE(6,'(A)')' Protests are useless - ;-) SESAME'
            CGRDFL=CBL//CBL//CBL//CBL//CBL//CBL//CBL
            LAUTOG=.TRUE.
            IWARN=IWARN+1
         ENDIF
         CLOSE (43)
      ENDIF
      IF (LXCONT.OR.LPTOB) THEN
         IF (.NOT.LAUTOG) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' %%% MESSAGE %%%'
            WRITE(6,'(2A)')' Background will be computed',
     1                    ' on a user-defined grid read from file !'
            WRITE(6,'(2A)')' Make sure that all trajectories',
     1                     ' are within the grid area !'
            WRITE(6,'(2A)')' Results may be very inaccurate',
     1                     ' otherwise !'
            WRITE(6,'(A)')'     '
         ENDIF
      ENDIF
      NWARN=NWARN+IWARN
      IF ((IWARN.NE.0).OR.(IMESS.NE.0)) WRITE(6,'(A)')'     '
      WRITE(6,'(A,I3,2A)')' ',IWARN,' WARNING(S) GENERATED DURING',
     1                    ' CHECKING THE &OUTPUT PARAMETERS'

      WRITE(6,'(A)')'  '
      WRITE(6,'(A)')' END OF INPUT PARAMETER CHECKS '
      WRITE(6,'(I4,A)')NWARN,' WARNING(S) WAS (WERE) DETECTED !'
      IF ((NWARN.GT.0).AND.(LIACT)) THEN
         WRITE(6,'(2A)')' CONTINUE SIMULATION ANYWAY ? (Y/N)'
         READ(*,'(A)')CYN
         IF ((CYN.EQ.'N').OR.(CYN.EQ.'n')) STOP
      ENDIF

*     SET THE STARTING INDEX FOR SCREEN OUTPUT OF IONIZATIONS ACCORDING
*     TO THE LSCRN LOGICAL
      IF (LSCRN) THEN
         ISCROFSHELL=1
      ELSE
         ISCROFSHELL=2*(MAXSCR+MAXPST)
      ENDIF

      RETURN
      END








