c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
* The file chkout.f contains the following routines:
*
*    CHKOUT - checks output parameters (mainly) specified in the input deck
*             to determine sizes of dynamically allocated arrays
*    GETHIS - finds out the number of histograms and the size of main
*             array histogram 
*    GETTAB - finds out the size of the shell tables and the x-ray tables
*
****************************************************************************
* last modification: CS 10-Nov-1997

      SUBROUTINE CHKOUT (
     I                   LTEST,
     I                   NSCPOS,MXCONT,E0,EDLIM,ECLIM,
     I                   SCREEN,POST,PMSAV,HIST,ION,XCHAR,
     I                   NHISINT,N1STELE,CEABR,ATNUM,NDMAELEM,
     O                   NSCRN,NPS,NPM,NHIST,NVTOT,
     O                   NSHELL,NXCHAR,NXPTOB,NXCONT,
     O                   NHISXCONT,LXCONT,LXPTOB)

*     CHKOUT - CHECKS THE OUTPUT (AND ALSO SOME MODEL PARAMETERS) TO 
*              DETERMINE SIZES OF SOME PARAMETERS NEEDED FOR DYNAMIC
*              MEMEORY ALLOCATION.
*
*     N1STELE - FIRST ELEMENT IN ATMAT(1)
*
*     AUTHOR: CHRISTIAN SCHIEBL
*             CONSULTANT (FORMER: CEC-VIENNA)
*             KREMS, SEPTEMBER 1996

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'

      CHARACTER*70 SCREEN(0:2*MAXSCR),POST(3*MAXPST)
      CHARACTER*70 PMSAV(MAXSAV),HIST(MAXHIS)
      CHARACTER*70 CDUMMY
      CHARACTER*50 XCHAR(MAXELE)
      CHARACTER*40 ION(MAXELE)
      CHARACTER*10 CBL
      CHARACTER*2  CEABR

      LOGICAL LTEST,LXPTOB

      INTEGER GETHIS
      INTEGER EDLIM(MAXSHELL,2),ECLIM(MAXXCHAR,2)
      INTEGER IELEM(MAXELE)
      INTEGER ISH(MAXELE,MAXSHELL),ISHDEF(MAXELE,MAXSHELL)
      INTEGER IXC(MAXELE,MAXXCHAR)
      INTEGER NSCRNUM(2*MAXSCR),NSCROUT(2*MAXSCR)
      INTEGER NPSNUM(3*MAXPST),NPSOUT(3*MAXPST)

      DOUBLE PRECISION ATNUM(MAXELE)
      DOUBLE PRECISION EXC(MAXELE,MAXXCHAR)

      LOGICAL AESALREADY,NEEDXCHAR

**    START OF EXECUTABLE CODE
*     ************************

*     ---SOME INITIALIZATION (VARIABLES NEEDED IN GETTAB)
      AESALREADY=.FALSE.
      NEEDXCHAR =.FALSE.
      NE=0
      NS=0
      NL=0
      CBL='          '
      E0=E0*1000
      DO 4 I=1,MAXELE
         DO 2 J=1,MAXSHELL
            ISH(I,J)=0
 2       CONTINUE
         DO 3 J=1,MAXXCHAR
            IXC(I,J)=0
 3       CONTINUE
 4    CONTINUE

*     ---PARSE INFORMATION FROM SCREEN ARRAY (OUTPUT TO SCREEN)
      NSCRN=0
      NHIST=0
      NXCONT=0
      NHISXCONT=0
*     ---FIRST: LOCATION DEPENDEND SCREEN OUTPUT
      DO 10 I=0,2*MAXSCR
         CALL CCAP(SCREEN(I),3)
         IF (SCREEN(I)(1:3).EQ.'   ') THEN
            GOTO 10
         ELSE IF ((SCREEN(I)(1:3).EQ.'PET').OR.
     1            (SCREEN(I)(1:3).EQ.'BET').OR.
     2            (SCREEN(I)(1:3).EQ.'TET').OR.
     3            (SCREEN(I)(1:3).EQ.'SET').OR.
     4            (SCREEN(I)(1:3).EQ.'AET').OR.
     5            (SCREEN(I)(1:3).EQ.'ION').OR.
     6            (SCREEN(I)(1:3).EQ.'PEB').OR.
     7            (SCREEN(I)(1:3).EQ.'IOD').OR.
     8            (SCREEN(I)(1:3).EQ.'XGD').OR.
     9            (SCREEN(I)(1:3).EQ.'XDD').OR.
     1            (SCREEN(I)(1:3).EQ.'AGD').OR.
     2            (SCREEN(I)(1:3).EQ.'ADD')) THEN
            NSCRN=NSCRN+1
            NSCRNUM(NSCRN)=I
            NSCROUT(NSCRN)=I
            CALL FIND(SCREEN(I),';',4,70,IFSEMI,IFND)
            IF (IFND.EQ.1) THEN
               CALL FIND(SCREEN(I),',',4,IFSEMI,IFCOM,IFND)
               IF (IFND.EQ.1) THEN
                  IS=IFCOM+1
                  CALL FIND(SCREEN(I),',',IS,IFSEMI,ISCOM,IFND)
                  IF (IFND.EQ.1) THEN
                     IF ((ISCOM-IFCOM).GT.1) THEN
                        READ(SCREEN(I)(IFCOM+1:ISCOM-1),*,ERR=5)
     &                       NSCROUT(NSCRN)
                     ENDIF
                  ELSE
                     IF ((IFSEMI-IFCOM).GT.1) THEN
                        READ(SCREEN(I)(IFCOM+1:IFSEMI-1),*,ERR=5)
     &                       NSCROUT(NSCRN)
                     ENDIF
                  ENDIF
               ENDIF
            ELSE
               CALL FIND(SCREEN(I),',',4,70,IFCOM,IFND)
               IF (IFND.EQ.1) THEN
                  IS=IFCOM+1
                  CALL FIND(SCREEN(I),',',IS,70,ISCOM,IFND)
                  IF (IFND.EQ.1) THEN
                     IF ((ISCOM-IFCOM).GT.1) THEN
                        READ(SCREEN(I)(IFCOM+1:ISCOM-1),*,ERR=5)
     &                       NSCROUT(NSCRN)
                     ENDIF
                  ELSE
                     IE=IEND(SCREEN(I))
                     IF ((IE-IFCOM).GT.0) THEN
                        READ(SCREEN(I)(IFCOM+1:IE),*,ERR=5)
     &                       NSCROUT(NSCRN)
                     ENDIF
                  ENDIF
               ENDIF
            ENDIF
         ENDIF
 5       CONTINUE
         IF ((SCREEN(I)(1:3).EQ.'ION').OR.
     &       (SCREEN(I)(1:3).EQ.'IOD')) THEN
*           EXTRACT INFORMATION NEEDED TO DETERMINE NSHELL 
            CALL GETTAB(
     I                  1,1,2,SCREEN(I),
     I                  N1STELE,CEABR,NDMAELEM,ATNUM,
     O                  NE,NS,NL,IELEM,ISH,ISHDEF,IXC,IERROR)
         ENDIF
         IF ((SCREEN(I)(1:3).EQ.'XGD').OR.
     &       (SCREEN(I)(1:3).EQ.'XDD')) THEN
*           EXTRACT INFORMATION NEEDED TO DETERMINE NSHELL AND NXCHAR 
            CALL GETTAB(
     I                  1,2,2,SCREEN(I),
     I                  N1STELE,CEABR,NDMAELEM,ATNUM,
     O                  NE,NS,NL,IELEM,ISH,ISHDEF,IXC,IERROR)
         ENDIF
         IF ((SCREEN(I)(1:3).EQ.'AGD').OR.
     &       (SCREEN(I)(1:3).EQ.'ADD')) THEN
*           EXTRACT INFORMATION NEEDED TO DETERMINE NSHELL 
            CDUMMY=SCREEN(I)
            CALL FIND(CDUMMY,';',4,70,ISEMI,IFND)
            IF (IFND.NE.0) THEN
               IS=ISEMI+1
               CALL FIND(CDUMMY,';',IS,70,ISEMI,IFND)
               IF (IFND.NE.0) THEN
                  IS=ISEMI+1
                  CALL FIND(CDUMMY,',',IS,70,ICOM,IFND)
                  IF (IFND.NE.0) THEN
                     CDUMMY(ICOM+2:ICOM+2)=' '
                     CALL GETTAB(
     I                           1,1,2,CDUMMY,
     I                           N1STELE,CEABR,NDMAELEM,ATNUM,
     O                           NE,NS,NL,IELEM,ISH,ISHDEF,IXC,
     O                           IERROR)
                     NHIST=NHIST+1
                     NVTOT=NVTOT+2000
                  ELSE
                     WRITE(6,'(A)')'               '
                     WRITE(6,'(A)')' *** ERROR ***'
                     WRITE(6,'(2A)')'     CHKOUT: Auger line not',
     &                              ' properly specified!'
                     WRITE(6,'(A)')'     SeSAME stops here!'
                     STOP
                  ENDIF
               ELSE
                  WRITE(6,'(A)')'               '
                  WRITE(6,'(A)')' *** ERROR ***'
                  WRITE(6,'(2A)')'     CHKOUT: Auger line not',
     &                           ' properly specified!'
                  WRITE(6,'(A)')'     SeSAME stops here!'
                  STOP
               ENDIF
            ELSE
               WRITE(6,'(A)')'               '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')'     CHKOUT: Auger line not',
     &                        ' properly specified!'
               WRITE(6,'(A)')'     SeSAME stops here!'
               STOP
            ENDIF
         ENDIF
 10   CONTINUE

      IDIFF=0
      DO 20 I=1,NSCRN
         IF (NSCRNUM(I).NE.NSCROUT(I)) IDIFF=IDIFF+1
 20   CONTINUE
      NSCRN=NSCRN-IDIFF

*     ---SECOND: HISTOGRAMS
      DO 50 I=0,2*MAXSCR
         IF (SCREEN(I)(1:3).EQ.'   ') THEN
            GOTO 50
         ELSE IF ((SCREEN(I)(1:3).EQ.'BEE').OR.
     1            (SCREEN(I)(1:3).EQ.'TEE').OR.
     2            (SCREEN(I)(1:3).EQ.'SEE').OR.
     3            (SCREEN(I)(1:3).EQ.'BEA').OR.
     4            (SCREEN(I)(1:3).EQ.'TEA').OR.
     5            (SCREEN(I)(1:3).EQ.'SEA').OR.
     6            (SCREEN(I)(1:3).EQ.'AEA').OR.
     7            (SCREEN(I)(1:3).EQ.'BEP').OR.
     8            (SCREEN(I)(1:3).EQ.'TEP').OR.
     9            (SCREEN(I)(1:3).EQ.'SEP').OR.
     1            (SCREEN(I)(1:3).EQ.'AEP').OR.
     2            (SCREEN(I)(1:3).EQ.'TEB').OR.
     3            (SCREEN(I)(1:3).EQ.'IOV').OR.
     4            (SCREEN(I)(1:3).EQ.'IOL').OR.
     5            (SCREEN(I)(1:3).EQ.'BEY').OR.
     6            (SCREEN(I)(1:3).EQ.'SEY').OR.
     7            (SCREEN(I)(1:3).EQ.'TEY').OR.
     8            (SCREEN(I)(1:3).EQ.'AEY').OR.
     9            (SCREEN(I)(1:3).EQ.'DEY').OR.
     1            (SCREEN(I)(1:3).EQ.'XCS').OR.
     2            (SCREEN(I)(1:3).EQ.'XCY').OR.
     3            (SCREEN(I)(1:3).EQ.'XKY').OR.
     4            (SCREEN(I)(1:3).EQ.'XRY').OR.
     5            (SCREEN(I)(1:3).EQ.'XKS').OR.
     6            (SCREEN(I)(1:3).EQ.'XRS').OR.
     7            (SCREEN(I)(1:3).EQ.'BEL').OR.
     8            (SCREEN(I)(1:3).EQ.'BEH').OR.
     9            (SCREEN(I)(1:3).EQ.'AES').OR.
     1            (SCREEN(I)(1:3).EQ.'DEE').OR.
     2            (SCREEN(I)(1:3).EQ.'AEE')) THEN
            NSCRN=NSCRN+1
            NHIST=NHIST+1
            NDIM=1
            NSTUETZ=GETHIS(NDIM,NHISINT,NSCPOS,MXCONT,SCREEN(I))
            NVTOT=NVTOT+NSTUETZ
            IF ((SCREEN(I)(1:3).EQ.'IOV').OR.
     1          (SCREEN(I)(1:3).EQ.'IOL')) THEN
               CALL GETTAB(
     I                     1,1,2,SCREEN(I),
     I                     N1STELE,CEABR,NDMAELEM,ATNUM,
     O                     NE,NS,NL,IELEM,ISH,ISHDEF,IXC,IERROR)
            ELSE IF ((SCREEN(I)(1:3).EQ.'XCY').OR.
     1               (SCREEN(I)(1:3).EQ.'XKY').OR.
     2               (SCREEN(I)(1:3).EQ.'XRY')) THEN
               NEEDXCHAR=.TRUE.
               CALL GETTAB(
     I                     0,2,2,SCREEN(I),
     I                     N1STELE,CEABR,NDMAELEM,ATNUM,
     O                     NE,NS,NL,IELEM,ISH,ISHDEF,IXC,IERROR)
               IF (SCREEN(I)(1:3).EQ.'XRY') LXPTOB = .TRUE.
               IF (SCREEN(I)(1:3).EQ.'XKY') LXPTOB = .TRUE.
CS            ELSE IF (SCREEN(I)(1:3).EQ.'XKY') THEN
CS               LXPTOB = .TRUE.
            ELSE IF ((SCREEN(I)(1:3).EQ.'XKS').OR.
     &               (SCREEN(I)(1:3).EQ.'XRS')) THEN
               NHISXCONT=MAX(NHISXCONT,NSTUETZ)
               LXCONT = .TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'AES') THEN
               IF (.NOT.AESALREADY) THEN
                  NHIST=NHIST+1
                  NVTOT=NVTOT+NBCKSZ
                  AESALREADY=.TRUE.
               ENDIF
            ELSE IF (SCREEN(I)(1:3).EQ.'AEY') THEN
*              EXTRACT INFORMATION NEEDED TO DETERMINE NSHELL 
               CDUMMY=SCREEN(I)
               CALL FIND(CDUMMY,';',4,70,ISEMI,IFND)
               IF (IFND.NE.0) THEN
                 IS=ISEMI+1
                 CALL FIND(CDUMMY,';',IS,70,ISEMI,IFND)
                 IF (IFND.NE.0) THEN
                   IS=ISEMI+1
                   CALL FIND(CDUMMY,',',IS,70,ICOM,IFND)
                   IF (IFND.NE.0) THEN
                     CDUMMY(ICOM+2:ICOM+2)=' '
                     CALL GETTAB(
     I                           1,1,2,CDUMMY,
     I                           N1STELE,CEABR,NDMAELEM,ATNUM,
     O                           NE,NS,NL,IELEM,ISH,ISHDEF,IXC,
     O                           IERROR)
                   ELSE
                     WRITE(6,'(A)')'               '
                     WRITE(6,'(A)')' *** ERROR ***'
                     WRITE(6,'(2A)')'     CHKOUT: Auger line not',
     &                              ' properly specified!'
                     WRITE(6,'(A)')'     SeSAME stops here!'
                     STOP
                   ENDIF
                 ELSE
                   WRITE(6,'(A)')'               '
                   WRITE(6,'(A)')' *** ERROR ***'
                   WRITE(6,'(2A)')'     CHKOUT: Auger line not',
     &                            ' properly specified!'
                   WRITE(6,'(A)')'     SeSAME stops here!'
                   STOP
                 ENDIF
               ELSE
                 WRITE(6,'(A)')'               '
                 WRITE(6,'(A)')' *** ERROR ***'
                 WRITE(6,'(2A)')'     CHKOUT: Auger line not',
     &                          ' properly specified!'
                 WRITE(6,'(A)')'     SeSAME stops here!'
                 STOP
               ENDIF
            ENDIF
        ENDIF
 50   CONTINUE


*     ---PARSE INFORMATION FROM POST ARRAY (POSTSCRIPT OUTPUT)
      NPS=0
      DO 70 I=1,3*MAXPST
         CALL CCAP(POST(I),3)
         IF (POST(I)(1:3).EQ.'   ') THEN
            GOTO 70
         ELSE IF ((POST(I)(1:3).EQ.'PET').OR.
     1            (POST(I)(1:3).EQ.'BET').OR.
     2            (POST(I)(1:3).EQ.'TET').OR.
     3            (POST(I)(1:3).EQ.'SET').OR.
     4            (POST(I)(1:3).EQ.'AET').OR.
     5            (POST(I)(1:3).EQ.'ION').OR.
     6            (POST(I)(1:3).EQ.'PEB').OR.
     7            (POST(I)(1:3).EQ.'IOD').OR.
     8            (POST(I)(1:3).EQ.'XGD').OR.
     9            (POST(I)(1:3).EQ.'XDD').OR.
     1            (POST(I)(1:3).EQ.'AGD').OR.
     2            (POST(I)(1:3).EQ.'ADD')) THEN
            NPS=NPS+1
            NPSNUM(NPS)=I
            NPSOUT(NPS)=I
            CALL FIND(POST(I),';',4,70,IFSEMI,IFND)
            IF (IFND.EQ.1) THEN
               CALL FIND(POST(I),',',4,IFSEMI,IFCOM,IFND)
               IF (IFND.EQ.1) THEN
                  IS=IFCOM+1
                  CALL FIND(POST(I),',',IS,IFSEMI,ISCOM,IFND)
                  IF (IFND.EQ.1) THEN
                     IF ((ISCOM-IFCOM).GT.1) THEN
                        READ(POST(I)(IFCOM+1:ISCOM-1),*,ERR=55)
     &                       NPSOUT(NPS)
                     ENDIF
                  ELSE
                     IF ((IFSEMI-IFCOM).GT.1) THEN
                        READ(POST(I)(IFCOM+1:IFSEMI-1),*,ERR=55)
     &                       NPSOUT(NPS)
                     ENDIF
                  ENDIF
               ENDIF
            ELSE
               CALL FIND(POST(I),',',4,70,IFCOM,IFND)
               IF (IFND.EQ.1) THEN
                  IS=IFCOM+1
                  CALL FIND(POST(I),',',IS,70,ISCOM,IFND)
                  IF (IFND.EQ.1) THEN
                     IF ((ISCOM-IFCOM).GT.1) THEN
                        READ(POST(I)(IFCOM+1:ISCOM-1),*,ERR=55)
     &                       NPSOUT(NPS)
                     ENDIF
                  ELSE
                     IE=IEND(POST(I))
                     IF ((IE-IFCOM).GT.0) THEN
                        READ(POST(I)(IFCOM+1:IE),*,ERR=55)
     &                       NPSOUT(NPS)
                     ENDIF
                  ENDIF
               ENDIF
            ENDIF
         ENDIF
 55      CONTINUE
         IF ((POST(I)(1:3).EQ.'ION').OR.
     &       (POST(I)(1:3).EQ.'IOD')) THEN
*           EXTRACT INFORMATION NEEDED TO DETERMINE NSHELL 
            CALL GETTAB(
     I                  1,1,3,POST(I),
     I                  N1STELE,CEABR,NDMAELEM,ATNUM,
     O                  NE,NS,NL,IELEM,ISH,ISHDEF,IXC,IERROR)
         ENDIF
         IF ((POST(I)(1:3).EQ.'XGD').OR.
     &       (POST(I)(1:3).EQ.'XDD')) THEN
*           EXTRACT INFORMATION NEEDED TO DETERMINE NSHELL AND NXCHAR 
            CALL GETTAB(
     I                  1,2,3,POST(I),
     I                  N1STELE,CEABR,NDMAELEM,ATNUM,
     O                  NE,NS,NL,IELEM,ISH,ISHDEF,IXC,IERROR)
         ENDIF
         IF ((POST(I)(1:3).EQ.'AGD').OR.
     &       (POST(I)(1:3).EQ.'ADD')) THEN
*           EXTRACT INFORMATION NEEDED TO DETERMINE NSHELL 
            CDUMMY=POST(I)
            CALL FIND(CDUMMY,';',4,70,ISEMI,IFND)
            IF (IFND.NE.0) THEN
               IS=ISEMI+1
               CALL FIND(CDUMMY,';',IS,70,ISEMI,IFND)
               IF (IFND.NE.0) THEN
                  IS=ISEMI+1
                  CALL FIND(CDUMMY,',',IS,70,ICOM,IFND)
                  IF (IFND.NE.0) THEN
                     CDUMMY(ICOM+2:ICOM+2)=' '
                     CALL GETTAB(
     I                           1,1,2,CDUMMY,
     I                           N1STELE,CEABR,NDMAELEM,ATNUM,
     O                           NE,NS,NL,IELEM,ISH,ISHDEF,IXC,
     O                           IERROR)
                     NHIST=NHIST+1
                     NVTOT=NVTOT+2000
                  ELSE
                     WRITE(6,'(A)')'               '
                     WRITE(6,'(A)')' *** ERROR ***'
                     WRITE(6,'(2A)')'     CHKOUT: Auger line not',
     &                              ' properly specified!'
                     WRITE(6,'(A)')'     SeSAME stops here!'
                     STOP
                  ENDIF
               ELSE
                  WRITE(6,'(A)')'               '
                  WRITE(6,'(A)')' *** ERROR ***'
                  WRITE(6,'(2A)')'     CHKOUT: Auger line not',
     &                           ' properly specified!'
                  WRITE(6,'(A)')'     SeSAME stops here!'
                  STOP
               ENDIF
            ELSE
               WRITE(6,'(A)')'               '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')'     CHKOUT: Auger line not',
     &                        ' properly specified!'
               WRITE(6,'(A)')'     SeSAME stops here!'
               STOP
            ENDIF
            NHIST=NHIST+2
            NVTOT=NVTOT+4000
         ENDIF
 70   CONTINUE
      IDIFF=0
      DO 80 I=1,NPS
         IF (NPSNUM(I).NE.NPSOUT(I)) IDIFF=IDIFF+1
 80   CONTINUE
      NPS=NPS-IDIFF

*     ---PARSE INFORMATION FROM PMSAV ARRAY (POSTMINI SAV FILE)
      NPM=0
      DO 100 I=1,MAXSAV
          CALL CCAP(PMSAV(I),3)
          IF (PMSAV(I)(1:3).EQ.'   ') THEN
             GOTO 100
          ELSE IF ((PMSAV(I)(1:3).EQ.'BEW').OR.
     1             (PMSAV(I)(1:3).EQ.'TEW').OR.
     2             (PMSAV(I)(1:3).EQ.'SEW').OR.
     3             (PMSAV(I)(1:3).EQ.'AEW').OR.
     4             (PMSAV(I)(1:3).EQ.'IO2')) THEN
             NPM=NPM+1
             NHIST=NHIST+1
             NDIM=2
             NVTOT=NVTOT+GETHIS(NDIM,NHISINT,NSCPOS,MXCONT,PMSAV(I))
          ELSE IF ((PMSAV(I)(1:3).EQ.'IOD').OR.
     1             (PMSAV(I)(1:3).EQ.'XGD').OR.
     2             (PMSAV(I)(1:3).EQ.'XDD')) THEN
             NPM=NPM+1
          ENDIF
 100  CONTINUE

*     ---PARSE INFORMATION FROM HIST ARRAY (HISTOGRAM FILES)
      DO 150 I=1,MAXHIS
         CALL CCAP(HIST(I),3)
         IF (HIST(I)(1:3).EQ.'   ') THEN
            GOTO 150
         ELSE IF ((HIST(I)(1:3).EQ.'BEE').OR.
     1            (HIST(I)(1:3).EQ.'TEE').OR.
     2            (HIST(I)(1:3).EQ.'SEE').OR.
     3            (HIST(I)(1:3).EQ.'AES').OR.
     4            (HIST(I)(1:3).EQ.'DEE').OR.
     5            (HIST(I)(1:3).EQ.'AEE').OR.
     6            (HIST(I)(1:3).EQ.'BEA').OR.
     7            (HIST(I)(1:3).EQ.'TEA').OR.
     8            (HIST(I)(1:3).EQ.'SEA').OR.
     9            (HIST(I)(1:3).EQ.'AEA').OR.
     1            (HIST(I)(1:3).EQ.'BEP').OR.
     2            (HIST(I)(1:3).EQ.'TEP').OR.
     3            (HIST(I)(1:3).EQ.'SEP').OR.
     4            (HIST(I)(1:3).EQ.'AEP').OR.
     5            (HIST(I)(1:3).EQ.'TEB').OR.
     6            (HIST(I)(1:3).EQ.'BEY').OR.
     7            (HIST(I)(1:3).EQ.'TEY').OR.
     8            (HIST(I)(1:3).EQ.'SEY').OR.
     9            (HIST(I)(1:3).EQ.'AEY').OR.
     1            (HIST(I)(1:3).EQ.'DEY').OR.
     2            (HIST(I)(1:3).EQ.'XCY').OR.
     3            (HIST(I)(1:3).EQ.'XKY').OR.
     4            (HIST(I)(1:3).EQ.'XRY').OR.
     5            (HIST(I)(1:3).EQ.'XCS').OR.
     6            (HIST(I)(1:3).EQ.'XKS').OR.
     7            (HIST(I)(1:3).EQ.'XRS').OR.
     8            (HIST(I)(1:3).EQ.'BEL').OR.
     9            (HIST(I)(1:3).EQ.'BEH').OR.
     1            (HIST(I)(1:3).EQ.'IOV').OR.
     2            (HIST(I)(1:3).EQ.'IOL')) THEN
            NDIM=1
         ELSE IF ((HIST(I)(1:3).EQ.'BEW').OR.
     1            (HIST(I)(1:3).EQ.'TEW').OR.
     2            (HIST(I)(1:3).EQ.'SEW').OR.
     3            (HIST(I)(1:3).EQ.'AEW').OR.
     4            (HIST(I)(1:3).EQ.'BER').OR.
     5            (HIST(I)(1:3).EQ.'IO2')) THEN
            NDIM=2
         ELSE IF ((HIST(I)(1:3).EQ.'BED').OR.
     1            (HIST(I)(1:3).EQ.'TED').OR.
     2            (HIST(I)(1:3).EQ.'SED').OR.
     3            (HIST(I)(1:3).EQ.'IO3')) THEN
            NDIM=3
         ELSE
            GOTO 150
         ENDIF
         NHIST=NHIST+1
         NSTUETZ=GETHIS(NDIM,NHISINT,NSCPOS,MXCONT,HIST(I))
         NVTOT=NVTOT+NSTUETZ
         IF ((HIST(I)(1:3).EQ.'XCY').OR.
     1       (HIST(I)(1:3).EQ.'XKY').OR.
     1       (HIST(I)(1:3).EQ.'XRY')) THEN
            NEEDXCHAR=.TRUE.
            CALL GETTAB(
     I                  0,2,2,HIST(I),
     I                  N1STELE,CEABR,NDMAELEM,ATNUM,
     O                  NE,NS,NL,IELEM,ISH,ISHDEF,IXC,IERROR)
            IF (HIST(I)(1:3).EQ.'XRY') LXPTOB = .TRUE.
            IF (HIST(I)(1:3).EQ.'XKY') LXPTOB = .TRUE.
CS         ELSE IF (HIST(I)(1:3).EQ.'XKY') THEN
CS            LXPTOB = .TRUE.
         ELSE IF ((HIST(I)(1:3).EQ.'IOV').OR.
     1            (HIST(I)(1:3).EQ.'IOL').OR.
     2            (HIST(I)(1:3).EQ.'IO2').OR.
     3            (HIST(I)(1:3).EQ.'IO3')) THEN
            CALL GETTAB(
     I                  1,1,2,HIST(I),
     I                  N1STELE,CEABR,NDMAELEM,ATNUM,
     O                  NE,NS,NL,IELEM,ISH,ISHDEF,IXC,IERROR)
         ELSE IF ((HIST(I)(1:3).EQ.'XKS').OR.
     &            (SCREEN(I)(1:3).EQ.'XRS')) THEN
               NHISXCONT=MAX(NHISXCONT,NSTUETZ)
               LXCONT = .TRUE.
         ELSE IF (HIST(I)(1:3).EQ.'AES') THEN
            IF (.NOT.AESALREADY) THEN
               NHIST=NHIST+1
               NVTOT=NVTOT+50
               AESALREADY=.TRUE.
            ENDIF
         ELSE IF (HIST(I)(1:3).EQ.'AEY') THEN
*           EXTRACT INFORMATION NEEDED TO DETERMINE NSHELL 
            CDUMMY=HIST(I)
            CALL FIND(CDUMMY,';',4,70,ISEMI,IFND)
            IF (IFND.NE.0) THEN
               IS=ISEMI+1
               CALL FIND(CDUMMY,';',IS,70,ISEMI,IFND)
               IF (IFND.NE.0) THEN
                  IS=ISEMI+1
                  CALL FIND(CDUMMY,',',IS,70,ICOM,IFND)
                  IF (IFND.NE.0) THEN
                     CDUMMY(ICOM+2:ICOM+2)=' '
                     CALL GETTAB(
     I                           1,1,2,CDUMMY,
     I                           N1STELE,CEABR,NDMAELEM,ATNUM,
     O                           NE,NS,NL,IELEM,ISH,ISHDEF,IXC,
     O                           IERROR)
                  ELSE
                     WRITE(6,'(A)')'               '
                     WRITE(6,'(A)')' *** ERROR ***'
                     WRITE(6,'(2A)')'     CHKOUT: Auger line not',
     &                              ' properly specified!'
                     WRITE(6,'(A)')'     SeSAME stops here!'
                     STOP
                  ENDIF
               ELSE
                  WRITE(6,'(A)')'               '
                  WRITE(6,'(A)')' *** ERROR ***'
                  WRITE(6,'(2A)')'     CHKOUT: Auger line not',
     &                           ' properly specified!'
                  WRITE(6,'(A)')'     SeSAME stops here!'
                  STOP
               ENDIF
            ELSE
               WRITE(6,'(A)')'               '
               WRITE(6,'(A)')' *** ERROR ***'
               WRITE(6,'(2A)')'     CHKOUT: Auger line not',
     &                        ' properly specified!'
               WRITE(6,'(A)')'     SeSAME stops here!'
               STOP
            ENDIF
         ENDIF
 150  CONTINUE

*     ---PARSE INFORMATION FROM ION ARRAY
      DO 210 I=1,MAXELE
         IF (ION(I)(1:3).NE.'   ') THEN
            CDUMMY=CBL//CBL//CBL//CBL//CBL//CBL//CBL
            CDUMMY(4:4)=';'
            CDUMMY(5:44)=ION(I)
            CALL GETTAB(
     I                  1,1,1,CDUMMY,
     I                  N1STELE,CEABR,NDMAELEM,ATNUM,
     O                  NE,NS,NL,IELEM,ISH,ISHDEF,IXC,IERROR)
         ENDIF
 210  CONTINUE

*     ---PARSE INFORMATION FROM XCHAR ARRAY
      DO 230 I=1,MAXELE
         IF (XCHAR(I)(1:3).NE.'   ') THEN
            CDUMMY=CBL//CBL//CBL//CBL//CBL//CBL//CBL
            CDUMMY(4:4)=';'
            CDUMMY(5:54)=XCHAR(I)
            CALL GETTAB(
     I                  1,2,1,CDUMMY,
     I                  N1STELE,CEABR,NDMAELEM,ATNUM,
     O                  NE,NS,NL,IELEM,ISH,ISHDEF,IXC,IERROR)
         ENDIF
 230  CONTINUE

      IF (LTEST) THEN
         WRITE(6,'(A)')' BEFOR RANGE CHECKING:'
         WRITE(6,'(A)')' CHKOUT: shells:'
         DO 480 I=1,NE
            DO 470 J=1,MAXSHELL
               IF (ISH(I,J).GT.0) THEN
                  WRITE(6,'(3I7)')I,IELEM(I),J
               ENDIF
 470        CONTINUE
 480     CONTINUE
         WRITE(6,'(A)')' CHKOUT: lines:'
         DO 430 I=1,NE
            DO 410 J=1,MAXXCHAR
               IF (IXC(I,J).GT.0) THEN
                  WRITE(6,'(3I7)')I,IELEM(I),J
               ENDIF
 410        CONTINUE
 430     CONTINUE
      ENDIF

      NSHELL=0
      NXCHAR=0
      DO 530 I=1,NE
         DO 520 J=1,MAXXCHAR
            IF (IXC(I,J).EQ.1) THEN
               IF ((IELEM(I).LT.ECLIM(J,1)).OR.
     &             (IELEM(I).GT.ECLIM(J,2))) THEN
                  IXC(I,J)=0
                  IF ((J.EQ.1).OR.(J.EQ.2).OR.(J.EQ.3)) THEN
                     IF (ISHDEF(I,1).EQ.0) ISH(I,1)=ISH(I,1)-1
                  ENDIF
                  IF ((J.EQ.4).OR.(J.EQ.5).OR.(J.EQ.7)) THEN
                     IF (ISHDEF(I,4).EQ.0) ISH(I,4)=ISH(I,4)-1
                  ENDIF
                  IF (J.EQ.6) THEN
                     IF (ISHDEF(I,3).EQ.0) ISH(I,3)=ISH(I,3)-1
                  ENDIF
                  IF (J.EQ.8) THEN
                     IF (ISHDEF(I,2).EQ.0) ISH(I,2)=ISH(I,2)-1
                  ENDIF
                  IF (J.EQ.9) THEN
                     IF (ISHDEF(I,9).EQ.0) ISH(I,9)=ISH(I,9)-1
                  ENDIF
                  IF (J.EQ.10) THEN
                     IF (ISHDEF(I,8).EQ.0) ISH(I,8)=ISH(I,8)-1
                  ENDIF
               ENDIF
               IF (IXC(I,J).GT.0) THEN
*                 CHECK WETHER CORRESPONDING CRITICAL ENERGY IS SMALLER
*                 THAN E0 OR NOT - IF SMALLER THEN SET IXC TO ZERO
                  IF ((J.EQ.1).OR.(J.EQ.2).OR.(J.EQ.3)) THEN
                     CALL GETED(2,1,IELEM(I),EC,IERR)
                  ELSE IF ((J.EQ.4).OR.(J.EQ.5).OR.(J.EQ.7)) THEN
                     CALL GETED(2,4,IELEM(I),EC,IERR)
                  ELSE IF (J.EQ.6) THEN
                     CALL GETED(2,3,IELEM(I),EC,IERR)
                  ELSE IF (J.EQ.8) THEN
                     CALL GETED(2,2,IELEM(I),EC,IERR)
                  ELSE IF (J.EQ.9) THEN
                     CALL GETED(2,9,IELEM(I),EC,IERR)
                  ELSE IF (J.EQ.10) THEN
                     CALL GETED(2,8,IELEM(I),EC,IERR)
                  ENDIF
                  IF (IERR.EQ.0) THEN
                     IF (EC.GT.E0) IXC(I,J)=0
                  ENDIF
               ENDIF
            ENDIF
 520     CONTINUE
 530  CONTINUE
      DO 550 I=1,NE
         DO 540 J=1,MAXSHELL
            IF (ISH(I,J).GT.0) THEN
               IF ((IELEM(I).LT.EDLIM(J,1)).OR.
     &             (IELEM(I).GT.EDLIM(J,2))) THEN
*                 NO CRITICAL ENERGY AVAILABLE
                  IF (ISHDEF(I,J).EQ.1) THEN
*                    SHELL WAS EXPLICITELY SPECIFIED
                     ISH(I,J)=0
                  ELSE
*                    SHELL WAS SPECIFIED VIA AN X-RAY LINE
*                    BUT CORRESPONDING SHELL IS NOT VALID
*                    -> DELETE THE X-RAY LINE TOO
                     ISH(I,J)=0
                     IF (J.EQ.1) THEN
                        IXC(I,1)=0
                        IXC(I,2)=0
                        IXC(I,3)=0
                     ENDIF
                     IF (J.EQ.2) THEN
                        IXC(I,8)=0
                     ENDIF
                     IF (J.EQ.3) THEN
                        IXC(I,6)=0
                     ENDIF
                     IF (J.EQ.4) THEN
                        IXC(I,4)=0
                        IXC(I,5)=0
                        IXC(I,7)=0
                     ENDIF
                     IF (J.EQ.8) THEN
                        IXC(I,10)=0
                     ENDIF
                     IF (J.EQ.9) THEN
                        IXC(I,9)=0
                     ENDIF
                  ENDIF
               ENDIF
               IF (ISH(I,J).GT.0) THEN
*                 IF ISH STILL > 0 THEN CHECK WETHER CRITICAL ENERGY
*                 IS SMALLER THAN E0
*                 GET CRITICAL ENERGY
                  CALL GETED(2,J,IELEM(I),EC,IERR)
                  IF (IERR.EQ.0) THEN
                     IF (EC.GT.E0) ISH(I,J)=0
                  ENDIF
               ENDIF
            ENDIF
 540     CONTINUE
 550  CONTINUE
      DO 630 I=1,NE
         DO 610 J=1,MAXSHELL
            IF (ISH(I,J).GT.0) NSHELL=NSHELL+1
 610     CONTINUE
         DO 620 J=1,MAXXCHAR
            IF (IXC(I,J).GT.0) THEN
               NXCHAR=NXCHAR+1
               CALL GETEC(J,IELEM(I),EXC(I,J),IERR)
            ENDIF
 620     CONTINUE
 630  CONTINUE

      NXPTOB=NXCHAR
      DO 670 I=1,NE
         DO 660 J=1,MAXXCHAR
            DO 650 K=J+1,MAXXCHAR
               IF ((IXC(I,J).GT.0).AND.(IXC(I,K).GT.0)) THEN
                  IF (EXC(I,J).EQ.EXC(I,K)) THEN
                     IXC(I,K)=-1
                     NXPTOB=NXPTOB-1
                  ENDIF
               ENDIF
 650        CONTINUE
 660     CONTINUE
 670  CONTINUE

      IF (LTEST) THEN
         WRITE(6,'(A)')' AFTER RANGE CHECKING:'
         WRITE(6,'(A)')' CHKOUT: shells:'
         DO 780 I=1,NE
            DO 770 J=1,MAXSHELL
               IF (ISH(I,J).GT.0) THEN
                  WRITE(6,'(3I7)')I,IELEM(I),J
               ENDIF
 770        CONTINUE
 780     CONTINUE
         WRITE(6,'(A)')' CHKOUT: lines:'
         DO 730 I=1,NE
            DO 710 J=1,MAXXCHAR
               IF (IXC(I,J).NE.0) THEN
                  WRITE(6,'(3I7)')I,IELEM(I),J
               ENDIF
 710        CONTINUE
 730     CONTINUE
      ENDIF

      IF (NEEDXCHAR.AND.(NXCHAR.LE.0)) THEN
         WRITE(6,'(A)')'   '
         WRITE(6,'(A)')' ***ERROR***'
         WRITE(6,'(2A)')' CHKOUT: No x-ray line specified (or:',
     &                  ' misspelled/not in sample) !'
         WRITE(6,'(2A)')' At least one valid x-ray line must be',
     &                  ' specified in this particular case !'
         WRITE(6,'(A)')' Check the "Options" menu in the GUI !'
         WRITE(6,'(A)')' PRESS <RETURN> TO CONTINUE (STOP) !'
         READ(6,*)
         STOP
      ENDIF

      RETURN
      END

****************************************************************************
* last modification: CS 17-Oct-1996

      INTEGER FUNCTION GETHIS (NDIM,NHISINT,NSCPOS,MXCONT,STRING)

*     GETHIS - GETHIS GETS HISTOGRAM INFORMATION (NUMBER OF HISTOGRAM
*              INTERVALS) NEEDED TO DETERMINE NVTOT. THIS INFORMATION
*              IS NEEDED FOR THE DYNAMIC MEMORY ALLOCATION.
*
*     NDIM    - HISTOGRAM DIMENSION (1,2 OR 3)
*     NHISINT - DEFAULT VALUE FOR NUMBER OF INTERVALS
*     NSCPOS  - NUMBER OF SCAN POSITIONS
*     MXCONT  - NUMBER OF X-RAY SPRECTRUM CHANNELS FOR HISTOGRAM OUTPUT
*     STRING  - STRING (SCREEN, POST, HIST, OR PMSAV)
*
*     AUTHOR: CHRISTIAN SCHIEBL
*             CONSULTANT (FORMER: CEC-VIENNA)
*             KREMS, OCTOBER 1996

      INCLUDE 'TYPE.INC'

      CHARACTER*70 STRING
      LOGICAL LSTOP,LREAD

**    START OF EXECUTABLE CODE
*     ************************

*     ---SOME INITIALIZATION
      NREAD=0
      NVALUE=1
      LSTOP=.FALSE.
      LREAD=.FALSE.

*     ---DETERMINE DEFAULT VALUE FOR GETHIS
      NDEF=NHISINT
      IF (STRING(3:3).EQ.'Y') NDEF=NSCPOS
      IF (STRING(1:3).EQ.'XKS') NDEF=MXCONT
      IF (STRING(1:3).EQ.'XRS') NDEF=MXCONT
      GETHIS=NDEF**NDIM
      IF (STRING(4:4).EQ.';') GOTO 999

*     ---EVALUATE WHETHER OTHER THAN DEFAULT VALUES ARE SPECIFIED IN STRING
*     IF 4TH POSITION IN STRING IS NO ',' THEN NO VALUES ARE SPECIFIED IN
*     STRING (-> TAKE DEFAULT VALUE)
      IF (STRING(4:4).NE.',') GOTO 999
*     NUMBER OF COMMAS: (PRESENTLY ONE AT POSTITION 4)
      NCOMMA=1
*     CHECK FOR NEXT ',' OR ';'
      IS=4
      JSTART=5
      JEND=IEND(STRING)
 100  CALL FIND(STRING,';',JSTART,JEND,IP1,IFND1)
      CALL FIND(STRING,',',JSTART,JEND,IP2,IFND2)
      IF ((IFND1.EQ.1).AND.(IFND2.EQ.1)) THEN
*        FOUND A COMMA AND A SEMICOLON IN STRING
         IF (IP1.GT.IP2) THEN
*           NEXT IS A COMMA
            IE=IP2
            NCOMMA=NCOMMA+1
            IF ((NCOMMA.EQ.2).OR.(NCOMMA.EQ.5).OR.(NCOMMA.EQ.8)) THEN
*              RELEVANT VALUE BETWEEN LAST COMMA AND SEMICOLON (HOPEFULLY!)
               LREAD=.TRUE.
            ENDIF
         ELSE IF (IP1.LT.IP2) THEN
*           NEXT IS A SEMICOLON
            IE=IP1
            LSTOP=.TRUE.
            IF ((NCOMMA.EQ.1).OR.(NCOMMA.EQ.4).OR.(NCOMMA.EQ.7)) THEN
*              RELEVANT VALUE BETWEEN LAST COMMA AND SEMICOLON (HOPEFULLY!)
               LREAD=.TRUE.
            ENDIF
         ELSE
            WRITE(6,'(A)')'   '
            WRITE(6,'(A)')' ***WARNING'
            WRITE(6,'(A)')'    GETHIS [1]: SOMETHING WRONG !'
         ENDIF
      ELSE IF ((IFND1.EQ.1).AND.(IFND2.NE.1)) THEN
*        FOUND A SIMICOLON BUT NO COMMA
         IE=IP1
         LSTOP=.TRUE.
         IF ((NCOMMA.EQ.1).OR.(NCOMMA.EQ.4).OR.(NCOMMA.EQ.7)) THEN
*           RELEVANT VALUE BETWEEN LAST COMMA AND SEMICOLON (HOPEFULLY!)
            LREAD=.TRUE.
         ENDIF
      ELSE IF ((IFND1.NE.1).AND.(IFND2.EQ.1)) THEN
*        FOUND A COMMA BUT NO SEMICOLON
         IE=IP2
         NCOMMA=NCOMMA+1
         IF ((NCOMMA.EQ.2).OR.(NCOMMA.EQ.5).OR.(NCOMMA.EQ.8)) THEN
*           RELEVANT VALUE BETWEEN LAST COMMA AND SEMICOLON (HOPEFULLY!)
            LREAD=.TRUE.
         ENDIF
      ELSE
*        FOUND NEITHER A COMMA NOR A SEMICOLON 
         IE=JEND+1
*        THERE COULD BE SOMETHING SPECIFIED BETWEEN LAST COMMA AND END OF 
*        STRING; TRY TO READ THIS (COULD BE THE NUMBER OF INTERVALS 
*        FOR ONE AXIS) IN CASE IT IS SPECIFIED AFTER A VALID NUMBER
*        OF PRE-COMMAS
         IF ((NCOMMA.EQ.1).OR.(NCOMMA.EQ.4).OR.(NCOMMA.EQ.7)) THEN
*           RELEVANT VALUE BETWEEN LAST COMMA AND END OF STRING (HOPEFULLY!)
            LREAD=.TRUE.
         ENDIF
         LSTOP=.TRUE.
      ENDIF

      IF (LREAD) THEN
         IF ((IE-IS).GT.1) THEN
*           SOMETHING SPECIFIED - TRY TO READ IT
            READ(STRING(IS+1:IE-1),*,ERR=800) NINTV
*           IF NO VALID VALUE TAKE DEFAULT VALUE
            IF (NINTV.GT.0) THEN
               NREAD=NREAD+1
               IF (NDIM.GE.NREAD) THEN
                  NVALUE=NVALUE*NINTV
               ENDIF
            ENDIF
         ENDIF
 800     LREAD=.FALSE.
      ENDIF

      IF (LSTOP) THEN
         GETHIS=NVALUE*NDEF**(NDIM-NREAD)
      ELSE
         IS=IE
         JSTART=IE+1
         GOTO 100
      ENDIF


 999  RETURN
      END

*****************************************************************************
* last modification: CS 29-Apr-1997

      SUBROUTINE GETTAB (
     I                   IFLAG,ITAB,ISEMI,STRING,
     I                   N1STELE,CEABR,NELEM,ATNUM,
     O                   NE,NS,NL,IEL,ISH,ISHDEF,IXC,IERR)

*     GETTAB - GETTAB GETS TABLE INFORMATION (NUMBER OF SHELLS AND
*              LINES) NEEDED TO DETERMINE NSHELL AND NXCHAR. THIS 
*              INFORMATION IS NEEDED FOR THE DYNAMIC MEMORY ALLOCATION.
*
*     IFLAG  - 0: SHELL/LINE INFO OPTIONAL
*              1: SHELL/LINE INFO REQUIRED
*     ITAB   - 1: SHELL, 2: LINE
*     ISEMI  - SEMICOLON IN STRING WHERE RELEVANT SUBSTRING STARTS
*     STRING - STRING (SCREEN, POST, HIST, OR PMSAV)
*     N1STELE- FIRST ELEMENT IN ATMAT(1)
*     CEABR  - CHEMICAL ABBREVIATION OF FIRST ELEMENT
*     ATNUM  - ARRAY CONTAINING ALL ELEMENTS SPECIFIED
*     NE     - NUMBER OF ELEMENTS
*     NS     - NUMBER OF SHELLS
*     NL     - NUMBER OF LINES
*     IEL    - ATOMIC NUMBER(S) OF ELEMENTS
*     ISH    - SHELL NUMBERS
*     ISHDEF - IS 1 IF SHELL WAS EXPLICITELY SPECIFIED (NOT VIA AN X-LINE)
*     IXC    - LINE NUMBERS
*     IERR   - ERROR FLAG (0=OK)
*
*     AUTHOR: CHRISTIAN SCHIEBL
*             CONSULTANT (FORMER: CEC-VIENNA)
*             KREMS, OCTOBER 1996

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'

      INTEGER IEL(MAXELE)
      INTEGER ISH(MAXELE,MAXSHELL)
      INTEGER ISHDEF(MAXELE,MAXSHELL)
      INTEGER IXC(MAXELE,MAXXCHAR)
      INTEGER ISHELL(MAXSHELL),ISHELLDEF(MAXSHELL),IXCHAR(MAXXCHAR)
      DOUBLE PRECISION ATNUM(MAXELE)
      CHARACTER*2  CEABR,C2
      CHARACTER*3  CVAL
      CHARACTER*70 STRING,BUFFER,CDUMMY
      CHARACTER*10 CBL

**    START OF EXECUTABLE CODE
*     ************************

      IERR=0
      CBL='          '
      BUFFER=CBL//CBL//CBL//CBL//CBL//CBL//CBL
      CDUMMY=CBL//CBL//CBL//CBL//CBL//CBL//CBL

*     FIND SEMI'S SEMICOLON
      ICOUNT=0
      JSTART=4
      JEND=70
 10   CALL FIND(STRING,';',JSTART,JEND,IPOS,IFND)
      IF (IFND.EQ.1) THEN
         ICOUNT=ICOUNT+1
         JSTART=IPOS+1
         IF (ICOUNT.LT.ISEMI) GOTO 10
      ENDIF
*     IF, ALTHOUGH SEMICOLON PRESENT, NO SUBSTRING SPECIFIED, TAKE DEFAULT
      IF ((JEND-JSTART).LE.1) ICOUNT=0
      IF (ICOUNT.EQ.ISEMI) THEN
*        FOUND POSITION OF ISEMI'S SEMICOLON
*        FIND END OF RELEVANT SUBSTRING
         CALL FIND(STRING,';',JSTART,JEND,IPOS,IFND)
         IF (IFND.EQ.1) THEN
            JEND=IPOS-1
         ELSE
            JEND=IEND(STRING)
         ENDIF
         BUFFER(1:JEND-JSTART+1)=STRING(JSTART:JEND)
      ELSE IF (ICOUNT.LT.ISEMI) THEN
*        THERE IS NO ISEMI'S SEMICOLON
*        IT IS ASSUMED THAT 1ST ELEMENT AND K-SHELL (K-ALPHA 1,2 LINE)
*        WERE MEANT TO BE SPECIFIED
         BUFFER(1:2)=CEABR(1:2)
         J=3
         IF(BUFFER(2:2).EQ.' ') J=2
         BUFFER(J:J)=','
         J=J+1
         BUFFER(J:J)='K'
         IF (ITAB.EQ.2) THEN
            J=J+1
            BUFFER(J:J)='A'
         ENDIF
      ELSE
*        THERE IS SOMETHING FUNDAMENTALLY WRONG
         WRITE(6,'(A)')'       '
         WRITE(6,'(A)')' *** WARNING ***'
         WRITE(6,'(A)')'     GETTAB: FUNDAMENTAL PARSING ERROR'
         WRITE(6,'(A)')'     MAY CAUSE PROBLEMS FOR MEMORY ALLOCATION'
         IERR=2
         GOTO 999
      ENDIF

*     EVALUATE INFORMATION IN BUFFER
*     EXTRACT ELEMENT INFORMATION
      CALL CCAP(BUFFER,70)
      IF ((BUFFER(1:3).EQ.'ALL').OR.
     &    (BUFFER(1:1).EQ.'*')) THEN
*        TAKE ALL ELEMENTS
         NELE=0
         DO 30 I=1,NELEM
            JFLAG=0
            DO 20 J=1,MAXELE
               IF (IEL(J).EQ.INT(ATNUM(I)+0.25)) THEN
*                 ELEMENT IS ALREADY IN TABLE
                  JFLAG=1
               ENDIF
 20         CONTINUE
            IF (JFLAG.NE.1) THEN
               NE=NE+1
               IEL(NE)=INT(ATNUM(I)+0.25)
            ENDIF
 30      CONTINUE
      ELSE
         C2='  '
         CDUMMY(1:1)=BUFFER(1:1)
         IF (BUFFER(2:2).NE.',') THEN
            CDUMMY(2:2)=BUFFER(2:2)
         ENDIF
         CALL ELMENT(1,CDUMMY,NELE,C2,FRM,FDENS,IERR)
         IF ((IERR.LT.0).AND.(IFLAG.EQ.1)) THEN
*           ELEMENT NOT FOUND
            WRITE(6,'(A)')'   '
            WRITE(6,'(A)')' ***ERROR***'
            WRITE(6,'(A)')' GETTAB: Element not found !'
            WRITE(6,'(2A)')' Probably misspelled or forgotten',
     &                     ' to specify !'
            WRITE(6,'(A)')' STRING:'
            WRITE(6,'(2A)')' ',STRING
            WRITE(6,'(A)')' PRESS <RETURN> TO CONTINUE (STOP) !'
            READ(6,*)
            STOP
         ENDIF
         JFLAG=0
         DO 35 I=1,NELEM
            IF (NELE.EQ.INT(ATNUM(I)+0.25)) JFLAG=1
 35      CONTINUE
         IF ((JFLAG.EQ.0).AND.(IFLAG.EQ.1)) THEN
            WRITE(6,'(A)')'   '
            WRITE(6,'(A)')' ***ERROR***'
            WRITE(6,'(A)')' GETTAB: Specified element not in sample !'
            WRITE(6,'(A)')' STRING:'
            WRITE(6,'(2A)')' ',STRING
            WRITE(6,'(A)')' PRESS <RETURN> TO CONTINUE (STOP) !'
            READ(6,*)
            STOP
         ENDIF
         JFLAG=0
         DO 40 I=1,NELEM
            IF (IEL(I).EQ.NELE) THEN
*              NELE IS ALREADY IN ELEMENT TABLE
               JFLAG=1
            ENDIF
 40      CONTINUE
         IF (JFLAG.NE.1) THEN
*           ADD IT TO THE TABLE
            NE=NE+1
            IEL(NE)=NELE
         ENDIF
      ENDIF

*     EXTRACT SHELL/LINE INFORMATION
      IEOBUFF=IEND(BUFFER)
      CALL FIND(BUFFER,',',1,IEOBUFF,ICOM,IFND)
      IF (IFND.EQ.1) THEN
*        FOUND A COMMA
         IS=ICOM+1
 50      CALL FIND(BUFFER,',',IS,IEOBUFF,ICOM,IFND)
         IF (IFND.EQ.1) THEN
*           FOUND ANOTHER COMMA
            IE=ICOM-1
         ELSE
            IE=IEOBUFF
         ENDIF
         CVAL='   '
         CVAL=BUFFER(IS:IE)
         DO 55 I=1,MAXSHELL
            ISHELL(I)=0
            ISHELLDEF(I)=0
 55      CONTINUE
         DO 60 I=1,MAXXCHAR
            IXCHAR(I)=0
 60      CONTINUE
         IF (ITAB.EQ.1) THEN
*           SHELL SPECIFIED
            IF ((CVAL.EQ.'ALL').OR.(CVAL(1:1).EQ.'*')) THEN
*              ALL SHELLS OF SPECIFIED ELEMENT(S)
               DO 70 I=1,9
                  ISHELL(I)=1
                  ISHELLDEF(I)=1
 70            CONTINUE
            ELSE IF (CVAL(1:1).EQ.'K') THEN
*              K-SHELL SPECIFIED
               ISHELL(1)=1
               ISHELLDEF(1)=1
            ELSE IF (CVAL(1:1).EQ.'L') THEN
*              L-SHELL SPECIFIED
               IF (CVAL(2:2).EQ.'1') THEN
*                 L1-SUBSHELL SPECIFIED
                  ISHELL(2)=1
                  ISHELLDEF(2)=1
               ELSE IF (CVAL(2:2).EQ.'2') THEN
*                 L2-SUBSHELL SPECIFIED
                  ISHELL(3)=1
                  ISHELLDEF(3)=1
               ELSE IF (CVAL(2:2).EQ.'3') THEN
*                 L3-SUBSHELL SPECIFIED
                  ISHELL(4)=1
                  ISHELLDEF(4)=1
               ELSE IF (CVAL(2:2).EQ.' ') THEN
*                 L1, L2 AND L3 SUBSHELL SPECIFIED
                  ISHELL(2)=1
                  ISHELL(3)=1
                  ISHELL(4)=1
                  ISHELLDEF(2)=1
                  ISHELLDEF(3)=1
                  ISHELLDEF(4)=1
               ENDIF
            ELSE IF (CVAL(1:1).EQ.'M') THEN
*              M-SHELL SPECIFIED
               IF (CVAL(2:2).EQ.'1') THEN
*                 M1-SUBSHELL SPECIFIED
                  ISHELL(5)=1
                  ISHELL(5)=1
               ELSE IF (CVAL(2:2).EQ.'2') THEN
*                 M2-SUBSHELL SPECIFIED
                  ISHELL(6)=1
                  ISHELL(6)=1
               ELSE IF (CVAL(2:2).EQ.'3') THEN
*                 M3-SUBSHELL SPECIFIED
                  ISHELL(7)=1
                  ISHELL(7)=1
               ELSE IF (CVAL(2:2).EQ.'4') THEN
*                 M4-SUBSHELL SPECIFIED
                  ISHELL(8)=1
                  ISHELL(8)=1
               ELSE IF (CVAL(2:2).EQ.'5') THEN
*                 M5-SUBSHELL SPECIFIED
                  ISHELL(9)=1
                  ISHELL(9)=1
               ELSE IF (CVAL(2:2).EQ.' ') THEN
*                 M1, M2, M3, M4 AND M5 SUBSHELL SPECIFIED
                  ISHELL(5)=1
                  ISHELL(6)=1
                  ISHELL(7)=1
                  ISHELL(8)=1
                  ISHELL(9)=1
                  ISHELLDEF(5)=1
                  ISHELLDEF(6)=1
                  ISHELLDEF(7)=1
                  ISHELLDEF(8)=1
                  ISHELLDEF(9)=1
               ENDIF
            ENDIF
         ELSE IF (ITAB.EQ.2) THEN
*           CHARACTERISTIC X-RAYS SPECIFIED
            IF ((CVAL.EQ.'ALL').OR.(CVAL(1:1).EQ.'*')) THEN
*              ALL LINES OF SPECIFIED ELEMENT(S)
               DO 80 I=1,10
                  IXCHAR(I)=1
 80            CONTINUE
               ISHELL(1)=3
               ISHELL(2)=1
               ISHELL(3)=1
               ISHELL(4)=3
               ISHELL(8)=1
               ISHELL(9)=1
            ELSE IF (CVAL(1:1).EQ.'K') THEN
*              K-LINE SPECIFIED
               IF (CVAL(2:2).EQ.' ') THEN
*                 K-ALPHA 1,2 AND K-BETA 1 SPECIFIED
                  IXCHAR(1)=1
                  IXCHAR(2)=1
                  IXCHAR(3)=1
                  ISHELL(1)=3
               ELSE IF (CVAL(2:2).EQ.'A')THEN
*                 K-ALPHA SPEDIFIED
                  IF (CVAL(3:3).EQ.' ') THEN
*                    K-ALPHA 1 AND 2 SPECIFIED
                     IXCHAR(1)=1
                     IXCHAR(2)=1
                     ISHELL(1)=2
                  ELSE IF (CVAL(3:3).EQ.'1') THEN
*                    K-ALPHA 1 SPECIFIED
                     IXCHAR(1)=1
                     ISHELL(1)=1
                  ELSE IF (CVAL(3:3).EQ.'2') THEN
*                    K-ALPHA 2 SPECIFIED
                     IXCHAR(2)=1
                     ISHELL(1)=1
                  ENDIF
               ELSE IF (CVAL(2:2).EQ.'B') THEN
*                 K-BETA 1 SPECIFIED
                  IXCHAR(3)=1
                  ISHELL(1)=1
               ENDIF
            ELSE IF (CVAL(1:1).EQ.'L') THEN
*              L-LINE SPECIFIED
               IF (CVAL(2:2).EQ.' ') THEN
*                 ALL L-LINES SPECIFIED
                  IXCHAR(4)=1
                  IXCHAR(5)=1
                  IXCHAR(6)=1
                  IXCHAR(7)=1
                  IXCHAR(8)=1
                  ISHELL(2)=1
                  ISHELL(3)=1
                  ISHELL(4)=3
               ELSE IF (CVAL(2:2).EQ.'A') THEN
*                 L-ALPHA SPECIFIED
                  IF (CVAL(3:3).EQ.' ') THEN
*                    L-ALPHA 1 AND 2 SPECIFIED
                     IXCHAR(4)=1
                     IXCHAR(5)=1
                     ISHELL(4)=2
                  ELSE IF (CVAL(3:3).EQ.'1') THEN
*                    L-ALPHA 1 SPECIFIED
                     IXCHAR(4)=1
                     ISHELL(4)=1
                  ELSE IF (CVAL(3:3).EQ.'2') THEN
*                    L-ALPHA 2 SPECIFIED
                     IXCHAR(5)=1
                     ISHELL(4)=1
                  ENDIF
               ELSE IF (CVAL(2:2).EQ.'B') THEN
*                 L-BETA SPECIFIED
                  IF (CVAL(3:3).EQ.' ') THEN
*                    L-BETA 1,2 AND 3 SPECIFIED
                     IXCHAR(6)=1
                     IXCHAR(7)=1
                     IXCHAR(8)=1
                     ISHELL(2)=1
                     ISHELL(3)=1
                     ISHELL(4)=1
                  ELSE IF (CVAL(3:3).EQ.'1') THEN
*                    L-BETA 1 SPECIFIED
                     IXCHAR(6)=1
                     ISHELL(3)=1
                  ELSE IF (CVAL(3:3).EQ.'2') THEN
*                    L-BETA 2 SPECIFIED
                     IXCHAR(7)=1
                     ISHELL(4)=1
                  ELSE IF (CVAL(3:3).EQ.'3') THEN
*                    L-BETA 3 SPECIFIED
                     IXCHAR(8)=1
                     ISHELL(2)=1
                  ENDIF
               ENDIF
            ELSE IF (CVAL(1:1).EQ.'M') THEN
*              M-LINE SPECIFIED
               IF (CVAL(2:2).EQ.' ') THEN
*                 M-ALPHA1,2 AND M-BETA1 SPECIFIED
                  IXCHAR(9)=1
                  IXCHAR(10)=1
                  ISHELL(9)=1
                  ISHELL(8)=1
               ELSE IF (CVAL(2:2).EQ.'A') THEN
*                 M-ALPHA1,2 SPECIFIED
                  IXCHAR(9)=1
                  ISHELL(9)=1
               ELSE IF (CVAL(2:2).EQ.'B') THEN
*                 M-BETA1 SPECIFIED
                  IXCHAR(10)=1
                  ISHELL(8)=1
               ENDIF
            ENDIF
         ENDIF
         IF (NELE.EQ.0) THEN
*           ALL ELEMENTS HAVE BEEN SPECIFIED
            DO 90 I=1,NE
               DO 85 J=1,MAXSHELL
                  IF (ISHELL(J).GT.0) THEN
                     ISH(I,J)=ISH(I,J)+ISHELL(J)
                     IF (ISHELLDEF(J).EQ.1) ISHDEF(I,J)=1
                  ENDIF
 85            CONTINUE
               DO 87 J=1,MAXXCHAR
                  IF (IXCHAR(J).EQ.1) THEN
                     IXC(I,J)=1
                  ENDIF
 87            CONTINUE
 90         CONTINUE
         ELSE IF ((NELE.GT.0).AND.(NELE.LE.100)) THEN
            DO 110 I=1,NE
               IF (IEL(I).EQ.NELE) THEN
                  DO 105 J=1,MAXSHELL
                     IF (ISHELL(J).GT.0) ISH(I,J)=ISH(I,J)+ISHELL(J)
                     IF (ISHELLDEF(J).EQ.1) ISHDEF(I,J)=1
 105              CONTINUE
                  DO 107 J=1,MAXXCHAR
                     IF (IXCHAR(J).EQ.1) IXC(I,J)=1
 107              CONTINUE
               ENDIF
 110        CONTINUE
         ELSE
            WRITE(6,'(A)')'   '
            WRITE(6,'(A)')' ***WARNING'
            WRITE(6,'(A)')'    GETTAB [1]: SOMETHING WRONG !'
         ENDIF
         IF (IE.LT.IEOBUFF) THEN
            IS=IE+2
            IF (IS.LE.IEOBUFF) GOTO 50
         ENDIF
      ELSE
*        FOUND NO SEMICOLON -> K-ALPHA1,2 AND/OR K-SHELL IS TAKEN
         IF (ITAB.EQ.1) THEN
            ISHELL(1)=1
            ISHELLDEF(1)=1
         ELSE IF (ITAB.EQ.2) THEN
            IXCHAR(1)=1
            IXCHAR(2)=1
            ISHELL(1)=2
         ELSE
            WRITE(6,'(A)')'   '
            WRITE(6,'(A)')' ***WARNING'
            WRITE(6,'(A)')'    GETTAB [2]: SOMETHING WRONG !'
         ENDIF
         IF (NELE.EQ.0) THEN
*           ALL ELEMENTS HAVE BEEN SPECIFIED
            DO 190 I=1,NE
               DO 185 J=1,MAXSHELL
                  IF (ISHELL(J).GT.0) ISH(I,J)=ISH(I,J)+ISHELL(J)
                  IF (ISHELLDEF(J).EQ.1) ISHDEF(I,J)=1
 185           CONTINUE
               DO 187 J=1,MAXXCHAR
                  IF (IXCHAR(J).EQ.1) IXC(I,J)=1
 187           CONTINUE
 190        CONTINUE
         ELSE IF ((NELE.GT.0).AND.(NELE.LE.NELEM)) THEN
            DO 210 I=1,NE
               IF (IEL(I).EQ.NELE) THEN
                  DO 205 J=1,MAXSHELL
                     IF (ISHELL(J).GT.0) ISH(I,J)=ISH(I,J)+ISHELL(J)
                     IF (ISHELLDEF(J).EQ.1) ISHDEF(I,J)=1
 205              CONTINUE
                  DO 207 J=1,MAXXCHAR
                     IF (IXCHAR(J).EQ.1) IXC(I,J)=1
 207              CONTINUE
               ENDIF
 210        CONTINUE
         ELSE
            WRITE(6,'(A)')'   '
            WRITE(6,'(A)')' ***WARNING'
            WRITE(6,'(A)')'    GETTAB [3]: SOMETHING COULD BE WRONG !'
         ENDIF
      ENDIF

 999  RETURN
      END
