c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
      SUBROUTINE ELDECT(
     I                  IEDT,
     I                  DIRX,DIRY,DIRZ,E,
     V                  FRAC)

***   DETECT - SIMULATES SIMPLE ELECTRON DETECTOR
*
*     IEDT     - ELECTRON DETECTOR NUMBER
*     DIRX     - X-DIRECTION OF ELECTRON
*     DIRY     - Y-DIRECTION OF ELECTRON
*     DIRZ     - Z-DIRECTION OF ELECTRON
*     E        - ELECTRON ENERGY
*     FRAC     - DETECTED FRACTION OF ELECTRON
*
**    AUTHOR:  H.WAGNER 16-JAN-1995
*
      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'

**    START OF EXECUTABLE CODE
*     ************************


*     TRANSFORM DIRECTION IN COORDINATE SYSTEM OF DETECTOR

      X = EDT(IEDT,1,1)*DIRX+EDT(IEDT,1,2)*DIRY+EDT(IEDT,1,3)*DIRZ
      Y = EDT(IEDT,2,1)*DIRX+EDT(IEDT,2,2)*DIRY+EDT(IEDT,2,3)*DIRZ
      Z = EDT(IEDT,3,1)*DIRX+EDT(IEDT,3,2)*DIRY+EDT(IEDT,3,3)*DIRZ

*     CALCULATE POLAR ANGLES

      IF (Z .GE. 1.) THEN 
         THETA = 0.
      ELSEIF (Z .LE. -1) THEN
         THETA = PI
      ELSE

        THETA = ACOS(-Z)

        IF (X .GT. 0) THEN
           PHI = ATAN(Y/X)
        ELSE

           IF (Y .GT. 0) THEN
              PHI = PI/2.
           ELSE
              PHI = 3*PI/2.
           ENDIF

        ENDIF

      ENDIF

C     ELECTRON ENTERS DETECTOR ??      
      IF (THETA.LT.DEDTHMN(IEDT).OR.THETA.GT.DEDTHMX(IEDT)) THEN
         FRAC = 0.
         GOTO 1000
      ENDIF       

C     ENERGY TRANSMISSION SPECIFIED ?
      IF (NEDTRN(IEDT) .EQ. 0) GOTO 1000

      DO 200, IENER=1,NEDTRN(IEDT)
          IF (EDTRN(IEDT,1,IENER).GT.E) GOTO 210
200   CONTINUE

C     ELECTRON ABOVE SPECIFIED TRANSMISSION ENERGY RANGE ?

      IF (E.GT.EDTRN(IEDT,1,NEDTRN(IEDT))) THEN
         FRAC = 0.
         GOTO 1000
      ENDIF
         
210   CONTINUE

C     ENERGY UNDER SPECIFIED TRANSMISSION ENERGY RANGE ?
      IF (IENER.EQ.1) THEN 
         FRAC = 0.
         GOTO 1000
      ENDIF

      ENER1 = EDTRN(IEDT,1,IENER-1)
      ENER2 = EDTRN(IEDT,1,IENER)
      TRAN1 = EDTRN(IEDT,2,IENER-1)
      TRAN2 = EDTRN(IEDT,2,IENER)
     
      TR = TRAN1 + (TRAN2-TRAN1)/(ENER2-ENER1)*(E-ENER1)

      FRAC = FRAC*TR

1000  CONTINUE
      END


