c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
* This file contains the following routines:
*
*     GETSIZ
*     SHOMEM
*     CHKMEM
*     SETBND
*     CHKBND
*
****************************************************************************
* last modification: CS 28-Apr-97

      SUBROUTINE GETSIZ(
     I                  FINPUT,NHISINT,EDLIMT,ECLIMT,
     V                  NQUADS,IER)

***   GETSIZ - DETERMINES THE SIZES OF THE ARRAYS WHICH WILL BE
*              DYNAMICALLY ALLOCATED AFTERWARDS
*
*     AUTHOR: CHRISTIAN SCHIEBL
*             CONSULTANT (FORMER: CEC-VIENNA)
*             KREMS, SEPTEMBER 1996

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      IMPLICIT INTEGER (I-N)

      INCLUDE 'PARAM.INC'
      INCLUDE 'DMA.INC'
      INCLUDE 'BOUND.INC'
      INCLUDE 'BREMS.INC'

      INTEGER GETNELEM,GETNEENER
      INTEGER EDLIMT(MAXSHELL,2),ECLIMT(MAXXCHAR,2)
      INTEGER EDLIM(MAXSHELL,2),ECLIM(MAXXCHAR,2)
      DOUBLE PRECISION ATNUM(MAXELE)
      CHARACTER*104 FINPUT
      CHARACTER*70 CDUMMY
      CHARACTER*80 BUFFER
      CHARACTER*10 CBL
      CHARACTER*2  CEABR
      CHARACTER*1  CHOIC
      LOGICAL LINSTR,LDETCT,LMYDEF,LAUTOGR,LGRID,LXCHAR

*     ---INIT NAMELIST:
*     STPBND IS ALSO A MEMBER OF THE &INIT NAMELIST 
*     BUT IS DECLARED IN BOUND.INC
      CHARACTER*70 CUSTXT,USEBK,FINSTR,FDETCT,FMYDEF
      CHARACTER*30 JOB
      CHARACTER*10 UNITS
      CHARACTER*3  TECHQU
      CHARACTER*2  SIGNAL(NSIG)
      LOGICAL LTEST

*     ---ETRNS NAMELIST
      INTEGER NETRN
      DOUBLE PRECISION E0,EF

*     ---EBEAM NAMELIST
      DOUBLE PRECISION ESTD,DIVERG,SPSIZE,ZFOCUS
      LOGICAL SCAN

*     ---TARGET NAMELIST
      INTEGER NREG
      DOUBLE PRECISION DENS(NRM)
      CHARACTER*70  ATMAT(MAXREG),CGFILE

*     ---MODEL NAMELIST
      CHARACTER*3 MODR(NRM),IONCRS,STOPP,BREMSCRS
      CHARACTER*40 ION(MAXELE)
      CHARACTER*50 XCHAR(MAXELE)
      CHARACTER*64 FAUGER
      CHARACTER*70 FMAT(MAXREG)
      INTEGER NAHISL,NAHISV,NXCONT
      DOUBLE PRECISION AUGMUL,AHISV
      LOGICAL LSECON,LAUG,LXRAY,LXCONT,LELATR,LPTOB

*     ---MSETUP NAMELIST
      DOUBLE PRECISION MAGNI,TAKOFF(0:MAXXDET),XDEROT(0:MAXXDET)
      DOUBLE PRECISION EBTILT,EBROT,XESPOT,XRANGE
      DOUBLE PRECISION EDPHI(0:MAXEDET),EDTHET(0:MAXEDET)
      DOUBLE PRECISION SCANANG,MTIME,CURREN

*     ---INSTR NAMELIST
      INTEGER NLSCP
      DOUBLE PRECISION XPCRT

*     ---DETECT NAMELIST
      CHARACTER*2  XDTYPE(0:MAXEDET)
      CHARACTER*70 FEDTRN(0:MAXEDET)
      CHARACTER*70 XFDEFF(0:MAXXDET),XLAYMAT(0:MAXXDET,MXDLAY)
      DOUBLE PRECISION EXCFAC
      DOUBLE PRECISION XLAYTH(0:MAXXDET,MXDLAY)
      DOUBLE PRECISION XLAYDN(0:MAXXDET,MXDLAY)
      DOUBLE PRECISION EDTHMN(0:MAXEDET),EDTHMX(0:MAXEDET)
      DOUBLE PRECISION SOLIDA(0:MAXXDET),FWHM(0:MAXXDET)
      DOUBLE PRECISION ENFWHM(0:MAXXDET)

*     ---OUTPUT NAMELIST
      INTEGER NXGRID,NYGRID,NZGRID
      CHARACTER*70 FETRBK,FPHI,FETAB,CGRDFL
      CHARACTER*70 SCREEN(0:2*MAXSCR),POST(3*MAXPST)
      CHARACTER*70 PMSAV(MAXSAV),HIST(MAXHIS)
      INTEGER NETRBK,NSCRUP,MINICOL,MAXICOL,MNCOLPAL
      LOGICAL LQUAD,LSCDEF,LSCRN,LSTATW,LGRAY,LGRD,LCOLTRJ,LEXCEED
*      LOGICAL LTEST


      NAMELIST /INIT/   CUSTXT,JOB,TECHQU,SIGNAL,USEBK,UNITS,
     +                  FINSTR,FDETCT,FMYDEF,LTEST,STPBND
      NAMELIST /ETRNS/  NETRN,E0,EF
      NAMELIST /EBEAM/  ESTD,DIVERG,SPSIZE,SCAN,ZFOCUS
      NAMELIST /TARGET/ DENS,NREG,CGFILE,ATMAT
      NAMELIST /MODEL/  MODR,ION,XCHAR,LSECON,LAUG,LXRAY,LXCONT,FAUGER,
     +		        AUGMUL,NAHISL,NAHISV,AHISV,FMAT,LELATR,IONCRS,
     +                  STOPP,BREMSCRS,LPTOB,NXCONT
      NAMELIST /MSETUP/ MAGNI,TAKOFF,XDEROT,EBTILT,EBROT,XESPOT,XRANGE,
     +                  EDPHI,EDTHET,SCANANG,MTIME,CURRENT
      NAMELIST /INSTR/  NLSCP,XPCRT
      NAMELIST /DETECT/ XFDEFF,XLAYTH,XLAYDN,XLAYMAT,
     +                  EDTHMN,EDTHMX,FEDTRN,SOLIDA,
     +                  FWHM,ENFWHM,XDTYPE,ESCFAC
      NAMELIST /OUTPUT/ NETRBK,NSCRUP,LQUAD,FETRBK,POST,SCREEN,PMSAV,
     +			HIST,FPHI,FETAB,LSCDEF,CGRDFL,LSCRN,LSTATW,
     +                  LGRAY,LGRID,MINICOL,MAXICOL,MNCOLPAL,
     +                  NXGRID,NYGRID,NZGRID,LCOLTRJ,LEXCEED,LTEST


      WRITE(6,'(A)')'   '
      WRITE(6,'(2A)')' READING INPUT FILE TO GET PARAMETERS FOR',
     &               ' DYNAMIC MEMORY ALLOCATION'

*     SOME INITIALIZATION:

      NDMAXGRID=0
      NDMAYGRID=0
      NDMAZGRID=0
      NDMASHELL=0
      NDMAXCHAR=0
      NDMAXCONT=0
      NDMAPTOB=0
      NDMAXDET=1
      NDMAEDET=1
      NDMAELEM=0
      NDMAREG=0
      NDMAHIST=0
      NDMAVHIS=0
      NDMASCRN=0
      NDMAPS=0
      NDMAPM=0
      NDMAEENER=0

      IER=0
      CHOIC='N'
      CBL='          '
      CGRDFL=CBL//CBL//CBL//CBL//CBL//CBL//CBL
      FINSTR(1:10)=CBL
      FDETCT(1:10)=CBL
      FMYDEF(1:10)=CBL
      LTEST=.FALSE.
      STPBND=.FALSE.
      LPTOB=.FALSE.
      LXCONT=.FALSE.
      LINSTR=.FALSE.
      LDETCT=.FALSE.
      LMYDEF=.FALSE.
      LGRD=.FALSE.
      NXCONT=0
      NBCKUP=24
      NAHISL=200
      NAHISV=10
      NXGRID=-1
      NYGRID=-1
      NZGRID=-1
      XTKDEF=-999
      XDRDEF=-999
      DO 3 I=0,MAXXDET
         XFDEFF(I)=CBL//CBL//CBL//CBL//CBL//CBL//CBL
         TAKOFF(I)=XTKDEF
         XDEROT(I)=XDRDEF
         SOLIDA(I)=0
 3    CONTINUE
      DO 4 I=0,MAXEDET
         FEDTRN(I)=CBL//CBL//CBL//CBL//CBL//CBL//CBL
         EDTHET(I)=XTKDEF
         EDPHI(I) =XDRDEF
         EDTHMN(I)=0
         EDTHMX(I)=0
 4    CONTINUE
      DO 5 I=1,MAXREG
         ATMAT(I)=CBL//CBL//CBL//CBL//CBL//CBL//CBL
 5    CONTINUE
      DO 7 I=0,2*MAXSCR
         SCREEN(I)=CBL//CBL//CBL//CBL//CBL//CBL//CBL
 7    CONTINUE
      DO 9 I=1,3*MAXPST
         POST(I)=CBL//CBL//CBL//CBL//CBL//CBL//CBL
 9    CONTINUE
      DO 11 I=1,MAXSAV
         PMSAV(I)=CBL//CBL//CBL//CBL//CBL//CBL//CBL
 11   CONTINUE
      DO 15 I=1,MAXHIS
         HIST(I)=CBL//CBL//CBL//CBL//CBL//CBL//CBL
 15   CONTINUE
      DO 18 I=1,MAXELE
         ION(I)=CBL//CBL//CBL//CBL
 18   CONTINUE
      DO 21 I=1,MAXELE
         XCHAR(I)=CBL//CBL//CBL//CBL//CBL
 21   CONTINUE

*     OPEN ACTUAL INPUT DECK FILE
      OPEN (11,FILE=FINPUT(1:IEND(FINPUT)),
     &         STATUS='OLD',FORM='FORMATTED',IOSTAT=IOS)
      IF (IOS.NE.0) THEN
         WRITE(6,'(A)')'        '
         WRITE(6,'(A)')' *** ERROR ***'
         WRITE(6,'(A)')'     COULD NOT OPEN INPUT FILE '
         WRITE(6,'(A)')'     WILL TERMINATE SeSAME'
         IER=1
         GOTO 899
      ENDIF
      USEBK(1:10)=CBL
      REWIND 11
      READ (11,INIT,END=903)
      IF (USEBK(1:10).NE.CBL) THEN
         IOS=0
*        A BACKUP FILE IS SPECIFIED IN THE CURRENT INPUT DECK
*        CLOSE CURRENT INPUT FILE
         CLOSE(11)
*        OPEN BACKUP FILE AND EXTRACT INPUT DECK FROM THERE
         OPEN (NBCKUP,FILE=USEBK(1:IEND(USEBK)),
     +         STATUS='OLD',FORM='UNFORMATTED',IOSTAT=IOS)
         IF (IOS.NE.0) THEN
            WRITE(6,'(A)')'        '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(A)')'     COULD NOT OPEN BACKUP FILE '
            WRITE(6,'(A)')'     WILL TERMINATE SeSAME'
            IER=2
            GOTO 899
         ENDIF
 25      READ(NBCKUP,END=940)BUFFER
         IF ((BUFFER(2:16).NE.'#START_INP_FILE').AND.
     +       (BUFFER(1:15).NE.'#START_INP_FILE')) GOTO 25
         IOSF=0
         IF (BUFFER(1:1).EQ.'#') IOSF=1
*        OPEN SCRATCH FILE
         OPEN(11,STATUS='SCRATCH',FORM='FORMATTED',ERR=950)
 30      READ(NBCKUP)BUFFER
         IF ((BUFFER(2:14).NE.'#END_INP_FILE').AND.
     +       (BUFFER(1:13).NE.'#END_INP_FILE')) THEN
            IF (IOSF.EQ.1) THEN
               WRITE(11,'(2A)')' ',BUFFER(1:79)
            ELSE
               WRITE(11,'(A)')BUFFER
            ENDIF
            GOTO 30
         ENDIF
         CLOSE (NBCKUP)
         REWIND 11
         READ (11,INIT,END=903)
      ENDIF

      IF (FINSTR(1:5).NE.'     ') THEN
         LINSTR=.TRUE.
         OPEN (12,FILE=FINSTR(1:IEND(FINSTR)),
     +         STATUS='OLD',FORM='FORMATTED',IOSTAT=IOS)
         IF (IOS.NE.0) THEN
            WRITE(*,'(A)')'    '
            WRITE(*,'(2A)')' *** WARNING: ERROR OPENING FILE: ',
     +                       FINSTR(1:IEND(FINSTR))
            WRITE(*,'(A)')' DO YOU WANT TO EXIT SESAME? [Y/N]'
            READ(*,'(A)')CHOIC
            IF (CHOIC.EQ.'Y'.OR.CHOIC.EQ.'y') THEN
               STOP
            ELSE
               LINSTR=.FALSE.
               FINSTR=CBL//CBL//CBL//CBL//CBL//CBL//CBL
               WRITE(*,'(A)')'    '
               WRITE(*,'(2A)')' No information will be read from',
     &                        ' instrument file (FINSTR) !'
            ENDIF   
         ENDIF
      ENDIF
      IF (FDETCT(1:5).NE.'     ') THEN
         LDETCT=.TRUE.
         OPEN (13,FILE=FDETCT(1:IEND(FDETCT)),
     +         STATUS='OLD',FORM='FORMATTED',IOSTAT=IOS)
         IF (IOS.NE.0) THEN
            WRITE(*,'(2A)')' *** WARNING: ERROR OPENING FILE: ',
     +                       FDETCT(1:IEND(FDETCT))
            WRITE(*,'(A)')' DO YOU WANT TO EXIT SESAME? [Y/N]'
            READ(*,'(A)')CHOIC
            IF (CHOIC.EQ.'Y'.OR.CHOIC.EQ.'y') THEN
               STOP
            ELSE
               LDETCT=.FALSE.
               FDETCT=CBL//CBL//CBL//CBL//CBL//CBL//CBL
               WRITE(*,'(A)')'    '
               WRITE(*,'(2A)')' No information will be read from',
     &                        ' detector file (FDETCT) !'
            ENDIF   
         ENDIF
      ENDIF
      IF (FMYDEF(1:5).NE.'     ') THEN
         LMYDEF=.TRUE.
         OPEN (14,FILE=FMYDEF(1:IEND(FMYDEF)),
     +         STATUS='OLD',FORM='FORMATTED',IOSTAT=IOS)
         IF (IOS.NE.0) THEN
            WRITE(*,'(2A)')' *** WARNING: ERROR OPENING FILE: ',
     +                       FMYDEF(1:IEND(FMYDEF))
            WRITE(*,'(A)')' DO YOU WANT TO EXIT SESAME? [Y/N]'
            READ(*,'(A)')CHOIC
            IF (CHOIC.EQ.'Y'.OR.CHOIC.EQ.'y') THEN
               STOP
            ELSE
               LMYDEF=.FALSE.
               FMYDEF=CBL//CBL//CBL//CBL//CBL//CBL//CBL
               WRITE(*,'(A)')'    '
               WRITE(*,'(2A)')' No information will be read from',
     &                        ' user file (FMYDEF) !'
            ENDIF   
         ENDIF
      ENDIF

*     ---READ DATA FROM INPUT FILE

*     &ETRN NAMELIST
      IF (LINSTR) THEN
         REWIND 12
         READ (12,ETRNS,END=75)
      ENDIF
 75   IF (LDETCT) THEN
         REWIND 13
         READ (13,ETRNS,END=78)
      ENDIF
 78   IF (LMYDEF) THEN
         REWIND 14
         READ (14,ETRNS,END=79)
      ENDIF
 79   REWIND 11
      READ (11,ETRNS,END=901)

*     &EBEAM NAMELIST
      IF (LINSTR) THEN
         REWIND 12
         READ (12,EBEAM,END=81)
      ENDIF
 81   IF (LDETCT) THEN
         REWIND 13
         READ (13,EBEAM,END=82)
      ENDIF
 82   IF (LMYDEF) THEN
         REWIND 14
         READ (14,EBEAM,END=83)
      ENDIF
 83   REWIND 11
      READ (11,EBEAM,END=85)
 85   CONTINUE

*     &TARGET NAMELIST
      IF (LINSTR) THEN
         REWIND 12
         READ (12,TARGET,END=86)
      ENDIF
 86   IF (LDETCT) THEN
         REWIND 13
         READ (13,TARGET,END=87)
      ENDIF
 87   IF (LMYDEF) THEN
         REWIND 14
         READ (14,TARGET,END=88)
      ENDIF
 88   REWIND 11
      READ (11,TARGET,END=89)
 89   CONTINUE

*     &MODEL NAMELIST
      IF (LINSTR) THEN
         REWIND 12
         READ (12,MODEL,END=281)
      ENDIF
281   IF (LDETCT) THEN
         REWIND 13
         READ (13,MODEL,END=282)
      ENDIF
282   IF (LMYDEF) THEN
         REWIND 14
         READ (14,MODEL,END=283)
      ENDIF
283   REWIND 11
      READ (11,MODEL,END=285)
285   CONTINUE

*     &MSETUP NAMELIST
      IF (LINSTR) THEN
         REWIND 12
         READ (12,MSETUP,END=292)
      ENDIF
292   IF (LDETCT) THEN
         REWIND 13
         READ (13,MSETUP,END=293)
      ENDIF
293   IF (LMYDEF) THEN
         REWIND 14
         READ (14,MSETUP,END=294)
      ENDIF
294   REWIND 11
      READ (11,MSETUP,END=298)
298   CONTINUE

*     &INSTR NAMELIST
      IF (LINSTR) THEN
         REWIND 12
         READ (12,INSTR,END=302)
      ENDIF
302   IF (LDETCT) THEN
         REWIND 13
         READ (13,INSTR,END=303)
      ENDIF
303   IF (LMYDEF) THEN
         REWIND 14
         READ (14,INSTR,END=304)
      ENDIF
304   REWIND 11
      READ (11,INSTR,END=310)
310   CONTINUE

*     &DETECT NAMELIST
      IF (LINSTR) THEN
         REWIND 12
         READ (12,DETECT,END=322)
      ENDIF
322   IF (LDETCT) THEN
         REWIND 13
         READ (13,DETECT,END=323)
      ENDIF
323   IF (LMYDEF) THEN
         REWIND 14
         READ (14,DETECT,END=324)
      ENDIF
324   REWIND 11
      READ (11,DETECT,END=325)
325   CONTINUE

*     &OUTPUT
      IF (LINSTR) THEN
         REWIND 12
         READ (12,OUTPUT,END=450)
      ENDIF
450   IF (LDETCT) THEN
         REWIND 13
         READ (13,OUTPUT,END=453)
      ENDIF
453   IF (LMYDEF) THEN
         REWIND 14
         READ (14,OUTPUT,END=456)
      ENDIF
456   REWIND 11
      READ (11,OUTPUT,END=460)
460   CONTINUE

      IF (LINSTR) CLOSE(12)
      IF (LDETCT) CLOSE(13)
      IF (LMYDEF) CLOSE(14)
      CLOSE(11)

*     ---ADJUST ECLIM AND EDLIM ACCORDING TO E0
      E=E0*1000
      CALL CHKENER (E,EDLIMT,ECLIMT,EDLIM,ECLIM)

*     ---GET NUMBER OF REGIONS DIRECTLY FROM THE INPUT DECK
      NDMAREG=NREG
*     ---GET NUMBER OF ELEMENTS
      NDMAELEM=GETNELEM(NREG,ATMAT,ATNUM)
*     ---GET ATOMIC NUMBER OF FIRST ELEMENT
      CEABR='  '
      N1STELE=INT(ATNUM(1)+0.25)
      CALL ELMENT(2,CDUMMY,N1STELE,CEABR,FRM,FDENS,IERR)

*     ---CHECK OUTPUT (LIKE INIOUT)
*     DETERMINATION OF NSCRN, NPS, NPM, NHIST, NVTOT, NSHELL, NXCHAR
*     DEFAULT NUMBER OF A BREMSSTRAHLUNG HISTOGRAM SHALL BE:
*     ATTENTION: E0 COMES BACK IN EV
      CALL CHKOUT(
     I            LTEST,
     I            NLSCP,MDEFXCONT,E0,EDLIM,ECLIM,
     I            SCREEN,POST,PMSAV,HIST,ION,XCHAR,
     I            NHISINT,N1STELE,CEABR,ATNUM,NDMAELEM,
     O            NDMASCRN,NDMAPS,NDMAPM,NDMAHIST,NDMAVHIS,
     O            NDMASHELL,NDMAXCHAR,NDMAPTOB,NDMAXCONT,
     O            NHISXCONT,LXCONT,LPTOB)
      IF (NDMAXCHAR.GT.0) LXCHAR=.TRUE.

*     ---GET BREMSSTRAHLUNG INFORMATION (NDMAXCONT)
cs      write (6,'(a,i6)')' nxcont    =',nxcont
cs      write (6,'(a,i6)')' ndmaxcont =',ndmaxcont
cs      write (6,'(a,i6)')' ndmaptob  =',ndmaptob
cs      write (6,'(a,i6)')' ndmaxchar =',ndmaxchar
cs      write (6,'(a,i6)')' nhisxcont =',nhisxcont
      IF ((.NOT.LXCONT).AND.(.NOT.LPTOB)) THEN
         IF ((NDMAXCONT.EQ.0).AND.(NHISXCONT.EQ.0)) NXCONT =0
      ENDIF
      IF (NXCONT.EQ.0) NXCONT=NHISXCONT
      IF (NXCONT.GT.0) THEN
         IF (NXCONT.LT.NDMAXCHAR) NXCONT=NDMAXCHAR
      ENDIF
      IF (LXCONT.AND.(NXCONT.LE.0)) NXCONT=MAXXCONT
      NDMAXCONT=MAX(NDMAXCONT,NXCONT)
      IF (NDMAXCONT.GT.0) LXCONT=.TRUE.
      IF (LXCONT) THEN
         LPTOB=.TRUE.
         IF (NDMAXCONT.EQ.0) NXCONT=MAXXCONT
      ELSE
         IF (LPTOB) NDMAXCONT=NDMAXCHAR
      ENDIF
      IF (LPTOB) THEN
         IF (NDMAPTOB.LE.0) NDMAPTOB=NDMAXCHAR
         IF (LXCONT) THEN
            IF (NDMAPTOB.GT.NDMAXCONT) NDMAXCONT=NDMAPTOB+NHISXCONT
         ENDIF
         NDMAXCONT=NDMAXCONT-(NDMAXCHAR-NDMAPTOB)
         IF (NDMAXCONT.LT.NDMAPTOB) NDMAXCONT=NDMAPTOB
      ENDIF
      IF ((.NOT.LXCONT).AND.(.NOT.LPTOB)) THEN
         NDMAPTOB=0
      ELSE
         CALL CCAP(BREMSCRS,3)
         IF (BREMSCRS.EQ.'TAB') THEN
            NDMAEENER = GETNEENER(E0)
            NELENER = NDMAEENER
         ENDIF
      ENDIF
cs      write (6,'(a,i6)')' nxcont    =',nxcont
cs      write (6,'(a,i6)')' ndmaxcont =',ndmaxcont
cs      write (6,'(a,i6)')' ndmaptob  =',ndmaptob
cs      write (6,'(a,i6)')' ndmaxchar =',ndmaxchar
cs      write (6,'(a,i6)')' nhisxcont =',nhisxcont
cs      stop

*     ---MAKE SURE THAT SOME OF THE "NDMA" VALUES DO NOT EXCEED
*        STATIC ARRAY BOUNDS
      IF (NDMASCRN.GT.MAXSCR) NDMASCRN=MAXSCR
      IF (NDMAPS.GT.MAXPST) NDMAPS=MAXPST
      IF (NDMAPM.GT.MAXSAV) NDMAPM=MAXSAV
      IF (NDMAHIST.GT.MAXHIS) NDMAHIST=MAXHIS
      IF (NDMAREG.GT.MAXREG) NDMAREG=MAXREG
      IF (NDMAELEM.GT.MAXELE) NDMAELEM=MAXELE

*     ---CHECK WETHER GRID IS NECESSARY AT ALL
*     IF CHARACTERISTIC AND/OR CONTINUUM X-RAYS ARE TO BE SIMULATED THEN
*     A GRID MUST BE GENERATED OR READ FROM FILE
      IF (LXCHAR.OR.LXCONT) LGRD=.TRUE.

*     ---CHECK GRID (LIKE RDGRID)
*     DETERMINATION OF GRID LINES IN X-, Y- AND Z-DIRECTION
      IF (LGRD) THEN
cs      IF NYGRID NOT SPECIFIED IN INPUT DECK AND ONLY ONE
cs      GEOMETRY (QUADTREE) SPECIFIED THEN ONLY A 2D GRID
cs      SHALL BE GENERATED
        NQUADS=1
        IF (NYGRID.LT.1) NYGRID=NQUADS
        IF ((NXGRID.LT.1).OR.(NXGRID.GT.NXM)) NXGRID=NXM
        IF ((NYGRID.LT.1).OR.(NYGRID.GT.NYM)) NYGRID=NYM
        IF ((NZGRID.LT.1).OR.(NZGRID.GT.NZM)) NZGRID=NZM
        LAUTOGR=.TRUE.
        IF (CGRDFL(1:10).NE.CBL) THEN
*         OPEN GRID FILE
          OPEN (12,FILE=CGRDFL(1:IEND(CGRDFL)),
     +          STATUS='OLD',FORM='FORMATTED',IOSTAT=IOS)
          IF (IOS.NE.0) THEN
            WRITE(*,'(2A)')' *** WARNING: ERROR OPENING GRID FILE: ',
     +                       CGRDFL(1:IEND(CGRDFL))
            WRITE(*,'(A)')' AUTOMATIC GRID WILL BE GENERATED'
            LAUTOGR=.TRUE.
          ELSE
*           READ GRID INFORMATION FROM FILE
            NDMAXGRID=0
            READ(12,*)NXMAIN
            NDMAXGRID=NDMAXGRID+NXMAIN
            DO 510 I=1,NXMAIN-1
               READ(12,*)RDUMMY
               READ(12,*)NXMINOR
               NDMAXGRID=NDMAXGRID+NXMINOR
 510        CONTINUE
            NDMAZGRID=0
            READ(12,*)RDUMMY
            READ(12,*)NZMAIN
            NDMAZGRID=NDMAZGRID+NZMAIN
            DO 520 I=1,NZMAIN-1
               READ(12,*)RDUMMY
               READ(12,*)NZMINOR
               NDMAZGRID=NDMAZGRID+NZMINOR
 520        CONTINUE
            NDMAYGRID=0
            READ(12,*)RDUMMY
            READ(12,*,IOSTAT=IOS)NYMAIN
            IF (IOS.LT.0) THEN
*              END OF FILE DETECTED => ONLY 2D GRID SPECIFIED
               NDMAYGRID=1
            ELSE
               NDMAYGRID=NDMAYGRID+NYMAIN
               DO 530 I=1,NYMAIN-1
                  READ(12,*)RDUMMY
                  READ(12,*)NYMINOR
                  NDMAYGRID=NDMAYGRID+NYMINOR
 530           CONTINUE
            ENDIF
            CLOSE(12)
            LAUTOGR=.FALSE.
          ENDIF
        ENDIF
        IF (LAUTOGR) THEN
          NDMAXGRID=NXGRID
          NDMAYGRID=NYGRID
          NDMAZGRID=NZGRID
        ELSE
          NDMAXGRID=MIN(NDMAXGRID,NXM)
          NDMAYGRID=MIN(NDMAYGRID,NYM)
          NDMAZGRID=MIN(NDMAZGRID,NZM)
        ENDIF
      ELSE
        NDMAXGRID=0
        NDMAYGRID=0
        NDMAZGRID=0
      ENDIF

*     ---GET NUMBER OF X-RAY DETECTORS
      DO 610 I=1,MAXXDET
CS         IF ((XLAYTH(I,1).GT.0).OR.
CS     1       (XLAYDN(I,1).GT.0).OR.
CS     2       (XFDEFF(I)(1:3).NE.'   ').OR.
CS     3       (TAKOFF(I).NE.XTKDEF).OR.
CS     4       (XDEROT(I).NE.XDRDEF)) NDMAXDET=NDMAXDET+1
         IF (SOLIDA(I).GT.0) NDMAXDET=NDMAXDET+1
 610  CONTINUE

*     ---GET NUMBER OF ELECTRON DETECTORS
      DO 630 I=1,MAXEDET
CS         IF ((FEDTRN(I)(1:3).NE.'   ').OR.
CS     1       (EDTHMN(I).NE.0).OR.
CS     2       (EDTHMX(I).NE.90).OR.
CS     3       (EDTHET(I).NE.XTKDEF).OR.
CS     4       (EDPHI(I).NE.XDRDEF)) NDMAEDET=NDMAEDET+1
         IF (EDTHMX(I).GT.0) NDMAEDET=NDMAEDET+1
 630  CONTINUE

      IF (LTEST) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A,I7)')' NDMAXGRID =',NDMAXGRID
         WRITE(6,'(A,I7)')' NDMAYGRID =',NDMAYGRID
         WRITE(6,'(A,I7)')' NDMAZGRID =',NDMAZGRID
         WRITE(6,'(A,I7)')' NDMASHELL =',NDMASHELL
         WRITE(6,'(A,I7)')' NDMAXCHAR =',NDMAXCHAR
         WRITE(6,'(A,I7)')' NDMAXCONT =',NDMAXCONT
         WRITE(6,'(A,I7)')' NDMAPTOB  =',NDMAPTOB
         WRITE(6,'(A,I7)')' NDMAXDET  =',NDMAXDET
         WRITE(6,'(A,I7)')' NDMAEDET  =',NDMAEDET
         WRITE(6,'(A,I7)')' NDMAELEM  =',NDMAELEM
         WRITE(6,'(A,I7)')' NDMAREG   =',NDMAREG
         WRITE(6,'(A,I7)')' NDMAVHIS  =',NDMAVHIS
         WRITE(6,'(A,I7)')' NDMAHIST  =',NDMAHIST
         WRITE(6,'(A,I7)')' NDMASCRN  =',NDMASCRN
         WRITE(6,'(A,I7)')' NDMAPS    =',NDMAPS
         WRITE(6,'(A,I7)')' NDMAPM    =',NDMAPM
      ENDIF

 899  RETURN

 901  STOP '&ETRNS: HAS NOT BEEN FOUND IN THE INPUT FILE'
 903  STOP '&INIT:  HAS NOT BEEN FOUND IN THE INPUT FILE'
 940  WRITE (*,*) USEBK
      STOP 'DID NOT FIND INPUT DECK IN BACKUP FILE'
 950  WRITE (*,*) USEBK
      STOP 'COULD NOT OPEN SCRATCH FILE TO EXTRACT INPUT DECK'
      

      END

*****************************************************************************

      SUBROUTINE SHOMEM ()

      IMPLICIT INTEGER (I-N)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      INCLUDE 'DMA.INC'

      WRITE(6,'(A)')'      '
      WRITE(6,'(A)')' EVALUATING MEMORY REQUIRMENTS AND AVAILABILITY'


      RETURN
      END

*****************************************************************************

      SUBROUTINE CHKMEM(LISSUFF)

***   CHKMEM - CHECKS WHETHER DYNAMICALLY ALLOCATED MEMORY IS SUFFICIENT
*
**    AUTHOR: CHRISTIAN SCHIEBL
*             CONSULTANT (FORMER: CEC-VIENNA)
*             KREMS, OCTOBER 1996

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      IMPLICIT INTEGER (I-N)

      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'GLOBAL.INC'
      INCLUDE 'HIST.INC'
      INCLUDE 'OUTPUT.INC'
      INCLUDE 'DMA.INC'

*** START OF EXECUTABLE CODE
****************************

      LISSUFF = .FALSE.

      IF (LTEST) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A,I7,A,I7)')' NDMAXGRID =',NDMAXGRID,
     &                         '   NXGRID =',NXGRID
         WRITE(6,'(A,I7,A,I7)')' NDMAYGRID =',NDMAYGRID,
     &                         '   NYGRID =',NYGRID
         WRITE(6,'(A,I7,A,I7)')' NDMAZGRID =',NDMAZGRID,
     &                         '   NZGRID =',NZGRID
         WRITE(6,'(A,I7,A,I7)')' NDMASHELL =',NDMASHELL,
     &                         '   NSHELL =',NSHELL
         WRITE(6,'(A,I7,A,I7)')' NDMAXCHAR =',NDMAXCHAR,
     &                         '   NXCHAR =',NXCHAR
         WRITE(6,'(A,I7,A,I7)')' NDMAXCONT =',NDMAXCONT,
     &                         '   NXCONT =',NXCONT
         WRITE(6,'(A,I7,A,I7)')' NDMAPTOB  =',NDMAPTOB,
     &                         '   NXPTOB =',NXPTOB
         WRITE(6,'(A,I7,A,I7)')' NDMAXDET  =',NDMAXDET,
     &                         '   NXDET  =',NXDET
         WRITE(6,'(A,I7,A,I7)')' NDMAEDET  =',NDMAEDET,
     &                         '   NEDET  =',NEDET
         WRITE(6,'(A,I7,A,I7)')' NDMAELEM  =',NDMAELEM,
     &                         '   NELEM  =',NELEM
         WRITE(6,'(A,I7,A,I7)')' NDMAREG   =',NDMAREG,
     &                         '   NREG   =',NREG
         WRITE(6,'(A,I7,A,I7)')' NDMAVHIS  =',NDMAVHIS,
     &                         '   NVTOT  =',NVTOT
         WRITE(6,'(A,I7,A,I7)')' NDMAHIST  =',NDMAHIST,
     &                         '   NHIST  =',NHIST
         WRITE(6,'(A,I7,A,I7)')' NDMASCRN  =',NDMASCRN,
     &                         '   NSCRN  =',NSCRN
         WRITE(6,'(A,I7,A,I7)')' NDMAPS    =',NDMAPS,
     &                         '   NPS    =',NPS
         WRITE(6,'(A,I7,A,I7)')' NDMAPM    =',NDMAPM,
     &                         '   NPM    =',NPM
      ENDIF

      IF (NDMAXGRID.LT.NXGRID) RETURN
      IF (NDMAYGRID.LT.NYGRID) RETURN
      IF (NDMAZGRID.LT.NZGRID) RETURN
      IF (NDMASHELL.LT.NSHELL) RETURN
      IF (NDMAXCHAR.LT.NXCHAR) RETURN
      IF (NDMAXCONT.LT.NXCONT) RETURN
      IF (NDMAXDET.LT.NXDET) RETURN
      IF (NDMAEDET.LT.NEDET) RETURN
      IF (NDMAELEM.LT.NELEM) RETURN
      IF (NDMAREG.LT.NREG) RETURN
      IF (NDMAVHIS.LT.NVTOT) RETURN
      IF (NDMAHIST.LT.NHIST) RETURN
      IF (NDMASCRN.LT.NSCRN) RETURN
      IF (NDMAPS.LT.NPS) RETURN
      IF (NDMAPM.LT.NPM) RETURN

      LISSUFF = .TRUE.

      RETURN
      END

**************************************************************************
*last modification: 23-Sep-1996

      INTEGER FUNCTION GETNELEM (NREG,MAT,ATNUM)

***   GETNELEM - DELIVERS NUMBER OF ELEMENTS IN SAMPLE FOR DYNAMIC
*                MEMORY ALLOCATION
*
**    AUTHOR: CHRISTIAN SCHIEBL
*             CONSULTANT (FORMER: CEC-VIENNA)
*             KREMS, SEPTEMBER 1996

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'

      CHARACTER*10 CBL
      CHARACTER*70 MAT(MAXREG)
      DIMENSION AFRAC(N2M,NRM),ATNUM(MAXELE)

      CBL='          '
      NR=NREG
      DO 10 I=1,MAXREG
         ATMAT(I)=MAT(I)
 10   CONTINUE

      CALL CHKMAT(AFRAC)

      DO 15 I=1,MAXELE
         ATNUM(I)=ANUM(I)
 15   CONTINUE

      DO 20 I=1,MAXREG
         ATMAT(I)=CBL//CBL//CBL//CBL//CBL//CBL//CBL
 20   CONTINUE

      GETNELEM=NATOM

      RETURN
      END

****************************************************************************
*last modification: 10-Feb-1997

      SUBROUTINE SETBND ()

***   SETBND - SETS THE ARRAY BOUNDS FOR DYNAMICLLY ALLOCATED ARRAYS
*
**    AUTHOR: CHRISTIAN SCHIEBL
*             CONSULTANT (FORMER: CEC-VIENNA)
*             KREMS, NOVEMBER 1996

      INCLUDE 'TYPE.INC'
      INCLUDE 'DMA.INC'
      INCLUDE 'BOUND.INC'
      INCLUDE 'PARAM.INC'

*** START OF EXECUTABLE CODE
****************************

      BNDERR=.FALSE.

      NALLOC(1)=NDMAXDET
      NALLOC(2)=NDMAXGRID
      NALLOC(3)=NDMAZGRID
      NALLOC(4)=NDMAYGRID
      NALLOC(5)=NDMASHELL
      NALLOC(6)=NDMAXCHAR
      NALLOC(7)=NDMAXCONT
      NALLOC(8)=NDMAVHIS
      NALLOC(9)=NDMAXCONT+NDMAXCHAR-NDMAPTOB
      NALLOC(10)=NDMAXGRID*NDMAZGRID*NDMAYGRID
      NALLOC(11)=NDMASHELL*NALLOC(10)
      NALLOC(12)=NDMAXCONT*NDMAXDET*NALLOC(10)
      NALLOC(13)=NDMAXDET*NALLOC(9)
      NALLOC(14)=NDMAXDET*NALLOC(9)*NALLOC(10)
      NALLOC(15)=NDMAREG*NDMASHELL
      NALLOC(16)=(NDMASCRN+NDMAPS)*NDMASHELL
      NALLOC(17)=NDMAPM*NDMASHELL
      NALLOC(18)=NDMAHIST*NDMASHELL
      NALLOC(19)=NDMAXCHAR*NDMASHELL
      NALLOC(20)=NDMAXDET*NDMAXCHAR
      NALLOC(21)=(NDMASCRN+NDMAPS)*NDMAXCHAR
      NALLOC(22)=NDMAPM*NDMAXCHAR
      NALLOC(23)=NDMAHIST*NDMAXCHAR
      NALLOC(24)=NDMAELEM*MAXSHELL*NDMAXCHAR
      NALLOC(25)=NDMAREG*NDMAXCHAR
      NALLOC(26)=NDMAHIST*NDMAXCONT

      RETURN
      END

****************************************************************************
*last modification: 05-Dec-1996

      SUBROUTINE CHKBND (N,INDX,STRING1,STRING2)

***   SETBND - CHECKS THE ARRAY BOUNDS FOR DYNAMICLLY ALLOCATED ARRAYS
*
**    AUTHOR: CHRISTIAN SCHIEBL
*             CONSULTANT (FORMER: CEC-VIENNA)
*             KREMS, NOVEMBER 1996

      INCLUDE 'TYPE.INC'
      INCLUDE 'BOUND.INC'

      CHARACTER*(*) STRING1
      CHARACTER*(*) STRING2

*** START OF EXECUTABLE CODE
****************************

      IF ((INDX.LE.NALLOC(N)).AND.(INDX.GE.1)) RETURN

*     WRITE ERROR MESSAGE
      WRITE(6,'(A)')'        '
      WRITE(6,'(A)')' *** WARNING ***'
      WRITE(6,'(2A)')' Array Index out of Boundary of Allocated',
     &               ' Memory Space !'
      WRITE(6,'(2A)')' Calling Routine:  ',STRING1
      WRITE(6,'(2A)')' Array:            ',STRING2
      WRITE(6,'(A,I9)')' Index:              ',INDX
      WRITE(6,'(A,I9)')' Boundary: FROM  1 TO',NALLOC(N)
      IF (STPBND) THEN
         WRITE(6,'(A)')' SeSAME TERMINATED !'
         WRITE(6,'(2A)')' [specifying STPBND=F in input deck and',
     &                  ' rerunning program will avoid termination]'
      ELSE
        WRITE(6,'(A)')' SeSAME WILL TRY TO CONTINUE SIMULATION !'
        WRITE(6,'(A)')' BE AWARE THAT RESULTS MIGHT BE WRONG !'
        BNDERR=.TRUE.
      ENDIF

      RETURN
      END

*****************************************************************************
*last modification: 04-Feb-1997

      INTEGER FUNCTION GETNEENER (E0)

***   GETNEENER - DELIVERS NUMBER OF ELECTRON ENERGY LEVELS BELOW E0
*                 FOR DYNAMIC MEMORY ALLOCATION
*
**    AUTHOR: CHRISTIAN SCHIEBL
*             CONSULTANT (FORMER: CEC-VIENNA)
*             KREMS/HUDSON, FEBRUARY 1997

      INCLUDE 'TYPE.INC'
      INCLUDE 'BREMS.INC'

*     TRANSFORM E0 TO KEV
      E0 = E0/1000
      IF (E0.GT.500) THEN
         WRITE(6,'(A)')'                '
         WRITE(6,'(A)')' *** WARNING ***'
         WRITE(6,'(A)')' GETNEENER: E0 too large!'
      ENDIF

      GETNEENER = 0

      INDX = 1
 10   IF (E0.GE.VELENER(INDX)) THEN
         INDX = INDX+1
         GOTO 10
      ENDIF

      GETNEENER = INDX

      RETURN
      END

****************************************************************************
