c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
      SUBROUTINE DRWAUG(
     I			 IAUG,IAUG2,IGEN
     O			 )

       INCLUDE 'TYPE.INC'
       INCLUDE 'PARAM.INC'
       INCLUDE 'GLOBAL.INC'
       INCLUDE 'HIST.INC'
       INCLUDE 'OUTPUT.INC'

       INTEGER IAUG
       INTEGER IAUG2
       INTEGER IGEN

***    DRWAUG - DRAWS 1-D and 2-D SURFACE-IONIZATION-HISTOGRAM TO SCREEN
*
**     ARGUMENTS
*
*      IAUG - AUGER - LINE NUMBER
*      IGEN - 1 = PLOT AUGER GENERATION (AGD)
*             0 = PLOT AUGER DETECTION  (ADD)
*
**     AUTHOR: H.WAGNER 23-DEC-94
*

**     START OF EXECUTABLE CODE
*      ************************

       DOUBLE PRECISION VMIN,VMAX,L0,L1,LMAX
       CHARACTER*20 STRING 

*      GET HISTOGRAM DATA

       IF (IGEN .EQ. 1) THEN
          IHIS = AGDHIS(IAUG)
          ILOC = AGDLOC(IAUG,IAUG2)
       ELSE 
          IHIS = ADDHIS(IAUG)
          ILOC = ADDLOC(IAUG,IAUG2)
       ENDIF

       IF (ILOC .EQ. 0) THEN
          WRITE (*,*) '***WARNING: DRWAUG CALLED WITH NO OUTPUT SCREEN'
          GOTO 1000
       ENDIF

       IBEG = IVBEG(IHIS)
       NL = NVAL(IHIS,1)
       ND = NVAL(IHIS,2)
       LMAX = VALMAX(IHIS,1)
       DMAX = VALMAX(IHIS,2)

       CALL MINMAX(VALHIS,IBEG,NL*ND,VMIN,IMIN,VMAX,IMAX)

       IF (VMIN .EQ. VMAX) VMAX = VMIN + 1.

*      SELECT WINDOW

       WRITE(*,*) VMAX,VMIN
       CALL F_OUTPUTTO(NXLOC(ILOC),NS)
 
*      PLOT DATA

       NVH=IBEG-1+ND*NL
       CALL CHKBND(8,NVH,'DRWAUG','VALHIS')
       DO 210,IL=1,NL

         L0 = LMAX/NL*(IL-1)
         L1 = LMAX/NL* IL

*        CALCULATE APPROPRIATE LINEWIDTH
      	 
         CALL IMSURFSETDEPTH(X1,Z1,0.D0,L0,IER)
         CALL IMSURFSETDEPTH(X2,Z2,DMAX/ND,L0,IER)
         CALL TRNXYZ(ILOC,X1,0.D0,Z1,XX1,XY1)
         CALL TRNXYZ(ILOC,X2,0.D0,Z2,XX2,XY2)
         QUAD = (XX2-XX1)*(XX2-XX1)+(XY2-XY1)*(XY2-XY1)
         WIDTH = 1.+AINT(0.5+DSQRT(QUAD))
         CALL F_SETLINEWIDTH(WIDTH,NS)
 
         DO 200,ID=1,ND

           D = DMAX/ND*(ID-0.5)

           CALL IMSURFSETDEPTH(X1,Z1,D,L0,IER)
           CALL TRNXYZ(ILOC,X1,0.D0,Z1,XX1,XY1)
           CALL IMSURFSETDEPTH(X2,Z2,D,L1,IER)
           CALL TRNXYZ(ILOC,X2,0.D0,Z2,XX2,XY2)
           IABS = IBEG-1+IL+(ID-1)*NL
           ICOL = 1+NINT((NPALET-1.)*(VALHIS(IABS)-VMIN)/(VMAX-VMIN))
           CALL F_PEN(NCOLOR(ICOL),NS)

      	   CALL F_FLINE(XX1,XY1,XX2,XY2,NS)
           
    
200      CONTINUE

210    CONTINUE

       CALL F_FSHOW(NS)
*  SET STANDARD PEN SETTINGS

       CALL F_PEN(1,NS)
       CALL F_SETLINEWIDTH(0.D0,NS)

1000   CONTINUE

       END
