c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
*last modification: 10-Nov-1997

      SUBROUTINE DRWHIS(
     I			 IHIS,ANORM,DUMMY,FDUMMY
     O			 )

       INCLUDE 'TYPE.INC'
       INCLUDE 'PARAM.INC'
       INCLUDE 'HIST.INC'
       INCLUDE 'OUTPUT.INC'

       INTEGER IHIS
       DOUBLE PRECISION VMIN,VMAX

***    DRWHIS - DRAWS 1D-HISTOGRAM TO SCREEN
*
**     ARGUMENTS
*
*      IHIS  - HISTOGRAM NUMBER
*      ANORM - NORMALIZATION VALUE (i.e. all values are divided by ANORM)
*      DUMMY - DOUBLE PRECISION DUMMY ARGUMENT
*      FDUMMY- DOUBLE PRECISION DYMMY ARRAY
*
**     AUTHOR: H.WAGNER 14-NOV-94
*              C.SCHIEBL (EXPANSIONS)
*

**     START OF EXECUTABLE CODE
*      ************************

       PARAMETER (LMARG=50.,RMARG=20.,TMARG=20.,BMARG=20.)

       DOUBLE PRECISION FDUMMY(2)
       CHARACTER*20 STRING 

cs-test-start
c       write(6,'(a,i3)')' ihis =',ihis
c       write(6,'(2a)')' cvalue(ihis) =',cvalue(ihis)
c       read(*,*)
cs-test-end

       IF (CVALUE(IHIS) .EQ. 'AES') THEN
          ANORM=ANORM/VDELT(IHIS,1)
          CALL DRWSPE(IHIS,BCKHIS(HISEDT(IHIS)),ANORM)
          GOTO 1000
       ENDIF

       XPIX = SCXSIZ(NSCL+IHIS)-LMARG-RMARG
       YPIX = SCYSIZ(NSCL+IHIS)-TMARG-BMARG
       XMARG = LMARG
       YMARG = TMARG

*      GET HISTOGRAM DATA

       N = NVAL(IHIS,1)
       NBEG = IVBEG(IHIS)-1

       NVH=NBEG+N
       CALL CHKBND(8,NVH,'DRWHIS','VALHIS')

cs-test-begin
c       write(6,'(a,i3,a,i3)')' VALHIS: Indices from',nbeg+1,' to',nbeg+n
c 5678  write(6,*)' input index'
c       read(*,*)index
c       if (index.gt.0) then
c         write(6,*)index,valhis(index)
c         goto 5678
c       endif
cs-test-end

*      FIND MAXIMUM AND MINIMUM VALUE
     
       VMAX =  VALHIS(NBEG+1)
       VMIN =  VALHIS(NBEG+1)

       DO 100,I=1,N
         IF (VALHIS(NBEG+I) .GT. VMAX) VMAX = VALHIS(NBEG+I)
         IF (VALHIS(NBEG+I) .LT. VMIN) VMIN = VALHIS(NBEG+I)
100    CONTINUE         

       IF (VMAX .EQ. VMIN) THEN
         VMAX = VMAX + 0.5
         VMIN = VMIN - 0.5
       ENDIF

*      CLEAR WINDOW

       CALL F_OUTPUTTO(NXHIS(IHIS),NS)
       CALL F_CLEAR(NS)

*      PLOT AXES

       CALL F_PEN(1,NS)

       CALL F_RECTANGLE(XMARG,YMARG,XPIX,YPIX,NS)

       WRITE(STRING,'(G9.2)') VALMIN(IHIS,1)
       CALL F_DRAWSTRING(30.D0,YPIX+TMARG+BMARG-7.D0,STRING)
       WRITE(STRING,'(G9.2)') VALMAX(IHIS,1)
       CALL F_DRAWSTRING(XPIX+5.D0,
     .                   YPIX+TMARG+BMARG-7.D0,STRING)


       IF (CVALUE(IHIS)(3:3) .EQ. 'E' .OR. CVALUE(IHIS) .EQ. 'DEB' .OR.
     .	   CVALUE(IHIS) .EQ. 'AES') THEN
          WRITE(STRING,'(G9.2)') VMAX/ANORM
          CALL F_DRAWSTRING(0.D0,YMARG+12,STRING)
          WRITE(STRING,'(G9.2)') VMIN/ANORM
          CALL F_DRAWSTRING(0.D0,YMARG+YPIX,STRING)
          CALL F_DRAWSTRING(XMARG+XPIX/2.D0-50.D0,
     .			    YPIX+TMARG+BMARG-7.D0,
     .			    'ENERGY (eV)')
          CALL F_DRAWSTRING(5.D0,YMARG-3.D0,
     .			    'Electrons/e(in)/eV)')
       ENDIF 

       IF (CVALUE(IHIS)(3:3) .EQ. 'P') THEN
          WRITE(STRING,'(G9.2)') VMAX/ANORM
          CALL F_DRAWSTRING(0.D0,YMARG+12,STRING)
          WRITE(STRING,'(G9.2)') VMIN/ANORM
          CALL F_DRAWSTRING(0.D0,YMARG+YPIX,STRING)
          CALL F_DRAWSTRING(XMARG+XPIX/2.D0-100.D0,
     .			    YPIX+TMARG+BMARG-7.D0,
     .			    'POLAR ANGLE (deg)')
          CALL F_DRAWSTRING(5.D0,YMARG-3.D0,
     .			    'Electrons/e(in)/deg)')
       ENDIF 

       IF (CVALUE(IHIS)(3:3) .EQ. 'A') THEN
          WRITE(STRING,'(G9.2)') VMAX/ANORM
          CALL F_DRAWSTRING(0.D0,YMARG+12,STRING)
          WRITE(STRING,'(G9.2)') VMIN/ANORM
          CALL F_DRAWSTRING(0.D0,YMARG+YPIX,STRING)
          CALL F_DRAWSTRING(XMARG+XPIX/2.D0-100.D0,
     .			    YPIX+TMARG+BMARG-7.D0,
     .			    'AZIM. ANGLE (deg)')
          CALL F_DRAWSTRING(5.D0,YMARG-3.D0,
     .			    'Electrons/e(in)/deg)')
       ENDIF 

       IF (CVALUE(IHIS)(3:3) .EQ. 'Y') THEN
          WRITE(STRING,'(G9.2)') VMAX*VDELT(IHIS,1)/ANORM
          CALL F_DRAWSTRING(0.D0,YMARG+12,STRING)
          WRITE(STRING,'(G9.2)') VMIN*VDELT(IHIS,1)/ANORM
          CALL F_DRAWSTRING(0.D0,YMARG+YPIX,STRING)
          CALL F_DRAWSTRING(XMARG+XPIX/2.D0-100.D0,
     .			    YPIX+TMARG+BMARG-7.D0,
     .			    'POSITION (Ang)')
          IF (CVALUE(IHIS)(1:1).EQ.'X') THEN
             CALL F_DRAWSTRING(5.D0,YMARG-3.D0,
     .			       'X-rays/e(in)/sr')
          ELSE
             CALL F_DRAWSTRING(5.D0,YMARG-3.D0,
     .			    'Electrons/e(in)')
          ENDIF
       ENDIF 

       IF (CVALUE(IHIS)(3:3) .EQ. 'V') THEN
          WRITE(STRING,'(G9.2)') VMAX/ANORM
          CALL F_DRAWSTRING(0.D0,YMARG+12,STRING)
          WRITE(STRING,'(G9.2)') VMIN/ANORM
          CALL F_DRAWSTRING(0.D0,YMARG+YPIX,STRING)
          CALL F_DRAWSTRING(XMARG+XPIX/2.D0-100.D0,
     .			    YPIX+TMARG+BMARG-7.D0,
     .			    'DEPTH (Ang)')
          CALL F_DRAWSTRING(5.D0,YMARG-3.D0,
     .			    'Ionizations/e(in)/')
       ENDIF

       IF (CVALUE(IHIS)(3:3) .EQ. 'L') THEN
          IF (CVALUE(IHIS)(1:1) .EQ. 'I') THEN
             WRITE(STRING,'(G9.2)') VMAX/ANORM
             CALL F_DRAWSTRING(0.D0,YMARG+12,STRING)
             WRITE(STRING,'(G9.2)') VMIN/ANORM
             CALL F_DRAWSTRING(0.D0,YMARG+YPIX,STRING)
             CALL F_DRAWSTRING(XMARG+XPIX/2.D0-100.D0,
     .		   	       YPIX+TMARG+BMARG-7.D0,
     .			       'LATERAL POS.(Ang)')
             CALL F_DRAWSTRING(5.D0,YMARG-3.D0,
     .		  	       'Ionizations/e(in)/')
          ELSE
             WRITE(STRING,'(G9.2)') VMAX/ANORM
             CALL F_DRAWSTRING(0.D0,YMARG+12,STRING)
             WRITE(STRING,'(G9.2)') VMIN/ANORM
             CALL F_DRAWSTRING(0.D0,YMARG+YPIX,STRING)
             CALL F_DRAWSTRING(XMARG+XPIX/2.D0-100.D0,
     .			       YPIX+TMARG+BMARG-7.D0,
     .			       'LATERAL (X) POS. [Ang]')
             CALL F_DRAWSTRING(5.D0,YMARG-3.D0,
     .			       'Electrons/e(in)/')
          ENDIF
       ENDIF 

       IF (CVALUE(IHIS)(1:3).EQ.'BEH') THEN
          WRITE(STRING,'(G9.2)') VMAX/ANORM
          CALL F_DRAWSTRING(0.D0,YMARG+12,STRING)
          WRITE(STRING,'(G9.2)') VMIN/ANORM
          CALL F_DRAWSTRING(0.D0,YMARG+YPIX,STRING)
          CALL F_DRAWSTRING(XMARG+XPIX/2.D0-100.D0,
     .			    YPIX+TMARG+BMARG-7.D0,
     .			    'HORIZONTAL (Y) POS. [Ang]')
          CALL F_DRAWSTRING(5.D0,YMARG-3.D0,
     .			    'Electrons/e(in)/')
       ENDIF

       IF ((CVALUE(IHIS)(1:3) .EQ. 'XCS').OR.
     .     (CVALUE(IHIS)(1:3) .EQ. 'XKS').OR.
     .     (CVALUE(IHIS)(1:3) .EQ. 'XRS')) THEN
          WRITE(STRING,'(G9.2)') VMAX/ANORM
          CALL F_DRAWSTRING(0.D0,YMARG+12,STRING)
          WRITE(STRING,'(G9.2)') VMIN/ANORM
          CALL F_DRAWSTRING(0.D0,YMARG+YPIX,STRING)
          CALL F_DRAWSTRING(XMARG+XPIX/2.D0-100.D0,
     .			    YPIX+TMARG+BMARG-7.D0,
     .			    'ENERGY (eV)')
          CALL F_DRAWSTRING(5.D0,YMARG-3.D0,
     .			    'X-ray Counts')
       ENDIF 


*      PLOT DATA

       W = 1.D0+AINT(XPIX/N)

       IF (CVALUE(IHIS)(1:3).EQ.'TEB') THEN
          CALL HISEVA(
     .                IHIS,DUMMY,9.0D-1,
     .                IMX,VMX,XMX,YMX,ZMX,
     .                BPORL,BPORR,SUMREL,IPFLAG)
          IF ((FDUMMY(2).GT.-5).AND.(FDUMMY(2).LT.5)) THEN
             BEAMREF=FDUMMY(1)
          ELSE
             BEAMREF=XMX
          ENDIF
          VMAX=0
          VMIN=VMX
          DO 200,I=1,N
             XHPOS=VALMIN(IHIS,1)+(I-0.5)*VDELT(IHIS,1)
             IF (XHPOS.LT.BEAMREF) THEN
                XHDELT=BEAMREF-XHPOS
                IF (XHDELT.LT.(0.5*VDELT(IHIS,1))) THEN
                   VAL=VALHIS(I+NBEG)*((0.5*VDELT(IHIS,1)+XHDELT)/
     &                 VDELT(IHIS,1))/((0.5*VDELT(IHIS,1)+XHDELT)**2
     &                 *2*PI)+
     &                 VALHIS(I+NBEG)*((0.5*VDELT(IHIS,1)-XHDELT)/
     &                 VDELT(IHIS,1))/((0.5*VDELT(IHIS,1)-XHDELT)**2
     &                 *2*PI)
                ELSE
                   R1=BEAMREF-XHPOS+0.5*VDELT(IHIS,1)
                   R2=R1-VDELT(IHIS,1)
                   VAL=VALHIS(I+NBEG)/(2*PI*(R1**2-R2**2))
                ENDIF
             ELSE
                XHDELT=XHPOS-BEAMREF
                IF (XHDELT.LT.(0.5*VDELT(IHIS,1))) THEN
                   VAL=VALHIS(I+NBEG)*((0.5*VDELT(IHIS,1)+XHDELT)/
     &                 VDELT(IHIS,1))/((0.5*VDELT(IHIS,1)+XHDELT)**2
     &                 *2*PI)+
     &                 VALHIS(I+NBEG)*((0.5*VDELT(IHIS,1)-XHDELT)/
     &                 VDELT(IHIS,1))/((0.5*VDELT(IHIS,1)-XHDELT)**2
     &                 *2*PI)
                ELSE
                   R1=XHPOS-BEAMREF+0.5*VDELT(IHIS,1)
                   R2=R1-VDELT(IHIS,1)
                   VAL=VALHIS(I+NBEG)/(2*PI*(R1**2-R2**2))
                ENDIF
             ENDIF
             VAL=VAL*VDELT(IHIS,1)
             IF (VAL.GT.VMAX) VMAX=VAL
             IF (VAL.LT.VMIN) VMIN=VAL
200       CONTINUE
          IF (VMAX .EQ. VMIN) THEN
            VMAX = VMAX + 0.5
            VMIN = VMIN - 0.5
          ENDIF
          WRITE(STRING,'(G9.2)') VMAX/ANORM
          CALL F_DRAWSTRING(0.D0,YMARG+12,STRING)
          WRITE(STRING,'(G9.2)') VMIN/ANORM
          CALL F_DRAWSTRING(0.D0,YMARG+YPIX,STRING)
          CALL F_DRAWSTRING(XMARG+XPIX/2.D0-100.D0,
     .			    YPIX+TMARG+BMARG-7.D0,
     .			    'LATERAL POS.(Ang)')
          CALL F_DRAWSTRING(5.D0,YMARG-3.D0,
     .			    'Transmitted Electrons/e(in)/Ų')
          CALL F_PEN(4,NS)
          DO 202,I=1,N
             XHPOS=VALMIN(IHIS,1)+(I-0.5)*VDELT(IHIS,1)
             IF (XHPOS.LT.BEAMREF) THEN
                XHDELT=BEAMREF-XHPOS
                IF (XHDELT.LT.(0.5*VDELT(IHIS,1))) THEN
CS                   VAL=VALHIS(I+NBEG)*((0.5*VDELT(IHIS,1)+XHDELT)/
CS     &                 VDELT(IHIS,1))/((0.5*VDELT(IHIS,1)+XHDELT)**2
CS     &                 *2*PI)+
CS     &                 VALHIS(I+NBEG)*((0.5*VDELT(IHIS,1)-XHDELT)/
CS     &                 VDELT(IHIS,1))/((0.5*VDELT(IHIS,1)-XHDELT)**2
CS     &                 *2*PI)
                   VAL=VALHIS(I+NBEG)/(PI*VDELT(IHIS,1)**2)
                ELSE
                   R1=BEAMREF-XHPOS+0.5*VDELT(IHIS,1)
                   R2=R1-VDELT(IHIS,1)
                   VAL=VALHIS(I+NBEG)/(2*PI*(R1**2-R2**2))
                ENDIF
             ELSE
                XHDELT=XHPOS-BEAMREF
                IF (XHDELT.LT.(0.5*VDELT(IHIS,1))) THEN
CS                   VAL=VALHIS(I+NBEG)*((0.5*VDELT(IHIS,1)+XHDELT)/
CS     &                 VDELT(IHIS,1))/((0.5*VDELT(IHIS,1)+XHDELT)**2
CS     &                 *2*PI)+
CS     &                 VALHIS(I+NBEG)*((0.5*VDELT(IHIS,1)-XHDELT)/
CS     &                 VDELT(IHIS,1))/((0.5*VDELT(IHIS,1)-XHDELT)**2
CS     &                 *2*PI)
                   VAL=VALHIS(I+NBEG)/(PI*VDELT(IHIS,1)**2)
                ELSE
                   R1=XHPOS-BEAMREF+0.5*VDELT(IHIS,1)
                   R2=R1-VDELT(IHIS,1)
                   VAL=VALHIS(I+NBEG)/(2*PI*(R1**2-R2**2))
                ENDIF
             ENDIF
             VAL=VAL*VDELT(IHIS,1)
             X = XMARG + NINT(XPIX*(I-1)/N)
             H = YPIX*(VAL-VMIN)/(VMAX-VMIN)
             Y = YPIX-H+YMARG
             CALL F_FILLEDRECTANGLE(X,Y,W,H,NS)
202       CONTINUE
       ELSE
          CALL F_PEN(4,NS)
          DO 205,I=1,N
             X = XMARG + NINT(XPIX*(I-1)/N)
             H = YPIX*(VALHIS(NBEG+I)-VMIN)/(VMAX-VMIN)
             Y = YPIX-H+YMARG
             CALL F_FILLEDRECTANGLE(X,Y,W,H,NS)
205       CONTINUE
       ENDIF

       IF (CVALUE(IHIS)(1:3).EQ.'TEB') THEN
*         DRAW BEAM SIZE OF TRANSMITTED ELECTRONS INTO HISTOGRAM
          CALL F_PEN(31,NS)
          YT=YMARG
          YB=YMARG+YPIX
          IF (BPORL.LT.VALMIN(IHIS,1)) THEN
             BPORL=VALMIN(IHIS,1)
             XL=XMARG
             GOTO 210
          ENDIF
          XL=XMARG+XPIX*(BPORL-VALMIN(IHIS,1))/
     &       (VALMAX(IHIS,1)-VALMIN(IHIS,1))
          CALL F_MOVE (XL,YT,NS)
          CALL F_LINETO (XL,YB,NS)
 210      IF (BPORR.GT.VALMAX(IHIS,1)) THEN
             BPORR=VALMAX(IHIS,1)
             XR=XMARG+XPIX
             GOTO 220
          ENDIF
          XR=XMARG+XPIX*(BPORR-VALMIN(IHIS,1))/
     &       (VALMAX(IHIS,1)-VALMIN(IHIS,1))
          CALL F_MOVE (XR,YT,NS)
          CALL F_LINETO (XR,YB,NS)
 220      YY=YT+0.2*(YB-YT)
          CALL F_MOVE (XL,YY,NS)
          CALL F_LINETO (XR,YY,NS)
          BPDIFF=BPORR-BPORL
          IF (SUMREL.LT.0.9) THEN
             IF (BPDIFF.LT.9.99E6) THEN
                WRITE(STRING,'(A,F9.2)') 'Beam > ',BPDIFF
             ELSE
                WRITE(STRING,'(A,G9.2)') 'Beam > ',BPDIFF
             ENDIF
             IE=IEND(STRING)
             WRITE(STRING(IE+1:IE+2),'(A)') ' '
             XX=XL+0.38*(XR-XL)
          ELSE
             IF (BPDIFF.LT.9.99E6) THEN
                WRITE(STRING,'(F9.2)') BPDIFF
             ELSE
                WRITE(STRING,'(G9.2)') BPDIFF
             ENDIF
             IE=IEND(STRING)
             WRITE(STRING(IE+1:IE+2),'(A)') ' '
             XX=XL+0.45*(XR-XL)
          ENDIF
          CALL F_DRAWSTRING(XX,YY-7.D0,STRING)
       ENDIF

*       CALL F_FSHOW(NS)
1000   CONTINUE

       RETURN
       END

****************************************************************************

      SUBROUTINE DRWSPE(
     I			 IHIS,IHISBK,ANORM
     O			 )

       INCLUDE 'TYPE.INC'
       INCLUDE 'PARAM.INC'
       INCLUDE 'HIST.INC'
       INCLUDE 'OUTPUT.INC'

       INTEGER IHIS,IHISBK
       DOUBLE PRECISION VMIN,VMAX

***    DRWSPE - DRAWS SPECTRUM CONSISTING OF SIGNAL HISTOGRAM (IHIS) AND
*               BACKGROUND HISTOGRAM (IHISBK)
*
**     ARGUMENTS
*
*      IHIS,IHISBK  - HISTOGRAM NUMBER
*      ANORM - NORMALIZATION VALUE (i.e. all values are divided by ANORM)
*
**     AUTHOR: H.WAGNER 28-SEP-95
*

**     START OF EXECUTABLE CODE
*      ************************

       PARAMETER (LMARG=50.,RMARG=20.,TMARG=20.,BMARG=20.)
       PARAMETER (NORD=5)

       DOUBLE PRECISION XVAL(400),YVAL(400)
       DOUBLE PRECISION A(NORD),AERR(NORD)

       CHARACTER*20 STRING 

       XPIX = SCXSIZ(NSCL+IHIS)-LMARG-RMARG
       YPIX = SCYSIZ(NSCL+IHIS)-TMARG-BMARG
       XMARG = LMARG
       YMARG = TMARG

*      GET HISTOGRAM DATA

       N = NVAL(IHIS,1)
       NBEG = IVBEG(IHIS)-1
       NBK = NVAL(IHISBK,1)
       NBEGBK = IVBEG(IHISBK)-1
       DEBK = (VALMAX(IHISBK,1)-VALMIN(IHISBK,1))/DBLE(NBK)
       DE   = (VALMAX(IHIS,1)-VALMIN(IHIS,1))/DBLE(N)
       
       IF (N .GT. 400 .OR. NBK .GT. 400) THEN
      	  WRITE(*,*) 'DRWSPE: ******* WARNING HISTOGRAM # ',IHIS
          WRITE(*,*) 'MAX. NUMBER OF DATA POINTS EXCEEDED'
          WRITE(*,*) 'SPECTRUM NOT DRAWN.'
          GOTO 1000
       ENDIF


*	CALCULATE ENERGY VALUES OF BACKGROUND

       DO 50,I=1,NBK
        XVAL(I)=DEBK*(DBLE(I)-.5)+VALMIN(IHISBK,1)
50     CONTINUE         

*      FIT POLYNOMIAL OF ORDER <NORD>

       CALL POLYFIT(XVAL,VALHIS(NBEGBK+1),NBK,A,AERR,NORD)

*      CALCULATE ENERGY VALUES OF SIGNAL

       DO 60,I=1,N
        XVAL(I)=DE*(DBLE(I)-.5)+VALMIN(IHIS,1)
60     CONTINUE         

*      CALCULATE FITTED BACKGROUND

       CALL POLY(XVAL,YVAL,N,A,NORD)
       
*      ADD SIGNAL TO BACKGROUND

       DO 70,I=1,N
         YVAL(I) = YVAL(I)/DEBK + VALHIS(NBEG+I)/DE
70     CONTINUE

*      FIND MAXIMUM AND MINIMUM VALUE
     
       VMAX =  YVAL(1)
       VMIN =  YVAL(1)

       DO 100,I=1,N
         IF (YVAL(I) .GT. VMAX) VMAX = YVAL(I)
         IF (YVAL(I) .LT. VMIN) VMIN = YVAL(I)
100    CONTINUE         

       IF (VMAX .EQ. VMIN) THEN
         VMAX = VMAX + 0.5
         VMIN = VMIN - 0.5
       ENDIF

*      CLEAR WINDOW

       CALL F_OUTPUTTO(NXHIS(IHIS),NS)
       CALL F_CLEAR(NS)

*      PLOT AXES

       CALL F_PEN(1,NS)

       CALL F_RECTANGLE(XMARG,YMARG,XPIX,YPIX,NS)

       WRITE(STRING,'(G9.2)') VALMIN(IHIS,1)
       CALL F_DRAWSTRING(30.D0,YPIX+TMARG+BMARG-8.D0,STRING)
       WRITE(STRING,'(G9.2)') VALMAX(IHIS,1)
       CALL F_DRAWSTRING(XPIX+5.D0,
     .                   YPIX+TMARG+BMARG-8.D0,STRING)


       WRITE(STRING,'(G9.2)') VMAX/ANORM
       CALL F_DRAWSTRING(0.D0,YMARG+12,STRING)
       WRITE(STRING,'(G9.2)') VMIN/ANORM
       CALL F_DRAWSTRING(0.D0,YMARG+YPIX,STRING)
 
*      PLOT DATA

       CALL F_PEN(4,NS)
       W = 1.D0+AINT(XPIX/N)

       DO 200,I=1,N

        X = XMARG + NINT(XPIX*(I-1)/N)
        H = YPIX*(YVAL(I)-VMIN)/(VMAX-VMIN)
        Y = YPIX-H+YMARG
        IF (I.EQ.1) THEN
          CALL F_MOVE(X,Y,NS)
        ELSE
          CALL F_FLINETO(X,Y,NS)
        ENDIF

200    CONTINUE

       CALL F_FSHOW(NS)
1000   CONTINUE
       END

       SUBROUTINE DENSPLOT(
     I	 		   IHIS,ANORM
     O			   )

       INCLUDE 'TYPE.INC'
       INCLUDE 'PARAM.INC'
       INCLUDE 'HIST.INC'
       INCLUDE 'OUTPUT.INC'

       INTEGER IHIS
       DOUBLE PRECISION VMIN,VMAX

***    DENSPLOT - DRAWS DENSITY PLOT OF HISTOGRAM TO SCREEN
*
**     ARGUMENTS
*
*      IHIS  - HISTOGRAM NUMBER
*      ANORM - NORMALIZATION VALUE (i.e. all values are divided by ANORM)
*
**     AUTHOR: H.WAGNER 14-JUL-95
*

**     START OF EXECUTABLE CODE
*      ************************

       PARAMETER (LMARG=50.,RMARG=20.,TMARG=20.,BMARG=20.)

       CHARACTER*20 STRING 

       XPIX = SCXSIZ(NSCL+IHIS)-LMARG-RMARG
       YPIX = SCYSIZ(NSCL+IHIS)-TMARG-BMARG
       XMARG = LMARG
       YMARG = TMARG

*      GET HISTOGRAM DATA

       N = NVAL(IHIS,1)
       NBEG = IVBEG(IHIS)-1

*      FIND MAXIMUM AND MINIMUM VALUE
     
       VMAX =  VALHIS(NBEG+1)
       VMIN =  VALHIS(NBEG+1)

       DO 100,I=1,N
         IF (VALHIS(NBEG+I) .GT. VMAX) VMAX = VALHIS(NBEG+I)
         IF (VALHIS(NBEG+I) .LT. VMIN) VMIN = VALHIS(NBEG+I)
100    CONTINUE         

       IF (VMAX .EQ. VMIN) THEN
         VMAX = VMAX + 0.5
         VMIN = VMIN - 0.5
       ENDIF

*      CLEAR WINDOW

       CALL F_OUTPUTTO(NXHIS(IHIS),NS)
       CALL F_CLEAR(NS)

*      PLOT AXES

*      PLOT DATA

       W = 1.D0+AINT(XPIX/N)

*       DO 200,I=1,N
*        ICOL = NINT((NPALET-1)*(VALHIS(NBEG+I)-VMIN)/(VMAX-VMIN))+1
*        CALL F_PEN(NGRAY(ICOL),NS)
*        X = XMARG + NINT(XPIX*(I-1)/N)
*        H = YPIX
*        Y = YMARG
*        CALL F_FILLEDRECTANGLE(X,Y,W,H,NS)
*200    CONTINUE
       H=YPIX
       DO 200,I=1,N-1
        VAL1 = (VALHIS(NBEG+I)-VMIN)/(VMAX-VMIN)
        VAL2 = (VALHIS(NBEG+I+1)-VMIN)/(VMAX-VMIN)
        X1 = XMARG + NINT(XPIX*(I-1)/N)
        X2 = XMARG + NINT(XPIX*(I)/N)
        IF (X2 .GT. X1) THEN
          DO 210 J=0,X2-X1
             VAL = VAL1+(VAL2-VAL1)/DBLE(X2-X1)*DBLE(J)
             ICOL = NINT((NPALET-1)*VAL)+1
             CALL F_PEN(NGRAY(ICOL),NS)
             CALL F_LINE(X1+J,Y,X1+J,Y+H,NS)
210       CONTINUE
        ENDIF
200    CONTINUE

*       CALL F_FSHOW(NS)
       END



      SUBROUTINE DRWION(
     I			 ILOC,X,Y,Z,IELE,ISHELL
     O			 )

       INCLUDE 'TYPE.INC'
       INCLUDE 'PARAM.INC'
       INCLUDE 'HIST.INC'
       INCLUDE 'OUTPUT.INC'
       

***    DRWION - DRAWS AN IONIZATION EVENT TO SCREEN/POSTFILE
*
**     ARGUMENTS
*
*      ILOC : LOCATION DEPENDENT SCREEN. 
*	      IF ILOC=0 THEN USE ACTUAL SCREEN, AND PIXEL COODINATES X,Y
*
**     AUTHOR: H.WAGNER 19-DEC-95
*

**     START OF EXECUTABLE CODE
*      ************************

        IF (ILOC .GT. 0) THEN
          CALL F_OUTPUTTO(NXLOC(ILOC),NS)
          CALL TRNXYZ(ILOC,X,Y,Z,XX,XY)
        ELSE
      	  XX = X
          XY = Y
        ENDIF
        CALL F_PEN(IONCOL(IELE),NS)
        GOTO (100,200,200,200,300,300,300,300,300,400) ISHELL

        WRITE (*,*) 'ILLEGAL SHELL IN  DRWION'
        STOP

* K-SHELL
100     CALL F_FFILLEDCIRCLE(XX,XY,4.D0,NS)
        GOTO 500

* L-SHELL
200     CALL F_FFILLEDTRIANGLE(XX,XY-4.,XX+4.6,XY+4.,XX-4.6,XY+4.,NS)
        GOTO 500

* M-SHELL
300     CALL F_FFILLEDRECTANGLES(XX-4.,XY-4.,XX+4.,XY+4.,NS)
        GOTO 500

* N-SHELL
400     CALL F_FFILLEDTRIANGLE(XX,XY+4.,XX+4.6,XY-4.,XX-4.6,XY-4.,NS)
        GOTO 500

500   CALL F_PEN(1,NS)
      END



      SUBROUTINE DRWAXS(
     I			 ILOC
     O			 )

***    DRWAXS - DRAWS AXIS IN LOCATION DEPENDANT SCREENS
*
**     ARGUMENTS
*
*      ILOC : LOCATION DEPENDENT SCREEN. 
*
**     AUTHOR: H.WAGNER 25-SEP-95
*
       INCLUDE 'TYPE.INC'
       INCLUDE 'PARAM.INC'
       INCLUDE 'HIST.INC'
       INCLUDE 'OUTPUT.INC'

**     START OF EXECUTABLE CODE
*      ************************
*
      CHARACTER*40 CBUFF
      CALL F_OUTPUTTO(NXLOC(ILOC),NS)
      

      X1 = SCMNMX(1,ILOC)
      Z1 = SCMNMX(3,ILOC)
      DX = SCMNMX(2,ILOC)-SCMNMX(1,ILOC)
      DZ= SCMNMX(4,ILOC)-SCMNMX(3,ILOC)



      IF (DX .LT. DZ) THEN
         DD = DX
      ELSE
         DD = DZ
      ENDIF
      
      DSTP = 0.1
100   CONTINUE      
      DSTP = DSTP * 10.D0     
      IF (2*DSTP .LE. DD) GOTO 100

      DSTP = DSTP/10.
      IF (DSTP .LT. 1000) THEN
        WRITE(CBUFF,'(G9.1)') DSTP
        CALL F_DRAWSTRING(20.D0,20.D0,CBUFF(1:IEND(CBUFF))//
     .		         ' Ang per unit')
      ELSE
        WRITE(CBUFF,'(G9.1)') DSTP/10000.
        CALL F_DRAWSTRING(20.D0,20.D0,CBUFF(1:IEND(CBUFF))//
     .			 ' Microns per unit')
      ENDIF
C     *DRAW X-AXIS
      ICOL = 1        
      X    = DSTP*NINT(X1/DSTP-.5D0)

200   CONTINUE
        CALL TRNXYZ(ILOC,X,Y,Z,XX,XY)
        CALL TRNXYZ(ILOC,X+DSTP,Y,Z,XX2,XY)
        IF (ICOL .EQ. 1) THEN
           CALL F_PEN(1,NS)
           CALL F_FILLEDRECTANGLES(XX,0.D0,XX2,5.D0,NS)
        ELSE
           CALL F_PEN(0,NS)
           CALL F_FILLEDRECTANGLES(XX,0.D0,XX2,5.D0,NS)
           CALL F_PEN(1,NS)
           CALL F_RECTANGLES(XX,0.D0,XX2,5.D0,NS)
        ENDIF
        X = X + DSTP
        ICOL = 1-ICOL
      IF (X .LE. SCMNMX(2,ILOC)) GOTO 200

      ICOL = 1
      Z    = DSTP*NINT(Z1/DSTP-.5D0)

300   CONTINUE
        CALL TRNXYZ(ILOC,X,Y,Z,XX,XY)
        CALL TRNXYZ(ILOC,X,Y,Z+DSTP,XX,XY2)
        IF (ICOL .EQ. 1) THEN
           CALL F_PEN(1,NS)
           CALL F_FILLEDRECTANGLES(0.D0,XY,5.D0,XY2,NS)
        ELSE
           CALL F_PEN(0,NS)
           CALL F_FILLEDRECTANGLES(0.D0,XY,5.D0,XY2,NS)
           CALL F_PEN(1,NS)
           CALL F_RECTANGLES(0.D0,XY,5.D0,XY2,NS)
        ENDIF
        Z = Z + DSTP
        ICOL = 1-ICOL
      IF (Z .LE. SCMNMX(4,ILOC)) GOTO 300

      END
