c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
*last modification: 09-Dec-1996

      SUBROUTINE DRWLDH(
     I			 MODE,JCOUNT,ILAST,
     I                   ISHTAB,IXCTAB,ILDH,ISCR,IXDET,I10LOG,
     I			 VALION,XCABS)

***    DRWLDH - DRAWS LOCATION DEPENDENT HISTOGRAMS TO SCREEN FOR
*               IONIZATIONS, GENERATED AND DETECTED CHAR. X-RAY DISTRIBUTIONS
*
**     ARGUMENTS
*
*      MODE   - 1: IONIZATION DISTRIBUTION
*               2: GENERATED CHAR. X-RAYS
*               3: DETECTED CHAR. X-RAYS
*      JCOUNT - COUNTER FOR OUTPUT ADDED UP IN ONE SCREEN
*      ILAST  - IF SET TO 1 THEN ACTUALLY UPDATE THE SCREEN ISCR
*      ISHTAB - INDEX IN SHELL TABLE
*      IXCTAB - INDEX IN XCHAR TABLE
*      ILDH   - INDEX IN VALION()
*      ISCR   - SCREEN NUMBER
*      IXDET  - X-RAY DETECTOR NUMBER
*      I10LOG - IF 0 THEN LINEAR SCALE, ELSE LOGARITHMIC SCALE
*
**     AUTHOR: C. SCHIEBL 6-FEB-95
*
       INCLUDE 'TYPE.INC'
       INCLUDE 'PARAM.INC'
       INCLUDE 'COMMON.INC'
       INCLUDE 'GLOBAL.INC'
       INCLUDE 'HIST.INC'
       INCLUDE 'OUTPUT.INC'
       INCLUDE 'DMA.INC'

*      HISTOGRAM FOR IONISATIONS
       DOUBLE PRECISION VALION(NDMASHELL,
     &                         NDMAXGRID,NDMAZGRID,NDMAYGRID)
*      ABSORPTION FACTORS (FOR CHARACTERISTIC AND BACKGROUND RADIATION)
       DOUBLE PRECISION XCABS(0:NDMAXDET-1,NDMAXCONT+NDMAXCHAR-NDMAPTOB,
     &                       NDMAXGRID,NDMAZGRID,NDMAYGRID)

       DOUBLE PRECISION VHELP(1)
       POINTER (P2VHELP,VHELP)
       SAVE P2VHELPS


**     START OF EXECUTABLE CODE
*      ************************

       CALL CHKBND(2,NGRIDX,'DRWLDH    ','XGRIDL')
       CALL CHKBND(3,NGRIDZ,'DRWLDH    ','ZGRIDL')
       CALL CHKBND(4,NGRIDY,'DRWLDH    ','YGRIDL')
       CALL CHKBND(6,IXCTAB,'DRWLDH    ','FYIELDOFXCHAR')

*      RESET THE HELP ARRAY
       IF (JCOUNT.EQ.1) THEN
*         ALLOCATE MEMORY FOR VHELP
          NALLOC1=NGRIDX*NGRIDZ*NGRIDY
          P2VHELP=MALLOC(SIZEOF(VHELP(1))*NALLOC1)
          IF (P2VHELP.EQ.0) THEN
             WRITE(6,'(A)')'     '
             WRITE(6,'(A)')' *** ERROR ***'
             WRITE(6,'(2A)')' DRWLDH: Could not allocate memory',
     &                      ' for VHELP !'
             STOP
          ENDIF
          DO 3 I=1,NGRIDX
             DO 2 J=1,NGRIDZ
                DO 1 K=1,NGRIDY
                   INDX=NDMAXGRID*NDMAZGRID*(K-1)+NDMAXGRID*(J-1)+I
                   IF (INDX.GT.NALLOC1) THEN
                      WRITE(6,'(A)')'     '
                      WRITE(6,'(A)')' *** WARNING ***'
                      WRITE(6,'(A)')' INIT_MAC: INDEX > NALLOC1'
                   ENDIF
                   VHELP(INDX)=0
 1              CONTINUE
 2           CONTINUE
 3        CONTINUE
       ENDIF

       IF (MODE.EQ.1) FMULT=1
       IF ((MODE.EQ.2).OR.(MODE.EQ.3)) FMULT=FYIELDOFXCHAR(IXCTAB)

       IF ((MODE.EQ.1).OR.(MODE.EQ.2)) THEN
          DO 6 I=1,NGRIDX
             DO 5 J=1,NGRIDZ
                DO 4 K=1,NGRIDY
                   INDX=NDMAXGRID*NDMAZGRID*(K-1)+NDMAXGRID*(J-1)+I
                   IF (INDX.GT.NALLOC1) THEN
                      WRITE(6,'(A)')'     '
                      WRITE(6,'(A)')' *** WARNING ***'
                      WRITE(6,'(A)')' INIT_MAC: INDEX > NALLOC1'
                   ENDIF
                   VHELP(INDX)=VHELP(INDX)+VALION(ILDH,I,J,K)*FMULT
 4              CONTINUE
 5           CONTINUE
 6        CONTINUE
       ENDIF

       IF (MODE.EQ.3) THEN
          DO 9 I=1,NGRIDX
             DO 8 J=1,NGRIDZ
                DO 7 K=1,NGRIDY
                   INDX=NDMAXGRID*NDMAZGRID*(K-1)+NDMAXGRID*(J-1)+I
                   IF (INDX.GT.NALLOC1) THEN
                      WRITE(6,'(A)')'     '
                      WRITE(6,'(A)')' *** WARNING ***'
                      WRITE(6,'(A)')' INIT_MAC: INDEX > NALLOC1'
                   ENDIF
                   VHELP(INDX)=VHELP(INDX)+VALION(ILDH,I,J,K)*FMULT*
     &                         XCABS(IXDET,IXCTAB,I,J,K)
 7              CONTINUE
 8           CONTINUE
 9        CONTINUE
       ENDIF
*      ---CHECK ILDH AND ISCR - BUT ONLY WHEN ACTUALLY SUPPOSED TO UPDATE SCREEN
       IF (ILAST.EQ.1) THEN
          IF (ILDH.LT.1) THEN
             WRITE(6,'(A)')'     '
             WRITE(6,'(A)')' %%% WARNING %%%'
             WRITE(6,'(2A)')' LOCATION DEPENDENT HISTOGRAM NUMBER ',
     &                      'OUT OF RANGE !'
             WRITE(6,'(A)')' LOCATION: DRWLDH '
             GOTO 900
          ENDIF
          IF (ISCR.LT.1) THEN
             WRITE(6,'(A)')'     '
             WRITE(6,'(A)')' %%% WARNING %%%'
             WRITE(6,'(2A)')' LOCATION DEPENDENT HISTOGRAM SCREEN ',
     &                      'NUMBER OUT OF RANGE !'
             WRITE(6,'(A)')' LOCATION: DRWLDH '
             GOTO 900
          ENDIF

*         ---DETERMINE MAX AND MIN OF VHELP
          VMAX=VHELP(1)
          VMIN=VHELP(1)
          DO 20 I=1,NGRIDX
             DO 17 J=1,NGRIDZ
                DO 15 K=1,NGRIDY
                   INDX=NDMAXGRID*NDMAZGRID*(K-1)+NDMAXGRID*(J-1)+I
                   IF (INDX.GT.NALLOC1) THEN
                      WRITE(6,'(A)')'     '
                      WRITE(6,'(A)')' *** WARNING ***'
                      WRITE(6,'(A)')' INIT_MAC: INDEX > NALLOC1'
                   ENDIF
                   IF (I.EQ.1) THEN
                      VHELP(INDX)=VHELP(INDX)*2
                      IF ((J.EQ.1).OR.(J.EQ.NGRIDZ)) THEN
                         VHELP(INDX)=VHELP(INDX)*2
                         GOTO 10
                      ENDIF
                   ELSE IF (I.EQ.NGRIDX) THEN
                      VHELP(INDX)=VHELP(INDX)*2
                      IF ((J.EQ.1).OR.(J.EQ.NGRIDZ)) THEN
                         VHELP(INDX)=VHELP(INDX)*2
                         GOTO 10
                      ENDIF
                   ENDIF
                   IF ((J.EQ.1).OR.(J.EQ.NGRIDZ)) THEN
                      VHELP(INDX)=VHELP(INDX)*2
                   ENDIF
 10                IF (VHELP(INDX).GT.VMAX) VMAX=VHELP(INDX)
                   IF (VHELP(INDX).LT.VMIN) VMIN=VHELP(INDX)
 15             CONTINUE
 17          CONTINUE
 20       CONTINUE

*         ---DETERMINE SCREEN
          CALL F_OUTPUTTO(NXLOC(ISCR),NS)

*         ---OUTPUT TO SCREEN
*         ONLY ONE GRID LINE IN Y-DIRECTION
CS        FOR THE TIME BEING THIS SHALL BE THE FIRST GRID LINE IN Y-DIRECTION
          KY=1
          IF (I10LOG.EQ.0) THEN
            DO 120 I=1,NGRIDX
              DO 110 J=1,NGRIDZ
                INDX=NDMAXGRID*NDMAZGRID*(KY-1)+NDMAXGRID*(J-1)+I
                IF (INDX.GT.NALLOC1) THEN
                   WRITE(6,'(A)')'     '
                   WRITE(6,'(A)')' *** WARNING ***'
                   WRITE(6,'(A)')' INIT_MAC: INDEX > NALLOC1'
                ENDIF
                IF (VHELP(INDX).LE.0) GOTO 110
*               DETERMINE COLOR
                ICOL=1+NINT((NPALET-1.)*(VHELP(INDX)-VMIN)/
     &                     (VMAX-VMIN))
                ICOL=IACTICOL(ICOL)
                CALL F_PEN(NCOLOR(ICOL),NS)
                IF ((I.EQ.1).OR.(J.EQ.1).OR.
     &              (I.EQ.NGRIDX).OR.(J.EQ.NGRIDZ)) THEN
                   IF (I.EQ.1) THEN
CS                      XG1=XGRIDL(1)-(XGRIDL(2)-XGRIDL(1))/2
                      XG1=XGRIDL(1)
                      XG2=XGRIDL(I)+(XGRIDL(I+1)-XGRIDL(I))/2
                      IF (J.EQ.1) THEN
CS                         ZG1=ZGRIDL(J)-(ZGRIDL(J+1)-ZGRIDL(J))/2
                         ZG1=ZGRIDL(J)
                         ZG2=ZGRIDL(J)+(ZGRIDL(J+1)-ZGRIDL(J))/2
                      ELSE IF (J.EQ.NGRIDZ) THEN
                         ZG1=ZGRIDL(J)-(ZGRIDL(J)-ZGRIDL(J-1))/2
                         ZG2=ZGRIDL(J)
CS                         ZG2=ZGRIDL(J)+(ZGRIDL(J)-ZGRIDL(J-1))/2
                      ELSE
                         ZG1=ZGRIDL(J)-(ZGRIDL(J)-ZGRIDL(J-1))/2
                         ZG2=ZGRIDL(J)+(ZGRIDL(J+1)-ZGRIDL(J))/2
                      ENDIF
                   ELSE IF (I.EQ.NGRIDX) THEN
                      XG1=XGRIDL(I)-(XGRIDL(I)-XGRIDL(I-1))/2
CS                      XG2=XGRIDL(I)+(XGRIDL(I)-XGRIDL(I-1))/2
                      XG2=XGRIDL(I)
                      IF (J.EQ.1) THEN
CS                         ZG1=ZGRIDL(J)-(ZGRIDL(J+1)-ZGRIDL(J))/2
                         ZG1=ZGRIDL(J)
                         ZG2=ZGRIDL(J)+(ZGRIDL(J+1)-ZGRIDL(J))/2
                      ELSE IF (J.EQ.NGRIDZ) THEN
                         ZG1=ZGRIDL(J)-(ZGRIDL(J)-ZGRIDL(J-1))/2
CS                         ZG2=ZGRIDL(J)+(ZGRIDL(J)-ZGRIDL(J-1))/2
                         ZG2=ZGRIDL(J)
                      ELSE
                         ZG1=ZGRIDL(J)-(ZGRIDL(J)-ZGRIDL(J-1))/2
                         ZG2=ZGRIDL(J)+(ZGRIDL(J+1)-ZGRIDL(J))/2
                      ENDIF
                   ENDIF
                   IF (J.EQ.1) THEN
CS                      ZG1=ZGRIDL(1)-(ZGRIDL(2)-ZGRIDL(1))/2
                      ZG1=ZGRIDL(1)
                      ZG2=ZGRIDL(J)+(ZGRIDL(J+1)-ZGRIDL(J))/2
                      IF (I.EQ.1) THEN
CS                         XG1=XGRIDL(I)-(XGRIDL(I+1)-XGRIDL(I))/2
                         XG1=XGRIDL(I)
                         XG2=XGRIDL(I)+(XGRIDL(I+1)-XGRIDL(I))/2
                      ELSE IF (I.EQ.NGRIDX) THEN
                         XG1=XGRIDL(I)-(XGRIDL(I)-XGRIDL(I-1))/2
CS                         XG2=XGRIDL(I)+(XGRIDL(I)-XGRIDL(I-1))/2
                         XG2=XGRIDL(I)
                      ELSE
                         XG1=XGRIDL(I)-(XGRIDL(I)-XGRIDL(I-1))/2
                         XG2=XGRIDL(I)+(XGRIDL(I+1)-XGRIDL(I))/2
                      ENDIF
                   ELSE IF (J.EQ.NGRIDZ) THEN
                      ZG1=ZGRIDL(J)-(ZGRIDL(J)-ZGRIDL(J-1))/2
CS                      ZG2=ZGRIDL(J)+(ZGRIDL(J)-ZGRIDL(J-1))/2
                      ZG2=ZGRIDL(J)
                      IF (I.EQ.1) THEN
CS                         XG1=XGRIDL(I)-(XGRIDL(I+1)-XGRIDL(I))/2
                         XG1=XGRIDL(I)
                         XG2=XGRIDL(I)+(XGRIDL(I+1)-XGRIDL(I))/2
                      ELSE IF (I.EQ.NGRIDX) THEN
                         XG1=XGRIDL(I)-(XGRIDL(I)-XGRIDL(I-1))/2
CS                         XG2=XGRIDL(I)+(XGRIDL(I)-XGRIDL(I-1))/2
                         XG2=XGRIDL(I)
                      ELSE
                         XG1=XGRIDL(I)-(XGRIDL(I)-XGRIDL(I-1))/2
                         XG2=XGRIDL(I)+(XGRIDL(I+1)-XGRIDL(I))/2
                      ENDIF
                   ENDIF
                ELSE
                   XG1=XGRIDL(I)-(XGRIDL(I)-XGRIDL(I-1))/2
                   ZG1=ZGRIDL(J)-(ZGRIDL(J)-ZGRIDL(J-1))/2
                   XG2=XGRIDL(I)+(XGRIDL(I+1)-XGRIDL(I))/2
                   ZG2=ZGRIDL(J)+(ZGRIDL(J+1)-ZGRIDL(J))/2
                ENDIF
                CALL TRNXYZ(ISCR,XG1,0.D0,ZG1,X1,Y1)
                CALL TRNXYZ(ISCR,XG2,0.D0,ZG2,X2,Y2)
cs                 x1=xg1
cs                 y1=zg1
cs                 x2=xg2
cs                 y2=zg2
c                CALL F_MOVE(X1,Y1,idmy)
c                CALL F_LINETO(X2,y2,idmy)
                WIDTH=DABS(X2-X1)
                HEIGHT=DABS(Y2-Y1)
cs                X1=X1+WIDTH/2
cs                Y1=Y1+HEIGHT/2
                X1=X1
                Y1=Y1
cs-test
cs                write(6,'(4f18.5)')x1,y1,width,height
                CALL F_FILLEDRECTANGLE(X1,Y1,WIDTH,HEIGHT,IDMY)
c                CALL F_FILLEDRECTANGLES(X1,Y1,X2,Y2,IDMY)
 110          CONTINUE
 120        CONTINUE
          ELSE
            IF (VMAX.LE.0) GOTO 150
cs-test
cs            write(6,*)' screen#: ',iscr
cs            write(6,*)' input basis for LOG'
cs            read(*,*)baselog
            BASELOG=DBLE(I10LOG)/1E6
C            IF (BASELOG.LT.1) BASELOG=1.0001
            BSLG=DLOG10(BASELOG)
            IPLMAX=NPALET-INT(DLOG10(VMAX)/BSLG)
            DO 140 I=1,NGRIDX
              DO 130 J=1,NGRIDZ
                INDX=NDMAXGRID*NDMAZGRID*(KY-1)+NDMAXGRID*(J-1)+I
                IF (INDX.GT.NALLOC1) THEN
                   WRITE(6,'(A)')'     '
                   WRITE(6,'(A)')' *** WARNING ***'
                   WRITE(6,'(A)')' INIT_MAC: INDEX > NALLOC1'
                ENDIF
                IF (VHELP(INDX).LE.0) GOTO 130
*               DETERMINE COLOR
                ICOL=IPLMAX+INT(DLOG10(VHELP(INDX))/BSLG)
                IF (ICOL.LT.1) ICOL=1
                if (icol.gt.npalet) write(6,*)' icol > npalet !'
                ICOL=IACTICOL(ICOL)
                CALL F_PEN(NCOLOR(ICOL),NS)
                IF ((I.EQ.1).OR.(J.EQ.1).OR.
     &              (I.EQ.NGRIDX).OR.(J.EQ.NGRIDZ)) THEN
                   IF (I.EQ.1) THEN
CS                      XG1=XGRIDL(1)-(XGRIDL(2)-XGRIDL(1))/2
                      XG1=XGRIDL(1)
                      XG2=XGRIDL(I)+(XGRIDL(I+1)-XGRIDL(I))/2
                      IF (J.EQ.1) THEN
CS                         ZG1=ZGRIDL(J)-(ZGRIDL(J+1)-ZGRIDL(J))/2
                         ZG1=ZGRIDL(J)
                         ZG2=ZGRIDL(J)+(ZGRIDL(J+1)-ZGRIDL(J))/2
                      ELSE IF (J.EQ.NGRIDZ) THEN
                         ZG1=ZGRIDL(J)-(ZGRIDL(J)-ZGRIDL(J-1))/2
                         ZG2=ZGRIDL(J)
CS                         ZG2=ZGRIDL(J)+(ZGRIDL(J)-ZGRIDL(J-1))/2
                      ELSE
                         ZG1=ZGRIDL(J)-(ZGRIDL(J)-ZGRIDL(J-1))/2
                         ZG2=ZGRIDL(J)+(ZGRIDL(J+1)-ZGRIDL(J))/2
                      ENDIF
                   ELSE IF (I.EQ.NGRIDX) THEN
                      XG1=XGRIDL(I)-(XGRIDL(I)-XGRIDL(I-1))/2
CS                      XG2=XGRIDL(I)+(XGRIDL(I)-XGRIDL(I-1))/2
                      XG2=XGRIDL(I)
                      IF (J.EQ.1) THEN
CS                         ZG1=ZGRIDL(J)-(ZGRIDL(J+1)-ZGRIDL(J))/2
                         ZG1=ZGRIDL(J)
                         ZG2=ZGRIDL(J)+(ZGRIDL(J+1)-ZGRIDL(J))/2
                      ELSE IF (J.EQ.NGRIDZ) THEN
                         ZG1=ZGRIDL(J)-(ZGRIDL(J)-ZGRIDL(J-1))/2
CS                         ZG2=ZGRIDL(J)+(ZGRIDL(J)-ZGRIDL(J-1))/2
                         ZG2=ZGRIDL(J)
                      ELSE
                         ZG1=ZGRIDL(J)-(ZGRIDL(J)-ZGRIDL(J-1))/2
                         ZG2=ZGRIDL(J)+(ZGRIDL(J+1)-ZGRIDL(J))/2
                      ENDIF
                   ENDIF
                   IF (J.EQ.1) THEN
CS                      ZG1=ZGRIDL(1)-(ZGRIDL(2)-ZGRIDL(1))/2
                      ZG1=ZGRIDL(1)
                      ZG2=ZGRIDL(J)+(ZGRIDL(J+1)-ZGRIDL(J))/2
                      IF (I.EQ.1) THEN
CS                         XG1=XGRIDL(I)-(XGRIDL(I+1)-XGRIDL(I))/2
                         XG1=XGRIDL(I)
                         XG2=XGRIDL(I)+(XGRIDL(I+1)-XGRIDL(I))/2
                      ELSE IF (I.EQ.NGRIDX) THEN
                         XG1=XGRIDL(I)-(XGRIDL(I)-XGRIDL(I-1))/2
CS                         XG2=XGRIDL(I)+(XGRIDL(I)-XGRIDL(I-1))/2
                         XG2=XGRIDL(I)
                      ELSE
                         XG1=XGRIDL(I)-(XGRIDL(I)-XGRIDL(I-1))/2
                         XG2=XGRIDL(I)+(XGRIDL(I+1)-XGRIDL(I))/2
                      ENDIF
                   ELSE IF (J.EQ.NGRIDZ) THEN
                      ZG1=ZGRIDL(J)-(ZGRIDL(J)-ZGRIDL(J-1))/2
CS                      ZG2=ZGRIDL(J)+(ZGRIDL(J)-ZGRIDL(J-1))/2
                      ZG2=ZGRIDL(J)
                      IF (I.EQ.1) THEN
CS                         XG1=XGRIDL(I)-(XGRIDL(I+1)-XGRIDL(I))/2
                         XG1=XGRIDL(I)
                         XG2=XGRIDL(I)+(XGRIDL(I+1)-XGRIDL(I))/2
                      ELSE IF (I.EQ.NGRIDX) THEN
                         XG1=XGRIDL(I)-(XGRIDL(I)-XGRIDL(I-1))/2
CS                         XG2=XGRIDL(I)+(XGRIDL(I)-XGRIDL(I-1))/2
                         XG2=XGRIDL(I)
                      ELSE
                         XG1=XGRIDL(I)-(XGRIDL(I)-XGRIDL(I-1))/2
                         XG2=XGRIDL(I)+(XGRIDL(I+1)-XGRIDL(I))/2
                      ENDIF
                   ENDIF
                ELSE
                   XG1=XGRIDL(I)-(XGRIDL(I)-XGRIDL(I-1))/2
                   ZG1=ZGRIDL(J)-(ZGRIDL(J)-ZGRIDL(J-1))/2
                   XG2=XGRIDL(I)+(XGRIDL(I+1)-XGRIDL(I))/2
                   ZG2=ZGRIDL(J)+(ZGRIDL(J+1)-ZGRIDL(J))/2
                ENDIF
                CALL TRNXYZ(ISCR,XG1,0.D0,ZG1,X1,Y1)
                CALL TRNXYZ(ISCR,XG2,0.D0,ZG2,X2,Y2)
cs                 x1=xg1
cs                 y1=zg1
cs                 x2=xg2
cs                 y2=zg2
c                CALL F_MOVE(X1,Y1,idmy)
c                CALL F_LINETO(X2,y2,idmy)
                WIDTH=DABS(X2-X1)
                HEIGHT=DABS(Y2-Y1)
cs                X1=X1+WIDTH/2
cs                Y1=Y1+HEIGHT/2
                X1=X1
                Y1=Y1
cs-test
cs                write(6,'(4f18.5)')x1,y1,width,height
                CALL F_FILLEDRECTANGLE(X1,Y1,WIDTH,HEIGHT,IDMY)
c                CALL F_FILLEDRECTANGLES(X1,Y1,X2,Y2,IDMY)
 130          CONTINUE
 140        CONTINUE
          ENDIF

*         SET STANDARD PEN SETTINGS
 150      CALL F_PEN(1,NS)
       ENDIF

 900   RETURN
       END

******************************************************************************

       SUBROUTINE DRWGRD (ISCR,NS)

***    DRWGRD - DRAWS THE GRID TO THE SCREEN
*
**     ARGUMENTS
*
*      ISCR  - SCREEN NUMBER
*      NS    - XPGP DEVICE NUMBER
*
**     AUTHOR: C. SCHIEBL 3-NOV-95
*
       INCLUDE 'TYPE.INC'
       INCLUDE 'PARAM.INC'
       INCLUDE 'COMMON.INC'


**     START OF EXECUTABLE CODE
*      ************************

       CALL CHKBND(2,NGRIDX,'DRWGRD','XGRIDL')
       CALL CHKBND(3,NGRIDZ,'DRWGRD','ZGRIDL')
       CALL CHKBND(4,NGRIDY,'DRWGRD','YGRIDL')

*      SET PEN COLOR
       CALL F_PEN(6,NS)
*      SET LINE WIDTH
       CALL F_SETLINEWIDTH(0.5D0,NS)

*      ALL VERTICAL GRID LINES
       DO 40 I=1,NGRIDX
          CALL TRNXYZ(ISCR,XGRIDL(I),0.D0,ZGRIDL(1),X1,Y1)
          CALL F_MOVE(X1,Y1,NS)
          CALL TRNXYZ(ISCR,XGRIDL(I),0.D0,ZGRIDL(NGRIDZ),X1,Y1)
          CALL F_FLINETO(X1,Y1,NS)
 40    CONTINUE

*      ALL HORIZONTAL GRID LINES
       DO 80 I=1,NGRIDZ
          CALL TRNXYZ(ISCR,XGRIDL(1),0.D0,ZGRIDL(I),X1,Y1)
          CALL F_MOVE(X1,Y1,NS)
          CALL TRNXYZ(ISCR,XGRIDL(NGRIDX),0.D0,ZGRIDL(I),X1,Y1)
          CALL F_FLINETO(X1,Y1,NS)
 80    CONTINUE

       CALL F_FSHOW(NS)

*      SET STANDARD SETTINGS
       CALL F_PEN(1,NS)
       CALL F_SETLINEWIDTH(1.0D0,NS)

       RETURN
       END
