c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
* last modification 24-Mar-1997

      SUBROUTINE EXTOUT (
     I			 MODE1,MODE2,N,K,CBUFF,
     I			 XX1,XX2,YY1,YY2,ZZ1,ZZ2,
     V			 N1D,N2D,NDUMMY,RDUMMY,CDUMMY)

      INCLUDE 'TYPE.INC'

***   EXTOUT - EXTRACTS INFORMATION FROM CHARACTER STRINGS SPECIFIED IN THE
*	       OUTPUT NAMELIST (SCREEN,POST,PMSAV,HIST)
*
**    ARGUMENTS
*
*	 MODE1	- 1: SCREEN; 2: POST; 3: PMSAV; 4: HIST
*        MODE2  - 1: LOCATION DEPENDENT
*                 2: NOT LOCATION DEPENDENT
*	 N	- INDEX IN CHARACTER ARRAY
*	 K	- MODE=1: INDEX OF 3 CHARACTERS ABBREVIATION OF POSSIBLE
*			  SCREEN OUTPUT (SEE CTOSCR IN OUTPUT.INC)
*		  MODE=4: HISTOGRAM INDEX
*	 CBUFF	- CHARACTER STRING FROM WHICH TO EXTRACT PARAMETERS
*	 XX1	- MINIMUM IN X DIRECTION (INPUT: DEFAULT VALUE)
*	 XX2	- MAXIMUM IN X DIRECTION (INPUT: DEFAULT VALUE)
*	 YY1	- MINIMUM IN Y DIRECTION (INPUT: DEFAULT VALUE)
*	 YY2	- MAXIMUM IN Y DIRECTION (INPUT: DEFAULT VALUE)
*	 ZZ1	- MINIMUM IN Z DIRECTION (INPUT: DEFAULT VALUE)
*	 ZZ2	- MAXIMUM IN Z DIRECTION (INPUT: DEFAULT VALUE)
*	 N1D	- DUMMY INTEGER
*	 N2D	- DUMMY INTEGER
*	 NDUMMY - DUMMY INTEGER ARRAY
*	 CDUMMY - DUMMY CHARACTER
*
**    REMARKS: NONE
*
**    SIDE EFFECTS: NONE
*
**    AUTHOR:  C. SCHIEBL	 04-NOV-1994
*
      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'GLOBAL.INC'
      INCLUDE 'HIST.INC'
      INCLUDE 'OUTPUT.INC'

      LOGICAL LSEMIC,LCOMMA

      CHARACTER*70 CBUFF,CDUMMY
      CHARACTER*10 CBL
      CHARACTER*3  CDMY
      CHARACTER*1  C1
      DIMENSION IPOS(15),NDUMMY(21),RDUMMY(2*MAXDIM+2)

**    START OF EXECUTABLE CODE
*     ************************

      CBL='          '
      CDMY='DEF'
      DO 10 I=1,21
         NDUMMY(I)=0
 10   CONTINUE
      DO 11 I=1,2*MAXDIM+2
         RDUMMY(I)=0
 11   CONTINUE
      CALL CCAP(CBUFF(1:3),3)

      GOTO (100,200,300,400,500) MODE1

 100  CONTINUE
*     ---EXTRACT PARAMETERS FOR SCREEN OUTPUT
*     INITIALIZE WITH DEFAULT VALUES
      CDUMMY=CBL//CBL//CBL//CBL//CBL//CBL//CBL
      N1D=N
      N2D=0
      RDUMMY(1)=XX1
      RDUMMY(2)=XX2
      RDUMMY(3)=YY1
      RDUMMY(4)=YY2
      RDUMMY(5)=ZZ1
      RDUMMY(6)=ZZ2
      SCMIMA(1,N)=XX1
      SCMIMA(2,N)=XX2
      SCMIMA(3,N)=YY1
      SCMIMA(4,N)=YY2
      SCMIMA(5,N)=ZZ1
      SCMIMA(6,N)=ZZ2
      NDUMMY(1)=NHINT
      IF ((CBUFF(1:3).EQ.'XKS').OR.
     &    (CBUFF(1:3).EQ.'XRS')) NDUMMY(1)=MDEFXCONT
      NDUMMY(2)=1
      NDUMMY(3)=1
      NDUMMY(4)=0
      NDUMMY(5)=0
      NDUMMY(6)=0
      NDUMMY(7)=0
      IFSEMI=0
      ISSEMI=0
      ITSEMI=0
      ISEMIC=IEND(CBUFF)
      LSEMIC=.FALSE.
      CALL FIND (CBUFF,';',4,ISEMIC,IP,IFND)
      IF (IFND.NE.0) THEN
	 LSEMIC=.TRUE.
	 ISEMIC=IP
      ENDIF
      CALL FIND (CBUFF,',',4,ISEMIC,IP,IFND)
      IF ((IFND.EQ.0).AND.(.NOT.LSEMIC)) THEN
         GOTO 131
      ELSE IF ((IFND.EQ.0).AND.(LSEMIC)) THEN
	 GOTO 120
      ENDIF
      I=1
      NPOS=1
      IPOS(I)=IP
 105  IST=IPOS(I)+1
      CALL FIND (CBUFF,',',IST,ISEMIC,IP,IFND)
      IF (IFND.EQ.1) THEN
	 I=I+1
	 IPOS(I)=IP
	 NPOS=NPOS+1
	 GOTO 105
      ENDIF
      IF (LSEMIC) THEN
         IPOS(NPOS+1)=ISEMIC
      ELSE
         IPOS(NPOS+1)=ISEMIC+1
      ENDIF
      IF (NPOS.GT.9) THEN
	 WRITE (6,'(A)')'    '
	 WRITE (6,'(A,I2,A)')' WARNING: ERROR IN SCREEN(',N,')'
	 WRITE (6,'(A)') CBUFF
	 RETURN
      ENDIF
      IF (MODE2.EQ.1) THEN
         IF ((IPOS(2)-IPOS(1)).GT.1) THEN
*           READ SCREEN NUMBER
            READ(CBUFF(IPOS(1)+1:IPOS(2)-1),*,ERR=108) M
            N1D=M
         ENDIF
 108     CONTINUE
         DO 110 I=2,MIN(NPOS,7)
*           READ MIN AND MAX COORDINATE VALUES
   	    IF ((IPOS(I+1)-IPOS(I)).GT.1) THEN
	       READ(CBUFF(IPOS(I)+1:IPOS(I+1)-1),*,ERR=110) V
	       SCMIMA(I-1,N)=V
	       RDUMMY(I-1)=V
	    ENDIF
 110     CONTINUE
      ELSE
         IKK=0
         JKK=0
	 DO 115 I=1,MIN(NPOS,9)
            IF ((I.EQ.1).OR.(I.EQ.4).OR.(I.EQ.7)) THEN
*              READ NUMBER OF INTERVALS
               IKK=IKK+1
 	       IF ((IPOS(I+1)-IPOS(I)).GT.1) THEN
	          READ(CBUFF(IPOS(I)+1:IPOS(I+1)-1),*,ERR=115) M
	          NDUMMY(IKK)=M
	       ENDIF
            ELSE
*              READ MIN AND MAX VALUES
               JKK=JKK+1
               IF ((IPOS(I+1)-IPOS(I)).GT.1) THEN
                  READ(CBUFF(IPOS(I)+1:IPOS(I+1)-1),*,ERR=110) V
                  SCMIMA(JKK,N)=V
                  RDUMMY(JKK)=V
               ENDIF
            ENDIF
 115	 CONTINUE
      ENDIF
 120  CONTINUE
      IF (.NOT.LSEMIC) RETURN
      IFSEMI=ISEMIC+1
      ISSEMI=0
      CALL FIND (CBUFF,';',IFSEMI,70,ISSEMI,IFND)
      IESTR=70
      IF (IFND.EQ.1) IESTR=ISSEMI
      I=1
      NPOS=1
      IPOS(I)=ISEMIC
 125  IST=IPOS(I)+1
      CALL FIND (CBUFF,',',IST,IESTR,IP,IFND)
      IF (IFND.EQ.1) THEN
	 I=I+1
	 IPOS(I)=IP
	 NPOS=NPOS+1
	 GOTO 125
      ENDIF
      IF (ISSEMI.GT.0) THEN
         IPOS(NPOS+1)=ISSEMI
      ELSE
         IPOS(NPOS+1)=IEND(CBUFF)+1
      ENDIF
      IF (NPOS.GT.4) THEN
	 WRITE (6,'(A)')'    '
	 WRITE (6,'(A,I2,A)')' WARNING: ERROR IN SCREEN(',N,')'
	 WRITE (6,'(A)') CBUFF
	 RETURN
      ENDIF
      DO 130 I=1,MIN(NPOS,4)
	 IF ((IPOS(I+1)-IPOS(I)).GT.1) THEN
	    READ(CBUFF(IPOS(I)+1:IPOS(I+1)-1),*,ERR=130) NDUMMY(3+I)
	 ENDIF
 130  CONTINUE
 131  CONTINUE
c      CALL CCAP(CBUFF(1:3),3)
      IF (CBUFF(1:3).EQ.'ION') THEN
         IF (ISSEMI.NE.0) THEN
            IIE=IEND(CBUFF)
            IST=ISSEMI+1
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
               IIE=IP-1
            ELSE
               IP=IIE+1
            ENDIF
            ICL=IIE-ISSEMI
            CDUMMY=CBUFF(ISSEMI+1:IP-1)
            CALL CHKION (2,NDUMMY,CBUFF(ISSEMI+1:IIE),ICL)
         ELSE IF (ISSEMI.EQ.0) THEN
            CALL CHKION (2,NDUMMY,CDMY,3)
         ENDIF
      ELSE IF ((CBUFF(1:3).EQ.'IOD').OR.
     &         (CBUFF(1:3).EQ.'IOV').OR.
     &         (CBUFF(1:3).EQ.'IOL')) THEN
         IF (ISSEMI.NE.0) THEN
            IIE=IEND(CBUFF)
            IST=ISSEMI+1
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
               IST=IP+1
               CALL FIND (CBUFF,';',IST,IIE,IP2,IFND)
               IF (IFND.NE.0) THEN
                  CALL CCAP(CBUFF(IP2+1:IP2+3),3)
                  IF (CBUFF(IP2+1:IP2+3).EQ.'LOG') THEN
                     RBUFF=-99
                     IF (IIE.LT.(IP2+4)) THEN
                        IIIE=IP2+4
                     ELSE
                        IIIE=IIE
                     ENDIF
   	             READ(CBUFF(IP2+4:IIIE),*,ERR=132) RBUFF
 132                 CONTINUE
                     IF (RBUFF.LT.1) RBUFF=10
                     IF (RBUFF.EQ.1) RBUFF=1.0001
                     RBUFF=RBUFF*1E6
                     NDUMMY(21)=INT(RBUFF)
                  ENDIF
               ENDIF
               IIE=IP-1
            ELSE
               IP=IIE+1
            ENDIF
            ICL=IIE-ISSEMI
            CDUMMY=CBUFF(ISSEMI+1:IP-1)
            CALL CHKION (1,NDUMMY,CBUFF(ISSEMI+1:IIE),ICL)
         ELSE IF (ISSEMI.EQ.0) THEN
            CALL CHKION (1,NDUMMY,CDMY,3)
         ENDIF
      ELSE IF ((CBUFF(1:3).EQ.'AEY').OR.
     &    (CBUFF(1:3).EQ.'AEA').OR.
     &    (CBUFF(1:3).EQ.'AEP').OR.
     &    (CBUFF(1:3).EQ.'AEW').OR.
     &    (CBUFF(1:3).EQ.'AGD').OR.
     &    (CBUFF(1:3).EQ.'ADD').OR.
     &    (CBUFF(1:3).EQ.'AET')) THEN
         IF (ISSEMI.NE.0) THEN
            IST=ISSEMI+1
            IIE=IEND(CBUFF)
            ITSEMI=ISSEMI
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
*              FOUND A THIRD SEMICOLON
               ITSEMI=IP
               IIE=IP-1
            ENDIF
            ICL=IIE-ISSEMI
            CALL CHKAUG (2,NDUMMY,CBUFF(ISSEMI+1:IIE),ICL)
            IF (ITSEMI.GT.ISSEMI) THEN
*              READ DETECTOR NUMBER
               IIE=IEND(CBUFF)
               READ(CBUFF(ITSEMI+1:IIE),*,ERR=134)N2D
               GOTO 135
 134           N2D=0
 135           IF ((N2D.LT.0).OR.(N2D.GT.MAXEDET)) N2D=0
            ELSE
               N2D=0
            ENDIF
         ELSE IF (ISSEMI.EQ.0) THEN
            CALL CHKAUG (2,NDUMMY,CDMY,3)
            N2D=0
         ENDIF
         IF ((CBUFF(1:3).EQ.'AGD').OR.
     &       (CBUFF(1:3).EQ.'AET')) N2D=0
      ELSE IF (CBUFF(1:3).EQ.'DEY') THEN
         IF (ISSEMI.NE.0) THEN
            IST=ISSEMI+1
            IIE=IEND(CBUFF)
            ITSEMI=ISSEMI
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
*              FOUND A THIRD SEMICOLON
               ITSEMI=IP
            ENDIF
            IF ((ITSEMI-1).GT.ISSEMI) THEN
*              AT LEAST ONE CHARACTER BETWEEN SECOND AND THIRD SMICOLON
               READ(CBUFF(ISSEMI+1:ITSEMI-1),*,IOSTAT=IERR) RENGY
               IF (IERR.NE.0) THEN
                  IIE=ITSEMI-1
                  ICL=ITSEMI-ISSEMI-1
                  CALL CHKAUG (2,NDUMMY,CBUFF(ISSEMI+1:IIE),ICL)
*                 DETERMINE ENERGY (RENGY) OF SPECIFIED AUGER PEAK
                  RENGY=AUGPKENER(NDUMMY(9),NDUMMY(8))
               ENDIF
               REDELT=RENGY*0.06
               RDUMMY(2*MAXDIM+1)=RENGY-REDELT
               RDUMMY(2*MAXDIM+2)=RENGY+REDELT
            ELSE
*              TOTAL ENERGY REGION
               RDUMMY(2*MAXDIM+1)=ELDETWIN(1,1)
               RDUMMY(2*MAXDIM+2)=ELDETWIN(1,2)
            ENDIF
            IF (ITSEMI.GT.ISSEMI) THEN
*              READ DETECTOR NUMBER
               IIE=IEND(CBUFF)
               READ(CBUFF(ITSEMI+1:IIE),*,ERR=136)N2D
               GOTO 137
 136           N2D=0
 137           IF ((N2D.LT.0).OR.(N2D.GT.MAXEDET)) N2D=0
            ELSE
               N2D=0
            ENDIF
         ELSE IF (ISSEMI.EQ.0) THEN
*           TOTAL ENERGY REGION
            RDUMMY(2*MAXDIM+1)=ELDETWIN(1,1)
            RDUMMY(2*MAXDIM+2)=ELDETWIN(1,2)
            N2D=0
         ENDIF
C      ELSE IF ((CBUFF(1:3).EQ.'XCY').OR.
C     &    (CBUFF(1:3).EQ.'XGD')) THEN
C         IF (ISSEMI.NE.0) THEN
C            IIE=IEND(CBUFF)
C            ICL=IIE-ISSEMI
C            CALL CHKXCH (2,NDUMMY,CBUFF(ISSEMI+1:IIE),ICL)
C         ELSE IF (ISSEMI.EQ.0) THEN
C            CALL CHKXCH (2,NDUMMY,CDMY,3)
C         ENDIF
      ELSE IF (CBUFF(1:3).EQ.'XDD') THEN
         IF (ISSEMI.NE.0) THEN
            IST=ISSEMI+1
            IIE=IEND(CBUFF)
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
               IST=IP+1
               CALL FIND (CBUFF,';',IST,IIE,IP2,IFND)
               IF (IFND.NE.0) THEN
                  CALL CCAP(CBUFF(IP2+1:IP2+3),3)
                  IF (CBUFF(IP2+1:IP2+3).EQ.'LOG') THEN
                     RBUFF=-99
                     IF (IIE.LT.(IP2+4)) THEN
                        IIIE=IP2+4
                     ELSE
                        IIIE=IIE
                     ENDIF
   	             READ(CBUFF(IP2+4:IIIE),*,ERR=148) RBUFF
 148                 CONTINUE
                     IF (RBUFF.LT.1) RBUFF=10
                     IF (RBUFF.EQ.1) RBUFF=1.0001
                     RBUFF=RBUFF*1E6
                     NDUMMY(21)=INT(RBUFF)
                  ENDIF
                  IIE=IP2-1
               ENDIF
               READ(CBUFF(IP+1:IIE),*,ERR=150)N2D
               GOTO 151
 150           N2D=0
 151           IF ((N2D.LT.0).OR.(N2D.GT.MAXXDET)) N2D=0
               IIE=IP-1
            ELSE
               IP=IIE+1
            ENDIF
            ICL=IIE-ISSEMI
            CDUMMY=CBUFF(ISSEMI+1:IP-1)
            CALL CHKXCH (2,NDUMMY,CBUFF(ISSEMI+1:IIE),ICL)
         ELSE IF (ISSEMI.EQ.0) THEN
            N2D=0
            CALL CHKXCH (2,NDUMMY,CDMY,3)
         ENDIF
      ELSE IF ((CBUFF(1:3).EQ.'XCY').OR.
     &         (CBUFF(1:3).EQ.'XRY').OR.
     &         (CBUFF(1:3).EQ.'XKY')) THEN
         IF (ISSEMI.NE.0) THEN
            IST=ISSEMI+1
            IIE=IEND(CBUFF)
            IIIE=IIE
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
               IST=IP+1
               CALL FIND (CBUFF,';',IST,IIE,IP2,IFND)
               IF (IFND.NE.0) THEN
*                 FOUND A FORTH SEMICOLON -READ ENERGY WINDOW INFORMATION
   	          READ(CBUFF(IP2+1:IIE),*,ERR=152)
     &                 RDUMMY(2*MAXDIM+1),RDUMMY(2*MAXDIM+2)
 152              CONTINUE
                  IIIE=IP2-1
               ENDIF
               READ(CBUFF(IP+1:IIIE),*,ERR=153)N2D
               GOTO 154
 153           N2D=0
 154           IF ((N2D.LT.0).OR.(N2D.GT.MAXXDET)) N2D=0
               IIE=IP-1
            ELSE
               IP=IIE+1
            ENDIF
            ICL=IIE-ISSEMI
            CDUMMY=CBUFF(ISSEMI+1:IP-1)
            IF (CBUFF(1:3).NE.'XKY') THEN
               IF (ICL.GT.0) THEN
                  CALL CHKXCH (2,NDUMMY,CBUFF(ISSEMI+1:IIE),ICL)
               ENDIF
            ENDIF
         ELSE IF (ISSEMI.EQ.0) THEN
            N2D=0
            IF (CBUFF(1:3).NE.'XKY') THEN
               CALL CHKXCH (2,NDUMMY,CDMY,3)
            ENDIF
         ENDIF
      ELSE IF (CBUFF(1:3).EQ.'XGD') THEN
         IF (ISSEMI.NE.0) THEN
            IST=ISSEMI+1
            IIE=IEND(CBUFF)
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
               IST=IP+1
               CALL FIND (CBUFF,';',IST,IIE,IP2,IFND)
               IF (IFND.NE.0) THEN
                  CALL CCAP(CBUFF(IP2+1:IP2+3),3)
                  IF (CBUFF(IP2+1:IP2+3).EQ.'LOG') THEN
                     RBUFF=-99
                     IF (IIE.LT.(IP2+4)) THEN
                        IIIE=IP2+4
                     ELSE
                        IIIE=IIE
                     ENDIF
   	             READ(CBUFF(IP2+4:IIIE),*,ERR=157) RBUFF
 157                 CONTINUE
                     IF (RBUFF.LT.1) RBUFF=10
                     IF (RBUFF.EQ.1) RBUFF=1.0001
                     RBUFF=RBUFF*1E6
                     NDUMMY(21)=INT(RBUFF)
                  ENDIF
               ENDIF
               IIE=IP-1
            ELSE
               IP=IIE+1
            ENDIF
            ICL=IIE-ISSEMI
            CDUMMY=CBUFF(ISSEMI+1:IP-1)
            CALL CHKXCH (2,NDUMMY,CBUFF(ISSEMI+1:IIE),ICL)
         ELSE IF (ISSEMI.EQ.0) THEN
            N2D=0
            CALL CHKXCH (2,NDUMMY,CDMY,3)
         ENDIF
      ELSE
         IF (ISSEMI.NE.0) THEN
            IST=ISSEMI+1
            IIE=IEND(CBUFF)
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
               IST=IP+1
            ENDIF
            READ(CBUFF(IST:IIE),*,ERR=158)N2D
            GOTO 159
 158        N2D=0
 159        IF ((N2D.LT.0).OR.(N2D.GT.MAXEDET)) N2D=0
         ENDIF
      ENDIF
      RETURN

 200  CONTINUE
*     ---EXTRACT PARAMETERS FOR POSTSCRIPT OUTPUT
*     INITIALIZE WITH DEFAULT VALUES
      SCMIMA(1,N)=XX1
      SCMIMA(2,N)=XX2
      SCMIMA(3,N)=YY1
      SCMIMA(4,N)=YY2
      SCMIMA(5,N)=ZZ1
      SCMIMA(6,N)=ZZ2
      IFSEMI=0
      ISSEMI=0
      ITSEMI=0
      N2D=0
      NDUMMY(4)=0
      NDUMMY(5)=0
      NDUMMY(6)=0
      NDUMMY(7)=0
      CALL FIND (CBUFF,';',4,70,IFSEMI,IFND)
      IF (IFND.GT.0) THEN
         IS=IFSEMI+1
         CALL FIND(CBUFF,';',IS,70,ISSEMI,IFND)
         IF (IFND.GT.0) THEN
            IS=ISSEMI+1
            CALL FIND(CBUFF,';',IS,70,ITSEMI,IFND)
         ENDIF
      ENDIF
      IF (IFSEMI.EQ.0) THEN
         IE=IEND(CBUFF)
      ELSE
         IE=IFSEMI
      ENDIF
      CALL FIND (CBUFF,',',4,IE,IP,IFND)
      IF ((IFSEMI.EQ.0).AND.(IFND.EQ.0)) RETURN
      IF (IFND.GT.0) THEN
         I=1
         NPOS=1
         IPOS(I)=IP
 205     IST=IPOS(I)+1
         CALL FIND (CBUFF,',',IST,IFSEMI,IP,IFND)
         IF (IFND.EQ.1) THEN
   	    I=I+1
	    IPOS(I)=IP
	    NPOS=NPOS+1
	    GOTO 205
         ENDIF
         IF (IFSEMI.GT.0) THEN
            IPOS(NPOS+1)=IFSEMI
         ELSE
            IPOS(NPOS+1)=IE+1
         ENDIF
         IF (NPOS.GT.8) THEN
            WRITE (6,'(A)')'    '
	    WRITE (6,'(A,I2,A)')' WARNING: ERROR IN POST(',N,')'
	    WRITE (6,'(A)') CBUFF
	    RETURN
         ENDIF
	 IF ((IPOS(2)-IPOS(1)).GT.1) THEN
            READ(CBUFF(IPOS(1)+1:IPOS(2)-1),*,ERR=208) M
	    N1D=M
	 ENDIF
 208     CONTINUE
         DO 210 I=2,MIN(NPOS,7)
	    IF ((IPOS(I+1)-IPOS(I)).GT.1) THEN
	       READ(CBUFF(IPOS(I)+1:IPOS(I+1)-1),*,ERR=210) V
	       SCMIMA(I-1,N)=V
	    ENDIF
 210     CONTINUE
      ENDIF
 220  IF (IFSEMI.GT.0) THEN
         IF (ISSEMI.EQ.0) THEN
            IE=IEND(CBUFF)
         ELSE
            IE=ISSEMI-1
         ENDIF
	 IF (IE.GT.IFSEMI) THEN
	    READ(CBUFF(IFSEMI+1:IE),'(A)',ERR=290)
     &	    CDUMMY(1:IE-IFSEMI)
	    DO 230 I=IE-IFSEMI+1,70
	       CDUMMY(I:I)=' '
 230	    CONTINUE
            IE=IEND(CDUMMY)
            CALL FIND (CDUMMY,'.',1,IE,IP,IFND)
            IF (IFND.EQ.1) THEN
               IF (IP.EQ.IE) CDUMMY(IE+1:IE+3)='---'
            ELSE
               CDUMMY(IE+1:IE+4)='.---'
            ENDIF
	 ENDIF
      ELSE
         RETURN
      ENDIF
      IF (ISSEMI.GT.0) THEN
         IF (ITSEMI.EQ.0) THEN
            IE=IEND(CBUFF)
         ELSE
            IE=ITSEMI-1
         ENDIF
         I=1
         NPOS=1
         IPOS(I)=ISSEMI
 240     IST=IPOS(I)+1
         CALL FIND (CBUFF,',',IST,IE,IP,IFND)
         IF (IFND.EQ.1) THEN
   	    I=I+1
	    IPOS(I)=IP
	    NPOS=NPOS+1
	    GOTO 240
         ENDIF
         IF (ITSEMI.GT.0) THEN
            IPOS(NPOS+1)=ITSEMI
         ELSE
            IPOS(NPOS+1)=IE+1
         ENDIF
         DO 250 I=1,MIN(NPOS,4)
   	    IF ((IPOS(I+1)-IPOS(I)).GT.1) THEN
	       READ(CBUFF(IPOS(I)+1:IPOS(I+1)-1),*,ERR=250)
     &                                       NDUMMY(3+I)
	    ENDIF
 250     CONTINUE
      ELSE
         RETURN
      ENDIF
c      CALL CCAP(CBUFF(1:3),3)
      IF (CBUFF(1:3).EQ.'ION') THEN
         IF (ITSEMI.NE.0) THEN
            IIE=IEND(CBUFF)
            IST=ITSEMI+1
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
               IIE=IP-1
            ENDIF
            ICL=IIE-ITSEMI
            CALL CHKION (2,NDUMMY,CBUFF(ITSEMI+1:IIE),ICL)
         ELSE IF (ITSEMI.EQ.0) THEN
            CALL CHKION (2,NDUMMY,CDMY,3)
         ENDIF
      ELSE IF (CBUFF(1:3).EQ.'IOD') THEN
         IF (ITSEMI.NE.0) THEN
            IIE=IEND(CBUFF)
            IST=ITSEMI+1
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
               IST=IP+1
               CALL FIND (CBUFF,';',IST,IIE,IP2,IFND)
               IF (IFND.NE.0) THEN
                  CALL CCAP(CBUFF(IP2+1:IP2+3),3)
                  IF (CBUFF(IP2+1:IP2+3).EQ.'LOG') THEN
                     RBUFF=-99
                     IF (IIE.LT.(IP2+4)) THEN
                        IIIE=IP2+4
                     ELSE
                        IIIE=IIE
                     ENDIF
   	             READ(CBUFF(IP2+4:IIIE),*,ERR=252) RBUFF
 252                 CONTINUE
                     IF (RBUFF.LT.1) RBUFF=10
                     IF (RBUFF.EQ.1) RBUFF=1.0001
                     RBUFF=RBUFF*1E6
                     NDUMMY(21)=INT(RBUFF)
                  ENDIF
               ENDIF
               IIE=IP-1
            ENDIF
            ICL=IIE-ITSEMI
            CALL CHKION (1,NDUMMY,CBUFF(ITSEMI+1:IIE),ICL)
         ELSE IF (ITSEMI.EQ.0) THEN
            CALL CHKION (1,NDUMMY,CDMY,3)
         ENDIF
      ELSE IF (CBUFF(1:3).EQ.'AGD') THEN
         IF (ITSEMI.NE.0) THEN
            IIE=IEND(CBUFF)
            ICL=IIE-ITSEMI
            CALL CHKAUG (2,NDUMMY,CBUFF(ITSEMI+1:IIE),ICL)
         ELSE IF (ITSEMI.EQ.0) THEN
            CALL CHKAUG (2,NDUMMY,CDMY,3)
         ENDIF
      ELSE IF (CBUFF(1:3).EQ.'ADD') THEN
         IF (ITSEMI.NE.0) THEN
            IST=ITSEMI+1
            IIE=IEND(CBUFF)
            I4SEMI=ITSEMI
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
*              FOUND A FOURTH SEMICOLON
               I4SEMI=IP
               IIE=IP-1
            ENDIF
            ICL=IIE-ITSEMI
            CALL CHKAUG (2,NDUMMY,CBUFF(ITSEMI+1:IIE),ICL)
            IF (I4SEMI.GT.ITSEMI) THEN
*              READ DETECTOR NUMBER
               IIE=IEND(CBUFF)
               READ(CBUFF(I4SEMI+1:IIE),*,ERR=254)N2D
               GOTO 255
 254           N2D=0
 255           IF ((N2D.LT.0).OR.(N2D.GT.MAXEDET)) N2D=0
            ELSE
               N2D=0
            ENDIF
         ELSE IF (ITSEMI.EQ.0) THEN
            CALL CHKAUG (2,NDUMMY,CDMY,3)
            N2D=0
         ENDIF
      ELSE IF (CBUFF(1:3).EQ.'XGD') THEN
         IF (ITSEMI.NE.0) THEN
            IIE=IEND(CBUFF)
            IST=ITSEMI+1
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
               IST=IP+1
               CALL FIND (CBUFF,';',IST,IIE,IP2,IFND)
               IF (IFND.NE.0) THEN
                  CALL CCAP(CBUFF(IP2+1:IP2+3),3)
                  IF (CBUFF(IP2+1:IP2+3).EQ.'LOG') THEN
                     RBUFF=-99
                     IF (IIE.LT.(IP2+4)) THEN
                        IIIE=IP2+4
                     ELSE
                        IIIE=IIE
                     ENDIF
   	             READ(CBUFF(IP2+4:IIIE),*,ERR=258) RBUFF
 258                 CONTINUE
                     IF (RBUFF.LT.1) RBUFF=10
                     IF (RBUFF.EQ.1) RBUFF=1.0001
                     RBUFF=RBUFF*1E6
                     NDUMMY(21)=INT(RBUFF)
                  ENDIF
               ENDIF
               IIE=IP-1
            ENDIF
            ICL=IIE-ITSEMI
            CALL CHKXCH (2,NDUMMY,CBUFF(ITSEMI+1:IIE),ICL)
         ELSE IF (ITSEMI.EQ.0) THEN
            CALL CHKXCH (2,NDUMMY,CDMY,3)
         ENDIF
      ELSE IF (CBUFF(1:3).EQ.'XDD') THEN
         IF (ITSEMI.NE.0) THEN
            IST=ITSEMI+1
            IIE=IEND(CBUFF)
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
               IST=IP+1
               CALL FIND (CBUFF,';',IST,IIE,IP2,IFND)
               IF (IFND.NE.0) THEN
                  CALL CCAP(CBUFF(IP2+1:IP2+3),3)
                  IF (CBUFF(IP2+1:IP2+3).EQ.'LOG') THEN
                     RBUFF=-99
                     IF (IIE.LT.(IP2+4)) THEN
                        IIIE=IP2+4
                     ELSE
                        IIIE=IIE
                     ENDIF
   	             READ(CBUFF(IP2+4:IIIE),*,ERR=259) RBUFF
 259                 CONTINUE
                     IF (RBUFF.LT.1) RBUFF=10
                     IF (RBUFF.EQ.1) RBUFF=1.0001
                     RBUFF=RBUFF*1E6
                     NDUMMY(21)=INT(RBUFF)
                  ENDIF
                  IIE=IP2-1
               ENDIF
               READ(CBUFF(IP+1:IIE),*,ERR=260)N2D
               GOTO 261
 260           N2D=0
 261           IF ((N2D.LT.0).OR.(N2D.GT.MAXXDET)) N2D=0
               IIE=IP-1
            ENDIF
            ICL=IIE-ITSEMI
            CALL CHKXCH (2,NDUMMY,CBUFF(ITSEMI+1:IIE),ICL)
         ELSE IF (ISSEMI.EQ.0) THEN
            N2D=0
            CALL CHKXCH (2,NDUMMY,CDMY,3)
         ENDIF
      ENDIF
 290  RETURN

 300  CONTINUE
*     ---EXTRACT PARAMETERS FOR POSTMINI SAVE FILE OUTPUT
*     INITIALIZE WITH DEFAULT VALUES
      N2D=0
      NDUMMY(1)=NHINT
      NDUMMY(2)=NHINT
      NDUMMY(3)=NHINT
      RDUMMY(1)=XX1
      RDUMMY(2)=XX2
      RDUMMY(3)=YY1
      RDUMMY(4)=YY2
      RDUMMY(5)=ZZ1
      RDUMMY(6)=ZZ2
      IFSEMI=0
      ISSEMI=0
      ITSEMI=0
      ISEMIC=IEND(CBUFF)
      LSEMIC=.FALSE.
      CALL FIND (CBUFF,';',4,ISEMIC,IP,IFND)
      IF (IFND.NE.0) THEN
	 LSEMIC=.TRUE.
	 ISEMIC=IP
      ENDIF
      CALL FIND (CBUFF,',',4,ISEMIC,IP,IFND)
      IF ((IFND.EQ.0).AND.(.NOT.LSEMIC)) THEN
         GOTO 378
      ELSE IF ((IFND.EQ.0).AND.(LSEMIC)) THEN
	 GOTO 330
      ENDIF
      IF (LSEMIC) IIE=ISEMIC
      CALL FIND (CBUFF,',',4,IIE,IP,IFND)
      IF (IFND.EQ.0) RETURN
      I=1
      NPOS=1
      IPOS(I)=IP
 305  IST=IPOS(I)+1
      CALL FIND (CBUFF,',',IST,IIE,IP,IFND)
      IF (IFND.EQ.1) THEN
	 I=I+1
	 IPOS(I)=IP
	 NPOS=NPOS+1
	 GOTO 305
      ENDIF
      IF (LSEMIC) THEN
         IPOS(NPOS+1)=IIE
      ELSE
         IPOS(NPOS+1)=IEND(CBUFF)
      ENDIF
      IF (NPOS.GT.10) THEN
	 WRITE (6,'(A)')'    '
	 WRITE (6,'(A,I2,A)')' WARNING: ERROR IN PMSAV(',N,')'
	 WRITE (6,'(A)') CBUFF
	 RETURN
      ENDIF
      J=0
      JJ=0
      NCOMMA=MIN(NPOS,9)
      IF (MODE2.EQ.1) THEN
*        READ MIN AND MAX COORDINATE VALUES
         DO 310 I=1,MIN(NPOS,6)
            IF ((IPOS(I+1)-IPOS(I)).GT.1) THEN
               READ(CBUFF(IPOS(I)+1:IPOS(I+1)-1),*,ERR=310) V
               RDUMMY(JJ)=V
            ENDIF
 310     CONTINUE
      ELSE
         IKK=0
         JKK=0
         DO 315 I=1,MIN(NPOS,9)
            IF ((I.EQ.1).OR.(I.EQ.4).OR.(I.EQ.7)) THEN
*              READ NUMBER OF INTERVALS
               IKK=IKK+1
               IF ((IPOS(I+1)-IPOS(I)).GT.1) THEN
                  READ(CBUFF(IPOS(I)+1:IPOS(I+1)-1),*,ERR=315) NV
                  NDUMMY(IKK)=NV
               ENDIF
            ELSE
*              READ MIN AND MAX VALUES
               JKK=JKK+1
               READ(CBUFF(IPOS(I)+1:IPOS(I+1)-1),*,ERR=315) V
               RDUMMY(JKK)=V
            ENDIF
 315     CONTINUE
      ENDIF
 330  CONTINUE
      IF (.NOT.LSEMIC) RETURN
      IFSEMI=ISEMIC
      ISEMIC=ISEMIC+1
      ISSEMI=0
      CALL FIND (CBUFF,';',ISEMIC,70,ISSEMI,IFND)
      IF (IFND.EQ.0) ISSEMI=IFSEMI
      IF (ISSEMI.GT.(IFSEMI+1)) THEN
	 READ(CBUFF(IFSEMI+1:ISSEMI-1),'(A)',ERR=380)
     &	      CDUMMY(1:ISSEMI-IFSEMI-1)
	 DO 335 I=ISSEMI-IFSEMI,70
	    CDUMMY(I:I)=' '
 335	 CONTINUE
         IE=IEND(CDUMMY)
         CALL FIND (CDUMMY,'.',1,IE,IP,IFND)
         IF (IFND.EQ.1) THEN
            IF (IP.EQ.IE) CDUMMY(IE+1:IE+3)='---'
         ELSE
            CDUMMY(IE+1:IE+4)='.---'
         ENDIF
      ENDIF
c      CALL CCAP(CBUFF(1:3),3)
CS    ONLY IOD, IO2, SEW, BEW, TEW, AEW, XGD AND XDD ARE POSSIBLE
CS    PMSAV OUTPUT OPTIONS
      IF ((CBUFF(1:3).EQ.'IOD').OR.
     &    (CBUFF(1:3).EQ.'IO2')) THEN
         IF (ISSEMI.NE.0) THEN
            IIE=IEND(CBUFF)
            ICL=IIE-ISSEMI
            IST=ISSEMI+1
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
               IIE=IP-1
            ENDIF
            CALL CHKION (1,NDUMMY,CBUFF(ISSEMI+1:IIE),ICL)
         ELSE IF (ISSEMI.EQ.0) THEN
            CALL CHKION (1,NDUMMY,CDMY,3)
         ENDIF
      ELSE IF (CBUFF(1:3).EQ.'AEW') THEN
         IF (ISSEMI.NE.0) THEN
            IIE=IEND(CBUFF)
            ICL=IIE-ISSEMI
            CALL CHKAUG (2,NDUMMY,CBUFF(ISSEMI+1:IIE),ICL)
         ELSE IF (ISSEMI.EQ.0) THEN
            CALL CHKAUG (2,NDUMMY,CDMY,3)
         ENDIF
      ELSE IF (CBUFF(1:3).EQ.'XDD') THEN
         IF (ISSEMI.NE.0) THEN
            IST=ISSEMI+1
            IIE=IEND(CBUFF)
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
               READ(CBUFF(IP+1:IIE),*,ERR=359)N2D
               GOTO 360
 359           N2D=0
 360           IF ((N2D.LT.0).OR.(N2D.GT.MAXXDET)) N2D=0
               IIE=IP-1
            ENDIF
            ICL=IIE-ISSEMI
            CALL CHKXCH (2,NDUMMY,CBUFF(ISSEMI+1:IIE),ICL)
         ELSE IF (ISSEMI.EQ.0) THEN
            CALL CHKXCH (2,NDUMMY,CDMY,3)
         ENDIF
      ELSE IF (CBUFF(1:3).EQ.'XGD') THEN
         IF (ISSEMI.NE.0) THEN
            IST=ISSEMI+1
            IIE=IEND(CBUFF)
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
               IIE=IP-1
            ENDIF
            ICL=IIE-ISSEMI
            CALL CHKXCH (2,NDUMMY,CBUFF(ISSEMI+1:IIE),ICL)
         ELSE IF (ISSEMI.EQ.0) THEN
            CALL CHKXCH (2,NDUMMY,CDMY,3)
         ENDIF
      ELSE
         IF (ISSEMI.NE.0) THEN
            IST=ISSEMI+1
            IIE=IEND(CBUFF)
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) IST=IP+1
            READ(CBUFF(IST:IIE),*,ERR=364)N2D
            GOTO 365
 364        N2D=0
 365        IF ((N2D.LT.0).OR.(N2D.GT.MAXEDET)) N2D=0
         ENDIF
      ENDIF
 378  CONTINUE
 380  RETURN

 400  CONTINUE
*     ---EXTRACT PARAMETERS FOR ASCII HISTOGRAM OUTPUT
*     INITIALIZE WITH DEFAULT VALUES
      N2D=0
      NDUMMY(1)=NHINT
      IF ((CBUFF(1:3).EQ.'XKS').OR.
     &    (CBUFF(1:3).EQ.'XRS')) NDUMMY(1)=MDEFXCONT
      NDUMMY(2)=NHINT
      NDUMMY(3)=NHINT
      RDUMMY(1)=XX1
      RDUMMY(2)=XX2
      RDUMMY(3)=YY1
      RDUMMY(4)=YY2
      RDUMMY(5)=ZZ1
      RDUMMY(6)=ZZ2
      IFSEMI=0
      ISSEMI=0
      ITSEMI=0
      CALL FIND (CBUFF,';',4,70,IFSEMI,IFND)
      IF (IFND.NE.0) THEN
         IS=IFSEMI+1
         CALL FIND (CBUFF,';',IS,70,ISSEMI,IFND)
         IF (IFND.EQ.0) ISSEMI=IFSEMI
      ENDIF
      IF (IFSEMI.EQ.0) THEN
         IE=IEND(CBUFF)
      ELSE
         IE=IFSEMI-1
      ENDIF
      CALL FIND (CBUFF,',',4,IE,IP,IFND)
      IF (IFND.EQ.0) GOTO 415
      I=1
      NPOS=1
      IPOS(I)=IP
 405  IST=IPOS(I)+1
      CALL FIND (CBUFF,',',IST,IE,IP,IFND)
      IF (IFND.EQ.1) THEN
	 I=I+1
	 IPOS(I)=IP
	 NPOS=NPOS+1
	 GOTO 405
      ENDIF
      IF (NPOS.GT.9) THEN
	 WRITE (6,'(A)')'    '
	 WRITE (6,'(A,I2,A)')' WARNING: ERROR IN HIST(',N,')'
	 WRITE (6,'(A)') CBUFF
	 RETURN
      ENDIF
      J=0
      JJ=0
      NCOMMA=MIN(NPOS,9)
      IPOS(NCOMMA+1)=IE+1
      DO 410 I=1,NCOMMA
	 IF (MOD(I,3).EQ.1) THEN
	    J=J+1
	 ELSE
	    JJ=JJ+1
	 ENDIF
	 IF ((IPOS(I+1)-IPOS(I)).GT.1) THEN
	    IF (MOD(I,3).EQ.1) THEN
	       READ(CBUFF(IPOS(I)+1:IPOS(I+1)-1),*,ERR=410) NV
	       NDUMMY(J)=NV
	    ELSE
	       READ(CBUFF(IPOS(I)+1:IPOS(I+1)-1),*,ERR=410) V
	       RDUMMY(JJ)=V
	    ENDIF
	 ENDIF
 410  CONTINUE
 415  IF (IFSEMI.GT.0) THEN
         IF (ISSEMI.GT.IFSEMI) THEN
            IE=ISSEMI-1
         ELSE
            IE=IEND(CBUFF)
         ENDIF
         IS=IFSEMI+1
         CDUMMY=CBL//CBL//CBL//CBL//CBL//CBL//CBL
         CDUMMY(1:IE-IFSEMI)=CBUFF(IS:IE)
         CALL FIND (CBUFF,'.',IS,IE,IP,IFND)
         IF (IFND.EQ.1) THEN
            IF (IP.EQ.IE) CDUMMY(IE-IS+2:IE-IS+4)='---'
         ELSE
            CDUMMY(IE-IS+2:IE-IS+5)='.---'
         ENDIF
      ENDIF
c      CALL CCAP(CBUFF(1:3),3)
      IF ((CBUFF(1:3).EQ.'IOV').OR.
     &    (CBUFF(1:3).EQ.'IOL').OR.
     &    (CBUFF(1:3).EQ.'IO2').OR.
     &    (CBUFF(1:3).EQ.'IO3')) THEN
         IF (ISSEMI.GT.IFSEMI) THEN
            IIE=IEND(CBUFF)
            ICL=IIE-ISSEMI
            CALL CHKION (1,NDUMMY,CBUFF(ISSEMI+1:IIE),ICL)
         ELSE IF (ISSEMI.EQ.0) THEN
            CALL CHKION (1,NDUMMY,CDMY,3)
         ENDIF
      ELSE IF ((CBUFF(1:3).EQ.'AEY').OR.
     &    (CBUFF(1:3).EQ.'AEA').OR.
     &    (CBUFF(1:3).EQ.'AEP').OR.
     &    (CBUFF(1:3).EQ.'AEW')) THEN
         IF (ISSEMI.GT.IFSEMI) THEN
            IST=ISSEMI+1
            IIE=IEND(CBUFF)
            ITSEMI=ISSEMI
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
*              FOUND A THIRD SEMICOLON
               ITSEMI=IP
               IIE=IP-1
            ENDIF
            ICL=IIE-ISSEMI
            CALL CHKAUG (2,NDUMMY,CBUFF(ISSEMI+1:IIE),ICL)
            CALL CHKAUG (2,NDUMMY,CBUFF(ISSEMI+1:IIE),ICL)
            IF (ITSEMI.GT.ISSEMI) THEN
*              READ DETECTOR NUMBER
               IIE=IEND(CBUFF)
               READ(CBUFF(ITSEMI+1:IIE),*,ERR=416)N2D
               GOTO 417
 416           N2D=0
 417           IF ((N2D.LT.0).OR.(N2D.GT.MAXEDET)) N2D=0
            ELSE
               N2D=0
            ENDIF
         ELSE
            CALL CHKAUG (2,NDUMMY,CDMY,3)
            N2D=0
         ENDIF
      ELSE IF (CBUFF(1:3).EQ.'DEY') THEN
         IF (ISSEMI.GT.IFSEMI) THEN
            IST=ISSEMI+1
            IIE=IEND(CBUFF)
            ITSEMI=ISSEMI
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
*              FOUND A THIRD SEMICOLON
               ITSEMI=IP
            ENDIF
            IF ((ITSEMI-1).GT.ISSEMI) THEN
*              AT LEAST ONE CHARACTER BETWEEN SECOND AND THIRD SMICOLON
               READ(CBUFF(ISSEMI+1:ITSEMI-1),*,IOSTAT=IERR) RENGY
               IF (IERR.NE.0) THEN
                  IIE=ITSEMI-1
                  ICL=ITSEMI-ISSEMI-1
                  CALL CHKAUG (2,NDUMMY,CBUFF(ISSEMI+1:IIE),ICL)
*                 DETERMINE ENERGY (RENGY) OF SPECIFIED AUGER PEAK
                  RENGY=AUGPKENER(NDUMMY(9),NDUMMY(8))
               ENDIF
               REDELT=RENGY*0.06
               RDUMMY(2*MAXDIM+1)=RENGY-REDELT
               RDUMMY(2*MAXDIM+2)=RENGY+REDELT
            ELSE
*              TOTAL ENERGY REGION
               RDUMMY(2*MAXDIM+1)=ELDETWIN(1,1)
               RDUMMY(2*MAXDIM+2)=ELDETWIN(1,2)
            ENDIF
            IF (ITSEMI.GT.ISSEMI) THEN
*              READ DETECTOR NUMBER
               IIE=IEND(CBUFF)
               READ(CBUFF(ITSEMI+1:IIE),*,ERR=420)N2D
               GOTO 421
 420           N2D=0
 421           IF ((N2D.LT.0).OR.(N2D.GT.MAXEDET)) N2D=0
            ELSE
               N2D=0
            ENDIF
         ELSE IF (ISSEMI.EQ.0) THEN
*           TOTAL ENERGY REGION
            RDUMMY(2*MAXDIM+1)=ELDETWIN(1,1)
            RDUMMY(2*MAXDIM+2)=ELDETWIN(1,2)
            N2D=0
         ENDIF
      ELSE IF ((CBUFF(1:3).EQ.'XCY').OR.
     &         (CBUFF(1:3).EQ.'XKY').OR.
     &         (CBUFF(1:3).EQ.'XRY')) THEN
         IF (ISSEMI.GT.IFSEMI) THEN
            IST=ISSEMI+1
            IIE=IEND(CBUFF)
            IIIE=IIE
            IP2=IIE
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) THEN
*              THIRD SEMICOLON FOUND
               IST=IP+1
               CALL FIND (CBUFF,';',IST,IIE,IP2,IFND)
               IF (IFND.NE.0) THEN
*                 FORTH SEMICOLON FOUND
                  IIIE=IP2-1
               ENDIF
               READ(CBUFF(IP+1:IIIE),*,ERR=426)N2D
               GOTO 427
 426           N2D=0
 427           IF ((N2D.LT.0).OR.(N2D.GT.MAXXDET)) N2D=0
               IIIE=IP-1
            ENDIF
            ICL=IIIE-ISSEMI
            IF (CBUFF(1:3).NE.'XKY') THEN
               IF (ICL.GT.0) THEN
                  CALL CHKXCH (2,NDUMMY,CBUFF(ISSEMI+1:IIIE),ICL)
               ENDIF
            ENDIF
            IF (IP2.LT.IIE) THEN
               READ(CBUFF(IP2+1:IIE),*,ERR=428)
     &             RDUMMY(2*MAXDIM+1),RDUMMY(2*MAXDIM+2)
 428           CONTINUE
            ENDIF
         ELSE
            N2D=0
            IF (CBUFF(1:3).NE.'XKY') THEN
               CALL CHKXCH (2,NDUMMY,CDMY,3)
            ENDIF
         ENDIF
      ELSE
         IF (ISSEMI.GT.IFSEMI) THEN
            IST=ISSEMI+1
            IIE=IEND(CBUFF)
            CALL FIND (CBUFF,';',IST,IIE,IP,IFND)
            IF (IFND.NE.0) IST=IP+1
            READ(CBUFF(IST:IIE),*,ERR=436)N2D
            GOTO 437
 436        N2D=0
 437        IF ((N2D.LT.0).OR.(N2D.GT.MAXEDET)) N2D=0
         ENDIF
      ENDIF
 440  RETURN

 500  CONTINUE
      NDUMMY(1)=-1
      NDUMMY(2)=1
      NDUMMY(3)=0
      CALL FIND (CBUFF,',',4,70,IP,IFND)
      IF (IFND.EQ.0) RETURN
      I=1
      NPOS=1
      IPOS(I)=IP
 505  IST=IPOS(I)+1
      CALL FIND (CBUFF,',',IST,70,IP,IFND)
      IF (IFND.EQ.1) THEN
	 I=I+1
	 IPOS(I)=IP
	 NPOS=NPOS+1
	 GOTO 505
      ENDIF
      IPOS(NPOS+1)=IEND(CBUFF)+1
      IF (NPOS.GT.4) THEN
	 WRITE (6,'(A)')'    '
	 WRITE (6,'(A,I2,A)')' WARNING: ERROR IN PMSAV(',N,')'
	 WRITE (6,'(A)') CBUFF
	 RETURN
      ENDIF
      DO 510 I=1,MIN(NPOS,3)
	 IF ((IPOS(I+1)-IPOS(I)).GT.1) THEN
	    IF (I.EQ.2) THEN
	       READ(CBUFF(IPOS(I)+1:IPOS(I+1)-1),'(A)',ERR=510) C1
	       IF ((C1.EQ.'K').OR.(C1.EQ.'k')) THEN
		  NDUMMY(I)=1
	       ELSE IF ((C1.EQ.'L').OR.(C1.EQ.'l')) THEN
		  NDUMMY(I)=2
	       ELSE IF ((C1.EQ.'M').OR.(C1.EQ.'m')) THEN
		  NDUMMY(I)=3
	       ELSE
		  NDUMMY(I)=1
	       ENDIF
	    ELSE
	       READ(CBUFF(IPOS(I)+1:IPOS(I+1)-1),*,ERR=510) M
	       NDUMMY(I)=M
	    ENDIF
	 ENDIF
 510  CONTINUE
      IF (NPOS.GE.4) THEN
	 IF ((IPOS(5)-IPOS(4)).GT.1) THEN
	    READ(CBUFF(IPOS(4)+1:IPOS(5)-1),'(A)',ERR=240)
     &	    CDUMMY(1:IPOS(5)-IPOS(4)-1)
	    DO 530 I=IPOS(5)-IPOS(4),70
	       CDUMMY(I:I)=' '
 530	    CONTINUE
	 ENDIF
      ENDIF
 540  RETURN

      END
