/*****************************************************************************/
/*     Copyright (c) 2000, Compaq Computer Corporation                       */
/*                                                                           */
/*  See the file "license.terms" for information on usage and redistribution */
/*  of this file, and for a DISCLAIMER OF ALL WARRANTIES.                    */
/*****************************************************************************/

/* This routine returns the CPU-time of a process.
   Sorry, there is no way to do this in FORTRAN under hp-ux!
   M. Stiftinger 1991
   C. Fischer 1991
*/

#ifdef __hpux
#include <time.h>

void hpsec (double *cputim)
{
   #define MAXTIME (double)0xffffffff

   static double oldtime = 0;
   static double factor = 0;
   double timehelp;

   if ( oldtime > (timehelp = clock()) ) factor++;
   oldtime = timehelp;
   *cputim = (MAXTIME * factor  + timehelp) / (double)CLOCKS_PER_SEC;

   return;
}

/* This routine returnes date and time for hp-ux.
   M. Stiftinger 1991
*/

#include <string.h>

void hpdat (char *dattim)
{
   char *timstr;
   long nsec;

   nsec = time (NULL);
   timstr = ctime (&nsec);
   strcpy (dattim, " ");
   strncpy (dattim+1, timstr+8, 2);
   strcpy (dattim+3, "-");
   strncpy (dattim+4, timstr+4, 3);
   strcpy (dattim+7, "-");
   strncpy (dattim+8, timstr+22, 2);
   strcpy (dattim+10, " ");
   strncpy (dattim+11, timstr+11, 8);
   strcpy (dattim+19, " ");
}
#else
void hpsec(double *cputim)
{
   return;
}
void hpdat(double *dattim)
{
   return;
}
#endif
