/*****************************************************************************/
/*     Copyright (c) 2000, Compaq Computer Corporation                       */
/*                                                                           */
/*  See the file "license.terms" for information on usage and redistribution */
/*  of this file, and for a DISCLAIMER OF ALL WARRANTIES.                    */
/*****************************************************************************/
/*
                          promis / imsil / src
                          --------------------
                               im2dgeo.h

  Header file for the geometry check routines.

  AUTHORS:   HS  Hannes Stippel, CEC Vienna, Digital Equipment Corporation

  who when        what
  ---------------------------------------------------------------------------
  HS  1994-02-01  new from scratch
  ===========================================================================*/

/* --------------------------------------------------------------------------*/

/* constants 
   ========= */

/* --------------------------------------------------------------------------*/

/* structures and type declarations 
   ================================ */

/* --------------------------------------------------------------------------*/

/* function prototypes 
   =================== */

/* determine the region of a point without considering the old leaf */
int getNewRegion (
		  Point      point,	/* testpoint */
		  QuadNode  *quadNode,	/* quadtree root node */
		  QuadLeaf **quadLeaf,	/* quadtree root node */
		  Point      center,	/* center of the root rectangle */
		  Point     *newCenter,	/* center of the rectangle */
		  double     sideX,	/* side x of the root rectangle */
		  double     sideZ,	/* side z of the root rectangle */
		  double    *newSideX,	/* side x of the rectangle */
		  double    *newSideZ,	/* side z of the rectangle */
		  double     pcoord[]);	/* coordinates of the points */

/* determine the region of a point considering the old leaf */
int getRegion (
	       Point      point,	/* testpoint */
	       QuadNode  *quadRoot,	/* quadtree root node */
	       QuadLeaf  *quadLeaf,	/* last quadtree leaf */
	       QuadLeaf **quadNewLeaf,	/* new quadtree leaf */
	       Point      center,	/* center of the rectangle */
	       Point     *leafCenter,	/* center of the last leaf rectangle */
	       double     sideX,	/* side x of the rectangle */
	       double     sideZ,	/* side z of the rectangle */
	       double    *leafSideX,	/* side x of the last leaf rectangle */
	       double    *leafSideZ,	/* side z of last leaf the rectangle */
	       double     pcoord[]);	/* coordinates of the points */

/* determine the entrance of an ion into the simulation area */
int getEntryPoint (
		   Point      point,		/* location of ion */
		   double     directionX,	/* direction of motion x */
		   double     directionZ,	/* direction of motion z */
		   int        numAmbients,	/* # of lines for the hull */
		   int        ambientBorder[],	/* lines of simulation hull */
		   double     pcoord[],		/* coordinates of the points */
		   QuadNode  *quadRoot,		/* root node of the quadtree */
		   QuadLeaf **quadLeaf,		/* quadtree root node */
		   Point      center,		/* center of root rectangle */
		   Point     *newCenter,	/* center of leaf rectangle */
		   double     rootSideX,	/* side x of root rectangle */
		   double     rootSideZ,	/* side z of root rectangle */
		   double    *newSideX,		/* side x of leaf rectangle */
		   double    *newSideZ,		/* side z of leaf rectangle */
		   double     overshoot,	/* entrance length to area */
		   Point     *entry);		/* entry point */
