/*****************************************************************************/
/*     Copyright (c) 2000, Compaq Computer Corporation                       */
/*                                                                           */
/*  See the file "license.terms" for information on usage and redistribution */
/*  of this file, and for a DISCLAIMER OF ALL WARRANTIES.                    */
/*****************************************************************************/
/*
                          promis / imsil / src
                          --------------------
                               imgetmem.h

  Header file for the memory routines.

  AUTHORS:   HS  Hannes Stippel, CEC Vienna, Digital Equipment Corporation

  who when        what
  ---------------------------------------------------------------------------
  HS  1994-02-01  new from scratch
  ===========================================================================*/

/* --------------------------------------------------------------------------*/

/* constants 
   ========= */

#define NUM_NODE_ALLOC			1000
#define NUM_LEAF_ALLOC			1000
#define NUM_LEAF_ELEMENT_I_ALLOC	1000
#define NUM_LEAF_ELEMENT_II_ALLOC	1000
#define NUM_LEAF_ELEMENT_III_ALLOC	1000
#define NUM_LEAF_ELEMENT_III_ADD_ALLOC	1000
#define NUM_CUT_ALLOC			1000
#define NUM_INSIDE_ALLOC		1000

/* --------------------------------------------------------------------------*/

/* structures and type declarations 
   ================================ */

/* --------------------------------------------------------------------------*/

/* function prototypes 
   =================== */

/* allocate space for nodes */
QuadNode *quadNodeAlloc ();

/* allocate space for leafs */
QuadLeaf *quadLeafAlloc ();

/* allocate space for leaf elements of type I */
QuadLeafElementI *quadLeafElementIAlloc ();

/* allocate space for leaf elements of type II */
QuadLeafElementII *quadLeafElementIIAlloc ();

/* allocate space for leaf elements of type III */
QuadLeafElementIII *quadLeafElementIIIAlloc ();

/* allocate space for intersection information */
int *quadCutAlloc (int numAlloc);

/* allocate space for points inside the rectangle */
int *quadInsideAlloc (int numAlloc);

/* allocate space for region and line information for elements of type III */
int *quadLeafElementIIIAddAlloc (int numAlloc);
