/*****************************************************************************/
/*     Copyright (c) 2000, Compaq Computer Corporation                       */
/*                                                                           */
/*  See the file "license.terms" for information on usage and redistribution */
/*  of this file, and for a DISCLAIMER OF ALL WARRANTIES.                    */
/*****************************************************************************/
/*
                          promis / imsil / src
                          --------------------
                                imtime.c

  This file contains the timer routines.

  AUTHORS:   HS  Hannes Stippel, CEC Vienna, Digital Equipment Corporation

  who when        what
  ---------------------------------------------------------------------------
  HS  1994-02-01  new from scratch
  ===========================================================================*/

#include <time.h>

/* --------------------------------------------------------------------------*/

/*** i m t i m e
     returns the elapsed since midnight Jan. 1, 1970 in seconds for
     DEC/ultrix, for VAX/VMS the total time for the current process.
     Otherwise it returns zero. ***/

double imtime ()
{
#ifdef __hpux
  struct timeval now;
  
  gettimeofday (&now, (struct timezone *) NULL);
  return ((double) now.tv_sec + 1.0e-6 * (double) now.tv_usec);
#endif

#ifdef ultrix
  struct timeval now;
  
  gettimeofday (&now, (struct timezone *) NULL);
  return ((double) now.tv_sec + 1.0e-6 * (double) now.tv_usec);
#endif

#ifdef vms
  tbuffer_t now;
  
  times (&now);
  return (1.0e-2 * (double) (now.proc_user_time  + now.proc_system_time +
			     now.child_user_time + now.child_system_time));
#endif

#ifndef __hpux
#ifndef ultrix
#ifndef vms
      /* dummy version */
      return (0.0);
#endif
#endif
#endif
}
