/*****************************************************************************/
/*     Copyright (c) 2000, Compaq Computer Corporation                       */
/*                                                                           */
/*  See the file "license.terms" for information on usage and redistribution */
/*  of this file, and for a DISCLAIMER OF ALL WARRANTIES.                    */
/*****************************************************************************/
/*
                          promis / imsil / src
                          --------------------
                             imvisualquad.h

  Header file for the visualization routines for the quadtree.

  AUTHORS:   HS  Hannes Stippel, CEC Vienna, Digital Equipment Corporation

  who when        what
  ---------------------------------------------------------------------------
  HS  1994-05-20  new from scratch
  ===========================================================================*/

/* --------------------------------------------------------------------------*/

/* constants 
   ========= */

/* --------------------------------------------------------------------------*/

/* structures and type declarations 
   ================================ */

/* --------------------------------------------------------------------------*/

/* function prototypes 
   =================== */

int visualQuadMain (
		    QuadNode *quadTree,		/* quadtree */
		    Point     rootCenter,	/* center of the root node */
		    double    rootSideX,	/* side of the root node, x */
		    double    rootSideZ,	/* side of the root node, z */
		    double    minX,		/* minimum x coordinate */
		    double    maxX,		/* maximum x coordinate */
		    double    minZ,		/* minimum z coordinate */
		    double    maxZ,		/* maximum z coordinate */
		    long      numFaces,		/* number of regions */
		    double    pcoord[],		/* coordinates of the points */
		    double    xscale);		/* geometry scaling factor */

void drawQuadTree (
		   QuadNode *quadNode,	/* node of the quadtree */
		   Point     center,	/* center of the rectangle */
		   double    sideX,	/* side x of the rectangle */
		   double    sideZ,	/* side z of the rectangle */
      		   int       *iloc);     /* location dependent */
