c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
* THE FOLLOWING ROUTINES ARE CONTAINED IN INITSE.F
*
*    INITSE
*    INITPH
*    INIBREMS
*    STSORT
*
****************************************************************************
* last modification: CS 28-Apr-1997

      SUBROUTINE INITSE (MODE)

***   INITSE - INITIALIZES PHYSICAL PARAMETERS OF SESAME
*
**    AUTHOR:  C.SCHIEBL   OCT 1994
*              H.WAGNER    AUG 1994
*              A.PFEIFFER  AUG 1994
*
**    ARGUMENT:
*              MODE - 1=READ INPUT FILE
*                     2=READ INPUT FILE FROM BACKUP FILE

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'GLOBAL.INC'
      INCLUDE 'HIST.INC'
      INCLUDE 'OUTPUT.INC'
      INCLUDE 'FILE.INC'
      INCLUDE 'DMA.INC'

      LOGICAL LINSTR,LDETCT,LMYDEF

      DIMENSION AFRAC(N2M,NRM)
*     STPBND IS ALSO A MEMBER OF THE &INIT NAMELIST 
*     BUT IS DECLARED IN BOUND.INC
      NAMELIST /INIT/   CUSTXT,JOB,TECHQU,SIGNAL,USEBK,UNITS,
     +                  FINSTR,FDETCT,FMYDEF,LTEST,STPBND
      NAMELIST /ETRNS/  NETRN,E0,EF
      NAMELIST /EBEAM/  ESTD,DIVERG,SPSIZE,SCAN,ZFOCUS
      NAMELIST /TARGET/ DENS,NREG,CGFILE,ATMAT
      NAMELIST /MODEL/  MODR,ION,XCHAR,LSECON,LAUG,LXRAY,LXCONT,FAUGER,
     +		        AUGMUL,NAHISL,NAHISV,AHISV,FMAT,LELATR,IONCRS,
     +                  BREMSCRS,STOPP,LPTOB,NXCONT
      NAMELIST /MSETUP/ MAGNI,TAKOFF,XDEROT,EBTILT,EBROT,XESPOT,XRANGE,
     +                  EDPHI,EDTHET,SCANANG,MTIME,CURRENT
      NAMELIST /INSTR/  NLSCP,XPCRT
      NAMELIST /DETECT/ XFDEFF,XLAYTH,XLAYDN,XLAYMAT,
     +                  EDTHMN,EDTHMX,FEDTRN,SOLIDA,
     +                  FWHM,ENFWHM,XDTYPE,ESCFAC
      NAMELIST /OUTPUT/ NETRBK,NSCRUP,LQUAD,FETRBK,POST,SCREEN,PMSAV,
     +			HIST,FPHI,FETAB,LSCDEF,CGRDFL,LSCRN,LSTATW,
     +                  LGRAY,LGRID,MINICOL,MAXICOL,MNCOLPAL,
     +                  NXGRID,NYGRID,NZGRID,LCOLTRJ,LEXCEED,LTEST

      DIMENSION NDUMMY(20),NXDETCT(0:MAXXDET),NEDETCT(0:MAXEDET)
      CHARACTER*80 BUFFER
      CHARACTER*64 CDUMMY
      CHARACTER*10 CBL
      LOGICAL LMINP

*     VARIABLES TO KEEP SOME VALUES FROM INPUT DECK IN CASE OF BACKUP FILE
      CHARACTER*70 C1USTXT,F1ETRBK
      CHARACTER*30 J1OB
      INTEGER N1ETRN,N1ETRBK,N1SCRUP,M1INICOL,M1AXICOL,M1NCOLPAL
      DOUBLE PRECISION A1UGMUL,A1HISV,M1TIME,C1URRENT
      LOGICAL L1TEST,L1QUAD,L1GRID,L1SCRN,L1STATW,L1GRAY
      SAVE C1USTXT,F1ETRBK,J1OB
      SAVE N1ETRN,N1ETRBK,N1SCRUP,M1INICOL,M1AXICOL,M1NCOLPAL
      SAVE L1TEST,L1QUAD,L1GRID,L1SCRN,L1STATW
      SAVE A1UGMUL,A1HISV
   
CHW   VARIABLES FOR SUBROUTINE ELMENT
      CHARACTER*12 ELE
      CHARACTER*2  EABR
      CHARACTER*1  CHOIC

      DATA CBL /'          '/

      INCLUDE 'PATH.INC'

**    START OF EXECUTABLE CODE
*     ************************

C OPEN INPUT DECK FILE
      IF (MODE.EQ.1) THEN
*        OPEN ACTUAL INPUT DECK FILE
         OPEN (11,FILE=INFILE(1:IEND(INFILE)),
     +         STATUS='OLD',FORM='FORMATTED',ERR=900)
      ELSE IF (MODE.EQ.2) THEN
*        OPEN BACKUP FILE AND EXTRACT INPUT DECK FROM THERE
         OPEN (NBCKUP,FILE=USEBK(1:IEND(USEBK)),
     +         STATUS='OLD',FORM='UNFORMATTED',ERR=930)
 5       READ(NBCKUP,END=940)BUFFER
         IF ((BUFFER(2:16).NE.'#START_INP_FILE').AND.
     +       (BUFFER(1:15).NE.'#START_INP_FILE')) GOTO 5
         IOSF=0
         IF (BUFFER(1:1).EQ.'#') IOSF=1
*        OPEN SCRATCH FILE
         OPEN(11,STATUS='SCRATCH',FORM='FORMATTED',ERR=950)
 10      READ(NBCKUP)BUFFER
         IF ((BUFFER(2:14).NE.'#END_INP_FILE').AND.
     +       (BUFFER(1:13).NE.'#END_INP_FILE')) THEN
            IF (IOSF.EQ.1) THEN
               WRITE(11,'(2A)')' ',BUFFER(1:79)
            ELSE
               WRITE(11,'(A)')BUFFER
            ENDIF
            GOTO 10
         ENDIF
         REWIND 11
         CLOSE (NBCKUP)
      ELSE
         GOTO 900
      ENDIF

CAPC INITIALIZE SINE AND COSINE LOOK-UP TABLES
CA      DO 50,I=0,360
CA         SINE(I)   = SIN(DBLE(I)/180.*PI)
CA        COSINE(I) = COS(DBLE(I)/180.*PI)
CAP50    CONTINUE

C INITIALIZE THE PARAMETERS OF THE INIT NAMELIST
*     ---DEFAULT VALUES
*     LOGICAL ACCORDING TO SIGNAL OF INTEREST (SIGNAL)
      LIACT =.TRUE.
      IF (MODE.EQ.1) LUSEBK=.FALSE.
      LXRAY =.FALSE.
      LXCHAR=.FALSE.
      LXCONT=.FALSE.
      LEBACK=.FALSE.
      LESEC =.FALSE.
      LETRAN=.FALSE.
      LEAUG =.FALSE.
      LIODIS=.FALSE.
      LION=.FALSE.
      LTEST=.FALSE.
      STPBND=.FALSE.
      LINIABS=.FALSE.
      LGRD=.FALSE.
      LAUTOG=.TRUE.
      CUSTXT=CBL//CBL//CBL//CBL//CBL//CBL//CBL
      USEBK =CBL//CBL//CBL//CBL//CBL//CBL//CBL
      FINSTR=CBL//CBL//CBL//CBL//CBL//CBL//CBL
      FDETCT=CBL//CBL//CBL//CBL//CBL//CBL//CBL
      FMYDEF=CBL//CBL//CBL//CBL//CBL//CBL//CBL
      JOB   =CBL//CBL//CBL
      UNITS ='MICRONS   '
      CUNITS='microns   '
      DUNITS=10000
*     DEFAULT VALUE IS 'SEM' - IS SET IN CHKINI
      TECHQU='???'
*     DEFAULT VALUE IS 'BE' - IS SET IN CHKINI
      SIGNAL(1)='??'
      DO 60 I=2,NSIG
         SIGNAL(I)='  '
 60   CONTINUE
      NSCXSI=NSCSIX
      IF (NSCXSI.GT.MXXPIX) THEN
         NSCXSI=MXXPIX
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%% '
         WRITE(6,'(2A)')' Default screen size larger then',
     &                  ' maximum screen size in x-direction!'
         WRITE(6,'(2A)')' Default screen size will be',
     &                  ' automatically reset by SESAME'
         WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
      ENDIF
      NSCYSI=NSCSIY
      IF (NSCYSI.GT.MXYPIX) THEN
         NSCYSI=MXYPIX
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%% '
         WRITE(6,'(2A)')' Default screen size larger then',
     &                  ' maximum screen size in y-direction!'
         WRITE(6,'(2A)')' Default screen size will be',
     &                  ' automatically reset by SESAME'
         WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
      ENDIF
      NPSXSI=NPSSIX
      IF (NPSXSI.GT.MXXPIX) THEN
         NPSXSI=MXXPIX
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%% '
         WRITE(6,'(2A)')' Default postscript size larger then',
     &                  ' maximum postscript size in x-direction!'
         WRITE(6,'(2A)')' Default postscript size will be',
     &                  ' automatically reset by SESAME'
         WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
      ENDIF
      NPSYSI=NPSSIY
      IF (NPSYSI.GT.MXYPIX) THEN
         NPSYSI=MXYPIX
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%% '
         WRITE(6,'(2A)')' Default postscript size larger then',
     &                  ' maximum postscrip size in y-direction!'
         WRITE(6,'(2A)')' Default postscript size will be',
     &                  ' automatically reset by SESAME'
         WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
      ENDIF
      DO 65 I=0,MAXSCR-1
	 SCXOFF(I+1)=1+I*NSCXOF
	 SCYOFF(I+1)=1+I*NSCYOF
	 SCXSIZ(I+1)=NSCXSI
	 SCYSIZ(I+1)=NSCYSI
 65   CONTINUE
      DO 69 I=1,MAXPST
         PSXSIZ(I)=NPSXSI
         PSYSIZ(I)=NPSYSI
 69   CONTINUE
*     ---READ DATA FROM INPUT FILE
      REWIND 11
      READ (11,INIT,END=903)
      IF (FINSTR(1:5).NE.'     ') THEN
         LINSTR=.TRUE.
         OPEN (12,FILE=FINSTR(1:IEND(FINSTR)),
     +         STATUS='OLD',FORM='FORMATTED',IOSTAT=IOS)
         IF (IOS.NE.0) THEN
            WRITE(*,'(A)')'    '
            WRITE(*,'(2A)')' *** WARNING: ERROR OPENING FILE: ',
     +                       FINSTR(1:IEND(FINSTR))
            WRITE(*,'(A)')' DO YOU WANT TO EXIT SESAME? [Y/N]'
            READ(*,'(A)')CHOIC
            IF (CHOIC.EQ.'Y'.OR.CHOIC.EQ.'y') THEN
               STOP
            ELSE
               LINSTR=.FALSE.
               FINSTR=CBL//CBL//CBL//CBL//CBL//CBL//CBL
               WRITE(*,'(A)')'    '
               WRITE(*,'(2A)')' No information will be read from',
     &                        ' instrument file (FINSTR) !'
            ENDIF   
         ENDIF
      ENDIF
      IF (FDETCT(1:5).NE.'     ') THEN
         LDETCT=.TRUE.
         OPEN (13,FILE=FDETCT(1:IEND(FDETCT)),
     +         STATUS='OLD',FORM='FORMATTED',IOSTAT=IOS)
         IF (IOS.NE.0) THEN
            WRITE(*,'(2A)')' *** WARNING: ERROR OPENING FILE: ',
     +                       FDETCT(1:IEND(FDETCT))
            WRITE(*,'(A)')' DO YOU WANT TO EXIT SESAME? [Y/N]'
            READ(*,'(A)')CHOIC
            IF (CHOIC.EQ.'Y'.OR.CHOIC.EQ.'y') THEN
               STOP
            ELSE
               LDETCT=.FALSE.
               FDETCT=CBL//CBL//CBL//CBL//CBL//CBL//CBL
               WRITE(*,'(A)')'    '
               WRITE(*,'(2A)')' No information will be read from',
     &                        ' detector file (FDETCT) !'
            ENDIF   
         ENDIF
      ENDIF
      IF (FMYDEF(1:5).NE.'     ') THEN
         LMYDEF=.TRUE.
         OPEN (14,FILE=FMYDEF(1:IEND(FMYDEF)),
     +         STATUS='OLD',FORM='FORMATTED',IOSTAT=IOS)
         IF (IOS.NE.0) THEN
            WRITE(*,'(2A)')' *** WARNING: ERROR OPENING FILE: ',
     +                       FMYDEF(1:IEND(FMYDEF))
            WRITE(*,'(A)')' DO YOU WANT TO EXIT SESAME? [Y/N]'
            READ(*,'(A)')CHOIC
            IF (CHOIC.EQ.'Y'.OR.CHOIC.EQ.'y') THEN
               STOP
            ELSE
               LMYDEF=.FALSE.
               FMYDEF=CBL//CBL//CBL//CBL//CBL//CBL//CBL
               WRITE(*,'(A)')'    '
               WRITE(*,'(2A)')' No information will be read from',
     &                        ' user file (FMYDEF) !'
            ENDIF   
         ENDIF
      ENDIF
      IF ((USEBK(1:5).NE.'     ').AND.(MODE.EQ.1)) LUSEBK=.TRUE.
C     IF DATA SHOULD BE READ FROM A BACKUP FILE AND CURRENTLY THE
C     INPUT FILE IS READ THEN SET LMINP=.TRUE.
C     IF LMINP IS SET TO .TRUE. THEN DO NOT CHECK EVERYTHING (MOST
C     DATA WILL BE READ FROM BACKUP FILE ANYWAY)
      LMINP=.FALSE.
      IF ((MODE.EQ.1).AND.(LUSEBK)) LMINP=.TRUE.

C INITIALIZE THE PARAMETERS OF THE ELECTRONS
*     ---DEFAULT VALUES
      NETRN=0
      E0=ZERO
      EF=10.
      MRAND=0
      IARAND=0
      IBRAND=0
      IRAND=0
      LONED=.FALSE.
*     ---READ DATA FROM INPUT FILE
      IF (LINSTR) THEN
         REWIND 12
         READ (12,ETRNS,END=75)
      ENDIF
 75   IF (LDETCT) THEN
         REWIND 13
         READ (13,ETRNS,END=78)
      ENDIF
 78   IF (LMYDEF) THEN
         REWIND 14
         READ (14,ETRNS,END=79)
      ENDIF
 79   REWIND 11
      READ (11,ETRNS,END=901)
*     ---CHECK OBLIGATORY PARAMETERS
      IF (NETRN.EQ.0) GOTO 902
      IF ((E0.EQ.ZERO).AND.(.NOT.LMINP)) GOTO 902
*     ---CHANGE UNITS (FROM keV TO eV)
      E0=E0*1000.
*     SET ELECTRON DETECTOR WINDOW
      DO 80 I=0,MAXEDET
         ELDETWIN(I,1)=EF
         ELDETWIN(I,2)=E0
 80   CONTINUE
      EPRIM=E0
      EMAX = 1.1*E0
      EMIN=EF


C     INITIALIZE THE PARAMETERS OF THE ELECTRON BEAM
*     ---DEFAULT VALUES
      ESTD=0
      DIVERG=0
      SPSIZE=0
      ZFOCUS=-9999999
      SCAN=.FALSE.
*     ---READ DATA FROM INPUT FILE
      IF (LINSTR) THEN
         REWIND 12
         READ (12,EBEAM,END=81)
      ENDIF
 81   IF (LDETCT) THEN
         REWIND 13
         READ (13,EBEAM,END=82)
      ENDIF
 82   IF (LMYDEF) THEN
         REWIND 14
         READ (14,EBEAM,END=83)
      ENDIF
 83   REWIND 11
      READ (11,EBEAM,END=85)
 85   CONTINUE


*     ---DEFAULT VALUES
CS      NETRN=0
CS      E0=ZERO
CS      ESTD = 0.
CS      EF=10.
CS      TILT=ZERO
CS      ROTATE=ZERO
CS      DIVERG=ZERO
CS      MRAND=0
CS      IARAND=0
CS      IBRAND=0
CS      IRAND=0
CS      USEBK=.FALSE.
CS      CUSTXT=CBL//CBL//CBL//CBL//CBL//CBL//CBL
CS      LONED=.FALSE.
*     ---READ DATA FROM INPUT FILE
CS      REWIND 11
CS      READ (11,ETRNS,END=901)
*     ---CHECK OBLIGATORY PARAMETERS
CS      IF (NETRN.EQ.0 .OR. E0.EQ.ZERO) GOTO 902
*     ---CHANGE UNITS (FROM keV TO eV)
CS      E0=E0*1000.
*     ---DETERMINE ELECTRON SOURCE, 1=BEAM,2=PHI(Z),3=TABULATED
CS      NELESOURCE = 1
CS      IF (PHIZFILE .GT. ' ') NELESOURCE = 2
CS      IF (ETABFILE .GT. ' ') NELESOURCE = 3

CS      EPRIM=E0
CS      EMAX = 1.1*E0
CS      EMIN=EF
CS      ROTAT=ROTATE


C INITIALIZE THE PARAMETERS OF THE TARGET ATOMS
      IF (LMINP) GOTO 430
*     ---DEFAULT VALUES
CS      NATOM=1
      ATOM(1:60)  =CBL//CBL//CBL//CBL//CBL//CBL
      ATOM(61:120)=CBL//CBL//CBL//CBL//CBL//CBL
CS      CATOM(1)='SI'
CS      ANUM(1)=14
      NREG=1
      NR=NREG
      DENS(1)=2.328
      AFRAC(1,1)=1
      CGFILE=CBL//CBL//CBL//CBL//CBL//CBL//CBL

*     ---READ DATA FROM INPUT FILE
      IF (LINSTR) THEN
         REWIND 12
         READ (12,TARGET,END=86)
      ENDIF
 86   IF (LDETCT) THEN
         REWIND 13
         READ (13,TARGET,END=87)
      ENDIF
 87   IF (LMYDEF) THEN
         REWIND 14
         READ (14,TARGET,END=88)
      ENDIF
 88   REWIND 11
      READ (11,TARGET,END=89)
 89   CONTINUE
      NLAYER=NREG
      NR=NREG
*      CALL CHKATO
      CALL CHKMAT(AFRAC)
      N2=NATOM
      DO 95 I=1,N2M
         Z2(I)=ANUM(I)
         DO 90 J=1,NRM
            PROB(I,J)=AFRAC(I,J)
 90      CONTINUE
 95   CONTINUE
*     ---CHECK MAXIMUM NUMBER OF TARGET ATOMS
101   IF (N2.GT.N2M) GOTO 911
*     ---DERIVED QUANTITIES OF ATOM PARAMETERS
      NELEM=N2
      DO 110 IELE=1,NELEM
          ATNUM(IELE)=INT(Z2(IELE))
          CALL ELMENT(0,ELE,ATNUM(IELE),
     2                EABR,RM,DENSHELP,IER)
          ATMASS(IELE) = RM
110   CONTINUE
*     ---CHECK MAXIMUM NUMBER OF REGIONS
      IF (NR.GT.NRM) GOTO 921
      ALAT=ZERO
      DO 221, IR=1,NREG
         IF (ISTRUC(IR).NE.1) GOTO 221
         IF (ALAT.NE.ZERO) GOTO 922
         ALAT=TWO/DENS(IR)**THIRD
221   CONTINUE
*     ---NOW WE CAN DETERMINE THE SCALING LENGTH
CS    FOR THE TIME BEEING THE SCALING FACTOR XSCALE IS ALWAYS ONE
CS      IF (ALAT.EQ.ZERO) THEN
         XSCALE=ONE
CS      ELSE
CS         XSCALE=QUART*ALAT
CS      ENDIF
*     ---SCALE ALL LENGTHS
CS    NOT NECESSARY
*     ---NORMALIZE PROB TO UNITY AND INITIALIZE CUMULATIVE PROBABILITY
      DO 240, IR=1,NREG
         PROBS(1,IR)=PROB(1,IR)
         DO 241, I2=2,N2
            PROBS(I2,IR)=PROBS(I2-1,IR)+PROB(I2,IR)
241      CONTINUE
         DO 242, I2=1,N2
            PROB(I2,IR)=PROB(I2,IR)/PROBS(N2,IR)
            PROBS(I2,IR)=PROBS(I2,IR)/PROBS(N2,IR)
242      CONTINUE
240   CONTINUE
CS    TRANSFORMATION TO OUR ELEMENT DATA STRUCTURE
      DO 251 IR=1,NREG
         ICOUNT=0
         DO 249 IELE=1,NELEM
            IF (PROB(IELE,IR).GT.1E-9) THEN
               ICOUNT=ICOUNT+1
               ELEM(IR,ICOUNT)=IELE
               ATFRAC(IR,ICOUNT)=PROB(IELE,IR)
            ENDIF
249      CONTINUE
         NELE(IR)=ICOUNT
251   CONTINUE
CS    INITIALIZE ARRAY FOR WEIGHTFRACTIONS AND ATOMIC DENSITY
      DO 263 IR=1,NREG
         DENSITY(IR)=DENS(IR)*1D-24
         SUMWGT=0
         DO 255 IELE=1,NELE(IR)
            SUMWGT=SUMWGT+ATMASS(ELEM(IR,IELE))*ATFRAC(IR,IELE)
255      CONTINUE
         ZQUER(IR)=0
         DO 257 IELE=1,NELE(IR)
            WEIGHTFRAC(IR,IELE)=ATFRAC(IR,IELE)*
     &                          ATMASS(ELEM(IR,IELE))/SUMWGT
            ATDENS(IR,IELE) = N_AVO*DENSITY(IR)*
     &             WEIGHTFRAC(IR,IELE)/ATMASS(ELEM(IR,IELE))
            TOT_ATDENS(IR) = TOT_ATDENS(IR) + ATDENS(IR,IELE)
CS            ZQUER(IR)=ZQUER(IR)+WEIGHTFRAC(IR,IELE)*
CS     &                Z2(ELEM(IR,IELE))*Z2(ELEM(IR,IELE))
            ZQUER(IR)=ZQUER(IR)+ATFRAC(IR,IELE)*
     &                Z2(ELEM(IR,IELE))*Z2(ELEM(IR,IELE))
257      CONTINUE
         ZQUER(IR)=DSQRT(ZQUER(IR))
263   CONTINUE


C     INITIALIZE PARAMETERS OF THE MODEL
 430  IONCRS='POU'
      LPOUCH=.TRUE.
      LGRYZ=.FALSE.
      LCASNATI=.FALSE.
      STOPP='LUO'
      LBETHE=.FALSE.
      BREMSCRS='ANA'
      LWIEDKIRK=.TRUE.
      LKQP=.FALSE.
      DO 431 I=1,4
         NSCATTER(I)=0
 431  CONTINUE
      DO 432 I=1,6
         TRLEN(I)=0
         TRLENP(I)=0
         TRLENB(I)=0
         TRLENT(I)=0
         TRLENS(I)=0
 432  CONTINUE
*     ---DEFAULT VALUES
      FAUGER='    '//CBL//CBL//CBL//CBL//CBL//CBL
      AUGMUL = 0.1
      NAHISV = 10
      NAHISL = 200
      AHISV = 200.
      DO 469 I=1,MAXREG
         FMAT(I)='    '//CBL//CBL//CBL//CBL//CBL//CBL
 469  CONTINUE
      DO 470 I=1,NREG
         MODR(I)='???'
         LELATR(I)= .FALSE.
 470  CONTINUE
      DO 507 I=1,MAXELE
         XCHAR(I)=CBL//CBL//CBL//CBL//CBL
 507  CONTINUE
      DO 508 I=1,MAXELE
         ION(I)=CBL//CBL//CBL//CBL
 508  CONTINUE
*     TABULATING OF INNER SHELL IONIZATION, DEFAULT 1000000eV
      DO 509,I=1,NDMASHELL
         ENEROFSHELL(I) = 1000000.
509   CONTINUE
*     NO IONISATION IS DEFAULT
      DO 280 IELE=1,MAXELE
         DO 278 IXCHAR=1,MAXXCHAR
            XCHARLINE(IXCHAR,IELE) = 0
278      CONTINUE
         DO 279 ISHELL=1,MAXSHELL
            SHELL(ISHELL,IELE) = 0
279      CONTINUE
280   CONTINUE
*     TABULATING OF CHAR. X-RAY ENERGY, DEFAULT 1000keV
      DO 609,I=1,MAXELE
         DO 608,J=1,MAXXCHAR
            EXCHAR(I,J) = 1000000.
608      CONTINUE
609   CONTINUE
*     NO IONISATION IS DEFAULT
      DO 380 IELE=1,MAXELE
         DO 379 IXCRAY=1,MAXXCHAR
            XCCHAR(IXCRAY,IELE) = 0
379      CONTINUE
380   CONTINUE
*     ---READ DATA FROM INPUT FILE
      IF (LINSTR) THEN
         REWIND 12
         READ (12,MODEL,END=281)
      ENDIF
281   IF (LDETCT) THEN
         REWIND 13
         READ (13,MODEL,END=282)
      ENDIF
282   IF (LMYDEF) THEN
         REWIND 14
         READ (14,MODEL,END=283)
      ENDIF
283   REWIND 11
      READ (11,MODEL,END=285)
285   CONTINUE
*     SET NXCONT TO ZERO IF NDMAXCONT IS ZERO TOO
      IF (NDMAXCONT.EQ.0) NXCONT=0
      NXCORIG=NXCONT
      IF (LMINP) GOTO 289
      DO 286,IR=1,NREG
         LSING(IR)=.FALSE.
         LPLAS(IR)=.FALSE.
         CALL CCAP(FMAT(IR),IEND(FMAT(IR)))
cs         IF (FMAT(IR).EQ.'SING')THEN
cs            LSING(IR)=.TRUE.
cs         ELSE IF (FMAT(IR).GT.' ') THEN
         IF (FMAT(IR).GT.' ') THEN
            IF ((MODR(IR).NE.'DIR').AND.(MODR(IR).NE.'dir')) GOTO 286
            LPLAS(IR) = .TRUE.
            I1=1
            I2=IEND(FMAT(IR))
            IFP=0
            IFC=0
            CALL FIND (FMAT(IR),']',I1,I2,IFPOS,IFD)
            IF (IFC.EQ.0) CALL FIND (FMAT(IR),'/',I1,I2,IFPOS,IFD)
            IF (IFC.EQ.0) THEN
               CDUMMY=CBL//CBL//CBL//CBL//CBL//CBL//CBL
               CDUMMY=FMAT(IR)
               FMAT(IR)=CDIEL(1:IEND(CDIEL))//CDUMMY(1:IEND(CDUMMY))
            ENDIF
         ELSE
cs            LSING(IR) = .FALSE.
            LPLAS(IR) = .FALSE.
         ENDIF
286   CONTINUE
      AUGERFILE=FAUGER
      IF (AUGERFILE .GT. ' ') THEN
         LAUGFILE = .TRUE.
      ELSE
         LAUGFILE = .FALSE.
      ENDIF
*     UPDATE SHELL() ACCORDING TO THE SPECIFICATION IN ION()
      DO 287 I=1,MAXELE
         IF (ION(I)(1:3).NE.'   ') THEN
            CALL CHKION (1,NDUMMY,ION(I),IEND(ION(I)))
         ENDIF
287   CONTINUE
*     UPDATE XCHARLINE() ACCORDING TO THE SPECIFICATION IN XCHAR()
      IFLAG=0
      DO 288 I=1,MAXELE
         IF (XCHAR(I)(1:3).NE.'   ') THEN
            CALL CHKXCH (1,NDUMMY,XCHAR(I),50)
            IFLAG=1
         ENDIF
288   CONTINUE
      IF (IFLAG.EQ.1) THEN
*        UPDATE SHELL() ACCORDING TO XCHARLINE()
         CALL CHKION (3,NDUMMY,CDUMMY,IEND(CDUMMY))
*        GUARANTEE THE GENERATION OF A GRID
         LGRD=.TRUE.
      ENDIF


CAP 19-DEC-1994 SEE INITPH
CA*     ---CONVERT DATA STRUCTURE FOR IONISATION
CAP
*     ---ROTATION MATRIX FROM INTERNAL TO EXTERNAL COORDINATE SYSTEM
CS      TLEN=SQRT(T(1,3)**2 + T(2,3)**2 + T(3,3)**2)
CS      T(1,3)=T(1,3)/TLEN
CS      T(2,3)=T(2,3)/TLEN
CS      T(3,3)=T(3,3)/TLEN
CS      TLEN=SQRT(T(1,1)**2 + T(2,1)**2 + T(3,1)**2)
CS
CS      T(1,1)=T(1,1)/TLEN
CS      T(2,1)=T(2,1)/TLEN
CS      T(3,1)=T(3,1)/TLEN
CS      IF (ABS(T(1,3)*T(1,1)+T(2,3)*T(2,1)+T(3,3)*T(3,1)).GT.EPSMA)
CS     +   GOTO 923
CS      T(1,2)=T(2,3)*T(3,1) - T(3,3)*T(2,1)
CS      T(2,2)=T(3,3)*T(1,1) - T(1,3)*T(3,1)
CS      T(3,2)=T(1,3)*T(2,1) - T(2,3)*T(1,1)

C     INITIALIZE PARAMETERS OF THE MEASUREMENT SETUP
*     ---DEFAULT VALUES
 289  MAGNI=-10000
      XTKDEF=-999
      XDRDEF=-999
      DTAKOFF(0)=30
      DXDEROT(0)=0
      MTIME=100
      CURRENT=1
      DO 290 I=0,MAXXDET
         DTAKOFF(I)=XTKDEF
         DXDEROT(I)=XDRDEF
 290  CONTINUE
      DO 291 I=0,MAXEDET
         DEDTHET(I)=XTKDEF
         DEDPHI(I) =XDRDEF
 291  CONTINUE
      EBTILT=0
      EBROT=0
      XESPOT=999999
      XRANGE=999999
      SCANANG=-999999
*     ---READ DATA FROM INPUT FILE
      IF (LINSTR) THEN
         REWIND 12
         READ (12,MSETUP,END=292)
      ENDIF
292   IF (LDETCT) THEN
         REWIND 13
         READ (13,MSETUP,END=293)
      ENDIF
293   IF (LMYDEF) THEN
         REWIND 14
         READ (14,MSETUP,END=294)
      ENDIF
294   REWIND 11
      READ (11,MSETUP,END=298)
298   CONTINUE

C     INITIALIZE PARAMETERS OF THE INSTRUMENT
*     ---DEFAULT VALUES
      NLSCP=-1
*     XPCRT IN MILLIMETERS
      XPCRT=-0.25
*     ---READ DATA FROM INPUT FILE
      IF (LINSTR) THEN
         REWIND 12
         READ (12,INSTR,END=302)
      ENDIF
302   IF (LDETCT) THEN
         REWIND 13
         READ (13,INSTR,END=303)
      ENDIF
303   IF (LMYDEF) THEN
         REWIND 14
         READ (14,INSTR,END=304)
      ENDIF
304   REWIND 11
      READ (11,INSTR,END=310)
310   CONTINUE

C     INITIALIZE PARAMETERS OF THE DETECTOR
*     ---DEFAULT VALUES
      DO 320 K=0,MAXXDET
         DO 319 I=1,MXDLAY
            NXLAYMAT(K,I)=0
            XLAYDN(K,I)=0
            XLAYTH(K,I)=0
            XLAYMAT(K,I)=CBL//CBL//CBL//CBL//CBL//CBL//CBL
            DO 318 J=1,10
               LAYXEL(K,I,J)=0
               XLAYAF(K,I,J)=0
318         CONTINUE
319      CONTINUE
         DXFDEFF(K)=CBL//CBL//CBL//CBL//CBL//CBL//CBL
         DXDTYPE(K)='  '
         DSOLIDA(K)=0
         DFWHM(K)=150
         DENFWHM(K)=5899
320   CONTINUE
      ESCFAC=0.2
      DO 321 I=0,MAXEDET
         DFEDTRN(I) = CBL//CBL//CBL//CBL//CBL//CBL//CBL
         NEDTRN(I) = 0
         DEDTHMN(I)=0
         DEDTHMX(I)=0
321   CONTINUE
*     ---READ DATA FROM INPUT FILE
      IF (LINSTR) THEN
         REWIND 12
         READ (12,DETECT,END=322)
      ENDIF
322   IF (LDETCT) THEN
         REWIND 13
         READ (13,DETECT,END=323)
      ENDIF
323   IF (LMYDEF) THEN
         REWIND 14
         READ (14,DETECT,END=324)
      ENDIF
324   REWIND 11
      READ (11,DETECT,END=325)
325   CONTINUE
      DO 330 J=0,MAXXDET
         DO 329 I=MXDLAY,1,-1
            IF (XLAYTH(J,I).EQ.0) NDLAY(J)=I-1
329      CONTINUE
330   CONTINUE
CS*     ---DEFAULT DETECTOR = 0 => SHIFT ENTRIES BY ONE TO HAVE ZERO ENTRY FREE
CS*        FOR DEFAULT
CS      DO 333 K=MAXXDET-1,0,-1
CS         TAKOFF(K+1)=TAKOFF(K)
CS         XDEROT(K+1)=XDEROT(K)
CS         XFDEFF(K+1)=XFDEFF(K)
CS         NDLAY(K+1)=NDLAY(K)
CS         DO 332 I=1,NDLAY(K+1)
CS            XLAYMAT(K+1,I)=XLAYMAT(K,I)
CS            XLAYTH(K+1,I)=XLAYTH(K,I)
CS            XLAYDN(K+1,I)=XLAYDN(K,I)
CS            NXLAYMAT(K+1,I)=NXLAYMAT(K,I)
CS            DO 331 J=1,10
CS               XLAYAF(K+1,I,J)=XLAYAF(K,I,J)
CS               LAYXEL(K+1,I,J)=LAYXEL(K,I,J)
CS331         CONTINUE
CS332      CONTINUE
CS333   CONTINUE
      NXDET=-1
      DO 341 I=0,MAXXDET
         NXDETCT(I)=0
CS         IF ((NDLAY(I).GT.0).OR.
CS     &       (DXFDEFF(I)(1:3).NE.'   ').OR.
CS     &       (DTAKOFF(I).NE.XTKDEF).OR.
CS     &       (DXDEROT(I).NE.XDRDEF)) THEN
         IF (DSOLIDA(I).GT.0) THEN
             NXDET=NXDET+1
             NXDETCT(NXDET)=I
         ENDIF
341   CONTINUE
      IF (NXDET.LE.0) GOTO 345
      DO 344 I=0,NXDETCT(NXDET)
         IF (I.NE.NXDETCT(I)) THEN
            DTAKOFF(I)=DTAKOFF(NXDETCT(I))
            DXDEROT(I)=DXDEROT(NXDETCT(I))
            DXFDEFF(I)=DXFDEFF(NXDETCT(I))
            DXDTYPE(I)=DXDTYPE(NXDETCT(I))
            DSOLIDA(I)=DSOLIDA(NXDETCT(I))
            DFWHM(I)=DFWHM(NXDETCT(I))
            DENFWHM(I)=DENFWHM(NXDETCT(I))
            NDLAY(I)=NDLAY(NXDETCT(I))
            DO 343 J=1,NDLAY(I)
               XLAYMAT(I,J)=XLAYMAT(NXDETCT(I),J)
               XLAYTH(I,J)=XLAYTH(NXDETCT(I),J)
               XLAYDN(I,J)=XLAYDN(NXDETCT(I),J)
               NXLAYMAT(I,J)=NXLAYMAT(NXDETCT(I),J)
               DO 342 K=1,10
                  XLAYAF(I,J,K)=XLAYAF(NXDETCT(I),J,K)
                  LAYXEL(I,J,K)=LAYXEL(NXDETCT(I),J,K)
342            CONTINUE
343         CONTINUE
         ENDIF
344   CONTINUE
345   IF (NXDET.LT.0) NXDET=0
      IF ((NXDET.EQ.0).AND.(DSOLIDA(0).LE.0)) DSOLIDA(0)=0.00314
      IF (NXDET.GT.MAXXDET) NXDET=MAXXDET
      DO 346 I=0,NXDET
         IF (DTAKOFF(I).EQ.XTKDEF) DTAKOFF(I)=30
         IF (DXDEROT(I).EQ.XDRDEF) DXDEROT(I)=0
346   CONTINUE

CS      DO 350 K=MAXEDET-1,0,-1
CS         FEDTRN(K+1)=FEDTRN(K)
CS         EDTHET(K+1)=EDTHET(K)
CS         EDPHI(K+1)=EDPHI(K)
CS         EDTHSZ(K+1,1)=EDTHSZ(K,1)
CS         EDTHSZ(K+1,2)=EDTHSZ(K,2)
CS350   CONTINUE
CS      DFEDTRN(0)=CBL//CBL//CBL//CBL//CBL//CBL//CBL
CS      DEDTHET(0)=0
CS      DEDPHI(0)=0
CS      DEDTHMN(0)=0
CS      DEDTHMX(0)=0
      NEDET=-1
      DO 351 I=0,MAXEDET
         NEDETCT(I)=0
CS         IF ((DFEDTRN(I)(1:3).NE.'   ').OR.
CS     &       (DEDTHMN(I).NE.0).OR.
CS     &       (DEDTHMX(I).NE.90).OR.
CS     &       (DEDTHET(I).NE.XTKDEF).OR.
CS     &       (DEDPHI(I).NE.XDRDEF)) THEN
         IF (DEDTHMX(I).GT.0) THEN
             NEDET=NEDET+1
             NEDETCT(NEDET)=I
         ENDIF
351   CONTINUE
      IF (NEDET.LE.0) GOTO 355
      DO 354 I=0,NEDETCT(NEDET)
         IF (I.NE.NEDETCT(I)) THEN
            DEDTHET(I)=DEDTHET(NEDETCT(I))
            DEDPHI(I)=DEDPHI(NEDETCT(I))
            DFEDTRN(I)=DFEDTRN(NEDETCT(I))
            DEDTHMN(I)=DEDTHMN(NEDETCT(I))
            DEDTHMX(I)=DEDTHMX(NEDETCT(I))
         ENDIF
354   CONTINUE
355   IF (NEDET.LT.0) NEDET=0
      IF ((NEDET.EQ.0).AND.(DEDTHMX(0).LE.0)) DEDTHMX(0)=90
      IF (NEDET.GT.MAXEDET) NEDET=MAXEDET
      DO 356 I=0,NEDET
         IF (DEDTHET(I).EQ.XTKDEF) DEDTHET(I)=0
         IF (DEDPHI(I).EQ.XDRDEF) DEDPHI(I)=0
356   CONTINUE

C     CALCULATE SOLID ANGLE OF ACCEPTANCE
      DO 358 I=0,NEDET
       EDACAN(I)=2*PI*
     .	 (COS(PI/180.*DEDTHMN(I))-COS(PI/180.*DEDTHMX(I)))    
358   CONTINUE


C     INITIALIZE PARAMETERS FOR THE OUTPUT
      DO 408 I=1,MAXELE
         DO 397 J=1,MAXXCHAR
            XCIODIS41(I,J)=0
            DO 396 K=1,MAXHIS
               XCIODIS4(I,J,K,1)=0
               XCIODIS4(I,J,K,2)=0
 396        CONTINUE
 397     CONTINUE
         DO 402 J=1,MAXSHELL
            XCIODIS1(I,J)=0
            DO 400 K=1,5
               XCIODIS21(I,J,K)=0
               XCIODIS21(I,J,K+3)=0
               DO 398 KK=1,MAXSCR
                  XCIODIS2(I,J,K,KK)=0
                  XCIODIS2(I,J,K+3,KK)=0
 398           CONTINUE
               XCIODIS31(I,J,K)=0
               DO 399 KK=1,MAXSAV
                  XCIODIS3(I,J,K,KK)=0
 399           CONTINUE
 400        CONTINUE
            XCIODIS91(I,J)=0
            DO 401 K=1,MAXHIS
               XCIODIS9(I,J,K)=0
 401        CONTINUE
 402     CONTINUE
         DO 407 J=1,MXAUGP
            XCIODIS8(I,J)=0
            DO 403 K=1,MAXHIS
               XCIODIS7(I,J,K)=0
 403        CONTINUE
            DO 406 K=1,4
               XCIODIS6(I,J,K)=0
               DO 405 KK=1,MAXSCR+MAXPST
                  XCIODIS5(I,J,KK,K)=0
 405           CONTINUE
 406        CONTINUE
 407     CONTINUE
 408  CONTINUE
*     ---DEFAULT VALUES
      CGRDFL=CBL//CBL//CBL//CBL//CBL//CBL//CBL
      FETRBK=CBL//CBL//CBL//CBL//CBL//CBL//CBL
      FPHI=CBL//CBL//CBL//CBL//CBL//CBL//CBL
      FETAB=CBL//CBL//CBL//CBL//CBL//CBL//CBL
      DO 409 I=1,MAXSCR
         SCRTITLE(I)=CBL//CBL//CBL//CBL//CBL//CBL
 409  CONTINUE
      DO 410 I=0,2*MAXSCR
         SCREEN(I)=CBL//CBL//CBL//CBL//CBL//CBL//CBL
 410  CONTINUE
      DO 411 I=1,3*MAXPST
         POST(I)=CBL//CBL//CBL//CBL//CBL//CBL//CBL
 411  CONTINUE
      DO 412 I=1,MAXSAV
         PMSAV(I)=CBL//CBL//CBL//CBL//CBL//CBL//CBL
 412  CONTINUE
      DO 413 I=1,MAXHIS
         HIST(I)=CBL//CBL//CBL//CBL//CBL//CBL//CBL
 413  CONTINUE
      LCOLTRJ=.TRUE.
      LQUAD=.FALSE.
      LGRID=.FALSE.
      LGRAY=.FALSE.
      LSCDEF=.FALSE.
      LSCRN1=.FALSE.
      LSCRN=.TRUE.
      LSTATW=.TRUE.
      NSCRN=0
      LPOST=.FALSE.
      LPMSAV=.FALSE.
      LHIS=.FALSE.
      LETAB=.FALSE.
      LTRAJ=.TRUE.
      LBE=.FALSE.
      LTE=.FALSE.
      LSE=.FALSE.
      LAE=.FALSE.
      LXR=.FALSE.
      LXC=.FALSE.
      LXK=.FALSE.
      LIO=.FALSE.
      LPOI=.FALSE.
      LTRA=.FALSE.
      LINT=.FALSE.
      LANG=.FALSE.
      LAANG=.FALSE.
      LPANG=.FALSE.
      LENERG=.FALSE.
      LETRBK=.FALSE.
      LBCKSC=.FALSE.
      LSCDEF=.FALSE.
      NETRBK=0
      NSCRUP=500
      MINICOL=1
      MAXICOL=NPALET
      MNCOLPAL=1
      NXGRID=-1
      NYGRID=-1
      NZGRID=-1
      IQUAD=0
*     ---READ DATA FROM INPUT FILE
      IF (LINSTR) THEN
         REWIND 12
         READ (12,OUTPUT,END=450)
      ENDIF
450   IF (LDETCT) THEN
         REWIND 13
         READ (13,OUTPUT,END=453)
      ENDIF
453   IF (LMYDEF) THEN
         REWIND 14
         READ (14,OUTPUT,END=456)
      ENDIF
456   REWIND 11
      READ (11,OUTPUT,END=460)
460   CONTINUE
      IF ((MODE.EQ.1).AND.(LUSEBK)) THEN
*        INPUT DECK SHOULD BE READ FROM BACKUP FILE
*        KEEP SOME VARIABLES FROM THE NEW INPUT DECK
         C1USTXT=CBL//CBL//CBL//CBL//CBL//CBL//CBL
         IF (CUSTXT(1:3).NE.'   ') C1USTXT=CUSTXT
         F1ETRBK=CBL//CBL//CBL//CBL//CBL//CBL//CBL
         IF (FETRBK(1:3).NE.'   ') F1ETRBK=FETRBK
         J1OB=CBL//CBL//CBL
         IF (JOB(1:3).NE.'   ') J1OB=JOB
         N1ETRN=NETRN
         A1HISV=200.
         IF (AHISV.NE.200.) A1HISV=AHISV
         A1UGMUL=0.1
         IF (AUGMUL.NE.0.1) A1UGMUL=AUGMUL
         L1TEST=.FALSE.
         IF (LTEST) L1TEST=LTEST
         L1QUAD=.FALSE.
         IF (LQUAD) L1QUAD=LQUAD
         L1GRID=.FALSE.
         IF (LGRID) L1GRID=LGRID
         L1SCRN=.TRUE.
         IF (.NOT.LSCRN) L1SCRN=LSCRN
         L1STATW=.TRUE.
         IF (.NOT.LSTATW) L1STATW=LSTATW
         N1ETRBK=NETRBK
         N1SCRUP=500
         IF (NSCRUP.NE.500) N1SCRUP=NSCRUP
         M1INICOL=1
         IF (MINICOL.NE.1) M1INICOL=MINICOL
         M1AXICOL=NPALET
         IF (MAXICOL.NE.NPALET) M1AXICOL=MAXICOL
         M1NCOLPAL=1
         IF (MNCOLPAL.NE.1) M1NCOLPAL=MNCOLPAL
         L1GRAY=.FALSE.
         IF (LGRAY) L1GRAY=LGRAY
         M1TIME=100.
         IF (MTIME.NE.100.) M1TIME=MTIME
         C1URRENT=1.
         IF (CURRENT.NE.1.) C1URRENT=CURRENT
         BCKLD=USEBK
         GOTO 800
      ELSE IF (MODE.EQ.2) THEN
*        TAKE SOME VARIABLES FROM THE NEW INPUT DECK INSTEAD FROM BACKUP FILE
         IF (C1USTXT(1:3).NE.'   ') CUSTXT=C1USTXT
         IF (F1ETRBK(1:3).NE.'   ') FETRBK=F1ETRBK
         IF (J1OB(1:3).NE.'   ') JOB=J1OB
         NETRN=N1ETRN
         AHISV=A1HISV
         AUGMUL=A1UGMUL
         LTEST=L1TEST
         LQUAD=L1QUAD
         LGRID=L1GRID
         LSTATW=L1STATW
         LSCRN=L1SCRN
         NETRBK=N1ETRBK
         NSCRUP=N1SCRUP
         MINICOL=M1INICOL
         MAXICOL=M1AXICOL
         MNCOLPAL=M1NCOLPAL
         LGRAY=L1GRAY
         MTIME=M1TIME
         CURRENT=C1URRENT
      ENDIF

      IF (LSCDEF) LSCRN1=.TRUE.
      DO 710 I=1,2*MAXSCR
         IF (SCREEN(I)(1:10).NE.CBL) LSCRN1=.TRUE.
         CALL CCAP(SCREEN(I),3)
         IF (SCREEN(I)(1:2).EQ.'SE') LESEC=.TRUE.
         IF ((SCREEN(I)(1:1).EQ.'A').OR.
     &       (SCREEN(I)(1:1).EQ.'D')) LEAUG=.TRUE.
710   CONTINUE
      DO 720 I=1,3*MAXPST
         IF (POST(I)(1:10).NE.CBL) LPOST=.TRUE.
         CALL CCAP(POST(I),3)
         IF (POST(I)(1:2).EQ.'SE') LESEC=.TRUE.
         IF ((POST(I)(1:1).EQ.'A').OR.
     &       (POST(I)(1:1).EQ.'D')) LEAUG=.TRUE.
720   CONTINUE
      DO 730 I=1,MAXSAV
         IF (PMSAV(I)(1:10).NE.CBL) LPMSAV=.TRUE.
         CALL CCAP(PMSAV(I),3)
         IF (PMSAV(I)(1:2).EQ.'SE') LESEC=.TRUE.
         IF ((PMSAV(I)(1:1).EQ.'A').OR.
     &       (PMSAV(I)(1:1).EQ.'D')) LEAUG=.TRUE.
730   CONTINUE
      DO 740 I=1,MAXHIS
         IF (HIST(I)(1:10).NE.CBL) LHIS=.TRUE.
         CALL CCAP(HIST(I),3)
         IF (HIST(I)(1:2).EQ.'SE') LESEC=.TRUE.
         IF ((HIST(I)(1:1).EQ.'A').OR.
     &       (HIST(I)(1:1).EQ.'D')) LEAUG=.TRUE.
740   CONTINUE
*     ---DETERMINE ELECTRON SOURCE, 1=BEAM,2=PHI(Z),3=TABULATED
      NELESOURCE = 1
      IF (FPHI(1:2).NE.'  ')  NELESOURCE = 2
      IF (FETAB(1:2).NE.'  ') NELESOURCE = 3
*     ---BACKUP FILE SHOULD BE WRITTEN (=>LETRBK=.TRUE.)
      IF ((FETRBK(1:10).NE.CBL).AND.(NETRBK.GT.0)) LETRBK=.TRUE.
      LBCKSC=LSCRN1.AND.LETRBK
      LSTATW=LSCRN.AND.LSTATW
      LSCRN=LSCRN.AND.LSCRN1
      LSCRN1=LSCRN.OR.LBCKSC
      IF (LQUAD.AND.LSCRN) IQUAD=1

*     CLOSE FILES
800   CLOSE(11)
      IF (LINSTR) CLOSE(12)
      IF (LDETCT) CLOSE(13)
      IF (LMYDEF) CLOSE(14)

      RETURN

900   WRITE (*,*) INFILE
      STOP 'ERROR DURING OPENING INPUT FILE'
901   STOP '&ETRNS: HAS NOT BEEN FOUND IN THE INPUT FILE'
902   STOP '&ETRNS: NETRN AND E0 MUST BE SPECIFIED NONZERO'
903   STOP '&INIT:  HAS NOT BEEN FOUND IN THE INPUT FILE'
911   STOP '&TARGET: MAXIMUM NUMBER OF ELEMENTS EXCEEDED'
921   STOP '&TARGET: MAXIMUM NUMBER OF REGIONS EXCEEDED'
922   STOP '&TARGET: ONLY ONE REGION MUST BE CRYSTALLINE'
930   WRITE (*,*) USEBK
      STOP 'ERROR DURING OPENING BACKUP FILE'
940   WRITE (*,*) USEBK
      STOP 'DID NOT FIND INPUT DECK IN BACKUP FILE'
950   WRITE (*,*) USEBK
      STOP 'COULD NOT OPEN SCRATCH FILE TO EXTRACT INPUT DECK'

      END

******************************************************************************
* last modification: CS 03-Dec-1996

      SUBROUTINE INITPH (NPTS,NFCS,XCABS)

***   INITPH - INITIALIZES PHYSICAL PARAMETERS OF SESAME
*              AFTER CHKINI
*
**    ARGUMENTS
*
*        NPTS   - ACTUAL NUMBER OF POINTS
*        NFCS   - ACTUAL NUMBER OF FACES
*
**    AUTHOR:  C.SCHIEBL   OCT 1994
*              H.WAGNER    AUG 1994
*              A.PFEIFFER  AUG 94
*
      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'GLOBAL.INC'
      INCLUDE 'HIST.INC'
      INCLUDE 'OUTPUT.INC'
      INCLUDE 'DMA.INC'

*     ABSORPTION FACTORS (FOR CHARACTERISTIC AND BACKGROUND RADIATION)
      DOUBLE PRECISION XCABS(0:NDMAXDET-1,NDMAXCONT+NDMAXCHAR-NDMAPTOB,
     &                       NDMAXGRID,NDMAZGRID,NDMAYGRID)

      DIMENSION NDUMMY(20)
      CHARACTER*64 CDUMMY
      CHARACTER*10 CBL

      DATA CBL /'          '/

      INCLUDE 'PATH.INC'

**    START OF EXECUTABLE CODE
*     ************************

      CDUMMY=CBL//CBL//CBL//CBL//CBL//CBL//CBL

C INITIALIZE SINE AND COSINE LOOK-UP TABLES
      DO 50,I=0,360
         SINE(I)   = SIN(DBLE(I)/180.*PI)
         COSINE(I) = COS(DBLE(I)/180.*PI)
50    CONTINUE

C INITIALIZE TRANSFORMATION TABLE FOR ELECTRON DETECTORS
      DO 58 I=0,NEDET
         EDT(I,1,1) = COS(DEDTHET(I))*COS(DEDPHI(I))
         EDT(I,1,2) = COS(DEDTHET(I))*SIN(DEDPHI(I))
         EDT(I,1,3) = -SIN(DEDTHET(I))
         EDT(I,2,1) = SIN(DEDPHI(I))
         EDT(I,2,2) = COS(DEDPHI(I))
         EDT(I,2,3) = 0.
         EDT(I,3,1) = SIN(DEDTHET(I))*COS(DEDPHI(I))
         EDT(I,3,2) = SIN(DEDTHET(I))*SIN(DEDPHI(I))
         EDT(I,3,3) = COS(DEDTHET(I))
 58   CONTINUE

C INITIALIZE THE AUGER TABLES

      CALL UPDAUG (IFLAG)
      CALL INIAUG()

C UPDATE SHELL(MAXSHELL,MAXELE) ACCORDING TO AUGERPEAK(MXAUGP,MAXELE)
      IF (NAUGER.GT.0) THEN
         CALL CHKION(4,NDUMMY,CDUMMY,IEND(CDUMMY))
      ENDIF

C INITIALIZE THE LINE TABLES
      CALL UPDXCH (IFLAG)
      IF (NXCHAR.GT.0) THEN
         MXINDX=NDMAXDET*(NXCHAR-1)+(NXDET+1)
         CALL CHKBND (13,MXINDX,'INITPH','FWHMOFXCHAR')
      ENDIF
      DO 70 I=1,NXCHAR
*        GET CHARACTERISTIC ENERGIES
         CALL GETEC (XCHAROFXCHAR(I),ATNUM(ELEMOFXCHAR(I)),
     &               ENEROFXCHAR(I),IERR)
 70   CONTINUE
      DO 75 J=0,NXDET
         DO 73 I=1,NXCHAR
            INDX=NDMAXDET*(I-1)+(J+1)
            CALL CCAP(DXDTYPE(J),2)
            IF (DXDTYPE(J).EQ.'WD') THEN
               FWHMOFXCHAR(INDX)=DFWHM(J)
               GOTO 73
            ENDIF
            AA=2.5*(ENEROFXCHAR(I)-DENFWHM(J))+DFWHM(J)**2
            IF (AA.LT.1) THEN
CS               FWHMOFXCHAR(J,I)=1
               FWHMOFXCHAR(INDX)=1
            ELSE
CS               FWHMOFXCHAR(J,I)=DSQRT(AA)
               FWHMOFXCHAR(INDX)=DSQRT(AA)
            ENDIF
 73      CONTINUE
 75   CONTINUE
C UPDATE SHELL(MAXSHELL,MAXELE) ACCORDING TO XCHARLINE(MAXXCHAR,MAXELE)
      IF (NXCHAR.GT.0) THEN
         CALL CHKION(3,NDUMMY,CDUMMY,IEND(CDUMMY))
      ENDIF

C INITIALIZE THE SHELL TABLES
cs      IF (NSHELL.GT.0) CALL UPDSHL (IFLAG)
      CALL UPDSHL (IFLAG)
      DO 77 I=1,NSHELL
*        GET EDGE ENERGIES
         CALL GETED (1,SHELLOFSHELL(I),ATNUM(ELEMOFSHELL(I)),
     &               ENEROFSHELL(I),IERR)
 77   CONTINUE

* INITIALIZE THE BREMSSTRAHLUNG TABLES
      NMXCONT=NDMAXCONT+NDMAXCHAR-NDMAPTOB
      IF (LXCONT.OR.LPTOB) CALL INIBREMS (NMXCONT)

C INITIALIZE FLUORESCENCE YIELDS AND TRANSITION PROBABILITIES
C XCHAR AND SHELL TABLES NEEDED!!
      DO 80 I=1,NXCHAR
*        GET FLUORESCENCE YIELDS
         CALL CHKBND(5,SHELLOFXCHAR(I),'INITPH    ','SHELLOFSHELL')
         CALL GETOME(SHELLOFSHELL(SHELLOFXCHAR(I)),
     &               ATNUM(ELEMOFXCHAR(I)),
     &               FYIELDOFXCHAR(I),IERR)
*        GET TRANSITION PROBABILITIES
         CALL GETPRO(XCHAROFXCHAR(I),
     &               SHELLOFSHELL(SHELLOFXCHAR(I)),
     &               ATNUM(ELEMOFXCHAR(I)),
     &               FRELINTOFXCHAR(I),IERR)
80    CONTINUE

CAP 19-DEC-1994 
CAP   CHOICE OF MODEL?!
      I_MODEL=1
      CALL INIT_ION_TOT (
     I                   I_MODEL)
CAP
      CALL INIT_SIGMAION(
     I                   I_MODEL)

CHW   INITIALIZE ELASTIC SCATTERING
      CALL E_INIT(IER)

CHW   INITIALIZE PLASMON LOSS
      CALL P_INIT(IER)

CHW   INITIALIZE PHI(Z)
      IF (NELESOURCE .EQ. 2) CALL ZPHI(DUMMY1,DUMMY2,DUMMY3,0)

CAP   INITIALIZE STOPPING
      CALL INIT_STOPP(IER)

CAP   INITIALIZE DELTAE
      CALL INIT_DELTAE(IER)

CAP   INITIALIZE MAC'S
      IF (LINIABS.OR.(NXCHAR.GT.0).OR.(NXCONT.GT.0)) THEN
         CALL INIT_MAC(
     D                 NPTS,NFCS,XCABS,
     O                 IER)
      ENDIF

      RETURN
      END

*****************************************************************************
* last modification: CS 24-Mar-1997

      SUBROUTINE INIBREMS (MXXCONT)

***   INIBREMS - INITIALIZES THE BREMSSTRAHLUNG TABLES
*
**    ARGUMENTS
*
*        MXXCONT - MAXIMUM NUMBER OF DESCRETE BREMSSTRAHLUNG ENERGIES
*                  (DETERMINED DURING FIRST EVALUATION OF INPUT DECK
*                  NEEDED FOR DYNAMIC MEMORY ALLOCATION)
*
**    AUTHOR: CHRISTIAN SCHIEBL
*             CONSULTANT (FORMER: CEC-VIENNA)
*             KREMS, SEPTEMBER 1996
*

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'GLOBAL.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'DMA.INC'

      INTEGER IINDX(1),IHELP(MAXXCHARS)
      POINTER (P2IINDX,IINDX)

**    START OF EXECUTABLE CODE
*     ************************

*     ALLOCATE MEMORY FOR IINDX
      IF (MXXCONT.NE.(NDMAXCONT+NDMAXCHAR-NDMAPTOB)) THEN
         MXXCONT=NDMAXCONT+NDMAXCHAR-NDMAPTOB
      ENDIF
      IF (MXXCONT.LE.0) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' *** ERROR ***'
         WRITE(6,'(2A)')' INIBREMS: Parameter (MXXCONT) for memory',
     &                  ' allocation of IINDX less.equal zero !'
         WRITE(6,'(2A)')'           MXXCONT will be set to the',
     &                  ' default value (MAXXCONT) !'
         MXXCONT=MAXXCONT
      ENDIF
      P2IINDX=MALLOC(SIZEOF(IINDX(1))*MXXCONT)
      IF (P2IINDX.EQ.0) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' *** ERROR ***'
         WRITE(6,'(2A)')' INIBREMS: Could not allocate memory',
     &                  ' for IINDX !'
         STOP
      ENDIF

*     PRIMARY INITIALIZATION
*     INITIALIZATION OF VALBREMS() IN BRMVAL
CS      CALL CHKBND (7,MXXCONT,'INIBREMS','ENEROFXCONT')
      CALL CHKBND (7,NDMAXCONT,'INIBREMS','ENEROFXCONT')
      MXINDX=NDMAXDET*NDMAXCONT
      CALL CHKBND (13,MXINDX,'INIBREMS','XDETOFXCONT')
      CALL CHKBND (7,NDMAXCONT,'INIBREMS','IXCONTOFXCHAR')
      IF (NDMAHIST.GT.0) THEN
         MXINDX=NDMAHIST*NDMAXCONT
         CALL CHKBND (26,MXINDX,'INIBREMS','XKHIS/...')
      ENDIF
CS      DO 25 IXC=1,MXXCONT
      DO 25 IXC=1,NDMAXCONT
         ENEROFXCONT(IXC)=0
         IXCONTOFXCHAR(IXC)=0
         DO 20 IXDET=0,NDMAXDET-1
            INDX=NDMAXDET*(IXC-1)+(IXDET+1)
CS            XDETOFXCONT(IXDET,IXC)=0
            XDETOFXCONT(INDX)=0
 20      CONTINUE
         NXKHIS(IXC)=0
         IF (NDMAHIST.GT.0) THEN
           DO 22 IHIS=1,NDMAHIST
             INDX=(IXC-1)*NDMAHIST+IHIS
             XKHIS(INDX)=0
             XDETXKHIS(INDX)=0
 22        CONTINUE
         ENDIF
 25   CONTINUE
      NXCONT=0
      NXPTOB=0

      IF (NXCHAR.GT.0) THEN
      NEST=NXCHAR+1
      DO 27 I=NXCHAR,1,-1
         CALL CHKBND(5,SHELLOFXCHAR(I),'INIBREMS  ','ENEROFSHELL')
         IF (ENEROFSHELL(SHELLOFXCHAR(I)).LT.E0) NEST=I
 27   CONTINUE
      CALL CHKBND(6,NEST,'INIBREMS  ','IXCHAROFXCONT')
      DO 28 I=1,NEST
         IXCHAROFXCONT(I)=0
 28   CONTINUE
      ENDIF

      IF (NXCHAR.GT.0) THEN
         DO 30 IXC=NEST,NXCHAR
            IF (IXC.EQ.NEST) THEN
               NXPTOB=NXPTOB+1
               ENEROFXCONT(NXPTOB)=ENEROFXCHAR(IXC)
               IXCONTOFXCHAR(NXPTOB)=NEST
               IXCHAROFXCONT(NEST)=NXPTOB
               GOTO 30
            ENDIF
            IFLAG=0
            DO 10 I=1,NXPTOB
               IF (ENEROFXCONT(I).EQ.ENEROFXCHAR(IXC)) THEN
                  IFLAG=1
                  IXCHAROFXCONT(IXC)=I
               ENDIF
 10         CONTINUE
            IF (IFLAG.EQ.1) GOTO 30
            CALL CHKBND(5,SHELLOFXCHAR(IXC),'INIBREMS  ',
     &                  'ENEROFSHELL')
            IF (ENEROFSHELL(SHELLOFXCHAR(IXC)).LT.E0)THEN
               NXPTOB=NXPTOB+1
               ENEROFXCONT(NXPTOB)=ENEROFXCHAR(IXC)
               IXCONTOFXCHAR(NXPTOB)=IXC
               IXCHAROFXCONT(IXC)=NXPTOB
            ELSE
               IXCHAROFXCONT(IXC)=0
            ENDIF
 30      CONTINUE
         CALL CHKBND (7,NXPTOB,'INIBREMS','IXCONTOFXCHAR')
         NXCONT=NXPTOB
         DO 40 I=1,MXXCONT
            IINDX(I)=I
 40      CONTINUE
         CALL STSORT (NXCONT,ENEROFXCONT,IXCONTOFXCHAR,IINDX)
         DO 50 I=1,NXCHAR
            IHELP(I)=IXCHAROFXCONT(I)
 50      CONTINUE
         DO 60 I=1,NXCHAR
            IF (IHELP(I).EQ.0) THEN
               IXCHAROFXCONT(I)=0
            ELSE
               DO 55 J=1,NXCONT
                  IF (IHELP(I).EQ.IINDX(J)) IXCHAROFXCONT(I)=J
 55            CONTINUE
            ENDIF
 60      CONTINUE
      ENDIF
      IF (NXPTOB.GT.0) LPTOB=.TRUE.

*     IN CASE THE WHOLE SPECTRUM SHOULD BE CALCULATED
      IF (LXCONT) THEN
         IF (NXCONT.GT.0) 
     &       CALL CHKBND (7,NXCONT,'INIBREMS','ENEROFXCONT')
         IF (NXPTOB.GT.0) THEN
*           DETERMINE NUMBER OF DESCRETE ENERGIES
 80         ELEFT=0
            NXCLEFT=MXXCONT-NXCONT
            IF (NXCLEFT.LE.0) GOTO 300
            EDIFFMX=E0-ENEROFXCONT(NXCONT)
            ENERG1=ENEROFXCONT(NXCONT)
            ENERG2=E0
            DO 100 I=1,NXCONT
               EDIFF=ENEROFXCONT(I)-ELEFT
               IF (EDIFF.GT.EDIFFMX) THEN
                  EDIFFMX=EDIFF
                  ENERG1=ELEFT
                  ENERG2=ENEROFXCONT(I)
               ENDIF
               ELEFT=ENEROFXCONT(I)
 100        CONTINUE
            NXCONT=NXCONT+1
CS            IF ((NXCHAR+NXCONT-NXPTOB).GT.MAX(MAXXCHARS,MXXCONT)) THEN
            IF ((NXCHAR+NXCONT-NXPTOB).GT.MXXCONT) THEN
               NXCONT=NXCONT-1
               GOTO 300
            ENDIF
            ENEROFXCONT(NXCONT)=(ENERG1+ENERG2)/2
            IXCONTOFXCHAR(NXCONT)=0
            DO 140 I=1,MXXCONT
               IINDX(I)=I
 140        CONTINUE
            CALL CHKBND (7,NXCONT,'INIBREMS','IXCONTOFXCHAR')
            CALL STSORT (NXCONT,ENEROFXCONT,IXCONTOFXCHAR,IINDX)
            DO 150 I=1,NXCHAR
               IHELP(I)=IXCHAROFXCONT(I)
 150        CONTINUE
            DO 160 I=1,NXCHAR
               IF (IHELP(I).EQ.0) THEN
                  IXCHAROFXCONT(I)=0
               ELSE
                  DO 155 J=1,NXCONT
                     IF (IHELP(I).EQ.IINDX(J)) IXCHAROFXCONT(I)=J
 155              CONTINUE
               ENDIF
 160        CONTINUE      
            GOTO 80
         ELSE
*           EQUIDISTRIBUTE DISCRETE ENERGIES BETWEEN 0 AND E0
            IF (NXCONT.NE.0) THEN
               WRITE(6,'(A)')'     '
               WRITE(6,'(A)')' %%% WARNING %%%'
               WRITE(6,'(A)')' INIBREMS: NXCONT SHOULD BE ZERO !'
               NXCONT=0
               NXPTOB=0
            ENDIF
            NXCONT=MXXCONT
            ENERDELT=E0/(MXXCONT+1)
            CALL CHKBND (7,NXCONT,'INIBREMS','IXCONTOFXCHAR')
            DO 200 I=1,NXCONT
               ENEROFXCONT(I)=ENERDELT*I
               IXCONTOFXCHAR(I)=0
 200        CONTINUE
         ENDIF
      ENDIF

*     DO INITIALIZATION OF IXCONTOFXCHAR TO FIND APPROPRIATE XCABS LATER
CS      IF (LXCONT.AND.(NXCONT.GT.NXCHAR)) THEN
 300  IF (LXCONT.AND.(NXCONT.GT.NXPTOB)) THEN
         INXT=NXCHAR
         DO 310 I=1,NXCONT
            IF (IXCONTOFXCHAR(I).EQ.0) THEN
               INXT=INXT+1
               IXCONTOFXCHAR(I)=INXT
            ENDIF
 310    CONTINUE
      ENDIF

*     CALCULATE DIRECTION (NORMALIZED VECTORS) TO THE X-RAY DETECTORS
      DO 320 IXD=0,NXDET
         DIRXDET(IXD,1)=DCOS(TAKOFR(IXD))*DCOS(DEROTR(IXD))
         DIRXDET(IXD,2)=DCOS(TAKOFR(IXD))*DSIN(DEROTR(IXD))
         DIRXDET(IXD,3)=-DSIN(TAKOFR(IXD))
         DXLNGT=DSQRT(DIRXDET(IXD,1)**2+DIRXDET(IXD,2)**2+
     &                DIRXDET(IXD,3)**2)
         DIRXDET(IXD,1)=DIRXDET(IXD,1)/DXLNGT
         DIRXDET(IXD,2)=DIRXDET(IXD,2)/DXLNGT
         DIRXDET(IXD,3)=DIRXDET(IXD,3)/DXLNGT
 320  CONTINUE

*     FREE ALLOCATED MEMORY
      CALL FREE (P2IINDX)

      RETURN
      END

*****************************************************************************

      SUBROUTINE STSORT (IN,A,B1,B2)
      INCLUDE 'TYPE.INC'
*
***   S T S O R T   ---   SORT ARRAY A(1:IN)
*
*     GERD NANZ             1991/01/30         CEC VIENNA
*     CHRISTIAN SCHIEBL     1991/10/31         CEC VIENNA
*
*
*     PARAMETERS:
*     ===========
*
*         INPUT:
*         ------
*         IN  ...  DIMENSION OF ARRAY A
*         A   ...  ARRAY TO BE SORTED (REAL)
*         B1  ...  ARRAY TO BE RENUMBERD ACCORDING TO A (INTEGER)
*         B2  ...  ARRAY TO BE RENUMBERD ACCORDING TO A (INTEGER)
*
*         OUTPUT:
*         -------
*         A   ...  SORTED ARRAY (REAL)
*         B1  ...  RENUMBERED ARRAY (ACCORDING TO A) (INTEGER)
*         B2  ...  RENUMBERED ARRAY (ACCORDING TO A) (INTEGER)
*
*
* SUBROUTINE DESCRIPTION:
* =======================
* THIS SUBROUTINE SORTS THE ARRAY A IN ASCENDING ORDER.
* THE ARRAYS B1 AND B2 ARE SORTED ACCORDING TO A
* THE METHOD IS BASED ON STRAIGHT SORT.
*
      DOUBLE PRECISION A,Y
      INTEGER B1,B2,X,Z
      DIMENSION A(IN),B1(IN),B2(IN)
*
      DO 30, J=2,IN
        I = J-1
        Y = A(J)
        X = B1(J)
        Z = B2(J)
   10   CONTINUE
        IF (.NOT. (I.GT.0 .AND. Y.LT.A(I))) GOTO 20
        A(I+1) = A(I)
        B1(I+1) = B1(I)
        B2(I+1) = B2(I)
        I = I-1
        GOTO 10
   20   CONTINUE
        A(I+1) = Y
        B1(I+1) = X
        B2(I+1) = Z
   30 CONTINUE
*
      RETURN
      END

****************************************************************************
