c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
*last modification: 05-Nov-1996

      SUBROUTINE IONVAL
     I                 ( INIT,MODE,
     D			 NSHELL,NGRIDX,NGRIDZ,NGRIDY,
     D			 XGRIDL,ZGRIDL,YGRIDL,
     D                   XMIN,XMAX,ZMIN,ZMAX,
     I                   X,Z,ISHELL,VALUE,
     O                   VALION,NOUTGR,NOUTAR,IXGRL,IZGRL,
     O                   IER)

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC' 
      INCLUDE 'DMA.INC'

***   IONVAL- INCREASES THE COUNTER OF THE GRIDPOINTS, WHERE THE SPECIFIED
*	      INNER-SHELL IONIZATION TAKES PLACE, 
*             VALUE OF INCREMENT IS MODEL DEPENDEND:
*                                   VALUE = 1. FOR HYB. AND DIR. MOD.
*                                   VALUE = PROBABILITY OF IONISATION
*                                           FOR SING. MOD.  
*              
*
**    ARGUMENTS                  
*
*        INIT   - INDICATES AN INITIALIZATION PASS
*        MODE   - =2: ONLY GRID INDEX OF NEAREST GRID POINT IS CALCULATED
*        NGRIDX - NUMBER OF GRIDLINES IN X-DIRECTION
*        NGRIDZ - NUMBER OF GRIDLINES IN Z-DIRECTION
*        XGRIDL - GRIDLINES X
*        ZGRIDL - GRIDLINES Z
*        XMIN   - MINIMUM X-COORDINATE OF THE SIMULATION AREA
*        XMAX   - MAXIMUM X-COORDINATE OF THE SIMULATION AREA
*        ZMIN   - MINIMUM Z-COORDINATE OF THE SIMULATION AREA
*        ZMAX   - MAXIMUM Z-COORDINATE OF THE SIMULATION AREA
*	 X	- X COORDINATE OF LOCATION OF IONIZATION
*	 Z	- Z COORDINATE OF LOCATION OF IONIZATION
*        ISHELL - SHELL (INDEX IN SHELL TABLES)
*        VALUE  - VALUE OF INCREMENT
*        VALION - ARRAY CONTAINING THE BOXES
*        NOUTAR - VALUE OF IONIZATIONS OUTSIDE THE SIMULATION AREA
*        NOUTGR - VALUE OF IONIZATIONS OUTSIDE THE GRID
*        IER    - ERROR INDICATOR: 0 ... EVERYTHING OK, 1 ... ERROR
*
**    AUTHOR:  A.PFEIFFER  1-FEB-1995  
*              BASED ON SORTIN.F (H.STIPPEL)
*

      LOGICAL   INIT
      DIMENSION XGRIDL(NDMAXGRID),ZGRIDL(NDMAZGRID),YGRIDL(NDMAYGRID)
      DOUBLE PRECISION VALION(NDMASHELL,NDMAXGRID,NDMAZGRID,NDMAYGRID)

**    START OF EXECUTABLE CODE
*     ************************

      IER = 0

      CALL CHKBND(2,NGRIDX,'IONVAL','XGRIDL')
      CALL CHKBND(3,NGRIDZ,'IONVAL','ZGRIDL')
      CALL CHKBND(4,NGRIDY,'IONVAL','YGRIDL')

      IF (INIT) THEN
*     INITIALIZE THE COUNTER ARRAY
         DO 15 IS =1,NSHELL 
            DO 10 IX = 1, NGRIDX
               DO 7 IZ = 1, NGRIDZ
                  DO 5 IY = 1, NGRIDY
                     VALION(IS,IX,IZ,IY) = 0.
 5                CONTINUE
 7             CONTINUE
 10         CONTINUE
 15      CONTINUE    
         NOUTGR = 0
         NOUTAR = 0
      ELSE
CS       FOR THE TIME BEING: SET NUMBER OF GRIDLINES IN Y-DIRECTION
CS       SHALL BE ONE (IY)
         IY=1
*	 CHECK, IF THE IONIZATION TOOK PLACE IN THE SIMULATION AREA
         IF (X.LT.XMIN .OR. X.GT.XMAX .OR.
     &	     Z.LT.ZMIN .OR. Z.GT.ZMAX) THEN
*	    IONIZATION TOOK PLACE OUTSIDE THE SIMULATION AREA
            NOUTAR = NOUTAR + 1
            IXGRD=0
            IZGRD=0
            RETURN
         ENDIF
*	 CHECK, IF THE IONIZATION LOCATION IS IN THE HISTOGRAM
         IF (X.LT.XGRIDL(1) .OR. X.GT.XGRIDL(NGRIDX) .OR.
     &	    Z.LT.ZGRIDL(1) .OR. Z.GT.ZGRIDL(NGRIDZ)) THEN
*	    IONIZATION LOCATION IS OUTSIDE THE HISTOGRAM
            NOUTGR = NOUTGR + 1
            IXGRD=0
            IZGRD=0
            RETURN
         ENDIF
*	 SEARCH THE APPROPRIATE GRID LINE IN X DIRECTION
         IX = 2
 30      CONTINUE
            IF (X.LE.XGRIDL(IX) .OR. IX.EQ.NGRIDX) GOTO 40
            IX = IX + 1
            GOTO 30
 40      CONTINUE
*	 SEARCH THE APPROPRIATE GRID LINE IN Z DIRECTION
         IZ = 2
 50      CONTINUE
            IF (Z.LE.ZGRIDL(IZ) .OR. IZ.EQ.NGRIDZ) GOTO 60
            IZ = IZ + 1
            GOTO 50
 60      CONTINUE
         IF (MODE.EQ.2) THEN
            IXGRL=IX
            IZGRL=IZ
            RETURN
         ENDIF

*	 INCREMENT THE COUNTER
         BOXAREA= (XGRIDL(IX)-XGRIDL(IX-1))*(ZGRIDL(IZ)-ZGRIDL(IZ-1))

         BOXPART= (X-XGRIDL(IX-1))*(Z-ZGRIDL(IZ-1))
         VALION(ISHELL,IX,IZ,IY)=VALION(ISHELL,IX,IZ,IY)
     &                            +VALUE*BOXPART/BOXAREA/BOXAREA

         BOXPART= (XGRIDL(IX)-X)*(Z-ZGRIDL(IZ-1))  
         VALION(ISHELL,IX-1,IZ,IY)=VALION(ISHELL,IX-1,IZ,IY)
     &                            +VALUE*BOXPART/BOXAREA/BOXAREA

         BOXPART= (X-XGRIDL(IX-1))*(ZGRIDL(IZ)-Z)  
         VALION(ISHELL,IX,IZ-1,IY)=VALION(ISHELL,IX,IZ-1,IY)
     &                            +VALUE*BOXPART/BOXAREA/BOXAREA

         BOXPART= (XGRIDL(IX)-X)*(ZGRIDL(IZ)-Z)  
         VALION(ISHELL,IX-1,IZ-1,IY)=VALION(ISHELL,IX-1,IZ-1,IY)
     &                            +VALUE*BOXPART/BOXAREA/BOXAREA
      ENDIF       

      RETURN
      END

**************************************************************************
*last modification 18-Oct-1996

      SUBROUTINE BRMVAL
     I                 ( INIT,MODE,MXXCONT,
     D			 NGRIDX,NGRIDZ,NGRIDY,
     D			 XGRIDL,ZGRIDL,YGRIDL,XMIN,XMAX,ZMIN,ZMAX,
     I                   X,Z,IXCIND,VALUE,
     O                   VALBRM,NOUTGR,NOUTAR,IXGRL,IZGRL,
     O                   IER)

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC' 

***   BRMVAL- INCREASES THE COUNTER OF THE GRIDPOINTS, WHERE THE SPECIFIED
*	      CONTINUUM X-RAY GENERATION TAKES PLACE, 
*             VALUE = PROBABILITY OF GENERATION OF A BREMSSTRHALUNG QUANTUM
*                     EMITTED INTO A CERTAIN DIRECTION (X-RAY DETECTOR)
*
**    ARGUMENTS                  
*
*        INIT   - INDICATES AN INITIALIZATION PASS
*        MODE   - =2: ONLY GRID INDEX OF NEAREST GRID POINT IS CALCULATED
*        MXXCONT- NUMBER OF DESCRETE BREMSSTRAHLUNG ENERGY VALUES
*        NGRIDX - NUMBER OF GRIDLINES IN X-DIRECTION
*        NGRIDZ - NUMBER OF GRIDLINES IN Z-DIRECTION
*        NGRIDY - NUMBER OF GRIDLINES IN Y-DIRECTION
*        XGRIDL - GRIDLINES X
*        ZGRIDL - GRIDLINES Z
*        YGRIDL - GRIDLINES Y
*        XMIN   - MINIMUM X-COORDINATE OF THE SIMULATION AREA
*        XMAX   - MAXIMUM X-COORDINATE OF THE SIMULATION AREA
*        ZMIN   - MINIMUM Z-COORDINATE OF THE SIMULATION AREA
*        ZMAX   - MAXIMUM Z-COORDINATE OF THE SIMULATION AREA
*	 X	- X COORDINATE OF LOCATION OF IONIZATION
*	 Z	- Z COORDINATE OF LOCATION OF IONIZATION
*        IXCIND - INDEX IN XCONT TABLES
*        VALUE  - VALUE OF INCREMENT
*        VALBRM - ARRAY CONTAINING THE BOXES
*        NOUTAR - VALUE OF IONIZATIONS OUTSIDE THE SIMULATION AREA
*        NOUTGR - VALUE OF IONIZATIONS OUTSIDE THE GRID
*        IER    - ERROR INDICATOR: 0 ... EVERYTHING OK, 1 ... ERROR
*
**    AUTHOR: CHRISTIAN SCHIEBL
*             CONSULTANT (FORMER: CEC-VIENNA)
*             KREMS, AUGUST 1996


      LOGICAL    INIT
      DIMENSION  XGRIDL(NGRIDX),ZGRIDL(NGRIDZ),YGRIDL(NGRIDY)
      DOUBLE PRECISION  VALBRM(MXXCONT,NGRIDX,NGRIDZ,NGRIDY)


**    START OF EXECUTABLE CODE
*     ************************

      IER = 0

      CALL CHKBND(2,NGRIDX,'BRMVAL','XGRIDL')
      CALL CHKBND(3,NGRIDZ,'BRMVAL','ZGRIDL')
      CALL CHKBND(4,NGRIDY,'BRMVAL','YGRIDL')

      IF (INIT) THEN
*     INITIALIZE THE COUNTER ARRAY
         DO 20 IXC=1,MXXCONT
            DO 15 IX=1,NGRIDX
               DO 10 IZ=1,NGRIDZ
                  DO 5 IY=1,NGRIDY
                     VALBRM(IXC,IX,IZ,IY)=0.
 5                CONTINUE
 10            CONTINUE
 15         CONTINUE
 20      CONTINUE
         NOUTGR = 0
         NOUTAR = 0
      ELSE
CS       FOR THE TIME BEING: SET IY TO 1 (ONLY ONE GRID LINE IN Y-DIRECTION)
         IY=1
*	 CHECK, IF THE IONIZATION TOOK PLACE IN THE SIMULATION AREA
         IF (X.LT.XMIN .OR. X.GT.XMAX .OR.
     &	     Z.LT.ZMIN .OR. Z.GT.ZMAX) THEN
*	    IONIZATION TOOK PLACE OUTSIDE THE SIMULATION AREA
            NOUTAR = NOUTAR + 1
            IXGRD=0
            IZGRD=0
*           RETURN
            GOTO 999
         ENDIF
*	 CHECK, IF THE IONIZATION LOCATION IS IN THE HISTOGRAM
         IF (X.LT.XGRIDL(1) .OR. X.GT.XGRIDL(NGRIDX) .OR.
     &	    Z.LT.ZGRIDL(1) .OR. Z.GT.ZGRIDL(NGRIDZ)) THEN
*	    IONIZATION LOCATION IS OUTSIDE THE HISTOGRAM
            NOUTGR = NOUTGR + 1
            IXGRD=0
            IZGRD=0
*           RETURN
            GOTO 999
         ENDIF
*	 SEARCH THE APPROPRIATE GRID LINE IN X DIRECTION
         IX = 2
 30      CONTINUE
            IF (X.LE.XGRIDL(IX) .OR. IX.EQ.NGRIDX) GOTO 40
            IX = IX + 1
            GOTO 30
 40      CONTINUE
*	 SEARCH THE APPROPRIATE GRID LINE IN Z DIRECTION
         IZ = 2
 50      CONTINUE
            IF (Z.LE.ZGRIDL(IZ) .OR. IZ.EQ.NGRIDZ) GOTO 60
            IZ = IZ + 1
            GOTO 50
 60      CONTINUE
         IXGRL=IX
         IZGRL=IZ
         IF (MODE.EQ.2) THEN
*           RETURN
            GOTO 999
         ENDIF

*	 INCREMENT THE COUNTER
         BOXAREA= (XGRIDL(IX)-XGRIDL(IX-1))*(ZGRIDL(IZ)-ZGRIDL(IZ-1))
C INCREMENT OF X,Z SURROUNDING GRIDPOINTS, 

         BOXAREA= (XGRIDL(IX)-XGRIDL(IX-1))*(ZGRIDL(IZ)-ZGRIDL(IZ-1))
         BOXPART= (X-XGRIDL(IX-1))*(Z-ZGRIDL(IZ-1))
         VALBRM(IXCIND,IX,IZ,IY)=VALBRM(IXCIND,IX,IZ,IY)
     &                            +VALUE*(BOXPART/BOXAREA)

         BOXPART= (XGRIDL(IX)-X)*(Z-ZGRIDL(IZ-1))  
         VALBRM(IXCIND,IX-1,IZ,IY)=VALBRM(IXCIND,IX-1,IZ,IY)
     &                            +VALUE*(BOXPART/BOXAREA)

         BOXPART= (X-XGRIDL(IX-1))*(ZGRIDL(IZ)-Z)  
         VALBRM(IXCIND,IX,IZ-1,IY)=VALBRM(IXCIND,IX,IZ-1,IY)
     &                            +VALUE*(BOXPART/BOXAREA)

         BOXPART= (XGRIDL(IX)-X)*(ZGRIDL(IZ)-Z)  
         VALBRM(IXCIND,IX-1,IZ-1,IY)=VALBRM(IXCIND,IX-1,IZ-1,IY)
     &                            +VALUE*(BOXPART/BOXAREA)
      ENDIF       

 999  RETURN
      END

**************************************************************************

      DOUBLE PRECISION FUNCTION QCHAR1(ZATOM,ENE,E_EDG,I_SHELL)
      
      INCLUDE 'TYPE.INC'   
      INCLUDE 'PARAM.INC' 
      INCLUDE 'GLOBAL.INC'
 
***   Q() - IONIZATION CROSS SECTION (POUCHOU) [Ang**2]
*
**    ARGUMENTS
*
*     ZATOM   - ATOMIC NUMBER
*     ENE     - ELECTRON ENERGY [eV]
*     E_EDG   - EDGE ENERGY [eV]
*     I_SHELL - IONIZED SHELL
*
*     AUTHOR: A.PFEIFFER  SEP-1994
*             C.SCHIEBL   JUN-1995
*
**    START OF EXECUTABLE CODE
*     ************************

*     TRANSFORM ENERGIES TO keV
      ENER=ENE/1000
      E_EDGE=E_EDG/1000

      U = ENER/E_EDGE
      IF (U.LE.1)THEN
          QCHAR1=0
          GOTO 100
      ENDIF
      IF (ENER.GT.50) THEN
         QCHAR1=1.4847045*QCHAR4(ZATOM,ENER,E_EDGE,I_SHELL)
         RETURN
      ENDIF
      NELEC=E_SHELL(I_SHELL)
      EE2=E_EDGE*E_EDGE
      IF (I_SHELL.LE.1) THEN
          FM1=0.86+0.12*DEXP(-ZATOM*ZATOM/25)
          QCHAR1=DLOG(U)/EE2/U**FM1+0.1*DLOG(U)/EE2/U**5+
     &           1.5*DLOG(U)/EE2/U**30
          QCHAR1=QCHAR1*3.80559456D-4*NELEC*FM1
      ELSE IF (I_SHELL.LE.4) THEN
          QCHAR1=2.674789319D-4*NELEC*DLOG(U)/(EE2*U**0.82)
      ELSE
          QCHAR1=2.674789319D-4*NELEC*DLOG(U)/(EE2*U**0.78)
      ENDIF

 100  CONTINUE
      RETURN
      END

**********************************************************************

      DOUBLE PRECISION FUNCTION QCHAR2(ZATOM,ENER,E_EDGE,I_SHELL)
      
      INCLUDE 'TYPE.INC'   
      INCLUDE 'PARAM.INC' 
      INCLUDE 'GLOBAL.INC'
 
***   Q() - IONIZATION CROSS SECTION (GRYZINSKI) [Ang**2]
*
**    ARGUMENTS
*
*     ZATOM   - ATOMIC NUMBER
*     ENER    - ELECTRON ENERGY [eV]
*     E_EDGE  - EDGE ENERGY     [eV]
*     I_SHELL - IONIZED SHELL
*
*     AUTHOR: C.SCHIEBL   JUN-1995
*
**    START OF EXECUTABLE CODE
*     ************************

      U = ENER/E_EDGE
      IF (U.LE.1)THEN
          Q=0.
          GOTO 100
      ENDIF
      IF (ENER.GT.50000) THEN
         QCHAR2=QCHAR4(ZATOM,ENER/1000,E_EDGE/1000,I_SHELL)*1.13008
         RETURN
      ENDIF
      NELEC=E_SHELL(I_SHELL)
      EE2=E_EDGE*E_EDGE
      E4=207.36D0     
      Q2=E4*PI*1.D0/U*((U-1.D0)/(U+1.D0) )**1.5D0*
     &   (1.D0+2.D0/3.D0*(1.-0.5D0/U)*
     &   DLOG(2.7D0+(U-1.D0)**.5D0))
      QCHAR2=Q2*NELEC/EE2

 100  CONTINUE
      RETURN
      END

**********************************************************************

      DOUBLE PRECISION FUNCTION QCHAR3(ZATOM,ENER,E_EDGE,I_SHELL)
      
      INCLUDE 'TYPE.INC'   
      INCLUDE 'PARAM.INC' 
      INCLUDE 'GLOBAL.INC'
 
***   Q() - IONIZATION CROSS SECTION (BETHE) [Ang**2]
*
**    ARGUMENTS
*
*     ZATOM   - ATOMIC NUMBER
*     ENER    - ELECTRON ENERGY [keV]
*     E_EDGE  - EDGE ENERGY [keV]
*     I_SHELL - IONIZED SHELL
*
*     AUTHOR: C.SCHIEBL   JAN-1996
*
*     E**4 TIMES PI (IN KEV*Ų)
      PARAMETER (E4PI=6.5098834D-4)
*
**    START OF EXECUTABLE CODE
*     ************************

      U=ENER/E_EDGE
      IF (U.LE.1) THEN
         QCHAR3=0
         RETURN
      ENDIF
      IF (I_SHELL.LE.1) THEN
         BS=0.52+0.0029*ZATOM
      ELSE IF (I_SHELL.LE.4) THEN
         BS=0.44+0.002*ZATOM
      ELSE
         BS=1
      ENDIF
      NELEC=E_SHELL(I_SHELL)

      QCHAR3=E4PI*NELEC*BS*DLOG(U)/ENER/E_EDGE

      RETURN
      END


**********************************************************************

      DOUBLE PRECISION FUNCTION QCHAR4(ZATOM,ENER,E_EDGE,I_SHELL)
      
      INCLUDE 'TYPE.INC'   
      INCLUDE 'PARAM.INC' 
      INCLUDE 'GLOBAL.INC'
 
***   Q() - IONIZATION CROSS SECTION (BETHE-RELATIVISTIC) [Ang**2]
*
**    ARGUMENTS
*
*     ZATOM   - ATOMIC NUMBER
*     ENER    - ELECTRON ENERGY [keV]
*     E_EDGE  - EDGE ENERGY [keV]
*     I_SHELL - IONIZED SHELL
*
*     AUTHOR: C.SCHIEBL   JAN-1996
*
*     E**4 TIMES PI (IN KEV*Ų)
      PARAMETER (E4PI=6.5098834D-4)
*
**    START OF EXECUTABLE CODE
*     ************************

      BETA=1-(2*ENER*ENER+1533*ENER)/(2*(511+ENER)**2)
      U=BETA*ENER/E_EDGE
      IF (U.LE.1) THEN
         QCHAR4=0
         RETURN
      ENDIF
      ALPH=511/(511+ENER)
      ALPH=ALPH*ALPH
      IF (I_SHELL.LE.1) THEN
         BS=0.52+0.0029*ZATOM
      ELSE IF (I_SHELL.LE.4) THEN
         BS=0.44+0.002*ZATOM
      ELSE
         BS=1
      ENDIF
      NELEC=E_SHELL(I_SHELL)

      QCHAR4=E4PI*NELEC*BS/BETA/ENER/E_EDGE
      QCHAR4=QCHAR4*(DLOG(U)+DLOG(ALPH)-1+ALPH)

      RETURN
      END

**********************************************************************

      DOUBLE PRECISION FUNCTION QCHAR5(ZATOM,ENER,E_EDGE,I_SHELL)
      
      INCLUDE 'TYPE.INC'   
      INCLUDE 'PARAM.INC' 
      INCLUDE 'GLOBAL.INC'
 
***   Q() - IONIZATION CROSS SECTION (GRYZINSKI-RELATIVISTIC) [Ang**2]
*
**    ARGUMENTS
*
*     ZATOM   - ATOMIC NUMBER
*     ENER    - ELECTRON ENERGY [keV]
*     E_EDGE  - EDGE ENERGY [keV]
*     I_SHELL - IONIZED SHELL
*
*     AUTHOR: C.SCHIEBL   JAN-1996
*
*     E**4 TIMES PI (IN KEV*)
      PARAMETER (E4PI=6.5098834D-4)
*
**    START OF EXECUTABLE CODE
*     ************************

      BETA=1-(2*ENER*ENER+1533*ENER)/(2*(511+ENER)**2)
      U=BETA*ENER/E_EDGE
CS      U=ENER/E_EDGE
      IF (U.LE.1) THEN
         QCHAR5=0
         RETURN
      ENDIF
      ALPH=511/(511+ENER)
      ALPH=ALPH*ALPH
      IF (I_SHELL.LE.1) THEN
         BS=0.52+0.0029*ZATOM
      ELSE IF (I_SHELL.LE.4) THEN
         BS=0.44+0.002*ZATOM
      ELSE
         BS=1
      ENDIF
      NELEC=E_SHELL(I_SHELL)

      QCHAR5=E4PI*NELEC*BS/BETA/ENER/E_EDGE
      QCHAR5=QCHAR5*(((U-1)/(U+1))**0.6666667/BS*(1+0.6666667
     1       *(1-1/U/2)*DLOG(2.7+DSQRT(U-1)))+DLOG(ALPH)-1+ALPH)

      RETURN
      END

*****************************************************************************

      DOUBLE PRECISION FUNCTION QCHAR6(ZATOM,ENER,E_EDGE,I_SHELL)
      
      INCLUDE 'TYPE.INC'   
      INCLUDE 'PARAM.INC' 
      INCLUDE 'GLOBAL.INC'
 
***   Q() - IONIZATION CROSS SECTION (BETHE SEMI-RELATIVISTIC) [Ang**2]
*
**    ARGUMENTS
*
*     ZATOM   - ATOMIC NUMBER
*     ENER    - ELECTRON ENERGY [keV]
*     E_EDGE  - EDGE ENERGY [keV]
*     I_SHELL - IONIZED SHELL
*
*     AUTHOR: C.SCHIEBL   JAN-1996
*
*     E**4 TIMES PI (IN KEV*Ų)
      PARAMETER (E4PI=6.5098834D-4)
*
**    START OF EXECUTABLE CODE
*     ************************

      BETA=1-(2*ENER*ENER+1533*ENER)/(2*(511+ENER)**2)
      U=ENER/E_EDGE
      IF (U.LE.1) THEN
         QCHAR6=0
         RETURN
      ENDIF
      IF (I_SHELL.LE.1) THEN
         BS=0.52+0.0029*ZATOM
      ELSE IF (I_SHELL.LE.4) THEN
         BS=0.44+0.002*ZATOM
      ELSE
         BS=1
      ENDIF
      NELEC=E_SHELL(I_SHELL)

      QCHAR6=E4PI*NELEC*BS*DLOG(BETA*U)/BETA/ENER/E_EDGE

      RETURN
      END

**********************************************************************

      DOUBLE PRECISION FUNCTION QCHAR7(ZATOM,ENER,E_EDGE,I_SHELL)
      
      INCLUDE 'TYPE.INC'   
      INCLUDE 'PARAM.INC' 
      INCLUDE 'GLOBAL.INC'
 
***   Q() - IONIZATION CROSS SECTION (POUCHOU SEMI-RELATIVISTIC) [Ang**2]
*
**    ARGUMENTS
*
*     ZATOM   - ATOMIC NUMBER
*     ENER    - ELECTRON ENERGY [keV]
*     E_EDGE  - EDGE ENERGY [keV]
*     I_SHELL - IONIZED SHELL
*
*     AUTHOR: C.SCHIEBL   JAN-1996
*
**    START OF EXECUTABLE CODE
*     ************************

      BETA=1-(2*ENER*ENER+1533*ENER)/(2*(511+ENER)**2)
      U=BETA*ENER/E_EDGE
      IF (U.LE.1)THEN
          QCHAR7=0.
          GOTO 100
      ENDIF
      NELEC=E_SHELL(I_SHELL)
      EE2=E_EDGE*E_EDGE
      IF (I_SHELL.LE.1) THEN
          FM1=0.86+0.12*DEXP(-ZATOM*ZATOM/25)
          QCHAR7=DLOG(U)/EE2/U**FM1+0.1*DLOG(U)/EE2/U**5+
     &          1.5*DLOG(U)/EE2/U**30
          QCHAR7=QCHAR7*3.80559456D-4*NELEC*FM1
      ELSE IF (I_SHELL.LE.4) THEN
          QCHAR7=2.674789319D-4*NELEC*DLOG(U)/(EE2*U**0.82)
      ELSE
          QCHAR7=2.674789319D-4*NELEC*DLOG(U)/(EE2*U**0.78)
      ENDIF

 100  CONTINUE
      RETURN
      END

**********************************************************************

      DOUBLE PRECISION FUNCTION QCHAR8(ZATOM,ENER,E_EDGE,I_SHELL)
      
      INCLUDE 'TYPE.INC'   
      INCLUDE 'PARAM.INC' 
      INCLUDE 'GLOBAL.INC'
 
***   Q() - IONIZATION CROSS SECTION (POUCHOU SEMI-RELATIVISTIC) [Ang**2]
*
**    ARGUMENTS
*
*     ZATOM   - ATOMIC NUMBER
*     ENER    - ELECTRON ENERGY [keV]
*     E_EDGE  - EDGE ENERGY [keV]
*     I_SHELL - IONIZED SHELL
*
*     AUTHOR: C.SCHIEBL   JAN-1996
*
**    START OF EXECUTABLE CODE
*     ************************

      BETA=1-(2*ENER*ENER+1533*ENER)/(2*(511+ENER)**2)
      U=BETA*ENER/E_EDGE
      IF (U.LE.1)THEN
          QCHAR8=0.
          GOTO 100
      ENDIF
      NELEC=E_SHELL(I_SHELL)
      EE2=E_EDGE*E_EDGE
      ALPH=511/(511+ENER)
      ALPH=ALPH*ALPH
      FLN=DLOG(U)+DLOG(ALPH)-1+ALPH
      IF (I_SHELL.LE.1) THEN
          FM1=0.86+0.12*DEXP(-ZATOM*ZATOM/25)
          QCHAR8=FLN/EE2/U**FM1+0.1*FLN/EE2/U**5+
     &          1.5*FLN/EE2/U**30
          QCHAR8=QCHAR8*3.80559456D-4*NELEC*FM1
      ELSE IF (I_SHELL.LE.4) THEN
          QCHAR8=2.674789319D-4*NELEC*FLN/(EE2*U**0.82)
      ELSE
          QCHAR8=2.674789319D-4*NELEC*FLN/(EE2*U**0.78)
      ENDIF

 100  CONTINUE
      RETURN
      END

**************************************************************************

      DOUBLE PRECISION FUNCTION QCHAR9(ZATOM,ENE,E_EDG,I_SHELL)
      
      INCLUDE 'TYPE.INC'   
      INCLUDE 'PARAM.INC' 
      INCLUDE 'GLOBAL.INC'
 
***   Q() - IONIZATION CROSS SECTION (Casnati) [Ang**2]
*
**    ARGUMENTS
*
*     ZATOM   - ATOMIC NUMBER
*     ENE     - ELECTRON ENERGY [eV]
*     E_EDG   - EDGE ENERGY [eV]
*     I_SHELL - IONIZED SHELL
*
*     AUTHOR: Christian Schiebl
*             Consultant (former CEC-Vienna)
*             Krems/Hudson, April 1997
*
**    START OF EXECUTABLE CODE
*     ************************

*     TRANSFORM ENERGIES TO keV
CS      ENER=ENE/1000
CS      E_EDGE=E_EDG/1000
      ENER=ENE
      E_EDGE=E_EDG

      U = ENER/E_EDGE
      IF (U.LE.1)THEN
          QCHAR9=0
          GOTO 100
      ENDIF
      NELEC=E_SHELL(I_SHELL)
      EE2=E_EDGE*E_EDGE
      DI=E_EDGE/511000
      DT=ENER/511000
      DC=((2+DI)/(2+DT))*(((1+DT)/(1+DI))**2)*
     &   ((((DI+DT)*(2+DT)*((1+DI)**2))/(DT*(2+DT)*((1+DI)**2)+
     &   DI*(2+DI)))**1.5)
      DD=-0.0318+0.316/U-0.1135/U/U
      DPHI=10.57*DEXP((-1.736/U)+(0.317/U/U))
      PHI=(E_EDGE/13.606)**DD
CS      A02=52.9*52.9
CS      R2=13.606*13.606
CS      IF (I_SHELL.LE.1) THEN
CS         QCHAR9=NELEC*A02*DC*R2*PHI*DPHI*DLOG(U)/EE2/U
         QCHAR9=51.805071*NELEC*DC*PHI*DPHI*DLOG(U)/EE2/U
CS      ELSE IF (I_SHELL.LE.4) THEN
CS         QCHAR9=NELEC*A02*DC*R2*PHI*DPHI*DLOG(U)/EE2/U
CS      ELSE
CS         QCHAR9=NELEC*A02*DC*R2*PHI*DPHI*DLOG(U)/EE2/U
CS      ENDIF

CS      QCHAR9=QCHAR9*1.0E-4

 100  CONTINUE
      RETURN
      END

**************************************************************************

      SUBROUTINE QBREMS(ZATOM,ENE,EC,QX,QYZ)
      
      INCLUDE 'TYPE.INC'   
 
***   Q() - IONIZATION CROSS SECTION (KIRKPATRICK & WIEDMANN) [Ang**2/eV]
*           MODIFICATIONS BY STATHAM
*
**    ARGUMENTS
*
*     ZATOM   - MEAN ATOMIC NUMBER
*     ENE     - ELECTRON ENERGY [eV]
*     EC      - CONTINUUM X-RAY ENERGY [eV]
*     QX      - CROSS SECTION IN X-DIRECTION
*     QYZ     - CROSS SECTION IN Y- (Z-) DIRECTION
*
*     AUTHOR: CHRISTIAN SCHIEBL
*             CONSULTANT (FORMER: CEC-VIENNA)
*             KREMS, SEPTEMBER 1996
*
**    START OF EXECUTABLE CODE
*     ************************

      IF (ENE.LT.EC) THEN
         QX=0
         QYZ=0
         RETURN
      ENDIF

      VZ=ENE/ZATOM/ZATOM/299.8
      RF=EC/ENE

      IF (VZ.LE.0.0604) THEN

         FY=1-(4.83*VZ-0.55)*DEXP(-20*RF)

         X1=(-1.01904+0.146014*RF-0.0501077*RF*RF)*DLOG(VZ)-1.48311+
     &      0.947484*RF-0.350014*RF*RF
         Y1=(-0.882129+0.0366934*RF-0.339646*RF*RF)*DLOG(VZ)-1.04088-
     &      1.86355*RF-0.723068*RF*RF
         QX=DEXP(X1)
         QYZ=DEXP(Y1)

      ELSE

         FY=1

         AA=DEXP(-0.223*VZ)-DEXP(-57*VZ)
         BB=DEXP(-0.0828*VZ)-DEXP(-84.9*VZ)
         A=1.47*BB-0.507*AA-0.833
         B=1.70*BB-1.09*AA-0.627
         X1=RF-0.135
         QX=0.252+A*X1-B*X1*X1
         QX=QX/VZ

         Y1=0.22*(1-0.39*DEXP(-26.9*VZ))
         Y2=0.067+0.023/(VZ+0.75)
         Y3=-0.00259+0.00776/(VZ+0.116)
         FH=(-0.214*Y1+1.21*Y2-Y3)/(1.43*Y1-2.43*Y2+Y3)
         FJ=(1+2*FH)*Y2-2*(1+FH)*Y3
         FK=(1+FH)*(Y3+FJ)
         QYZ=-FJ+FK/(RF+FH)
         QYZ=QYZ/VZ

      ENDIF

      IF (RF.GE.0.2) THEN

         QX=QX*1.501D-8
         QYZ=QYZ*1.501D-8

      ELSE

         QX=QX*(1-0.567*DEXP(-20*RF))*1.501D-8
         QYZ=QYZ*FY*1.501D-8

      ENDIF

      QX=QX/EC
      QYZ=QYZ/EC

      RETURN
      END

**********************************************************************
*last modification: 09-Dec-1996

       SUBROUTINE IONSAVE (
     D                     MODE,JCOUNT,ILAST,
     D                     ISHTAB,IXCTAB,
     D                     NGRIDX,NGRIDZ,NGRIDY,
     I			   XGRIDL,ZGRIDL,YGRIDL,
     I			   ISHL,VALION,
     I                     WGTGRD,XCABS,XW1,XW2,
     I			   CUSTXT,CFILE,IXDET)

*     MODE   - 1: IONIZATION DISTRIBUTION
*              2: GENERATED X-RAY DISTRIBUTION
*              3: DETECTED X-RAY DISTRIBUTION
*     JCOUNT - COUNTER FOR OUTPUT ADDED UP IN ONE FILE
*     ILAST  - IF SET TO 1 THEN ACTUALLY WRITE TO FILE
*     ISHTAB - INDEX IN SHELL TABLE
*     IXCTAB - INDEX IN XCHAR TABLE
*     NGRIDX - NUMBER OF GRID LINES IN X-DIRECTION
*     NGRIDX - NUMBER OF GRID LINES IN Z-DIRECTION
*     XGRIDL - X COORDINATES OF GRID LINES
*     ZGRIDL - Z COORDINATES OF GRID LINES
*     ISHL   - SHELL INDEX IN VALION

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'GLOBAL.INC'
      INCLUDE 'FILE.INC'
      INCLUDE 'DMA.INC'

      INTEGER*4 NDMY1,NDMY2

      DOUBLE PRECISION XGRIDL(NDMAXGRID),ZGRIDL(NDMAZGRID)
      DOUBLE PRECISION YGRIDL(NDMAYGRID)
      DOUBLE PRECISION WGTGRD(NDMAXGRID,NDMAZGRID,NDMAYGRID)
      DOUBLE PRECISION VALION(NDMASHELL,NDMAXGRID,NDMAZGRID,NDMAYGRID)
      DOUBLE PRECISION XCABS(0:NDMAXDET-1,NDMAXCONT+NDMAXCHAR-NDMAPTOB,
     &                 NDMAXGRID,NDMAZGRID,NDMAYGRID)
      DOUBLE PRECISION VHELP(1)
      POINTER (P2VHELP,VHELP)
      SAVE P2VHELP

      CHARACTER*64 CDUMMY
      CHARACTER*70 CUSTXT
      CHARACTER*64 CFILE
      CHARACTER*2  CHELP,CHELP2
      CHARACTER*70 CTITLE
      CHARACTER*10 CBL
      DATA CBL /'          '/

      CALL CHKBND(2,NGRIDX,'IONSAVE   ','XGRIDL')
      CALL CHKBND(3,NGRIDZ,'IONSAVE   ','ZGRIDL')
      CALL CHKBND(4,NGRIDY,'IONSAVE   ','YGRIDL')
      CALL CHKBND(6,IXCTAB,'IONSAVE   ','FYIELDOFXCHAR')

*     RESET VHELP VALUE IF FIRST ENTRY FOR A SPECIFIC PM FILE
      IF (JCOUNT.EQ.1) THEN
*        ALLOCATE MEMORY FOR VHELP
         N=NGRIDX*NGRIDZ*NGRIDY
         P2VHELP=MALLOC(SIZEOF(VHELP(1))*N)
         IF (P2VHELP.EQ.0) THEN
            WRITE(6,'(A)')'     '
            WRITE(6,'(A)')' *** ERROR ***'
            WRITE(6,'(2A)')' IONVAL: Could not allocate memory',
     &                     ' for VHELP !'
            STOP
         ENDIF
         MXINDX=NDMAXGRID*NDMAZGRID*(NGRIDY-1)+
     &          NDMAXGRID*(NGRIDZ-1)+NGRIDX
         CALL CHKBND(10,MXINDX,'IONSAVE','VHELP')
         DO 10 I=1,NGRIDX
            DO 7 J=1,NGRIDZ
               DO 5 K=1,NGRIDY
                  INDX=NDMAXGRID*NDMAZGRID*(K-1)+NDMAXGRID*(J-1)+I
                  VHELP(INDX)=0
 5             CONTINUE
 7          CONTINUE
 10      CONTINUE
      ENDIF

      IF (MODE.EQ.1) FMULT=1
      IF ((MODE.EQ.2).OR.(MODE.EQ.3)) FMULT=FYIELDOFXCHAR(IXCTAB)

      DO 20 I=1,NGRIDX
         DO 18 J=1,NGRIDZ
            DO 15 K=1,NGRIDY
               FFACT=1
               IF (MODE.EQ.3) FFACT=XCABS(IXDET,IXCTAB,I,J,K)
               INDX=NDMAXGRID*NDMAZGRID*(K-1)+NDMAXGRID*(J-1)+I
               VHELP(INDX)=VHELP(INDX)+VALION(ISHL,I,J,K)*FMULT*FFACT
     &                    /WGTGRD(I,J,K)
 15         CONTINUE
 18      CONTINUE
 20   CONTINUE

*     WRITE TO FILE IF LAST ENTRY FOR A SPECIFIC PM FILE
      IF (ILAST.EQ.1) THEN
*        SET THE MAX. VALUE
         VALLO=VBNDUP
         VALUP=VBNDLO
         IF (MODE.EQ.1) THEN
*           IONIZATIONS
            CTITLE = 'SESAME - SIMULATION OF INNER-SHELL '
     +               //'IONIZATIONS '//'   '//CBL//CBL
         ELSE IF (MODE.EQ.2) THEN
*           GENERATED CHAR. X-RAYS
            CTITLE = 'SESAME - SIMULATION OF GENERATED CHAR. '
     +               //'X-RAYS  '//'   '//CBL//CBL
         ELSE IF (MODE.EQ.3) THEN
*           DETECTED CHAR. X-RAYS
            CTITLE = 'SESAME - SIMULATION OF DETECTED CHAR. X'
     +               //'-RAYS   '//'   '//CBL//CBL
         ENDIF
         DO 60 I=1,NGRIDX
            DO 55 J=1,NGRIDZ
               DO 50 K=1,NGRIDY
                  INDX=NDMAXGRID*NDMAZGRID*(K-1)+NDMAXGRID*(J-1)+I
                  IF (VHELP(INDX).GT.VALUP) VALUP = VHELP(INDX)
                  IF (VHELP(INDX).LT.VALLO) VALLO = VHELP(INDX)
 50            CONTINUE
 55         CONTINUE
 60      CONTINUE

*        WRITE THE CONCENTRATION TO A FILE
         OPEN (NSAVE,FILE=CFILE,STATUS='UNKNOWN',FORM='UNFORMATTED')
      
*        WRITE THE CONCENTRATION TO THE OUTPUT FILE
         NDMY1=NGRIDX
         NDMY2=NGRIDZ
         WRITE (NSAVE) CTITLE
         WRITE (NSAVE) CUSTXT
         WRITE (NSAVE) 1, NDMY2, NDMY1
         WRITE (NSAVE) 0
         WRITE (NSAVE) .FALSE.
         WRITE (NSAVE) 1
         WRITE (NSAVE) VALLO
         WRITE (NSAVE) VALUP
         WRITE (NSAVE) (ZGRIDL(IZ), IZ=1,NGRIDZ)
         WRITE (NSAVE) (XGRIDL(IX), IX=1,NGRIDX)
         IY=1
         DO 90 IZ=1, NGRIDZ
            INDX=NDMAXGRID*NDMAZGRID*(IY-1)+NDMAXGRID*(IZ-1)
            WRITE (NSAVE) (VHELP(INDX+IX),IX=1,NGRIDX)
 90      CONTINUE
         CLOSE (NSAVE)
*        FREE ALLOCATED MEMORY FOR VHELP
         CALL FREE(P2VHELP)
      ENDIF

      RETURN
      END
