c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
      SUBROUTINE INTERP_LAM_ION (
     I                           IREG,ENER,
     O                           LAMBDA_IO_TOT)

***   SUBROUTINE INTERP_LAM_ION INTERPOLATES MEAN FREE PATH 
*     FOR INNER SHELL IONIZATION
*
**    INPUT:
*     IREG.....NUMBER OF REGION
*     ENER.....ENERGY OF ELECTRON
*
**    OUTPUT:
*     LAMBDA_IO_TOT...INTERPOLATED TOTAL MEAN FREE PATH FOR
*                     INNER SHELL IONIZATION

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'GLOBAL.INC'      
      
      DOUBLE PRECISION LAMBDA_IO_TOT

**    START OF EXECUTABLE CODE:
*     *************************

      ESTEP_IO = (EMAX-EMIN)/FLOAT(MAXENER-1)

      IF (ENER.LT.EMIN) THEN

*     SOLLTE IM HAUPTPROGRAMM UEBERPRUEFT WERDEN
               WRITE(*,'(A)')' ENERGY TOO LOW'
               LAMBDA_IO_TOT = 0.D0
         ELSE IF(ENER.GT.EMAX) THEN
*     SOLLTE IM HAUPTPROGRAMM UEBERPRUEFT WERDEN
               WRITE(*,'(A)')' ENERGY TOO HIGH'               
               LAMBDA_IO_TOT = 0.D0
         ELSE

           I_ENER = INT( (ENER-EMIN)/ESTEP_IO)+1

           IF (I_ENER.EQ.MAXENER) THEN
               LAMBDA_IO_TOT=LAMBDA_IO(IREG,I_ENER)
             ELSE
               LAMBDA_IO_TOT=LAMBDA_IO(IREG,I_ENER)+
     &             ( ENER-(( I_ENER-1)*ESTEP_IO+EMIN) )/ESTEP_IO*
     &             ( LAMBDA_IO(IREG,I_ENER+1)-LAMBDA_IO(IREG,I_ENER) )
           ENDIF

      ENDIF

      RETURN
      END
