c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
*last modification: 20-Feb-1997

      SUBROUTINE LOADBK (IELTR,
     1                   VALION,VALBREMS,XCABS)

***   LOADBK - READS THE BACKUP FILE
*
**    ARGUMENTS
*
*     IELTR  - LAST SIMULATED ELECTRON
*
**    AUTHOR:  CHRISTIAN SCHIEBL  OCT. 1995
*
      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'GLOBAL.INC'
      INCLUDE 'HIST.INC'
      INCLUDE 'OUTPUT.INC'
      INCLUDE 'FILE.INC'
      INCLUDE 'DMA.INC'

*     HISTOGRAM FOR IONISATIONS
      DOUBLE PRECISION VALION(NDMASHELL,
     &                        NDMAXGRID,NDMAZGRID,NDMAYGRID)
*     BREMSSTRAHLUNG (CONTINUUM X-RAY) ARRAY
      DOUBLE PRECISION VALBREMS(NDMAXCONT,NDMAXGRID,NDMAZGRID,
     &                          NDMAYGRID,0:NDMAXDET-1)
*     ABSORPTION FACTORS (FOR CHARACTERISTIC AND BACKGROUND RADIATION)
      DOUBLE PRECISION XCABS(0:NDMAXDET-1,NDMAXCONT+NDMAXCHAR-NDMAPTOB,
     &                       NDMAXGRID,NDMAZGRID,NDMAYGRID)

      CHARACTER*80 BUFFER


**    START OF EXECUTABLE CODE
*     ************************

*     ---OPEN BACKUP FILE
      OPEN (NBCKUP,FILE=BCKLD(1:IEND(BCKLD)),FORM='UNFORMATTED',
     &      STATUS='OLD',IOSTAT=IOS)
      IF (IOS.NE.0) THEN
         WRITE(6,'(A)')'      '
         WRITE(6,'(A)')' %%% ERROR %%%'
         WRITE(6,'(A)')' ERROR DURING OPENING BACKUP FILE'
         WRITE(6,'(A)')' CANNOT READ  SPECIFIED BACKUP FILE'
         WRITE(6,'(2A)')' BACKUP FILENAME: ',BCKLD(1:IEND(BCKLD))
         WRITE(6,'(A)')' SESAME - protests are useless ;-)'
         RETURN
      ENDIF

*     ---READ INDEX OF LAST SIMULATED ION
      READ (NBCKUP)BUFFER
      READ (BUFFER,*) IELTR

*     ---REED AND SET THE SEED OF THE RANDOM NUMBER GENERATOR
      READ (NBCKUP)BUFFER
      READ (BUFFER,*) M,IA,IB,IRAND
      CALL RANSET(M,IA,IB,IRAND)

*     ---READ LOCATION DEPENDENT HISTOGRAM INFORMATION (LDH)
 10   READ (NBCKUP) BUFFER
      IF ((BUFFER(2:16).NE.'#START_LDH_INFO').AND.
     &    (BUFFER(1:15).NE.'#START_LDH_INFO')) GOTO 10
      READ (NBCKUP)NGRIDX,NGRIDZ,NGRIDY
      READ (NBCKUP)NSHE,NXCH,NXCO,NXPB
      CALL CHKBND(2,NGRIDX,'LOADBK','XGRIDL')
      CALL CHKBND(3,NGRIDZ,'LOADBK','ZGRIDL')
      CALL CHKBND(4,NGRIDY,'LOADBK','YGRIDL')
      DO 110 I=1,NGRIDX
         READ (NBCKUP)XGRIDL(I)
 110  CONTINUE
      DO 113 I=1,NGRIDZ
         READ (NBCKUP)ZGRIDL(I)
 113  CONTINUE
      DO 115 I=1,NGRIDY
         READ (NBCKUP)YGRIDL(I)
 115  CONTINUE
      MXINDX=NDMAXGRID*NDMAZGRID*(NGRIDY-1)+
     &       NDMAXGRID*(NGRIDZ-1)+NGRIDX
      CALL CHKBND(10,MXINDX,'LOADBK','WGTGRD')
      DO 125 I=1,NGRIDX
         DO 120 J=1,NGRIDZ
            DO 117 K=1,NGRIDY
               INDX=NDMAXGRID*NDMAZGRID*(K-1)+NDMAXGRID*(J-1)+I
               READ (NBCKUP)WGTGRD(INDX)
 117        CONTINUE
 120     CONTINUE
 125  CONTINUE
      DO 140 N=1,NSHE
         DO 135 I=1,NGRIDX
            DO 133 J=1,NGRIDZ
               DO 130 K=1,NGRIDY
                  READ (NBCKUP)VALION(N,I,J,K)
 130           CONTINUE
 133        CONTINUE
 135     CONTINUE
 140  CONTINUE
      READ (NBCKUP)NIND
      DO 160 IJ=0,NXDET
         DO 155 K=1,NIND
            DO 150 I=1,NGRIDX
               DO 148 J=1,NGRIDZ
                  DO 145 L=1,NGRIDY
                     READ (NBCKUP)XCABS(IJ,K,I,J,L)
 145              CONTINUE
 148           CONTINUE
 150        CONTINUE
 155     CONTINUE
 160  CONTINUE
      MXINDX=NDMAXDET*(NXCO-1)+(NXDET+1)
      IF (MXINDX.GT.0) CALL CHKBND (13,MXINDX,'LOADBK','XDETOFXCONT')
      DO 180 IX=1,NXCO
         DO 175 IJ=0,NXDET
            INDX=NDMAXDET*(IX-1)+(IJ+1)
CS            READ (NBCKUP)XDETOFXCONT(IJ,K)
            READ (NBCKUP)XDETOFXCONT(INDX)
            DO 170 I=1,NGRIDX
               DO 168 J=1,NGRIDZ
                  DO 165 K=1,NGRIDY
                     READ (NBCKUP)VALBREMS(IX,I,J,K,IJ)
 165              CONTINUE
 168           CONTINUE
 170        CONTINUE
 175     CONTINUE
 180  CONTINUE

*     ---READ HISTOGRAM INFORMATION FROM BACKUP FILE
      READ (NBCKUP)BUFFER
      READ (NBCKUP)BUFFER
      READ (NBCKUP)NHH,NVV
      CALL CHKBND(8,NVV,'LOADBK','VALHIS')
      DO 220 I=1,NVV
         READ (NBCKUP)VALHIS(I)
 220  CONTINUE
      IF (NHH.NE.NHIST) THEN
         WRITE(6,'(A)')'      '
         WRITE(6,'(A)')' %%% ERROR %%%'
         WRITE(6,'(A)')' READING HISTOGRAM INFORMATION FROM BACKUP FILE'
         WRITE(6,'(2A)')' NHIST DOES NOT MATCH THE ACTUAL',
     &                  ' NUMBER OF HISTOGRAMS'
         WRITE(6,'(A)')' HAVE TO STOP SIMULATION'
         WRITE(6,'(A)')' Protests are useless - SESAME!'
         STOP
      ENDIF
      IF (NVV.NE.NVTOT) THEN
         WRITE(6,'(A)')'      '
         WRITE(6,'(A)')' %%% ERROR %%%'
         WRITE(6,'(A)')' READING HISTOGRAM INFORMATION FROM BACKUP FILE'
         WRITE(6,'(2A)')' NVTOT DOES NOT MATCH THE ACTUAL',
     &                  ' ENTRIES IN HISTOGRAM ARRAY'
         WRITE(6,'(A)')' HAVE TO STOP SIMULATION'
         WRITE(6,'(A)')' Protests are useless - SESAME!'
         STOP
      ENDIF
      NHIST=NHH
      NVTOT=NVV

*     ---READ MISCELLANEOUS INFORMATION FROM BACKUP FILE
      READ (NBCKUP)BUFFER
      READ (NBCKUP)BUFFER
      READ (NBCKUP)NIN,NBACK,NTRAN
      READ (NBCKUP)NOUTS,NOUTR,NOUTL,NOUTLR
      READ (NBCKUP)DENSUM,DEESUM

*     ---READ GENERATED AND DETECTED X-RAY INTENSITIES FROM BACKUP FILE
      READ (NBCKUP)BUFFER
      READ (NBCKUP)BUFFER
      READ (NBCKUP)NXC,NXD
      DO 250 I=1,NXC
         READ (NBCKUP)XGENOFXCHAR(I)
         DO 245 J=0,NXD
            IXINDX=(I-1)*NDMAXDET+J+1
            CALL CHKBND (20,IXINDX,'LOADBK    ','XDETOFXCHAR')
CS            READ (NBCKUP)XDETOFXCHAR(J,I)
            READ (NBCKUP)XDETOFXCHAR(IXINDX)
 245     CONTINUE
 250  CONTINUE


*     ---READ OLD EXECUTION TIME


*     ---REPORT THE USE OF A BACKUP FILE TO THE OUTPUT FILE
      CALL WROUT(5,IELTR)

*     ---CLOSE BACKUP FILE
      CLOSE (NBCKUP)

      RETURN
      END
