c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
      SUBROUTINE MCS(Z,IENER,MCSDATA)

***   MCS - RETURNS MOTT CROSS SECTIONS
*
***   AUTHOR: H.WAGNER 6-JUN-95
*
**    INPUT : 
*     Z     - ATOMIC NUMBER
*     IENER - ENERGY INDEX (s.below for energy values)
*     
***   OUTPUT :
*     MCSDATA - TABLE OF MOTT CROSS SECTIONS IN 2 DEG STEPS FROM 0 TO 178 DEG
*
***   START OF EXECUTABLE CODE


      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      
      INTEGER Z,IENER
      DOUBLE PRECISION MCSDATA(90)
      REAL*4 MCSTMP
      CHARACTER*70 FILENAME
      INCLUDE 'PATH.INC'

      FILENAME = CFUND(1:IEND(CFUND))//'MCSTAB.DAT'

      OPEN(12,NAME=FILENAME,STATUS = 'OLD',READONLY,SHARED,
     .     ACCESS='DIRECT',FORM='UNFORMATTED',RECORDSIZE=1)


      IOFFSET = (92*90+1)*(IENER-1)+90*(Z-1)+1

      DO 300,I=1,90
         READ(12'IOFFSET+I) MCSTMP
         MCSDATA(I) = DBLE(MCSTMP)*a0*a0
300   CONTINUE

1000  END

