c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
*last modification: 26-Nov-1997

      SUBROUTINE ONETRJ (
     V                    IETYP,NPTS,NFCS,
     V                    NSCAT,NSCATEL,NSCATIO,NSCATPL,TRJLEN,
     I                    X,Y,Z,DIRX,DIRY,DIRZ,E,FRAC,
     A                    VALION,VALBREMS,XCABS,
     A                    BREMSSPEC,BREMSANGLE)

***   PERFORMS ONE TRAJECTORY OF AN ELECTRON WITH GIVEN ENERGY,LOCATION
*     AND FLIGHT DIRECTION

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'GLOBAL.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'HIST.INC'
      INCLUDE 'OUTPUT.INC'
      INCLUDE 'DMA.INC'
      INCLUDE 'BREMS.INC'

*     HISTOGRAM FOR IONISATIONS
      DOUBLE PRECISION VALION(NDMASHELL,
     &                        NDMAXGRID,NDMAZGRID,NDMAYGRID)
*     BREMSSTRAHLUNG (CONTINUUM X-RAY) ARRAY
      DOUBLE PRECISION VALBREMS(NDMAXCONT,NDMAXGRID,NDMAZGRID,
     &                          NDMAYGRID,0:NDMAXDET-1)
      DOUBLE PRECISION XCABS(0:NDMAXDET-1,NDMAXCONT+NDMAXCHAR-NDMAPTOB,
     &                       NDMAXGRID,NDMAZGRID,NDMAYGRID)
      DOUBLE PRECISION BREMSSPEC(NDMAREG,NDMAEENER,MAXPHENER)
      DOUBLE PRECISION BREMSANGLE(NDMAREG,NDMAEENER,MAXPHENER,
     &                            MAXANGLES)

      DOUBLE PRECISION TRJLEN,X,Y,Z,DIRX,DIRY,DIRZ,E,DELTA
      DOUBLE PRECISION DEE_RUNGE(2)
      DOUBLE PRECISION SIGMAAUG(MAXAUGER)
      INTEGER IETYP
      PARAMETER(DELTA = 2d-1)
*     NUMBER OF DIFFERENT COLORS FOR ELECTRON TRAJECTORIES
      PARAMETER(NCOLTRJ = 10)

      DIMENSION PHELP(1),RHELP(MAXELE)
      DOUBLE PRECISION LAMTOT,LAMELA,LAMION,LAMPLAS
      INTEGER IR,IER,IRNXT,IHELP(MAXELE)
      DOUBLE PRECISION XNXT,YNXT,ZNXT,DEE
      DIMENSION XXOLD(MAXSCR+MAXPST),XYOLD(MAXSCR+MAXPST)

      DOUBLE PRECISION GETQBRS

      INTEGER ICOLTRJ(NCOLTRJ)
      DATA ICOLTRJ / 1,5,4,8,7,14,21,23,28,31 /


**    START OF EXECUTABLE CODE
*     ************************

*     CALCULATE DELTA E FOR COLORED TRAJECTORIES
      DECOL=(E0-EF)/NCOLTRJ

*     SET "JUST ENTERED ONETRJ FLAG" TO ONE
      IJENTO=1
*     MOVE TO ELECTRON STARTING POSITION IF NOT PRIMARY ELECTRON
      IF (IETYP.NE.1 .AND. IETYP .NE. 7) THEN
         DO 4 I=ILOCST(IETYP),NLOCOUT(IETYP)
            ILOC = LOCOUT(IETYP,I)
            CALL F_OUTPUTTO(NXLOC(ILOC),NS)
            CALL TRNXYZ(ILOC,X,Y,Z,XX,ZZ)
            CALL F_MOVE(XX,ZZ,NS)
 4       CONTINUE
      ENDIF
      

*     KEEP E-BEAM STARTING POSITION
      XSEB=X
      YSEB=Y
      ZSEB=Z

CHW   NUMBER OF SCATTERINGS
      NSCAT=0
      NSCATEL=0
      NSCATIO=0
      NSCATPL=0
CS    TRAJECTORY LENGTH
      TRJLEN=0

CHW   DETERMINE STARTING REGION
      IUSOLL=0      
      CALL IMGREG(IUSOLL,
     I            X,Z,PCOORD,
     O            IR,IER)

CHW   ERROR IN POINT LOCATION ?
      IF (IER.NE.0) GOTO 2000

CHW   REGION IS AIR ?      
      IF (IR.LE.0) GOTO 1000

CHW   REGION IN SPECIMEN - MAIN LOOP STARTS HERE
200   CONTINUE

CC      IF (E.LE.EMIN) GOTO 1400

C     ELASTIC SCATTERING

      IF (LELATR(IR)) THEN
        CALL TR_LAMBDA(IR,E,LAMELA,IER)
      ELSE
        CALL E_LAMBDA (IR,E,LAMELA,IER)
      ENDIF

C     PLASMON SCATTERING
      IF (LPLAS(IR)) CALL P_LAMBDA(IR,E,LAMPLAS,IER)

C     IONISATION
      IF (NSHELLOFREG(IR).EQ.0) THEN
	 SIGMAION = 0.           
      ELSE
	 SIGMAION = DINTERPOL(
     I                        SIGMA_ION(1,IR,NSHELLOFREG(IR)),
     I                        MAXENER,EMIN,EMAX,E,
     O                        IER)
      ENDIF

C     SUM ALL MEAN FREE PATHS 

      IF (SIGMAION.EQ.0) THEN 
	 LAMION = 0 
	 LAMTOT = LAMELA
      ELSE
	 LAMION = 1/(TOT_ATDENS(IR)*SIGMAION)
	 LAMTOT = 1./(1./LAMELA + 1./LAMION)
      ENDIF

      IF (LPLAS(IR)) THEN
	 LAMTOT = 1./(1./LAMTOT + 1./LAMPLAS)
      ENDIF
CAP
      IF (LSING(IR)) THEN
	 LAMTOT = LAMELA
      ENDIF
CAP

CS    CALCULATE A STOCHASTIC FREE FLIGHT PATH
      FFP=-LAMTOT*LOG(RANNUM())

CS    CALCULATE LOCATION OF NEXT SCATTERING EVENT
      XNXT=X+FFP*DIRX
      YNXT=Y+FFP*DIRY
      ZNXT=Z+FFP*DIRZ


CS    CHECK IF LOCATION OF NEXT SCATTERING EVENT LIES IN SAME REGION
      CALL IMGREG (
     I             IUSOLL,XNXT,ZNXT,PCOORD,
     O             IRNXT,IER)

CHW   ERROR IN POINT LOCATION ?
      IF (IER.NE.0) GOTO 2000
      
      IF (IR.NE.IRNXT) THEN
CS       NEXT SCATTERING EVENT WOULD LIE IN A DIFFERENT DOMAIN
CS       CALCULATE THE COORDINATES OF POINT AT THE INTERFACE

	 CALL INTERSECT (
     D                   NPTS,NFCS,
     I                   PCOORD,ILINES,IENDIX,
     I                   IR,X,Z,DIRX,DIRZ,
     O                   XNXT,ZNXT,IRNXT,RLDB,IER)

	 IF (IER.NE.0) THEN
	    GOTO 2200
	 ENDIF
CHW      NEW FFP AND INTERFACE LOCATION :
	 FFP = RLDB

CHW      "BUGFIX" FOR IMENTR 
	 XNXT = XNXT + DIRX*DELTA
	 ZNXT = ZNXT + DIRZ*DELTA
	 YNXT = Y + FFP*DIRY

CHW      SET 'STOPPED AT INTERFACE' FLAG
	 IINTER = 1

      ELSE
	 IINTER = 0
      ENDIF

CS    CALCULATE LENGTH OF TRAJECTORY
      TRJLEN=TRJLEN+FFP

      IF (LBREMS) THEN
         EMEAN=E
         RANSC=RANNUM()
         XSING=(X+RANSC*FFP*DIRX)
         ZSING=(Z+RANSC*FFP*DIRZ) 
         YSING=(Y+RANSC*FFP*DIRY)
      ENDIF

CS    CALCULATE THE SLOWING DOWN OF THE ELECTRON 
      IF (.NOT. LPLAS(IR) .AND. .NOT. LSING(IR)) THEN
	 CALL SLOWD(
     O              DEE,
     I              E,IR,
     I              X,Y,Z,XNXT,YNXT,ZNXT,FFP)
	 IF (DEE.GT.E) DEE = E
         EMEAN=E-DEE*0.5
	 E=E-DEE
	 DEESUM=DEESUM+DEE
      ENDIF

CAP
      IF (LSING(IR)) THEN 
*     CALCULATION OF HALF AND FULL STEP ENERGY LOSS
	 CALL RUNGE (
     I               IR,E,FFP, 
     O               DEE_RUNGE,IER)
	 IF (DABS(DEE_RUNGE(2)).GT.E) DEE_RUNGE(2) = E
	 E_SING=E-DABS(DEE_RUNGE(1))              
         IF (E_SING.LT.0) E_SING=0
         EMEAN=E_SING
	 E=E-DABS(DEE_RUNGE(2))
	 DEESUM=DEESUM+DABS(DEE_RUNGE(2))

*        CALCULATION OF IONIZATIONS AND PHI(Z)
*        IN SINGLE SCATTERING MODEL
* START
         IF (.NOT.LBREMS) THEN
            RANSC=RANNUM()
            XSING=(X+RANSC*FFP*DIRX)
            ZSING=(Z+RANSC*FFP*DIRZ) 
            YSING=(Y+RANSC*FFP*DIRY)
         ENDIF
         DO 171 IN = 1,NSHELLOFREG(IR)
            ISINDX=(IN-1)*NDMAREG+IR
            CALL CHKBND(15,ISINDX,'ONETRJ    ','SHELLOFREG')
CS            IS=SHELLOFREG(IR,IN)
            IS=SHELLOFREG(ISINDX)
            CALL CHKBND(5,IS,'ONETRJ    ',
     &                  'ENER/ELEM/SHELLOFSHELL')
            EC_IS=ENEROFSHELL(IS)
            I_ELEM=ELEMOFSHELL(IS) 
            I_SHELL=SHELLOFSHELL(IS)
            A_TOM=ATNUM(I_ELEM)
            IF (E_SING.GT.EC_IS) THEN
      	       DO 1171 I_ELE = 1,NELE(IR)
                  IF (ELEM(IR,I_ELE) .EQ. I_ELEM) THEN 
                     CW = WEIGHTFRAC(IR,I_ELE)
                     I_ELE_IR=I_ELE
                     GOTO 1172 
                  ENDIF
 1171          CONTINUE

*              CALCULATION OF IONISATION CROSSECTION WITH POUCHOU'S OR
*              GRYZINSKI'S FORMULA
*              SHOULD BE READ FROM A TABLE LATER (FOR BOTH)

 1172          CONTINUE
               IF (LPOUCH) THEN
                 QIW=QCHAR1(A_TOM,E_SING,EC_IS,I_SHELL)
               ELSE IF (LGRYZ) THEN
                 QIW=QCHAR2(A_TOM,E_SING,EC_IS,I_SHELL)
               ELSE IF (LCASNATI) THEN
                 QIW=QCHAR9(A_TOM,E_SING,EC_IS,I_SHELL)
               ELSE
                 QIW=QCHAR1(A_TOM,E_SING,EC_IS,I_SHELL)
               ENDIF

CS               THE WEIGHTFRACTION IS ALREADY TAKEN INTO ACCOUNT IN ATDENS
CS               THAT WAY IT WOULD BE TAKEN INTO ACCOUNT TWICE - TOTALLY WRONG
CS               VALUE1 = WEIGHTFRAC(IR,I_ELE_IR)*
CS     &                  QIW*FFP*ATDENS(IR,I_ELE_IR)
CS               VALUE1 = QIW*FFP*ATDENS(IR,I_ELE_IR)/NETRN
               VALUE1 = QIW*FFP*ATDENS(IR,I_ELE_IR)
               VALUE2 = VALUE1/4/PI
CS               VALUE = CW*QIW*FFP*ATDENS(IR,I_ELE_IR)
CS     &                 /NETRN/4/PI
               IONINTOFSHELL(IS)=IONINTOFSHELL(IS)+VALUE1
CS               DO 1175 IXC=1,NXCHTABINDX(I_ELEM,I_SHELL)
CS                  IINDX=XCHTABINDX(I_ELEM,I_SHELL,IXC)
CS                  IF (XCHIS(SHELLOFXCHAR(IINDX),IXC).GT.0) THEN
CS                     IHIS=XCHIS(SHELLOFXCHAR(IINDX),IXC)
CAP               DO 1175 IDSH=1,NXCHAROFSHELL(ISHELN)
               DO 1176 IDSH=1,NXCHAROFSHELL(IS) 
CAP                  IINDX=XCHAROFSHELL(ISHELN,IDSH)
                  ISINDX=(IS-1)*NDMAXCHAR+IDSH
                  CALL CHKBND(19,ISINDX,'ONETRJ    ','XCHAROFSHELL')
CS                  IINDX=XCHAROFSHELL(IS,IDSH)
                  IINDX=XCHAROFSHELL(ISINDX)
                  CALL CHKBND(6,IINDX,'ONETRJ    ','XGENOFXCHAR/...')
*                 INCREASE X-RAY INTENSITIES (GENERATED AND DETECTED)
                  VALUE3=VALUE2*FYIELDOFXCHAR(IINDX)*
     &                   FRELINTOFXCHAR(IINDX)*FFUDGEOFXCHAR(IINDX)
                  XGENOFXCHAR(IINDX)=XGENOFXCHAR(IINDX)+VALUE3
CS                CALCULATE NEAREST GRID POINT
                  CALL  IONVAL (
     I                          .FALSE.,2,
     D	  	   	        NSHELL,NGRIDX,NGRIDZ,NGRIDY,
     D			        XGRIDL,ZGRIDL,YGRIDL,
     D                          X_MIN,X_MAX,Z_MIN,Z_MAX,
     I                          XSING,ZSING,0,VALUE,
     O                          VALION,NOUTGR,NOUTAR,IXGRL,IZGRL,
     O                          IER)
CS-TEST-START
CS                  WRITE(6,'(D11.4,2I4,2D11.4)')
CS     &               VALUE,IXGRL,IZGRL,XCABS(IINDX,IXGRL,IZGRL),
CS     &               XCABS(IINDX,IXGRL,IZGRL)*VALUE
CS-TEST-END
                  IF ((IXGRL.GT.0).AND.(IZGRL.GT.0).AND.
     &                (IXGRL.LE.NGRIDX).AND.(IZGRL.LE.NGRIDZ)) THEN
CS                   FOR THE TIME BEING: ONLY ONE GRID LINE IN Y-DIRECTION
                     IYGRL=1
                     DO 1174 IXDET=0,NXDET
                        KINDX=(NXDET+1)*(IINDX-1)+(IXDET+1)
                        CALL CHKBND (13,KINDX,'ONETRJ','XDETEFFOFXCHAR')
CS                        VALUE4=VALUE3*
CS     &                         XCABS(IXDET,IINDX,IXGRL,IZGRL,IYGRL)*
CS     &                         XDETEFFOFXCHAR(IXDET,IINDX)
                        VALUE4=VALUE3*
     &                         XCABS(IXDET,IINDX,IXGRL,IZGRL,IYGRL)*
     &                         XDETEFFOFXCHAR(KINDX)
                        IXINDX=(IINDX-1)*NDMAXDET+IXDET+1
                        CALL CHKBND (20,IXINDX,'ONETRJ','XDETOFXCHAR')
CS                        XDETOFXCHAR(IXDET,IINDX)=
CS     &                  XDETOFXCHAR(IXDET,IINDX)+VALUE4
                        XDETOFXCHAR(IXINDX)=XDETOFXCHAR(IXINDX)+VALUE4
                        DO 1173 JDXH=1,NXCHIS(IINDX)
                           IXINDX=(IINDX-1)*NDMAHIST+JDXH
                           CALL CHKBND (23,IXINDX,'ONETRJ','XCHIS/...')
CS                           IF (XDETXCHIS(IINDX,JDXH).NE.IXDET)GOTO 1173
                           IF (XDETXCHIS(IXINDX).NE.IXDET)GOTO 1173
CS                           IHIS=XCHIS(IINDX,JDXH)
                           IHIS=XCHIS(IXINDX)
                           V4F=VALUE4*XCHISWINFRAC(IXINDX)
                           CALL HISTOG(1,IHIS,V4F,XPREF,0.D0,0.D0)
 1173                   CONTINUE
 1174                CONTINUE
                     DO 1175 IXCSHIS=1,NXCSHIS
                        AA=1
                        IXDET=XCSDET(IXCSHIS)
                        KINDX=(NXDET+1)*(IINDX-1)+(IXDET+1)
                        CALL CHKBND (13,KINDX,'ONETRJ','XDETEFFOFXCHAR')
CS                        VALUE4=VALUE3*
CS     &                         XCABS(IXDET,IINDX,IXGRL,IZGRL,IYGRL)*
CS     &                         XDETEFFOFXCHAR(IXDET,IINDX)
                        VALUE4=VALUE3*
     &                         XCABS(IXDET,IINDX,IXGRL,IZGRL,IYGRL)*
     &                         XDETEFFOFXCHAR(KINDX)
                        AA=DSIGN(AA,RANNUM()-0.5)
CS                        ECHAR_IS=ENEROFXCHAR(IINDX)+AA*RANNO()*
CS     &                           FWHMOFXCHAR(IXDET,IINDX)/2.355
                        ECHAR_IS=ENEROFXCHAR(IINDX)+AA*RANNO()*
     &                           FWHMOFXCHAR(KINDX)/2.355
                        IHIS=XCSHIS(IXCSHIS)
                        CALL HISTOG(1,IHIS,VALUE4,ECHAR_IS,0.D0,0.D0)
 1175                CONTINUE
                  ENDIF
 1176          CONTINUE
               IF (HISTOFION(IS).GT.0) THEN
                  CALL IONVAL (
     I                         .FALSE.,1,
     D                         NSHELL,NGRIDX,NGRIDZ,NGRIDY,
     D                         XGRIDL,ZGRIDL,YGRIDL,
     D                         X_MIN,X_MAX,Z_MIN,Z_MAX,
     I                         XSING,ZSING,HISTOFION(IS),VALUE1,
     O                         VALION,NOUTGR,NOUTAR,IXGR,IZGR,
     O                         IER)
               ENDIF
*              UPDATE IONIZATION DISTRIBUTIONS (HISTOGRAMS)
               DO 1177 J=1,NIONHIST(IS)
                  ISINDX=(IS-1)*NDMAHIST+J
                  CALL CHKBND(18,ISINDX,'ONETRJ    ','IONHIST   ')
CS                  JHIST=IONHIST(IS,J)
                  JHIST=IONHIST(ISINDX)
                  NJDIM=NVDIM(JHIST)
                  IF (CVALUE(JHIST).EQ.'IOV') THEN
                     CALL HISTOG(NJDIM,JHIST,VALUE1,ZSING,XSING,YSING)
                  ELSE
                     CALL HISTOG(NJDIM,JHIST,VALUE1,XSING,ZSING,YSING)
                  ENDIF
 1177          CONTINUE

*              UPDATE IONIZATIONS (ION) ON SCREEN
               IF (RANNUM().LE.VALUE1*NETRN) THEN
                 DO 2761 J=ISCROFSHELL,NSCROFSHELL(IS)
                   ISINDX=(IS-1)*(NDMASCRN+NDMAPS)+J
                   CALL CHKBND(16,ISINDX,'ONETRJ    ','SCROFSHELL')
CS       	     CALL DRWION(SCROFSHELL(IS,J),XSING,YSING,ZSING,
CS     &                         I_ELEM,I_SHELL)
       	           CALL DRWION(SCROFSHELL(ISINDX),XSING,YSING,ZSING,
     &                         I_ELEM,I_SHELL)
 2761            CONTINUE
               ENDIF
            ENDIF
 171     CONTINUE
      ENDIF  

CS    CALCULATION OF BREMSSTRAHLUNG
      IF (LBREMS) THEN
         CALL CHKBND (7,NXCONT,'ONETRJ','ENEROFXCONT')
         BETA=DSQRT(1-(511000/(511000+EMEAN))**2)
         MXINDX=(NXDET+1)*(NXCONT-1)+(NXDET+1)
         CALL CHKBND (13,MXINDX,'ONETRJ','XDETOFXCONT')
         CALL CHKBND (7,NXCONT,'ONETRJ','IXCONTOFXCHAR')
         DO 173 I=1,NXCONT
            IF (EMEAN.LT.ENEROFXCONT(I)) GOTO 173
            IF (LWIEDKIRK) THEN
               CALL QBREMS (ZQUER(IR),EMEAN,ENEROFXCONT(I),
     &                      QXBREMS,QYZBREMS)
               IF ((QXBREMS.EQ.0).AND.(QYZBREMS.EQ.0)) GOTO 173
            ENDIF
            DO 172 J=0,NXDET
CS               FCT1=DIRX*DIRXDET(J,1)+DIRY*DIRXDET(J,2)+
CS     &              DIRZ*DIRXDET(J,3)
*              COSINE OF ANGLE BETWEEN ELECTRON'S DIRECTION AND DETECTOR
               FCT1=COSTAK(J)*(DIRX*COSXDER(J)+DIRY*SINXDER(J))-
     &              DIRZ*SINTAK(J)
               IF (LWIEDKIRK) THEN
                  FCT2=FCT1*FCT1
                  QBRS=QXBREMS+QYZBREMS+(QYZBREMS-QXBREMS)*FCT2
                  FCT3=(1-BETA*FCT1)*(1-BETA*FCT1)
                  QBRS=QBRS/FCT3
CS                  VLBRMS=QBRS*TOT_ATDENS(IR)*FFP/NETRN
               ELSE
cs3978              write(6,'(a)')'       '
csc                  write(6,'(a)')' input: EE AND EP [keV]'
csc                  read(*,*)ee,ep
cs                  write(6,'(a)')' input: EE [keV]'
cs                  read(*,*)ee
cs                  write(6,'(a)')' input: number of intervals for EP'
cs                  read(*,*)nep
cs                  write(6,'(a)')' input: angle [degrees]'
cs                  read(*,*)theangl
cs                  ee=ee*1000
cs                  ep=ep*1000
cs                  theangle=theangl*pi/180
cs                  theangle=dcos(theangle)
cs                  BETA=DSQRT(1-(511000/(511000+ee))**2)
cs                  epdelt=ee/nep
cs                  do 3421 iep=1,nep-1
cs                  ep=epdelt*iep
csc                  sumqbrs1=0
csc                  sumqbrs2=0
csc                  do 3422 iang=0,36
csc                  theangl=5*iang
csc                  theangle=theangl*pi/180
csc                  theangle=dcos(theangle)
cs                  QBRS1=GETQBRS(IR,ZQUER(IR),ee,ep,theangle,BETA,
cs     &                          BREMSSPEC,BREMSANGLE)
csc                  qbrs1=qbrs1*1d11
csc                  sumqbrs1=sumqbrs1+qbrs1
cs                  CALL QBREMS (ZQUER(IR),ee,ep,
cs     &                         QXBREMS,QYZBREMS)
cs                  costhet=theangle
cs                  qbrs2=qxbrems*(1-costhet*costhet)+
cs     &                  qyzbrems*(1+costhet*costhet)
cs                  qbrs2=qbrs2/(1-beta*costhet)**2
csc                  qbrs2=qbrs2*1d11
csc                  sumqbrs2=sumqbrs2+qbrs2
csc 3422             continue
cs                  write(6,'(4f8.3,3f10.3)')ee/1000,ep/1000,ep/ee,
cs     &                         theangl,qbrs1*ep*1d11,qbrs2*ep*1d11,
cs     &                         qbrs2/qbrs1
csc                  write(6,'(3f8.3,2f15.2,f10.3)')ee/1000,ep/1000,ep/ee,
csc     &                         sumqbrs1,sumqbrs2,
csc     &                         sumqbrs2/sumqbrs1
cs 3421             continue
cs                  goto 3978
                  IF (EMEAN.LT.1000) THEN
                     EDUMMY=1000
                     BETFCT=DSQRT(1-(511000/(511000+EDUMMY))**2)
                     QFCT1=GETQBRS(IR,ZQUER(IR),EDUMMY,ENEROFXCONT(I),
     &                             FCT1,BETFCT,
     &                             BREMSSPEC,BREMSANGLE)
                     CALL QBREMS (ZQUER(IR),EDUMMY,ENEROFXCONT(I),
     &                            QXBREMS,QYZBREMS)
                     FCT2=FCT1*FCT1
                     QFCT2=QXBREMS+QYZBREMS+(QYZBREMS-QXBREMS)*FCT2
                     FCT3=(1-BETFCT*FCT1)*(1-BETFCT*FCT1)
                     QFCT2=QFCT2/FCT3
                     CALL QBREMS (ZQUER(IR),EMEAN,ENEROFXCONT(I),
     &                            QXBREMS,QYZBREMS)
                     QBRS=QXBREMS+QYZBREMS+(QYZBREMS-QXBREMS)*FCT2
                     FCT3=(1-BETA*FCT1)*(1-BETA*FCT1)
                     QBRS=QBRS/FCT3
                     IF (FCT2.GT.0) THEN
                        QBRS=QBRS*QFCT1/QFCT2
                     ENDIF
                  ELSE
                     QBRS=GETQBRS(IR,ZQUER(IR),EMEAN,ENEROFXCONT(I),
     &                            FCT1,BETA,
     &                            BREMSSPEC,BREMSANGLE)
                  ENDIF
               ENDIF
               VLBRMS=QBRS*TOT_ATDENS(IR)*FFP*BREMSFUDGE
               CALL BRMVAL (
     I                      .FALSE.,1,NXCONT,
     D                      NGRIDX,NGRIDZ,NGRIDY,
     D                      XGRIDL,ZGRIDL,YGRIDL,
     D                      X_MIN,X_MAX,Z_MIN,Z_MAX,
     I                      XSING,ZSING,IXCONTOFXCHAR(I),VLBRMS,
     O                      VALBREMS(1,1,1,1,J),
     O                      NBREMSOUTGR,NBREMSOUTAR,
     O                      IXGRL,IZGRL,
     O                      IER)
               IF ((IXGRL.GT.0).AND.(IZGRL.GT.0).AND.
     &             (IXGRL.LE.NGRIDX).AND.(IZGRL.LE.NGRIDZ)) THEN
CS                FOR THE TIME BEING: ONLY ONE GRIDLINE IN Y-DIRECTION
                  IYGRL=1
                  K1INDX=(NXDET+1)*(IXCONTOFXCHAR(I)-1)+(J+1)
                  CALL CHKBND (13,K1INDX,'ONETRJ','XDETEFFOFXCHAR')
                  K2INDX=(NXDET+1)*(I-1)+(J+1)
CS                  XDETOFXCONT(J,I)=XDETOFXCONT(J,I)+
CS     &                  VLBRMS*
CS     &                  XCABS(J,IXCONTOFXCHAR(I),IXGRL,IZGRL,IYGRL)*
CS     &                  XDETEFFOFXCHAR(J,IXCONTOFXCHAR(I))
                  XDETOFXCONT(K2INDX)=XDETOFXCONT(K2INDX)+
     &                  VLBRMS*
     &                  XCABS(J,IXCONTOFXCHAR(I),IXGRL,IZGRL,IYGRL)*
     &                  XDETEFFOFXCHAR(K1INDX)
                  DO 1178 JDXH=1,NXKHIS(I)
                     IXINDX=(I-1)*NDMAHIST+JDXH
                     CALL CHKBND (26,IXINDX,'ONETRJ','XKHIS/...')
                     IF (XDETXKHIS(IXINDX).NE.J)GOTO 1178
                     IHIS=XKHIS(IXINDX)
                     VAL=VLBRMS*
     &                   XCABS(J,IXCONTOFXCHAR(I),IXGRL,IZGRL,IYGRL)*
     &                   XDETEFFOFXCHAR(K1INDX)*
     &                   (HISENWIN(IHIS,2)-HISENWIN(IHIS,1))
                     CALL HISTOG(1,IHIS,VAL,XPREF,0.D0,0.D0)
CS                     IF (LTEST) THEN
CS                       WRITE(6,'(A)')'           '
CS                       WRITE(6,'(2A)')' HISTOGRAMS FOR LINE SCANS',
CS     &                      ' TAKING BREMSSTRAHLUNG INTO ACCOUNT:'
CS                       WRITE(6,'(A,I5)')' ENTRY IN XCONT-TABLE:',
CS     &                                    I
CS                       WRITE(6,'(A,I5)')' HISTOGRAM NUMBER:    ',
CS     &                                    IHIS
CS                       WRITE(6,'(A,I5)')' NXKHIS:              ',
CS     &                                    NXKHIS(I)
CS                       WRITE(6,'(A,I5)')' INDEX IN XKHIS:      ',
CS     &                                    IXINDX
CS                       WRITE(6,'(A,I5)')' XKHIS:               ',
CS     &                                    XKHIS(IXINDX)
CS                       WRITE(6,'(A,I5)')' DETECTOR NUMBER:     ',
CS     &                                    XDETXKHIS(IXINDX)
CS                     ENDIF
 1178             CONTINUE
               ENDIF
 172        CONTINUE
 173     CONTINUE
      ENDIF

C      IF (NAUGER .GT. 0 .AND. AUGMOD .EQ. 1) THEN
CHW      CALCULATE AUGER GENERATION PROBABILITY
C         DO 170,IAUG = 1,NAUGER
C            SIGMAAUG(IAUG) = DINTERPOL(
C     I			               SIGMA_AUG(1,IR,IAUG),
C     I			               MAXENER,EMIN,EMAX,E,
C     O			               IER)
C
C170      CONTINUE
C
C173      CONTINUE
C
C         CALL IMSURFGETDEPTH(X+FP*DIRX,Z+FP*DIRZ,DD,DL,IER)
C
C         IF (IER .EQ. 0) THEN
C            DO 174,IAUG=1,NAUGER
C      	       GENPROB = TOT_ATDENS(IR)*SIGMAAUG(IAUG)         
C               CALL HISTOG(2,AGDHIST(IAUG),GENPROB,DL,DD,DD)
C       	       CALL HISGET(2,AUGERESCHIST(IAUG),ESCPROB,DL,DD,DD)
C*      	       AUGTOT(IAUG) = AUGTOT(IAUG)+GENPROB*ESCPROB               
C174         CONTINUE
C         ENDIF
C
C         FP=FP+1.D0
C         IF (FP .LT. FFP) GOTO 173
C         FP = FP - FFP
C
C      ENDIF
CHW      END AUGER CALCULATION        

CHW   --- TRAJECTORY OUTPUT EVENTS

      IF (NLOCOUT(IETYP) .GT. 0) THEN 
        DO 175 I=ILOCST(IETYP),NLOCOUT(IETYP)
           ILOC = LOCOUT(IETYP,I)
           CALL F_OUTPUTTO(NXLOC(ILOC),NS)
	   CALL TRNXYZ(ILOC,XNXT,YNXT,ZNXT,XX,XY)
           IF (AINT((XX-XXOLD(ILOC))) .NE. 0 .OR.
     .         AINT((XY-XYOLD(ILOC))) .NE. 0) THEN
       		  IF (IETYP .EQ. 4) THEN
C		     * DRAW SECONDARIES RED
                     CALL F_PEN(31,NS)
         	     CALL F_FLINETO(XX,XY,NS)
                     CALL F_PEN(1,NS)
                  ELSE
                     IF (LCOLTRJ) THEN
                        ICOL=MIN(INT((E-EF)/DECOL)+1,NCOLTRJ)
                        CALL F_PEN(ICOLTRJ(ICOL),NS)
                     ENDIF
         	     CALL F_FLINETO(XX,XY,NS)
                     CALL F_PEN(1,NS)
                  ENDIF
                  XXOLD(ILOC) = XX
                  XYOLD(ILOC) = XY
           ENDIF
175     CONTINUE         
      ENDIF

      X = XNXT
      Y = YNXT
      Z = ZNXT

      IF (E.LE.EMIN) GOTO 1400

CHW   IF ELECTRON STOPPED AT INTERFACE THEN NO SCATTERING

      IF (IINTER .GT. 0) THEN
	 IR = IRNXT
	 IF (IR.LE.0) THEN
	    GOTO 1000
	 ENDIF   
	 GOTO 200
      ENDIF

CHW   ELSE PERFORM SCATTERING EVENT

      NSCAT=NSCAT+1

CHW   USE OLD LAMBDA's , MAYBE LAMBDAS FOR NEW E IS BETTER(?)
C     SELECT THE NEXT SCATTERING EVENT (ELASTIC OR INNER SHELL IONIZATION)
CHW   SETUP RHELP() FOR SELECTION OF SCATTERING EVENT USING TAKEDI

CAP   SINGLE SCATTERING MODEL
      IF (LSING(IR)) GOTO 300
CAP      
      RHELP(1) = 1./LAMELA

      IF (LAMION .GT. 0) THEN
	 RHELP(2) = RHELP(1) + 1./LAMION
      ELSE
	 RHELP(2) = RHELP(1)
      ENDIF

      IF (LPLAS(IR)) THEN
	 RHELP(3) = RHELP(1) + 1./LAMPLAS
      ELSE
	 RHELP(3) = RHELP(2)
      ENDIF

      IF (NAUGER .GT. 0) THEN

CHW     CALCULATE AUGER GENERATION PROBABILITY

        CALL IMSURFGETDEPTH(X,Z,DD,DL,IER)
                
      	IF (DD .LE. AHISV .AND. FRAC .EQ. 1.D0) THEN
         IF (RANNUM() .LE. AUGMUL) THEN

         DO 270,IAUG = 1,NAUGER

CHW     CALCULATE AUGER CROSS SECTION
           SIGMAAUG(IAUG) = DINTERPOL(
     I			      SIGMA_AUG(1,IR,IAUG),
     I			      MAXENER,EMIN,EMAX,E,
     O			      IER)


          IF (SIGMAAUG(IAUG) .GT. 0) THEN
      	     AUGFRAC = 1./AUGMUL*LAMTOT*TOT_ATDENS(IR)*SIGMAAUG(IAUG)

CHW     UPDATE AGD HISTOGRAMM
      	     IF (AGDHIS(IAUG) .GT. 0) THEN
                CALL HISTOG(2,AGDHIS(IAUG),AUGFRAC,DL,DD,DD)
      	     ENDIF

CHW     CREATE AUGER ENTRY IN SECONDARY LIST
	  DO 280 ISEC=1,1
      	     IF (NSEC .GE. MAXSEC) THEN
      		WRITE(*,*) '*** WARNING: OVERFLOW OF SECONDARY QUEUE'
      	        GOTO 280
      	     ENDIF 
	     NSEC = NSEC + 1
	     SEC_FRAC(NSEC)=AUGFRAC
	     SEC_E(NSEC) = ENEROFAUGER(IAUG)
	     SEC_DIRX(NSEC) = 1.D0
	     SEC_DIRY(NSEC) = 0.D0
	     SEC_DIRZ(NSEC) = 0.D0
	     SEC_X(NSEC) = X
	     SEC_Y(NSEC) = Y
	     SEC_Z(NSEC) = Z
      	     SEC_ETYP(NSEC) = 5
      	     SEC_ESUBTYP(NSEC) = IAUG
	     SEC_FI = 2.D0*PI*RANNUM()
	     COSSEC_FI = COS(SEC_FI)
	     SINSEC_FI = SIN(SEC_FI)
	     COSSEC_PSI = RANNUM()*2.D0-1.D0
	     SINSEC_PSI = SQRT(1.D0-COSSEC_PSI*COSSEC_PSI) 
	     CALL NDIRA(
     V                 SEC_DIRX(NSEC),SEC_DIRY(NSEC),SEC_DIRZ(NSEC),
     I                 COSSEC_PSI,SINSEC_PSI,COSSEC_FI,SINSEC_FI    )
280      CONTINUE
         ENDIF
270    CONTINUE
       ENDIF
       ENDIF
      ENDIF

CHW      END AUGER CALCULATION        

CHW   SELECT SCATTERING EVENT
 
 297  RAND = RANNUM()
      CALL TAKEDI(3,RHELP,RAND,ISCAT,IER)
CS    EXPLICITELY STORE PROBABILITY OF IONIZATION
      PROPION=PROPION+(RHELP(2)-RHELP(1))/RHELP(3)
      GOTO (300,400,450) ISCAT

C ELASTIC SCATTERING:
C ===================

 300  CONTINUE

      NSCATEL=NSCATEL+1

C     DETERMINE SCATTERING ANGLE

      IF (LELATR(IR)) THEN
    
        COSPSI = RANNUM()*2.D0-1.D0
        SINPSI = SQRT(1.D0-COSPSI*COSPSI)
  	
      ELSE

        CALL E_THETA(
     I               IR,E,RANNUM(),RANNUM(),
     O               COSPSI,IER)

        SINPSI = SINE(NINT(COSPSI))
        COSPSI = COSINE(NINT(COSPSI))

      ENDIF

      GOTO 500


C INNER SHELL IONIZATION:
C =======================

 400  CONTINUE

      NSCATIO=NSCATIO+1
		    
C     SETUP RHELP ARRAY FOR TAKEDI 

      DO 260 ISHEL=1,NSHELLOFREG(IR)
   	    RHELP(ISHEL)=DINTERPOL(
     I                             SIGMA_ION(1,IR,ISHEL),
     I                             MAXENER,EMIN,EMAX,E+DEE,
     O                             IER)
260   CONTINUE


C      IF (ISHLL.LT.1) THEN
*        NON OF THE SPECIFIED SHELL CAN BE EXCITED
*        GO BACK TO SELECTING SCATTERING EVENT
C         GOTO 297
C      ENDIF

CHW   SELECT SHELL
      RAND=RANNUM()
      CALL TAKEDI (NSHELLOFREG(IR),RHELP,RAND,ISHELN,IERR)
      IF (IERR .EQ. 1) WRITE(*,*) ' ERROR IN TAKEDI IN SHELL SELECTION!'       
      ISINDX = (ISHELN-1)*NDMAREG+IR
      CALL CHKBND(15,ISINDX,'ONETRJ    ','SHELLOFREG') 
CS      ISHELN = SHELLOFREG(IR,ISHELN)
      ISHELN = SHELLOFREG(ISINDX)

CHW   DETERMINE ELEMENT AND SHELL OF SELECTED SHELL
      CALL CHKBND(5,ISHELN,'ONETRJ    ','ELEM/SHELLOFSHELL')
      IELE = ELEMOFSHELL(ISHELN)
      ISHELL = SHELLOFSHELL(ISHELN)

      
CS    UPDATE HISTOGRAMS ONLY FOR PRIMARY ELECTRONS
      IF (IETYP .GT. 1) GOTO 278

      VALUE=0.25/PI
CS      VALUE=1./NETRN/4/PI
      IONINTOFSHELL(ISHELN)=IONINTOFSHELL(ISHELN)+1
CS      IONINTOFSHELL(ISHELN)=IONINTOFSHELL(ISHELN)+1./NETRN

      DO 266 I=1,NXCHAROFSHELL(ISHELN)
         ISINDX=(ISHELN-1)*NDMAXCHAR+I
         CALL CHKBND(19,ISINDX,'ONETRJ    ','XCHAROFSHELL')
CS         IDXXC=XCHAROFSHELL(ISHELN,I)
         IDXXC=XCHAROFSHELL(ISINDX)
         CALL CHKBND(6,IDXXC,'ONETRJ    ','ENEROFXCHAR/...')
*        INCREASE X-RAY INTENSITIES (GENERATED AND DETECTED)
         XGENOFXCHAR(IDXXC)=XGENOFXCHAR(IDXXC)+
     &          FYIELDOFXCHAR(IDXXC)*FRELINTOFXCHAR(IDXXC)*VALUE
CS       CALCULATE NEAREST GRID POINT
         CALL IONVAL (
     I                .FALSE.,2,
     D                NSEHLL,NGRIDX,NGRIDZ,NGRIDY,
     D                XGRIDL,ZGRIDL,YGRIDL,
     D                X_MIN,X_MAX,Z_MIN,Z_MAX,
     I                X,Z,0,VDUMMY,
     O                VALION,NOUTGR,NOUTAR,IXGR,IZGR,
     O                IER)
         IF ((IXGR.GT.0).AND.(IZGR.GT.0).AND.
     &       (IXGR.LE.NGRIDX).AND.(IZGR.LE.NGRIDZ)) THEN
CS          FOR THE TIME BEING: ONLY ONE GRID LINE IN Y-DIRECTION
            IYGR=1
            DO 264 IXDET=0,NXDET
               KINDX=(NXDET+1)*(IDXXC-1)+(IXDET+1)
               CALL CHKBND (13,KINDX,'ONETRJ','XDETEFFOFXCHAR')
CS               VLUE=XCABS(IXDET,IDXXC,IXGR,IZGR,IYGR)*
CS     &              FYIELDOFXCHAR(IDXXC)*FRELINTOFXCHAR(IDXXC)*
CS     &              XDETEFFOFXCHAR(IXDET,IDXXC)*VALUE
               VLUE=XCABS(IXDET,IDXXC,IXGR,IZGR,IYGR)*
     &              FYIELDOFXCHAR(IDXXC)*FRELINTOFXCHAR(IDXXC)*
     &              XDETEFFOFXCHAR(KINDX)*VALUE
               IXINDX=(IDXXC-1)*NDMAXDET+IXDET+1
               CALL CHKBND (20,IXINDX,'ONETRJ','XDETOFXCHAR')
CS               XDETOFXCHAR(IXDET,IDXXC)=
CS     &              XDETOFXCHAR(IXDET,IDXXC)+VLUE
               XDETOFXCHAR(IXINDX)=XDETOFXCHAR(IXINDX)+VLUE
               DO 263 J=1,NXCHIS(IDXXC)
                  IXINDX=(IDXXC-1)*NDMAHIST+J
                  CALL CHKBND (23,IXINDX,'ONETRJ','XDETXCHIS/...')
CS                  IF (XDETXCHIS(IDXXC,J).NE.IXDET) GOTO 263
                  IF (XDETXCHIS(IXINDX).NE.IXDET) GOTO 263
CS                  IHIS=XCHIS(IDXXC,J)
                  IHIS=XCHIS(IXINDX)
                  CALL HISTOG(1,IHIS,VLUE,XPREF,0.D0,0.D0)
 263           CONTINUE
 264        CONTINUE
            DO 265 IXCSHIS=1,NXCSHIS
                AA=1
                IXDET=XCSDET(IXCSHIS)
                KINDX=(NXDET+1)*(IDXXC-1)+(IXDET+1)
                CALL CHKBND (13,KINDX,'ONETRJ','XDETEFFOFXCHAR')
CS                VLUE=XCABS(IXDET,IDXXC,IXGR,IZGR,IYGR)*
CS     &              FYIELDOFXCHAR(IDXXC)*FRELINTOFXCHAR(IDXXC)*
CS     &              XDETEFFOFXCHAR(IXDET,IDXXC)*VALUE
                VLUE=XCABS(IXDET,IDXXC,IXGR,IZGR,IYGR)*
     &              FYIELDOFXCHAR(IDXXC)*FRELINTOFXCHAR(IDXXC)*
     &              XDETEFFOFXCHAR(KINDX)*VALUE
                AA=DSIGN(AA,RANNUM()-0.5)
CS                ECHAR_IS=ENEROFXCHAR(IDXXC)+AA*RANNO()*
CS     &                   FWHMOFXCHAR(IXDET,IDXXC)/2.355
                ECHAR_IS=ENEROFXCHAR(IDXXC)+AA*RANNO()*
     &                   FWHMOFXCHAR(KINDX)/2.355
                IHIS=XCSHIS(IXCSHIS)
                CALL HISTOG(1,IHIS,VLUE,ECHAR_IS,0.D0,0.D0)
 265        CONTINUE
         ELSE
            WRITE(6,'(A)')'    '
            WRITE(6,'(2A)')' X-RAY PHOTON GENERATED OUTSIDE GRID!',
     &                     ' THIS PHOTON IS NOT COUNTED!'

         ENDIF
 266  CONTINUE


CHW   IONIZATION OUTPUT EVENTS
      
C      IF (NLOCOUT(6) .GT. 0) THEN
C          
C        DO 275 I=ILOCST(6),NLOCOUT(6)
C           ILOC = LOCOUT(6,I)
C           CALL F_OUTPUTTO(NXLOC(ILOC),NS)
C           CALL F_PEN(IELE+2,NS)
C	   CALL TRNXYZ(ILOC,X,Y,Z,XX,XY)
C	   CALL F_FFILLEDCIRCLE(XX,XY,4.D0,NS)
C	   CALL F_PEN(1,NS)
C275     CONTINUE         

*     UPDATE IONIZATION DISTRIBUTION HISTOGRAM
      IF (HISTOFION(ISHELN).GT.0) THEN
          VDUMMY=1./NETRN
          CALL IONVAL (
     I                 .FALSE.,1,
     D                 NSHELL,NGRIDX,NGRIDZ,NGRIDY,
     D                 XGRIDL,ZGRIDL,YGRIDL,
     D                 X_MIN,X_MAX,Z_MIN,Z_MAX,
     I                 X,Z,HISTOFION(ISHELN),VDUMMY,
     O                 VALION,NOUTGR,NOUTAR,IXGR,IZGR,
     O                 IER)
         
      ENDIF
*     UPDATE IONIZATIONS (ION) ON SCREEN
      DO 276 J=ISCROFSHELL,NSCROFSHELL(ISHELN)
        ISINDX=(ISHELN-1)*(NDMASCRN+NDMAPS)+J
        CALL CHKBND(16,ISINDX,'ONETRJ    ','SCROFSHELL')
CS        CALL DRWION(SCROFSHELL(ISHELN,J),X,Y,Z,IELE,ISHELL)
      	CALL DRWION(SCROFSHELL(ISINDX),X,Y,Z,IELE,ISHELL)
 276  CONTINUE
*     UPDATE IONIZATION DISTRIBUTIONS (HISTOGRAMS)
      DO 277 J=1,NIONHIST(ISHELN)
        ISINDX=(ISHELN-1)*NDMAHIST+J
        CALL CHKBND(18,ISINDX,'ONETRJ    ','IONHIST   ')
CS        JHIST=IONHIST(ISHELN,J)
        JHIST=IONHIST(ISINDX)
        NJDIM=NVDIM(JHIST)
        VDUMMY=1./NETRN
        IF (CVALUE(JHIST).EQ.'IOV') THEN
           CALL HISTOG(NJDIM,JHIST,VDUMMY,Z,X,Y)
        ELSE
           CALL HISTOG(NJDIM,JHIST,VDUMMY,X,Z,Y)
        ENDIF
 277  CONTINUE

      
C     DETERMINE ENERGY LOSS [DEN]
 278  CONTINUE

      UOLD = E/ENEROFSHELL(ISHELN)
      if (uold.lt.umin) uold=umin
      IU = IDNINT((UOLD-UMIN)/(USTEP))+1
      WMIN = 1.
      WMAX = FLOAT(MAXW) 
      RAND=RANNUM()*100.
C      WRITE(*,*) 'RAND',RAND
      IF (IU.EQ.1) THEN 
	 DEN=1.1*ENEROFSHELL(ISHELN)
      ELSE 
C        WRITE(*,*)'BEFORE DINTERPOL'
	 DEN =E*DINTERPOL(ENER_DELTA(1,IU),MAXW,WMIN,WMAX,RAND,IER)      
C         WRITE(*,*)'AFTER DINTERPOL'
C	 DEN = E*W
C         WRITE(*,*)'AFTER DINTERPOL'
      ENDIF   
CAP      DEN=1.1*ENEROFSHELL(ISHELN)
C      WRITE(*,*) DEN,E
C      WRITE(*,*) 'BEFORE MIN'
      DEN = MIN(DEN,E)
C      WRITE(*,*) 'AFTER MIN'
      EOLD=E
      E=MAX(E-DEN,DEN-ENEROFSHELL(ISHELN))
      DENSUM=DENSUM+(EOLD-E)

      IF (E.LE.EMIN) GOTO 1400
*CAPTEST

      E_ION=DEN-ENEROFSHELL(ISHELN)

C     DETERMINE POLAR SCATTERING ANGLE

      SINPSI=SQRT((EOLD-E)/EOLD)
      COSPSI=SQRT(E/EOLD)

C     STORE INFORMATION CONCERNING THE IONIZED ELEMENT, IONIZED SHELL 
C     AND THE LOCATION OF THE IONIZATION

C      CALL STATCS(
C     I            22,X,Y,Z,DUMMY1,DUMMY2,DUMMY3,DUMMY4,DUMMY5,DUMMY6,
C     I            XR,YR,ZR,E,FRAC,IETYP,IESUBTYP)

      GOTO 500


C PLASMON SCATTERING:
C ===================

450   CONTINUE      

      NSCATPL=NSCATPL+1

      CALL P_DELTAE(IR,E,RANNUM(),RANNUM(),DELTAE,IER)
      IF (DELTAE.GT.E) DELTAE = E
      E = E - DELTAE

CHW   CREATE SECONDARY ENTRY IN SECONDARY LIST
      IF (LSECON) THEN
	 IF (DELTAE .GT. EMIN) THEN
      	     IF (NSEC .GE. MAXSEC) THEN
      		WRITE(*,*) '*** WARNING: OVERFLOW OF SECONDARY QUEUE'
      	        GOTO 455
      	     ENDIF 
	    NSEC = NSEC + 1
      	    SEC_ETYP(NSEC) = 4
	    SEC_FRAC(NSEC) = FRAC
	    SEC_E(NSEC) = DELTAE
	    SEC_DIRX(NSEC) = 1.
	    SEC_DIRY(NSEC) = 0.
	    SEC_DIRZ(NSEC) = 0.
	    SEC_X(NSEC) = X
	    SEC_Y(NSEC) = Y
	    SEC_Z(NSEC) = Z
	    SEC_FI = 2*PI*RANNUM()
	    COSSEC_FI = COS(SEC_FI)
	    SINSEC_FI = SIN(SEC_FI)
	    COSSEC_PSI = RANNUM()*2.D0-1.D0
	    SINSEC_PSI = SQRT(1.D0-COSSEC_PSI*COSSEC_PSI) 
	    CALL NDIRA(
     V                 SEC_DIRX(NSEC),SEC_DIRY(NSEC),SEC_DIRZ(NSEC),
     I                 COSSEC_PSI,SINSEC_PSI,COSSEC_FI,SINSEC_FI    )
455         CONTINUE
	 ENDIF
      ENDIF

CHW   NOT ENOUGh ENERGY ?
      IF (E.LE.EMIN) GOTO 1400

C     NO DEFLECTION
      GOTO 700


C     DETERMINE NEW DIRECTION:
C     ------------------------

 500  CONTINUE

C     AZIMUTHAL DEFLECTION ANGLE

      IFI= IDNINT(360.D0*RANNUM())
CHW
      COSFI = COSINE(IFI)
      SINFI = SINE(IFI)

C     NEW DIRECTION

      CALL NDIRA(
     V           DIRX,DIRY,DIRZ,
     I           COSPSI,SINPSI,COSFI,SINFI)

700   CONTINUE

C     DO NEXT FLIGHT
      GOTO 200


1000  CONTINUE
******ELECTRON IS IN THE AIR REGION

      CALL IMENTR (
     I             X, Z, DIRX, DIRZ, PCOORD,
     O             INTERS, XNXT, ZNXT, IR, IER)

C     ERROR DURING POINT LOCATION ?                  
      IF (IER.NE.0) GOTO 2100

C     ELECTRON LEFT SIMULATION AREA ?      
      IF (INTERS.EQ.0 .OR. IR .EQ. -1) THEN
	 GOTO 1500
      ENDIF
 
C     ENTRY IN AIR ? (SHOULD NOT HAPPEN ! -> STOP)
      IF (IR.EQ.0) THEN 
	 WRITE (*,'(2I4,8F8.1)') IR,NSCAT,X,Z,DIRX,DIRZ,XNXT,
     &   ZNXT,XOLD,ZOLD
	 STOP
      ENDIF

 
C     ELECTRON ENTERS SPECIMEN

      IF (DIRY .NE. 0) THEN
	 IF (DIRX .NE. 0) THEN
CS	    Y = Y + (XNXT-X)/(DIRX*DIRY)
	    Y = Y + (XNXT-X)*DIRY/DIRX
	 ELSEIF (DIRZ .NE. 0) THEN
CS	    Y = Y + (ZNXT-Z)/(DIRZ*DIRY)
	    Y = Y + (ZNXT-Z)*DIRY/DIRZ
	 ENDIF
      ENDIF
	  
*     DRAW PRIMARY ELECTRON BEAM ON SCREEN IF SPECIFIED
      IF (IJENTO.NE.0) THEN
         IF (NLOCOUT(7).GT.0) THEN
            DO 1005 I=ILOCST(7),NLOCOUT(7)
               ILOC = LOCOUT(7,I)
               CALL F_OUTPUTTO(NXLOC(ILOC),NS)
               CALL TRNXYZ(ILOC,XSEB,YSEB,ZSEB,XX,ZZ)
               CALL F_MOVE(XX,ZZ,NS)
               CALL TRNXYZ(ILOC,XNXT,Y,ZNXT,XX,ZZ)
               CALL F_LINETO(XX,ZZ,NS)
1005        CONTINUE
         ENDIF
      ENDIF

CHW   SET ELECTRON STARTING POSITION IF OUTPUT OF ELECTRON TRAJECTORY DESIRED
      IF (NLOCOUT(IETYP) .GT. 0) THEN
         DO 190 I=ILOCST(IETYP),NLOCOUT(IETYP)
            ILOC = LOCOUT(IETYP,I)
            CALL F_OUTPUTTO(NXLOC(ILOC),NS)
            CALL TRNXYZ(ILOC,XNXT,Y,ZNXT,XX,XY)
cs            CALL TRNXYZ(ILOC,X,Y,Z,XX,XY)
	    CALL F_MOVE(XX,XY,NS)
190      CONTINUE
      ENDIF

      X = XNXT + DIRX*DELTA
      Z = ZNXT + DIRZ*DELTA

C     ELECTRON ENTERED SPECIMEN, GOTO MAIN LOOP

      IJENTO=0
      GOTO 200 

1400  CONTINUE
******ELECTRON HAS LOW ENERGY

*     --- FLUSH ALL OUTPUTS

      IF(LLOC) THEN
        IF (LSCRN) THEN
           KLOC=1
        ELSE
           KLOC=NSCL+1
        ENDIF
        DO 1410 ILOC=KLOC,NLOC
           CALL F_OUTPUTTO(NXLOC(ILOC),NS)
           CALL F_FSHOW(NS)
1410    CONTINUE
      ENDIF
      RETURN      

1500  CONTINUE

******ELECTRON LEFT SIMULATION AREA

*     --- FLUSH ALL OUTPUTS

      IF(LLOC) THEN
        IF (LSCRN) THEN
           KLOC=1
        ELSE
           KLOC=NSCL+1
        ENDIF
        DO 1510 ILOC=KLOC,NLOC
           CALL F_OUTPUTTO(NXLOC(ILOC),NS)
           CALL F_FSHOW(NS)
1510    CONTINUE
      ENDIF
      RETURN      

2000  CONTINUE
*****ERROR DURING POINT LOCATION
      WRITE (*,*) ' '
      WRITE (*,*) '***** ERROR: OCCURED IN IMGREG *****'
      WRITE (*,*) ' (X,Y,Z) = ',X,Y,Z
      GOTO 1500

2100  CONTINUE
*****ERROR DURING POINT LOCATION
      WRITE (*,*) ' '
      WRITE (*,*) '***** ERROR: OCCURED IN IMENTR *****'
      WRITE (*,*) ' (X,Y,Z) = ',X,Y,Z
      WRITE (*,*) ' (DIRX,DIRZ) = ',DIRX,DIRZ
      GOTO 1500

2200  CONTINUE
*****ERROR DURING POINT LOCATION
      WRITE (*,*) ' '
      WRITE (*,*) '***** ERROR: OCCURED IN INTERS *****'
      WRITE (*,*) ' (X,Y,Z) = ',X,Y,Z
      WRITE (*,*) ' (DIRX,DIRZ) = ',DIRX,DIRZ
      GOTO 1500

      END
