c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
      subroutine polyfit(x, y, n, a, aerr, ord)
      implicit none
c
      integer n, ord
      double precision x(n), y(n)
      double precision a(ord), aerr(ord)
c
      integer    MAXPTS, MAXORD
      parameter (MAXPTS = 1000, MAXORD = 10)
c
      integer ndeg, maxdeg, ierr, ll
      double precision w(MAXPTS), eps, r(MAXORD),
     1                 work(3*MAXPTS+3*MAXORD+3), c
c
c     Note: 'ord' as defined from the call from Sesame is the
c           number of coefficients in the polynomial, not the polynomial
c           order, e.g. ord=5 implies a 4th order polynomial.
c
      if( n .gt. MAXPTS .or. ord .gt. MAXORD ) then
         write(6,*)
     1      'internal error in polyfit: internal array bounds exceeded'
         return
      endif
c
c     Setting the weight(1) to -1 implies no weights to be applied
      w(1)   = -1.0D0
      maxdeg = ord - 1
      eps    = 0.0D0
      call dpolft(n, x, y, w, maxdeg, ndeg, eps, r, ierr, work)
      c      = 0.0D0
      ll     = ord - 1
      call dpcoef(ll, c, a, work)
c
      return
      end
c
      subroutine poly(x, y,n, a, ord)
      implicit none
c
      integer n, ord
      double precision x(n), y(n), a(ord)
c
      integer i, j
      double precision t, yy
c
c     Note: 'ord' as defined from the call from Sesame is the
c           number of coefficients in the polynomial, not the polynomial
c           order, e.g. ord=5 implies a 4th order polynomial.
c
      do 100 i=1,n
         t  = 1.0D0
         yy = 0.0D0
         do 200 j=1,ord
            yy = yy + a(j)*t
            t  = t*x(i)
200      continue
         y(i) = yy
100   continue
      return
      end
