c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
      FUNCTION RANNO()

***   RANNO - GENERATE A RANDOM NUMBER WHICH IS GAUSSIAN DISTRIBUTED
*             WITH MEAN VALUE 0 AND STANDARD DEVIATION 1
*
**    REMARKS
*
*     1) USES EQUIDISTRIBUTED RANDOM NUMBER GENERATOR "RANNUM"
*
**    AUTHOR: G.HOBLER  04-JAN-1988
*                       14-APR-1989
*                       16-JUL-1991
*
      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'

      LOGICAL FIRST,FIRSTG,FIRSTS
      SAVE FIRST, RANNO2
      DATA FIRST /.TRUE./

**    START OF EXECUTABLE CODE
*     ************************

      IF (FIRST) THEN
10       U1 = RANNUM()
         U2 = RANNUM()
         V1 = TWO*U1 - ONE
         V2 = TWO*U2 - ONE
         S = V1**2 + V2**2
         IF (S.GE.ONE .OR. S.EQ.ZERO) GOTO 10
         
         FAC = SQRT(-TWO*LOG(S)/S)
         RANNO = V1 * FAC
         RANNO2 = V2 * FAC
      ELSE
         RANNO = RANNO2
      ENDIF

      FIRST = .NOT. FIRST      

      RETURN

C GET STATUS OF RANNO

      ENTRY RNNGET(
     O             FIRSTG,RANNOG)

      FIRSTG=FIRST
      RANNOG=RANNO2

*     DUMMY VALUE, ONLY FOR THE STUPID COMPILERS
      RANNO=ZERO

      RETURN

C SET STATUS OF RANNO

      ENTRY RNNSET(
     I             FIRSTS,RANNOS)

      FIRST=FIRSTS
      IF (.NOT.FIRST) RANNO2=RANNOS

*     DUMMY VALUE, ONLY FOR THE STUPID COMPILERS
      RANNO=ZERO

      RETURN

      END      
