c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
      FUNCTION RANNUM()
 
***   RANNUM - PRODUCES UNIFORMLY DISTRIBUTED RANDOM NUMBERS IN THE
*              RANGE  0 < RANNUM < 1
*
**    REMARKS
*
*     1) SEED MAY BE SET USING THE ENTRY   RANSET   OR MAY BE DETERMINED 
*        USING THE ENTRY   RANGET .
*     2) USING RANSET, THE RECOMMENDED RANGE OF M, IA, IB, AND IRAND IS
*                    1000 < M < 9000
*                  20000 < IA < 90000
*                 130000 < IB < 220000
*                       IRAND < 10000. 
*        CHANGING ONLY IRAND MIGHT RESULT IN AN IDENTICAL SERIES OF
*        RANDOM NUMBERS AFTER A RELATIVELY SMALL NUMBER OF NUMBERS.
*     3) LITERATURE:
*        A.HAAS: 'THE MULTIPLE PRIME RANDOM NUMBER GENERATOR',
*        ACM TRANS. MATH. SOFTWARE, VOL.13, NO.4, PP.368-381, 1987.
*
**    AUTHOR:  G.HOBLER  XX-XXX-1988
* 
      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'

      SAVE M,IA,IB,IRAND
 
      DATA   M  ,  IA   ,   IB   , IRAND /
     1      971 , 11113 , 104322 , 4181  /
 
 
**    START OF EXECUTABLE CODE
*     ************************
 
 
      M = M+7
      IF (M.GE.9973) M = M-9871
      IA = IA+1907
      IF (IA.GE.99991) IA = IA-89989
      IB = IB+73939
      IF (IB.GE.224729) IB = IB-96233
      IRAND = MOD(IRAND*M+IA+IB,100000) / 10
      RANNUM = 10000*IRAND
 
      M = M+7
      IF (M.GE.9973) M = M-9871
      IA = IA+1907
      IF (IA.GE.99991) IA = IA-89989
      IB = IB+73939
      IF (IB.GE.224729) IB = IB-96233
      IRAND = MOD(IRAND*M+IA+IB,100000) / 10
      RANNUM = (RANNUM+IRAND+0.5) / 100000000.
 
      RETURN

**    GET THE SEED OF THE RANDOM NUMBER GENERATOR
*
      ENTRY RANGET(
     O             MG,IAG,IBG,IRANDG)
      MG = M
      IAG = IA
      IBG = IB
      IRANDG = IRAND

*     DUMMY VALUE, ONLY FOR THE STUPID COMPILERS
      RANNUM=ZERO

      RETURN

**    SET THE SEED OF THE RANDOM NUMBER GENERATOR
*
      ENTRY RANSET(
     I             MS,IAS,IBS,IRANDS)
      M = MS
      IA = IAS
      IB = IBS
      IRAND = IRANDS

*     DUMMY VALUE, ONLY FOR THE STUPID COMPILERS
      RANNUM=ZERO

      RETURN

      END
