c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
      SUBROUTINE RUNGE (
     I                  IR,ENER,FFP, 
     O                  DEE_RUNGE,IER)

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'GLOBAL.INC'

      DIMENSION FACT_K(4),DEE_RUNGE(2)
 
***   RUNGE - INTEGRATION OF STOPPING POWER FOR SINGLE SCATTERING MODEL WITH 
*             RUNGE KUTTA METHOD (PROPOSED BY HENOC, MAURICE)
* 
**    ARGUMENTS 
*     
*     IR - REGION 
*     ENER - ENERGY OF SCATTERED ELECTRON (eV)
*     FFP -  FREE PATH OF ELASTIC SCATTERED ELECTRON
*     DEE_RUNGE -  ENERGY LOSS OF ELECTRON, HALF AND FULL STEP(eV)
*     IER -  ERROR FLAG
*
**    AUTHOR: A. PFEIFFER SEP-1994
*
**    START OF EXECUTABLE CODE
*     ************************     

      YDEE=0.
      H=FFP/2.

      DO 100 I=1,2

      Y1 = ENER

         STPP=DINTERPOL(
     I                STOPPING(1,IR),MAXENER,EMIN,EMAX,Y1,
     O                IER)     
         FACT_K(1) = -STPP

         Y2 = Y1+H/2.* FACT_K(1) 

         STPP=DINTERPOL(
     I                STOPPING(1,IR),MAXENER,EMIN,EMAX,Y2,
     O                IER)
         FACT_K(2) = -STPP

         Y3 = Y1+H/2.* FACT_K(2)
         STPP=DINTERPOL(
     I                STOPPING(1,IR),MAXENER,EMIN,EMAX,Y3,
     O                IER)      
         FACT_K(3)=-STPP

         Y4 = Y1+H*FACT_K(3)
         STPP=DINTERPOL(
     I                STOPPING(1,IR),MAXENER,EMIN,EMAX,Y4,
     O                IER)
         FACT_K(4)=-STPP

         YDEE=YDEE+H/6.*(FACT_K(1)+2.*(FACT_K(2)+FACT_K(3))+FACT_K(4)) 
         DEE_RUNGE(I)=DABS(YDEE)

         Y1=ENER+YDEE
 100  CONTINUE
 
      RETURN
      END 
