c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
      SUBROUTINE INTERP_SIGMA_IOCW (
     I                            IREG,IELEM,ENER,
     O                            SIGMA_CW)

***   SUBROUTINE INTERP_SIGME_IOCW INTERPOLATES
*     CROSS FOR INNER SHELL IONIZATION
*     SUMMARIZED OVER SHELLS AND ELEMENTS 
*
**    INPUT:
*     IREG.....NUMBER OF REGION
*     IELE.....NUMBER OF ELEMENT 
*     ENER.....ENERGY OF ELECTRON
*
**    OUTPUT:
*     SIGMA_CW...INTERPOLATED CROSS FOR INNER SHELL IONIZATION
*                   CROSS SECTION SUMMARIZED OVER  ELEMENTS
*

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'GLOBAL.INC'      

**    START OF EXECUTABLE CODE:
*     *************************

      ESTEP_IO = (EMAX-EMIN)/FLOAT(MAXENER-1)

      IF (ENER.LT.EMIN) THEN
*     SOLLTE IM HAUPPROGRAMM UEBERPRUEFT WERDEN
               WRITE(*,'(A)')' ENERGY TOO LOW'
               SIGMA_CW = 0.D0
         ELSE IF(ENER.GT.EMAX) THEN
*     SOLLTE IM HAUPPROGRAMM UEBERPRUEFT WERDEN
               WRITE(*,'(A)')' ENERGY TOO HIGH'               
               SIGMA_CW = 0.D0
         ELSE

           I_ENER = INT( (ENER-EMIN)/ESTEP_IO)+1

           IF (I_ENER.EQ.MAXENER) THEN
               SIGMA_CW=SIGMA_IO_CW(IREG,IELEM,I_ENER)
             ELSE
               SIGMA_CW=SIGMA_IO_CW(IREG,IELEM,I_ENER)+
     &             ( ENER-(( I_ENER-1)*ESTEP_IO+EMIN) )/ESTEP_IO*
     &             ( SIGMA_IO_CW(IREG,IELEM,I_ENER+1)
     &               -SIGMA_IO_CW(IREG,IELEM,I_ENER) )
           ENDIF

      ENDIF

      RETURN
      END





