c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
      SUBROUTINE SLOWD(
     O                 DEE,
     I                 ENER,IR,
     I                 XB,YB,ZB,XE,YE,ZE,FFP )

***   SLOWD - COMPUTES ENERGY LOSS IN A CONTINUOUS SLOWING DOWN APPROXIMATION
*             FOR THE TIME BEING A CONSTANT COMPOSITION ALONG FFP IS ASSUMED 
*
**    ARGUMENTS
*
*     DEE    - ENERGY LOSS (eV)
*     ENER   - PARTICLE ENERGY (eV)
*     IR     - INDEX OF THE LAYER
*     XB     - X-COORDINATE OF THE BEGINNING OF THE FREE FLIGHT PATH
*     YB     - Y-COORDINATE OF THE BEGINNING OF THE FREE FLIGHT PATH
*     ZB     - Z-COORDINATE OF THE BEGINNING OF THE FREE FLIGHT PATH
*     XE     - X-COORDINATE OF THE END OF THE FREE FLIGHT PATH
*     YE     - Y-COORDINATE OF THE END OF THE FREE FLIGHT PATH
*     ZE     - Z-COORDINATE OF THE END OF THE FREE FLIGHT PATH
*     FFP    - FREE FLIGHT PATH ()
*
**    AUTHOR:  Christian Schiebl
*              CEC-Vienna
*              23-JUN-94
*
      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'GLOBAL.INC'

*     MAXIMUM PORTION OF ENERGY LOSS COMPARED TO ENERGY IN %
      PARAMETER (EDELTM=5)
*     MAXIMUM NUMBER OF STEPS FOR THE CALCULATION OF THE ENERGY LOSS
      PARAMETER (MAXSTP=20)

**    START OF EXECUTABLE CODE
*     ************************

*     CALCULATE ENERGY LOSS FOR WHOLE FFP AT ENERGY=ENER
CAP      CALL ?????? (IR,ENER,STPP)
CAP stpp nicht tabelliert!!!!!!!!!!!
*      CALL STOPM1(IR,ENER,STPP)
CAP
       STPP=DINTERPOL(
     I                STOPPING(1,IR),MAXENER,EMIN,EMAX,ENER,
     O                IER) 
CAP
      DEE=FFP*STPP

cs    no path to this statement (full block commented out by "cs")
cs      IF (1 .GT. 2) THEN
csCHW      EN wird in manchen faellen negativ !!! Fehler
csCHW      IF (100*DEE/ENER.GT.EDELTM) THEN
cs         NSTEP=INT(100*DEE/ENER/EDELTM)+1
cs         NSTEP=MIN(NSTEP,MAXSTP)
cs         DEE=0
cs         EN=ENER
cs         DELFFP=FFP/NSTEP
cs         DO 10 ISTEP=1,NSTEP
csCAP            CALL ?????? (IR,EN,STPP)
csCAP               CALL STOPM1(IR,EN,STPP)
cs               STPP=DINTERPOL(
cs     I                STOPPING(1,IR),MAXENER,EMIN,EMAX,EN,
cs     O                IER)
cs            DELTE=DELFFP*STPP
cs            EN=EN-DELTE
cs            DEE=DEE+DELTE
cs 10      CONTINUE
cs      ENDIF            

      RETURN
      END

