c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
      SUBROUTINE STOPM1(
     I                  IREG,ENER,
     O                  STPP      )

***   STOPM1 - STOPPING POWER FOR THE HYBRID MODEL M1
*	       HYBRID MODEL: CONTINUOUS SLOWING DOWN FOR VALENCE ELECTRON
*			     SCATTERING; EXPLICIT CALCULATION OF ELASTIC
*			     SCATTERING AND OF INNER SHELL IONIZATION
*
*     THE STOPPING POWER USED IN THIS MODEL IS THE DIFFERENCE IN THE
*     STOPPING POWER OF BETHE (TOTAL) AND GRYZINSKI (INNER SHELL IONIZATION).
*     FOR ENERGIES < 6.338 OF THE MEAN IONIZATION POTENTIAL THE STOPPING
*     POWER OF RAO-SAHIB AND WITTRY (1974) IS USED INSTEAD OF THAT OF BETHE.
*
**    ARGUMENTS
*
*     IREG   - REGION NUMBER
*     ENER   - ELECTRON ENERGY
*     STPP   - STOPPING POWER [eV/] FOR ENERGY=ENER AND REGION=IREG
*
**    AUTHOR:  C. SCHIEBL  15-JUN-1994
*
      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'GLOBAL.INC'

**    START OF EXECUTABLE CODE
*     ************************

      DENS=DENSITY(IREG)
      STPBTH=0
      STPGRY=0
C     FOR EACH ELEMENT (1-NELE(IREG))
      DO 40 IELE=1,NELE(IREG)
C        CALCULATE BETHE STOPPING POWER
         STPB=0
	 CALL STBETH (ATNUM(ELEM(IREG,IELE)),
     &                ATMASS(ELEM(IREG,IELE)),DENS,ENER,STPB)
         STPB=STPB*WEIGHTFRAC(IREG,IELE)
         STPBTH=STPBTH+STPB
C        CALCULATE GRYZINSKI STOPPING POWER
C        FOR EACH SHELL (1-NSHELL)
         STPG=0
	 DO 20 ISHELL=1,NSHELL
	    IF ((EEDGE(ELEM(IREG,IELE),ISHELL).LT.ENER).AND.
     &          (EEDGE(ELEM(IREG,IELE),ISHELL).GT.0))THEN
	       STP=0
               CALL STGRYZ (E_SHELL(ISHELL),ATDENS(IREG,IELE),
     1                      ENER,EEDGE(ELEM(IREG,IELE),ISHELL),
     2                      STP)
               STPG=STPG+STP
            ENDIF
20      CONTINUE
CHW        STPG=STPG*WEIGHTFRAC(IREG,IELE)
         STPGRY=STPGRY+STPG
40    CONTINUE
      STPP=STPBTH-STPGRY

      RETURN
      END

