c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
      SUBROUTINE WRGEOM (
     D                   NR, NPTS,
     I                   PCOORD, ILINES, IENDIX, XSCALE)

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'FILE.INC'

***   WRGEO - WRITES THE GEOMETRY TO THE OUTPUT FILE.
*
**    ARGUMENTS
*
*        NR     - NUMBER OF FACES
*        NPTS   - NUMBER OF POINTS
*        PCOORD - COORDINATES OF THE POINTS
*        ILINES - INDICES OF THE FACES
*        IENDIX - ENDINDICES OF THE LINES
*        XSCALE - A QUARTER UNIT CELL EDGE OF SILICON DIAMOND LATTICE
*
**    REMARKS:
*
*        NOTE: THE MAXIMUM NUMBER OF LINES, WHICH CAN BE DEFINED OVER
*              NPTM POINTS IS 3*NPTM-6, IF THE LINES DO NOT INTERSECT
*              ONE ANOTHER! THEREFORE WE DO NOT NEED A SEPARATE LIMIT
*              FOR THE LINE INDEX ARRAY (ILINES).
*
**    AUTHOR:  H.STIPPEL   24-FEB-1994
*
      DIMENSION PCOORD(2*NPTS), ILINES(3*NPTS-6), IENDIX(NR)

**    START OF EXECUTABLE CODE
*     ************************

      WRITE (NFOUT,'(A)')'         '
      WRITE (NFOUT,'(T5,''GEOMETRY DEFINITION:'')')
      WRITE (NFOUT,'(T10,''NPTS='',I4)') NPTS
      DO 10 IPTS = 1, NPTS
         WRITE (NFOUT,'(T10,2F20.10)')
     1        PCOORD(2*IPTS-1)*XSCALE, PCOORD(2*IPTS)*XSCALE
 10   CONTINUE

      IBEGIN = 1
      DO 20 IR = 1, NR
CS         WRITE (NFOUT,'(T10,''NUMBER OF LINES FOR FACE ''
CS     1        ,I2,'' ='',I4)')IR, IENDIX(IR)-IBEGIN+1
         WRITE (NFOUT,'(T10,A,I2,A,I4)')'NUMBER OF LINES FOR FACE ',
     &          IR,' =',IENDIX(IR)-IBEGIN+1
         WRITE (NFOUT,'(T10,10I4)')
     1         (ILINES(IP), IP=IBEGIN,IENDIX(IR))
         IBEGIN = IENDIX(IR) + 1
 20   CONTINUE

      RETURN
      END
