c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
*last modification: CS 27-Nov-1996

      SUBROUTINE WRHIST (JJ,IXDET)

*     WRHIST - WRITES ALL HISTOGRAM FILES
*
*     ARGUMENTS:
*
*       JJ    - INDEX OF HISTOGRAM WHICH SHOULD BE WRITTEN TO AN ASCII FILE
*       IXDET - X-RAY DETECTOR NUMBER
*
*     REMARKS
*
*     1) NO REMARKS PRESENTLY
*
*     AUTHOR:  C.SCHIEBL   NOVEMBER 1994

      INCLUDE 'TYPE.INC'
      INCLUDE 'FILE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'GLOBAL.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'HIST.INC'
      INCLUDE 'OUTPUT.INC'

      CHARACTER*20 XDATE
      CHARACTER*15 XNODE

**    START OF EXECUTABLE CODE
*     ************************

       PARAMETER (NORD=5)

       DOUBLE PRECISION XVAL(400),YVAL(400)
       DOUBLE PRECISION A(NORD),AERR(NORD)

      IF (JJ.GT.NHIST) THEN
         WRITE(6,'(A)')'     '
         WRITE(6,'(A)')' %%% WARNING %%%'
         WRITE(6,'(2A,I3)')' COULD NOT WRITE A HISTOGRAM FILE FOR',
     &                     ' HISTOGRAM INDEX',JJ
         WRITE(6,'(A)')' INDEX GREATER THAN NHIST'
      ENDIF
*     CALCULATE BACKSCATTERING AND TRANSMISSION COEFFICIENT
      TRNCOEFF=DBLE(NTRAN)/DBLE(NETRN)
      BCKCOEFF=DBLE(NBACK)/DBLE(NETRN)
*     ---OPEN FILE
      OPEN (NHIS,FILE=CHFILE(JJ),FORM='FORMATTED',STATUS='UNKNOWN',
     &      CARRIAGECONTROL='LIST',ERR=990)
*     DETERMINE NODE AND DATE
      XNODE='               '
      CALL ZZZNOD (XNODE)
      XDATE='                    '
      CALL ZZZDAT (XDATE)
*     ---WRITE TO FILE
      WRITE (NHIS,'(2A)')'# **** SeSAME *** '
      WRITE (NHIS,'(2A)')'# SIMULATION EXECUTED ON NODE: ',XNODE
      WRITE (NHIS,'(2A)')'# OUTPUT WRITTEN AT: ',XDATE
      WRITE (NHIS,'(2A)')'# NAME OF INPUT DECK: ',
     &                      INFILE(1:IEND(INFILE))
      WRITE (NHIS,'(3A)')'# * ',CUSTXT(1:IEND(CUSTXT)),' *'
      WRITE (NHIS,'(2A,I10)')'# NUMBER OF TOTAL PRIMARY ',
     &                       'ELECTRONS:  ',NETRN
      WRITE (NHIS,'(2A,I10)')'# NUMBER OF BACKSCATTERED ',
     &                       'ELECTRONS:  ',NBACK
      WRITE (NHIS,'(2A,I10)')'# NUMBER OF TRANSMITTED ',
     &                       'ELECTRONS:    ',NTRAN
      WRITE (NHIS,'(2A,F10.6)')'# BACKSCATTERING COEFFICIENT:',
     &                         '         ',BCKCOEFF
      WRITE (NHIS,'(2A,F10.6)')'# TRANSMISSION COEFFICIENT:  ',
     &                         '         ',TRNCOEFF
      IF (CVALUE(JJ)(1:3).EQ.'TEB') THEN
         CALL HISEVA(
     .               JJ,DBLE(NTRAN),9.0D-1,
     .               IDMY,VDMY,XDMY,YDMY,ZDMY,
     .               BPORL,BPORR,SUMREL,IPFLAG)
         IF (IPFLAG.GT.0) THEN
         WRITE (NHIS,'(2A,F10.1,A)')'# BEAM SIZE OF TRANSMITTED EL',
     &                       'ECTRONS: > ',BPORR-BPORL,' ANGSTROM'
         ELSE
         WRITE (NHIS,'(2A,F10.1,A)')'# BEAM SIZE OF TRANSMITTED EL',
     &                       'ECTRONS: ',BPORR-BPORL,' ANGSTROM'
         ENDIF
         IF ((EBTILT.GT.-5).AND.(EBTILT.LT.5)) THEN
            BEAMREF=XESPOT
         ELSE
            BEAMREF=XDMY
         ENDIF
      ENDIF
      IOFF=IVBEG(JJ)-1
      XKA=VALMIN(JJ,3)
      XJA=VALMIN(JJ,2)
      XIA=VALMIN(JJ,1)
      XKD=VDELT(JJ,3)
      XJD=VDELT(JJ,2)
      XID=VDELT(JJ,1)
      NK=NVAL(JJ,3)
      NJ=NVAL(JJ,2)
      NI=NVAL(JJ,1)
      WRITE(NHIS,'(A,3I10)')'# INTERVALS PER AXIS: ',NI,NJ,NK

      IF (CVALUE(JJ) .EQ. 'AES') THEN

*       GET HISTOGRAM DATA

        IHISBK=BCKHIS(HISEDT(JJ))
        N = NI
        NBEG = IOFF
        NBK = NVAL(IHISBK,1)
        NBEGBK = IVBEG(IHISBK)-1
        DEBK = (VALMAX(IHISBK,1)-VALMIN(IHISBK,1))/DBLE(NBK)
        DE   = (VALMAX(JJ,1)-VALMIN(JJ,1))/DBLE(N)

        IF (N .GT. 400 .OR. NBK .GT. 400) THEN
          WRITE(*,*) 'DRWSPE: ******* WARNING HISTOGRAM # ',JJ
          WRITE(*,*) 'MAX. NUMBER OF DATA POINTS EXCEEDED'
          WRITE(*,*) 'SPECTRUM NOT WRITTEN.'
          GOTO 490
        ENDIF
    

*       CALCULATE ENERGY VALUES OF BACKGROUND

        DO 50,I=1,NBK
         XVAL(I)=DEBK*(DBLE(I)-.5)+VALMIN(IHISBK,1)
50      CONTINUE

*       FIT POLYNOMIAL OF ORDER <NORD>

        NVH=NBEGBK+NBK
        CALL CHKBND(8,NVH,'WRHIST','VALHIS')
        CALL POLYFIT(XVAL,VALHIS(NBEGBK+1),NBK,A,AERR,NORD)

*       CALCULATE ENERGY VALUES OF SIGNAL

        DO 60,I=1,N
         XVAL(I)=DE*(DBLE(I)-.5)+VALMIN(JJ,1)
60      CONTINUE

*       CALCULATE FITTED BACKGROUND

        CALL POLY(XVAL,YVAL,N,A,NORD)

*       ADD SIGNAL TO BACKGROUND

        NVH=NBEG+N
        CALL CHKBND(8,NVH,'WRHIST','VALHIS')
        DO 70,I=1,N
         YVAL(I) = YVAL(I)/DEBK + VALHIS(NBEG+I)/DE
70      CONTINUE

        WRITE(NHIS,'(2A)')'#        ENERGY     ',
     &                        '    # OF ELECTRONS'
        DO 71,I=1,N
            WRITE(NHIS,'(F16.6,F18.8)')XVAL(I),YVAL(I)
71      CONTINUE

        GOTO 490
      ENDIF

      NVH=NI+IOFF
      CALL CHKBND(8,NVH,'WRHIST','VALHIS')
      IF (NVDIM(JJ).EQ.1) THEN
         IF (LENGY(JJ,1)) THEN
            IF ((CVALUE(JJ)(1:3).EQ.'XCS').OR.
     &          (CVALUE(JJ)(1:3).EQ.'XKS').OR.
     &          (CVALUE(JJ)(1:3).EQ.'XRS')) THEN
               WRITE(NHIS,'(A,F27.6,A)')'# ENERGY PER CHANNEL:',
     &                                  VDELT(JJ,1),' eV'
               WRITE(NHIS,'(2A)')'#        ENERGY     ',
     &                           ' X-ray Counts     Channel'
               DO 301 I=1,NI
                  XI=XIA+(DBLE(I)-0.5)*XID
                  VAL=VALHIS(I+IOFF)*6.24219725D9*CURRENT*
     &                DSOLIDA(IXDET)*MTIME/DBLE(NETRN)
CS                  WRITE(NHIS,'(I5,F16.6,E18.8)')I,XI,VAL
                  WRITE(NHIS,'(F16.6,E18.8,I8)')XI,VAL,I
 301           CONTINUE
            ELSE
               WRITE(NHIS,'(2A)')'#        ENERGY     ',
     &                           '    ELECTRONS/e(in)/eV'
               DO 302 I=1,NI
                  XI=XIA+(DBLE(I)-0.5)*XID
                  VAL=VALHIS(I+IOFF)/DBLE(NETRN)/VDELT(JJ,1)
CS                  WRITE(NHIS,'(I5,F16.6,E18.8)')I,XI,VAL
                  WRITE(NHIS,'(F16.6,E18.8)')XI,VAL
 302           CONTINUE
            ENDIF
         ELSE IF (LAZIMU(JJ,1)) THEN
            WRITE(NHIS,'(2A)')'#   AZIMUTHAL ANGLE ',
     &                        '    ELECTRONS/e(in)/deg'
            DO 304 I=1,NI
               XI=XIA+(DBLE(I)-0.5)*XID
               VAL=VALHIS(I+IOFF)/DBLE(NETRN)/VDELT(JJ,1)
CS               WRITE(NHIS,'(I5,F16.6,E18.8)')I,XI,VAL
               WRITE(NHIS,'(F16.6,E18.8)')XI,VAL
 304        CONTINUE
         ELSE IF (LPOLAR(JJ,1)) THEN
            WRITE(NHIS,'(2A)')'#   POLAR ANGLE     ',
     &                        '    ELECTRONS/e(in)/deg'
            DO 306 I=1,NI
               XI=XIA+(DBLE(I)-0.5)*XID
               VAL=VALHIS(I+IOFF)/DBLE(NETRN)/VDELT(JJ,1)
CS               WRITE(NHIS,'(I5,F16.6,E18.8)')I,XI,VAL
               WRITE(NHIS,'(F16.6,E18.8)')XI,VAL
 306        CONTINUE
         ELSE
            IF (CVALUE(JJ)(3:3).EQ.'Y') THEN
               IF (CVALUE(JJ)(1:1).EQ.'X') THEN
                  WRITE(NHIS,'(2A)')'#          X        ',
     &                           '       X-rays/e(in)/sr'
               ELSE
                  WRITE(NHIS,'(2A)')'#          X        ',
     &                           '       ELECTRONS/e(in)'
               ENDIF
               DO 307 I=1,NI
                  VAL=VALHIS(I+IOFF)/DBLE(NETRN)
                  XI=XIA+(DBLE(I)-0.5)*XID
                  WRITE(NHIS,'(F16.6,E18.8)')XI,VAL
 307           CONTINUE
            ELSE IF (CVALUE(JJ)(1:3).EQ.'TEB') THEN
               WRITE(NHIS,'(2A)')'#          R        ',
     &                           '       ELECTRONS/e(in)/Ang.'
               DO 308 I=1,NI
                  XHPOS=VALMIN(JJ,1)+(I-0.5)*VDELT(JJ,1)
                  IF (XHPOS.LT.BEAMREF) THEN
                     XHDELT=BEAMREF-XHPOS
                     IF (XHDELT.LT.(0.5*VDELT(JJ,1))) THEN
                        VAL=VALHIS(I+IOFF)*((0.5*VDELT(JJ,1)+XHDELT)/
     &                      VDELT(JJ,1))/((0.5*VDELT(JJ,1)+XHDELT)**2
     &                      *2*PI)+
     &                      VALHIS(I+IOFF)*((0.5*VDELT(JJ,1)-XHDELT)/
     &                      VDELT(JJ,1))/((0.5*VDELT(JJ,1)-XHDELT)**2
     &                      *2*PI)
                        VAL=VAL/DBLE(NETRN)
                     ELSE
                        R1=BEAMREF-XHPOS+0.5*VDELT(JJ,1)
                        R2=R1-VDELT(JJ,1)
                        VAL=VALHIS(I+IOFF)/(2*PI*(R1**2-R2**2))
                        VAL=VAL/DBLE(NETRN)
                     ENDIF
                  ELSE
                     XHDELT=XHPOS-BEAMREF
                     IF (XHDELT.LT.(0.5*VDELT(JJ,1))) THEN
                        VAL=VALHIS(I+IOFF)*((0.5*VDELT(JJ,1)+XHDELT)/
     &                      VDELT(JJ,1))/((0.5*VDELT(JJ,1)+XHDELT)**2
     &                      *2*PI)+
     &                      VALHIS(I+IOFF)*((0.5*VDELT(JJ,1)-XHDELT)/
     &                      VDELT(JJ,1))/((0.5*VDELT(JJ,1)-XHDELT)**2
     &                      *2*PI)
                        VAL=VAL/DBLE(NETRN)
                     ELSE
                        R1=XHPOS-BEAMREF+0.5*VDELT(JJ,1)
                        R2=R1-VDELT(JJ,1)
                        VAL=VALHIS(I+IOFF)/(2*PI*(R1**2-R2**2))
                        VAL=VAL/DBLE(NETRN)
                     ENDIF
                  ENDIF
                  XI=XIA+(DBLE(I)-0.5)*XID
                  WRITE(NHIS,'(F16.6,E18.8)')XI,VAL
 308           CONTINUE
            ELSE
               WRITE(NHIS,'(2A)')'#          X        ',
     &                        '       F(X)/e(in)/his_int_length'
               DO 309 I=1,NI
                  VAL=VALHIS(I+IOFF)/DBLE(NETRN)/VDELT(JJ,1)
                  XI=XIA+(DBLE(I)-0.5)*XID
CS                  WRITE(NHIS,'(I5,F16.6,E18.8)')I,XI,VAL
                  WRITE(NHIS,'(F16.6,E18.8)')XI,VAL
 309           CONTINUE
            ENDIF
         ENDIF
      ELSE IF (NVDIM(JJ).EQ.2) THEN
         IF (LAZIMU(JJ,1)) THEN
            WRITE(NHIS,'(2A)')'#      AZIMUTHAL           POLAR   ',
     &                        '         ELECTRONS/e(in)/deg'
         ELSE
            WRITE(NHIS,'(2A)')'#         X                  Z     ',
     &                        '           F(X,Z)/e(in)/his_int_length'
         ENDIF
         NVH=NJ*NI
         CALL CHKBND(8,NVH,'WRHIST','VALHIS')
         DO 350 J=1,NJ
            XJ=XJA+(DBLE(J)-0.5)*XJD
            DO 320 I=1,NI
               XI=XIA+(DBLE(I)-0.5)*XID
               INDX=(J-1)*NI+I
               VAL=VALHIS(INDX+IOFF)/DBLE(NETRN)/VDELT(JJ,1)/VDELT(JJ,2)
CS               WRITE(NHIS,'(I5,2F16.6,E18.8)')INDX,XI,XJ,VAL
               WRITE(NHIS,'(2F16.6,E18.8)')XI,XJ,VAL
 320        CONTINUE
 350     CONTINUE
      ELSE IF (NVDIM(JJ).EQ.3) THEN
         IF (LAZIMU(JJ,2)) THEN
            WRITE(NHIS,'(2A)')'#       ENERGY         AZIMUTHAL   ',
     &        '        POLAR       ELECTRONS/e(in)/eV/deg'
         ELSE
            WRITE(NHIS,'(2A)')'#         X               Z       ',
     &        '           Y      F(X,Z,Y)/e(in)/his_int_length'
         ENDIF
         NVH=NK*NJ*NI
         CALL CHKBND(8,NVH,'WRHIST','VALHIS')
         DO 480 K=1,NK
            XK=XKA+(DBLE(K)-0.5)*XKD
            DO 450 J=1,NJ
               XJ=XJA+(DBLE(J)-0.5)*XJD
               DO 420 I=1,NI
                  XI=XIA+(DBLE(I)-0.5)*XID
                  INDX=(K-1)*NJ*NI+(J-1)*NI+I
                  VAL=VALHIS(INDX+IOFF)
CS                  WRITE(NHIS,'(I5,3F16.6,E18.8)')INDX,XI,XJ,XK,VAL
                  WRITE(NHIS,'(3F16.6,E18.8)')XI,XJ,XK,VAL
 420           CONTINUE
 450        CONTINUE
 480     CONTINUE
      ENDIF
 
 490  CONTINUE
*     ---CLOSE FILE
      CLOSE (NHIS)

 990  RETURN
      END
