c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
* last modification: CS 15-Apr-1997 
      
      SUBROUTINE WROUT(
     I                  MODE,IETRN)

***   OPENS OUTPUT FILE 'OUT' AND WRITES THE HEADER
*
**    ARGUMENTS
*
*     MODE   - MODE=1: START OF PROGRAM
*              MODE=2: WRITE THE CONTENTS OF THE COMMON BLOCKS TO THE 
*                      OUTPUT FILE
*              MODE=3: END OF PROGRAM
*              MODE=4: REPORT BACKUP
*              MODE=5: READ FROM BACKUP FILE
*     IETRN  - NUMBER OF SIMULATED ELECTRONS
*
**    AUTHOR:  C.SCHIEBL 20-OCT-1994
*
      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'GLOBAL.INC'
      INCLUDE 'FILE.INC'
      INCLUDE 'HIST.INC'
      INCLUDE 'OUTPUT.INC'
      INCLUDE 'DMA.INC'

      CHARACTER*80 BUFFER
      CHARACTER*20 XDATE
      CHARACTER*15 XNODE
      CHARACTER*80 LINE
      CHARACTER*5  CDUMMY(2)

      DATA CDUMMY / 'FALSE','TRUE ' /

      SAVE TIMBEG

**    START OF EXECUTABLE CODE
*     ************************

      GOTO (100,200,300,400,500) MODE
4     STOP 'SUSPECT MODE IN WROUT'
      
C START OF PROGRAM
C ----------------

100   CONTINUE

*     ---START TIME
CHS      TIMBEG=ZZZSEC()
      CALL ZZZSEC (TIMBEG)
*     ---OPEN THE OUTPUT FILE
      OPEN (NFOUT,FILE=OUTFILE,FORM='FORMATTED',STATUS='UNKNOWN',
     .         CARRIAGECONTROL='LIST',ERR=990)
*     ---WRITE SYSTEM INFORMATION TO THE OUTPUT FILE
      XNODE='               '
      CALL ZZZNOD (XNODE)
      XDATE='                    '
      CALL ZZZDAT (XDATE)
cs      WRITE (NFOUT,'(T2,''SIMULATION'',T24,''EXECUTED ON '',
cs     1       A15,T58,A20)')XNODE,XDATE
      WRITE (NFOUT,'(T2,A,T24,A,A15,T58,A20)')'SIMULATION',
     &       'EXECUTED ON ',XNODE,XDATE
      WRITE (NFOUT,'('' '')')
*     ---COPY HEADER OF THE INPUT FILE TO THE OUTPUT FILE
      OPEN (NFINP,FILE=INFILE(1:IEND(INFILE)),
     .         STATUS='OLD',FORM='FORMATTED',ERR=980)
110   READ (NFINP,'(A)',END=190) LINE
      IF (LINE(2:2).EQ.'&' .OR. LINE(2:2).EQ.'$') GOTO 190
      WRITE (NFOUT,'(T2,A79)') LINE      
      GOTO 110
190   WRITE (NFOUT,'('' '')')
      CLOSE (NFINP)

      RETURN

C WRITE CONTENTS OF COMMON BLOCKS TO THE OUTPUT FILE
C --------------------------------------------------

200   CONTINUE

      WRITE(NFOUT,'(A)')'     ' 
      WRITE(NFOUT,'(2A)')' NAME OF INPUT DECK: ',
     &                     INFILE(1:IEND(INFILE))
      
*     ---INIT
      WRITE(NFOUT,'(A)')'     '
      WRITE(NFOUT,'(A)')' INITIALIZATION [&INIT]:'
      WRITE(NFOUT,'(2A)')' CUSTXT=',CUSTXT
      WRITE(NFOUT,'(2A)')' JOB   =',JOB
      WRITE(NFOUT,'(2A)')' USEBK =',USEBK
      WRITE(NFOUT,'(2A)')' FINSTR=',FINSTR
      WRITE(NFOUT,'(2A)')' FDETCT=',FDETCT
      WRITE(NFOUT,'(2A)')' FMYDEF=',FMYDEF
      WRITE(NFOUT,'(2A)')' TECHQU=',TECHQU
      WRITE(NFOUT,'(2A)')' SIGNAL=',SIGNAL(1)

*     ---ETRNS
      WRITE(NFOUT,'(A)')'    ' 
      WRITE(NFOUT,'(A)')' ELECTRONS [&ETRNS]:'
      WRITE(NFOUT,'(A,I10)')' NETRN=',NETRN
      WRITE(NFOUT,'(A,F12.6,A)')' E0    =',E0/1000,' keV'
      WRITE(NFOUT,'(A,F12.6,A)')' EF    =',EF,' eV'

*     ---EBEAM
      WRITE(NFOUT,'(A)')'     '
      WRITE(NFOUT,'(A)')' ELECTRON BEAM [&EBEAM]:' 
      INDX=1
      IF (SCAN) INDX=2
      WRITE(NFOUT,'(2A)')' SCAN   =    ',CDUMMY(INDX)
      WRITE(NFOUT,'(A,F12.6,A)')' ESTD   =',ESTD,' eV'
      WRITE(NFOUT,'(A,F12.6,A)')' DIVERG =',DIVERG,' deg'
      WRITE(NFOUT,'(A,F12.6,A)')' SPSIZE =',SPSIZE,' '
	 
*     ---TARGET
      WRITE(NFOUT,'(A)')'    ' 
      WRITE(NFOUT,'(A)')' TARGET [&TARGET]:'
      WRITE(NFOUT,'(2A)')' GEOMETRY FILE NAME: ',
     &                     CGFILE(1:IEND(CGFILE))
      WRITE(NFOUT,'(A,I5)')' MAX# OF ELEMENTS (N2M):',N2M
      WRITE(NFOUT,'(A,I5)')' # OF ELEMENTS (N2):    ',N2
      WRITE(NFOUT,'(A,I5)')' MAX# OF REGIONS (NRM): ',NRM 
      WRITE(NFOUT,'(A,I5)')' # OF REGIONS (NR):     ',NR
      WRITE(NFOUT,'(A,I5)')' MAX# OF POINTS:        ',NPTM
      DO 210 I=1,N2
	 WRITE(NFOUT,'(A,I3,A,I3)')' ELEMENT',I,': ANUM=',INT(Z2(I))
 210  CONTINUE
      WRITE(NFOUT,'(A)')' REGIONS:'      
      DO 230 I=1,NR
	 WRITE(NFOUT,'(A,I3)')'  REGION ',I
         WRITE(NFOUT,'(A,F12.6,A)')'  DENSITY (DENS): ',DENS(I),
     &                             ' g/cm3' 
	 WRITE(NFOUT,'(A)')'  ATOMIC FRACTION(S):'
	 DO 220 J=1,N2
	    WRITE(NFOUT,'(A,I2,A,F12.6)')'     ELEMENT ',J,': ',
     &                                         PROB(J,I)
 220     CONTINUE
	 WRITE(NFOUT,'(A)')'  WEIGHT FRACTION(S):'
	 DO 221 J=1,N2
	    WRITE(NFOUT,'(A,I2,A,F12.6)')'     ELEMENT ',J,': ',
     &                                         WEIGHTFRAC(I,J)
 221     CONTINUE
 230  CONTINUE

*     ---MODEL      
      WRITE(NFOUT,'(A)')'    ' 
      WRITE(NFOUT,'(A)')' MODEL [&MODEL]:' 
      WRITE(NFOUT,'(3A)')' IONIZATION CROSS SECTION USED FOR',
     &                   ' SINGLE SCATTERING MODEL: ',IONCRS
      WRITE(NFOUT,'(2A)')' BREMSSTRAHLUNG CROSS SECTION USED: ',
     &                     IONCRS
      WRITE(NFOUT,'(3A)')' STOPPING POWER USED FOR HYBRID AND',
     &                   ' SINGLE SCATTERING MODEL: ',STOPP
      WRITE(NFOUT,'(2A)')' FAUGER = ',FAUGER(1:IEND(FAUGER))
      DO 240 I=1,NR
	 WRITE(NFOUT,'(A,I3)')'  REGION ',I
	 WRITE(NFOUT,'(2A)')'  NAME OF PLASMON DATA FILE: ',
     &                         FMAT(I)(1:IEND(FMAT(I)))
	 WRITE(NFOUT,'(A,I3,2A)')' MODEL IN REGION',I,':   ',
     &                             MODR(I)
 240  CONTINUE
CS      DO 242 I=1,N2
CS	 WRITE(NFOUT,'(A,I3,A,I4)')' SHELL FOR ELEMENT',I,': ',
CS     &                               SHELL(1,I)
CS 242  CONTINUE
      DO 244 I=1,MAXELE
         IF (ION(I)(1:3).NE.'   ')
     &      WRITE(NFOUT,'(A,I2,2A)')' ION(',I,')   = ',
     &                                ION(I)(1:IEND(ION(I)))
 244  CONTINUE
      DO 246 I=1,MAXELE
         IF (XCHAR(I)(1:3).NE.'   ')
     &      WRITE(NFOUT,'(A,I2,2A)')' XCHAR(',I,') = ',
     &                                XCHAR(I)(1:IEND(XCHAR(I)))
 246  CONTINUE

*     ---MEASUREMENT SETUP
      WRITE(NFOUT,'(A)')'    '
      WRITE(NFOUT,'(A)')' MEASUREMENT SETUP [&MSETUP]:'
      WRITE(NFOUT,'(A,F13.2,A)')'   MTIME   = ',MTIME,' sec'
      WRITE(NFOUT,'(A,F13.6,A)')'   CURRENT =     ',CURRENT,' nA'
      WRITE(NFOUT,'(A)')' ANGLES (deg):'
      WRITE(NFOUT,'(A,F13.6)')'   EBTILT = ',EBTILT
      WRITE(NFOUT,'(A,F13.6)')'   EBROT  = ',EBROT
      DO 252 I=0,NXDET
         WRITE(NFOUT,'(A,I2,A,F13.6)')'   TAKOFF(',I,') = ',DTAKOFF(I)
         WRITE(NFOUT,'(A,I2,A,F13.6)')'   XDEROT(',I,') = ',DXDEROT(I)
 252  CONTINUE
      WRITE(NFOUT,'(A,F15.3)')' MAGNI  = ',MAGNI
      WRITE(NFOUT,'(A,F15.6,2A)')' XESPOT = ',XESPOT/DUNITS,
     &                           ' ',CUNITS
      WRITE(NFOUT,'(A,F15.6,2A)')' XRANGE = ',XRANGE/DUNITS,
     &                           ' ',CUNITS

*     ---INSTRUMENT
      WRITE(NFOUT,'(A)')'    '
      WRITE(NFOUT,'(A)')' INSTRUMENT [&INSTR]:'
      WRITE(NFOUT,'(A,I12)')' NLSCP  = ',NLSCP
      WRITE(NFOUT,'(A,F12.6,A)')' XPCRT  = ',XPCRT/1E7,' mm'

*     ---DETECTOR
      WRITE(NFOUT,'(A)')'    '
      WRITE(NFOUT,'(A)')' DETECTOR [&DETECT]:'
      DO 262 K=0,NXDET
        WRITE(NFOUT,'(A,I2,A)')' X-RAY DETECTOR ',K,' :'
        WRITE(NFOUT,'(A,I2,2A)')' XFDEFF(',K,') = ',
     &                            DXFDEFF(K)(1:IEND(DXFDEFF(K)))
        WRITE(NFOUT,'(A,I2,2A)')' XDTYPE(',K,') = ',
     &                            DXDTYPE(K)(1:IEND(DXDTYPE(K)))
        WRITE(NFOUT,'(A,I2,A,F13.6)')' SOLIDA(',K,') = ',
     &                            DSOLIDA(K)
        WRITE(NFOUT,'(A,I2,A,F13.6)')' FWHM(',K,') =   ',
     &                            DFWHM(K)
        WRITE(NFOUT,'(A,I2,A,F13.6)')' ENFWHM(',K,') = ',
     &                            DENFWHM(K)
        DO 260 I=1,NDLAY(K)
 	  WRITE(NFOUT,'(A,I2,A,F12.6)')' LAYER ',I,' : XLAYTH = ',
     &                              XLAYTH(K,I)
	  WRITE(NFOUT,'(A,I2,A,F12.6)')' LAYER ',I,' : XLAYDN = ',
     &                              XLAYDN(K,I)
	  WRITE(NFOUT,'(A,I2,2A)')' LAYER ',I,' : XLAYMAT = ',
     &                              XLAYMAT(K,I)(1:IEND(XLAYMAT(K,I)))
          DO 258 J=1,NXLAYMAT(K,I)
	  WRITE(NFOUT,'(A,I2,A)')' LAYER ',I,': '
          WRITE(NFOUT,'(A,I2,A,F12.6)')'   ELEMENT ',J,': XLAYAF= ',
     &                                     XLAYAF(K,I,J)
 258      CONTINUE
 260    CONTINUE
 262  CONTINUE

*     ---OUTPUT
      WRITE(NFOUT,'(A)')'    '
      WRITE(NFOUT,'(A)')' OUTPUT [&OUTPUT]:'
      INDX=1
      IF (LQUAD) INDX=2
      WRITE(NFOUT,'(2A)')' LQUAD  = ',CDUMMY(INDX)
      INDX=1
      IF (LSCDEF) INDX=2
      WRITE(NFOUT,'(2A)')' LSCDEF = ',CDUMMY(INDX)
      INDX=1
      IF (LSTATW.OR.LSCRN) INDX=2
      WRITE(NFOUT,'(2A)')' LSCRN  = ',CDUMMY(INDX)
      INDX=1
      IF (LSTATW) INDX=2
      WRITE(NFOUT,'(2A)')' LSTATW = ',CDUMMY(INDX)
      IF (LSCRN) THEN
	 DO 270 I=1,MAXSCR
	    IF (SCREEN(I)(1:5).NE.'     ') THEN
	       WRITE(NFOUT,'(A,I2,2A)')' SCREEN(',I,')=',
     &                            SCREEN(I)(1:IEND(SCREEN(I)))
	    ENDIF
 270     CONTINUE
      ENDIF
      IF (LPOST) THEN
	 DO 280 I=1,MAXPST
	    IF (POST(I)(1:5).NE.'     ') THEN
	       WRITE(NFOUT,'(A,I2,2A)')' POST(',I,')  =',
     &                            POST(I)(1:IEND(POST(I)))
	    ENDIF
 280     CONTINUE
      ENDIF
      IF (LPMSAV) THEN
	 DO 285 I=1,MAXSAV
	    IF (PMSAV(I)(1:5).NE.'     ') THEN
	       WRITE(NFOUT,'(A,I2,2A)')' PMSAV(',I,') =',
     &                            PMSAV(I)(1:IEND(PMSAV(I)))
	    ENDIF
 285     CONTINUE
      ENDIF
      IF (LHIS) THEN
	 DO 290 I=1,MAXHIS
	    IF (HIST(I)(1:5).NE.'     ') THEN
	       WRITE(NFOUT,'(A,I2,2A)')' HIST(',I,')  =',
     &                            HIST(I)(1:IEND(HIST(I)))
	    ENDIF
 290     CONTINUE
      ENDIF
      WRITE(NFOUT,'(A,I8)')' NSCRUP = ',NSCRUP
      WRITE(NFOUT,'(A,I8)')' NETRBK = ',NETRBK
      WRITE(NFOUT,'(2A)')' FETRBK = ',FETRBK(1:IEND(FETRBK))

      RETURN


C END OF PROGRAM OR BACKUP
C ------------------------

300   CONTINUE

**    TABLE INFORMATION:
*     WRITE SHELL TABLES TO OUTPUT FILE
      IF (NSHELL.GT.0) THEN
         WRITE(NFOUT,'(A)')'    '
         WRITE(NFOUT,'(A)')' SHELL Tables: '
         WRITE(NFOUT,'(2A)')' ELEM   SHELL  ENER   SCR    HIST  SCR',
     &                      ' PSMIN XCHAR ION'
         WRITE(NFOUT,'(2A)')'  OF     OF     OF     OF     OF    OF',
     &                      '   OF    OF  HIST'
         WRITE(NFOUT,'(2A)')' SHELL  SHELL  SHELL  SHELL  ION   ION',
     &                      '  ION  SHELL'
         WRITE(NFOUT,'(2A)')'--------------------------------------',
     &                      '------------------'
         DO 310 K=1,NSHELL
            IS1INDX=(K-1)*(NDMASCRN+NDMAPS)+1
            IS2INDX=(K-1)*NDMAPM+1
            IS3INDX=(K-1)*NDMAXCHAR+1
            IS4INDX=(K-1)*NDMAHIST+1
            WRITE(BUFFER(1:20),'(A)')'                    '
            WRITE(BUFFER(21:40),'(A)')'                    '
            WRITE(BUFFER(41:60),'(A)')'                    '
            WRITE(BUFFER(61:80),'(A)')'                    '
            WRITE(BUFFER(1:21),'(2I5,F11.2)')ELEMOFSHELL(K),
     &                                       SHELLOFSHELL(K),
     &                                       ENEROFSHELL(K)
            IF ((NDMASCRN+NDMAPS).GT.0) THEN
              WRITE(BUFFER(22:24),'(I3)')    SCROFSHELL(IS1INDX)
              WRITE(BUFFER(25:30),'(I6)')    HISTOFION(K)
              WRITE(BUFFER(31:36),'(I6)')    SCROFION(IS1INDX)
            ELSE
              WRITE(BUFFER(25:30),'(I6)')    HISTOFION(K)
            ENDIF
            IF (NDMAPM.GT.0)
     &        WRITE(BUFFER(37:42),'(I6)')    PSMINOFION(IS2INDX)
            IF (NDMAXCHAR.GT.0)
     &        WRITE(BUFFER(43:48),'(I6)')    XCHAROFSHELL(IS3INDX)
            IF (NDMAHIST.GT.0)
     &        WRITE(BUFFER(49:54),'(I6)')    IONHIST(IS4INDX)
            WRITE(NFOUT,'(A)')BUFFER
CS            WRITE(NFOUT,'(2I5,F11.2,I3,9I6)')ELEMOFSHELL(K),
CS     &                                       SHELLOFSHELL(K),
CS     &                                       ENEROFSHELL(K),
CSCS     &                                       SCROFSHELL(K,1),
CS     &                                       SCROFSHELL(IS1INDX),
CS     &                                       HISTOFION(K),
CSCS     &                                       SCROFION(K,1),
CS     &                                       SCROFION(IS1INDX),
CSCS     &                                       PSMINOFION(K,1),
CS     &                                       PSMINOFION(IS2INDX),
CSCS     &                                       XCHAROFSHELL(K,1),
CS     &                                       XCHAROFSHELL(IS3INDX),
CSCS     &                                       IONHIST(K,1)
CS     &                                       IONHIST(IS4INDX)
            MXINDX=MAX(NSCROFSHELL(K),NSCROFION(K))
            MXINDX=MAX(MXINDX,NPSMINOFION(K))
            MXINDX=MAX(MXINDX,NXCHAROFSHELL(K))
            MXINDX=MAX(MXINDX,NIONHIST(K))
            DO 309 KK=2,MXINDX
               IS1INDX=(K-1)*(NDMASCRN+NDMAPS)+KK
               IS2INDX=(K-1)*NDMAPM+KK
               IS3INDX=(K-1)*NDMAXCHAR+KK
               IS4INDX=(K-1)*NDMAHIST+KK
CS               WRITE(NFOUT,'(A,I3,A,4I6)')'                     ',
CS     &               SCROFSHELL(K,KK),'      ',SCROFION(K,KK),
CS     &               PSMINOFION(K,KK),
CS     &               XCHAROFSHELL(K,KK),IONHIST(K,KK)
               WRITE(BUFFER(1:20),'(A)')'                    '
               WRITE(BUFFER(21:40),'(A)')'                    '
               WRITE(BUFFER(41:60),'(A)')'                    '
               WRITE(BUFFER(61:80),'(A)')'                    '
               IF (((NDMASCRN+NDMAPS).GT.0).AND.
     &             (KK.LE.NSCROFSHELL(K)))
     &            WRITE(BUFFER(22:24),'(I3)')SCROFSHELL(IS1INDX)
               IF (((NDMASCRN+NDMAPS).GT.0).AND.
     &             (KK.LE.NSCROFION(K)))
     &            WRITE(BUFFER(31:36),'(I6)')SCROFION(IS1INDX)
               IF ((NDMAPM.GT.0).AND.(KK.LE.NPSMINOFION(K)))
     &            WRITE(BUFFER(37:42),'(I6)')PSMINOFION(IS2INDX)
               IF ((NDMAXCHAR.GT.0).AND.(KK.LE.NXCHAROFSHELL(K)))
     &            WRITE(BUFFER(43:48),'(I6)')XCHAROFSHELL(IS3INDX)
               IF ((NDMAHIST.GT.0).AND.(KK.LE.NIONHIST(K)))
     &            WRITE(BUFFER(49:54),'(I6)')IONHIST(IS4INDX)
               WRITE(NFOUT,'(A)')BUFFER
CS               WRITE(NFOUT,'(A,I3,A,4I6)')'                     ',
CS     &               SCROFSHELL(IS1INDX),'      ',SCROFION(IS1INDX),
CS     &               PSMINOFION(IS2INDX),
CS     &               XCHAROFSHELL(IS3INDX),IONHIST(IS4INDX)
 309        CONTINUE
 310     CONTINUE
      ENDIF

*     WRITE XCHAR TABLES TO FILE
      IF (NXCHAR.GT.0) THEN
         WRITE(NFOUT,'(A)')'    '
         WRITE(NFOUT,'(A)')' XCHAR Tables: '
         WRITE(NFOUT,'(3A)')' ELEM  XCHAR ENER  SHELL FYIELD',
     &                      ' FRELINT XDETEFF NXCHIS XCHIS',
     &                      ' SCR  SCR PSMIN PSMIN'
         WRITE(NFOUT,'(3A)')'  OF    OF    OF    OF     OF  ',
     &                      '  OF     OF                  ',
     &                      ' OF   OF   OF    OF'
         WRITE(NFOUT,'(3A)')' XCHAR XCHAR XCHAR XCHAR XCHAR ',
     &                      ' XCHAR   XCHAR               ',
     &                      ' XCG  XCD  XCG   XCD'
         WRITE(NFOUT,'(3A)')'-------------------------------',
     &                      '-----------------------------',
     &                      '---------------------'
         DO 312 K=1,NXCHAR
            IK=(NXDET+1)*(K-1)+2
            IXINDX1=(K-1)*NDMAHIST+1
            IXINDX2=(K-1)*(NDMASCRN+NDMAPS)+1
            IXINDX3=(K-1)*NDMAPM+1
            WRITE(BUFFER(1:20),'(A)')'                    '
            WRITE(BUFFER(21:40),'(A)')'                    '
            WRITE(BUFFER(41:60),'(A)')'                    '
            WRITE(BUFFER(61:80),'(A)')'                    '
            WRITE(BUFFER(1:38),'(2I4,F11.2,I3,2F8.3)')
     &                                       ELEMOFXCHAR(K),
     &                                       XCHAROFXCHAR(K),
     &                                       ENEROFXCHAR(K),
     &                                       SHELLOFXCHAR(K),
     &                                       FYIELDOFXCHAR(K),
     &                                       FRELINTOFXCHAR(K)
            IF (NXDET.GT.0)
     &         WRITE(BUFFER(39:46),'(F8.3)') XDETEFFOFXCHAR(IK)
            WRITE(BUFFER(47:52),'(I6)')      NXCHIS(K)
            IF (NDMAHIST.GT.0)
     &         WRITE(BUFFER(53:58),'(I6)')   XCHIS(IXINDX1)
            IF ((NDMASCRN+NDMAPS).GT.0)
     &         WRITE(BUFFER(59:68),'(2I5)')  SCROFXCG(IXINDX2),
     &                                       SCROFXCD(IXINDX2)
            IF (NDMAPM.GT.0)
     &         WRITE(BUFFER(69:79),'(I5,I6)')PSMINOFXCG(IXINDX3),
     &                                       PSMINOFXCD(IXINDX3)
            WRITE(NFOUT,'(A)')BUFFER
CS            WRITE(NFOUT,'(2I4,F11.2,I3,3F8.3,2I6,3I5,I6)')
CS     &                                         ELEMOFXCHAR(K),
CS     &                                         XCHAROFXCHAR(K),
CS     &                                         ENEROFXCHAR(K),
CS     &                                         SHELLOFXCHAR(K),
CS     &                                         FYIELDOFXCHAR(K),
CS     &                                         FRELINTOFXCHAR(K),
CSCS     &                                         XDETEFFOFXCHAR(1,K),
CS     &                                         XDETEFFOFXCHAR(IK),
CS     &                                         NXCHIS(K),
CSCS     &                                         XCHIS(K,1),
CS     &                                         XCHIS(IXINDX1),
CSCS     &                                         SCROFXCG(K,1),
CS     &                                         SCROFXCG(IXINDX2),
CSCS     &                                         SCROFXCD(K,1),
CS     &                                         SCROFXCD(IXINDX2),
CSCS     &                                         PSMINOFXCG(K,1),
CS     &                                         PSMINOFXCG(IXINDX3),
CSCS     &                                         PSMINOFXCD(K,1)
CS     &                                         PSMINOFXCD(IXINDX3)
            MXINDX=MAX(NXCHIS(K),NSCROFXCG(K))
            MXINDX=MAX(MXINDX,NSCROFXCD(K))
            MXINDX=MAX(MXINDX,NPSMINOFXCG(K))
            MXINDX=MAX(MXINDX,NPSMINOFXCD(K))
            MXINDX=MAX(MXINDX,NXDET)
            DO 311 KK=2,MXINDX
              IXINDX1=(K-1)*NDMAHIST+KK
              IXINDX2=(K-1)*(NDMASCRN+NDMAPS)+KK
              IXINDX3=(K-1)*NDMAPM+KK
              WRITE(BUFFER(1:20),'(A)')'                    '
              WRITE(BUFFER(21:40),'(A)')'                    '
              WRITE(BUFFER(41:60),'(A)')'                    '
              WRITE(BUFFER(61:80),'(A)')'                    '
              IF ((NDMAXDET.GT.0).AND.(KK.LE.NXDET))
     &           WRITE(BUFFER(38:45),'(F8.3)')XDETEFFOFXCHAR(IK)
              IF ((NDMAHIST.GT.0).AND.(KK.LE.NXCHIS(K)))
     &           WRITE(BUFFER(52:57),'(I6)')  XCHIS(IXINDX1)
              IF (((NDMASCRN+NDMAPS).GT.0).AND.
     &            (KK.LE.NSCROFXCG(K)))
     &           WRITE(BUFFER(58:62),'(I5)')SCROFXCG(IXINDX2)
              IF (((NDMASCRN+NDMAPS).GT.0).AND.
     &            (KK.LE.NSCROFXCD(K)))
     &           WRITE(BUFFER(63:67),'(I5)')SCROFXCD(IXINDX2)
              IF ((NDMAPM.GT.0).AND.(KK.LE.NPSMINOFXCG(K)))
     &           WRITE(BUFFER(68:72),'(I5)')PSMINOFXCG(IXINDX3)
              IF ((NDMAPM.GT.0).AND.(KK.LE.NPSMINOFXCD(K)))
     &           WRITE(BUFFER(73:78),'(I6)')PSMINOFXCD(IXINDX3)
              WRITE(NFOUT,'(A)')BUFFER
CS              IF (KK.LE.MAXXDET) THEN
CS                IK=(NXDET+1)*(K-1)+(KK+1)
CS                WRITE(NFOUT,'(A,F8.3,A,I6,3I5,I6)')
CS     &            '                                      ',
CSCS     &            XDETEFFOFXCHAR(KK,K),'      ',
CS     &            XDETEFFOFXCHAR(IK),'      ',
CSCS     &            XCHIS(K,KK),SCROFXCG(K,KK),SCROFXCD(K,KK),
CS     &            XCHIS(IXINDX1),SCROFXCG(IXINDX2),SCROFXCD(IXINDX2),
CSCS     &            PSMINOFXCG(K,KK),PSMINOFXCD(K,KK)
CS     &            PSMINOFXCG(IXINDX3),PSMINOFXCD(IXINDX3)
CS              ELSE IF (KK.LE.MAXSAV) THEN
CS                WRITE(NFOUT,'(3A,I6,3I5,I6)')
CS     &            '                                      ',
CS     &            '        ','      ',
CSCS     &            XCHIS(K,KK),SCROFXCG(K,KK),SCROFXCD(K,KK),
CS     &            XCHIS(IXINDX1),SCROFXCG(IXINDX2),SCROFXCD(IXINDX2),
CSCS     &            PSMINOFXCG(K,KK),PSMINOFXCD(K,KK)
CS     &            PSMINOFXCG(IXINDX3),PSMINOFXCD(IXINDX3)
CS              ELSE
CS                WRITE(NFOUT,'(3A,I6,2I5)')
CS     &            '                                      ',
CS     &            '        ','      ',
CSCS     &            XCHIS(K,KK),SCROFXCG(K,KK),SCROFXCD(K,KK)
CS     &            XCHIS(IXINDX1),SCROFXCG(IXINDX2),SCROFXCD(IXINDX2)
CS              ENDIF
 311        CONTINUE
 312     CONTINUE
      ENDIF

CS      IF (NXCONT.GT.0) THEN
CS         WRITE(NFOUT,'(A)')'    '
CS         WRITE(NFOUT,'(A)')' XCONT Tables: '
CS         WRITE(NFOUT,'(A)')' INDEX    ENERGY  XDET   X-RAYS/E/SR'
CS         DO 316 I=1,NXCONT
CS            IXD=0
CS            INDX=(NXDET+1)*(I-1)+1
CS            WRITE(NFOUT,'(I5,F11.2,I5,E15.8)')I,ENEROFXCONT(I),
CS     &                                     IXD,XDETOFXCONT(INDX)
CS            DO 315 J=1,NXDET
CS               INDX=(NXDET+1)*(I-1)+(J+1)
CS               WRITE(NFOUT,'(A,I5,E15.8)')'                ',
CS     &                                     J,XDETOFXCONT(INDX)
CS 315        CONTINUE
CS 316     CONTINUE
CS      ENDIF

*     WRITE AUGER TABLES TO SCREEN
      IF (NAUGER.GT.0) THEN
        WRITE(NFOUT,'(A)')'    '
        WRITE(NFOUT,'(A)')' Auger Tables: '
        WRITE(NFOUT,'(2A)')' ELEM   LINE   ENER   ADD    AGD   AGD',
     &                 '  ADD  NAE_  AE_'
        WRITE(NFOUT,'(2A)')'  OF     OF     OF    HIS    HIS   LOC',
     &                 '  LOC  HIS   HIS'
        WRITE(NFOUT,'(2A)')' AUGER  AUGER  AUGER                  ',
     &                 '                            '
        WRITE(NFOUT,'(2A)')'--------------------------------------',
     &                 '------------------'
      ENDIF
      DO 324 K=1,NAUGER
         WRITE(NFOUT,'(2I5,F11.2,I3,5I6)')ELEMOFAUGER(K),
     &                                LINEOFAUGER(K),
     &                                ENEROFAUGER(K),
     &                                ADDHIS(K),
     &                                AGDHIS(K),
     &                                AGDLOC(K,1),
     &                                ADDLOC(K,1),
     &                                NAE_HIS(K),
     &                                AE_HIS(K,1)
         MXINDX=MAX(NAGDLOC(K),NADDLOC(K))
         MXINDX=MAX(MXINDX,NAE_HIS(K))
         DO 323 IAE=2,MXINDX
            WRITE(NFOUT,'(A,2I6,A,I6)')
     &          '                              ',AGDLOC(K,IAE),
     &          ADDLOC(K,IAE),'      ',AE_HIS(K,IAE)
 323     CONTINUE
 324  CONTINUE
         
*     WRITE DETECTOR INFORMATION
*     X-RAY DETECTOR
      WRITE(NFOUT,'(A)')'        '
      WRITE(NFOUT,'(A)')' X-RAY DETECTOR INFO:'
      WRITE(NFOUT,'(2A)')' DET#   TAKOFF  XDEROT    SOLIDA   FWHM    ',
     &                   ' ENFWHM  XDTYPE  XFDEFF'
      WRITE(NFOUT,'(2A)')'---------------------------------------',
     &                   '-------------------------------'
      DO 325 I=0,NXDET
          WRITE(NFOUT,'(I4,F10.2,F8.2,F10.5,F8.2,F10.2,4A)')
     &            I,DTAKOFF(I),DXDEROT(I),DSOLIDA(I),DFWHM(I),
     &            DENFWHM(I),'    ',DXDTYPE(I),'    ',
     &            DXFDEFF(I)(1:IEND(DXFDEFF(I)))
 325  CONTINUE
*     ELECTRON DETECTOR
      WRITE(NFOUT,'(A)')'        '
      WRITE(NFOUT,'(A)')' ELECTRON DETECTOR INFO:'
      WRITE(NFOUT,'(2A)')' DET#   EDTHET   EDPHI   EDTHMN  EDTHMX',
     &                  '  ACC.ANG   FEDTRN  '
      WRITE(NFOUT,'(2A)')'------------------------------------',
     &                  '--------------------------------'
      DO 326 I=0,NEDET
          WRITE(NFOUT,'(I4,F10.2,F8.2,F9.2,F8.2,F9.2,2A)')
     &          I,DEDTHET(I)*180/PI,DEDPHI(I)*180/PI,
     &          DEDTHMN(I)*180/PI,DEDTHMX(I)*180/PI,EDACAN(I),
     &          '   ',DFEDTRN(I)(1:IEND(DFEDTRN(I)))
 326  CONTINUE

      IF (MXIONSCR.GT.0) THEN
         WRITE(NFOUT,'(A)')'   '
         WRITE(NFOUT,'(A)')' SCREEN TABLE FOR IOD:'
         WRITE(NFOUT,'(A)')' SCREEN#    ENTRY#      SHELLENTRY#'
         DO 328 I=1,MXIONSCR
            ISINDX=I
            CALL CHKBND(16,ISINDX,'WROUT     ','IONTOSCR')
CS            WRITE(NFOUT,'(I5,I10,I15)')I,NIONTOSCR(I),IONTOSCR(I,1)
            WRITE(NFOUT,'(I5,I10,I15)')I,NIONTOSCR(I),
     &                                 IONTOSCR(ISINDX)
            DO 327 J=2,NIONTOSCR(I)
               ISINDX=(J-1)*(NDMASCRN+NDMAPS)+I
               CALL CHKBND(16,ISINDX,'WROUT     ','IONTOSCR')
CS               WRITE(NFOUT,'(T16,I15)')IONTOSCR(I,J)
               WRITE(NFOUT,'(T16,I15)')IONTOSCR(ISINDX)
 327        CONTINUE
 328     CONTINUE
      ENDIF
      IF (MXXCGSCR.GT.0) THEN
         WRITE(NFOUT,'(A)')'   '
         WRITE(NFOUT,'(A)')' SCREEN TABLE FOR XGD:'
         WRITE(NFOUT,'(A)')' SCREEN#    ENTRY#      XCHARENTRY#'
         DO 330 I=1,MXXCGSCR
            IXINDX=I
CS            WRITE(NFOUT,'(I5,I10,I15)')I,NXCGTOSCR(I),XCGTOSCR(I,1)
            WRITE(NFOUT,'(I5,I10,I15)')I,NXCGTOSCR(I),XCGTOSCR(IXINDX)
            DO 329 J=2,NXCGTOSCR(I)
               IXINDX=(J-1)*(NDMASCRN+NDMAPS)+I
               CALL CHKBND(21,IXINDX,'WROUT     ','XCGTOSCR')
CS               WRITE(NFOUT,'(T16,I15)')XCGTOSCR(I,J)
               WRITE(NFOUT,'(T16,I15)')XCGTOSCR(IXINDX)
 329        CONTINUE
 330     CONTINUE
      ENDIF
      IF (MXXCDSCR.GT.0) THEN
         WRITE(NFOUT,'(A)')'   '
         WRITE(NFOUT,'(A)')' SCREEN TABLE FOR XDD:'
         WRITE(NFOUT,'(A)')' SCREEN#    ENTRY#      XCHARENTRY#   XDET#'
         DO 332 I=1,MXXCDSCR
            IXINDX=I
            WRITE(NFOUT,'(I5,I10,I15,I12)')
CS     &               I,NXCDTOSCR(I),XCDTOSCR(I,1),XDETSCR(I,1)
     &               I,NXCDTOSCR(I),XCDTOSCR(IXINDX),XDETSCR(IXINDX)
            DO 331 J=2,NXCDTOSCR(I)
               IXINDX=(J-1)*(NDMASCRN+NDMAPS)+I
               CALL CHKBND(21,IXINDX,'WROUT     ','XCDTOSCR')
CS               WRITE(NFOUT,'(T16,I15,I12)')XCDTOSCR(I,J),XDETSCR(I,J)
               WRITE(NFOUT,'(T16,I15,I12)')XCDTOSCR(IXINDX),
     &                                     XDETSCR(IXINDX)
 331        CONTINUE
 332     CONTINUE
      ENDIF
      IF (MXIONPM.GT.0) THEN
         WRITE(NFOUT,'(A)')'   '
         WRITE(NFOUT,'(A)')' POSTMINI TABLE FOR IOD:'
         WRITE(NFOUT,'(A)')'   PM#      ENTRY#      SHELLENTRY#'
         DO 334 I=1,MXIONPM
            ISINDX=I
            CALL CHKBND(17,ISINDX,'WROUT     ','IONTOPM')
CS            WRITE(NFOUT,'(I5,I10,I15)')I,NIONTOPM(I),IONTOPM(I,1)
            WRITE(NFOUT,'(I5,I10,I15)')I,NIONTOPM(I),IONTOPM(ISINDX)
            DO 333 J=2,NIONTOPM(I)
               ISINDX=(J-1)*NDMAPM+I
               CALL CHKBND(17,ISINDX,'WROUT     ','IONTOPM')
CS               WRITE(NFOUT,'(T16,I15)')IONTOPM(I,J)
               WRITE(NFOUT,'(T16,I15)')IONTOPM(ISINDX)
 333        CONTINUE
 334     CONTINUE
      ENDIF
      IF (MXXCGPM.GT.0) THEN
         WRITE(NFOUT,'(A)')'   '
         WRITE(NFOUT,'(A)')' POSTMINI TABLE FOR XGD:'
         WRITE(NFOUT,'(A)')'   PM#      ENTRY#      XCHARENTRY#'
         DO 336 I=1,MXXCGPM
            IXINDX=I
CS            WRITE(NFOUT,'(I5,I10,I15)')I,NXCGTOPM(I),XCGTOPM(I,1)
            WRITE(NFOUT,'(I5,I10,I15)')I,NXCGTOPM(I),XCGTOPM(IXINDX)
            DO 335 J=2,NXCGTOPM(I)
               IXINDX=(J-1)*NDMAPM+I
               CALL CHKBND(22,IXINDX,'WROUT     ','XCGTOPM')
CS               WRITE(NFOUT,'(T16,I15)')XCGTOPM(I,J)
               WRITE(NFOUT,'(T16,I15)')XCGTOPM(IXINDX)
 335        CONTINUE
 336     CONTINUE
      ENDIF
      IF (MXXCDPM.GT.0) THEN
         WRITE(NFOUT,'(A)')'   '
         WRITE(NFOUT,'(A)')' POSTMINI TABLE FOR XDD:'
         WRITE(NFOUT,'(A)')'   PM#      ENTRY#      XCHARENTRY#   XDET#'
         DO 338 I=1,MXXCDPM
            IXINDX=I
            WRITE(NFOUT,'(I5,I10,I15,I12)')
CS     &               I,NXCDTOPM(I),XCDTOPM(I,1),XDETPM(I,1)
     &               I,NXCDTOPM(I),XCDTOPM(IXINDX),XDETPM(IXINDX)
            DO 337 J=2,NXCDTOPM(I)
               IXINDX=(J-1)*NDMAPM+I
               CALL CHKBND(22,IXINDX,'WROUT     ','XCDTOPM')
CS               WRITE(NFOUT,'(T16,I15,I12)')XCDTOPM(I,J),XDETPM(I,J)
               WRITE(NFOUT,'(T16,I15,I12)')XCDTOPM(IXINDX),
     &                                     XDETPM(IXINDX)
 337        CONTINUE
 338     CONTINUE
      ENDIF


**    WRITE RESULTS OF SIMULATION
      NSTP=NETRN-NBACK-NTRAN-NOUTL-NOUTR
      WRITE(NFOUT,'(A)')'      '
      WRITE(NFOUT,'(A)')'      '
      WRITE(NFOUT,'(A,I7)')' TOTAL NUMBER OF ELECTRONS:   ',NETRN
      WRITE(NFOUT,'(A,I7,F15.4,A)')' EL. STOPPED INSIDE SAMPLE:   ',
     &            NIN,DBLE(NIN)/DBLE(NETRN)*100,' %'
      WRITE(NFOUT,'(A,I7,F15.4,A)')' ELECTRONS STOPPED INSIDE:    ',
     &            NSTP,DBLE(NSTP)/DBLE(NETRN)*100,' %'
      WRITE(NFOUT,'(A,I7,F15.4,A)')' BACKSCATTERED ELECTRONS:     ',
     &            NBACK,DBLE(NBACK)/DBLE(NETRN)*100,' %'
      WRITE(NFOUT,'(A,I7,F15.4,A)')' TRANSMITTED ELECTRONS:       ',
     &            NTRAN,DBLE(NTRAN)/DBLE(NETRN)*100,' %'
CS      WRITE(NFOUT,'(A,I7,F15.4,A)')' ELECTRONS LEFT ON SIDE:      ',
CS     &            NOUTS,DBLE(NOUTS)/DBLE(NETRN)*100,' %'
      WRITE(NFOUT,'(A,I7,F15.4,A)')' ELECTRONS LEFT ON RIGHT SIDE:',
     &            NOUTR,DBLE(NOUTR)/DBLE(NETRN)*100,' %'
      WRITE(NFOUT,'(A,I7,F15.4,A)')' ELECTRONS LEFT ON LEFT SIDE: ',
     &            NOUTL,DBLE(NOUTL)/DBLE(NETRN)*100,' %'
CS      WRITE(NFOUT,'(A,I7,F15.4,A)')' ELECTRONS LOST:              ',
CS     &            NOUTLR,DBLE(NOUTLR)/DBLE(NETRN)*100,' %'
      WRITE(NFOUT,'(A)')' TOTAL MEAN PATH LENGTH PER ELECTRONS:'
      WRITE(NFOUT,'(A,F12.7,A)')' ALL ELECTRONS:           ',
     &                            TRLEN(2)/10000,' m'
      WRITE(NFOUT,'(A,F12.7,A)')' EL. STOPPED IN SAMPLE:   ',
     &                            TRLENP(2)/10000,' m'
      WRITE(NFOUT,'(A,F12.7,A)')' BACKSCATTERED ELECTRONS: ',
     &                            TRLENB(2)/10000,' m'
      WRITE(NFOUT,'(A,F12.7,A)')' TRANSMITTED ELECTRONS:   ',
     &                            TRLENT(2)/10000,' m'
      WRITE(NFOUT,'(A,F12.7,A)')' ELECTRONS LEFT ON SIDE:  ',
     &                            TRLENS(2)/10000,' m'
      IF (NSCATTER(1).GT.0) THEN
         WRITE(NFOUT,'(2A)')' MEAN PATH LENGTH BETWEEN TWO ',
     &                      'SCATTERING EVENTS:'
         WRITE(NFOUT,'(A,F12.7,A)')' ALL ELECTRONS:           ',
     &                               TRLEN(3),' '
      ENDIF
      IF (NSCATTER(2).GT.0) THEN
         WRITE(NFOUT,'(2A)')' MEAN PATH LENGTH BETWEEN TWO ',
     &                      ' ELASTIC SCATTERING EVENTS:'
         WRITE(NFOUT,'(A,F12.7,A)')' ALL ELECTRONS:           ',
     &                               TRLEN(4),' '
      ENDIF
      IF (NSCATTER(3).GT.0) THEN
         WRITE(NFOUT,'(2A)')' MEAN PATH LENGTH BETWEEN TWO ',
     &                      'IIONIZATION EVENTS:'
         WRITE(NFOUT,'(A,F12.7,A)')' ALL ELECTRONS:           ',
     &                               TRLEN(5)/10000,' m'
      ENDIF
      IF (NSCATTER(4).GT.0) THEN
         WRITE(NFOUT,'(2A)')' MEAN PATH LENGTH BETWEEN TWO ',
     &                      'SCATTERING EVENTS:'
         WRITE(NFOUT,'(A,F12.7,A)')' ALL ELECTRONS:           ',
     &                               TRLEN(6),' '
      ENDIF

      WRITE(NFOUT,'(A)')'   '
      WRITE(NFOUT,'(2A)')' GENERATED IONIZATIONS PER ELECTRON AND',
     &               ' STERADIANT FOR MODEL=HYB:'
      WRITE(NFOUT,'(2A)')' IONIZATION PROBABILITIES SUMMED UP AT',
     &               ' EACH SCATTERING EVENT (EL.AND INEL.)'
      WRITE(NFOUT,'(2A)')' ALL ENTRIES IN SHELL TABLE IN ONE',
     &               ' SINGLE NUMBER (PROPION)'
      WRITE(NFOUT,'(A,E14.5)')' PROPION = ',PROPION/NETRN/4/PI

      IF (NSHELL.GT.0) THEN
         WRITE(NFOUT,'(A)')'   '
         WRITE(NFOUT,'(A)')'   '
         WRITE(NFOUT,'(A)')' IONIZATIONS: (/ELECTRON/STERADIANT)'
         WRITE(NFOUT,'(A)')' ==================================='
         WRITE(NFOUT,'(A)')'   '
         WRITE(NFOUT,'(2A)')'  ATOMIC# SHELL        ENERGY ',
     &                      '  IONIZATIONS'
         WRITE(NFOUT,'(2A)')' -----------------------------',
     &                      '-------------'
      ENDIF
      DO 339 I=1,NSHELL
         WRITE(NFOUT,'(I7,I6,F16.4,E14.5)')
     &                                ATNUM(ELEMOFSHELL(I)),
     &                                SHELLOFSHELL(I),
     &                                ENEROFSHELL(I)/1000,
     &                                IONINTOFSHELL(I)/DBLE(NETRN)
 339  CONTINUE
      IF (NXCHAR.GT.0) THEN
         WRITE(NFOUT,'(A)')'   '
         WRITE(NFOUT,'(A)')'   '
         WRITE(NFOUT,'(2A)')' CHARACTERISTIC X-RAYS:',
     &                      ' (/ELECTRON/STERADIANT)'
         WRITE(NFOUT,'(2A)')' ======================',
     &                      '======================='
         WRITE(NFOUT,'(A)')'   '
         WRITE(NFOUT,'(3A)')'  ATOMIC# SHELL LINE   ENERGY ',
     &                  '  IONIZATIONS   GEN. X-RAYS ',
     &                  '  DET. X-RAYS   DET#'
         WRITE(NFOUT,'(3A)')' -----------------------------',
     &                      '----------------------------',
     &                      '--------------------'
      ENDIF
      NND=0
      DO 341 I=1,NXCHAR
         IXINDX=(I-1)*NDMAXDET+1
         CALL CHKBND(5,SHELLOFXCHAR(I),'WROUT     ','SHELLOFSHELL')
         WRITE(NFOUT,'(I7,2I6,F10.4,3E14.5,I6)')
     &                       ATNUM(ELEMOFXCHAR(I)),
     &                       SHELLOFSHELL(SHELLOFXCHAR(I)),
     &                       XCHAROFXCHAR(I),
     &                       ENEROFXCHAR(I)/1000,
     &                       IONINTOFSHELL(SHELLOFXCHAR(I))/DBLE(NETRN),
     &                       XGENOFXCHAR(I)/DBLE(NETRN),
CS     &                       XDETOFXCHAR(0,I)/DBLE(NETRN),
     &                       XDETOFXCHAR(IXINDX)/DBLE(NETRN),
     &                       NND
         DO 340 J=1,NXDET
            IXINDX=(I-1)*NDMAXDET+(J+1)
            CALL CHKBND(20,IXINDX,'WROUT     ','XDETOFXCHAR')
            WRITE(NFOUT,'(2A,E14.5,I6)')'                             ',
     &                       '                            ',
CS     &                       XDETOFXCHAR(J,I)/DBLE(NETRN),J
     &                       XDETOFXCHAR(IXINDX)/DBLE(NETRN),J
 340     CONTINUE
 341  CONTINUE

      IF (NXCHAR.GT.0) THEN
         WRITE(NFOUT,'(A)')'   '
         WRITE(NFOUT,'(A)')'   '
         WRITE(NFOUT,'(2A)')' DETECTED CHARACTERISTIC X-RAYS:',
     &                      ' (ABSOLUTE UNITS [COUNTS/SEC])'
         WRITE(NFOUT,'(2A)')' ======================',
     &                      '======================='
         WRITE(NFOUT,'(A)')'   '
         WRITE(NFOUT,'(3A)')'  ATOMIC# SHELL LINE   ENERGY ',
     &                  '  DET. X-RAYS   P/B[1 eV]   ',
     &                  '  FIORI FACT.   DET#'
         WRITE(NFOUT,'(3A)')' -----------------------------',
     &                      '----------------------------',
     &                      '--------------------'
      ENDIF
      NND=0
      DO 351 I=1,NXCHAR
         IXINDX=(I-1)*NDMAXDET+1
         CALL CHKBND(5,SHELLOFXCHAR(I),'WROUT     ','SHELLOFSHELL')
         WRITE(NFOUT,'(I7,2I6,F10.4,3E14.5,I6)')
     &                              ATNUM(ELEMOFXCHAR(I)),
     &                              SHELLOFSHELL(SHELLOFXCHAR(I)),
     &                              XCHAROFXCHAR(I),
     &                              ENEROFXCHAR(I)/1000,
CS     &                              XDETOFXCHAR(0,I)*6.24219725D9*
     &                              XDETOFXCHAR(IXINDX)*6.24219725D9*
     &                               CURRENT*DSOLIDA(0)/DBLE(NETRN),
CS     &                              XPEAKTOBACK(0,I),
     &                              XPEAKTOBACK(IXINDX),
CS     &                              XFIORIFACT(0,I),
     &                              XFIORIFACT(IXINDX),
     &                              NND
         DO 350 J=1,NXDET
            IXINDX=(I-1)*NDMAXDET+(J+1)
            CALL CHKBND(20,IXINDX,'WROUT     ','XDETOFXCHAR/...')
            WRITE(NFOUT,'(A,3E14.5,I6)')'                             ',
CS     &                                 XDETOFXCHAR(J,I)*6.24219725D9*
     &                                 XDETOFXCHAR(IXINDX)*6.24219725D9*
     &                                  CURRENT*DSOLIDA(J)/DBLE(NETRN),
CS     &                                 XPEAKTOBACK(J,I),
     &                                 XPEAKTOBACK(IXINDX),
CS     &                                 XFIORIFACT(J,I),J
     &                                 XFIORIFACT(IXINDX),J
 350     CONTINUE
 351  CONTINUE

      IF (NXCONT.GT.0) THEN
         WRITE(NFOUT,'(A)')'   '
         WRITE(NFOUT,'(A)')' BREMSSTRAHLUNG [absolute units]:'
         WRITE(NFOUT,'(2A)')'   energy [keV]   counts/sec/eV    ',
     &                      '  counts    det#     det.efficiency'
         WRITE(NFOUT,'(2A)')'-----------------------------------',
     &                      '---------------------------------------'
      ENDIF
      NND=0
      IF (NXCONT.GT.0) CALL CHKBND (7,NXCONT,'WROUT','ENEROFXCONT')
      MXINDX=NDMAXDET*(NXCONT-1)+(NXDET+1)
      IF (NXCONT.GT.0) THEN
         CALL CHKBND (13,MXINDX,'WROUT','XDETOFXCONT')
         CALL CHKBND (7,NXCONT,'WROUT','IXCONTOFXCHAR')
      ENDIF
      DO 353 I=1,NXCONT
         IK1=NDMAXDET*(I-1)+1
         IK2=NDMAXDET*(IXCONTOFXCHAR(I)-1)+1
         CALL CHKBND (13,IK2,'WROUT','XDETEFFOFXCHAR')
         WRITE(NFOUT,'(F13.4,2E15.5,I7,F17.5)')
     &                            ENEROFXCONT(I)/1000,
CS     &                               XDETOFXCONT(0,I)*6.24219725D9*
CS     &                                      CURRENT*DSOLIDA(0),
     &                            XDETOFXCONT(IK1)*6.24219725D9*
     &                            CURRENT*DSOLIDA(0)/DBLE(NETRN),
CS     &                            XDETOFXCONT(0,I)*6.24219725D9*
CS     &                                    CURRENT*DSOLIDA(0)*MTIME,
     &                            XDETOFXCONT(IK1)*6.24219725D9*
     &                            CURRENT*DSOLIDA(0)*MTIME/DBLE(NETRN),
     &                            NND,
CS     &                               XDETEFFOFXCHAR(0,IXCONTOFXCHAR(I))
     &                            XDETEFFOFXCHAR(IK2)
         DO 352 J=1,NXDET
           IK1=NDMAXDET*(I-1)+(J+1)
           IK2=NDMAXDET*(IXCONTOFXCHAR(I)-1)+(J+1)
           CALL CHKBND (13,IK2,'WROUT','XDETEFFOFXCHAR')
           WRITE(NFOUT,'(A,2E15.5,I7,F17.5)')'             ',
CS     &                               XDETOFXCONT(J,I)*6.24219725D9*
CS     &                                      CURRENT*DSOLIDA(J),
     &                         XDETOFXCONT(IK1)*6.24219725D9*
     &                         CURRENT*DSOLIDA(J)/DBLE(NETRN),
CS     &                               XDETOFXCONT(J,I)*6.24219725D9*
CS     &                                    CURRENT*DSOLIDA(J)*MTIME,J,
     &                         XDETOFXCONT(IK1)*6.24219725D9*
     &                         CURRENT*DSOLIDA(J)*MTIME/DBLE(NETRN),J,
CS     &                               XDETEFFOFXCHAR(J,IXCONTOFXCHAR(I))
     &                         XDETEFFOFXCHAR(IK2)
 352     CONTINUE
 353  CONTINUE


*     ---SEED OF RANDOM NUMBER GENERATOR
      CALL RANGET(
     O            MG,IAG,IBG,IRANDG)
*     ---EXECUTION TIME
      CALL ZZZSEC (HTIME)
      TIME = HTIME - TIMBEG
      ITIMH=TIME/3600
      ITIMM=(TIME-ITIMH*3600)/60
      ITIMS=TIME-ITIMH*3600-ITIMM*60
      WRITE(NFOUT,'(A)')'   '
      WRITE(NFOUT,'(A)')'   '
      IF (MODE.EQ.4) THEN
	 WRITE (22) TIME
	 IF (IETRN.EQ.NETRBK) WRITE (NFOUT,'('' '')')
	 WRITE (NFOUT,830)
     1        'BACKUP: IETRN=',IETRN,',TEXE=',ITIMH,':',ITIMM,':',ITIMS,
     2        ',M=',MG,',IA=',IAG,',IB=',IBG,',IRAND=',IRANDG
      ELSE
	 WRITE (NFOUT,'('' '')')
	 WRITE (NFOUT,'(T2,A40,A2,I4,A4,I5,A4,I6,A7,I4)')
     1          'FINAL STATE OF RANDOM NUMBER GENERATOR: ',
     2          'M=',MG,',IA=',IAG,',IB=',IBG,',IRAND=',IRANDG
	 WRITE (NFOUT,'('' '')')
	 WRITE (NFOUT,'(T2,A16,I3.2,'':'',I2.2,'':'',I2.2,A11)')
     1        'EXECUTION TIME: ',ITIMH,ITIMM,ITIMS,' (HH:MM:SS)'
*        ---CLOSE OUTPUT FILE
	 CLOSE (NFOUT)
      ENDIF

      RETURN

C REPORT WRITING OF A BACKUP FILE
C -------------------------------

400   CONTINUE

      WRITE (NFOUT,'(A)')'      '
      WRITE (NFOUT,'(A)')' BACKUP FILE SUCCESSFULLY WRITTEN'
      WRITE (NFOUT,'(A,I10)')' NUMBER OF SIMULATED ELECTRONS:',IETRN
      WRITE (NFOUT,'(2A)')' BACKUP FILE NAME: ',FETRBK(1:IEND(FETRBK))
      WRITE (NFOUT,'(2A)')' INPUT FILE NAME: ',INFILE(1:IEND(INFILE))
      WRITE (6,'(A)')'      '
      WRITE (6,'(A)')' BACKUP FILE SUCCESSFULLY WRITTEN'
      WRITE (6,'(A,I10)')' NUMBER OF SIMULATED ELECTRONS:',IETRN
      WRITE (6,'(2A)')' BACKUP FILE NAME: ',FETRBK(1:IEND(FETRBK))
      WRITE (6,'(2A)')' INPUT FILE NAME: ',INFILE(1:IEND(INFILE))

      RETURN

C REPORT THE USE OF A BACKUP FILE
C -------------------------------

500   CONTINUE

      WRITE (NFOUT,'(A)')'      '
      WRITE (NFOUT,'(A)')' A BACKUP FILE WAS USED'
      WRITE (NFOUT,'(2A)')' NAME OF BACKUP FILE: ',BCKLD(1:IEND(BCKLD))
      WRITE (NFOUT,'(2A)')' NAME OF INPUT FILE:  ',
     &                      INFILE(1:IEND(INFILE))
      WRITE (6,'(A)')'      '
      WRITE (6,'(A)')' A BACKUP FILE WAS USED'
      WRITE (6,'(2A)')' NAME OF BACKUP FILE: ',BCKLD(1:IEND(BCKLD))
      WRITE (6,'(2A)')' NAME OF INPUT FILE:  ',
     &                      INFILE(1:IEND(INFILE))

      RETURN

 830  FORMAT (T2,A13,I7,A6,I3.2,A1,I2.2,A1,I2.2,A3,I4,A4,I5,A4,I6,A7,I4)

980   STOP 'ERROR DURING OPENING INPUT FILE IN SUBROUTINE ''WROUT'''
990   STOP 'ERROR DURING OPENING OUTPUT FILE IN SUBROUTINE ''WROUT'''

      END

****************************************************************************
*last modification: 25-Oct-1996

      SUBROUTINE WRXCONT(CFILE)

***   WRXCONT - OPENS FILE CFILE AND WRITES BREMSSTRAHLUNG INFORMATION
*
**    ARGUMENTS
*
*     CFILE - FILE NAME
*
**    AUTHOR: CHRISTIAN SCHIEBL
*             CONSULTANT (FORMER: CEC-VIENNA)
*             KREMS, SEPTEMBER 1996
*
      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'GLOBAL.INC'
      INCLUDE 'DMA.INC'

      CHARACTER*64  CFILE
      CHARACTER*20  XDATE
      CHARACTER*15  XNODE
      CHARACTER*120 BUFFER
      CHARACTER*30  CBL

      PARAMETER (NBSOUT=27)

**    START OF EXECUTABLE CODE
*     ************************

      CBL='                              '

*     ---OPEN THE FILE
      OPEN (NBSOUT,FILE=CFILE,FORM='FORMATTED',STATUS='UNKNOWN',
     .         CARRIAGECONTROL='LIST',IOSTAT=IOS)
      IF (IOS.NE.0) THEN
         WRITE(6,'(A)')' %%% ERROR %%%'
         WRITE(6,'(A)')' COULD NOT OPEN FILE FOR BREMSSTRAHLUNG' 
         RETURN
      ENDIF

*     ---WRITE SYSTEM INFORMATION TO THE FILE
      XNODE='               '
      CALL ZZZNOD (XNODE)
      XDATE='                    '
      CALL ZZZDAT (XDATE)
      WRITE (NBSOUT,'(T1,A,T25,A,A15,T59,A20)')'# SIMULATION',
     &                     'EXECUTED ON ',XNODE,XDATE
      WRITE(NBSOUT,'(2A)')'# NAME OF INPUT DECK: ',
     &                     INFILE(1:IEND(INFILE))

*     ---WRITE BEAM INFORMATION TO FILE
      WRITE(NBSOUT,'(A,F12.5)')'# BEAM TILT ANGLE:     ',EBTILT
      WRITE(NBSOUT,'(A,F12.5)')'# BEAM ROTATION ANGLE: ',EBROT
      WRITE(NBSOUT,'(A,F12.5,A)')'# BEAM CURRENT:        ',
     &                            CURRENT,' nA'

*     ---WRITE DETECTOR INFORMATION TO FILE
*     X-RAY DETECTOR
      WRITE(NBSOUT,'(A)')'# X-RAY DETECTOR INFO:'
      WRITE(NBSOUT,'(2A)')'# DET#   TAKOFF  XDEROT    SOLIDA   FWHM   ',
     &                    '  ENFWHM  XDTYPE  XFDEFF'
      WRITE(NBSOUT,'(2A)')'#---------------------------------------',
     &                   '-------------------------------'
      DO 25 I=0,NXDET
          WRITE(NBSOUT,'(A,I4,F10.2,F8.2,F10.5,F8.2,F10.2,4A)')'#',
     &            I,DTAKOFF(I),DXDEROT(I),DSOLIDA(I),DFWHM(I),
     &            DENFWHM(I),'    ',DXDTYPE(I),'    ',
     &            DXFDEFF(I)(1:IEND(DXFDEFF(I)))
 25   CONTINUE

      WRITE(NBSOUT,'(2A)')'#=======================================',
     &                   '==============================='
      WRITE(NBSOUT,'(A)')'# BREMSSTRAHLUNGSPECTRA [COUNTS PER SECOND]'
      BUFFER=CBL//CBL//CBL//CBL
      WRITE(BUFFER(1:15),'(A)')'# ENERGY [KEV] '
      DO 30 J=0,MIN(NXDET,5)
         WRITE(BUFFER(16+15*J:30+15*J),'(A,I2,A)')'     DET#',J,'    '
 30   CONTINUE
      WRITE(NBSOUT,'(A)')BUFFER(1:IEND(BUFFER))
      WRITE(NBSOUT,'(2A)')'#---------------------------------------',
     &                   '-------------------------------'

      MXINDX=NDMAXDET*(NXCONT-1)+(MIN(NXDET,5)+1)
      IF (NXCONT.GT.0) CALL CHKBND (13,MXINDX,'WROUT','XDETOFXCONT')
      DO 50 I=1,NXCONT
         BUFFER=CBL//CBL//CBL//CBL
         WRITE(BUFFER(1:13),'(F13.7)')ENEROFXCONT(I)/1000
         DO 40 J=0,MIN(NXDET,5)
            INDX=NDMAXDET*(I-1)+(J+1)
            WRITE(BUFFER(14+15*J:28+15*J),'(E15.5)')
CS     &                             XDETOFXCONT(J,I)*6.24219725D9*
     &                             XDETOFXCONT(INDX)*6.24219725D9*
     &                             CURRENT*DSOLIDA(J)
 40      CONTINUE
         WRITE(NBSOUT,'(A)')BUFFER(1:IEND(BUFFER))
 50   CONTINUE

 999  CLOSE (NBSOUT)

      RETURN
      END
