/*****************************************************************************/
/*     Copyright (c) 2000, Compaq Computer Corporation                       */
/*                                                                           */
/*  See the file "license.terms" for information on usage and redistribution */
/*  of this file, and for a DISCLAIMER OF ALL WARRANTIES.                    */
/*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "xpgp.h"
#include "icon.bm"
#include "compaq_logo.bm"
#include "cec_logo_1.bm"
#include "sesame.bm"


#if !( defined(vms) || defined(__vms) )

#define F_Clear f_clear_
#define F_CloseDevice f_closedevice_
#define F_DrawString f_drawstring_
#define F_FilledCircle f_filledcircle_
#define F_FilledRectangle f_filledrectangle_
#define F_FilledRectangleS f_filledrectangles_
#define F_GetMousePressEvent f_getmousepressevent_
#define F_Rectangle f_rectangle_
#define F_RectangleS f_rectangles_
#define F_Ink f_ink_
#define F_Line f_line_
#define F_LineTo f_lineto_
#define F_Move f_move_
#define F_OpenPS f_openps_
#define F_Pen f_pen_
#define F_Plot f_plot_
#define F_PutBitmap f_putbitmap_
#define F_SetLineWidth f_setlinewidth_
#define F_SetFontSize f_setfontsize_
#define F_fFilledCircle f_ffilledcircle_
#define F_fFilledRectangle f_ffilledrectangle_
#define F_fFilledRectangleS f_ffilledrectangles_
#define F_fLine f_fline_
#define F_fLineTo f_flineto_
#define F_fShow f_fshow_
#define F_FilledTriangle f_filledtriangle_
#define F_fFilledTriangle f_ffilledtriangle_

#else 

#include <descrip.h>

#endif

#if !( defined(vms) || defined(__vms) )

char* osf_f2c_string(char* f_string,int length)
{
int i1;
char *p1;

i1 = lnblnk_(f_string,length);
if ((p1 = (char*)malloc((unsigned) i1+1)) == NULL)
   {
    printf("Error : Problem allocating memory in osf_f2c_string\n");
    free(p1); 
    return (char *) NULL;
   }
strncpy(p1,f_string,i1);
p1[i1] = '\0';
return p1;
}

#else

char* vms_f2c_string(struct dsc$descriptor_s *f_string)

{
int i1;
char *p1;

i1 = f_string->dsc$w_length;
if ((p1 = (char*)malloc((unsigned) i1+1)) == NULL)
   {
    printf("Error : Problem allocating memory in vms_f2c_string \n");
    free(p1); 
    return (char *) NULL;
   }
strncpy(p1,f_string->dsc$a_pointer,i1);
p1[i1] = '\0';
return p1;
}
#endif

#define BITMAPS 4
/* Bitmap definitions */

char *BitData[BITMAPS] = {compaq_logo_bits,cec_logo_1_bits,sesame_bits,sesame_bits};
unsigned int BitWidth[BITMAPS] = {compaq_logo_width,cec_logo_1_width,
           sesame_width,sesame_width};
unsigned int BitHeight[BITMAPS] = {compaq_logo_height,cec_logo_1_height,
           sesame_height,sesame_height};



/*int Arc(double x, double y, double r1, double r2, double a1, double a2); 
int Circle(double x, double y, double r); 
*/

void F_Clear(int *s)
{
*s = Clear(); 
}

/*
int ClearPalette(void); 
*/

void F_CloseDevice(int *n,int *s)
{
*s = CloseDevice(*n);
}

#if !( defined(vms) || defined(__vms) )
void F_DrawString(double *x,double *y,char *ftxt,int length)
{
char text[255];
int s;

strncpy(text,ftxt,length);
text[length] = '\0';
s = DrawString(*x,*y,text); 
}
#else

void F_DrawString(double *x,double *y,struct dsc$descriptor_s *f_text)
{
char *text;
int s;

text = vms_f2c_string(f_text);
s = DrawString(*x,*y,text); 
free(text);
}

#endif


/*
int Ellipse(double x, double y, double r1, double r2); 
int FilledArc(double x, double y, double r1, double r2, double a1, double a2); 
*/

void F_FilledCircle(double *x, double *y, double *r,int *s)
{
*s = FilledCircle(*x, *y, *r); 
}

/*
int FilledEllipse(double x, double y, double r1, double r2); 
*/

void F_FilledRectangle(double *x, double *y, double *width, double *height,int *s)
{
*s = FilledRectangle(*x,*y,*width,*height); 
}

void F_FilledRectangleS(double *x, double *y, double *x2, double *y2,int *s)
{
*s = FilledRectangleS(*x,*y,*x2,*y2); 
}

void F_FilledTriangle(double *x1, double *y1,double *x2, double *y2, double *x3, double *y3,int *s)
{
*s = FilledTriangle(*x1,*y1,*x2,*y2,*x3,*y3); 
}

void F_fFilledTriangle(double *x1, double *y1,double *x2, double *y2, double *x3, double *y3,int *s)
{
*s = fFilledTriangle(*x1,*y1,*x2,*y2,*x3,*y3); 
}


void F_GetMousePressEvent(int *x, int *y,unsigned int *status,int *s)
{
*s = GetMousePressEvent(x,y,status);
} 

void F_Ink(int *red,int *green,int *blue,int *s)
{
unsigned short R,G,B;
R = *red; G = *green; B = *blue;
*s = Ink(*red,*green,*blue); 
}

void F_Line(double *x1, double *y1, double *x2, double *y2, int *s)
{
*s = Line(*x1,*y1,*x2,*y2);
}

/*int LineR(double dx, double dy); 
*/

void F_LineTo(double *x, double *y,int *s) 
{
if ((*x != 0) || (*y !=0)) 
*s = LineTo(*x,*y);
else
*s = 0; 
}

void F_Move(double *x, double *y,int *s) 
{
*s = Move(*x,*y); 
}

/*
int MoveR(double dx, double dy); 
*/

#if !( defined(vms) || defined(__vms) )
void f_openps_(char* f_filename,int *orientation,int *s,int f_lfilename)
{
int i1;
char *filename;

filename = osf_f2c_string(f_filename,f_lfilename);

*s = OpenPS(filename,*orientation);

free(filename);
}

#else

void F_OpenPS(struct dsc$descriptor_s *f_filename,
	      int *orientation,int *s)
{
char* filename; 

filename = vms_f2c_string(f_filename);
*s = OpenPS(filename,*orientation);
free(filename);
}
#endif

#if !( defined(vms) || defined(__vms) )
void f_openbmp_(char* f_filename,int* width,int* height,int *s,int f_lfilename)
{
int i1;
char *filename;

filename = osf_f2c_string(f_filename,f_lfilename);

*s = OpenBMP(filename,*width,*height);

free(filename);
}

#else

void F_OpenBMP(struct dsc$descriptor_s *f_filename,
	      int* width,int* height,int *s)
{
char* filename; 

filename = vms_f2c_string(f_filename);
*s = OpenBMP(filename,*width,*height);
free(filename);
}
#endif


#if !( defined(vms) || defined(__vms) )
void f_openx_(int *width, int *height,int *xposition, int *yposition,
	     char* f_windowname,char* f_iconname,int *icon,int *s,
	      int f_lwindowname, int f_liconname)
{
int i1,i2;
char *windowname,*iconname;

windowname = osf_f2c_string(f_windowname,f_lwindowname);
iconname = osf_f2c_string(f_iconname,f_liconname);

*s = OpenXX(*width,*height,*xposition,*yposition,
            windowname,iconname,NULL,icondata[*icon]);

free(windowname);
free(iconname);
}

#else

void F_OpenX(int *width,int *height,int *xposition, int *yposition,
      	     struct dsc$descriptor_s *f_windowname,
      	     struct dsc$descriptor_s *f_iconname,
	     int *icon,int *s)
{
char *windowname,*iconname; 
windowname = vms_f2c_string(f_windowname);
iconname =   vms_f2c_string(f_iconname);

*s = OpenXX(*width,*height,*xposition,*yposition,
             windowname,iconname,NULL,icondata[*icon]);

free(windowname);
free(iconname);
}

#endif

#if !( defined(vms) || defined(__vms) ) 
void f_outputto_(int *n,int *s)
{
*s = OutputTo(*n);
}
#else
void f_outputto(int *n,int *s)
{
*s = OutputTo(*n);
}
#endif

void F_Pen(int *color,int *s)
{
*s = Pen(*color); 
}

void F_Plot(double *x, double *y,int *s) 
{
*s = Plot(*x, *y); 
}

/*
int PlotQP(double x, double y); 
int PlotR(double dx, double dy); 
*/

void F_PutBitmap(double *x,double *y,int *bitmapnr,int *fg,int *bg)
{
PutBitmap(*x,*y,BitData[*bitmapnr],BitWidth[*bitmapnr],BitHeight[*bitmapnr],
               *fg,*bg);
}



void F_Rectangle(double *x, double *y, double *width, double *height, int *s)
{ 
*s = Rectangle(*x, *y, *width, *height);
}

void F_RectangleS(double *x1, double *y1, double *x2, double *y2,int *s)
{
*s = RectangleS(*x1, *y1, *x2, *y2); 
}


/*
int ResetPalette(void); 
int SetBackground(int color); 
int SetDash(double b, double w); 
*/

void F_SetFontSize(double *size,int *s)
{
*s = SetFontSize(*size); 
}

void F_SetLineWidth(double *w,int *s)
{
*s = SetLineWidth(*w); 
}

/*
int SetQP(double d, int shape); 
int fArc(double x, double y, double r1, double r2, double a1, double a2); 
int fCircle(double x, double y, double r); 
int fDrawString(double x, double y, char *text); 
int fEllipse(double x, double y, double r1, double r2); 
int fFilledArc(double x, double y, double r1, double r2, double a1, double a2); 
*/

void F_fFilledCircle(double *x, double *y, double *r,int *s)
{
*s = fFilledCircle(*x, *y, *r); 
}

/*
int fFilledEllipse(double x, double y, double r1, double r2); 
*/
void F_fFilledRectangle(double *x, double *y, double *width, double *height,int *s) 
{
*s = fFilledRectangle(*x, *y, *width, *height); 
}

void F_fFilledRectangleS(double *x1, double *y1, double *x2, double *y2, int *s) 
{
*s = fFilledRectangleS(*x1, *y1, *x2, *y2); 
}

void F_fLine(double *x1, double *y1, double *x2, double *y2, int *s)
{
if (*x1 != *x2 || *y2 != *y1)
  *s = fLine(*x1,*y1,*x2,*y2);
else 
  *s = 0;
}

/*
int fLineR(double dx, double dy); 
*/

void F_fLineTo(double *x, double *y,int *s) 
{
if ((*x == 0) && (*y == 0)) 
*s = 0;
else
*s = fLineTo(*x,*y);
}

/*
int fPlot(double x, double y); 
int fPlotQP(double x, double y); 
int fPlotR(double dx, double dy); 
int fRectangle(double x, double y, double width, double height); 
int fRectangleS(double x1, double y1, double x2, double y2); 
*/

void F_fShow(int *s)
{
*s = fShow();
}
