c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
      SUBROUTINE ZPHI(
     V		      Z,FRAC,
     I		      R,MODE)

***  a.) INITIALIZE ZPHITABLE AND 
*    b.) MONTECARLO GENERATOR FOR Z(PHI)

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'GLOBAL.INC'
      INCLUDE 'COMMON.INC'

      DOUBLE PRECISION Z,FRAC,RAND
      INTEGER MODE
*     Z    - RANDOM SELECTED Z
*     FRAC - ELECTRON FRACTION
*     RAND - RANDOM NUMBER
*     MODE - 0    : INITIALIZE MONTE CARLO GENERATOR
*          - ELSE : MONTE CARLO GENERATOR
*
**    AUTHOR H.WAGNER  1-SEP-1994
*
**    START OF EXECUTABLE CODE
**    ************************

      INTEGER MAXZPHI
      PARAMETER (MAXZPHI=100)
      INTEGER I,J,NDATA
      DOUBLE PRECISION PHI,PHITOTAL
      DOUBLE PRECISION ZPHITAB(0:MAXZPHI)
      DOUBLE PRECISION ZHELP(200),PHIHELP(200)

      IF (MODE .EQ.0) GOTO 1000
         
*     MC GENERATOR Z(R)
*     =================

      R = R * DBLE(MAXZPHI)
      I = AINT(R)
      R = R - DBLE(I)
      Z = ZPHITAB(I)*(1-R) + ZPHITAB(I+1)*R       
C      WRITE(*,*) Z
      GOTO 2000



*     INITIALIZE
*     ==========

C     READ PHI(Z) FILE

1000  CALL STATXT ('INITIALIZING Z(PHI) TABLE')

      OPEN(17,FILE=FPHI,CARRIAGECONTROL='LIST',STATUS='OLD')
      NDATA = 1

1010    READ(17,*,END=1100) ZHELP(NDATA),PHIHELP(NDATA)
        NDATA = NDATA + 1
        IF (NDATA.GT.200) THEN
      	   WRITE(*,*)'*** FATAL ERROR ! ***'
      	   WRITE(*,*)'FPHI EXCEEDS 200 DATA POINTS'
      	   STOP
      	ENDIF
        GOTO 1010

1100  CLOSE(17)
     
C     INTEGRATE PHI(Z)
      
      Q = DSIMPSON(0,0,-1)
      DO 1200 I=1,NDATA
      	PHIHELP(I) = DSIMPSON(ZHELP(I),PHIHELP(I),0)
1200  CONTINUE

      PHITOTAL = PHIHELP(NDATA)
     
C     INVERT INTEGRATED PHI(Z)

      DO 1300 I = 0,MAXZPHI
        PHI = DBLE(I)/DBLE(MAXZPHI)*PHITOTAL        
        J = 2
1350    IF (PHIHELP(J) .LT. PHI) THEN
          J = J + 1
          IF (J .LE. NDATA) GOTO 1350
        ENDIF
        ZPHITAB(I) = (ZHELP(J)-ZHELP(J-1))/(PHIHELP(J)-PHIHELP(J-1))*
     .		     (PHI-PHIHELP(J-1)) + ZHELP(J-1)
1300  CONTINUE
      
2000  FRAC = PHITOTAL
      END
