c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
c     Utility routines to get arguments passed on command line.
c     VAX/VMS
c
      subroutine getarg (iarg, arg)
      integer iarg
      character*(*) arg
c
c      This routine returns argument number iarg.
c
      integer jarg,i
c
      jarg = 0
      i = 1
      do while (i .gt. 0 .and. jarg .lt. iarg)
        call argfind (i, arg)
        jarg = jarg + 1
      end do
      return
      end  ! Subroutine getarg
c
c
      integer function iargc()
c
c      Counts the number of arguments on the command line
c
      integer i
      character*1 xarg
c
      iargc = 0
      i = 1
      call argfind (i, xarg)
      do while (i .gt. 0)
        iargc = iargc + 1
        call argfind (i, xarg)
      end do
      return
      end ! function iargc
c
c
      subroutine argfind (i, arg)
      integer i
      character*(*) arg
c
c       Utility routine used by getargs and iargc to bracket the 
c       next argument in the buffer.
c
      character*132 buffer
      integer*2 length
      integer j
      data length/-1/
c
c     The command line is one string.
      if (length .lt. 0) call lib$get_foreign (buffer,
     1  'Input and Output files: ', length, )
c     Arguments are delimited by blanks.
      j = i
      do while (j .le. length .and. buffer(j:j) .eq. ' ')
        j = j + 1
      end do
      i = j
      do while (i .le. length .and. buffer(i:i) .ne. ' ')
        i = i + 1
      end do
      if (j .gt. length) then
        arg = ' '
        i = 0
      else
        arg = buffer(j:i-1)
      end if
      return
      end  ! Subroutine argfind

c
c subroutine dotfind is used to get the length and the dot position in
c filename
c
      subroutine dotfind (arg,l,idot)
      character*(*) arg
      integer*2 i,j,l,idot,length
c
c remove Leading blanks if any
c
      length = len(arg)
      j = 1
      idot = -1
      do while (j .le. length .and. arg(j:j) .eq. ' ')
        j = j + 1
      end do
      i = j
      do while (i .le. length .and. arg(i:i) .ne. ' ')
        i = i + 1
	if (arg(i:i) .eq. '.' ) idot = i - j 
      end do
      if (j .gt. length) then
        arg = ' '
      else
        arg = arg(j:i-1)
	if (idot .lt. 0 ) then
		l   = i-j
	else
		l   = idot 
	end if
      end if
      return
      end  ! Subroutine dotfind


   
      SUBROUTINE ZZZNOD (
     O                   NODNAM)

***   ZZZNOD - RETURNS THE NODE NAME WHERE THE PROGRAM IS EXECUTED
*
**    AUTHOR:   H.STIPPEL 03-05-1994
*
**    ARGUMENT LIST
*
*        NODNAM - NODE NAME
*
      CHARACTER*(*) NODNAM
      EXTERNAL      SYI$_NODENAME

**    START OF EXECUTABLE CODE
*     ************************

      CALL LIB$GETSYI(%LOC(SYI$_NODENAME),,NODNAM,LENGTH)

      RETURN
      END
