c
c     Copyright (c) 2000, Compaq Computer Corporation
c
c     See the file "license.terms" for information on usage and redistribution
c     of this file, and for a DISCLAIMER OF ALL WARRANTIES.
c
* last modification: CS 10-Nov-1997

      SUBROUTINE INIOUT (NELMNT,XMIN,XMAX,ZMIN,ZMAX,
     &                   EPRIM,NHISXCONT)

*     INIOUT - INITIALIZATION OF OUTPUT (SCREEN, PROMIS SAVE FILE,
*              POSTSCRIPT AND HISTOGRAM) PARAMETERS
*
*     XMIN  - MINIMUM X-VALUE OF GEOMETRY
*     XMAX  - MAXIMUM X-VALUE OF GEOMETRY
*     ZMIN  - MINIMUM Z-VALUE OF GEOMETRY
*     ZMAX  - MAXIMUM Z-VALUE OF GEOMETRY
*     EPRIN - PRIMARY ENERGY OF ELECTRONS
*     NHISXCONT - NUMBER OF STUETZSTELLEN FOR XKS/XRS HISTOGRAMS
*
*     REMARKS
*
*     1) NO REMARKS PRESENTLY
*
*     AUTHOR:  C.SCHIEBL   NOVEMBER 1994

      INCLUDE 'TYPE.INC'
      INCLUDE 'PARAM.INC'
      INCLUDE 'COMMON.INC'
      INCLUDE 'HIST.INC'
      INCLUDE 'OUTPUT.INC'

      DIMENSION NDUMMY(MAXDIM+18),RDY(2*MAXDIM+2)
      DIMENSION IHELP(MAXELE,MXAUGP)
      CHARACTER*70 CDUMMY,CDY,ADDSTR
      CHARACTER*10 CBL

**    START OF EXECUTABLE CODE
*     ************************

*     SOME INITIALIZATION
      NXCSHIS=0
      NXKSHIS=0
      NHISXCONT=0
      DO 1 I=1,MAXXCSHIS
         XCSHIS(I)=0
         XCSDET(I)=0
 1    CONTINUE

*     INITIALIZE HBND
      HBND=ONE-EPSMA

*     DETERMINE ELECTRON SENSITIVE ENERGY RANGE
      DO 2 IEDT=0,NEDET
         ELDETWIN(IEDT,1)=MAX(EF,EDTRN(IEDT,1,1))
         ELDETWIN(IEDT,1)=MIN(ELDETWIN(IEDT,1),E0)
         ELDETWIN(IEDT,2)=E0
         IF (ELDETWIN(IEDT,1).GE.ELDETWIN(IEDT,2)) ELDETWIN(IEDT,1)=EF
 2    CONTINUE

*     ALLOW MARGIN FOR LOCATION DEPENDENT OUTPUT TO SCREEN
      SCM=SCMARG
      IF (SCM.LT.1) SCM=0.15
      XDELT=XMAX-XMIN
      ZDELT=ZMAX-ZMIN
      DELT=MAX(XDELT,ZDELT)
      XMINSC=XMIN-DELT*SCM*2/3
      XMAXSC=XMAX+DELT*SCM*2/3
      ZMINSC=ZMIN-DELT*SCM
      ZMAXSC=ZMAX+DELT*SCM
      ZMNSCD=ZMIN-DELT*SCM*2/3
      ZMXSCD=ZMAX+DELT*SCM*2/3
*     THESE SCREEN VALUES ARE IN ANGSTROM - MAKE SURE TO USE SAME
*     UNITS AS IN INPUT DECK
      XMINSC=XMINSC/DUNITS
      XMAXSC=XMAXSC/DUNITS
      ZMINSC=ZMINSC/DUNITS
      ZMAXSC=ZMAXSC/DUNITS
*     SOME INITIALIZATION
      CBL='          '
      LPMHIS=.FALSE.
      LPMION=.FALSE.
      NHIST=0
      NVTOT=0
      NBEHIS=0
      NTEHIS=0
      NSEHIS=0
      NAEHIS=0
      LBE=.FALSE.
      LTE=.FALSE.
      LSE=.FALSE.
      LAE=.FALSE.
      LIO=.FALSE.
      LXR=.FALSE.
      LANG=.FALSE.
      LAANG=.FALSE.
      LPANG=.FALSE.
      LENERG=.FALSE.
      DO 4 I=1,MXHIST
         HISSCR(I)=0
         DO 3 J=1,3
            LOUTTO(I,J)=.FALSE.
            LENGY(I,J)=.FALSE.
            LAZIMU(I,J)=.FALSE.
            LPOLAR(I,J)=.FALSE.
 3       CONTINUE
 4    CONTINUE
      DO 7 I=1,MAXELE
         DO 6 J=1,MAXSHELL
            NSHELLSCR(I,J)=0
            DO 5 K=1,MAXSCR
               SHELLSCR(J,I,K)=0
 5          CONTINUE
 6       CONTINUE
 7    CONTINUE
      IIONHIS=0

*     ---PARSE INFORMATION FROM SCREEN ARRAY (OUTPUT TO SCREEN)
      IF (LSCRN1) THEN
*        INITIALIZE SOME PARAMETERES
         NS=0
         ISCL=0
         NSCL=0
         NSCH=0
         NQUAD=0
         NSCRN=0
         LLOC=.FALSE.
         LSCLOC=.FALSE.
         LSCHIS=.FALSE.
         DO 9 I=1,NTOSCL
            DO 8 J=1,MAXSCR
               LOCOUT(I,J)=0
 8          CONTINUE
 9       CONTINUE
*        DETERMINE NUMBER OF SCREEN OUTPUT (CAN BE GREATER THAN OPEN SCREENS)
         DO 11 I=1,2*MAXSCR
            IF (SCREEN(I)(1:3).NE.'   ') NS=I
 11	 CONTINUE
	 ISTART=1
	 IF (LSCDEF) ISTART=0
	 DO 13 I=ISTART,NS
            IF (SCREEN(I)(1:3).EQ.'   ') GOTO 13
            IFND=0
            DO 12 J=1,NTOSCR
               IF (SCREEN(I)(1:3).EQ.CTOSCR(J)) IFND=1
 12         CONTINUE
            IF (IFND.EQ.0) THEN
               WRITE(*,'(A)')'   '
               WRITE(*,'(3A)')' WARNING: ',SCREEN(I)(1:3),
     &                        ' IS NOT A VALID ABBREVIATION IN SCREEN'
            ENDIF
 13      CONTINUE
         DO 15 I=1,NTOSCL
            NLOCSC(I)=0
            NLOCPS(I)=0
            NLOCOUT(I)=0
 15      CONTINUE
	 DO 25 I=ISTART,NS
            II=0
            IF (SCREEN(I)(1:3).EQ.'PET') THEN
*              TRAJECTORIES OF PRIMARY ELECTRONS
               II=1
            ELSE IF (SCREEN(I)(1:3).EQ.'BET') THEN
*              TRAJECTORIES OF BACKSCATTERED ELECTRONS
               II=2
               LEBACK=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'TET') THEN
*              TRAJECTORIES OF TRANSMITTED ELECTRONS
               II=3
               LETRAN=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'SET') THEN
*              TRAJECTORIES OF SECONDARY ELECTRONS
               II=4
               LESEC=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'AET') THEN
*              TRAJECTORIES OF AUGER ELECTRONS
               II=5
               LEAUG=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'ION') THEN
*              LOCATION OF IONIZATIONS
               II=6
               LION=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'PEB') THEN
*              PRIMARY ELECTRON BEAM
               II=7
            ELSE IF (SCREEN(I)(1:3).EQ.'IOD') THEN
*              LOCATION DEPENDENT IONIZATION DISTRIBUTION
               II=8
               LIODIS=.TRUE.
               LGRD=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'XGD') THEN
*              LOCATION DEPENDENT GENERATED CHAR. X-RAY DISTRIBUTION
               II=9
               LXCHAR=.TRUE.
               LGRD=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'XDD') THEN
*              LOCATION DEPENDENT DETECTED CHAR. X-RAY DISTRIBUTION
               II=10
               LXCHAR=.TRUE.
               LINIABS=.TRUE.
               LGRD=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'AGD') THEN
*              LOCATION DEPENDENT GENERATED AUGER DISTRIBUTION
               II=11
               LEAUG=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'ADD') THEN
*              LOCATION DEPENDENT DETECTED AUGER DISTIBUTION
               II=12
               LEAUG=.TRUE.
               LDELE(5)=.TRUE.
            ELSE
               GOTO 25
            ENDIF
            NLOCSC(II)=NLOCSC(II)+1
            NLOCOUT(II)=NLOCSC(II)
            ISCL=ISCL+1
            LSCLOC=.TRUE.
            NSCINP(ISCL)=I
            CALL EXTOUT (1,1,I,II,SCREEN(I),
     1                   XMINSC,XMAXSC,ZMINSC,ZMAXSC,0.D0,0.D0,
     2                   NMSC,N2DMY,NDUMMY,RDY,CDUMMY)
            NSCO=NMSC
            DO 16 IK=1,6
               SCMIMA(IK,I)=SCMIMA(IK,I)*DUNITS
 16         CONTINUE
            IF (NSCINP(ISCL).EQ.NSCO) THEN
               NSCL=NSCL+1
	       NSCOUT(ISCL)=NSCL
	       IF (NDUMMY(4).GT.0) SCXOFF(NSCL)=NDUMMY(4)
	       IF (NDUMMY(5).GT.0) SCYOFF(NSCL)=NDUMMY(5)
	       IF (NDUMMY(6).GT.0) SCXSIZ(NSCL)=NDUMMY(6)
	       IF (NDUMMY(7).GT.0) SCYSIZ(NSCL)=NDUMMY(7)
               XDELTA=SCMIMA(2,I)-SCMIMA(1,I)
               ZDELTA=SCMIMA(4,I)-SCMIMA(3,I)
               IF ((SCXSIZ(NSCL).EQ.NSCXSI).AND.
     &             (SCYSIZ(NSCL).EQ.NSCYSI)) THEN
*                 BOTH DIRECTIONS DEFAULT SCREEN SIZE
*                 SMALLER IS REFERENCE
                  IF (SCXSIZ(NSCL).LT.SCYSIZ(NSCL)) THEN
                     SCYSIZ(NSCL)=INT(SCXSIZ(NSCL)*ZDELTA/XDELTA+0.5)
                     IF (SCYSIZ(NSCL).GT.MXYPIX) THEN
                        SCYSIZ(NSCL)=MXYPIX
                        SCXSIZ(NSCL)=INT(SCYSIZ(NSCL)*XDELTA/
     &                               ZDELTA+0.5)
                     ENDIF
                  ELSE
                     SCXSIZ(NSCL)=INT(SCYSIZ(NSCL)*XDELTA/ZDELTA+0.5)
                     IF (SCXSIZ(NSCL).GT.MXXPIX) THEN
                        SCXSIZ(NSCL)=MXXPIX
                        SCYSIZ(NSCL)=INT(SCXSIZ(NSCL)*ZDELTA/
     &                               XDELTA+0.5)
                     ENDIF
                  ENDIF
               ELSE IF ((SCXSIZ(NSCL).EQ.NSCXSI).AND.
     &             (SCYSIZ(NSCL).NE.NSCYSI)) THEN
*                 Y DIRECTION EXPLICITELY SPECIFIED
*                 Y IS REFERENCE
                  SCXSIZ(NSCL)=INT(SCYSIZ(NSCL)*XDELTA/ZDELTA+0.5)
                  IF (SCXSIZ(NSCL).GT.MXXPIX) THEN
                     SCXSIZ(NSCL)=MXXPIX
                     SCYSIZ(NSCL)=INT(SCXSIZ(NSCL)*ZDELTA/
     &                            XDELTA+0.5)
                  ENDIF
               ELSE IF ((SCXSIZ(NSCL).NE.NSCXSI).AND.
     &             (SCYSIZ(NSCL).EQ.NSCYSI)) THEN
*                 X DIRECTION EXPLICITELY SPECIFIED
*                 X IS REFERENCE
                  SCYSIZ(NSCL)=INT(SCXSIZ(NSCL)*ZDELTA/XDELTA+0.5)
                  IF (SCYSIZ(NSCL).GT.MXYPIX) THEN
                     SCYSIZ(NSCL)=MXYPIX
                     SCXSIZ(NSCL)=INT(SCYSIZ(NSCL)*XDELTA/
     &                            ZDELTA+0.5)
                  ENDIF
               ELSE
*                 BOTH DIRECTIONS SPECIFIED
*                 TAKE BOTH AS SPECIFIED (DISTORTED)
                  IF (SCXSIZ(NSCL).GT.MXXPIX) SCXSIZ(NSCL)=MXXPIX
                  IF (SCYSIZ(NSCL).GT.MXYPIX) SCYSIZ(NSCL)=MXYPIX
               ENDIF
            ELSE
               NN=0
               DO 17 IK=1,ISCL-1
                  IF (NSCINP(IK).EQ.NSCO) NN=IK
 17            CONTINUE
               IF (NN.EQ.0) THEN
                  NSCL=NSCL+1
                  NSCOUT(ISCL)=NSCL
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%% '
                  WRITE(6,'(A)')' Screen number specified in:'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(A)')' points to nowhere !'
                  WRITE(6,'(A,I2,A)')' The screen number',NSCO,
     &                 ' must point to an already specified SCREEN !'
                  WRITE(6,'(2A)')' This output will be directed to',
     &                           ' a new window on your screen.'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
               ELSE
                  NSCOUT(ISCL)=NSCOUT(NN)
               ENDIF
            ENDIF
            ISTT=IEND(SCRTITLE(NSCOUT(ISCL)))
            IF (ISTT.GT.1) THEN
               IFLG=0
               DO 18,IK=1,LEN(SCRTITLE(NSCOUT(ISCL)))/4
                  IF (SCRTITLE(NSCOUT(ISCL))(1+4*(IK-1):3+4*(IK-1))
     &                .EQ.SCREEN(I)(1:3)) IFLG=1
 18            CONTINUE
               IF (IFLG.EQ.0) THEN
                  SCRTITLE(NSCOUT(ISCL))(ISTT+1:ISTT+1)=','
                  SCRTITLE(NSCOUT(ISCL))(ISTT+2:ISTT+4)=SCREEN(I)(1:3)
               ENDIF
            ELSE
               SCRTITLE(NSCOUT(ISCL))(1:3)=SCREEN(I)(1:3)
            ENDIF
            DO 19 J=1,6
               SCMIMA(J,I)=SCMIMA(J,NSCO)
               SCMNMX(J,NSCOUT(ISCL))=SCMIMA(J,I)
 19         CONTINUE
            LOCOUT(II,NLOCSC(II))=NSCOUT(ISCL)
            IF (II.EQ.5) THEN
               XCIODIS6(NDUMMY(8),NDUMMY(9),3)=
     &                  XCIODIS6(NDUMMY(8),NDUMMY(9),3)+1
               IJK=XCIODIS6(NDUMMY(8),NDUMMY(9),3)
               XCIODIS5(NDUMMY(8),NDUMMY(9),IJK,3)=
     &                               LOCOUT(II,NLOCSC(II))
            ELSE IF (II.EQ.6) THEN
*              UPDATE SHELLSCR
               DO 21 IE=1,MAXELE
                  DO 20 IS=1,MAXSHELL
                     ISCR=NSHELLSCR(IE,IS)
                     IF (ISCR.LE.0) GOTO 20
                     IF (SHELLSCR(IS,IE,ISCR).EQ.(MAXSCR+1)) THEN
                        SHELLSCR(IS,IE,ISCR)=LOCOUT(II,NLOCSC(II))
                     ENDIF
 20               CONTINUE
 21            CONTINUE
               IIE=IEND(SCRTITLE(NSCOUT(ISCL)))
               IIE1=IEND(CDUMMY)
               SCRTITLE(NSCOUT(ISCL))(IIE+1:IIE+IIE1+1)=
     &                  ';'//CDUMMY(1:IEND(CDUMMY))
            ELSE IF ((II.GT.7).AND.(II.LT.11)) THEN
               IF ((II.EQ.9).OR.(II.EQ.10)) THEN
cs scrofxcg and scrofxcd moved from shell to xchar tables!
cs                  DO 22 LK=1,NDUMMY(20)
cs                     IF (NDUMMY(8+LK).EQ.1) NDUMMY(8+LK)=1
cs                     IF (NDUMMY(8+LK).EQ.2) NDUMMY(8+LK)=1
cs                     IF (NDUMMY(8+LK).EQ.3) NDUMMY(8+LK)=1
cs                     IF (NDUMMY(8+LK).EQ.4) NDUMMY(8+LK)=4
cs                     IF (NDUMMY(8+LK).EQ.5) NDUMMY(8+LK)=4
cs                     IF (NDUMMY(8+LK).EQ.6) NDUMMY(8+LK)=3
cs                     IF (NDUMMY(8+LK).EQ.7) NDUMMY(8+LK)=4
cs                     IF (NDUMMY(8+LK).EQ.8) NDUMMY(8+LK)=2
cs                     IF (NDUMMY(8+LK).EQ.9) NDUMMY(8+LK)=9
cs                     IF (NDUMMY(8+LK).EQ.10) NDUMMY(8+LK)=8
cs 22               CONTINUE
                  IIE=IEND(SCRTITLE(NSCOUT(ISCL)))
                  IF (II.EQ.10) THEN
                     CDUMMY(IEND(CDUMMY)+1:IEND(CDUMMY)+5)=';DET#'
                  ENDIF
                  IIE1=IEND(CDUMMY)
                  IF (II.EQ.10) THEN
                     IF (N2DMY.GT.99) N2DMY=1
                     IF (N2DMY.LT.10) THEN
                        WRITE(CDUMMY(IIE1+1:IIE1+1),'(I1)')N2DMY
                        IIE1=IIE1+1
                     ELSE
                        WRITE(CDUMMY(IIE1+1:IIE1+2),'(I2)')N2DMY
                        IIE1=IIE1+2
                     ENDIF
                  ENDIF
                  SCRTITLE(NSCOUT(ISCL))(IIE+1:IIE+IIE1+1)=
     &                     ';'//CDUMMY(1:IEND(CDUMMY))
               ENDIF
               DO 23 LK=1,NDUMMY(20)
                  IF (NDUMMY(8+LK).EQ.1) IXCSHELL=1
                  IF (NDUMMY(8+LK).EQ.2) IXCSHELL=1
                  IF (NDUMMY(8+LK).EQ.3) IXCSHELL=1
                  IF (NDUMMY(8+LK).EQ.4) IXCSHELL=4
                  IF (NDUMMY(8+LK).EQ.5) IXCSHELL=4
                  IF (NDUMMY(8+LK).EQ.6) IXCSHELL=3
                  IF (NDUMMY(8+LK).EQ.7) IXCSHELL=4
                  IF (NDUMMY(8+LK).EQ.8) IXCSHELL=2
                  IF (NDUMMY(8+LK).EQ.9) IXCSHELL=9
                  IF (NDUMMY(8+LK).EQ.10) IXCSHELL=8
                  IF (XCIODIS1(NDUMMY(8),IXCSHELL).EQ.0) THEN
                     IIONHIS=IIONHIS+1
                     XCIODIS1(NDUMMY(8),IXCSHELL)=IIONHIS
                  ENDIF
                  XCIODIS21(NDUMMY(8),NDUMMY(8+LK),II-7)=
     &                XCIODIS21(NDUMMY(8),NDUMMY(8+LK),II-7)+1
                  LK1=XCIODIS21(NDUMMY(8),NDUMMY(8+LK),II-7)
                  XCIODIS2(NDUMMY(8),NDUMMY(8+LK),II-7,LK1)=
     &                               LOCOUT(II,NLOCSC(II))
                  IF ((II.GE.8).AND.(II.LE.10)) THEN
                     XCIODIS2(NDUMMY(8),NDUMMY(8+LK),II-3,LK1)=
     &                                  NDUMMY(21)
                  ENDIF
                  IF (II.EQ.10) THEN
                     XCIODIS2(NDUMMY(8),NDUMMY(8+LK),II-6,LK1)=
     &                                  N2DMY
                  ENDIF
 23            CONTINUE
               IF (II.EQ.8) THEN
                  IIE=IEND(SCRTITLE(NSCOUT(ISCL)))
                  IIE1=IEND(CDUMMY)
                  SCRTITLE(NSCOUT(ISCL))(IIE+1:IIE+IIE1+1)=
     &                     ';'//CDUMMY(1:IEND(CDUMMY))
               ENDIF
               IIE=IEND(SCRTITLE(NSCOUT(ISCL)))
               IF (NDUMMY(21).GT.0) THEN
                  SCRTITLE(NSCOUT(ISCL))(IIE+1:IIE+5)=';[Log'
                  WRITE(SCRTITLE(NSCOUT(ISCL))(IIE+6:IIE+12),'(F7.3)')
     &                  DBLE(NDUMMY(21))/1E6
                  SCRTITLE(NSCOUT(ISCL))(IIE+13:IIE+13)=']'
               ELSE
                  SCRTITLE(NSCOUT(ISCL))(IIE+1:IIE+6)=';[Lin]'
               ENDIF
            ELSE IF (II.EQ.11) THEN
               XCIODIS6(NDUMMY(8),NDUMMY(9),1)=
     &                  XCIODIS6(NDUMMY(8),NDUMMY(9),1)+1
               IJK=XCIODIS6(NDUMMY(8),NDUMMY(9),1)
               XCIODIS5(NDUMMY(8),NDUMMY(9),IJK,1)=
     &                               LOCOUT(II,NLOCSC(II))
            ELSE IF (II.EQ.12) THEN
               XCIODIS6(NDUMMY(8),NDUMMY(9),2)=
     &                  XCIODIS6(NDUMMY(8),NDUMMY(9),2)+1
               IJK=XCIODIS6(NDUMMY(8),NDUMMY(9),2)
               XCIODIS5(NDUMMY(8),NDUMMY(9),IJK,2)=
     &                               LOCOUT(II,NLOCSC(II))
               XCIODIS5(NDUMMY(8),NDUMMY(9),IJK,4)=N2DMY
            ENDIF
 25      CONTINUE
*        FROM HERE ON DATA FOR SCREEN OUTPUT IS STORED IN HISTOGRAM
*        ARRAY VALHIS
*        SOME INITIALIZATION
         IIK=NTOSCL+1
         DO 50 I=ISTART,NS
            IF (SCREEN(I)(1:3).EQ.'BEE') THEN
*              ENERGY DISTRIBUTION OF BACKSCATTERED ELECTRONS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      0.D0,EPRIM,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LENGY(NHIST,1)=.TRUE.
               LBE=.TRUE.
               LENERG=.TRUE.
               LEBACK=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'TEE') THEN
*              ENERGY DISTRIBUTION OF TRANSMITTED ELECTRONS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      0.D0,EPRIM,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NTEHIS=NTEHIS+1
               TEHIS(NTEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LENGY(NHIST,1)=.TRUE.
               LTE=.TRUE.
               LENERG=.TRUE.
               LETRAN=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'SEE') THEN
*              ENERGY DISTRIBUTION OF SECONDARY ELECTRONS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      0.D0,EPRIM,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NSEHIS=NSEHIS+1
               SEHIS(NSEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LENGY(NHIST,1)=.TRUE.
               LSE=.TRUE.
               LENERG=.TRUE.
               LESEC=.TRUE.
               LDELE(4)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'BEA') THEN
*              AZIMUTHAL ANGLE DISTRIBUTION OF BACKSCATTERED ELECTRONS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      0.D0,DEFAZI,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LAZIMU(NHIST,1)=.TRUE.
               LBE=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LEBACK=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'TEA') THEN
*              AZIMUTHAL ANGLE DISTRIBUTION OF TRANSMITTED ELECTRONS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      0.D0,DEFAZI,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NTEHIS=NTEHIS+1
               TEHIS(NTEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LAZIMU(NHIST,1)=.TRUE.
               LTE=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LETRAN=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'SEA') THEN
*              AZIMUTHAL ANGLE DISTRIBUTION OF SECONDARY ELECTRONS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      0.D0,DEFAZI,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NSEHIS=NSEHIS+1
               SEHIS(NSEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LAZIMU(NHIST,1)=.TRUE.
               LSE=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LESEC=.TRUE.
               LDELE(4)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'AEA') THEN
*              AZIMUTHAL ANGLE DISTRIBUTION OF AUGER ELECTRONS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      0.D0,DEFAZI,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NAEHIS=NAEHIS+1
               AEHIS(NAEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               XCIODIS8(NDUMMY(8),NDUMMY(9))=
     &                        XCIODIS8(NDUMMY(8),NDUMMY(9))+1
               IJK=XCIODIS8(NDUMMY(8),NDUMMY(9))
               XCIODIS7(NDUMMY(8),NDUMMY(9),IJK)=NHIST
               LAZIMU(NHIST,1)=.TRUE.
               LAE=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LEAUG=.TRUE.
               LDELE(5)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'BEP') THEN
*              POLAR ANGLE DISTRIBUTION OF BACKSCATTERED ELECTRONS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      0.D0,DEFPOL,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LPOLAR(NHIST,1)=.TRUE.
               LBE=.TRUE.
               LANG=.TRUE.
               LPANG=.TRUE.
               LEBACK=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'TEP') THEN
*              POLAR ANGLE DISTRIBUTION OF TRANSMITTED ELECTRONS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      0.D0,DEFPOL,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NTEHIS=NTEHIS+1
               TEHIS(NTEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LPOLAR(NHIST,1)=.TRUE.
               LTE=.TRUE.
               LANG=.TRUE.
               LPANG=.TRUE.
               LETRAN=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'SEP') THEN
*              POLAR ANGLE DISTRIBUTION OF SECONDARY ELECTRONS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      0.D0,DEFPOL,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NSEHIS=NSEHIS+1
               SEHIS(NSEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LPOLAR(NHIST,1)=.TRUE.
               LSE=.TRUE.
               LANG=.TRUE.
               LPANG=.TRUE.
               LESEC=.TRUE.
               LDELE(4)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'AEP') THEN
*              POLAR ANGLE DISTRIBUTION OF AUGER ELECTRONS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      0.D0,DEFPOL,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NAEHIS=NAEHIS+1
               AEHIS(NAEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               XCIODIS8(NDUMMY(8),NDUMMY(9))=
     &                        XCIODIS8(NDUMMY(8),NDUMMY(9))+1
               IJK=XCIODIS8(NDUMMY(8),NDUMMY(9))
               XCIODIS7(NDUMMY(8),NDUMMY(9),IJK)=NHIST
               LPOLAR(NHIST,1)=.TRUE.
               LAE=.TRUE.
               LANG=.TRUE.
               LPANG=.TRUE.
               LEAUG=.TRUE.
               LDELE(5)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'BEL') THEN
*              SPACIAL RESOLUTION OF BACKSCATTERED ELECTRONS IN X-DIRECTION
               DEFXMN=(XESPOT-30000)/DUNITS
               DEFXMX=(XESPOT+30000)/DUNITS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      DEFXMN,DEFXMX,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LBE=.TRUE.
               LEBACK=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'BEH') THEN
*              SPACIAL RESOLUTION OF BACKSCATTERED ELECTRONS IN Y-DIRECTION
               DEFYMN=-30000/DUNITS
               DEFYMX=30000/DUNITS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      DEFYMN,DEFYMX,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LBE=.TRUE.
               LEBACK=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'TEB') THEN
*              TRANSMITTED ELECTRONS: BEAM BROADENING
               IF (SCAN) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' Since SCAN=T the specification',
     1            ' of beam broadening in SCREEN(',I,') is useless !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(A,I2,2A)')' SCREEN(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 50
               ENDIF
*              DEFTEB: DEFAULT VALUE FOR BEAM BROADENING HISTOGRAM
               IF (SPSIZE.LT.0.1) THEN
                  DEFTEB=7500
               ELSE
                  DEFTEB=7.5*SPSIZE
               ENDIF
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      XESPOT-DEFTEB,XESPOT+DEFTEB,
     2                      0.D0,0.D0,0.D0,0.D0,
     3                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NTEHIS=NTEHIS+1
               TEHIS(NTEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LTE=.TRUE.
               LETRAN=.TRUE.
               HISEDT(NHIST)=0
               LDELE(1)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'IOV') THEN
*              DEPTH (VERTICAL) DISTRIBUTION OF IONIZATION
               ZZMIN=ZMIN/DUNITS
               ZZMAX=ZMAX/DUNITS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      ZZMIN,ZZMAX,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               DO 26 IK=1,6
                  RDY(IK)=RDY(IK)*DUNITS
 26            CONTINUE
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               CHISTITLE(NHIST)=';'//CDUMMY(1:IEND(CDUMMY))
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LIO=.TRUE.
               LION=.TRUE.
               DO 27 LK=1,NDUMMY(20)
                  XCIODIS91(NDUMMY(8),NDUMMY(8+LK))=
     &                XCIODIS91(NDUMMY(8),NDUMMY(8+LK))+1
                  LK1=XCIODIS91(NDUMMY(8),NDUMMY(8+LK))
                  XCIODIS9(NDUMMY(8),NDUMMY(8+LK),LK1)=NHIST
 27            CONTINUE
            ELSE IF (SCREEN(I)(1:3).EQ.'IOL') THEN
*              LATERAL DISTRIBUTION OF IONIZATION
               XXMIN=XMIN/DUNITS
               XXMAX=XMAX/DUNITS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      XXMIN,XXMAX,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               DO 28 IK=1,6
                  RDY(IK)=RDY(IK)*DUNITS
 28            CONTINUE
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               CHISTITLE(NHIST)=';'//CDUMMY(1:IEND(CDUMMY))
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LIO=.TRUE.
               LION=.TRUE.
               DO 31 LK=1,NDUMMY(20)
                  XCIODIS91(NDUMMY(8),NDUMMY(8+LK))=
     &                XCIODIS91(NDUMMY(8),NDUMMY(8+LK))+1
                  LK1=XCIODIS91(NDUMMY(8),NDUMMY(8+LK))
                  XCIODIS9(NDUMMY(8),NDUMMY(8+LK),LK1)=NHIST
 31            CONTINUE
            ELSE IF (SCREEN(I)(1:3).EQ.'BEY') THEN
*              BACKSCATTERED ELECTRON YIELD
               IF (.NOT.SCAN) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' Since SCAN=F the specification',
     1                     ' of a yield in SCREEN(',I,') is useless !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(A,I2,2A)')' SCREEN(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 50
               ENDIF
               XA1=XEFRST-XLSCP/2
               XB2=XELAST+XLSCP/2
*              TRANSFORM TO ACTUAL DIMENSIONS
               XAA1=XA1/DUNITS
               XBB2=XB2/DUNITS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      XAA1,XBB2,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
*              TRANSFORM TO ANGSTROM
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               IF (RDY(1).LT.(XA1-1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The minimum value of 1st',
     1                     ' axis is to small in SCREEN(',i,') !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This values is',
     1                     ' set to: ',XA1,' from: ',RDY(1)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(1)=XA1
               ENDIF
               IF (RDY(2).GT.(XB2+1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The maximum value of 1st',
     1                     ' axis is to big in SCREEN(',i,') !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This values is',
     1                     ' set to: ',XB2,' from: ',RDY(2)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(2)=XB2
               ENDIF
               RDY(1)=XA1+INT((RDY(1)-XA1)/XLSCP)*XLSCP
               RDY(2)=XB2-INT((XB2-RDY(2))/XLSCP)*XLSCP
               NDUMMY(1)=INT((RDY(2)-RDY(1))/XLSCP+0.2)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LYIELD(NHIST,1)=.TRUE.
               LBE=.TRUE.
               LEBACK=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'SEY') THEN
*              SECONDARY ELECTRON YIELD
               IF (.NOT.SCAN) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' Since SCAN=F the specification',
     1                     ' of a yield in SCREEN(',I,') is useless !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(A,I2,2A)')' SCREEN(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 50
               ENDIF
               XA1=XEFRST-XLSCP/2
               XB2=XELAST+XLSCP/2
               XAA1=XA1/DUNITS
               XBB2=XB2/DUNITS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      XAA1,XBB2,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               IF (RDY(1).LT.(XA1-1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The minimum value of 1st',
     1                     ' axis is to small in SCREEN(',i,') !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This values is',
     1                     ' set to: ',XA1,' from: ',RDY(1)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(1)=XA1
               ENDIF
               IF (RDY(2).GT.(XB2+1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The maximum value of 1st',
     1                     ' axis is to big in SCREEN(',i,') !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This values is',
     1                     ' set to: ',XB2,' from: ',RDY(2)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(2)=XB2
               ENDIF
               RDY(1)=XA1+INT((RDY(1)-XA1)/XLSCP)*XLSCP
               RDY(2)=XB2-INT((XB2-RDY(2))/XLSCP)*XLSCP
               NDUMMY(1)=INT((RDY(2)-RDY(1))/XLSCP+0.2)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NSEHIS=NSEHIS+1
               SEHIS(NSEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LYIELD(NHIST,1)=.TRUE.
               LSE=.TRUE.
               LESEC=.TRUE.
               LDELE(4)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'TEY') THEN
*              TRANSMITTED ELECTRON YIELD
               IF (.NOT.SCAN) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' Since SCAN=F the specification',
     1                     ' of a yield in SCREEN(',I,') is useless !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(A,I2,2A)')' SCREEN(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 50
               ENDIF
               XA1=XEFRST-XLSCP/2
               XB2=XELAST+XLSCP/2
               XAA1=XA1/DUNITS
               XBB2=XB2/DUNITS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      XAA1,XBB2,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               IF (RDY(1).LT.(XA1-1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The minimum value of 1st',
     1                     ' axis is to small in SCREEN(',i,') !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This values is',
     1                     ' set to: ',XA1,' from: ',RDY(1)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(1)=XA1
               ENDIF
               IF (RDY(2).GT.(XB2+1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The maximum value of 1st',
     1                     ' axis is to big in SCREEN(',i,') !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This values is',
     1                     ' set to: ',XB2,' from: ',RDY(2)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(2)=XB2
               ENDIF
               RDY(1)=XA1+INT((RDY(1)-XA1)/XLSCP)*XLSCP
               RDY(2)=XB2-INT((XB2-RDY(2))/XLSCP)*XLSCP
               NDUMMY(1)=INT((RDY(2)-RDY(1))/XLSCP+0.2)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NTEHIS=NTEHIS+1
               TEHIS(NTEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LYIELD(NHIST,1)=.TRUE.
               LTE=.TRUE.
               LETRAN=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'AEY') THEN
*              AUGER ELECTRON YIELD
*              ONLY AE (BE, TE, SE NEGLECTED)
               IF (.NOT.SCAN) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' Since SCAN=F the specification',
     1                     ' of a yield in SCREEN(',I,') is useless !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(A,I2,2A)')' SCREEN(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 50
               ENDIF
               XA1=XEFRST-XLSCP/2
               XB2=XELAST+XLSCP/2
               XAA1=XA1/DUNITS
               XBB2=XB2/DUNITS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      XAA1,XBB2,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               IF (RDY(1).LT.(XA1-1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The minimum value of 1st',
     1                     ' axis is to small in SCREEN(',i,') !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This value is',
     1                     ' set to: ',XA1,' from: ',RDY(1)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(1)=XA1
               ENDIF
               IF (RDY(2).GT.(XB2+1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The maximum value of 1st',
     1                     ' axis is to big in SCREEN(',i,') !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This value is',
     1                     ' set to: ',XB2,' from: ',RDY(2)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(2)=XB2
               ENDIF
               RDY(1)=XA1+INT((RDY(1)-XA1)/XLSCP)*XLSCP
               RDY(2)=XB2-INT((XB2-RDY(2))/XLSCP)*XLSCP
               NDUMMY(1)=INT((RDY(2)-RDY(1))/XLSCP+0.2)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NAEHIS=NAEHIS+1
               AEHIS(NAEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               XCIODIS8(NDUMMY(8),NDUMMY(9))=
     &                        XCIODIS8(NDUMMY(8),NDUMMY(9))+1
               IJK=XCIODIS8(NDUMMY(8),NDUMMY(9))
               XCIODIS7(NDUMMY(8),NDUMMY(9),IJK)=NHIST
               LYIELD(NHIST,1)=.TRUE.
               LAE=.TRUE.
               LEAUG=.TRUE.
               LDELE(5) =.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'DEY') THEN
*              ELECTRON YIELD
*              INCLUDES AE, BE, TE AND SE (SE ONLY IF SE ARE SIMULATED)
               IF (.NOT.SCAN) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' Since SCAN=F the specification',
     1                     ' of a yield in SCREEN(',I,') is useless !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(A,I2,2A)')' SCREEN(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 50
               ENDIF
               XA1=XEFRST-XLSCP/2
               XB2=XELAST+XLSCP/2
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      XA1,XB2,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IEDCT=N2DMY
               EE1=MAX(RDY(2*MAXDIM+1),ELDETWIN(IEDCT,1))
CS               EE2=MAX(RDY(2*MAXDIM+2),ELDETWIN(IEDCT,2))
               EE2=E0
               IF (EE1.GE.EE2) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A)')' The electron detector cannot',
     1              ' detect electrons for specified energy range !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(A)')' No histogram will be generated !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 50
               ENDIF
               IF (RDY(1).LT.(XA1-1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The minimum value of 1st',
     1                     ' axis is to small in SCREEN(',i,') !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This values is',
     1                     ' set to: ',XA1,' from: ',RDY(1)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(1)=XA1
               ENDIF
               IF (RDY(2).GT.(XB2+1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The maximum value of 1st',
     1                     ' axis is to big in SCREEN(',i,') !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This values is',
     1                     ' set to: ',XB2,' from: ',RDY(2)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(2)=XB2
               ENDIF
               RDY(1)=XA1+INT((RDY(1)-XA1)/XLSCP)*XLSCP
               RDY(2)=XB2-INT((XB2-RDY(2))/XLSCP)*XLSCP
               NDUMMY(1)=INT((RDY(2)-RDY(1))/XLSCP+0.2)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               CALL AEINTV (EE1,EE2,IHELP)
               DO 290 K1=1,NELMNT
                  DO 289 K2=1,MXAUGP
                     IF (IHELP(K1,K2).GT.0) THEN
                        XCIODIS8(K1,K2)=XCIODIS8(K1,K2)+1
                        IJK=XCIODIS8(K1,K2)
                        XCIODIS7(K1,K2,IJK)=NHIST
                     ENDIF
 289              CONTINUE
 290           CONTINUE
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               NAEHIS=NAEHIS+1
               AEHIS(NAEHIS)=NHIST
               NTEHIS=NTEHIS+1
               TEHIS(NTEHIS)=NHIST
               IF (LESEC) THEN
                  NSEHIS=NSEHIS+1
                  SEHIS(NSEHIS)=NHIST
               ENDIF
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LYIELD(NHIST,1)=.TRUE.
               LBE=.TRUE.
               LAE=.TRUE.
               LTE=.TRUE.
               IF (LESEC) LSE=.TRUE.
               LEBACK=.TRUE.
               LETRAN=.TRUE.
               LEAUG=.TRUE.
               LDELE(1)=.TRUE.
               LDELE(5)=.TRUE.
               LDELE(4)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'XCS') THEN
*              ENERGY SPECTRUM OF CHARACTERISTIC X-RAYS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      0,EPRIM,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               IF (NXCSHIS.GE.MAXXCSHIS) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(A,I2,A)')' Not more than ',MAXXCSHIS,
     1                     ' XCS/XRS histograms allowed !'
                  WRITE(6,'(A,I2,2A)')' SCREEN(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 50
               ENDIF
               CDUMMY(IEND(CDUMMY)+1:IEND(CDUMMY)+4)='DET#'
               IIE1=IEND(CDUMMY)
               IF (N2DMY.GT.99) N2DMY=1
               IF (N2DMY.LT.10) THEN
                  WRITE(CDUMMY(IIE1+1:IIE1+1),'(I1)')N2DMY
               ELSE
                  WRITE(CDUMMY(IIE1+1:IIE1+2),'(I2)')N2DMY
               ENDIF
               CHISTITLE(NHIST)=';'//CDUMMY(1:IEND(CDUMMY))
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LENGY(NHIST,1)=.TRUE.
               LXC=.TRUE.
               LXCHAR=.TRUE.
               LENERG=.TRUE.
               LINIABS=.TRUE.
               LGRD=.TRUE.
               NXCSHIS=NXCSHIS+1
               XCSHIS(NXCSHIS)=NHIST
               XCSDET(NXCSHIS)=N2DMY
            ELSE IF (SCREEN(I)(1:3).EQ.'XCY') THEN
*              CHARACTERISTIC X-RAY YIELD
               IF (.NOT.SCAN) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' Since SCAN=F the specification',
     1                     ' of a yield in SCREEN(',I,') is useless !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(A,I2,2A)')' SCREEN(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 50
               ENDIF
               XA1=XEFRST-XLSCP/2
               XB2=XELAST+XLSCP/2
               XAA1=XA1/DUNITS
               XBB2=XB2/DUNITS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      XAA1,XBB2,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               IF (RDY(1).LT.(XA1-1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The minimum value of 1st',
     1                     ' axis is to small in SCREEN(',i,') !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This value is',
     1                     ' set to: ',XA1,' from: ',RDY(1)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(1)=XA1
               ENDIF
               IF (RDY(2).GT.(XB2+1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The maximum value of 1st',
     1                     ' axis is to big in SCREEN(',i,') !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This value is',
     1                     ' set to: ',XB2,' from: ',RDY(2)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(2)=XB2
               ENDIF
               RDY(1)=XA1+INT((RDY(1)-XA1)/XLSCP)*XLSCP
               RDY(2)=XB2-INT((XB2-RDY(2))/XLSCP)*XLSCP
               NDUMMY(1)=INT((RDY(2)-RDY(1))/XLSCP+0.2)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               CDUMMY(IEND(CDUMMY)+1:IEND(CDUMMY)+5)=';DET#'
               IIE1=IEND(CDUMMY)
               IF ((RDY(3).LT.RDY(4)).AND.(RDY(3).GE.0)) THEN
                  HISENWIN(NHIST,1)=RDY(3)
                  HISENWIN(NHIST,2)=RDY(4)
               ELSE IF ((RDY(7).LT.RDY(8)).AND.(RDY(7).GE.0)) THEN
                  HISENWIN(NHIST,1)=RDY(7)
                  HISENWIN(NHIST,2)=RDY(8)
               ELSE
                  HISENWIN(NHIST,1)=0
                  HISENWIN(NHIST,2)=0
               ENDIF
               HISEDT(NHIST)=N2DMY
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CDUMMY(IIE1+1:IIE1+1),'(I1)')HISEDT(NHIST)
               ELSE
                  WRITE(CDUMMY(IIE1+1:IIE1+2),'(I2)')HISEDT(NHIST)
               ENDIF
               CHISTITLE(NHIST)=';'//CDUMMY(1:IEND(CDUMMY))
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               DO 36 LK=1,NDUMMY(20)
                  XCIODIS41(NDUMMY(8),NDUMMY(8+LK))=
     &                     XCIODIS41(NDUMMY(8),NDUMMY(8+LK))+1
                  JJK=XCIODIS41(NDUMMY(8),NDUMMY(8+LK))
                  XCIODIS4(NDUMMY(8),NDUMMY(8+LK),JJK,1)=NHIST
                  XCIODIS4(NDUMMY(8),NDUMMY(8+LK),JJK,2)=N2DMY
 36            CONTINUE
               LYIELD(NHIST,1)=.TRUE.
               LXC=.TRUE.
               LXCHAR=.TRUE.
               LINIABS=.TRUE.
               LGRD=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'XRY') THEN
*              CHARACTERISTIC X-RAY YIELD INCLUDING BACKGROUND CONTRIBUTION
               IF (.NOT.SCAN) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' Since SCAN=F the specification',
     1                     ' of a yield in SCREEN(',I,') is useless !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(A,I2,2A)')' SCREEN(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 50
               ENDIF
               XA1=XEFRST-XLSCP/2
               XB2=XELAST+XLSCP/2
               XAA1=XA1/DUNITS
               XBB2=XB2/DUNITS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      XAA1,XBB2,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               IF (RDY(1).LT.(XA1-1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The minimum value of 1st',
     1                     ' axis is to small in SCREEN(',i,') !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This value is',
     1                     ' set to: ',XA1,' from: ',RDY(1)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(1)=XA1
               ENDIF
               IF (RDY(2).GT.(XB2+1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The maximum value of 1st',
     1                     ' axis is to big in SCREEN(',i,') !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This value is',
     1                     ' set to: ',XB2,' from: ',RDY(2)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(2)=XB2
               ENDIF
               RDY(1)=XA1+INT((RDY(1)-XA1)/XLSCP)*XLSCP
               RDY(2)=XB2-INT((XB2-RDY(2))/XLSCP)*XLSCP
               NDUMMY(1)=INT((RDY(2)-RDY(1))/XLSCP+0.2)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               IF ((RDY(3).LT.RDY(4)).AND.(RDY(3).GE.0)) THEN
                  HISENWIN(NHIST,1)=RDY(3)
                  HISENWIN(NHIST,2)=RDY(4)
               ELSE IF ((RDY(7).LT.RDY(8)).AND.(RDY(7).GE.0)) THEN
                  HISENWIN(NHIST,1)=RDY(7)
                  HISENWIN(NHIST,2)=RDY(8)
               ELSE
                  HISENWIN(NHIST,1)=0
                  HISENWIN(NHIST,2)=0
               ENDIF
               CDUMMY(IEND(CDUMMY)+1:IEND(CDUMMY)+5)=';DET#'
               IIE1=IEND(CDUMMY)
               HISEDT(NHIST)=N2DMY
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CDUMMY(IIE1+1:IIE1+1),'(I1)')HISEDT(NHIST)
               ELSE
                  WRITE(CDUMMY(IIE1+1:IIE1+2),'(I2)')HISEDT(NHIST)
               ENDIF
               CHISTITLE(NHIST)=';'//CDUMMY(1:IEND(CDUMMY))
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               DO 37 LK=1,NDUMMY(20)
                  XCIODIS41(NDUMMY(8),NDUMMY(8+LK))=
     &                     XCIODIS41(NDUMMY(8),NDUMMY(8+LK))+1
                  JJK=XCIODIS41(NDUMMY(8),NDUMMY(8+LK))
                  XCIODIS4(NDUMMY(8),NDUMMY(8+LK),JJK,1)=NHIST
                  XCIODIS4(NDUMMY(8),NDUMMY(8+LK),JJK,2)=N2DMY
 37            CONTINUE
               LYIELD(NHIST,1)=.TRUE.
               LXC=.TRUE.
               LXCHAR=.TRUE.
               LPTOB=.TRUE.
               LINIABS=.TRUE.
               LGRD=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'XKY') THEN
*              BREMSSTRAHLUNG YIELD (SCAN)
               IF (.NOT.SCAN) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' Since SCAN=F the specification',
     1                     ' of a yield in SCREEN(',I,') is useless !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(A,I2,2A)')' SCREEN(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 50
               ENDIF
               XA1=XEFRST-XLSCP/2
               XB2=XELAST+XLSCP/2
               XAA1=XA1/DUNITS
               XBB2=XB2/DUNITS
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      XAA1,XBB2,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               IF (RDY(1).LT.(XA1-1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The minimum value of 1st',
     1                     ' axis is to small in SCREEN(',i,') !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This value is',
     1                     ' set to: ',XA1,' from: ',RDY(1)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(1)=XA1
               ENDIF
               IF (RDY(2).GT.(XB2+1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The maximum value of 1st',
     1                     ' axis is to big in SCREEN(',i,') !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This value is',
     1                     ' set to: ',XB2,' from: ',RDY(2)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(2)=XB2
               ENDIF
               RDY(1)=XA1+INT((RDY(1)-XA1)/XLSCP)*XLSCP
               RDY(2)=XB2-INT((XB2-RDY(2))/XLSCP)*XLSCP
               NDUMMY(1)=INT((RDY(2)-RDY(1))/XLSCP+0.2)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               IF ((RDY(3).LT.RDY(4)).AND.(RDY(3).GE.0)) THEN
                  HISENWIN(NHIST,1)=RDY(3)
                  HISENWIN(NHIST,2)=RDY(4)
               ELSE IF ((RDY(7).LT.RDY(8)).AND.(RDY(7).GE.0)) THEN
                  HISENWIN(NHIST,1)=RDY(7)
                  HISENWIN(NHIST,2)=RDY(8)
               ELSE
                  HISENWIN(NHIST,1)=0
                  HISENWIN(NHIST,2)=0
               ENDIF
               CDUMMY(IEND(CDUMMY)+1:IEND(CDUMMY)+5)=';DET#'
               IIE1=IEND(CDUMMY)
               HISEDT(NHIST)=N2DMY
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CDUMMY(IIE1+1:IIE1+1),'(I1)')HISEDT(NHIST)
               ELSE
                  WRITE(CDUMMY(IIE1+1:IIE1+2),'(I2)')HISEDT(NHIST)
               ENDIF
               CHISTITLE(NHIST)=';'//CDUMMY(1:IEND(CDUMMY))
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LYIELD(NHIST,1)=.TRUE.
               LPTOB=.TRUE.
               LINIABS=.TRUE.
               LGRD=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'XKS') THEN
*              ENERGY SPECTRUM OF BREMSSTRAHLUNG
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      0.D0,EPRIM,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               IF (NXKSHIS.GE.MAXXKSHIS) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(A,I2,A)')' Not more than ',MAXXKSHIS,
     1                     ' XKS histograms allowed !'
                  WRITE(6,'(A,I2,2A)')' SCREEN(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 50
               ENDIF
               CDUMMY(IEND(CDUMMY)+1:IEND(CDUMMY)+4)='DET#'
               IIE1=IEND(CDUMMY)
               IF (N2DMY.GT.99) N2DMY=1
               IF (N2DMY.LT.10) THEN
                  WRITE(CDUMMY(IIE1+1:IIE1+1),'(I1)')N2DMY
               ELSE
                  WRITE(CDUMMY(IIE1+1:IIE1+2),'(I2)')N2DMY
               ENDIF
               CHISTITLE(NHIST)=';'//CDUMMY(1:IEND(CDUMMY))
               NHISXCONT=MAX(NHISXCONT,NDUMMY(1))
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LENGY(NHIST,1)=.TRUE.
               LXK=.TRUE.
               LXCONT=.TRUE.
               LENERG=.TRUE.
               NXKSHIS=NXKSHIS+1
               XKSHIS(NXKSHIS)=NHIST
               XKSDET(NXKSHIS)=N2DMY
            ELSE IF (SCREEN(I)(1:3).EQ.'XRS') THEN
*              ENERGY SPECTRUM OF X-RAYS (CHARACTERISTIC AND BREMSSTRAHLUNG)
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      0.D0,EPRIM,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               IF (NXCSHIS.GE.MAXXCSHIS) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(A,I2,A)')' Not more than ',MAXXCSHIS,
     1                     ' XCS/XRS histograms allowed !'
                  WRITE(6,'(A,I2,2A)')' SCREEN(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 50
               ENDIF
               NHISXCONT=MAX(NHISXCONT,NDUMMY(1))
               CDUMMY(IEND(CDUMMY)+1:IEND(CDUMMY)+4)='DET#'
               IIE1=IEND(CDUMMY)
               IF (N2DMY.GT.99) N2DMY=1
               IF (N2DMY.LT.10) THEN
                  WRITE(CDUMMY(IIE1+1:IIE1+1),'(I1)')N2DMY
               ELSE
                  WRITE(CDUMMY(IIE1+1:IIE1+2),'(I2)')N2DMY
               ENDIF
               CHISTITLE(NHIST)=';'//CDUMMY(1:IEND(CDUMMY))
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LENGY(NHIST,1)=.TRUE.
               LXCONT=.TRUE.
               LXR=.TRUE.
               LXCHAR=.TRUE.
               LXRAY=.TRUE.
               LENERG=.TRUE.
               LINIABS=.TRUE.
               LGRD=.TRUE.
               NXCSHIS=NXCSHIS+1
               XCSHIS(NXCSHIS)=NHIST
               XCSDET(NXCSHIS)=N2DMY
            ELSE IF ((SCREEN(I)(1:3).EQ.'AES')) THEN
*              ELECTRON SPECTRUM (INCLUDES AUGER, BACKSCATTERED,
*              TRANSMITTED AND SECONDARY ELECTRONS)
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      0.D0,EPRIM,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IEDCT=N2DMY
               BCKHIS(IEDCT)=-1
               EE1=MAX(RDY(1),ELDETWIN(IEDCT,1))
CS               EE2=MAX(RDY(2),ELDETWIN(IEDCT,2))
               EE2=E0
               IF (EE1.GE.EE2) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A)')' The electron detector cannot',
     1              ' detect electrons for specified energy range !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(A)')' No histogram will be generated !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 50
               ENDIF
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               CALL AEINTV (EE1,EE2,IHELP)
               DO 39 K1=1,NELMNT
                  DO 38 K2=1,MXAUGP
                     IF (IHELP(K1,K2).GT.0) THEN
                        XCIODIS8(K1,K2)=XCIODIS8(K1,K2)+1
                        IJK=XCIODIS8(K1,K2)
                        XCIODIS7(K1,K2,IJK)=NHIST
                     ENDIF
 38               CONTINUE
 39            CONTINUE
               NAEHIS=NAEHIS+1
               AEHIS(NAEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LENGY(NHIST,1)=.TRUE.
               LBE=.TRUE.
               LTE=.TRUE.
               LAE=.TRUE.
               IF (LESEC) LSE=.TRUE.
               LENERG=.TRUE.
               LEBACK=.TRUE.
               LETRAN=.TRUE.
               LEAUG=.TRUE.
               LDELE(1)=.TRUE.
               LDELE(5)=.TRUE.
               LDELE(4)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'DEE') THEN
*              ELECTRON SPECTRUM (INCLUDES BACKSCATTERED,
*              TRANSMITTED AND SECONDARY ELECTRONS; NO AUGER ELECTRONS)
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      0.D0,EPRIM,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               NTEHIS=NTEHIS+1
               TEHIS(NTEHIS)=NHIST
               IF (LESEC) THEN
                  NSEHIS=NSEHIS+1
                  SEHIS(NSEHIS)=NHIST
               ENDIF
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LENGY(NHIST,1)=.TRUE.
               LBE=.TRUE.
               LTE=.TRUE.
               IF (LESEC) LSE=.TRUE.
               LENERG=.TRUE.
               LEBACK=.TRUE.
               LETRAN=.TRUE.
               LDELE(1)=.TRUE.
               LDELE(4)=.TRUE.
            ELSE IF (SCREEN(I)(1:3).EQ.'AEE') THEN
*              AUGER ELECTRON SPECTRUM (INCLUDES ONLY AUGER ELECTRONS;
*              NO BACKSCATTERED, TRANSMITTED AND SECONDARY ELECTRONS)
               CALL EXTOUT (1,2,I,IIK,SCREEN(I),
     1                      0.D0,EPRIM,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IEDCT=N2DMY
               EE1=MAX(RDY(1),ELDETWIN(IEDCT,1))
CS               EE2=MAX(RDY(2),ELDETWIN(IEDCT,2))
               EE2=E0
               IF (EE1.GE.EE2) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A)')' The electron detector cannot',
     1              ' detect electrons for specified energy range !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(A)')' No histogram will be generated !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 50
               ENDIF
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,SCREEN(I)(1:3),'SCR',CDUMMY,
     5                      IER                          )
               IF (IER.NE.0) GOTO 50
               CALL AEINTV (EE1,EE2,IHELP)
               DO 45 K1=1,NELMNT
                  DO 40 K2=1,MXAUGP
                     IF (IHELP(K1,K2).GT.0) THEN
                        XCIODIS8(K1,K2)=XCIODIS8(K1,K2)+1
                        IJK=XCIODIS8(K1,K2)
                        XCIODIS7(K1,K2,IJK)=NHIST
                     ENDIF
 40               CONTINUE
 45            CONTINUE
               NAEHIS=NAEHIS+1
               AEHIS(NAEHIS)=NHIST
               LSCHIS=.TRUE.
               NSCH=NSCH+1
               HISSCR(NHIST)=NSCL+NSCH
               HISEDT(NHIST)=IEDCT
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               JL=NSCL+NSCH
               IF (NDUMMY(4).GT.0) SCXOFF(JL)=MIN(NDUMMY(4),MXXPIX)
               IF (NDUMMY(5).GT.0) SCYOFF(JL)=MIN(NDUMMY(5),MXYPIX)
               IF (NDUMMY(6).GT.0) SCXSIZ(JL)=MIN(NDUMMY(6),MXXPIX)
               IF (NDUMMY(7).GT.0) SCYSIZ(JL)=MIN(NDUMMY(7),MXYPIX)
               LENGY(NHIST,1)=.TRUE.
               LAE=.TRUE.
               LENERG=.TRUE.
               LEAUG=.TRUE.
               LDELE(5)=.TRUE.
            ENDIF
 50     CONTINUE
      ENDIF
      NSCRN=NSCL+NSCH

*     ---PARSE INFORMATION FROM POST ARRAY (POSTSCRIPT OUTPUT)
      IF (LPOST) THEN
*        INITIALIZE SOME PARAMETERES
         NP=0
         NPS=0
*        DETERMINE NUMBER OF POSTSCRIPT OUTPUT (CAN BE GREATER THAN OPEN
*        POSTSCRIPT FILE)
         DO 110 I=1,3*MAXPST
            IF (POST(I)(1:3).NE.'   ') NP=I
 110     CONTINUE
         DO 114 I=1,NP
            IFND=0
            DO 112 J=1,NTOPST
               IF (POST(I)(1:3).EQ.CTOPST(J)) IFND=1
 112        CONTINUE
            IF (POST(I)(1:3).EQ.'   ') GOTO 114
            IF (IFND.EQ.0) THEN
               WRITE(*,'(A)')'   '
               WRITE(*,'(3A)')' WARNING: ',POST(I)(1:3),
     &                        ' IS NOT A VALID ABBREVIATION IN POST'
            ENDIF
 114     CONTINUE
         DO 180 I=1,NP
            II=0
            IF (POST(I)(1:3).EQ.'PET') THEN
*              TRAJECTORIES OF PRIMARY ELECTRONS
               II=1
            ELSE IF (POST(I)(1:3).EQ.'BET') THEN
*              TRAJECTORIES OF BACKSCATTERED ELECTRONS
               II=2
               LEBACK=.TRUE.
            ELSE IF (POST(I)(1:3).EQ.'TET') THEN
*              TRAJECTORIES OF TRANSMITTED ELECTRONS
               II=3
               LETRAN=.TRUE.
            ELSE IF (POST(I)(1:3).EQ.'SET') THEN
*              TRAJECTORIES OF SECONDARY ELECTRONS
               II=4
               LESEC=.TRUE.
            ELSE IF (POST(I)(1:3).EQ.'AET') THEN
*              TRAJECTORIES OF AUGER ELECTRONS
               II=5
               LEAUG=.TRUE.
            ELSE IF (POST(I)(1:3).EQ.'ION') THEN
*              LOCATION OF IONIZATIONS
               II=6
               LION=.TRUE.
            ELSE IF (POST(I)(1:3).EQ.'PEB') THEN
*              PRIMARY ELECTRON BEAM
               II=7
            ELSE IF (POST(I)(1:3).EQ.'IOD') THEN
*              LOCATION DEPENDENT IONIZATION DISTRIBUTION
               II=8
               LIODIS=.TRUE.
               LGRD=.TRUE.
            ELSE IF (POST(I)(1:3).EQ.'XGD') THEN
*              LOCATION DEPENDENT GENERATED CHAR. X-RAY DISTRIBUTION
               II=9
               LXCHAR=.TRUE.
               LGRD=.TRUE.
            ELSE IF (POST(I)(1:3).EQ.'XDD') THEN
*              LOCATION DEPENDENT DETECTED CHAR. X-RAY DISTRIBUTION
               II=10
               LXCHAR=.TRUE.
               LINIABS=.TRUE.
               LGRD=.TRUE.
            ELSE IF (POST(I)(1:3).EQ.'AGD') THEN
*              LOCATION DEPENDENT GENERATED AUGER DISTRIBUTION
               II=11
               LEAUG=.TRUE.
            ELSE IF (POST(I)(1:3).EQ.'ADD') THEN
*              LOCATION DEPENDENT DETECTED AUGER DISTIBUTION
               II=12
               LEAUG=.TRUE.
               LDELE(5)=.TRUE.
            ELSE
               GOTO 180
            ENDIF
            NLOCPS(II)=NLOCPS(II)+1
            IPSL=IPSL+1
            INDX=ISCL+IPSL
            INDXI=ISCL+I
            NSCINP(INDX)=I
            NMPS=I
            CDUMMY=ADDSTR(4,JOB,'_',POST(I)(1:3),'.---',CDY)
            CALL EXTOUT (2,1,INDXI,II,POST(I),
     1                   XMINSC,XMAXSC,ZMINSC,ZMAXSC,0.D0,0.D0,
     2                   NMPS,N2DMY,NDUMMY,RDY,CDUMMY)
            IE=IEND(CDUMMY)
            IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='PS '
            NPSO=NMPS
            DO 115 IK=1,6
               SCMIMA(IK,ISCL+I)=SCMIMA(IK,ISCL+I)*DUNITS
 115        CONTINUE
            IF (NSCINP(INDX).EQ.NPSO) THEN
               NPS=NPS+1
               FILEPS(NPS)=CDUMMY
               NSCOUT(INDX)=NPS
	       IF (NDUMMY(4).GT.0) PSXSIZ(NPS)=NDUMMY(4)
	       IF (NDUMMY(5).GT.0) PSYSIZ(NPS)=NDUMMY(5)
               XDELTA=SCMIMA(2,ISCL+I)-SCMIMA(1,ISCL+I)
               ZDELTA=SCMIMA(4,ISCL+I)-SCMIMA(3,ISCL+I)
               IF ((PSXSIZ(NPS).EQ.NPSXSI).AND.
     &             (PSYSIZ(NPS).EQ.NPSYSI)) THEN
*                 BOTH DIRECTIONS DEFAULT PS SIZE
*                 SMALLER IS REFERENCE
                  IF (PSXSIZ(NPS).LT.PSYSIZ(NPS)) THEN
                     PSYSIZ(NPS)=INT(PSXSIZ(NPS)*ZDELTA/XDELTA+0.5)
                     IF (PSYSIZ(NPS).GT.MXYPIX) THEN
                        PSYSIZ(NPS)=MXYPIX
                        PSXSIZ(NPS)=INT(PSYSIZ(NPS)*XDELTA/
     &                               ZDELTA+0.5)
                     ENDIF
                  ELSE
                     PSXSIZ(NPS)=INT(PSYSIZ(NPS)*XDELTA/ZDELTA+0.5)
                     IF (PSXSIZ(NPS).GT.MXXPIX) THEN
                        PSXSIZ(NPS)=MXXPIX
                        PSYSIZ(NPS)=INT(PSXSIZ(NPS)*ZDELTA/
     &                               XDELTA+0.5)
                     ENDIF
                  ENDIF
               ELSE IF ((PSXSIZ(NPS).EQ.NPSXSI).AND.
     &             (PSYSIZ(NPS).NE.NPSYSI)) THEN
*                 Y DIRECTION EXPLICITELY SPECIFIED
*                 Y IS REFERENCE
                  PSXSIZ(NPS)=INT(PSYSIZ(NPS)*XDELTA/ZDELTA+0.5)
                  IF (PSXSIZ(NPS).GT.MXXPIX) THEN
                     PSXSIZ(NPS)=MXXPIX
                     PSYSIZ(NPS)=INT(PSXSIZ(NPS)*ZDELTA/
     &                            XDELTA+0.5)
                  ENDIF
               ELSE IF ((PSXSIZ(NPS).NE.NPSXSI).AND.
     &             (PSYSIZ(NPS).EQ.NPSYSI)) THEN
*                 X DIRECTION EXPLICITELY SPECIFIED
*                 X IS REFERENCE
                  PSYSIZ(NPS)=INT(PSXSIZ(NPS)*ZDELTA/XDELTA+0.5)
                  IF (PSYSIZ(NPS).GT.MXYPIX) THEN
                     PSYSIZ(NPS)=MXYPIX
                     PSXSIZ(NPS)=INT(PSYSIZ(NPS)*XDELTA/
     &                            ZDELTA+0.5)
                  ENDIF
               ELSE
*                 BOTH DIRECTIONS SPECIFIED
*                 TAKE BOTH AS SPECIFIED (DISTORTED)
                  IF (PSXSIZ(NPS).GT.MXXPIX) PSXSIZ(NPS)=MXXPIX
                  IF (PSYSIZ(NPS).GT.MXYPIX) PSYSIZ(NPS)=MXYPIX
               ENDIF
            ELSE
               NN=0
               DO 116 IK=ISCL+1,INDX-1
                  IF (NSCINP(IK).EQ.NPSO) NN=IK
 116           CONTINUE
               IF (NN.EQ.0) THEN
                  NPS=NPS+1
                  NSCOUT(INDX)=NPS
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%% '
                  WRITE(6,'(A)')' PostScript file number specified in:'
                  WRITE(6,'(2A)')' ',POST(I)
                  WRITE(6,'(A)')' points to nowhere !'
                  WRITE(6,'(A,I2,A)')' The PostScript file number',NPSO,
     &                 ' must point to an already specified POST !'
                  WRITE(6,'(2A)')' This output will be directed to',
     &                           ' a new PostScript file.'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
               ELSE
                  NSCOUT(INDX)=NSCOUT(NN)
               ENDIF
            ENDIF
            DO 117 J=1,6
               SCMIMA(J,ISCL+I)=SCMIMA(J,ISCL+NPSO)
               SCMNMX(J,NSCOUT(INDX)+NSCL)=SCMIMA(J,ISCL+I)
 117        CONTINUE
            NLOCOUT(II)=NLOCSC(II)+NLOCPS(II)
            LOCOUT(II,NLOCOUT(II))=NSCOUT(INDX)+NSCL
            IF (II.EQ.5) THEN
               XCIODIS6(NDUMMY(8),NDUMMY(9),3)=
     &                  XCIODIS6(NDUMMY(8),NDUMMY(9),3)+1
               IJK=XCIODIS6(NDUMMY(8),NDUMMY(9),3)
               XCIODIS5(NDUMMY(8),NDUMMY(9),IJK,3)=
     &                               LOCOUT(II,NLOCOUT(II))
            ELSE IF (II.EQ.6) THEN
*              UPDATE SHELLSCR
               DO 121 IE=1,MAXELE
                  DO 120 IS=1,MAXSHELL
                     ISCR=NSHELLSCR(IE,IS)
                     IF (ISCR.LE.0) GOTO 120
                     IF (SHELLSCR(IS,IE,ISCR).EQ.(MAXSCR+1)) THEN
                        SHELLSCR(IS,IE,ISCR)=LOCOUT(II,NLOCOUT(II))
                     ENDIF
 120              CONTINUE
 121           CONTINUE
            ELSE IF ((II.GT.7).AND.(II.LT.11)) THEN
               IF ((II.EQ.9).OR.(II.EQ.10)) THEN
cs scrofxcg and scrofxcd moved from shell table to xchar table!
cs                  DO 178 LK=1,NDUMMY(20)
cs                     IF (NDUMMY(8+LK).EQ.1) NDUMMY(8+LK)=1
cs                     IF (NDUMMY(8+LK).EQ.2) NDUMMY(8+LK)=1
cs                     IF (NDUMMY(8+LK).EQ.3) NDUMMY(8+LK)=1
cs                     IF (NDUMMY(8+LK).EQ.4) NDUMMY(8+LK)=4
cs                     IF (NDUMMY(8+LK).EQ.5) NDUMMY(8+LK)=4
cs                     IF (NDUMMY(8+LK).EQ.6) NDUMMY(8+LK)=3
cs                     IF (NDUMMY(8+LK).EQ.7) NDUMMY(8+LK)=4
cs                     IF (NDUMMY(8+LK).EQ.8) NDUMMY(8+LK)=2
cs                     IF (NDUMMY(8+LK).EQ.9) NDUMMY(8+LK)=9
cs                     IF (NDUMMY(8+LK).EQ.10) NDUMMY(8+LK)=8
cs 178              CONTINUE
               ENDIF
               DO 179 LK=1,NDUMMY(20)
                  IF (NDUMMY(8+LK).EQ.1) IXCSHELL=1
                  IF (NDUMMY(8+LK).EQ.2) IXCSHELL=1
                  IF (NDUMMY(8+LK).EQ.3) IXCSHELL=1
                  IF (NDUMMY(8+LK).EQ.4) IXCSHELL=4
                  IF (NDUMMY(8+LK).EQ.5) IXCSHELL=4
                  IF (NDUMMY(8+LK).EQ.6) IXCSHELL=3
                  IF (NDUMMY(8+LK).EQ.7) IXCSHELL=4
                  IF (NDUMMY(8+LK).EQ.8) IXCSHELL=2
                  IF (NDUMMY(8+LK).EQ.9) IXCSHELL=9
                  IF (NDUMMY(8+LK).EQ.10) IXCSHELL=8
                  IF (XCIODIS1(NDUMMY(8),IXCSHELL).EQ.0) THEN
                     IIONHIS=IIONHIS+1
                     XCIODIS1(NDUMMY(8),IXCSHELL)=IIONHIS
                  ENDIF
                  XCIODIS21(NDUMMY(8),NDUMMY(8+LK),II-7)=
     &                XCIODIS21(NDUMMY(8),NDUMMY(8+LK),II-7)+1
                  LK1=XCIODIS21(NDUMMY(8),NDUMMY(8+LK),II-7)
                  XCIODIS2(NDUMMY(8),NDUMMY(8+LK),II-7,LK1)=
     &                               LOCOUT(II,NLOCOUT(II))
                  IF ((II.GE.8).AND.(II.LE.10)) THEN
                     XCIODIS2(NDUMMY(8),NDUMMY(8+LK),II-3,LK1)=
     &                                  NDUMMY(21)
                  ENDIF
                  IF (II.EQ.10) THEN
                     XCIODIS2(NDUMMY(8),NDUMMY(8+LK),II-6,LK1)=
     &                                  N2DMY
                  ENDIF
 179           CONTINUE
            ELSE IF (II.EQ.11) THEN
               XCIODIS6(NDUMMY(8),NDUMMY(9),1)=
     &                  XCIODIS6(NDUMMY(8),NDUMMY(9),1)+1
               IJK=XCIODIS6(NDUMMY(8),NDUMMY(9),1)
               XCIODIS5(NDUMMY(8),NDUMMY(9),IJK,1)=
     &                               LOCOUT(II,NLOCOUT(II))
            ELSE IF (II.EQ.12) THEN
               XCIODIS6(NDUMMY(8),NDUMMY(9),2)=
     &                  XCIODIS6(NDUMMY(8),NDUMMY(9),2)+1
               IJK=XCIODIS6(NDUMMY(8),NDUMMY(9),2)
               XCIODIS5(NDUMMY(8),NDUMMY(9),IJK,2)=
     &                               LOCOUT(II,NLOCOUT(II))
               XCIODIS5(NDUMMY(8),NDUMMY(9),IJK,2)=N2DMY
            ENDIF
 180     CONTINUE
      ENDIF
      NLOC=NSCL+NPS

*     ---PARSE INFORMATION FROM PMSAV ARRAY (POSTMINI SAV FILE)
      NPM=0
      NPMH=0
      IF (LPMSAV) THEN
         DO 250 I=1,MAXSAV
            IF (PMSAV(I)(1:3).EQ.'BEW') THEN
*              AZIMUTHAL AND POLAR ANGLE DISTRIBUTION OF BACKSCATTERED
*              ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',PMSAV(I)(1:3),'.---',CDY)
               CALL EXTOUT (3,2,I,NH,PMSAV(I),
     1                      0.D0,DEFAZI,0.D0,DEFPOL,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='SAV'
               CALL INIHIS (2,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      3,PMSAV(I)(1:3),'SAV',CDUMMY,
     5                      IER                         )
               IF (IER.NE.0) GOTO 250
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LPMHIS=.TRUE.
               NPMH=NPMH+1
               NPMHIS(NPMH)=NHIST
               FILEPM(NPMH)=CDUMMY
               LAZIMU(NHIST,1)=.TRUE.
               LPOLAR(NHIST,2)=.TRUE.
               LBE=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LPANG=.TRUE.
               LEBACK=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (PMSAV(I)(1:3).EQ.'TEW') THEN
*              AZIMUTHAL AND POLAR ANGLE DISTRIBUTION OF TRANSMITTED
*              ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',PMSAV(I)(1:3),'.---',CDY)
               CALL EXTOUT (3,2,I,NH,PMSAV(I),
     1                      0.D0,DEFAZI,0.D0,DEFPOL,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='SAV'
               CALL INIHIS (2,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      3,PMSAV(I)(1:3),'SAV',CDUMMY,
     5                      IER                         )
               IF (IER.NE.0) GOTO 250
               NTEHIS=NTEHIS+1
               TEHIS(NTEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LPMHIS=.TRUE.
               NPMH=NPMH+1
               NPMHIS(NPMH)=NHIST
               FILEPM(NPMH)=CDUMMY
               LAZIMU(NHIST,1)=.TRUE.
               LPOLAR(NHIST,2)=.TRUE.
               LTE=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LPANG=.TRUE.
               LETRAN=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (PMSAV(I)(1:3).EQ.'SEW') THEN
*              AZIMUTHAL AND POLAR ANGLE DISTRIBUTION OF SECONDARY
*              ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',PMSAV(I)(1:3),'.---',CDY)
               CALL EXTOUT (3,2,I,NH,PMSAV(I),
     1                      0.D0,DEFAZI,0.D0,DEFPOL,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='SAV'
               CALL INIHIS (2,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      3,PMSAV(I)(1:3),'SAV',CDUMMY,
     5                      IER                         )
               IF (IER.NE.0) GOTO 250
               NSEHIS=NSEHIS+1
               SEHIS(NSEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LPMHIS=.TRUE.
               NPMH=NPMH+1
               NPMHIS(NPMH)=NHIST
               FILEPM(NPMH)=CDUMMY
               LAZIMU(NHIST,1)=.TRUE.
               LPOLAR(NHIST,2)=.TRUE.
               LSE=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LPANG=.TRUE.
               LESEC=.TRUE.
               LDELE(4)=.TRUE.
            ELSE IF (PMSAV(I)(1:3).EQ.'AEW') THEN
*              AZIMUTHAL AND POLAR ANGLE DISTRIBUTION OF AUGER
*              ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',PMSAV(I)(1:3),'.---',CDY)
               CALL EXTOUT (3,2,I,NH,PMSAV(I),
     1                      0.D0,DEFAZI,0.D0,DEFPOL,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='SAV'
               CALL INIHIS (2,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      3,PMSAV(I)(1:3),'SAV',CDUMMY,
     5                      IER                         )
               IF (IER.NE.0) GOTO 250
               NAEHIS=NAEHIS+1
               AEHIS(NAEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LPMHIS=.TRUE.
               NPMH=NPMH+1
               NPMHIS(NPMH)=NHIST
               FILEPM(NPMH)=CDUMMY
               XCIODIS8(NDUMMY(8),NDUMMY(9))=
     &                        XCIODIS8(NDUMMY(8),NDUMMY(9))+1
               IJK=XCIODIS8(NDUMMY(8),NDUMMY(9))
               XCIODIS7(NDUMMY(8),NDUMMY(9),IJK)=NHIST
               LAZIMU(NHIST,1)=.TRUE.
               LPOLAR(NHIST,2)=.TRUE.
               LAE=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LPANG=.TRUE.
               LEAUG=.TRUE.
               LDELE(5)=.TRUE.
            ELSE IF (PMSAV(I)(1:3).EQ.'IO2') THEN
*              2-DIMENSIONAL IONIZATION DISTRIBUTION
               XXMIN=XMIN/DUNITS
               XXMAX=XMAX/DUNITS
               ZZMIN=ZMIN/DUNITS
               ZZMAX=ZMAX/DUNITS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',PMSAV(I)(1:3),'.---',CDY)
               CALL EXTOUT (3,2,I,NH,PMSAV(I),
     1                      XXMIN,XXMAX,ZZMIN,ZZMAX,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='SAV'
               DO 248 IK=1,6
                  RDY(IK)=RDY(IK)*DUNITS
 248           CONTINUE
               CALL INIHIS (2,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      3,PMSAV(I)(1:3),'SAV',CDUMMY,
     5                      IER                         )
               IF (IER.NE.0) GOTO 250
               DO 249 LK=1,NDUMMY(20)
                  XCIODIS91(NDUMMY(8),NDUMMY(8+LK))=
     &                XCIODIS91(NDUMMY(8),NDUMMY(8+LK))+1
                  LK1=XCIODIS91(NDUMMY(8),NDUMMY(8+LK))
                  XCIODIS9(NDUMMY(8),NDUMMY(8+LK),LK1)=NHIST
 249           CONTINUE
               LIO=.TRUE.
               LPMHIS=.TRUE.
               NPMH=NPMH+1
               NPMHIS(NPMH)=NHIST
               FILEPM(NPMH)=CDUMMY
            ENDIF
 250     CONTINUE
         NPM=NPMH
         DO 260 I=1,MAXSAV
            IF ((PMSAV(I)(1:3).EQ.'IOD').OR.
     &          (PMSAV(I)(1:3).EQ.'XGD').OR.
     &          (PMSAV(I)(1:3).EQ.'XDD')) THEN
*              SPACIAL DISTRIBUTION OF INNER SHELL IONIZATIONS,
*              GENERATED CHAR. X-RAYS AND DETECTED CHAR. X-RAYS.
               IF (PMSAV(I)(1:3).EQ.'IOD') THEN
                  II=1
                  LIODIS=.TRUE.
                  LGRD=.TRUE.
               ELSE IF (PMSAV(I)(1:3).EQ.'XGD') THEN
                  II=2
                  LXCHAR=.TRUE.
                  LGRD=.TRUE.
               ELSE IF (PMSAV(I)(1:3).EQ.'XDD') THEN
                  II=3
                  LXCHAR=.TRUE.
                  LINIABS=.TRUE.
                  LGRD=.TRUE.
               ENDIF
               LPMION=.TRUE.
               NPM=NPM+1
               CDUMMY=CBL//CBL//CBL//CBL//CBL//CBL//CBL
               CDUMMY=ADDSTR(4,JOB,'_',PMSAV(I)(1:3),'.---',CDY)
               CALL EXTOUT (3,1,I,NPM,PMSAV(I),
     1                      0.D0,0.D0,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='SAV'
               DO 255 LK=1,NDUMMY(20)
                  IF (PMSAV(I)(1:3).EQ.'IOD') THEN
                     IXCSHELL=NDUMMY(8+LK)
                  ELSE
                     IF (NDUMMY(8+LK).EQ.1) IXCSHELL=1
                     IF (NDUMMY(8+LK).EQ.2) IXCSHELL=1
                     IF (NDUMMY(8+LK).EQ.3) IXCSHELL=1
                     IF (NDUMMY(8+LK).EQ.4) IXCSHELL=4
                     IF (NDUMMY(8+LK).EQ.5) IXCSHELL=4
                     IF (NDUMMY(8+LK).EQ.6) IXCSHELL=3
                     IF (NDUMMY(8+LK).EQ.7) IXCSHELL=4
                     IF (NDUMMY(8+LK).EQ.8) IXCSHELL=2
                     IF (NDUMMY(8+LK).EQ.9) IXCSHELL=9
                     IF (NDUMMY(8+LK).EQ.10) IXCSHELL=8
                  ENDIF
                  IF (XCIODIS1(NDUMMY(8),IXCSHELL).EQ.0) THEN
                     IIONHIS=IIONHIS+1
                     XCIODIS1(NDUMMY(8),IXCSHELL)=IIONHIS
                  ENDIF
                  XCIODIS31(NDUMMY(8),NDUMMY(8+LK),II)=
     &                   XCIODIS31(NDUMMY(8),NDUMMY(8+LK),II)+1
                  LK1=XCIODIS31(NDUMMY(8),NDUMMY(8+LK),II)
                  XCIODIS3(NDUMMY(8),NDUMMY(8+LK),II,LK1)=NPM
                  IF (II.EQ.3) THEN
                     XCIODIS3(NDUMMY(8),NDUMMY(8+LK),4,LK1)=N2DMY
                  ENDIF
 255           CONTINUE
               FILEPM(NPM)=CDUMMY
            ENDIF
 260     CONTINUE
      ENDIF

*     ---PARSE INFORMATION FROM HIST ARRAY (HISTOGRAM FILES)
      IF(LHIS) THEN
         DO 350 I=1,MXHIST
            IF (HIST(I)(1:3).EQ.'BEE') THEN
*              ENERGY DISTRIBUTION OF BACKSCATTERED ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,EPRIM,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LENGY(NHIST,1)=.TRUE.
               LBE=.TRUE.
               LENERG=.TRUE.
               LEBACK=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'TEE') THEN
*              ENERGY DISTRIBUTION OF TRANSMITTED ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,EPRIM,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               NTEHIS=NTEHIS+1
               TEHIS(NTEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LENGY(NHIST,1)=.TRUE.
               LTE=.TRUE.
               LENERG=.TRUE.
               LETRAN=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'SEE') THEN
*              ENERGY DISTRIBUTION OF SECONDARY ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,EPRIM,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               NSEHIS=NSEHIS+1
               SEHIS(NSEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LENGY(NHIST,1)=.TRUE.
               LSE=.TRUE.
               LENERG=.TRUE.
               LESEC=.TRUE.
               LDELE(4)=.TRUE.
            ELSE IF ((HIST(I)(1:3).EQ.'AES')) THEN
*              ENERGY DISTRIBUTION OF ELECTRONS
*              INCLUDES ALL ELECTRONS (BACKSCATTERED, TRANSMITTED,
*              SECONDARY, AUGER)
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,EPRIM,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IEDCT=N2DMY
               BCKHIS(IEDCT)=-1
               EE1=MAX(RDY(1),ELDETWIN(IEDCT,1))
CS               EE2=MAX(RDY(2),ELDETWIN(IEDCT,2))
               EE2=E0
               IF (EE1.GE.EE2) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A)')' The electron detector cannot',
     1              ' detect electrons for specified energy range !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(A)')' No histogram will be generated !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 350
               ENDIF
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               CALL AEINTV (EE1,EE2,IHELP)
               DO 265 K1=1,NELMNT
                  DO 263 K2=1,MXAUGP
                     IF (IHELP(K1,K2).GT.0) THEN
                        XCIODIS8(K1,K2)=XCIODIS8(K1,K2)+1
                        IJK=XCIODIS8(K1,K2)
                        XCIODIS7(K1,K2,IJK)=NHIST
                     ENDIF
 263              CONTINUE
 265           CONTINUE
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               NTEHIS=NTEHIS+1
               TEHIS(NTEHIS)=NHIST
               NAEHIS=NAEHIS+1
               AEHIS(NAEHIS)=NHIST
               IF (LESEC) THEN
                  NSEHIS=NSEHIS+1
                  SEHIS(NSEHIS)=NHIST
               ENDIF
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LENGY(NHIST,1)=.TRUE.
               LBE=.TRUE.
               LTE=.TRUE.
               LAE=.TRUE.
               IF (LESEC) LSE=.TRUE.
               LENERG=.TRUE.
               LEBACK=.TRUE.
               LETRAN=.TRUE.
               LEAUG=.TRUE.
               LDELE(1)=.TRUE.
               LDELE(5)=.TRUE.
               LDELE(4)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'DEE') THEN
*              ENERGY DISTRIBUTION OF ELECTRONS (ELECTRON BACKGROUND)
*              INCLUDES BACKSCATTERED, TRANSMITTED, AND SECONDARY ELECTRONS
*              NO AUGER ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,EPRIM,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               NTEHIS=NTEHIS+1
               TEHIS(NTEHIS)=NHIST
               IF (LESEC) THEN
                  NSEHIS=NSEHIS+1
                  SEHIS(NSEHIS)=NHIST
               ENDIF
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LENGY(NHIST,1)=.TRUE.
               LBE=.TRUE.
               LTE=.TRUE.
               IF (LESEC) LSE=.TRUE.
               LENERG=.TRUE.
               LEBACK=.TRUE.
               LETRAN=.TRUE.
               LDELE(1)=.TRUE.
               LDELE(4)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'AEE') THEN
*              ENERGY DISTRIBUTION OF AUGER ELECTRONS
*              (NO BACKSCATTERED, TRANSMITTED AND SECONDARY ELECTRONS)
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,EPRIM,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IEDCT=N2DMY
               EE1=MAX(RDY(1),ELDETWIN(IEDCT,1))
CS               EE2=MAX(RDY(2),ELDETWIN(IEDCT,2))
               EE2=E0
               IF (EE1.GE.EE2) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A)')' The electron detector cannot',
     1              ' detect electrons for specified energy range !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(A)')' No histogram will be generated !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 350
               ENDIF
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               CALL AEINTV (EE1,EE2,IHELP)
               DO 275 K1=1,NELMNT
                  DO 270 K2=1,MXAUGP
                     IF (IHELP(K1,K2).GT.0) THEN
                        XCIODIS8(K1,K2)=XCIODIS8(K1,K2)+1
                        IJK=XCIODIS8(K1,K2)
                        XCIODIS7(K1,K2,IJK)=NHIST
                     ENDIF
 270              CONTINUE
 275           CONTINUE
               NAEHIS=NAEHIS+1
               AEHIS(NAEHIS)=NHIST
               HISEDT(NHIST)=IEDCT
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LENGY(NHIST,1)=.TRUE.
               LAE=.TRUE.
               LENERG=.TRUE.
               LEAUG=.TRUE.
               LDELE(5)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'BEA') THEN
*              AZIMUTHAL ANGLE DISTRIBUTION OF BACKSCATTERED ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,DEFAZI,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LAZIMU(NHIST,1)=.TRUE.
               LBE=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LEBACK=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'TEA') THEN
*              AZIMUTHAL ANGLE DISTRIBUTION OF TRANSMITTED ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,DEFAZI,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               NTEHIS=NTEHIS+1
               TEHIS(NTEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LAZIMU(NHIST,1)=.TRUE.
               LTE=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LETRAN=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'SEA') THEN
*              AZIMUTHAL ANGLE DISTRIBUTION OF SECONDARY ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,DEFAZI,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               NSEHIS=NSEHIS+1
               SEHIS(NSEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               CHFILE(NHIST)=CDUMMY
               LSE=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LESEC=.TRUE.
               LDELE(4)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'AEA') THEN
*              AZIMUTHAL ANGLE DISTRIBUTION OF AUGER ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,DEFAZI,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               XCIODIS8(NDUMMY(8),NDUMMY(9))=
     &                        XCIODIS8(NDUMMY(8),NDUMMY(9))+1
               IJK=XCIODIS8(NDUMMY(8),NDUMMY(9))
               XCIODIS7(NDUMMY(8),NDUMMY(9),IJK)=NHIST
               NAEHIS=NAEHIS+1
               AEHIS(NAEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LAZIMU(NHIST,1)=.TRUE.
               LAE=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LEAUG=.TRUE.
               LDELE(5)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'BEP') THEN
*              POLAR ANGLE DISTRIBUTION OF BACKSCATTERED ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,DEFPOL,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LPOLAR(NHIST,1)=.TRUE.
               LBE=.TRUE.
               LANG=.TRUE.
               LPANG=.TRUE.
               LEBACK=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'TEP') THEN
*              POLAR ANGLE DISTRIBUTION OF TRANSMITTED ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,DEFAZI,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               NTEHIS=NTEHIS+1
               TEHIS(NTEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LPOLAR(NHIST,1)=.TRUE.
               LTE=.TRUE.
               LANG=.TRUE.
               LPANG=.TRUE.
               LETRAN=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'SEP') THEN
*              POLAR ANGLE DISTRIBUTION OF SECONDARY ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,DEFAZI,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               NSEHIS=NSEHIS+1
               SEHIS(NSEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LPOLAR(NHIST,1)=.TRUE.
               LSE=.TRUE.
               LANG=.TRUE.
               LPANG=.TRUE.
               LESEC=.TRUE.
               LDELE(4)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'AEP') THEN
*              POLAR ANGLE DISTRIBUTION OF AUGER ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,DEFAZI,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               XCIODIS8(NDUMMY(8),NDUMMY(9))=
     &                        XCIODIS8(NDUMMY(8),NDUMMY(9))+1
               IJK=XCIODIS8(NDUMMY(8),NDUMMY(9))
               XCIODIS7(NDUMMY(8),NDUMMY(9),IJK)=NHIST
               NAEHIS=NAEHIS+1
               AEHIS(NAEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LPOLAR(NHIST,1)=.TRUE.
               LAE=.TRUE.
               LANG=.TRUE.
               LPANG=.TRUE.
               LEAUG=.TRUE.
               LDELE(5)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'BEL') THEN
*              SPACIAL RESOLUTION OF BACKSCATTERED ELECTRONS IN X-DIRECTION
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               DEFXMN=(XESPOT-30000)/DUNITS
               DEFXMX=(XESPOT+30000)/DUNITS
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      DEFXMN,DEFXMX,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LBE=.TRUE.
               LEBACK=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'BEH') THEN
*              SPACIAL RESOLUTION OF BACKSCATTERED ELECTRONS IN Y-DIRECTION
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               DEFYMN=-30000/DUNITS
               DEFYMX=30000/DUNITS
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      DEFYMN,DEFYMX,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LBE=.TRUE.
               LEBACK=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'TEB') THEN
*              TRANSMITTED ELECTRONS: BEAM BROADENING
               IF (SCAN) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' Since SCAN=T the specification',
     1            ' of beam broadening in SCREEN(',I,') is useless !'
                  WRITE(6,'(2A)')' ',SCREEN(I)
                  WRITE(6,'(A,I2,2A)')' SCREEN(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 350
               ENDIF
*              DEFTEB: DEFAULT VALUE FOR BEAM BROADENING HISTOGRAM
               IF (SPSIZE.LT.0.1) THEN
                  DEFTEB=7500
               ELSE
                  DEFTEB=7.5*SPSIZE
               ENDIF
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      XESPOT-DEFTEB,XESPOT+DEFTEB,
     2                      0.D0,0.D0,0.D0,0.D0,
     3                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               NTEHIS=NTEHIS+1
               TEHIS(NTEHIS)=NHIST
               LTE=.TRUE.
               LETRAN=.TRUE.
               HISEDT(NHIST)=0
               LDELE(1)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'BEY') THEN
*              BACKSCATTERED ELECTRON YIELD
               IF (.NOT.SCAN) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' Since SCAN=F the specification',
     1                     ' of a yield in HIST(',I,') is useless !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(A,I2,2A)')' HIST(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 350
               ENDIF
               XA1=XEFRST-XLSCP/2
               XB2=XELAST+XLSCP/2
               XAA1=XA1/DUNITS
               XBB2=XB2/DUNITS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      XAA1,XBB2,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               IF (RDY(1).LT.(XA1-1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The minimum value of 1st',
     1                     ' axis is to small in HIST(',i,') !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This values is',
     1                     ' set to: ',XA1,' from: ',RDY(1)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(1)=XA1
               ENDIF
               IF (RDY(2).GT.(XB2+1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The maximum value of 1st',
     1                     ' axis is to big in HIST(',i,') !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This values is',
     1                     ' set to: ',XB2,' from: ',RDY(2)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(2)=XB2
               ENDIF
               RDY(1)=XA1+INT((RDY(1)-XA1)/XLSCP)*XLSCP
               RDY(2)=XB2-INT((XB2-RDY(2))/XLSCP)*XLSCP
               NDUMMY(1)=INT((RDY(2)-RDY(1))/XLSCP+0.2)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LYIELD(NHIST,1)=.TRUE.
               LBE=.TRUE.
               LEBACK=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'TEY') THEN
*              TRANSMITTED ELECTRON YIELD
               IF (.NOT.SCAN) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' Since SCAN=F the specification',
     1                     ' of a yield in HIST(',I,') is useless !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(A,I2,2A)')' HIST(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 350
               ENDIF
               XA1=XEFRST-XLSCP/2
               XB2=XELAST+XLSCP/2
               XAA1=XA1/DUNITS
               XBB2=XB2/DUNITS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      XAA1,XBB2,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               IF (RDY(1).LT.(XA1-1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The minimum value of 1st',
     1                     ' axis is to small in HIST(',i,') !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This values is',
     1                     ' set to: ',XA1,' from: ',RDY(1)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(1)=XA1
               ENDIF
               IF (RDY(2).GT.(XB2+1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The maximum value of 1st',
     1                     ' axis is to big in HIST(',i,') !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This values is',
     1                     ' set to: ',XB2,' from: ',RDY(2)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(2)=XB2
               ENDIF
               RDY(1)=XA1+INT((RDY(1)-XA1)/XLSCP)*XLSCP
               RDY(2)=XB2-INT((XB2-RDY(2))/XLSCP)*XLSCP
               NDUMMY(1)=INT((RDY(2)-RDY(1))/XLSCP+0.2)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               NTEHIS=NTEHIS+1
               TEHIS(NTEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LYIELD(NHIST,1)=.TRUE.
               LTE=.TRUE.
               LETRAN=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'SEY') THEN
*              SECONDARY ELECTRON YIELD
               IF (.NOT.SCAN) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' Since SCAN=F the specification',
     1                     ' of a yield in HIST(',I,') is useless !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(A,I2,2A)')' HIST(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 350
               ENDIF
               XA1=XEFRST-XLSCP/2
               XB2=XELAST+XLSCP/2
               XAA1=XA1/DUNITS
               XBB2=XB2/DUNITS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      XAA1,XBB2,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               IF (RDY(1).LT.(XA1-1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The minimum value of 1st',
     1                     ' axis is to small in HIST(',i,') !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This values is',
     1                     ' set to: ',XA1,' from: ',RDY(1)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(1)=XA1
               ENDIF
               IF (RDY(2).GT.(XB2+1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The maximum value of 1st',
     1                     ' axis is to big in HIST(',i,') !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This values is',
     1                     ' set to: ',XB2,' from: ',RDY(2)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(2)=XB2
               ENDIF
               RDY(1)=XA1+INT((RDY(1)-XA1)/XLSCP)*XLSCP
               RDY(2)=XB2-INT((XB2-RDY(2))/XLSCP)*XLSCP
               NDUMMY(1)=INT((RDY(2)-RDY(1))/XLSCP+0.2)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               NSEHIS=NSEHIS+1
               SEHIS(NSEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LYIELD(NHIST,1)=.TRUE.
               LSE=.TRUE.
               LESEC=.TRUE.
               LDELE(4)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'AEY') THEN
*              AUGER ELECTRON YIELD
*              ONLY AE (BE, TE, SE NEGLECTED)
               IF (.NOT.SCAN) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' Since SCAN=F the specification',
     1                     ' of a yield in HIST(',I,') is useless !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(A,I2,2A)')' HIST(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 350
               ENDIF
               XA1=XEFRST-XLSCP/2
               XB2=XELAST+XLSCP/2
               XAA1=XA1/DUNITS
               XBB2=XB2/DUNITS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      XAA1,XBB2,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               IF (RDY(1).LT.(XA1-1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The minimum value of 1st',
     1                     ' axis is to small in HIST(',i,') !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This value is',
     1                     ' set to: ',XA1,' from: ',RDY(1)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(1)=XA1
               ENDIF
               IF (RDY(2).GT.(XB2+1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The maximum value of 1st',
     1                     ' axis is to big in HIST(',i,') !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This value is',
     1                     ' set to: ',XB2,' from: ',RDY(2)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(2)=XB2
               ENDIF
               RDY(1)=XA1+INT((RDY(1)-XA1)/XLSCP)*XLSCP
               RDY(2)=XB2-INT((XB2-RDY(2))/XLSCP)*XLSCP
               NDUMMY(1)=INT((RDY(2)-RDY(1))/XLSCP+0.2)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               XCIODIS8(NDUMMY(8),NDUMMY(9))=
     &                        XCIODIS8(NDUMMY(8),NDUMMY(9))+1
               IJK=XCIODIS8(NDUMMY(8),NDUMMY(9))
               XCIODIS7(NDUMMY(8),NDUMMY(9),IJK)=NHIST
               NAEHIS=NAEHIS+1
               AEHIS(NAEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LYIELD(NHIST,1)=.TRUE.
               LAE=.TRUE.
               LEAUG=.TRUE.
               LDELE(5)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'DEY') THEN
*              ELECTRON YIELD
*              INCLUDES AE, BE, TE AND SE (SE ONLY IF SE ARE SIMULATED)
               IF (.NOT.SCAN) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' Since SCAN=F the specification',
     1                     ' of a yield in HIST(',I,') is useless !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(A,I2,2A)')' HIST(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 350
               ENDIF
               XA1=XEFRST-XLSCP/2
               XB2=XELAST+XLSCP/2
               XAA1=XA1/DUNITS
               XBB2=XB2/DUNITS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      XAA1,XBB2,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               IEDCT=N2DMY
               EE1=MAX(RDY(2*MAXDIM+1),ELDETWIN(IEDCT,1))
CS               EE2=MAX(RDY(2*MAXDIM+2),ELDETWIN(IEDCT,2))
               EE2=E0
               IF (EE1.GE.EE2) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A)')' The electron detector cannot',
     1              ' detect electrons for specified energy range !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(A)')' No histogram will be generated !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 350
               ENDIF
               IF (RDY(1).LT.(XA1-1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The minimum value of 1st',
     1                     ' axis is to small in HIST(',i,') !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This value is',
     1                     ' set to: ',XA1,' from: ',RDY(1)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(1)=XA1
               ENDIF
               IF (RDY(2).GT.(XB2+1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The maximum value of 1st',
     1                     ' axis is to big in HIST(',i,') !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This value is',
     1                     ' set to: ',XB2,' from: ',RDY(2)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(2)=XB2
               ENDIF
               RDY(1)=XA1+INT((RDY(1)-XA1)/XLSCP)*XLSCP
               RDY(2)=XB2-INT((XB2-RDY(2))/XLSCP)*XLSCP
               NDUMMY(1)=INT((RDY(2)-RDY(1))/XLSCP+0.2)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               CALL AEINTV (EE1,EE2,IHELP)
               DO 30 K1=1,NELMNT
                  DO 29 K2=1,MXAUGP
                     IF (IHELP(K1,K2).GT.0) THEN
                        XCIODIS8(K1,K2)=XCIODIS8(K1,K2)+1
                        IJK=XCIODIS8(K1,K2)
                        XCIODIS7(K1,K2,IJK)=NHIST
                     ENDIF
 29               CONTINUE
 30            CONTINUE
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               NTEHIS=NTEHIS+1
               TEHIS(NTEHIS)=NHIST
               NAEHIS=NAEHIS+1
               AEHIS(NAEHIS)=NHIST
               IF (LESEC) THEN
                  NSEHIS=NSEHIS+1
                  SEHIS(NSEHIS)=NHIST
               ENDIF
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LYIELD(NHIST,1)=.TRUE.
               LBE=.TRUE.
               LTE=.TRUE.
               LAE=.TRUE.
               IF (LESEC) LSE=.TRUE.
               LEBACK=.TRUE.
               LETRAN=.TRUE.
               LEAUG=.TRUE.
               LDELE(1)=.TRUE.
               LDELE(5)=.TRUE.
               LDELE(4)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'IOV') THEN
*              DEPTH (VERTICAL) DISTRIBUTION OF IONIZATIONS
               ZZMIN=ZMIN/DUNITS
               ZZMAX=ZMAX/DUNITS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      ZZMIN,ZZMAX,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               DO 279 IK=1,6
                  RDY(IK)=RDY(IK)*DUNITS
 279           CONTINUE
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               IF (IER.NE.0) GOTO 350
               DO 280 LK=1,NDUMMY(20)
                  XCIODIS91(NDUMMY(8),NDUMMY(8+LK))=
     &                XCIODIS91(NDUMMY(8),NDUMMY(8+LK))+1
                  LK1=XCIODIS91(NDUMMY(8),NDUMMY(8+LK))
                  XCIODIS9(NDUMMY(8),NDUMMY(8+LK),LK1)=NHIST
 280           CONTINUE
               LIO=.TRUE.
CS               LION=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'IOL') THEN
*              LATERAL DISTRIBUTION OF IONIZATIONS
               XXMIN=XMIN/DUNITS
               XXMAX=XMAX/DUNITS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      XXMIN,XXMAX,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               DO 284 IK=1,6
                  RDY(IK)=RDY(IK)*DUNITS
 284           CONTINUE
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               IF (IER.NE.0) GOTO 350
               DO 285 LK=1,NDUMMY(20)
                  XCIODIS91(NDUMMY(8),NDUMMY(8+LK))=
     &                XCIODIS91(NDUMMY(8),NDUMMY(8+LK))+1
                  LK1=XCIODIS91(NDUMMY(8),NDUMMY(8+LK))
                  XCIODIS9(NDUMMY(8),NDUMMY(8+LK),LK1)=NHIST
 285           CONTINUE
               LIO=.TRUE.
CS               LION=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'IO2') THEN
*              TWO DIMENSIONAL DISTRIBUTION OF IONIZATIONS
               XXMIN=XMIN/DUNITS
               XXMAX=XMAX/DUNITS
               ZZMIN=ZMIN/DUNITS
               ZZMAX=ZMAX/DUNITS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      XXMIN,XXMAX,ZZMIN,ZZMAX,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               DO 292 IK=1,6
                  RDY(IK)=RDY(IK)*DUNITS
 292           CONTINUE
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H2D'
               CALL INIHIS (2,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H2D',CDUMMY,
     5                      IER                         )
               IF (IER.NE.0) GOTO 350
               DO 293 LK=1,NDUMMY(20)
                  XCIODIS91(NDUMMY(8),NDUMMY(8+LK))=
     &                XCIODIS91(NDUMMY(8),NDUMMY(8+LK))+1
                  LK1=XCIODIS91(NDUMMY(8),NDUMMY(8+LK))
                  XCIODIS9(NDUMMY(8),NDUMMY(8+LK),LK1)=NHIST
 293           CONTINUE
               LIO=.TRUE.
CS               LION=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'IO3') THEN
*              3-DIMENSIONSL DISTRIBUTION OF IONIZATIONS
               YMIN=-20000
               YMAX=20000
               XXMIN=XMIN/DUNITS
               XXMAX=XMAX/DUNITS
               YYMIN=YMIN/DUNITS
               YYMAX=YMAX/DUNITS
               ZZMIN=ZMIN/DUNITS
               ZZMAX=ZMAX/DUNITS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      XXMIN,XXMAX,ZZMIN,ZZMAX,YYMIN,YYMAX,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               DO 294 IK=1,6
                  RDY(IK)=RDY(IK)*DUNITS
 294           CONTINUE
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H3D'
               CALL INIHIS (3,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H3D',CDUMMY,
     5                      IER                         )
               IF (IER.NE.0) GOTO 350
               DO 295 LK=1,NDUMMY(20)
                  XCIODIS91(NDUMMY(8),NDUMMY(8+LK))=
     &                XCIODIS91(NDUMMY(8),NDUMMY(8+LK))+1
                  LK1=XCIODIS91(NDUMMY(8),NDUMMY(8+LK))
                  XCIODIS9(NDUMMY(8),NDUMMY(8+LK),LK1)=NHIST
 295           CONTINUE
               LIO=.TRUE.
CS               LION=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'BEW') THEN
*              AZIMUTHAL AND POLAR ANGLE DISTRIBUTION OF BACKSCATTERED
*              ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,DEFAZI,0.D0,DEFPOL,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H2D'
               CALL INIHIS (2,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H2D',CDUMMY,
     5                      IER                         )
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LAZIMU(NHIST,1)=.TRUE.
               LPOLAR(NHIST,2)=.TRUE.
               LBE=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LPANG=.TRUE.
               LEBACK=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'TEW') THEN
*              AZIMUTHAL AND POLAR ANGLE DISTRIBUTION OF TRANSMITTED
*              ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,DEFAZI,0.D0,DEFPOL,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H2D'
               CALL INIHIS (2,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H2D',CDUMMY,
     5                      IER                         )
               NTEHIS=NTEHIS+1
               TEHIS(NTEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LAZIMU(NHIST,1)=.TRUE.
               LPOLAR(NHIST,2)=.TRUE.
               LTE=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LPANG=.TRUE.
               LETRAN=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'SEW') THEN
*              AZIMUTHAL AND POLAR ANGLE DISTRIBUTION OF SECONDARY
*              ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,DEFAZI,0.D0,DEFPOL,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H2D'
               CALL INIHIS (2,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H2D',CDUMMY,
     5                      IER                         )
               NSEHIS=NSEHIS+1
               SEHIS(NSEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LAZIMU(NHIST,1)=.TRUE.
               LPOLAR(NHIST,2)=.TRUE.
               LSE=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LPANG=.TRUE.
               LESEC=.TRUE.
               LDELE(4)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'AEW') THEN
*              AZIMUTHAL AND POLAR ANGLE DISTRIBUTION OF AUGER
*              ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,DEFAZI,0.D0,DEFPOL,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H2D'
               CALL INIHIS (2,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H2D',CDUMMY,
     5                      IER                         )
               XCIODIS8(NDUMMY(8),NDUMMY(9))=
     &                        XCIODIS8(NDUMMY(8),NDUMMY(9))+1
               IJK=XCIODIS8(NDUMMY(8),NDUMMY(9))
               XCIODIS7(NDUMMY(8),NDUMMY(9),IJK)=NHIST
               NAEHIS=NAEHIS+1
               AEHIS(NAEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LAZIMU(NHIST,1)=.TRUE.
               LPOLAR(NHIST,2)=.TRUE.
               LAE=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LPANG=.TRUE.
               LEAUG=.TRUE.
               LDELE(5)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'BER') THEN
*              SPACIAL RESOLUTION OF BACKSCATTERED
*              ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               DEFXMN=(XESPOT-30000)/DUNITS
               DEFXMX=(XESPOT+30000)/DUNITS
               DEFYMN=-30000/DUNITS
               DEFYMX=30000/DUNITS
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      DEFXMN,DEFXMX,DEFYMN,DEFYMX,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               RDY(3)=RDY(3)*DUNITS
               RDY(4)=RDY(4)*DUNITS
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H2D'
               CALL INIHIS (2,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H2D',CDUMMY,
     5                      IER                         )
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LBE=.TRUE.
               LEBACK=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'BED') THEN
*              ENERGY, AZIMUTHAL AND POLAR ANGLE DISTRIBUTION OF
*              BACKSCATTERED ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,EPRIM,0.D0,DEFAZI,0.D0,DEFPOL,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H3D'
               CALL INIHIS (3,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H3D',CDUMMY,
     5                      IER                         )
               NBEHIS=NBEHIS+1
               BEHIS(NBEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LENGY(NHIST,1)=.TRUE.
               LAZIMU(NHIST,2)=.TRUE.
               LPOLAR(NHIST,3)=.TRUE.
               LBE=.TRUE.
               LENERG=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LPANG=.TRUE.
               LEBACK=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'TED') THEN
*              ENERGY, AZIMUTHAL AND POLAR ANGLE DISTRIBUTION OF
*              TRANSMITTED ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,EPRIM,0.D0,DEFAZI,0.D0,DEFPOL,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H3D'
               CALL INIHIS (3,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H3D',CDUMMY,
     5                      IER                         )
               NTEHIS=NTEHIS+1
               TEHIS(NTEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LENGY(NHIST,1)=.TRUE.
               LAZIMU(NHIST,2)=.TRUE.
               LPOLAR(NHIST,3)=.TRUE.
               LTE=.TRUE.
               LENERG=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LPANG=.TRUE.
               LETRAN=.TRUE.
               LDELE(1)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'SED') THEN
*              ENERGY, AZIMUTHAL AND POLAR ANGLE DISTRIBUTION OF
*              SECONDARY ELECTRONS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,EPRIM,0.D0,DEFAZI,0.D0,DEFPOL,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H3D'
               CALL INIHIS (3,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H3D',CDUMMY,
     5                      IER                         )
               NSEHIS=NSEHIS+1
               SEHIS(NSEHIS)=NHIST
               HISEDT(NHIST)=N2DMY
               CHISTITLE(NHIST)(1:5)=';DET#'
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               IF (HISEDT(NHIST).LT.10) THEN
                  WRITE(CHISTITLE(NHIST)(6:6),'(I1)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(7:40)='    '//CBL//CBL//CBL
               ELSE
                  WRITE(CHISTITLE(NHIST)(6:7),'(I2)')HISEDT(NHIST)
                  CHISTITLE(NHIST)(8:40)='   '//CBL//CBL//CBL
               ENDIF
               LENGY(NHIST,1)=.TRUE.
               LAZIMU(NHIST,2)=.TRUE.
               LPOLAR(NHIST,3)=.TRUE.
               LSE=.TRUE.
               LENERG=.TRUE.
               LANG=.TRUE.
               LAANG=.TRUE.
               LPANG=.TRUE.
               LESEC=.TRUE.
               LDELE(4)=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'XCS') THEN
*              ENERGY SPECTRUM OF CHARACTERISTIC X-RAYS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,EPRIM,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               IF (NXCSHIS.GE.MAXXCSHIS) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(A,I2,A)')' Not more than ',MAXXCSHIS,
     1                     ' XCS/XRS histograms allowed !'
                  WRITE(6,'(A,I2,2A)')' SCREEN(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 350
               ENDIF
               CDUMMY(IEND(CDUMMY)+1:IEND(CDUMMY)+4)='DET#'
               IIE1=IEND(CDUMMY)
               IF (N2DMY.GT.99) N2DMY=1
               IF (N2DMY.LT.10) THEN
                  WRITE(CDUMMY(IIE1+1:IIE1+1),'(I1)')N2DMY
               ELSE
                  WRITE(CDUMMY(IIE1+1:IIE1+2),'(I2)')N2DMY
               ENDIF
               CHISTITLE(NHIST)=';'//CDUMMY(1:IEND(CDUMMY))
               LENGY(NHIST,1)=.TRUE.
               LXR=.TRUE.
               LENERG=.TRUE.
               LXCHAR=.TRUE.
               LINIABS=.TRUE.
               LGRD=.TRUE.
               NXCSHIS=NXCSHIS+1
               XCSHIS(NXCSHIS)=NHIST
               XCSDET(NXCSHIS)=N2DMY
            ELSE IF (HIST(I)(1:3).EQ.'XKS') THEN
*              ENERGY SPECTRUM OF CONTIUUM X-RAYS (BREMSSTRAHLUNGSSPEKTRUM)
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,EPRIM,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               IF (NXKSHIS.GE.MAXXKSHIS) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(A,I2,A)')' Not more than ',MAXXKSHIS,
     1                     ' XKS histograms allowed !'
                  WRITE(6,'(A,I2,2A)')' SCREEN(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 350
               ENDIF
               CDUMMY(IEND(CDUMMY)+1:IEND(CDUMMY)+4)='DET#'
               IIE1=IEND(CDUMMY)
               IF (N2DMY.GT.99) N2DMY=1
               IF (N2DMY.LT.10) THEN
                  WRITE(CDUMMY(IIE1+1:IIE1+1),'(I1)')N2DMY
               ELSE
                  WRITE(CDUMMY(IIE1+1:IIE1+2),'(I2)')N2DMY
               ENDIF
               CHISTITLE(NHIST)=';'//CDUMMY(1:IEND(CDUMMY))
               NHISXCONT=MAX(NHISXCONT,NDUMMY(1))
               LENGY(NHIST,1)=.TRUE.
               LXK=.TRUE.
               LENERG=.TRUE.
               LXCONT=.TRUE.
               NXKSHIS=NXKSHIS+1
               XKSHIS(NXKSHIS)=NHIST
               XKSDET(NXKSHIS)=N2DMY
            ELSE IF (HIST(I)(1:3).EQ.'XRS') THEN
*              X-RAY ENERGY SPECTRUM (CONTINUUM PLUS CHARACTERISTIC)
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      0.D0,EPRIM,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               IF (NXCSHIS.GE.MAXXCSHIS) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(A,I2,A)')' Not more than ',MAXXCSHIS,
     1                     ' XCS/XRS histograms allowed !'
                  WRITE(6,'(A,I2,2A)')' HIST(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 350
               ENDIF
               NHISXCONT=MAX(NHISXCONT,NDUMMY(1))
               CDUMMY(IEND(CDUMMY)+1:IEND(CDUMMY)+4)='DET#'
               IIE1=IEND(CDUMMY)
               IF (N2DMY.GT.99) N2DMY=1
               IF (N2DMY.LT.10) THEN
                  WRITE(CDUMMY(IIE1+1:IIE1+1),'(I1)')N2DMY
               ELSE
                  WRITE(CDUMMY(IIE1+1:IIE1+2),'(I2)')N2DMY
               ENDIF
               CHISTITLE(NHIST)=';'//CDUMMY(1:IEND(CDUMMY))
               LENGY(NHIST,1)=.TRUE.
               LXR=.TRUE.
               LENERG=.TRUE.
               LXCONT=.TRUE.
               LXRAY=.TRUE.
               LXCHAR=.TRUE.
               LINIABS=.TRUE.
               LGRD=.TRUE.
               NXCSHIS=NXCSHIS+1
               XCSHIS(NXCSHIS)=NHIST
               XCSDET(NXCSHIS)=N2DMY
            ELSE IF (HIST(I)(1:3).EQ.'XCY') THEN
*              CHARACTERISTIC X-RAY YIELD
               IF (.NOT.SCAN) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' Since SCAN=F the specification',
     1                     ' of a yield in HIST(',I,') is useless !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(A,I2,2A)')' HIST(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 350
               ENDIF
               XA1=XEFRST-XLSCP/2
               XB2=XELAST+XLSCP/2
               XAA1=XA1/DUNITS
               XBB2=XB2/DUNITS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      XAA1,XBB2,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               IF (RDY(1).LT.(XA1-1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The minimum value of 1st',
     1                     ' axis is to small in HIST(',i,') !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This value is',
     1                     ' set to: ',XA1,' from: ',RDY(1)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(1)=XA1
               ENDIF
               IF (RDY(2).GT.(XB2+1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The maximum value of 1st',
     1                     ' axis is to big in HIST(',i,') !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This value is',
     1                     ' set to: ',XB2,' from: ',RDY(2)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(2)=XB2
               ENDIF
               RDY(1)=XA1+INT((RDY(1)-XA1)/XLSCP)*XLSCP
               RDY(2)=XB2-INT((XB2-RDY(2))/XLSCP)*XLSCP
               NDUMMY(1)=INT((RDY(2)-RDY(1))/XLSCP+0.2)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               IF (IER.NE.0) GOTO 350
               IF ((RDY(3).LT.RDY(4)).AND.(RDY(3).GE.0)) THEN
                  HISENWIN(NHIST,1)=RDY(3)
                  HISENWIN(NHIST,2)=RDY(4)
               ELSE IF ((RDY(7).LT.RDY(8)).AND.(RDY(7).GE.0)) THEN
                  HISENWIN(NHIST,1)=RDY(7)
                  HISENWIN(NHIST,2)=RDY(8)
               ELSE
                  HISENWIN(NHIST,1)=0
                  HISENWIN(NHIST,2)=0
               ENDIF
               HISEDT(NHIST)=N2DMY
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               DO 340 LK=1,NDUMMY(20)
                  XCIODIS41(NDUMMY(8),NDUMMY(8+LK))=
     &                     XCIODIS41(NDUMMY(8),NDUMMY(8+LK))+1
                  JJK=XCIODIS41(NDUMMY(8),NDUMMY(8+LK))
                  XCIODIS4(NDUMMY(8),NDUMMY(8+LK),JJK,1)=NHIST
                  XCIODIS4(NDUMMY(8),NDUMMY(8+LK),JJK,2)=HISEDT(NHIST)
 340           CONTINUE
               LYIELD(NHIST,1)=.TRUE.
               LXC=.TRUE.
               LXCHAR=.TRUE.
               LINIABS=.TRUE.
               LGRD=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'XRY') THEN
*              CHARACTERISTIC X-RAY YIELD CONTAINING BACKGROUND CONTRIBUTION
               IF (.NOT.SCAN) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' Since SCAN=F the specification',
     1                     ' of a yield in HIST(',I,') is useless !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(A,I2,2A)')' HIST(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 350
               ENDIF
               XA1=XEFRST-XLSCP/2
               XB2=XELAST+XLSCP/2
               XAA1=XA1/DUNITS
               XBB2=XB2/DUNITS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      XAA1,XBB2,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               IF (RDY(1).LT.(XA1-1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The minimum value of 1st',
     1                     ' axis is to small in HIST(',i,') !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This value is',
     1                     ' set to: ',XA1,' from: ',RDY(1)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(1)=XA1
               ENDIF
               IF (RDY(2).GT.(XB2+1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The maximum value of 1st',
     1                     ' axis is to big in HIST(',i,') !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This value is',
     1                     ' set to: ',XB2,' from: ',RDY(2)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(2)=XB2
               ENDIF
               RDY(1)=XA1+INT((RDY(1)-XA1)/XLSCP)*XLSCP
               RDY(2)=XB2-INT((XB2-RDY(2))/XLSCP)*XLSCP
               NDUMMY(1)=INT((RDY(2)-RDY(1))/XLSCP+0.2)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               IF (IER.NE.0) GOTO 350
               IF ((RDY(3).LT.RDY(4)).AND.(RDY(3).GE.0)) THEN
                  HISENWIN(NHIST,1)=RDY(3)
                  HISENWIN(NHIST,2)=RDY(4)
               ELSE IF ((RDY(7).LT.RDY(8)).AND.(RDY(7).GE.0)) THEN
                  HISENWIN(NHIST,1)=RDY(7)
                  HISENWIN(NHIST,2)=RDY(8)
               ELSE
                  HISENWIN(NHIST,1)=0
                  HISENWIN(NHIST,2)=0
               ENDIF
               HISEDT(NHIST)=N2DMY
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               DO 345 LK=1,NDUMMY(20)
                  XCIODIS41(NDUMMY(8),NDUMMY(8+LK))=
     &                     XCIODIS41(NDUMMY(8),NDUMMY(8+LK))+1
                  JJK=XCIODIS41(NDUMMY(8),NDUMMY(8+LK))
                  XCIODIS4(NDUMMY(8),NDUMMY(8+LK),JJK,1)=NHIST
                  XCIODIS4(NDUMMY(8),NDUMMY(8+LK),JJK,2)=HISEDT(NHIST)
 345              CONTINUE
               LYIELD(NHIST,1)=.TRUE.
               LXC=.TRUE.
               LXCHAR=.TRUE.
               LPTOB=.TRUE.
               LINIABS=.TRUE.
               LGRD=.TRUE.
            ELSE IF (HIST(I)(1:3).EQ.'XKY') THEN
*              BREMSSTRAHLUNG YIELD
               IF (.NOT.SCAN) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' Since SCAN=F the specification',
     1                     ' of a yield in HIST(',I,') is useless !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(A,I2,2A)')' HIST(',I,') will',
     1                     ' be simply ignored !'
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  GOTO 350
               ENDIF
               XA1=XEFRST-XLSCP/2
               XB2=XELAST+XLSCP/2
               XAA1=XA1/DUNITS
               XBB2=XB2/DUNITS
               NH=NHIST+1
               CDUMMY=ADDSTR(4,JOB,'_',HIST(I)(1:3),'.---',CDY)
               CALL EXTOUT (4,2,I,NH,HIST(I),
     1                      XAA1,XBB2,0.D0,0.D0,0.D0,0.D0,
     2                      N1DMY,N2DMY,NDUMMY,RDY,CDUMMY)
               RDY(1)=RDY(1)*DUNITS
               RDY(2)=RDY(2)*DUNITS
               IF (RDY(1).LT.(XA1-1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The minimum value of 1st',
     1                     ' axis is to small in HIST(',i,') !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This value is',
     1                     ' set to: ',XA1,' from: ',RDY(1)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(1)=XA1
               ENDIF
               IF (RDY(2).GT.(XB2+1.0E-11)) THEN
                  WRITE(6,'(A)')'     '
                  WRITE(6,'(A)')' %%% WARNING %%%'
                  WRITE(6,'(2A,I2,A)')' The maximum value of 1st',
     1                     ' axis is to big in HIST(',i,') !'
                  WRITE(6,'(2A)')' ',HIST(I)
                  WRITE(6,'(2A,F12.3,A,F12.3)')' This value is',
     1                     ' set to: ',XB2,' from: ',RDY(2)
                  WRITE(6,'(A)')' Protests are useless - SESAME ;-)'
                  RDY(2)=XB2
               ENDIF
               RDY(1)=XA1+INT((RDY(1)-XA1)/XLSCP)*XLSCP
               RDY(2)=XB2-INT((XB2-RDY(2))/XLSCP)*XLSCP
               NDUMMY(1)=INT((RDY(2)-RDY(1))/XLSCP+0.2)
               IE=IEND(CDUMMY)
               IF (CDUMMY(IE-2:IE).EQ.'---') CDUMMY(IE-2:IE)='H1D'
               CALL INIHIS (1,
     1                      NDUMMY(1),RDY(1),RDY(2),
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      2,HIST(I)(1:3),'H1D',CDUMMY,
     5                      IER                         )
               IF (IER.NE.0) GOTO 350
               IF ((RDY(3).LT.RDY(4)).AND.(RDY(3).GE.0)) THEN
                  HISENWIN(NHIST,1)=RDY(3)
                  HISENWIN(NHIST,2)=RDY(4)
               ELSE IF ((RDY(7).LT.RDY(8)).AND.(RDY(7).GE.0)) THEN
                  HISENWIN(NHIST,1)=RDY(7)
                  HISENWIN(NHIST,2)=RDY(8)
               ELSE
                  HISENWIN(NHIST,1)=0
                  HISENWIN(NHIST,2)=0
               ENDIF
               HISEDT(NHIST)=N2DMY
               IF ((HISEDT(NHIST).GT.99).OR.
     &             (HISEDT(NHIST).LT.0)) HISEDT(NHIST)=0
               LYIELD(NHIST,1)=.TRUE.
               LPTOB=.TRUE.
               LINIABS=.TRUE.
               LGRD=.TRUE.
            ELSE
               IF (HIST(I)(1:1).NE.' ') THEN
                  WRITE(*,'(A)')'   '
                  WRITE(*,'(3A)')' WARNING: ',HIST(I)(1:3),
     &                     ' IS NOT A VALID ABBREVIATION IN HIST'
                  WRITE(*,'(2A,I2,2A)')' ','HIST(',I,
     &                     ') WILL BE IGNORED'
               ENDIF
            ENDIF
 350     CONTINUE
      ENDIF
*
* CREATE BACKGROUND HISTOGRAMS FOR AES:
* 

      DO 400 IEDCT=0,MAXEDET

               IF (BCKHIS(IEDCT) .EQ. -1) THEN

                  CALL INIHIS (1,
     1                      NBCKSZ,0.D0,E0,
     2                      NDUMMY(2),RDY(3),RDY(4),
     3                      NDUMMY(3),RDY(5),RDY(6),
     4                      1,'BCK','SCR',CDUMMY,
     5                      IER                          )
 
                  IF (IER .NE. 0) GOTO 50

                  BCKHIS(IEDCT) = NHIST

                  NBEHIS=NBEHIS+1
                  BEHIS(NBEHIS)=NHIST
                  NTEHIS=NTEHIS+1
                  TEHIS(NTEHIS)=NHIST
                  IF (LESEC) THEN
                     NSEHIS=NSEHIS+1
                     SEHIS(NSEHIS)=NHIST
                  ENDIF
               ENDIF
           
 400  CONTINUE

      IF (LSCLOC.OR.LPOST) LLOC=.TRUE.

      IF (NBEHIS.GT.0) LEBACK=.TRUE.
      IF (NTEHIS.GT.0) LETRAN=.TRUE.
      IF (NAEHIS.GT.0) LEAUG=.TRUE.
      IF (NSEHIS.GT.0) LESEC=.TRUE.

*     PREPARE FOR ACTUAL SCREEN OUTPUT AND SCREEN OUTPUT CALULATION!
      IF (NSCRN.EQ.0) THEN
         LSCRN=.FALSE.
         LSCRN1=.FALSE.
      ENDIF
      DO 523 I=1,NTOSCL
         IF (LSCRN) THEN
            ILOCST(I)=1
         ELSE
            ILOCST(I)=NLOCSC(I)+1
         ENDIF
 523  CONTINUE

      LBREMS=LXCONT.OR.LPTOB

      RETURN
      END
